/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ 368:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "S1": () => (/* binding */ init)
});

// UNUSED EXPORTS: ApmBase, apm, apmBase, default

;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/error-logging/stack-trace.js
function filePathToFileName(fileUrl) {
  var origin = window.location.origin || window.location.protocol + '//' + window.location.hostname + (window.location.port ? ':' + window.location.port : '');

  if (fileUrl.indexOf(origin) > -1) {
    fileUrl = fileUrl.replace(origin + '/', '');
  }

  return fileUrl;
}

function cleanFilePath(filePath) {
  if (filePath === void 0) {
    filePath = '';
  }

  if (filePath === '<anonymous>') {
    filePath = '';
  }

  return filePath;
}

function isFileInline(fileUrl) {
  if (fileUrl) {
    return window.location.href.indexOf(fileUrl) === 0;
  }

  return false;
}

function normalizeStackFrames(stackFrames) {
  return stackFrames.map(function (frame) {
    if (frame.functionName) {
      frame.functionName = normalizeFunctionName(frame.functionName);
    }

    return frame;
  });
}

function normalizeFunctionName(fnName) {
  var parts = fnName.split('/');

  if (parts.length > 1) {
    fnName = ['Object', parts[parts.length - 1]].join('.');
  } else {
    fnName = parts[0];
  }

  fnName = fnName.replace(/.<$/gi, '.<anonymous>');
  fnName = fnName.replace(/^Anonymous function$/, '<anonymous>');
  parts = fnName.split('.');

  if (parts.length > 1) {
    fnName = parts[parts.length - 1];
  } else {
    fnName = parts[0];
  }

  return fnName;
}

function isValidStackTrace(stackTraces) {
  if (stackTraces.length === 0) {
    return false;
  }

  if (stackTraces.length === 1) {
    var stackTrace = stackTraces[0];
    return 'lineNumber' in stackTrace;
  }

  return true;
}

function createStackTraces(stackParser, errorEvent) {
  var error = errorEvent.error,
      filename = errorEvent.filename,
      lineno = errorEvent.lineno,
      colno = errorEvent.colno;
  var stackTraces = [];

  if (error) {
    try {
      stackTraces = stackParser.parse(error);
    } catch (e) {}
  }

  if (!isValidStackTrace(stackTraces)) {
    stackTraces = [{
      fileName: filename,
      lineNumber: lineno,
      columnNumber: colno
    }];
  }

  var normalizedStackTraces = normalizeStackFrames(stackTraces);
  return normalizedStackTraces.map(function (stack) {
    var fileName = stack.fileName,
        lineNumber = stack.lineNumber,
        columnNumber = stack.columnNumber,
        _stack$functionName = stack.functionName,
        functionName = _stack$functionName === void 0 ? '<anonymous>' : _stack$functionName;

    if (!fileName && !lineNumber) {
      return {};
    }

    if (!columnNumber && !lineNumber) {
      return {};
    }

    var filePath = cleanFilePath(fileName);
    var cleanedFileName = filePathToFileName(filePath);

    if (isFileInline(filePath)) {
      cleanedFileName = '(inline script)';
    }

    return {
      abs_path: fileName,
      filename: cleanedFileName,
      function: functionName,
      lineno: lineNumber,
      colno: columnNumber
    };
  });
}
function filterInvalidFrames(frames) {
  return frames.filter(function (_ref) {
    var filename = _ref.filename,
        lineno = _ref.lineno;
    return typeof filename !== 'undefined' && typeof lineno !== 'undefined';
  });
}
;// CONCATENATED MODULE: ./node_modules/promise-polyfill/src/finally.js
/**
 * @this {Promise}
 */
function finallyConstructor(callback) {
  var constructor = this.constructor;
  return this.then(
    function(value) {
      // @ts-ignore
      return constructor.resolve(callback()).then(function() {
        return value;
      });
    },
    function(reason) {
      // @ts-ignore
      return constructor.resolve(callback()).then(function() {
        // @ts-ignore
        return constructor.reject(reason);
      });
    }
  );
}

/* harmony default export */ const src_finally = (finallyConstructor);

;// CONCATENATED MODULE: ./node_modules/promise-polyfill/src/allSettled.js
function allSettled(arr) {
  var P = this;
  return new P(function(resolve, reject) {
    if (!(arr && typeof arr.length !== 'undefined')) {
      return reject(
        new TypeError(
          typeof arr +
            ' ' +
            arr +
            ' is not iterable(cannot read property Symbol(Symbol.iterator))'
        )
      );
    }
    var args = Array.prototype.slice.call(arr);
    if (args.length === 0) return resolve([]);
    var remaining = args.length;

    function res(i, val) {
      if (val && (typeof val === 'object' || typeof val === 'function')) {
        var then = val.then;
        if (typeof then === 'function') {
          then.call(
            val,
            function(val) {
              res(i, val);
            },
            function(e) {
              args[i] = { status: 'rejected', reason: e };
              if (--remaining === 0) {
                resolve(args);
              }
            }
          );
          return;
        }
      }
      args[i] = { status: 'fulfilled', value: val };
      if (--remaining === 0) {
        resolve(args);
      }
    }

    for (var i = 0; i < args.length; i++) {
      res(i, args[i]);
    }
  });
}

/* harmony default export */ const src_allSettled = (allSettled);

;// CONCATENATED MODULE: ./node_modules/promise-polyfill/src/any.js
/**
 * @constructor
 */
function AggregateError(errors, message) {
  (this.name = 'AggregateError'), (this.errors = errors);
  this.message = message || '';
}
AggregateError.prototype = Error.prototype;

function any(arr) {
  var P = this;
  return new P(function(resolve, reject) {
    if (!(arr && typeof arr.length !== 'undefined')) {
      return reject(new TypeError('Promise.any accepts an array'));
    }

    var args = Array.prototype.slice.call(arr);
    if (args.length === 0) return reject();

    var rejectionReasons = [];
    for (var i = 0; i < args.length; i++) {
      try {
        P.resolve(args[i])
          .then(resolve)
          .catch(function(error) {
            rejectionReasons.push(error);
            if (rejectionReasons.length === args.length) {
              reject(
                new AggregateError(
                  rejectionReasons,
                  'All promises were rejected'
                )
              );
            }
          });
      } catch (ex) {
        reject(ex);
      }
    }
  });
}

/* harmony default export */ const src_any = (any);

;// CONCATENATED MODULE: ./node_modules/promise-polyfill/src/index.js




// Store setTimeout reference so promise-polyfill will be unaffected by
// other code modifying setTimeout (like sinon.useFakeTimers())
var setTimeoutFunc = setTimeout;

function isArray(x) {
  return Boolean(x && typeof x.length !== 'undefined');
}

function noop() {}

// Polyfill for Function.prototype.bind
function bind(fn, thisArg) {
  return function() {
    fn.apply(thisArg, arguments);
  };
}

/**
 * @constructor
 * @param {Function} fn
 */
function Promise(fn) {
  if (!(this instanceof Promise))
    throw new TypeError('Promises must be constructed via new');
  if (typeof fn !== 'function') throw new TypeError('not a function');
  /** @type {!number} */
  this._state = 0;
  /** @type {!boolean} */
  this._handled = false;
  /** @type {Promise|undefined} */
  this._value = undefined;
  /** @type {!Array<!Function>} */
  this._deferreds = [];

  doResolve(fn, this);
}

function handle(self, deferred) {
  while (self._state === 3) {
    self = self._value;
  }
  if (self._state === 0) {
    self._deferreds.push(deferred);
    return;
  }
  self._handled = true;
  Promise._immediateFn(function() {
    var cb = self._state === 1 ? deferred.onFulfilled : deferred.onRejected;
    if (cb === null) {
      (self._state === 1 ? resolve : reject)(deferred.promise, self._value);
      return;
    }
    var ret;
    try {
      ret = cb(self._value);
    } catch (e) {
      reject(deferred.promise, e);
      return;
    }
    resolve(deferred.promise, ret);
  });
}

function resolve(self, newValue) {
  try {
    // Promise Resolution Procedure: https://github.com/promises-aplus/promises-spec#the-promise-resolution-procedure
    if (newValue === self)
      throw new TypeError('A promise cannot be resolved with itself.');
    if (
      newValue &&
      (typeof newValue === 'object' || typeof newValue === 'function')
    ) {
      var then = newValue.then;
      if (newValue instanceof Promise) {
        self._state = 3;
        self._value = newValue;
        finale(self);
        return;
      } else if (typeof then === 'function') {
        doResolve(bind(then, newValue), self);
        return;
      }
    }
    self._state = 1;
    self._value = newValue;
    finale(self);
  } catch (e) {
    reject(self, e);
  }
}

function reject(self, newValue) {
  self._state = 2;
  self._value = newValue;
  finale(self);
}

function finale(self) {
  if (self._state === 2 && self._deferreds.length === 0) {
    Promise._immediateFn(function() {
      if (!self._handled) {
        Promise._unhandledRejectionFn(self._value);
      }
    });
  }

  for (var i = 0, len = self._deferreds.length; i < len; i++) {
    handle(self, self._deferreds[i]);
  }
  self._deferreds = null;
}

/**
 * @constructor
 */
function Handler(onFulfilled, onRejected, promise) {
  this.onFulfilled = typeof onFulfilled === 'function' ? onFulfilled : null;
  this.onRejected = typeof onRejected === 'function' ? onRejected : null;
  this.promise = promise;
}

/**
 * Take a potentially misbehaving resolver function and make sure
 * onFulfilled and onRejected are only called once.
 *
 * Makes no guarantees about asynchrony.
 */
function doResolve(fn, self) {
  var done = false;
  try {
    fn(
      function(value) {
        if (done) return;
        done = true;
        resolve(self, value);
      },
      function(reason) {
        if (done) return;
        done = true;
        reject(self, reason);
      }
    );
  } catch (ex) {
    if (done) return;
    done = true;
    reject(self, ex);
  }
}

Promise.prototype['catch'] = function(onRejected) {
  return this.then(null, onRejected);
};

Promise.prototype.then = function(onFulfilled, onRejected) {
  // @ts-ignore
  var prom = new this.constructor(noop);

  handle(this, new Handler(onFulfilled, onRejected, prom));
  return prom;
};

Promise.prototype['finally'] = src_finally;

Promise.all = function(arr) {
  return new Promise(function(resolve, reject) {
    if (!isArray(arr)) {
      return reject(new TypeError('Promise.all accepts an array'));
    }

    var args = Array.prototype.slice.call(arr);
    if (args.length === 0) return resolve([]);
    var remaining = args.length;

    function res(i, val) {
      try {
        if (val && (typeof val === 'object' || typeof val === 'function')) {
          var then = val.then;
          if (typeof then === 'function') {
            then.call(
              val,
              function(val) {
                res(i, val);
              },
              reject
            );
            return;
          }
        }
        args[i] = val;
        if (--remaining === 0) {
          resolve(args);
        }
      } catch (ex) {
        reject(ex);
      }
    }

    for (var i = 0; i < args.length; i++) {
      res(i, args[i]);
    }
  });
};

Promise.any = src_any;

Promise.allSettled = src_allSettled;

Promise.resolve = function(value) {
  if (value && typeof value === 'object' && value.constructor === Promise) {
    return value;
  }

  return new Promise(function(resolve) {
    resolve(value);
  });
};

Promise.reject = function(value) {
  return new Promise(function(resolve, reject) {
    reject(value);
  });
};

Promise.race = function(arr) {
  return new Promise(function(resolve, reject) {
    if (!isArray(arr)) {
      return reject(new TypeError('Promise.race accepts an array'));
    }

    for (var i = 0, len = arr.length; i < len; i++) {
      Promise.resolve(arr[i]).then(resolve, reject);
    }
  });
};

// Use polyfill for setImmediate for performance gains
Promise._immediateFn =
  // @ts-ignore
  (typeof setImmediate === 'function' &&
    function(fn) {
      // @ts-ignore
      setImmediate(fn);
    }) ||
  function(fn) {
    setTimeoutFunc(fn, 0);
  };

Promise._unhandledRejectionFn = function _unhandledRejectionFn(err) {
  if (typeof console !== 'undefined' && console) {
    console.warn('Possible Unhandled Promise Rejection:', err); // eslint-disable-line no-console
  }
};

/* harmony default export */ const src = (Promise);

;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/polyfills.js


var local = {};

if (isBrowser) {
  local = window;
} else if (typeof self !== 'undefined') {
  local = self;
}

var polyfills_Promise = 'Promise' in local ? local.Promise : src;

;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/utils.js

var slice = [].slice;
var isBrowser = typeof window !== 'undefined';
var PERF = isBrowser && typeof performance !== 'undefined' ? performance : {};

function isCORSSupported() {
  var xhr = new window.XMLHttpRequest();
  return 'withCredentials' in xhr;
}

var byteToHex = [];

for (var i = 0; i < 256; ++i) {
  byteToHex[i] = (i + 0x100).toString(16).substr(1);
}

function bytesToHex(buffer) {
  var hexOctets = [];

  for (var _i = 0; _i < buffer.length; _i++) {
    hexOctets.push(byteToHex[buffer[_i]]);
  }

  return hexOctets.join('');
}

var destination = new Uint8Array(16);

function rng() {
  if (typeof crypto != 'undefined' && typeof crypto.getRandomValues == 'function') {
    return crypto.getRandomValues(destination);
  } else if (typeof msCrypto != 'undefined' && typeof msCrypto.getRandomValues == 'function') {
    return msCrypto.getRandomValues(destination);
  }

  return destination;
}

function generateRandomId(length) {
  var id = bytesToHex(rng());
  return id.substr(0, length);
}

function getDtHeaderValue(span) {
  var dtVersion = '00';
  var dtUnSampledFlags = '00';
  var dtSampledFlags = '01';

  if (span && span.traceId && span.id && span.parentId) {
    var flags = span.sampled ? dtSampledFlags : dtUnSampledFlags;
    var id = span.sampled ? span.id : span.parentId;
    return dtVersion + '-' + span.traceId + '-' + id + '-' + flags;
  }
}

function parseDtHeaderValue(value) {
  var parsed = /^([\da-f]{2})-([\da-f]{32})-([\da-f]{16})-([\da-f]{2})$/.exec(value);

  if (parsed) {
    var flags = parsed[4];
    var sampled = flags !== '00';
    return {
      traceId: parsed[2],
      id: parsed[3],
      sampled: sampled
    };
  }
}

function isDtHeaderValid(header) {
  return /^[\da-f]{2}-[\da-f]{32}-[\da-f]{16}-[\da-f]{2}$/.test(header) && header.slice(3, 35) !== '00000000000000000000000000000000' && header.slice(36, 52) !== '0000000000000000';
}

function getTSHeaderValue(_ref) {
  var sampleRate = _ref.sampleRate;

  if (typeof sampleRate !== 'number' || String(sampleRate).length > 256) {
    return;
  }

  var NAMESPACE = 'es';
  var SEPARATOR = '=';
  return "" + NAMESPACE + SEPARATOR + "s:" + sampleRate;
}

function setRequestHeader(target, name, value) {
  if (typeof target.setRequestHeader === 'function') {
    target.setRequestHeader(name, value);
  } else if (target.headers && typeof target.headers.append === 'function') {
    target.headers.append(name, value);
  } else {
    target[name] = value;
  }
}

function checkSameOrigin(source, target) {
  var isSame = false;

  if (typeof target === 'string') {
    isSame = source === target;
  } else if (target && typeof target.test === 'function') {
    isSame = target.test(source);
  } else if (Array.isArray(target)) {
    target.forEach(function (t) {
      if (!isSame) {
        isSame = checkSameOrigin(source, t);
      }
    });
  }

  return isSame;
}

function isPlatformSupported() {
  return isBrowser && typeof Set === 'function' && typeof JSON.stringify === 'function' && PERF && typeof PERF.now === 'function' && isCORSSupported();
}

function setLabel(key, value, obj) {
  if (!obj || !key) return;
  var skey = removeInvalidChars(key);
  var valueType = typeof value;

  if (value != undefined && valueType !== 'boolean' && valueType !== 'number') {
    value = String(value);
  }

  obj[skey] = value;
  return obj;
}

function getServerTimingInfo(serverTimingEntries) {
  if (serverTimingEntries === void 0) {
    serverTimingEntries = [];
  }

  var serverTimingInfo = [];
  var entrySeparator = ', ';
  var valueSeparator = ';';

  for (var _i2 = 0; _i2 < serverTimingEntries.length; _i2++) {
    var _serverTimingEntries$ = serverTimingEntries[_i2],
        name = _serverTimingEntries$.name,
        duration = _serverTimingEntries$.duration,
        description = _serverTimingEntries$.description;
    var timingValue = name;

    if (description) {
      timingValue += valueSeparator + 'desc=' + description;
    }

    if (duration) {
      timingValue += valueSeparator + 'dur=' + duration;
    }

    serverTimingInfo.push(timingValue);
  }

  return serverTimingInfo.join(entrySeparator);
}

function getTimeOrigin() {
  return PERF.timing.fetchStart;
}

function stripQueryStringFromUrl(url) {
  return url && url.split('?')[0];
}

function isObject(value) {
  return value !== null && typeof value === 'object';
}

function isFunction(value) {
  return typeof value === 'function';
}

function baseExtend(dst, objs, deep) {
  for (var i = 0, ii = objs.length; i < ii; ++i) {
    var obj = objs[i];
    if (!isObject(obj) && !isFunction(obj)) continue;
    var keys = Object.keys(obj);

    for (var j = 0, jj = keys.length; j < jj; j++) {
      var key = keys[j];
      var src = obj[key];

      if (deep && isObject(src)) {
        if (!isObject(dst[key])) dst[key] = Array.isArray(src) ? [] : {};
        baseExtend(dst[key], [src], false);
      } else {
        dst[key] = src;
      }
    }
  }

  return dst;
}

function getElasticScript() {
  if (typeof document !== 'undefined') {
    var scripts = document.getElementsByTagName('script');

    for (var i = 0, l = scripts.length; i < l; i++) {
      var sc = scripts[i];

      if (sc.src.indexOf('elastic') > 0) {
        return sc;
      }
    }
  }
}

function getCurrentScript() {
  if (typeof document !== 'undefined') {
    var currentScript = document.currentScript;

    if (!currentScript) {
      return getElasticScript();
    }

    return currentScript;
  }
}

function extend(dst) {
  return baseExtend(dst, slice.call(arguments, 1), false);
}

function merge(dst) {
  return baseExtend(dst, slice.call(arguments, 1), true);
}

function isUndefined(obj) {
  return typeof obj === 'undefined';
}

function utils_noop() {}

function find(array, predicate, thisArg) {
  if (array == null) {
    throw new TypeError('array is null or not defined');
  }

  var o = Object(array);
  var len = o.length >>> 0;

  if (typeof predicate !== 'function') {
    throw new TypeError('predicate must be a function');
  }

  var k = 0;

  while (k < len) {
    var kValue = o[k];

    if (predicate.call(thisArg, kValue, k, o)) {
      return kValue;
    }

    k++;
  }

  return undefined;
}

function removeInvalidChars(key) {
  return key.replace(/[.*"]/g, '_');
}

function getLatestSpan(spans, typeFilter) {
  var latestSpan = null;

  for (var _i3 = 0; _i3 < spans.length; _i3++) {
    var span = spans[_i3];

    if (typeFilter && typeFilter(span.type) && (!latestSpan || latestSpan._end < span._end)) {
      latestSpan = span;
    }
  }

  return latestSpan;
}

function getLatestNonXHRSpan(spans) {
  return getLatestSpan(spans, function (type) {
    return String(type).indexOf('external') === -1;
  });
}

function getLatestXHRSpan(spans) {
  return getLatestSpan(spans, function (type) {
    return String(type).indexOf('external') !== -1;
  });
}

function getEarliestSpan(spans) {
  var earliestSpan = spans[0];

  for (var _i4 = 1; _i4 < spans.length; _i4++) {
    var span = spans[_i4];

    if (earliestSpan._start > span._start) {
      earliestSpan = span;
    }
  }

  return earliestSpan;
}

function now() {
  return PERF.now();
}

function getTime(time) {
  return typeof time === 'number' && time >= 0 ? time : now();
}

function getDuration(start, end) {
  if (isUndefined(end) || isUndefined(start)) {
    return null;
  }

  return parseInt(end - start);
}

function scheduleMacroTask(callback) {
  setTimeout(callback, 0);
}

function scheduleMicroTask(callback) {
  polyfills_Promise.resolve().then(callback);
}

function isPerfTimelineSupported() {
  return typeof PERF.getEntriesByType === 'function';
}

function isPerfTypeSupported(type) {
  return typeof PerformanceObserver !== 'undefined' && PerformanceObserver.supportedEntryTypes && PerformanceObserver.supportedEntryTypes.indexOf(type) >= 0;
}

function isBeaconInspectionEnabled() {
  var flagName = '_elastic_inspect_beacon_';

  if (sessionStorage.getItem(flagName) != null) {
    return true;
  }

  if (!window.URL || !window.URLSearchParams) {
    return false;
  }

  try {
    var parsedUrl = new URL(window.location.href);
    var isFlagSet = parsedUrl.searchParams.has(flagName);

    if (isFlagSet) {
      sessionStorage.setItem(flagName, true);
    }

    return isFlagSet;
  } catch (e) {}

  return false;
}


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/url.js


function isDefaultPort(port, protocol) {
  switch (protocol) {
    case 'http:':
      return port === '80';

    case 'https:':
      return port === '443';
  }

  return true;
}

var RULES = [['#', 'hash'], ['?', 'query'], ['/', 'path'], ['@', 'auth', 1], [NaN, 'host', undefined, 1]];
var PROTOCOL_REGEX = /^([a-z][a-z0-9.+-]*:)?(\/\/)?([\S\s]*)/i;
var Url = function () {
  function Url(url) {
    var _this$extractProtocol = this.extractProtocol(url || ''),
        protocol = _this$extractProtocol.protocol,
        address = _this$extractProtocol.address,
        slashes = _this$extractProtocol.slashes;

    var relative = !protocol && !slashes;
    var location = this.getLocation();
    var instructions = RULES.slice();
    address = address.replace('\\', '/');

    if (!slashes) {
      instructions[2] = [NaN, 'path'];
    }

    var index;

    for (var i = 0; i < instructions.length; i++) {
      var instruction = instructions[i];
      var parse = instruction[0];
      var key = instruction[1];

      if (typeof parse === 'string') {
        index = address.indexOf(parse);

        if (~index) {
          var instLength = instruction[2];

          if (instLength) {
            var newIndex = address.lastIndexOf(parse);
            index = Math.max(index, newIndex);
            this[key] = address.slice(0, index);
            address = address.slice(index + instLength);
          } else {
            this[key] = address.slice(index);
            address = address.slice(0, index);
          }
        }
      } else {
        this[key] = address;
        address = '';
      }

      this[key] = this[key] || (relative && instruction[3] ? location[key] || '' : '');
      if (instruction[3]) this[key] = this[key].toLowerCase();
    }

    if (relative && this.path.charAt(0) !== '/') {
      this.path = '/' + this.path;
    }

    this.relative = relative;
    this.protocol = protocol || location.protocol;
    this.hostname = this.host;
    this.port = '';

    if (/:\d+$/.test(this.host)) {
      var value = this.host.split(':');
      var port = value.pop();
      var hostname = value.join(':');

      if (isDefaultPort(port, this.protocol)) {
        this.host = hostname;
      } else {
        this.port = port;
      }

      this.hostname = hostname;
    }

    this.origin = this.protocol && this.host && this.protocol !== 'file:' ? this.protocol + '//' + this.host : 'null';
    this.href = this.toString();
  }

  var _proto = Url.prototype;

  _proto.toString = function toString() {
    var result = this.protocol;
    result += '//';

    if (this.auth) {
      var REDACTED = '[REDACTED]';
      var userpass = this.auth.split(':');
      var username = userpass[0] ? REDACTED : '';
      var password = userpass[1] ? ':' + REDACTED : '';
      result += username + password + '@';
    }

    result += this.host;
    result += this.path;
    result += this.query;
    result += this.hash;
    return result;
  };

  _proto.getLocation = function getLocation() {
    var globalVar = {};

    if (isBrowser) {
      globalVar = window;
    }

    return globalVar.location;
  };

  _proto.extractProtocol = function extractProtocol(url) {
    var match = PROTOCOL_REGEX.exec(url);
    return {
      protocol: match[1] ? match[1].toLowerCase() : '',
      slashes: !!match[2],
      address: match[3]
    };
  };

  return Url;
}();
function slugifyUrl(urlStr, depth) {
  if (depth === void 0) {
    depth = 2;
  }

  var parsedUrl = new Url(urlStr);
  var query = parsedUrl.query,
      path = parsedUrl.path;
  var pathParts = path.substring(1).split('/');
  var redactString = ':id';
  var wildcard = '*';
  var specialCharsRegex = /\W|_/g;
  var digitsRegex = /[0-9]/g;
  var lowerCaseRegex = /[a-z]/g;
  var upperCaseRegex = /[A-Z]/g;
  var redactedParts = [];
  var redactedBefore = false;

  for (var index = 0; index < pathParts.length; index++) {
    var part = pathParts[index];

    if (redactedBefore || index > depth - 1) {
      if (part) {
        redactedParts.push(wildcard);
      }

      break;
    }

    var numberOfSpecialChars = (part.match(specialCharsRegex) || []).length;

    if (numberOfSpecialChars >= 2) {
      redactedParts.push(redactString);
      redactedBefore = true;
      continue;
    }

    var numberOfDigits = (part.match(digitsRegex) || []).length;

    if (numberOfDigits > 3 || part.length > 3 && numberOfDigits / part.length >= 0.3) {
      redactedParts.push(redactString);
      redactedBefore = true;
      continue;
    }

    var numberofUpperCase = (part.match(upperCaseRegex) || []).length;
    var numberofLowerCase = (part.match(lowerCaseRegex) || []).length;
    var lowerCaseRate = numberofLowerCase / part.length;
    var upperCaseRate = numberofUpperCase / part.length;

    if (part.length > 5 && (upperCaseRate > 0.3 && upperCaseRate < 0.6 || lowerCaseRate > 0.3 && lowerCaseRate < 0.6)) {
      redactedParts.push(redactString);
      redactedBefore = true;
      continue;
    }

    part && redactedParts.push(part);
  }

  var redacted = '/' + (redactedParts.length >= 2 ? redactedParts.join('/') : redactedParts.join('')) + (query ? '?{query}' : '');
  return redacted;
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/constants.js
var SCHEDULE = 'schedule';
var INVOKE = 'invoke';
var ADD_EVENT_LISTENER_STR = 'addEventListener';
var REMOVE_EVENT_LISTENER_STR = 'removeEventListener';
var RESOURCE_INITIATOR_TYPES = ['link', 'css', 'script', 'img', 'xmlhttprequest', 'fetch', 'beacon', 'iframe'];
var REUSABILITY_THRESHOLD = 5000;
var MAX_SPAN_DURATION = 5 * 60 * 1000;
var PAGE_LOAD_DELAY = 1000;
var PAGE_LOAD = 'page-load';
var ROUTE_CHANGE = 'route-change';
var TYPE_CUSTOM = 'custom';
var USER_INTERACTION = 'user-interaction';
var HTTP_REQUEST_TYPE = 'http-request';
var TEMPORARY_TYPE = 'temporary';
var NAME_UNKNOWN = 'Unknown';
var TRANSACTION_TYPE_ORDER = [PAGE_LOAD, ROUTE_CHANGE, USER_INTERACTION, HTTP_REQUEST_TYPE, TYPE_CUSTOM, TEMPORARY_TYPE];
var OUTCOME_SUCCESS = 'success';
var OUTCOME_FAILURE = 'failure';
var OUTCOME_UNKNOWN = 'unknown';
var USER_TIMING_THRESHOLD = 60;
var TRANSACTION_START = 'transaction:start';
var TRANSACTION_END = 'transaction:end';
var CONFIG_CHANGE = 'config:change';
var QUEUE_FLUSH = 'queue:flush';
var QUEUE_ADD_TRANSACTION = 'queue:add_transaction';
var XMLHTTPREQUEST = 'xmlhttprequest';
var FETCH = 'fetch';
var HISTORY = 'history';
var EVENT_TARGET = 'eventtarget';
var CLICK = 'click';
var ERROR = 'error';
var BEFORE_EVENT = ':before';
var AFTER_EVENT = ':after';
var LOCAL_CONFIG_KEY = 'elastic_apm_config';
var LONG_TASK = 'longtask';
var PAINT = 'paint';
var MEASURE = 'measure';
var NAVIGATION = 'navigation';
var RESOURCE = 'resource';
var FIRST_CONTENTFUL_PAINT = 'first-contentful-paint';
var LARGEST_CONTENTFUL_PAINT = 'largest-contentful-paint';
var FIRST_INPUT = 'first-input';
var LAYOUT_SHIFT = 'layout-shift';
var ERRORS = 'errors';
var TRANSACTIONS = 'transactions';
var CONFIG_SERVICE = 'ConfigService';
var LOGGING_SERVICE = 'LoggingService';
var TRANSACTION_SERVICE = 'TransactionService';
var APM_SERVER = 'ApmServer';
var PERFORMANCE_MONITORING = 'PerformanceMonitoring';
var ERROR_LOGGING = 'ErrorLogging';
var TRUNCATED_TYPE = '.truncated';
var KEYWORD_LIMIT = 1024;
var SESSION_TIMEOUT = 30 * 60000;
var constants_HTTP_REQUEST_TIMEOUT = 10000;

;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/context.js
var _excluded = ["tags"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }




var LEFT_SQUARE_BRACKET = 91;
var RIGHT_SQUARE_BRACKET = 93;
var EXTERNAL = 'external';
var context_RESOURCE = 'resource';
var HARD_NAVIGATION = 'hard-navigation';

function getPortNumber(port, protocol) {
  if (port === '') {
    port = protocol === 'http:' ? '80' : protocol === 'https:' ? '443' : '';
  }

  return port;
}

function getResponseContext(perfTimingEntry) {
  var transferSize = perfTimingEntry.transferSize,
      encodedBodySize = perfTimingEntry.encodedBodySize,
      decodedBodySize = perfTimingEntry.decodedBodySize,
      serverTiming = perfTimingEntry.serverTiming;
  var respContext = {
    transfer_size: transferSize,
    encoded_body_size: encodedBodySize,
    decoded_body_size: decodedBodySize
  };
  var serverTimingStr = getServerTimingInfo(serverTiming);

  if (serverTimingStr) {
    respContext.headers = {
      'server-timing': serverTimingStr
    };
  }

  return respContext;
}

function getDestination(parsedUrl) {
  var port = parsedUrl.port,
      protocol = parsedUrl.protocol,
      hostname = parsedUrl.hostname;
  var portNumber = getPortNumber(port, protocol);
  var ipv6Hostname = hostname.charCodeAt(0) === LEFT_SQUARE_BRACKET && hostname.charCodeAt(hostname.length - 1) === RIGHT_SQUARE_BRACKET;
  var address = hostname;

  if (ipv6Hostname) {
    address = hostname.slice(1, -1);
  }

  return {
    service: {
      resource: hostname + ':' + portNumber,
      name: '',
      type: ''
    },
    address: address,
    port: Number(portNumber)
  };
}

function getResourceContext(data) {
  var entry = data.entry,
      url = data.url;
  var parsedUrl = new Url(url);
  var destination = getDestination(parsedUrl);
  return {
    http: {
      url: url,
      response: getResponseContext(entry)
    },
    destination: destination
  };
}

function getExternalContext(data) {
  var url = data.url,
      method = data.method,
      target = data.target,
      response = data.response;
  var parsedUrl = new Url(url);
  var destination = getDestination(parsedUrl);
  var context = {
    http: {
      method: method,
      url: parsedUrl.href
    },
    destination: destination
  };
  var statusCode;

  if (target && typeof target.status !== 'undefined') {
    statusCode = target.status;
  } else if (response) {
    statusCode = response.status;
  }

  context.http.status_code = statusCode;
  return context;
}

function getNavigationContext(data) {
  var url = data.url;
  var parsedUrl = new Url(url);
  var destination = getDestination(parsedUrl);
  return {
    destination: destination
  };
}

function getPageContext() {
  return {
    page: {
      referer: document.referrer,
      url: location.href
    }
  };
}
function addSpanContext(span, data) {
  if (!data) {
    return;
  }

  var type = span.type;
  var context;

  switch (type) {
    case EXTERNAL:
      context = getExternalContext(data);
      break;

    case context_RESOURCE:
      context = getResourceContext(data);
      break;

    case HARD_NAVIGATION:
      context = getNavigationContext(data);
      break;
  }

  span.addContext(context);
}
function addTransactionContext(transaction, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      tags = _ref.tags,
      configContext = _objectWithoutPropertiesLoose(_ref, _excluded);

  var pageContext = getPageContext();
  var responseContext = {};

  if (transaction.type === PAGE_LOAD && isPerfTimelineSupported()) {
    var entries = PERF.getEntriesByType(NAVIGATION);

    if (entries && entries.length > 0) {
      responseContext = {
        response: getResponseContext(entries[0])
      };
    }
  }

  transaction.addContext(pageContext, responseContext, configContext);
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/truncate.js

var METADATA_MODEL = {
  service: {
    name: [KEYWORD_LIMIT, true],
    version: true,
    agent: {
      version: [KEYWORD_LIMIT, true]
    },
    environment: true
  },
  labels: {
    '*': true
  }
};
var RESPONSE_MODEL = {
  '*': true,
  headers: {
    '*': true
  }
};
var DESTINATION_MODEL = {
  address: [KEYWORD_LIMIT],
  service: {
    '*': [KEYWORD_LIMIT, true]
  }
};
var CONTEXT_MODEL = {
  user: {
    id: true,
    email: true,
    username: true
  },
  tags: {
    '*': true
  },
  http: {
    response: RESPONSE_MODEL
  },
  destination: DESTINATION_MODEL,
  response: RESPONSE_MODEL
};
var SPAN_MODEL = {
  name: [KEYWORD_LIMIT, true],
  type: [KEYWORD_LIMIT, true],
  id: [KEYWORD_LIMIT, true],
  trace_id: [KEYWORD_LIMIT, true],
  parent_id: [KEYWORD_LIMIT, true],
  transaction_id: [KEYWORD_LIMIT, true],
  subtype: true,
  action: true,
  context: CONTEXT_MODEL
};
var TRANSACTION_MODEL = {
  name: true,
  parent_id: true,
  type: [KEYWORD_LIMIT, true],
  id: [KEYWORD_LIMIT, true],
  trace_id: [KEYWORD_LIMIT, true],
  span_count: {
    started: [KEYWORD_LIMIT, true]
  },
  context: CONTEXT_MODEL
};
var ERROR_MODEL = {
  id: [KEYWORD_LIMIT, true],
  trace_id: true,
  transaction_id: true,
  parent_id: true,
  culprit: true,
  exception: {
    type: true
  },
  transaction: {
    type: true
  },
  context: CONTEXT_MODEL
};

function truncate(value, limit, required, placeholder) {
  if (limit === void 0) {
    limit = KEYWORD_LIMIT;
  }

  if (required === void 0) {
    required = false;
  }

  if (placeholder === void 0) {
    placeholder = 'N/A';
  }

  if (required && isEmpty(value)) {
    value = placeholder;
  }

  if (typeof value === 'string') {
    return value.substring(0, limit);
  }

  return value;
}

function isEmpty(value) {
  return value == null || value === '' || typeof value === 'undefined';
}

function replaceValue(target, key, currModel) {
  var value = truncate(target[key], currModel[0], currModel[1]);

  if (isEmpty(value)) {
    delete target[key];
    return;
  }

  target[key] = value;
}

function truncateModel(model, target, childTarget) {
  if (model === void 0) {
    model = {};
  }

  if (childTarget === void 0) {
    childTarget = target;
  }

  var keys = Object.keys(model);
  var emptyArr = [];

  var _loop = function _loop(i) {
    var currKey = keys[i];
    var currModel = model[currKey] === true ? emptyArr : model[currKey];

    if (!Array.isArray(currModel)) {
      truncateModel(currModel, target, childTarget[currKey]);
    } else {
      if (currKey === '*') {
        Object.keys(childTarget).forEach(function (key) {
          return replaceValue(childTarget, key, currModel);
        });
      } else {
        replaceValue(childTarget, currKey, currModel);
      }
    }
  };

  for (var i = 0; i < keys.length; i++) {
    _loop(i);
  }

  return target;
}


// EXTERNAL MODULE: ./node_modules/error-stack-parser/error-stack-parser.js
var error_stack_parser = __webpack_require__(180);
var error_stack_parser_default = /*#__PURE__*/__webpack_require__.n(error_stack_parser);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/error-logging/error-logging.js
var error_logging_excluded = ["tags"];

function error_logging_objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }






var IGNORE_KEYS = ['stack', 'message'];

function getErrorProperties(error) {
  var propertyFound = false;
  var properties = {};
  Object.keys(error).forEach(function (key) {
    if (IGNORE_KEYS.indexOf(key) >= 0) {
      return;
    }

    var val = error[key];

    if (val == null || typeof val === 'function') {
      return;
    }

    if (typeof val === 'object') {
      if (typeof val.toISOString !== 'function') return;
      val = val.toISOString();
    }

    properties[key] = val;
    propertyFound = true;
  });

  if (propertyFound) {
    return properties;
  }
}

var ErrorLogging = function () {
  function ErrorLogging(apmServer, configService, transactionService) {
    this._apmServer = apmServer;
    this._configService = configService;
    this._transactionService = transactionService;
  }

  var _proto = ErrorLogging.prototype;

  _proto.createErrorDataModel = function createErrorDataModel(errorEvent) {
    var frames = createStackTraces((error_stack_parser_default()), errorEvent);
    var filteredFrames = filterInvalidFrames(frames);
    var culprit = '(inline script)';
    var lastFrame = filteredFrames[filteredFrames.length - 1];

    if (lastFrame && lastFrame.filename) {
      culprit = lastFrame.filename;
    }

    var message = errorEvent.message,
        error = errorEvent.error;
    var errorMessage = message;
    var errorType = '';
    var errorContext = {};

    if (error && typeof error === 'object') {
      errorMessage = errorMessage || error.message;
      errorType = error.name;
      var customProperties = getErrorProperties(error);

      if (customProperties) {
        errorContext.custom = customProperties;
      }
    }

    if (!errorType) {
      if (errorMessage && errorMessage.indexOf(':') > -1) {
        errorType = errorMessage.split(':')[0];
      }
    }

    var currentTransaction = this._transactionService.getCurrentTransaction();

    var transactionContext = currentTransaction ? currentTransaction.context : {};

    var _this$_configService$ = this._configService.get('context'),
        tags = _this$_configService$.tags,
        configContext = error_logging_objectWithoutPropertiesLoose(_this$_configService$, error_logging_excluded);

    var pageContext = getPageContext();
    var context = merge({}, pageContext, transactionContext, configContext, errorContext);
    var errorObject = {
      id: generateRandomId(),
      culprit: culprit,
      exception: {
        message: errorMessage,
        stacktrace: filteredFrames,
        type: errorType
      },
      context: context
    };

    if (currentTransaction) {
      errorObject = extend(errorObject, {
        trace_id: currentTransaction.traceId,
        parent_id: currentTransaction.id,
        transaction_id: currentTransaction.id,
        transaction: {
          type: currentTransaction.type,
          sampled: currentTransaction.sampled
        }
      });
    }

    return truncateModel(ERROR_MODEL, errorObject);
  };

  _proto.logErrorEvent = function logErrorEvent(errorEvent) {
    if (typeof errorEvent === 'undefined') {
      return;
    }

    var errorObject = this.createErrorDataModel(errorEvent);

    if (typeof errorObject.exception.message === 'undefined') {
      return;
    }

    this._apmServer.addError(errorObject);
  };

  _proto.registerListeners = function registerListeners() {
    var _this = this;

    window.addEventListener('error', function (errorEvent) {
      return _this.logErrorEvent(errorEvent);
    });
    window.addEventListener('unhandledrejection', function (promiseRejectionEvent) {
      return _this.logPromiseEvent(promiseRejectionEvent);
    });
  };

  _proto.logPromiseEvent = function logPromiseEvent(promiseRejectionEvent) {
    var prefix = 'Unhandled promise rejection: ';
    var reason = promiseRejectionEvent.reason;

    if (reason == null) {
      reason = '<no reason specified>';
    }

    var errorEvent;

    if (typeof reason.message === 'string') {
      var name = reason.name ? reason.name + ': ' : '';
      errorEvent = {
        error: reason,
        message: prefix + name + reason.message
      };
    } else {
      reason = typeof reason === 'object' ? '<object>' : typeof reason === 'function' ? '<function>' : reason;
      errorEvent = {
        message: prefix + reason
      };
    }

    this.logErrorEvent(errorEvent);
  };

  _proto.logError = function logError(messageOrError) {
    var errorEvent = {};

    if (typeof messageOrError === 'string') {
      errorEvent.message = messageOrError;
    } else {
      errorEvent.error = messageOrError;
    }

    return this.logErrorEvent(errorEvent);
  };

  return ErrorLogging;
}();

/* harmony default export */ const error_logging = (ErrorLogging);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/queue.js
var Queue = function () {
  function Queue(onFlush, opts) {
    if (opts === void 0) {
      opts = {};
    }

    this.onFlush = onFlush;
    this.items = [];
    this.queueLimit = opts.queueLimit || -1;
    this.flushInterval = opts.flushInterval || 0;
    this.timeoutId = undefined;
  }

  var _proto = Queue.prototype;

  _proto._setTimer = function _setTimer() {
    var _this = this;

    this.timeoutId = setTimeout(function () {
      return _this.flush();
    }, this.flushInterval);
  };

  _proto._clear = function _clear() {
    if (typeof this.timeoutId !== 'undefined') {
      clearTimeout(this.timeoutId);
      this.timeoutId = undefined;
    }

    this.items = [];
  };

  _proto.flush = function flush() {
    this.onFlush(this.items);

    this._clear();
  };

  _proto.add = function add(item) {
    this.items.push(item);

    if (this.queueLimit !== -1 && this.items.length >= this.queueLimit) {
      this.flush();
    } else {
      if (typeof this.timeoutId === 'undefined') {
        this._setTimer();
      }
    }
  };

  return Queue;
}();

/* harmony default export */ const queue = (Queue);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/throttle.js
function throttle(fn, onThrottle, opts) {
  var context = this;
  var limit = opts.limit;
  var interval = opts.interval;
  var counter = 0;
  var timeoutId;
  return function () {
    counter++;

    if (typeof timeoutId === 'undefined') {
      timeoutId = setTimeout(function () {
        counter = 0;
        timeoutId = undefined;
      }, interval);
    }

    if (counter > limit && typeof onThrottle === 'function') {
      return onThrottle.apply(context, arguments);
    } else {
      return fn.apply(context, arguments);
    }
  };
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/ndjson.js
var NDJSON = function () {
  function NDJSON() {}

  NDJSON.stringify = function stringify(object) {
    return JSON.stringify(object) + '\n';
  };

  return NDJSON;
}();

/* harmony default export */ const common_ndjson = (NDJSON);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/span-base.js



var SpanBase = function () {
  function SpanBase(name, type, options) {
    if (options === void 0) {
      options = {};
    }

    if (!name) {
      name = NAME_UNKNOWN;
    }

    if (!type) {
      type = TYPE_CUSTOM;
    }

    this.name = name;
    this.type = type;
    this.options = options;
    this.id = options.id || generateRandomId(16);
    this.traceId = options.traceId;
    this.sampled = options.sampled;
    this.sampleRate = options.sampleRate;
    this.timestamp = options.timestamp;
    this._start = getTime(options.startTime);
    this._end = undefined;
    this.ended = false;
    this.outcome = undefined;
    this.onEnd = options.onEnd;
  }

  var _proto = SpanBase.prototype;

  _proto.ensureContext = function ensureContext() {
    if (!this.context) {
      this.context = {};
    }
  };

  _proto.addLabels = function addLabels(tags) {
    this.ensureContext();
    var ctx = this.context;

    if (!ctx.tags) {
      ctx.tags = {};
    }

    var keys = Object.keys(tags);
    keys.forEach(function (k) {
      return setLabel(k, tags[k], ctx.tags);
    });
  };

  _proto.addContext = function addContext() {
    for (var _len = arguments.length, context = new Array(_len), _key = 0; _key < _len; _key++) {
      context[_key] = arguments[_key];
    }

    if (context.length === 0) return;
    this.ensureContext();
    merge.apply(void 0, [this.context].concat(context));
  };

  _proto.end = function end(endTime) {
    if (this.ended) {
      return;
    }

    this.ended = true;
    this._end = getTime(endTime);
    this.callOnEnd();
  };

  _proto.callOnEnd = function callOnEnd() {
    if (typeof this.onEnd === 'function') {
      this.onEnd(this);
    }
  };

  _proto.duration = function duration() {
    return getDuration(this._start, this._end);
  };

  return SpanBase;
}();

/* harmony default export */ const span_base = (SpanBase);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/span.js
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }




var Span = function (_SpanBase) {
  _inheritsLoose(Span, _SpanBase);

  function Span(name, type, options) {
    var _this;

    _this = _SpanBase.call(this, name, type, options) || this;
    _this.parentId = _this.options.parentId;
    _this.subtype = undefined;
    _this.action = undefined;

    if (_this.type.indexOf('.') !== -1) {
      var fields = _this.type.split('.', 3);

      _this.type = fields[0];
      _this.subtype = fields[1];
      _this.action = fields[2];
    }

    _this.sync = _this.options.sync;
    return _this;
  }

  var _proto = Span.prototype;

  _proto.end = function end(endTime, data) {
    _SpanBase.prototype.end.call(this, endTime);

    addSpanContext(this, data);
  };

  return Span;
}(span_base);

/* harmony default export */ const performance_monitoring_span = (Span);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/state.js
var __DEV__ = "production" !== 'production';

var state = {
  bootstrapTime: null,
  lastHiddenStart: Number.MIN_SAFE_INTEGER
};

;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/capture-navigation.js




var eventPairs = [['domainLookupStart', 'domainLookupEnd', 'Domain lookup'], ['connectStart', 'connectEnd', 'Making a connection to the server'], ['requestStart', 'responseEnd', 'Requesting and receiving the document'], ['domLoading', 'domInteractive', 'Parsing the document, executing sync. scripts'], ['domContentLoadedEventStart', 'domContentLoadedEventEnd', 'Fire "DOMContentLoaded" event'], ['loadEventStart', 'loadEventEnd', 'Fire "load" event']];

function shouldCreateSpan(start, end, trStart, trEnd, baseTime) {
  if (baseTime === void 0) {
    baseTime = 0;
  }

  return typeof start === 'number' && typeof end === 'number' && start >= baseTime && end > start && start - baseTime >= trStart && end - baseTime <= trEnd && end - start < MAX_SPAN_DURATION && start - baseTime < MAX_SPAN_DURATION && end - baseTime < MAX_SPAN_DURATION;
}

function createNavigationTimingSpans(timings, baseTime, trStart, trEnd) {
  var spans = [];

  for (var i = 0; i < eventPairs.length; i++) {
    var start = timings[eventPairs[i][0]];
    var end = timings[eventPairs[i][1]];

    if (!shouldCreateSpan(start, end, trStart, trEnd, baseTime)) {
      continue;
    }

    var span = new performance_monitoring_span(eventPairs[i][2], 'hard-navigation.browser-timing');
    var data = null;

    if (eventPairs[i][0] === 'requestStart') {
      span.pageResponse = true;
      data = {
        url: location.origin
      };
    }

    span._start = start - baseTime;
    span.end(end - baseTime, data);
    spans.push(span);
  }

  return spans;
}

function createResourceTimingSpan(resourceTimingEntry) {
  var name = resourceTimingEntry.name,
      initiatorType = resourceTimingEntry.initiatorType,
      startTime = resourceTimingEntry.startTime,
      responseEnd = resourceTimingEntry.responseEnd;
  var kind = 'resource';

  if (initiatorType) {
    kind += '.' + initiatorType;
  }

  var spanName = stripQueryStringFromUrl(name);
  var span = new performance_monitoring_span(spanName, kind);
  span._start = startTime;
  span.end(responseEnd, {
    url: name,
    entry: resourceTimingEntry
  });
  return span;
}

function isCapturedByPatching(resourceStartTime, requestPatchTime) {
  return requestPatchTime != null && resourceStartTime > requestPatchTime;
}

function isIntakeAPIEndpoint(url) {
  return /intake\/v\d+\/rum\/events/.test(url);
}

function createResourceTimingSpans(entries, requestPatchTime, trStart, trEnd) {
  var spans = [];

  for (var i = 0; i < entries.length; i++) {
    var _entries$i = entries[i],
        initiatorType = _entries$i.initiatorType,
        name = _entries$i.name,
        startTime = _entries$i.startTime,
        responseEnd = _entries$i.responseEnd;

    if (RESOURCE_INITIATOR_TYPES.indexOf(initiatorType) === -1 || name == null) {
      continue;
    }

    if ((initiatorType === 'xmlhttprequest' || initiatorType === 'fetch') && (isIntakeAPIEndpoint(name) || isCapturedByPatching(startTime, requestPatchTime))) {
      continue;
    }

    if (shouldCreateSpan(startTime, responseEnd, trStart, trEnd)) {
      spans.push(createResourceTimingSpan(entries[i]));
    }
  }

  return spans;
}

function createUserTimingSpans(entries, trStart, trEnd) {
  var userTimingSpans = [];

  for (var i = 0; i < entries.length; i++) {
    var _entries$i2 = entries[i],
        name = _entries$i2.name,
        startTime = _entries$i2.startTime,
        duration = _entries$i2.duration;
    var end = startTime + duration;

    if (duration <= USER_TIMING_THRESHOLD || !shouldCreateSpan(startTime, end, trStart, trEnd)) {
      continue;
    }

    var kind = 'app';
    var span = new performance_monitoring_span(name, kind);
    span._start = startTime;
    span.end(end);
    userTimingSpans.push(span);
  }

  return userTimingSpans;
}

var NAVIGATION_TIMING_MARKS = ['fetchStart', 'domainLookupStart', 'domainLookupEnd', 'connectStart', 'connectEnd', 'requestStart', 'responseStart', 'responseEnd', 'domLoading', 'domInteractive', 'domContentLoadedEventStart', 'domContentLoadedEventEnd', 'domComplete', 'loadEventStart', 'loadEventEnd'];
var COMPRESSED_NAV_TIMING_MARKS = ['fs', 'ls', 'le', 'cs', 'ce', 'qs', 'rs', 're', 'dl', 'di', 'ds', 'de', 'dc', 'es', 'ee'];

function getNavigationTimingMarks(timing) {
  var fetchStart = timing.fetchStart,
      navigationStart = timing.navigationStart,
      responseStart = timing.responseStart,
      responseEnd = timing.responseEnd;

  if (fetchStart >= navigationStart && responseStart >= fetchStart && responseEnd >= responseStart) {
    var marks = {};
    NAVIGATION_TIMING_MARKS.forEach(function (timingKey) {
      var m = timing[timingKey];

      if (m && m >= fetchStart) {
        marks[timingKey] = parseInt(m - fetchStart);
      }
    });
    return marks;
  }

  return null;
}

function getPageLoadMarks(timing) {
  var marks = getNavigationTimingMarks(timing);

  if (marks == null) {
    return null;
  }

  return {
    navigationTiming: marks,
    agent: {
      timeToFirstByte: marks.responseStart,
      domInteractive: marks.domInteractive,
      domComplete: marks.domComplete
    }
  };
}

function captureNavigation(transaction) {
  if (!transaction.captureTimings) {
    return;
  }

  var trEnd = transaction._end;

  if (transaction.type === PAGE_LOAD) {
    if (transaction.marks && transaction.marks.custom) {
      var customMarks = transaction.marks.custom;
      Object.keys(customMarks).forEach(function (key) {
        customMarks[key] += transaction._start;
      });
    }

    var trStart = 0;
    transaction._start = trStart;
    var timings = PERF.timing;
    createNavigationTimingSpans(timings, timings.fetchStart, trStart, trEnd).forEach(function (span) {
      span.traceId = transaction.traceId;
      span.sampled = transaction.sampled;

      if (span.pageResponse && transaction.options.pageLoadSpanId) {
        span.id = transaction.options.pageLoadSpanId;
      }

      transaction.spans.push(span);
    });
    transaction.addMarks(getPageLoadMarks(timings));
  }

  if (isPerfTimelineSupported()) {
    var _trStart = transaction._start;
    var resourceEntries = PERF.getEntriesByType(RESOURCE);
    createResourceTimingSpans(resourceEntries, state.bootstrapTime, _trStart, trEnd).forEach(function (span) {
      return transaction.spans.push(span);
    });
    var userEntries = PERF.getEntriesByType(MEASURE);
    createUserTimingSpans(userEntries, _trStart, trEnd).forEach(function (span) {
      return transaction.spans.push(span);
    });
  }
}


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/compress.js




function compressStackFrames(frames) {
  return frames.map(function (frame) {
    return {
      ap: frame.abs_path,
      f: frame.filename,
      fn: frame.function,
      li: frame.lineno,
      co: frame.colno
    };
  });
}

function compressResponse(response) {
  return {
    ts: response.transfer_size,
    ebs: response.encoded_body_size,
    dbs: response.decoded_body_size
  };
}

function compressHTTP(http) {
  var compressed = {};
  var method = http.method,
      status_code = http.status_code,
      url = http.url,
      response = http.response;
  compressed.url = url;

  if (method) {
    compressed.mt = method;
  }

  if (status_code) {
    compressed.sc = status_code;
  }

  if (response) {
    compressed.r = compressResponse(response);
  }

  return compressed;
}

function compressContext(context) {
  if (!context) {
    return null;
  }

  var compressed = {};
  var page = context.page,
      http = context.http,
      response = context.response,
      destination = context.destination,
      user = context.user,
      custom = context.custom;

  if (page) {
    compressed.p = {
      rf: page.referer,
      url: page.url
    };
  }

  if (http) {
    compressed.h = compressHTTP(http);
  }

  if (response) {
    compressed.r = compressResponse(response);
  }

  if (destination) {
    var service = destination.service;
    compressed.dt = {
      se: {
        n: service.name,
        t: service.type,
        rc: service.resource
      },
      ad: destination.address,
      po: destination.port
    };
  }

  if (user) {
    compressed.u = {
      id: user.id,
      un: user.username,
      em: user.email
    };
  }

  if (custom) {
    compressed.cu = custom;
  }

  return compressed;
}

function compressMarks(marks) {
  if (!marks) {
    return null;
  }

  var compressedNtMarks = compressNavigationTimingMarks(marks.navigationTiming);
  var compressed = {
    nt: compressedNtMarks,
    a: compressAgentMarks(compressedNtMarks, marks.agent)
  };
  return compressed;
}

function compressNavigationTimingMarks(ntMarks) {
  if (!ntMarks) {
    return null;
  }

  var compressed = {};
  COMPRESSED_NAV_TIMING_MARKS.forEach(function (mark, index) {
    var mapping = NAVIGATION_TIMING_MARKS[index];
    compressed[mark] = ntMarks[mapping];
  });
  return compressed;
}

function compressAgentMarks(compressedNtMarks, agentMarks) {
  var compressed = {};

  if (compressedNtMarks) {
    compressed = {
      fb: compressedNtMarks.rs,
      di: compressedNtMarks.di,
      dc: compressedNtMarks.dc
    };
  }

  if (agentMarks) {
    var fp = agentMarks.firstContentfulPaint;
    var lp = agentMarks.largestContentfulPaint;

    if (fp) {
      compressed.fp = fp;
    }

    if (lp) {
      compressed.lp = lp;
    }
  }

  if (Object.keys(compressed).length === 0) {
    return null;
  }

  return compressed;
}

function compressMetadata(metadata) {
  var service = metadata.service,
      labels = metadata.labels;
  var agent = service.agent,
      language = service.language;
  return {
    se: {
      n: service.name,
      ve: service.version,
      a: {
        n: agent.name,
        ve: agent.version
      },
      la: {
        n: language.name
      },
      en: service.environment
    },
    l: labels
  };
}
function compressTransaction(transaction) {
  var spans = transaction.spans.map(function (span) {
    var spanData = {
      id: span.id,
      n: span.name,
      t: span.type,
      s: span.start,
      d: span.duration,
      c: compressContext(span.context),
      o: span.outcome,
      sr: span.sample_rate
    };

    if (span.parent_id !== transaction.id) {
      spanData.pid = span.parent_id;
    }

    if (span.sync === true) {
      spanData.sy = true;
    }

    if (span.subtype) {
      spanData.su = span.subtype;
    }

    if (span.action) {
      spanData.ac = span.action;
    }

    return spanData;
  });
  var tr = {
    id: transaction.id,
    tid: transaction.trace_id,
    n: transaction.name,
    t: transaction.type,
    d: transaction.duration,
    c: compressContext(transaction.context),
    k: compressMarks(transaction.marks),
    me: compressMetricsets(transaction.breakdown),
    y: spans,
    yc: {
      sd: spans.length
    },
    sm: transaction.sampled,
    sr: transaction.sample_rate,
    o: transaction.outcome
  };

  if (transaction.experience) {
    var _transaction$experien = transaction.experience,
        cls = _transaction$experien.cls,
        fid = _transaction$experien.fid,
        tbt = _transaction$experien.tbt,
        longtask = _transaction$experien.longtask;
    tr.exp = {
      cls: cls,
      fid: fid,
      tbt: tbt,
      lt: longtask
    };
  }

  if (transaction.session) {
    var _transaction$session = transaction.session,
        id = _transaction$session.id,
        sequence = _transaction$session.sequence;
    tr.ses = {
      id: id,
      seq: sequence
    };
  }

  return tr;
}
function compressError(error) {
  var exception = error.exception;
  var compressed = {
    id: error.id,
    cl: error.culprit,
    ex: {
      mg: exception.message,
      st: compressStackFrames(exception.stacktrace),
      t: error.type
    },
    c: compressContext(error.context)
  };
  var transaction = error.transaction;

  if (transaction) {
    compressed.tid = error.trace_id;
    compressed.pid = error.parent_id;
    compressed.xid = error.transaction_id;
    compressed.x = {
      t: transaction.type,
      sm: transaction.sampled
    };
  }

  return compressed;
}
function compressMetricsets(breakdowns) {
  return breakdowns.map(function (_ref) {
    var span = _ref.span,
        samples = _ref.samples;
    var isSpan = span != null;

    if (isSpan) {
      return {
        y: {
          t: span.type
        },
        sa: {
          ysc: {
            v: samples['span.self_time.count'].value
          },
          yss: {
            v: samples['span.self_time.sum.us'].value
          }
        }
      };
    }

    return {
      sa: {
        xdc: {
          v: samples['transaction.duration.count'].value
        },
        xds: {
          v: samples['transaction.duration.sum.us'].value
        },
        xbc: {
          v: samples['transaction.breakdown.count'].value
        }
      }
    };
  });
}
function compressPayload(params, type) {
  if (type === void 0) {
    type = 'gzip';
  }

  var isCompressionStreamSupported = typeof CompressionStream === 'function';
  return new polyfills_Promise(function (resolve) {
    if (!isCompressionStreamSupported) {
      return resolve(params);
    }

    if (isBeaconInspectionEnabled()) {
      return resolve(params);
    }

    var payload = params.payload,
        headers = params.headers,
        beforeSend = params.beforeSend;
    var payloadStream = new Blob([payload]).stream();
    var compressedStream = payloadStream.pipeThrough(new CompressionStream(type));
    return new Response(compressedStream).blob().then(function (payload) {
      headers['Content-Encoding'] = type;
      return resolve({
        payload: payload,
        headers: headers,
        beforeSend: beforeSend
      });
    });
  });
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/http/response-status.js
function isResponseSuccessful(status) {
  if (status === 0 || status > 399 && status < 600) {
    return false;
  }

  return true;
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/http/fetch.js
function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }



var BYTE_LIMIT = 60 * 1000;
function shouldUseFetchWithKeepAlive(method, payload) {
  if (!isFetchSupported()) {
    return false;
  }

  var isKeepAliveSupported = ('keepalive' in new Request(''));

  if (!isKeepAliveSupported) {
    return false;
  }

  var size = calculateSize(payload);
  return method === 'POST' && size < BYTE_LIMIT;
}
function sendFetchRequest(method, url, _ref) {
  var _ref$keepalive = _ref.keepalive,
      keepalive = _ref$keepalive === void 0 ? false : _ref$keepalive,
      _ref$timeout = _ref.timeout,
      timeout = _ref$timeout === void 0 ? constants_HTTP_REQUEST_TIMEOUT : _ref$timeout,
      payload = _ref.payload,
      headers = _ref.headers,
      sendCredentials = _ref.sendCredentials;
  var timeoutConfig = {};

  if (typeof AbortController === 'function') {
    var controller = new AbortController();
    timeoutConfig.signal = controller.signal;
    setTimeout(function () {
      return controller.abort();
    }, timeout);
  }

  var fetchResponse;
  return window.fetch(url, _extends({
    body: payload,
    headers: headers,
    method: method,
    keepalive: keepalive,
    credentials: sendCredentials ? 'include' : 'omit'
  }, timeoutConfig)).then(function (response) {
    fetchResponse = response;
    return fetchResponse.text();
  }).then(function (responseText) {
    var bodyResponse = {
      url: url,
      status: fetchResponse.status,
      responseText: responseText
    };

    if (!isResponseSuccessful(fetchResponse.status)) {
      throw bodyResponse;
    }

    return bodyResponse;
  });
}
function isFetchSupported() {
  return typeof window.fetch === 'function' && typeof window.Request === 'function';
}

function calculateSize(payload) {
  if (!payload) {
    return 0;
  }

  if (payload instanceof Blob) {
    return payload.size;
  }

  return new Blob([payload]).size;
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/patching/patch-utils.js
var globalState = {
  fetchInProgress: false
};
function apmSymbol(name) {
  return '__apm_symbol__' + name;
}

function isPropertyWritable(propertyDesc) {
  if (!propertyDesc) {
    return true;
  }

  if (propertyDesc.writable === false) {
    return false;
  }

  return !(typeof propertyDesc.get === 'function' && typeof propertyDesc.set === 'undefined');
}

function attachOriginToPatched(patched, original) {
  patched[apmSymbol('OriginalDelegate')] = original;
}

function patchMethod(target, name, patchFn) {
  var proto = target;

  while (proto && !proto.hasOwnProperty(name)) {
    proto = Object.getPrototypeOf(proto);
  }

  if (!proto && target[name]) {
    proto = target;
  }

  var delegateName = apmSymbol(name);
  var delegate;

  if (proto && !(delegate = proto[delegateName])) {
    delegate = proto[delegateName] = proto[name];
    var desc = proto && Object.getOwnPropertyDescriptor(proto, name);

    if (isPropertyWritable(desc)) {
      var patchDelegate = patchFn(delegate, delegateName, name);

      proto[name] = function () {
        return patchDelegate(this, arguments);
      };

      attachOriginToPatched(proto[name], delegate);
    }
  }

  return delegate;
}
var XHR_IGNORE = apmSymbol('xhrIgnore');
var XHR_SYNC = apmSymbol('xhrSync');
var XHR_URL = apmSymbol('xhrURL');
var XHR_METHOD = apmSymbol('xhrMethod');
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/http/xhr.js



function sendXHR(method, url, _ref) {
  var _ref$timeout = _ref.timeout,
      timeout = _ref$timeout === void 0 ? HTTP_REQUEST_TIMEOUT : _ref$timeout,
      payload = _ref.payload,
      headers = _ref.headers,
      beforeSend = _ref.beforeSend,
      sendCredentials = _ref.sendCredentials;
  return new polyfills_Promise(function (resolve, reject) {
    var xhr = new window.XMLHttpRequest();
    xhr[XHR_IGNORE] = true;
    xhr.open(method, url, true);
    xhr.timeout = timeout;
    xhr.withCredentials = sendCredentials;

    if (headers) {
      for (var header in headers) {
        if (headers.hasOwnProperty(header)) {
          xhr.setRequestHeader(header, headers[header]);
        }
      }
    }

    xhr.onreadystatechange = function () {
      if (xhr.readyState === 4) {
        var status = xhr.status,
            responseText = xhr.responseText;

        if (isResponseSuccessful(status)) {
          resolve(xhr);
        } else {
          reject({
            url: url,
            status: status,
            responseText: responseText
          });
        }
      }
    };

    xhr.onerror = function () {
      var status = xhr.status,
          responseText = xhr.responseText;
      reject({
        url: url,
        status: status,
        responseText: responseText
      });
    };

    var canSend = true;

    if (typeof beforeSend === 'function') {
      canSend = beforeSend({
        url: url,
        method: method,
        headers: headers,
        payload: payload,
        xhr: xhr
      });
    }

    if (canSend) {
      xhr.send(payload);
    } else {
      reject({
        url: url,
        status: 0,
        responseText: 'Request rejected by user configuration.'
      });
    }
  });
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/apm-server.js











var THROTTLE_INTERVAL = 60000;

var ApmServer = function () {
  function ApmServer(configService, loggingService) {
    this._configService = configService;
    this._loggingService = loggingService;
    this.queue = undefined;
    this.throttleEvents = utils_noop;
  }

  var _proto = ApmServer.prototype;

  _proto.init = function init() {
    var _this = this;

    var queueLimit = this._configService.get('queueLimit');

    var flushInterval = this._configService.get('flushInterval');

    var limit = this._configService.get('eventsLimit');

    var onFlush = function onFlush(events) {
      var promise = _this.sendEvents(events);

      if (promise) {
        promise.catch(function (reason) {
          _this._loggingService.warn('Failed sending events!', _this._constructError(reason));
        });
      }
    };

    this.queue = new queue(onFlush, {
      queueLimit: queueLimit,
      flushInterval: flushInterval
    });
    this.throttleEvents = throttle(this.queue.add.bind(this.queue), function () {
      return _this._loggingService.warn('Dropped events due to throttling!');
    }, {
      limit: limit,
      interval: THROTTLE_INTERVAL
    });

    this._configService.observeEvent(QUEUE_FLUSH, function () {
      _this.queue.flush();
    });
  };

  _proto._postJson = function _postJson(endPoint, payload) {
    var _this2 = this;

    var headers = {
      'Content-Type': 'application/x-ndjson'
    };

    var apmRequest = this._configService.get('apmRequest');

    var params = {
      payload: payload,
      headers: headers,
      beforeSend: apmRequest
    };
    return compressPayload(params).catch(function (error) {
      if (__DEV__) {
        _this2._loggingService.debug('Compressing the payload using CompressionStream API failed', error.message);
      }

      return params;
    }).then(function (result) {
      return _this2._makeHttpRequest('POST', endPoint, result);
    }).then(function (_ref) {
      var responseText = _ref.responseText;
      return responseText;
    });
  };

  _proto._constructError = function _constructError(reason) {
    var url = reason.url,
        status = reason.status,
        responseText = reason.responseText;

    if (typeof status == 'undefined') {
      return reason;
    }

    var message = url + ' HTTP status: ' + status;

    if (__DEV__ && responseText) {
      try {
        var serverErrors = [];
        var response = JSON.parse(responseText);

        if (response.errors && response.errors.length > 0) {
          response.errors.forEach(function (err) {
            return serverErrors.push(err.message);
          });
          message += ' ' + serverErrors.join(',');
        }
      } catch (e) {
        this._loggingService.debug('Error parsing response from APM server', e);
      }
    }

    return new Error(message);
  };

  _proto._makeHttpRequest = function _makeHttpRequest(method, url, _temp) {
    var _ref2 = _temp === void 0 ? {} : _temp,
        _ref2$timeout = _ref2.timeout,
        timeout = _ref2$timeout === void 0 ? constants_HTTP_REQUEST_TIMEOUT : _ref2$timeout,
        payload = _ref2.payload,
        headers = _ref2.headers,
        beforeSend = _ref2.beforeSend;

    var sendCredentials = this._configService.get('sendCredentials');

    if (!beforeSend && shouldUseFetchWithKeepAlive(method, payload)) {
      return sendFetchRequest(method, url, {
        keepalive: true,
        timeout: timeout,
        payload: payload,
        headers: headers,
        sendCredentials: sendCredentials
      }).catch(function (reason) {
        if (reason instanceof TypeError) {
          return sendXHR(method, url, {
            timeout: timeout,
            payload: payload,
            headers: headers,
            beforeSend: beforeSend,
            sendCredentials: sendCredentials
          });
        }

        throw reason;
      });
    }

    return sendXHR(method, url, {
      timeout: timeout,
      payload: payload,
      headers: headers,
      beforeSend: beforeSend,
      sendCredentials: sendCredentials
    });
  };

  _proto.fetchConfig = function fetchConfig(serviceName, environment) {
    var _this3 = this;

    var _this$getEndpoints = this.getEndpoints(),
        configEndpoint = _this$getEndpoints.configEndpoint;

    if (!serviceName) {
      return polyfills_Promise.reject('serviceName is required for fetching central config.');
    }

    configEndpoint += "?service.name=" + serviceName;

    if (environment) {
      configEndpoint += "&service.environment=" + environment;
    }

    var localConfig = this._configService.getLocalConfig();

    if (localConfig) {
      configEndpoint += "&ifnonematch=" + localConfig.etag;
    }

    var apmRequest = this._configService.get('apmRequest');

    return this._makeHttpRequest('GET', configEndpoint, {
      timeout: 5000,
      beforeSend: apmRequest
    }).then(function (xhr) {
      var status = xhr.status,
          responseText = xhr.responseText;

      if (status === 304) {
        return localConfig;
      } else {
        var remoteConfig = JSON.parse(responseText);
        var etag = xhr.getResponseHeader('etag');

        if (etag) {
          remoteConfig.etag = etag.replace(/["]/g, '');

          _this3._configService.setLocalConfig(remoteConfig, true);
        }

        return remoteConfig;
      }
    }).catch(function (reason) {
      var error = _this3._constructError(reason);

      return polyfills_Promise.reject(error);
    });
  };

  _proto.createMetaData = function createMetaData() {
    var cfg = this._configService;
    var metadata = {
      service: {
        name: cfg.get('serviceName'),
        version: cfg.get('serviceVersion'),
        agent: {
          name: 'rum-js',
          version: cfg.version
        },
        language: {
          name: 'javascript'
        },
        environment: cfg.get('environment')
      },
      labels: cfg.get('context.tags')
    };
    return truncateModel(METADATA_MODEL, metadata);
  };

  _proto.addError = function addError(error) {
    var _this$throttleEvents;

    this.throttleEvents((_this$throttleEvents = {}, _this$throttleEvents[ERRORS] = error, _this$throttleEvents));
  };

  _proto.addTransaction = function addTransaction(transaction) {
    var _this$throttleEvents2;

    this.throttleEvents((_this$throttleEvents2 = {}, _this$throttleEvents2[TRANSACTIONS] = transaction, _this$throttleEvents2));
  };

  _proto.ndjsonErrors = function ndjsonErrors(errors, compress) {
    var key = compress ? 'e' : 'error';
    return errors.map(function (error) {
      var _NDJSON$stringify;

      return common_ndjson.stringify((_NDJSON$stringify = {}, _NDJSON$stringify[key] = compress ? compressError(error) : error, _NDJSON$stringify));
    });
  };

  _proto.ndjsonMetricsets = function ndjsonMetricsets(metricsets) {
    return metricsets.map(function (metricset) {
      return common_ndjson.stringify({
        metricset: metricset
      });
    }).join('');
  };

  _proto.ndjsonTransactions = function ndjsonTransactions(transactions, compress) {
    var _this4 = this;

    var key = compress ? 'x' : 'transaction';
    return transactions.map(function (tr) {
      var _NDJSON$stringify2;

      var spans = '',
          breakdowns = '';

      if (!compress) {
        if (tr.spans) {
          spans = tr.spans.map(function (span) {
            return common_ndjson.stringify({
              span: span
            });
          }).join('');
          delete tr.spans;
        }

        if (tr.breakdown) {
          breakdowns = _this4.ndjsonMetricsets(tr.breakdown);
          delete tr.breakdown;
        }
      }

      return common_ndjson.stringify((_NDJSON$stringify2 = {}, _NDJSON$stringify2[key] = compress ? compressTransaction(tr) : tr, _NDJSON$stringify2)) + spans + breakdowns;
    });
  };

  _proto.sendEvents = function sendEvents(events) {
    var _payload, _NDJSON$stringify3;

    if (events.length === 0) {
      return;
    }

    var transactions = [];
    var errors = [];

    for (var i = 0; i < events.length; i++) {
      var event = events[i];

      if (event[TRANSACTIONS]) {
        transactions.push(event[TRANSACTIONS]);
      }

      if (event[ERRORS]) {
        errors.push(event[ERRORS]);
      }
    }

    if (transactions.length === 0 && errors.length === 0) {
      return;
    }

    var cfg = this._configService;
    var payload = (_payload = {}, _payload[TRANSACTIONS] = transactions, _payload[ERRORS] = errors, _payload);
    var filteredPayload = cfg.applyFilters(payload);

    if (!filteredPayload) {
      this._loggingService.warn('Dropped payload due to filtering!');

      return;
    }

    var apiVersion = cfg.get('apiVersion');
    var compress = apiVersion > 2;
    var ndjson = [];
    var metadata = this.createMetaData();
    var metadataKey = compress ? 'm' : 'metadata';
    ndjson.push(common_ndjson.stringify((_NDJSON$stringify3 = {}, _NDJSON$stringify3[metadataKey] = compress ? compressMetadata(metadata) : metadata, _NDJSON$stringify3)));
    ndjson = ndjson.concat(this.ndjsonErrors(filteredPayload[ERRORS], compress), this.ndjsonTransactions(filteredPayload[TRANSACTIONS], compress));
    var ndjsonPayload = ndjson.join('');

    var _this$getEndpoints2 = this.getEndpoints(),
        intakeEndpoint = _this$getEndpoints2.intakeEndpoint;

    return this._postJson(intakeEndpoint, ndjsonPayload);
  };

  _proto.getEndpoints = function getEndpoints() {
    var serverUrl = this._configService.get('serverUrl');

    var apiVersion = this._configService.get('apiVersion');

    var serverUrlPrefix = this._configService.get('serverUrlPrefix') || "/intake/v" + apiVersion + "/rum/events";
    var intakeEndpoint = serverUrl + serverUrlPrefix;
    var configEndpoint = serverUrl + "/config/v1/rum/agents";
    return {
      intakeEndpoint: intakeEndpoint,
      configEndpoint: configEndpoint
    };
  };

  return ApmServer;
}();

/* harmony default export */ const apm_server = (ApmServer);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/event-handler.js


var EventHandler = function () {
  function EventHandler() {
    this.observers = {};
  }

  var _proto = EventHandler.prototype;

  _proto.observe = function observe(name, fn) {
    var _this = this;

    if (typeof fn === 'function') {
      if (!this.observers[name]) {
        this.observers[name] = [];
      }

      this.observers[name].push(fn);
      return function () {
        var index = _this.observers[name].indexOf(fn);

        if (index > -1) {
          _this.observers[name].splice(index, 1);
        }
      };
    }
  };

  _proto.sendOnly = function sendOnly(name, args) {
    var obs = this.observers[name];

    if (obs) {
      obs.forEach(function (fn) {
        try {
          fn.apply(undefined, args);
        } catch (error) {
          console.log(error, error.stack);
        }
      });
    }
  };

  _proto.send = function send(name, args) {
    this.sendOnly(name + BEFORE_EVENT, args);
    this.sendOnly(name, args);
    this.sendOnly(name + AFTER_EVENT, args);
  };

  return EventHandler;
}();

/* harmony default export */ const event_handler = (EventHandler);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/config-service.js
function config_service_extends() { config_service_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return config_service_extends.apply(this, arguments); }





function getConfigFromScript() {
  var script = getCurrentScript();
  var config = getDataAttributesFromNode(script);
  return config;
}

function getDataAttributesFromNode(node) {
  if (!node) {
    return {};
  }

  var dataAttrs = {};
  var dataRegex = /^data-([\w-]+)$/;
  var attrs = node.attributes;

  for (var i = 0; i < attrs.length; i++) {
    var attr = attrs[i];

    if (dataRegex.test(attr.nodeName)) {
      var key = attr.nodeName.match(dataRegex)[1];
      var camelCasedkey = key.split('-').map(function (value, index) {
        return index > 0 ? value.charAt(0).toUpperCase() + value.substring(1) : value;
      }).join('');
      dataAttrs[camelCasedkey] = attr.value || attr.nodeValue;
    }
  }

  return dataAttrs;
}

var Config = function () {
  function Config() {
    this.config = {
      serviceName: '',
      serviceVersion: '',
      environment: '',
      serverUrl: 'http://localhost:8200',
      serverUrlPrefix: '',
      active: true,
      instrument: true,
      disableInstrumentations: [],
      logLevel: 'warn',
      breakdownMetrics: false,
      ignoreTransactions: [],
      eventsLimit: 80,
      queueLimit: -1,
      flushInterval: 500,
      distributedTracing: true,
      distributedTracingOrigins: [],
      distributedTracingHeaderName: 'traceparent',
      pageLoadTraceId: '',
      pageLoadSpanId: '',
      pageLoadSampled: false,
      pageLoadTransactionName: '',
      propagateTracestate: false,
      transactionSampleRate: 1.0,
      centralConfig: false,
      monitorLongtasks: true,
      apiVersion: 2,
      context: {},
      session: false,
      apmRequest: null,
      sendCredentials: false
    };
    this.events = new event_handler();
    this.filters = [];
    this.version = '';
  }

  var _proto = Config.prototype;

  _proto.init = function init() {
    var scriptData = getConfigFromScript();
    this.setConfig(scriptData);
  };

  _proto.setVersion = function setVersion(version) {
    this.version = version;
  };

  _proto.addFilter = function addFilter(cb) {
    if (typeof cb !== 'function') {
      throw new Error('Argument to must be function');
    }

    this.filters.push(cb);
  };

  _proto.applyFilters = function applyFilters(data) {
    for (var i = 0; i < this.filters.length; i++) {
      data = this.filters[i](data);

      if (!data) {
        return;
      }
    }

    return data;
  };

  _proto.get = function get(key) {
    return key.split('.').reduce(function (obj, objKey) {
      return obj && obj[objKey];
    }, this.config);
  };

  _proto.setUserContext = function setUserContext(userContext) {
    if (userContext === void 0) {
      userContext = {};
    }

    var context = {};
    var _userContext = userContext,
        id = _userContext.id,
        username = _userContext.username,
        email = _userContext.email;

    if (typeof id === 'number' || typeof id === 'string') {
      context.id = id;
    }

    if (typeof username === 'string') {
      context.username = username;
    }

    if (typeof email === 'string') {
      context.email = email;
    }

    this.config.context.user = extend(this.config.context.user || {}, context);
  };

  _proto.setCustomContext = function setCustomContext(customContext) {
    if (customContext === void 0) {
      customContext = {};
    }

    this.config.context.custom = extend(this.config.context.custom || {}, customContext);
  };

  _proto.addLabels = function addLabels(tags) {
    var _this = this;

    if (!this.config.context.tags) {
      this.config.context.tags = {};
    }

    var keys = Object.keys(tags);
    keys.forEach(function (k) {
      return setLabel(k, tags[k], _this.config.context.tags);
    });
  };

  _proto.setConfig = function setConfig(properties) {
    if (properties === void 0) {
      properties = {};
    }

    var _properties = properties,
        transactionSampleRate = _properties.transactionSampleRate,
        serverUrl = _properties.serverUrl;

    if (serverUrl) {
      properties.serverUrl = serverUrl.replace(/\/+$/, '');
    }

    if (!isUndefined(transactionSampleRate)) {
      if (transactionSampleRate < 0.0001 && transactionSampleRate > 0) {
        transactionSampleRate = 0.0001;
      }

      properties.transactionSampleRate = Math.round(transactionSampleRate * 10000) / 10000;
    }

    merge(this.config, properties);
    this.events.send(CONFIG_CHANGE, [this.config]);
  };

  _proto.validate = function validate(properties) {
    if (properties === void 0) {
      properties = {};
    }

    var requiredKeys = ['serviceName', 'serverUrl'];
    var allKeys = Object.keys(this.config);
    var errors = {
      missing: [],
      invalid: [],
      unknown: []
    };
    Object.keys(properties).forEach(function (key) {
      if (requiredKeys.indexOf(key) !== -1 && !properties[key]) {
        errors.missing.push(key);
      }

      if (allKeys.indexOf(key) === -1) {
        errors.unknown.push(key);
      }
    });

    if (properties.serviceName && !/^[a-zA-Z0-9 _-]+$/.test(properties.serviceName)) {
      errors.invalid.push({
        key: 'serviceName',
        value: properties.serviceName,
        allowed: 'a-z, A-Z, 0-9, _, -, <space>'
      });
    }

    var sampleRate = properties.transactionSampleRate;

    if (typeof sampleRate !== 'undefined' && (typeof sampleRate !== 'number' || isNaN(sampleRate) || sampleRate < 0 || sampleRate > 1)) {
      errors.invalid.push({
        key: 'transactionSampleRate',
        value: sampleRate,
        allowed: 'Number between 0 and 1'
      });
    }

    return errors;
  };

  _proto.getLocalConfig = function getLocalConfig() {
    var storage = sessionStorage;

    if (this.config.session) {
      storage = localStorage;
    }

    var config = storage.getItem(LOCAL_CONFIG_KEY);

    if (config) {
      return JSON.parse(config);
    }
  };

  _proto.setLocalConfig = function setLocalConfig(config, merge) {
    if (config) {
      if (merge) {
        var prevConfig = this.getLocalConfig();
        config = config_service_extends({}, prevConfig, config);
      }

      var storage = sessionStorage;

      if (this.config.session) {
        storage = localStorage;
      }

      storage.setItem(LOCAL_CONFIG_KEY, JSON.stringify(config));
    }
  };

  _proto.dispatchEvent = function dispatchEvent(name, args) {
    this.events.send(name, args);
  };

  _proto.observeEvent = function observeEvent(name, fn) {
    return this.events.observe(name, fn);
  };

  return Config;
}();

/* harmony default export */ const config_service = (Config);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/logging-service.js


var LoggingService = function () {
  function LoggingService(spec) {
    if (spec === void 0) {
      spec = {};
    }

    this.levels = ['trace', 'debug', 'info', 'warn', 'error'];
    this.level = spec.level || 'warn';
    this.prefix = spec.prefix || '';
    this.resetLogMethods();
  }

  var _proto = LoggingService.prototype;

  _proto.shouldLog = function shouldLog(level) {
    return this.levels.indexOf(level) >= this.levels.indexOf(this.level);
  };

  _proto.setLevel = function setLevel(level) {
    if (level === this.level) {
      return;
    }

    this.level = level;
    this.resetLogMethods();
  };

  _proto.resetLogMethods = function resetLogMethods() {
    var _this = this;

    this.levels.forEach(function (level) {
      _this[level] = _this.shouldLog(level) ? log : utils_noop;

      function log() {
        var normalizedLevel = level;

        if (level === 'trace' || level === 'debug') {
          normalizedLevel = 'info';
        }

        var args = arguments;
        args[0] = this.prefix + args[0];

        if (console) {
          var realMethod = console[normalizedLevel] || console.log;

          if (typeof realMethod === 'function') {
            realMethod.apply(console, args);
          }
        }
      }
    });
  };

  return LoggingService;
}();

/* harmony default export */ const logging_service = (LoggingService);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/service-factory.js
var _serviceCreators;






var serviceCreators = (_serviceCreators = {}, _serviceCreators[CONFIG_SERVICE] = function () {
  return new config_service();
}, _serviceCreators[LOGGING_SERVICE] = function () {
  return new logging_service({
    prefix: '[Elastic APM] '
  });
}, _serviceCreators[APM_SERVER] = function (factory) {
  var _factory$getService = factory.getService([CONFIG_SERVICE, LOGGING_SERVICE]),
      configService = _factory$getService[0],
      loggingService = _factory$getService[1];

  return new apm_server(configService, loggingService);
}, _serviceCreators);

var ServiceFactory = function () {
  function ServiceFactory() {
    this.instances = {};
    this.initialized = false;
  }

  var _proto = ServiceFactory.prototype;

  _proto.init = function init() {
    if (this.initialized) {
      return;
    }

    this.initialized = true;
    var configService = this.getService(CONFIG_SERVICE);
    configService.init();

    var _this$getService = this.getService([LOGGING_SERVICE, APM_SERVER]),
        loggingService = _this$getService[0],
        apmServer = _this$getService[1];

    configService.events.observe(CONFIG_CHANGE, function () {
      var logLevel = configService.get('logLevel');
      loggingService.setLevel(logLevel);
    });
    apmServer.init();
  };

  _proto.getService = function getService(name) {
    var _this = this;

    if (typeof name === 'string') {
      if (!this.instances[name]) {
        if (typeof serviceCreators[name] === 'function') {
          this.instances[name] = serviceCreators[name](this);
        } else if (__DEV__) {
          console.log('Cannot get service, No creator for: ' + name);
        }
      }

      return this.instances[name];
    } else if (Array.isArray(name)) {
      return name.map(function (n) {
        return _this.getService(n);
      });
    }
  };

  return ServiceFactory;
}();


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/error-logging/index.js




function registerServices() {
  serviceCreators[ERROR_LOGGING] = function (serviceFactory) {
    var _serviceFactory$getSe = serviceFactory.getService([APM_SERVER, CONFIG_SERVICE, TRANSACTION_SERVICE]),
        apmServer = _serviceFactory$getSe[0],
        configService = _serviceFactory$getSe[1],
        transactionService = _serviceFactory$getSe[2];

    return new error_logging(apmServer, configService, transactionService);
  };
}


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/patching/xhr-patch.js


function patchXMLHttpRequest(callback) {
  var XMLHttpRequestPrototype = XMLHttpRequest.prototype;

  if (!XMLHttpRequestPrototype || !XMLHttpRequestPrototype[ADD_EVENT_LISTENER_STR]) {
    return;
  }

  var READY_STATE_CHANGE = 'readystatechange';
  var LOAD = 'load';
  var ERROR = 'error';
  var TIMEOUT = 'timeout';
  var ABORT = 'abort';

  function invokeTask(task, status) {
    if (task.state !== INVOKE) {
      task.state = INVOKE;
      task.data.status = status;
      callback(INVOKE, task);
    }
  }

  function scheduleTask(task) {
    if (task.state === SCHEDULE) {
      return;
    }

    task.state = SCHEDULE;
    callback(SCHEDULE, task);
    var target = task.data.target;

    function addListener(name) {
      target[ADD_EVENT_LISTENER_STR](name, function (_ref) {
        var type = _ref.type;

        if (type === READY_STATE_CHANGE) {
          if (target.readyState === 4 && target.status !== 0) {
            invokeTask(task, 'success');
          }
        } else {
          var status = type === LOAD ? 'success' : type;
          invokeTask(task, status);
        }
      });
    }

    addListener(READY_STATE_CHANGE);
    addListener(LOAD);
    addListener(TIMEOUT);
    addListener(ERROR);
    addListener(ABORT);
  }

  var openNative = patchMethod(XMLHttpRequestPrototype, 'open', function () {
    return function (self, args) {
      if (!self[XHR_IGNORE]) {
        self[XHR_METHOD] = args[0];
        self[XHR_URL] = args[1];
        self[XHR_SYNC] = args[2] === false;
      }

      return openNative.apply(self, args);
    };
  });
  var sendNative = patchMethod(XMLHttpRequestPrototype, 'send', function () {
    return function (self, args) {
      if (self[XHR_IGNORE]) {
        return sendNative.apply(self, args);
      }

      var task = {
        source: XMLHTTPREQUEST,
        state: '',
        type: 'macroTask',
        data: {
          target: self,
          method: self[XHR_METHOD],
          sync: self[XHR_SYNC],
          url: self[XHR_URL],
          status: ''
        }
      };

      try {
        scheduleTask(task);
        return sendNative.apply(self, args);
      } catch (e) {
        invokeTask(task, ERROR);
        throw e;
      }
    };
  });
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/patching/fetch-patch.js





function patchFetch(callback) {
  if (!isFetchSupported()) {
    return;
  }

  function scheduleTask(task) {
    task.state = SCHEDULE;
    callback(SCHEDULE, task);
  }

  function invokeTask(task) {
    task.state = INVOKE;
    callback(INVOKE, task);
  }

  function handleResponseError(task, error) {
    task.data.aborted = isAbortError(error);
    task.data.error = error;
    invokeTask(task);
  }

  function readStream(stream, task) {
    var reader = stream.getReader();

    var read = function read() {
      reader.read().then(function (_ref) {
        var done = _ref.done;

        if (done) {
          invokeTask(task);
        } else {
          read();
        }
      }, function (error) {
        handleResponseError(task, error);
      });
    };

    read();
  }

  var nativeFetch = window.fetch;

  window.fetch = function (input, init) {
    var fetchSelf = this;
    var args = arguments;
    var request, url;

    if (typeof input === 'string') {
      request = new Request(input, init);
      url = input;
    } else if (input) {
      request = input;
      url = request.url;
    } else {
      return nativeFetch.apply(fetchSelf, args);
    }

    var task = {
      source: FETCH,
      state: '',
      type: 'macroTask',
      data: {
        target: request,
        method: request.method,
        url: url,
        aborted: false
      }
    };
    return new polyfills_Promise(function (resolve, reject) {
      globalState.fetchInProgress = true;
      scheduleTask(task);
      var promise;

      try {
        promise = nativeFetch.apply(fetchSelf, [request]);
      } catch (error) {
        reject(error);
        task.data.error = error;
        invokeTask(task);
        globalState.fetchInProgress = false;
        return;
      }

      promise.then(function (response) {
        var clonedResponse = response.clone ? response.clone() : {};
        resolve(response);
        scheduleMicroTask(function () {
          task.data.response = response;
          var body = clonedResponse.body;

          if (body) {
            readStream(body, task);
          } else {
            invokeTask(task);
          }
        });
      }, function (error) {
        reject(error);
        scheduleMicroTask(function () {
          handleResponseError(task, error);
        });
      });
      globalState.fetchInProgress = false;
    });
  };
}

function isAbortError(error) {
  return error && error.name === 'AbortError';
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/patching/history-patch.js

function patchHistory(callback) {
  if (!window.history) {
    return;
  }

  var nativePushState = history.pushState;

  if (typeof nativePushState === 'function') {
    history.pushState = function (state, title, url) {
      var task = {
        source: HISTORY,
        data: {
          state: state,
          title: title,
          url: url
        }
      };
      callback(INVOKE, task);
      nativePushState.apply(this, arguments);
    };
  }
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/patching/index.js





var patchEventHandler = new event_handler();
var alreadyPatched = false;

function patchAll() {
  if (!alreadyPatched) {
    alreadyPatched = true;
    patchXMLHttpRequest(function (event, task) {
      patchEventHandler.send(XMLHTTPREQUEST, [event, task]);
    });
    patchFetch(function (event, task) {
      patchEventHandler.send(FETCH, [event, task]);
    });
    patchHistory(function (event, task) {
      patchEventHandler.send(HISTORY, [event, task]);
    });
  }

  return patchEventHandler;
}


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/performance-monitoring.js







var SIMILAR_SPAN_TO_TRANSACTION_RATIO = 0.05;
var TRANSACTION_DURATION_THRESHOLD = 60000;
function groupSmallContinuouslySimilarSpans(originalSpans, transDuration, threshold) {
  originalSpans.sort(function (spanA, spanB) {
    return spanA._start - spanB._start;
  });
  var spans = [];
  var lastCount = 1;
  originalSpans.forEach(function (span, index) {
    if (spans.length === 0) {
      spans.push(span);
    } else {
      var lastSpan = spans[spans.length - 1];
      var isContinuouslySimilar = lastSpan.type === span.type && lastSpan.subtype === span.subtype && lastSpan.action === span.action && lastSpan.name === span.name && span.duration() / transDuration < threshold && (span._start - lastSpan._end) / transDuration < threshold;
      var isLastSpan = originalSpans.length === index + 1;

      if (isContinuouslySimilar) {
        lastCount++;
        lastSpan._end = span._end;
      }

      if (lastCount > 1 && (!isContinuouslySimilar || isLastSpan)) {
        lastSpan.name = lastCount + 'x ' + lastSpan.name;
        lastCount = 1;
      }

      if (!isContinuouslySimilar) {
        spans.push(span);
      }
    }
  });
  return spans;
}
function adjustTransaction(transaction) {
  if (transaction.sampled) {
    var filterdSpans = transaction.spans.filter(function (span) {
      return span.duration() > 0 && span._start >= transaction._start && span._end <= transaction._end;
    });

    if (transaction.isManaged()) {
      var duration = transaction.duration();
      var similarSpans = groupSmallContinuouslySimilarSpans(filterdSpans, duration, SIMILAR_SPAN_TO_TRANSACTION_RATIO);
      transaction.spans = similarSpans;
    } else {
      transaction.spans = filterdSpans;
    }
  } else {
    transaction.resetFields();
  }

  return transaction;
}

var PerformanceMonitoring = function () {
  function PerformanceMonitoring(apmServer, configService, loggingService, transactionService) {
    this._apmServer = apmServer;
    this._configService = configService;
    this._logginService = loggingService;
    this._transactionService = transactionService;
  }

  var _proto = PerformanceMonitoring.prototype;

  _proto.init = function init(flags) {
    var _this = this;

    if (flags === void 0) {
      flags = {};
    }

    this._configService.events.observe(TRANSACTION_END + AFTER_EVENT, function (tr) {
      var payload = _this.createTransactionPayload(tr);

      if (payload) {
        _this._apmServer.addTransaction(payload);

        _this._configService.dispatchEvent(QUEUE_ADD_TRANSACTION);
      }
    });

    if (flags[HISTORY]) {
      patchEventHandler.observe(HISTORY, this.getHistorySub());
    }

    if (flags[XMLHTTPREQUEST]) {
      patchEventHandler.observe(XMLHTTPREQUEST, this.getXHRSub());
    }

    if (flags[FETCH]) {
      patchEventHandler.observe(FETCH, this.getFetchSub());
    }
  };

  _proto.getHistorySub = function getHistorySub() {
    var transactionService = this._transactionService;
    return function (event, task) {
      if (task.source === HISTORY && event === INVOKE) {
        transactionService.startTransaction(task.data.title, 'route-change', {
          managed: true,
          canReuse: true
        });
      }
    };
  };

  _proto.getXHRSub = function getXHRSub() {
    var _this2 = this;

    return function (event, task) {
      if (task.source === XMLHTTPREQUEST && !globalState.fetchInProgress) {
        _this2.processAPICalls(event, task);
      }
    };
  };

  _proto.getFetchSub = function getFetchSub() {
    var _this3 = this;

    return function (event, task) {
      if (task.source === FETCH) {
        _this3.processAPICalls(event, task);
      }
    };
  };

  _proto.processAPICalls = function processAPICalls(event, task) {
    var configService = this._configService;
    var transactionService = this._transactionService;

    if (task.data && task.data.url) {
      var endpoints = this._apmServer.getEndpoints();

      var isOwnEndpoint = Object.keys(endpoints).some(function (endpoint) {
        return task.data.url.indexOf(endpoints[endpoint]) !== -1;
      });

      if (isOwnEndpoint) {
        return;
      }
    }

    if (event === SCHEDULE && task.data) {
      var data = task.data;
      var requestUrl = new Url(data.url);
      var spanName = data.method + ' ' + (requestUrl.relative ? requestUrl.path : stripQueryStringFromUrl(requestUrl.href));

      if (!transactionService.getCurrentTransaction()) {
        transactionService.startTransaction(spanName, HTTP_REQUEST_TYPE, {
          managed: true
        });
      }

      var span = transactionService.startSpan(spanName, 'external.http', {
        blocking: true
      });

      if (!span) {
        return;
      }

      var isDtEnabled = configService.get('distributedTracing');
      var dtOrigins = configService.get('distributedTracingOrigins');
      var currentUrl = new Url(window.location.href);
      var isSameOrigin = checkSameOrigin(requestUrl.origin, currentUrl.origin) || checkSameOrigin(requestUrl.origin, dtOrigins);
      var target = data.target;

      if (isDtEnabled && isSameOrigin && target) {
        this.injectDtHeader(span, target);
        var propagateTracestate = configService.get('propagateTracestate');

        if (propagateTracestate) {
          this.injectTSHeader(span, target);
        }
      } else if (__DEV__) {
        this._logginService.debug("Could not inject distributed tracing header to the request origin ('" + requestUrl.origin + "') from the current origin ('" + currentUrl.origin + "')");
      }

      if (data.sync) {
        span.sync = data.sync;
      }

      data.span = span;
    } else if (event === INVOKE) {
      var _data = task.data;

      if (_data && _data.span) {
        var _span = _data.span,
            response = _data.response,
            _target = _data.target;
        var status;

        if (response) {
          status = response.status;
        } else {
          status = _target.status;
        }

        var outcome;

        if (_data.status != 'abort' && !_data.aborted) {
          if (status >= 400 || status == 0) {
            outcome = OUTCOME_FAILURE;
          } else {
            outcome = OUTCOME_SUCCESS;
          }
        } else {
          outcome = OUTCOME_UNKNOWN;
        }

        _span.outcome = outcome;
        var tr = transactionService.getCurrentTransaction();

        if (tr && tr.type === HTTP_REQUEST_TYPE) {
          tr.outcome = outcome;
        }

        transactionService.endSpan(_span, _data);
      }
    }
  };

  _proto.injectDtHeader = function injectDtHeader(span, target) {
    var headerName = this._configService.get('distributedTracingHeaderName');

    var headerValue = getDtHeaderValue(span);
    var isHeaderValid = isDtHeaderValid(headerValue);

    if (isHeaderValid && headerValue && headerName) {
      setRequestHeader(target, headerName, headerValue);
    }
  };

  _proto.injectTSHeader = function injectTSHeader(span, target) {
    var headerValue = getTSHeaderValue(span);

    if (headerValue) {
      setRequestHeader(target, 'tracestate', headerValue);
    }
  };

  _proto.extractDtHeader = function extractDtHeader(target) {
    var configService = this._configService;
    var headerName = configService.get('distributedTracingHeaderName');

    if (target) {
      return parseDtHeaderValue(target[headerName]);
    }
  };

  _proto.filterTransaction = function filterTransaction(tr) {
    var duration = tr.duration();

    if (!duration) {
      if (__DEV__) {
        var message = "transaction(" + tr.id + ", " + tr.name + ") was discarded! ";

        if (duration === 0) {
          message += "Transaction duration is 0";
        } else {
          message += "Transaction wasn't ended";
        }

        this._logginService.debug(message);
      }

      return false;
    }

    if (tr.isManaged()) {
      if (duration > TRANSACTION_DURATION_THRESHOLD) {
        if (__DEV__) {
          this._logginService.debug("transaction(" + tr.id + ", " + tr.name + ") was discarded! Transaction duration (" + duration + ") is greater than managed transaction threshold (" + TRANSACTION_DURATION_THRESHOLD + ")");
        }

        return false;
      }

      if (tr.sampled && tr.spans.length === 0) {
        if (__DEV__) {
          this._logginService.debug("transaction(" + tr.id + ", " + tr.name + ") was discarded! Transaction does not have any spans");
        }

        return false;
      }
    }

    return true;
  };

  _proto.createTransactionDataModel = function createTransactionDataModel(transaction) {
    var transactionStart = transaction._start;
    var spans = transaction.spans.map(function (span) {
      var spanData = {
        id: span.id,
        transaction_id: transaction.id,
        parent_id: span.parentId || transaction.id,
        trace_id: transaction.traceId,
        name: span.name,
        type: span.type,
        subtype: span.subtype,
        action: span.action,
        sync: span.sync,
        start: parseInt(span._start - transactionStart),
        duration: span.duration(),
        context: span.context,
        outcome: span.outcome,
        sample_rate: span.sampleRate
      };
      return truncateModel(SPAN_MODEL, spanData);
    });
    var transactionData = {
      id: transaction.id,
      trace_id: transaction.traceId,
      session: transaction.session,
      name: transaction.name,
      type: transaction.type,
      duration: transaction.duration(),
      spans: spans,
      context: transaction.context,
      marks: transaction.marks,
      breakdown: transaction.breakdownTimings,
      span_count: {
        started: spans.length
      },
      sampled: transaction.sampled,
      sample_rate: transaction.sampleRate,
      experience: transaction.experience,
      outcome: transaction.outcome
    };
    return truncateModel(TRANSACTION_MODEL, transactionData);
  };

  _proto.createTransactionPayload = function createTransactionPayload(transaction) {
    var adjustedTransaction = adjustTransaction(transaction);
    var filtered = this.filterTransaction(adjustedTransaction);

    if (filtered) {
      return this.createTransactionDataModel(transaction);
    }
  };

  return PerformanceMonitoring;
}();


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/breakdown.js


var pageLoadBreakdowns = [['domainLookupStart', 'domainLookupEnd', 'DNS'], ['connectStart', 'connectEnd', 'TCP'], ['requestStart', 'responseStart', 'Request'], ['responseStart', 'responseEnd', 'Response'], ['domLoading', 'domComplete', 'Processing'], ['loadEventStart', 'loadEventEnd', 'Load']];

function getValue(value) {
  return {
    value: value
  };
}

function calculateSelfTime(transaction) {
  var spans = transaction.spans,
      _start = transaction._start,
      _end = transaction._end;

  if (spans.length === 0) {
    return transaction.duration();
  }

  spans.sort(function (span1, span2) {
    return span1._start - span2._start;
  });
  var span = spans[0];
  var spanEnd = span._end;
  var spanStart = span._start;
  var lastContinuousEnd = spanEnd;
  var selfTime = spanStart - _start;

  for (var i = 1; i < spans.length; i++) {
    span = spans[i];
    spanStart = span._start;
    spanEnd = span._end;

    if (spanStart > lastContinuousEnd) {
      selfTime += spanStart - lastContinuousEnd;
      lastContinuousEnd = spanEnd;
    } else if (spanEnd > lastContinuousEnd) {
      lastContinuousEnd = spanEnd;
    }
  }

  if (lastContinuousEnd < _end) {
    selfTime += _end - lastContinuousEnd;
  }

  return selfTime;
}

function groupSpans(transaction) {
  var spanMap = {};
  var transactionSelfTime = calculateSelfTime(transaction);
  spanMap['app'] = {
    count: 1,
    duration: transactionSelfTime
  };
  var spans = transaction.spans;

  for (var i = 0; i < spans.length; i++) {
    var span = spans[i];
    var duration = span.duration();

    if (duration === 0 || duration == null) {
      continue;
    }

    var type = span.type,
        subtype = span.subtype;
    var key = type.replace(TRUNCATED_TYPE, '');

    if (subtype) {
      key += '.' + subtype;
    }

    if (!spanMap[key]) {
      spanMap[key] = {
        duration: 0,
        count: 0
      };
    }

    spanMap[key].count++;
    spanMap[key].duration += duration;
  }

  return spanMap;
}

function getSpanBreakdown(transactionDetails, _ref) {
  var details = _ref.details,
      _ref$count = _ref.count,
      count = _ref$count === void 0 ? 1 : _ref$count,
      duration = _ref.duration;
  return {
    transaction: transactionDetails,
    span: details,
    samples: {
      'span.self_time.count': getValue(count),
      'span.self_time.sum.us': getValue(duration)
    }
  };
}

function breakdown_captureBreakdown(transaction, timings) {
  if (timings === void 0) {
    timings = PERF.timing;
  }

  var breakdowns = [];
  var trDuration = transaction.duration();
  var name = transaction.name,
      type = transaction.type,
      sampled = transaction.sampled;
  var transactionDetails = {
    name: name,
    type: type
  };
  breakdowns.push({
    transaction: transactionDetails,
    samples: {
      'transaction.duration.count': getValue(1),
      'transaction.duration.sum.us': getValue(trDuration),
      'transaction.breakdown.count': getValue(sampled ? 1 : 0)
    }
  });

  if (!sampled) {
    return breakdowns;
  }

  if (type === PAGE_LOAD && timings) {
    for (var i = 0; i < pageLoadBreakdowns.length; i++) {
      var current = pageLoadBreakdowns[i];
      var start = timings[current[0]];
      var end = timings[current[1]];
      var duration = getDuration(start, end);

      if (duration === 0 || duration == null) {
        continue;
      }

      breakdowns.push(getSpanBreakdown(transactionDetails, {
        details: {
          type: current[2]
        },
        duration: duration
      }));
    }
  } else {
    var spanMap = groupSpans(transaction);
    Object.keys(spanMap).forEach(function (key) {
      var _key$split = key.split('.'),
          type = _key$split[0],
          subtype = _key$split[1];

      var _spanMap$key = spanMap[key],
          duration = _spanMap$key.duration,
          count = _spanMap$key.count;
      breakdowns.push(getSpanBreakdown(transactionDetails, {
        details: {
          type: type,
          subtype: subtype
        },
        duration: duration,
        count: count
      }));
    });
  }

  return breakdowns;
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/transaction.js
function transaction_inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; transaction_setPrototypeOf(subClass, superClass); }

function transaction_setPrototypeOf(o, p) { transaction_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return transaction_setPrototypeOf(o, p); }







var Transaction = function (_SpanBase) {
  transaction_inheritsLoose(Transaction, _SpanBase);

  function Transaction(name, type, options) {
    var _this;

    _this = _SpanBase.call(this, name, type, options) || this;
    _this.traceId = generateRandomId();
    _this.marks = undefined;
    _this.spans = [];
    _this._activeSpans = {};
    _this._activeTasks = new Set();
    _this.blocked = false;
    _this.captureTimings = false;
    _this.breakdownTimings = [];
    _this.sampleRate = _this.options.transactionSampleRate;
    _this.sampled = Math.random() <= _this.sampleRate;
    return _this;
  }

  var _proto = Transaction.prototype;

  _proto.addMarks = function addMarks(obj) {
    this.marks = merge(this.marks || {}, obj);
  };

  _proto.mark = function mark(key) {
    var skey = removeInvalidChars(key);

    var markTime = now() - this._start;

    var custom = {};
    custom[skey] = markTime;
    this.addMarks({
      custom: custom
    });
  };

  _proto.canReuse = function canReuse() {
    var threshold = this.options.reuseThreshold || REUSABILITY_THRESHOLD;
    return !!this.options.canReuse && !this.ended && now() - this._start < threshold;
  };

  _proto.redefine = function redefine(name, type, options) {
    if (name) {
      this.name = name;
    }

    if (type) {
      this.type = type;
    }

    if (options) {
      this.options.reuseThreshold = options.reuseThreshold;
      extend(this.options, options);
    }
  };

  _proto.startSpan = function startSpan(name, type, options) {
    var _this2 = this;

    if (this.ended) {
      return;
    }

    var opts = extend({}, options);

    opts.onEnd = function (trc) {
      _this2._onSpanEnd(trc);
    };

    opts.traceId = this.traceId;
    opts.sampled = this.sampled;
    opts.sampleRate = this.sampleRate;

    if (!opts.parentId) {
      opts.parentId = this.id;
    }

    var span = new performance_monitoring_span(name, type, opts);
    this._activeSpans[span.id] = span;

    if (opts.blocking) {
      this.addTask(span.id);
    }

    return span;
  };

  _proto.isFinished = function isFinished() {
    return !this.blocked && this._activeTasks.size === 0;
  };

  _proto.detectFinish = function detectFinish() {
    if (this.isFinished()) this.end();
  };

  _proto.end = function end(endTime) {
    if (this.ended) {
      return;
    }

    this.ended = true;
    this._end = getTime(endTime);

    for (var sid in this._activeSpans) {
      var span = this._activeSpans[sid];
      span.type = span.type + TRUNCATED_TYPE;
      span.end(endTime);
    }

    this.callOnEnd();
  };

  _proto.captureBreakdown = function captureBreakdown() {
    this.breakdownTimings = breakdown_captureBreakdown(this);
  };

  _proto.block = function block(flag) {
    this.blocked = flag;

    if (!this.blocked) {
      this.detectFinish();
    }
  };

  _proto.addTask = function addTask(taskId) {
    if (!taskId) {
      taskId = 'task-' + generateRandomId(16);
    }

    this._activeTasks.add(taskId);

    return taskId;
  };

  _proto.removeTask = function removeTask(taskId) {
    var deleted = this._activeTasks.delete(taskId);

    deleted && this.detectFinish();
  };

  _proto.resetFields = function resetFields() {
    this.spans = [];
    this.sampleRate = 0;
  };

  _proto._onSpanEnd = function _onSpanEnd(span) {
    this.spans.push(span);
    delete this._activeSpans[span.id];
    this.removeTask(span.id);
  };

  _proto.isManaged = function isManaged() {
    return !!this.options.managed;
  };

  return Transaction;
}(span_base);

/* harmony default export */ const transaction = (Transaction);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/metrics.js



var metrics = {
  fid: 0,
  fcp: 0,
  tbt: {
    start: Infinity,
    duration: 0
  },
  cls: {
    score: 0,
    firstEntryTime: Number.NEGATIVE_INFINITY,
    prevEntryTime: Number.NEGATIVE_INFINITY,
    currentSessionScore: 0
  },
  longtask: {
    count: 0,
    duration: 0,
    max: 0
  }
};
var LONG_TASK_THRESHOLD = 50;
function createLongTaskSpans(longtasks, agg) {
  var spans = [];

  for (var i = 0; i < longtasks.length; i++) {
    var _longtasks$i = longtasks[i],
        name = _longtasks$i.name,
        startTime = _longtasks$i.startTime,
        duration = _longtasks$i.duration,
        attribution = _longtasks$i.attribution;
    var end = startTime + duration;
    var span = new performance_monitoring_span("Longtask(" + name + ")", LONG_TASK, {
      startTime: startTime
    });
    agg.count++;
    agg.duration += duration;
    agg.max = Math.max(duration, agg.max);

    if (attribution.length > 0) {
      var _attribution$ = attribution[0],
          _name = _attribution$.name,
          containerType = _attribution$.containerType,
          containerName = _attribution$.containerName,
          containerId = _attribution$.containerId;
      var customContext = {
        attribution: _name,
        type: containerType
      };

      if (containerName) {
        customContext.name = containerName;
      }

      if (containerId) {
        customContext.id = containerId;
      }

      span.addContext({
        custom: customContext
      });
    }

    span.end(end);
    spans.push(span);
  }

  return spans;
}
function createFirstInputDelaySpan(fidEntries) {
  var firstInput = fidEntries[0];

  if (firstInput) {
    var startTime = firstInput.startTime,
        processingStart = firstInput.processingStart;
    var span = new performance_monitoring_span('First Input Delay', FIRST_INPUT, {
      startTime: startTime
    });
    span.end(processingStart);
    return span;
  }
}
function createTotalBlockingTimeSpan(tbtObject) {
  var start = tbtObject.start,
      duration = tbtObject.duration;
  var tbtSpan = new performance_monitoring_span('Total Blocking Time', LONG_TASK, {
    startTime: start
  });
  tbtSpan.end(start + duration);
  return tbtSpan;
}
function calculateTotalBlockingTime(longtaskEntries) {
  longtaskEntries.forEach(function (entry) {
    var name = entry.name,
        startTime = entry.startTime,
        duration = entry.duration;

    if (startTime < metrics.fcp) {
      return;
    }

    if (name !== 'self' && name.indexOf('same-origin') === -1) {
      return;
    }

    metrics.tbt.start = Math.min(metrics.tbt.start, startTime);
    var blockingTime = duration - LONG_TASK_THRESHOLD;

    if (blockingTime > 0) {
      metrics.tbt.duration += blockingTime;
    }
  });
}
function calculateCumulativeLayoutShift(clsEntries) {
  clsEntries.forEach(function (entry) {
    if (!entry.hadRecentInput && entry.value) {
      var shouldCreateNewSession = entry.startTime - metrics.cls.firstEntryTime > 5000 || entry.startTime - metrics.cls.prevEntryTime > 1000;

      if (shouldCreateNewSession) {
        metrics.cls.firstEntryTime = entry.startTime;
        metrics.cls.currentSessionScore = 0;
      }

      metrics.cls.prevEntryTime = entry.startTime;
      metrics.cls.currentSessionScore += entry.value;
      metrics.cls.score = Math.max(metrics.cls.score, metrics.cls.currentSessionScore);
    }
  });
}
function captureObserverEntries(list, _ref) {
  var isHardNavigation = _ref.isHardNavigation,
      trStart = _ref.trStart;
  var longtaskEntries = list.getEntriesByType(LONG_TASK).filter(function (entry) {
    return entry.startTime >= trStart;
  });
  var longTaskSpans = createLongTaskSpans(longtaskEntries, metrics.longtask);
  var result = {
    spans: longTaskSpans,
    marks: {}
  };

  if (!isHardNavigation) {
    return result;
  }

  var lcpEntries = list.getEntriesByType(LARGEST_CONTENTFUL_PAINT);
  var lastLcpEntry = lcpEntries[lcpEntries.length - 1];

  if (lastLcpEntry) {
    var lcp = parseInt(lastLcpEntry.startTime);
    metrics.lcp = lcp;
    result.marks.largestContentfulPaint = lcp;
  }

  var timing = PERF.timing;
  var unloadDiff = timing.fetchStart - timing.navigationStart;
  var fcpEntry = list.getEntriesByName(FIRST_CONTENTFUL_PAINT)[0];

  if (fcpEntry) {
    var fcp = parseInt(unloadDiff >= 0 ? fcpEntry.startTime - unloadDiff : fcpEntry.startTime);
    metrics.fcp = fcp;
    result.marks.firstContentfulPaint = fcp;
  }

  var fidEntries = list.getEntriesByType(FIRST_INPUT);
  var fidSpan = createFirstInputDelaySpan(fidEntries);

  if (fidSpan) {
    metrics.fid = fidSpan.duration();
    result.spans.push(fidSpan);
  }

  calculateTotalBlockingTime(longtaskEntries);
  var clsEntries = list.getEntriesByType(LAYOUT_SHIFT);
  calculateCumulativeLayoutShift(clsEntries);
  return result;
}
var PerfEntryRecorder = function () {
  function PerfEntryRecorder(callback) {
    this.po = {
      observe: utils_noop,
      disconnect: utils_noop
    };

    if (window.PerformanceObserver) {
      this.po = new PerformanceObserver(callback);
    }
  }

  var _proto = PerfEntryRecorder.prototype;

  _proto.start = function start(type) {
    try {
      this.po.observe({
        type: type,
        buffered: true
      });
    } catch (_) {}
  };

  _proto.stop = function stop() {
    this.po.disconnect();
  };

  return PerfEntryRecorder;
}();
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/transaction-service.js










var TransactionService = function () {
  function TransactionService(logger, config) {
    var _this = this;

    this._config = config;
    this._logger = logger;
    this.currentTransaction = undefined;
    this.respIntervalId = undefined;
    this.recorder = new PerfEntryRecorder(function (list) {
      var tr = _this.getCurrentTransaction();

      if (tr && tr.captureTimings) {
        var _tr$spans;

        var isHardNavigation = tr.type === PAGE_LOAD;

        var _captureObserverEntri = captureObserverEntries(list, {
          isHardNavigation: isHardNavigation,
          trStart: isHardNavigation ? 0 : tr._start
        }),
            spans = _captureObserverEntri.spans,
            marks = _captureObserverEntri.marks;

        (_tr$spans = tr.spans).push.apply(_tr$spans, spans);

        tr.addMarks({
          agent: marks
        });
      }
    });
  }

  var _proto = TransactionService.prototype;

  _proto.createCurrentTransaction = function createCurrentTransaction(name, type, options) {
    var tr = new transaction(name, type, options);
    this.currentTransaction = tr;
    return tr;
  };

  _proto.getCurrentTransaction = function getCurrentTransaction() {
    if (this.currentTransaction && !this.currentTransaction.ended) {
      return this.currentTransaction;
    }
  };

  _proto.createOptions = function createOptions(options) {
    var config = this._config.config;
    var presetOptions = {
      transactionSampleRate: config.transactionSampleRate
    };
    var perfOptions = extend(presetOptions, options);

    if (perfOptions.managed) {
      perfOptions = extend({
        pageLoadTraceId: config.pageLoadTraceId,
        pageLoadSampled: config.pageLoadSampled,
        pageLoadSpanId: config.pageLoadSpanId,
        pageLoadTransactionName: config.pageLoadTransactionName
      }, perfOptions);
    }

    return perfOptions;
  };

  _proto.startManagedTransaction = function startManagedTransaction(name, type, perfOptions) {
    var tr = this.getCurrentTransaction();
    var isRedefined = false;

    if (!tr) {
      tr = this.createCurrentTransaction(name, type, perfOptions);
    } else if (tr.canReuse() && perfOptions.canReuse) {
      var redefineType = tr.type;
      var currentTypeOrder = TRANSACTION_TYPE_ORDER.indexOf(tr.type);
      var redefineTypeOrder = TRANSACTION_TYPE_ORDER.indexOf(type);

      if (currentTypeOrder >= 0 && redefineTypeOrder < currentTypeOrder) {
        redefineType = type;
      }

      if (__DEV__) {
        this._logger.debug("redefining transaction(" + tr.id + ", " + tr.name + ", " + tr.type + ")", 'to', "(" + (name || tr.name) + ", " + redefineType + ")", tr);
      }

      tr.redefine(name, redefineType, perfOptions);
      isRedefined = true;
    } else {
      if (__DEV__) {
        this._logger.debug("ending previous transaction(" + tr.id + ", " + tr.name + ")", tr);
      }

      tr.end();
      tr = this.createCurrentTransaction(name, type, perfOptions);
    }

    if (tr.type === PAGE_LOAD) {
      if (!isRedefined) {
        this.recorder.start(LARGEST_CONTENTFUL_PAINT);
        this.recorder.start(PAINT);
        this.recorder.start(FIRST_INPUT);
        this.recorder.start(LAYOUT_SHIFT);
      }

      if (perfOptions.pageLoadTraceId) {
        tr.traceId = perfOptions.pageLoadTraceId;
      }

      if (perfOptions.pageLoadSampled) {
        tr.sampled = perfOptions.pageLoadSampled;
      }

      if (tr.name === NAME_UNKNOWN && perfOptions.pageLoadTransactionName) {
        tr.name = perfOptions.pageLoadTransactionName;
      }
    }

    if (!isRedefined && this._config.get('monitorLongtasks')) {
      this.recorder.start(LONG_TASK);
    }

    if (tr.sampled) {
      tr.captureTimings = true;
    }

    return tr;
  };

  _proto.startTransaction = function startTransaction(name, type, options) {
    var _this2 = this;

    var perfOptions = this.createOptions(options);
    var tr;
    var fireOnstartHook = true;

    if (perfOptions.managed) {
      var current = this.currentTransaction;
      tr = this.startManagedTransaction(name, type, perfOptions);

      if (current === tr) {
        fireOnstartHook = false;
      }
    } else {
      tr = new transaction(name, type, perfOptions);
    }

    tr.onEnd = function () {
      return _this2.handleTransactionEnd(tr);
    };

    if (fireOnstartHook) {
      if (__DEV__) {
        this._logger.debug("startTransaction(" + tr.id + ", " + tr.name + ", " + tr.type + ")");
      }

      this._config.events.send(TRANSACTION_START, [tr]);
    }

    return tr;
  };

  _proto.handleTransactionEnd = function handleTransactionEnd(tr) {
    var _this3 = this;

    this.recorder.stop();
    var currentUrl = window.location.href;
    return polyfills_Promise.resolve().then(function () {
      var name = tr.name,
          type = tr.type;
      var lastHiddenStart = state.lastHiddenStart;

      if (lastHiddenStart >= tr._start) {
        if (__DEV__) {
          _this3._logger.debug("transaction(" + tr.id + ", " + name + ", " + type + ") was discarded! The page was hidden during the transaction!");
        }

        return;
      }

      if (_this3.shouldIgnoreTransaction(name) || type === TEMPORARY_TYPE) {
        if (__DEV__) {
          _this3._logger.debug("transaction(" + tr.id + ", " + name + ", " + type + ") is ignored");
        }

        return;
      }

      if (type === PAGE_LOAD) {
        var pageLoadTransactionName = _this3._config.get('pageLoadTransactionName');

        if (name === NAME_UNKNOWN && pageLoadTransactionName) {
          tr.name = pageLoadTransactionName;
        }

        if (tr.captureTimings) {
          var cls = metrics.cls,
              fid = metrics.fid,
              tbt = metrics.tbt,
              longtask = metrics.longtask;

          if (tbt.duration > 0) {
            tr.spans.push(createTotalBlockingTimeSpan(tbt));
          }

          tr.experience = {};

          if (isPerfTypeSupported(LONG_TASK)) {
            tr.experience.tbt = tbt.duration;
          }

          if (isPerfTypeSupported(LAYOUT_SHIFT)) {
            tr.experience.cls = cls.score;
          }

          if (fid > 0) {
            tr.experience.fid = fid;
          }

          if (longtask.count > 0) {
            tr.experience.longtask = {
              count: longtask.count,
              sum: longtask.duration,
              max: longtask.max
            };
          }
        }

        _this3.setSession(tr);
      }

      if (tr.name === NAME_UNKNOWN) {
        tr.name = slugifyUrl(currentUrl);
      }

      captureNavigation(tr);

      _this3.adjustTransactionTime(tr);

      var breakdownMetrics = _this3._config.get('breakdownMetrics');

      if (breakdownMetrics) {
        tr.captureBreakdown();
      }

      var configContext = _this3._config.get('context');

      addTransactionContext(tr, configContext);

      _this3._config.events.send(TRANSACTION_END, [tr]);

      if (__DEV__) {
        _this3._logger.debug("end transaction(" + tr.id + ", " + tr.name + ", " + tr.type + ")", tr);
      }
    }, function (err) {
      if (__DEV__) {
        _this3._logger.debug("error ending transaction(" + tr.id + ", " + tr.name + ")", err);
      }
    });
  };

  _proto.setSession = function setSession(tr) {
    var session = this._config.get('session');

    if (session) {
      if (typeof session == 'boolean') {
        tr.session = {
          id: generateRandomId(16),
          sequence: 1
        };
      } else {
        if (session.timestamp && Date.now() - session.timestamp > SESSION_TIMEOUT) {
          tr.session = {
            id: generateRandomId(16),
            sequence: 1
          };
        } else {
          tr.session = {
            id: session.id,
            sequence: session.sequence ? session.sequence + 1 : 1
          };
        }
      }

      var sessionConfig = {
        session: {
          id: tr.session.id,
          sequence: tr.session.sequence,
          timestamp: Date.now()
        }
      };

      this._config.setConfig(sessionConfig);

      this._config.setLocalConfig(sessionConfig, true);
    }
  };

  _proto.adjustTransactionTime = function adjustTransactionTime(transaction) {
    var spans = transaction.spans;
    var earliestSpan = getEarliestSpan(spans);

    if (earliestSpan && earliestSpan._start < transaction._start) {
      transaction._start = earliestSpan._start;
    }

    var latestSpan = getLatestNonXHRSpan(spans) || {};
    var latestSpanEnd = latestSpan._end || 0;

    if (transaction.type === PAGE_LOAD) {
      var transactionEndWithoutDelay = transaction._end - PAGE_LOAD_DELAY;
      var lcp = metrics.lcp || 0;
      var latestXHRSpan = getLatestXHRSpan(spans) || {};
      var latestXHRSpanEnd = latestXHRSpan._end || 0;
      transaction._end = Math.max(latestSpanEnd, latestXHRSpanEnd, lcp, transactionEndWithoutDelay);
    } else if (latestSpanEnd > transaction._end) {
      transaction._end = latestSpanEnd;
    }

    this.truncateSpans(spans, transaction._end);
  };

  _proto.truncateSpans = function truncateSpans(spans, transactionEnd) {
    for (var i = 0; i < spans.length; i++) {
      var span = spans[i];

      if (span._end > transactionEnd) {
        span._end = transactionEnd;
        span.type += TRUNCATED_TYPE;
      }

      if (span._start > transactionEnd) {
        span._start = transactionEnd;
      }
    }
  };

  _proto.shouldIgnoreTransaction = function shouldIgnoreTransaction(transactionName) {
    var ignoreList = this._config.get('ignoreTransactions');

    if (ignoreList && ignoreList.length) {
      for (var i = 0; i < ignoreList.length; i++) {
        var element = ignoreList[i];

        if (typeof element.test === 'function') {
          if (element.test(transactionName)) {
            return true;
          }
        } else if (element === transactionName) {
          return true;
        }
      }
    }

    return false;
  };

  _proto.startSpan = function startSpan(name, type, options) {
    var tr = this.getCurrentTransaction();

    if (!tr) {
      tr = this.createCurrentTransaction(undefined, TEMPORARY_TYPE, this.createOptions({
        canReuse: true,
        managed: true
      }));
    }

    var span = tr.startSpan(name, type, options);

    if (__DEV__) {
      this._logger.debug("startSpan(" + name + ", " + span.type + ")", "on transaction(" + tr.id + ", " + tr.name + ")");
    }

    return span;
  };

  _proto.endSpan = function endSpan(span, context) {
    if (!span) {
      return;
    }

    if (__DEV__) {
      var tr = this.getCurrentTransaction();
      tr && this._logger.debug("endSpan(" + span.name + ", " + span.type + ")", "on transaction(" + tr.id + ", " + tr.name + ")");
    }

    span.end(null, context);
  };

  return TransactionService;
}();

/* harmony default export */ const transaction_service = (TransactionService);
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/performance-monitoring/index.js





function performance_monitoring_registerServices() {
  serviceCreators[TRANSACTION_SERVICE] = function (serviceFactory) {
    var _serviceFactory$getSe = serviceFactory.getService([LOGGING_SERVICE, CONFIG_SERVICE]),
        loggingService = _serviceFactory$getSe[0],
        configService = _serviceFactory$getSe[1];

    return new transaction_service(loggingService, configService);
  };

  serviceCreators[PERFORMANCE_MONITORING] = function (serviceFactory) {
    var _serviceFactory$getSe2 = serviceFactory.getService([APM_SERVER, CONFIG_SERVICE, LOGGING_SERVICE, TRANSACTION_SERVICE]),
        apmServer = _serviceFactory$getSe2[0],
        configService = _serviceFactory$getSe2[1],
        loggingService = _serviceFactory$getSe2[2],
        transactionService = _serviceFactory$getSe2[3];

    return new PerformanceMonitoring(apmServer, configService, loggingService, transactionService);
  };
}


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/index.js












function createServiceFactory() {
  performance_monitoring_registerServices();
  registerServices();
  var serviceFactory = new ServiceFactory();
  return serviceFactory;
}


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/bootstrap.js



var enabled = false;
function bootstrap() {
  if (isPlatformSupported()) {
    patchAll();
    state.bootstrapTime = now();
    enabled = true;
  } else if (isBrowser) {
    console.log('[Elastic APM] platform is not supported!');
  }

  return enabled;
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum-core/dist/es/common/instrument.js

function getInstrumentationFlags(instrument, disabledInstrumentations) {
  var _flags;

  var flags = (_flags = {}, _flags[XMLHTTPREQUEST] = false, _flags[FETCH] = false, _flags[HISTORY] = false, _flags[PAGE_LOAD] = false, _flags[ERROR] = false, _flags[EVENT_TARGET] = false, _flags[CLICK] = false, _flags);

  if (!instrument) {
    return flags;
  }

  Object.keys(flags).forEach(function (key) {
    if (disabledInstrumentations.indexOf(key) === -1) {
      flags[key] = true;
    }
  });
  return flags;
}
;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum/dist/es/apm-base.js


var ApmBase = function () {
  function ApmBase(serviceFactory, disable) {
    this._disable = disable;
    this.serviceFactory = serviceFactory;
    this._initialized = false;
  }

  var _proto = ApmBase.prototype;

  _proto.isEnabled = function isEnabled() {
    return !this._disable;
  };

  _proto.isActive = function isActive() {
    var configService = this.serviceFactory.getService(CONFIG_SERVICE);
    return this.isEnabled() && this._initialized && configService.get('active');
  };

  _proto.init = function init(config) {
    var _this = this;

    if (this.isEnabled() && !this._initialized) {
      this._initialized = true;

      var _this$serviceFactory$ = this.serviceFactory.getService([CONFIG_SERVICE, LOGGING_SERVICE]),
          configService = _this$serviceFactory$[0],
          loggingService = _this$serviceFactory$[1];

      configService.setVersion('5.8.0');
      this.config(config);
      var logLevel = configService.get('logLevel');
      loggingService.setLevel(logLevel);
      var isConfigActive = configService.get('active');

      if (isConfigActive) {
        this.serviceFactory.init();
        var flags = getInstrumentationFlags(configService.get('instrument'), configService.get('disableInstrumentations'));
        var performanceMonitoring = this.serviceFactory.getService('PerformanceMonitoring');
        performanceMonitoring.init(flags);

        if (flags[ERROR]) {
          var errorLogging = this.serviceFactory.getService('ErrorLogging');
          errorLogging.registerListeners();
        }

        if (configService.get('session')) {
          var localConfig = configService.getLocalConfig();

          if (localConfig && localConfig.session) {
            configService.setConfig({
              session: localConfig.session
            });
          }
        }

        var sendPageLoad = function sendPageLoad() {
          return flags[PAGE_LOAD] && _this._sendPageLoadMetrics();
        };

        if (configService.get('centralConfig')) {
          this.fetchCentralConfig().then(sendPageLoad);
        } else {
          sendPageLoad();
        }
      } else {
        this._disable = true;
        loggingService.warn('RUM agent is inactive');
      }
    }

    return this;
  };

  _proto.fetchCentralConfig = function fetchCentralConfig() {
    var _this$serviceFactory$2 = this.serviceFactory.getService([APM_SERVER, LOGGING_SERVICE, CONFIG_SERVICE]),
        apmServer = _this$serviceFactory$2[0],
        loggingService = _this$serviceFactory$2[1],
        configService = _this$serviceFactory$2[2];

    return apmServer.fetchConfig(configService.get('serviceName'), configService.get('environment')).then(function (config) {
      var transactionSampleRate = config['transaction_sample_rate'];

      if (transactionSampleRate) {
        transactionSampleRate = Number(transactionSampleRate);
        var _config2 = {
          transactionSampleRate: transactionSampleRate
        };

        var _configService$valida = configService.validate(_config2),
            invalid = _configService$valida.invalid;

        if (invalid.length === 0) {
          configService.setConfig(_config2);
        } else {
          var _invalid$ = invalid[0],
              key = _invalid$.key,
              value = _invalid$.value,
              allowed = _invalid$.allowed;
          loggingService.warn("invalid value \"" + value + "\" for " + key + ". Allowed: " + allowed + ".");
        }
      }

      return config;
    }).catch(function (error) {
      loggingService.warn('failed fetching config:', error);
    });
  };

  _proto._sendPageLoadMetrics = function _sendPageLoadMetrics() {
    var tr = this.startTransaction(undefined, PAGE_LOAD, {
      managed: true,
      canReuse: true
    });

    if (!tr) {
      return;
    }

    tr.addTask(PAGE_LOAD);

    var sendPageLoadMetrics = function sendPageLoadMetrics() {
      setTimeout(function () {
        return tr.removeTask(PAGE_LOAD);
      });
    };

    if (document.readyState === 'complete') {
      sendPageLoadMetrics();
    } else {
      window.addEventListener('load', sendPageLoadMetrics);
    }
  };

  _proto.observe = function observe(name, fn) {
    var configService = this.serviceFactory.getService(CONFIG_SERVICE);
    configService.events.observe(name, fn);
  };

  _proto.config = function config(_config) {
    var configService = this.serviceFactory.getService(CONFIG_SERVICE);

    var _configService$valida2 = configService.validate(_config),
        missing = _configService$valida2.missing,
        invalid = _configService$valida2.invalid;

    if (missing.length === 0 && invalid.length === 0) {
      configService.setConfig(_config);
    } else {
      var loggingService = this.serviceFactory.getService(LOGGING_SERVICE);
      var separator = ', ';
      var message = "RUM agent isn't correctly configured. ";

      if (missing.length > 0) {
        message += missing.join(separator) + ' is missing';

        if (invalid.length > 0) {
          message += separator;
        }
      }

      invalid.forEach(function (_ref, index) {
        var key = _ref.key,
            value = _ref.value,
            allowed = _ref.allowed;
        message += key + " \"" + value + "\" contains invalid characters! (allowed: " + allowed + ")" + (index !== invalid.length - 1 ? separator : '');
      });
      loggingService.error(message);
      configService.setConfig({
        active: false
      });
    }
  };

  _proto.setUserContext = function setUserContext(userContext) {
    var configService = this.serviceFactory.getService(CONFIG_SERVICE);
    configService.setUserContext(userContext);
  };

  _proto.setCustomContext = function setCustomContext(customContext) {
    var configService = this.serviceFactory.getService(CONFIG_SERVICE);
    configService.setCustomContext(customContext);
  };

  _proto.addLabels = function addLabels(labels) {
    var configService = this.serviceFactory.getService(CONFIG_SERVICE);
    configService.addLabels(labels);
  };

  _proto.setInitialPageLoadName = function setInitialPageLoadName(name) {
    var configService = this.serviceFactory.getService(CONFIG_SERVICE);
    configService.setConfig({
      pageLoadTransactionName: name
    });
  };

  _proto.startTransaction = function startTransaction(name, type, options) {
    if (this.isEnabled()) {
      var transactionService = this.serviceFactory.getService('TransactionService');
      return transactionService.startTransaction(name, type, options);
    }
  };

  _proto.startSpan = function startSpan(name, type, options) {
    if (this.isEnabled()) {
      var transactionService = this.serviceFactory.getService('TransactionService');
      return transactionService.startSpan(name, type, options);
    }
  };

  _proto.getCurrentTransaction = function getCurrentTransaction() {
    if (this.isEnabled()) {
      var transactionService = this.serviceFactory.getService('TransactionService');
      return transactionService.getCurrentTransaction();
    }
  };

  _proto.captureError = function captureError(error) {
    if (this.isEnabled()) {
      var errorLogging = this.serviceFactory.getService('ErrorLogging');
      return errorLogging.logError(error);
    }
  };

  _proto.addFilter = function addFilter(fn) {
    var configService = this.serviceFactory.getService(CONFIG_SERVICE);
    configService.addFilter(fn);
  };

  return ApmBase;
}();


;// CONCATENATED MODULE: ./node_modules/@elastic/apm-rum/dist/es/index.js



function getApmBase() {
  if (isBrowser && window.elasticApm) {
    return window.elasticApm;
  }

  var enabled = bootstrap();
  var serviceFactory = createServiceFactory();
  var apmBase = new ApmBase(serviceFactory, !enabled);

  if (isBrowser) {
    window.elasticApm = apmBase;
  }

  return apmBase;
}

var apmBase = getApmBase();
var init = apmBase.init.bind(apmBase);
/* harmony default export */ const es = ((/* unused pure expression or super */ null && (init)));


/***/ }),

/***/ 270:
/***/ (() => {

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
(function outer(modules, cache, entries) {
  /**
   * Global
   */

  var global = function () {
    return this;
  }();

  /**
   * Require `name`.
   *
   * @param {String} name
   * @api public
   */

  function require(name) {
    if (cache[name]) {
      return cache[name].exports;
    }
    if (modules[name]) {
      return call(name, require);
    }
    throw new Error("cannot find module \"".concat(name, "\""));
  }

  /**
   * Call module `id` and cache it.
   *
   * @param {Number} id
   * @param {Function} require
   * @return {Function}
   * @api private
   */

  function call(id, require) {
    var m = cache[id] = {
      exports: {}
    };
    var mod = modules[id];
    var name = mod[2];
    var fn = mod[0];
    var threw = true;
    try {
      fn.call(m.exports, function (req) {
        var dep = modules[id][1][req];
        return require(dep || req);
      }, m, m.exports, outer, modules, cache, entries);
      threw = false;
    } finally {
      if (threw) {
        delete cache[id];
      } else if (name) {
        // expose as 'name'.
        cache[name] = cache[id];
      }
    }
    return cache[id].exports;
  }

  /**
   * Require all entries exposing them on global if needed.
   */

  for (var id in entries) {
    if (entries[id]) {
      global[entries[id]] = require(id);
    } else {
      require(id);
    }
  }

  /**
   * Duo flag.
   */

  require.duo = true;

  /**
   * Expose cache.
   */

  require.cache = cache;

  /**
   * Expose modules
   */

  require.modules = modules;

  /**
   * Return newest require.
   */

  return require;
})({
  1: [function (require, module, exports) {
    'use strict';

    /**
     * Dependencies
     */
    var Emitter = require('component/emitter');
    var bind = require('component/bind');

    /**
     * Exports
     */

    module.exports = PayWithAmazon;

    /**
     * Off Amazon Payments wrapper
     *
     * order of operations
     *
     *   button -> address book -> wallet -> consent
     *
     * example
     *
     *   new PayWithAmazon({
     *     sellerId: 'abc',
     *     clientId: 'xyz',
     *     button: { id: 'pay-with-amazon' },
     *     addressBook: { id: 'address-book' [, width: 400 [, height: 260]]},
     *     wallet: { id: 'wallet' [, width: 400 [, height: 260]]},
     *     consent: { id: 'consent' [, width: 400 [, height: 140]]},
     *   });
     *
     * @param {Object} opts
     * @param {String} opts.sellerId
     * @param {String} opts.clientId
     * @param {Boolean} opts.production Whether to use the production widgets (defaults to false)
     * @param {Object|String} opts.button if string, sets opts.button.id
     * @param {String} opts.button.id
     * @param {String} [opts.button.type] 'large' (default), 'small'
     * @param {String} [opts.button.color] 'Gold' (default), 'LightGray', 'DarkGray'
     * @param {Object|String} opts.wallet
     * @param {String} opts.wallet.id
     * @param {Number} [opts.wallet.width]
     * @param {Number} [opts.wallet.height]
     * @param {Object|String} [opts.addressBook]
     * @param {String} opts.addressBook.id
     * @param {Number} [opts.addressBook.width]
     * @param {Number} [opts.addressBook.height]
     * @param {Object|String} opts.consent
     * @param {String} opts.consent.id
     * @param {Number} [opts.consent.width]
     * @param {Number} [opts.consent.height]
     * @param {String} [opts.openedClass]
     * @param {String} [opts.region] 'us' (default), 'eu', 'uk'
     */

    function PayWithAmazon(opts) {
      if (!(this instanceof PayWithAmazon)) {
        return new PayWithAmazon(opts);
      }
      this.configure(opts);
      this.billingAgreementId = null;
      this.consent = undefined;
      this.widgets = {};
      this._status = this.status();
      this.setBillingAgreementId = bind(this, this.setBillingAgreementId);
      this.initWallet = bind(this, this.initWallet);
      this.initConsent = bind(this, this.initConsent);
      this.setConsent = bind(this, this.setConsent);
      this.error = bind(this, this.error);
      this.init = bind(this, this.init);
      if ('OffAmazonPayments' in window) {
        this.init();
      } else {
        document.write("<script src=\"".concat(this.getAssetPath(), "\"></script>"));
        window.onAmazonLoginReady = this.init;
      }
      return this;
    }

    /**
     * PayWithAmazon inherits Emitter
     */

    Emitter(PayWithAmazon.prototype);

    /**
     * Version
     */

    PayWithAmazon.prototype.version = '1.0.4';

    /**
     * Configures the instance based on passed `opts`
     *
     * Throws errors if the opts are insufficient to configure the instance,
     * and sets defaults for those not specified.
     *
     * See initializer for description of `opts`
     */

    PayWithAmazon.prototype.configure = function (opts) {
      if (_typeof(opts) !== 'object') {
        throw new Error('opts must be provided as an object.');
      }
      if (!opts.sellerId) {
        throw new Error('opts.sellerId is required.');
      }
      if (!opts.clientId) {
        throw new Error('opts.clientId is required.');
      }
      if (!opts.button) {
        throw new Error('opts.button is required.');
      }
      if (!opts.wallet) {
        throw new Error('opts.wallet is required.');
      }
      if (!opts.consent) {
        throw new Error('opts.consent is required.');
      }
      if (typeof opts.button === 'string') {
        opts.button = {
          id: opts.button
        };
      }
      if (typeof opts.wallet === 'string') {
        opts.wallet = {
          id: opts.wallet
        };
      }
      if (typeof opts.consent === 'string') {
        opts.consent = {
          id: opts.consent
        };
      }
      if (typeof opts.addressBook === 'string') {
        opts.addressBook = {
          id: opts.addressBook
        };
      }
      if (opts.button.kind === 'login') {
        opts.button.type = opts.button.type === 'small' ? 'Login' : 'LwA';
      } else {
        opts.button.type = opts.button.type === 'small' ? 'Pay' : 'PwA';
      }
      opts.button.color = opts.button.color || 'Gold';
      if (opts.wallet.width || opts.wallet.height) {
        opts.wallet.dimensions = {
          width: dimension(opts.wallet.width || 400),
          height: dimension(opts.wallet.height || 260)
        };
      }
      if (opts.consent.width || opts.consent.height) {
        opts.consent.dimensions = {
          width: dimension(opts.consent.width || 400),
          height: dimension(opts.consent.height || 140)
        };
      }
      if (opts.addressBook && (opts.addressBook.width || opts.addressBook.height)) {
        opts.addressBook.dimensions = {
          width: dimension(opts.addressBook.width || 400),
          height: dimension(opts.addressBook.height || 260)
        };
      }
      opts.production = typeof opts.production === 'boolean' ? opts.production : false;
      opts.openedClass = opts.openedClass || 'open';
      this.config = opts;
    };

    /**
     * Initialized the Amazon plugin
     *
     * Sets the client ID then waits for the widget classes to load
     * before initializing the login button.
     */

    PayWithAmazon.prototype.init = function () {
      window.amazon.Login.setClientId(this.config.clientId);
      var self = this;
      var pollId = setInterval(poll, 200);
      function poll() {
        if (!window.OffAmazonPayments.Button) {
          return;
        }
        clearTimeout(pollId);
        self.initButton();
      }
    };

    /**
     * Returns the url for Amazon widgets based on region url param
     *
     * @return {String} url
     */
    PayWithAmazon.prototype.getAssetPath = function () {
      var env = this.config.production ? '' : '/sandbox';
      var assetPath;
      switch (this.config.region) {
        case 'eu':
          assetPath = "https://static-eu.payments-amazon.com/OffAmazonPayments/eur".concat(env, "/lpa/js/Widgets.js?sellerId=");
          break;
        case 'uk':
          assetPath = "https://static-eu.payments-amazon.com/OffAmazonPayments/gbp".concat(env, "/lpa/js/Widgets.js?sellerId=");
          break;
        default:
          assetPath = "https://static-na.payments-amazon.com/OffAmazonPayments/us".concat(env, "/js/Widgets.js?sellerId=");
          break;
      }
      return assetPath + this.config.sellerId;
    };

    /**
     * Returns an object describing the customer state
     *
     * @return {Object} customer state
     */

    PayWithAmazon.prototype.status = function () {
      var id = this.billingAgreementId;
      var consent = this.consent;
      var status = {};
      if (!id) {
        status.error = 'Billing agreement ID has not been set.';
      }
      if (consent !== undefined) {
        status.consent = consent;
      }
      if (consent === undefined) {
        status.error = 'Billing consent not yet given.';
      } else if (!consent) {
        status.error = 'Billing consent not given.';
      }
      if (!status.error) {
        status.id = id;
      }
      return status;
    };

    /**
     * Emits the 'change' event if the customer status has changed
     */

    PayWithAmazon.prototype.check = function () {
      var status = this.status();
      if (JSON.stringify(status) !== JSON.stringify(this._status)) {
        this._status = status;
        this.emit('change', status);
      }
    };

    /**
     * Initializes the login button
     */

    PayWithAmazon.prototype.initButton = function () {
      var self = this;
      var type = this.config.button.type;
      var color = this.config.button.color;
      this.widgets.button = new window.OffAmazonPayments.Button(this.config.button.id, this.config.sellerId, {
        type: type,
        color: color,
        authorization: function authorization() {
          var opts = {
            scope: 'profile payments:widget payments:shipping_address',
            popup: true
          };
          window.amazon.Login.authorize(opts, function (res) {
            if (res.error) {
              return self.error(res.error);
            }
            self.emit('login', res);
            self.initAddressBook();
          });
        },
        onError: this.error
      });
    };

    /**
     * Initializes the Address Book widget
     */

    PayWithAmazon.prototype.initAddressBook = function () {
      var self = this;
      if (!this.config.addressBook) {
        return this.initWallet();
      }
      var opts = {
        agreementType: 'BillingAgreement',
        sellerId: this.config.sellerId,
        onReady: function onReady(ref) {
          self.emit('ready.addressBook');
          self.setBillingAgreementId(ref);
        },
        onAddressSelect: this.initWallet,
        design: design(this.config.addressBook),
        onError: this.error
      };
      this.widgets.addressBook = new window.OffAmazonPayments.Widgets.AddressBook(opts);
      this.widgets.addressBook.bind(this.config.addressBook.id);
      this.opened(this.config.addressBook.id);
    };

    /**
     * Initializes the wallet widget
     */

    PayWithAmazon.prototype.initWallet = function () {
      var self = this;
      var opts = {
        amazonBillingAgreementId: this.billingAgreementId,
        sellerId: this.config.sellerId,
        design: design(this.config.wallet),
        onReady: function onReady(ref) {
          self.emit('ready.wallet');
          if (!self.billingAgreementId) {
            self.setBillingAgreementId(ref);
          }
        },
        onPaymentSelect: function onPaymentSelect() {
          self.initConsent();
          self.check();
        },
        onError: this.error
      };
      if (!this.billingAgreementId) {
        opts.agreementType = 'BillingAgreement';
      }
      this.widgets.wallet = new window.OffAmazonPayments.Widgets.Wallet(opts);
      this.widgets.wallet.bind(this.config.wallet.id);
      this.opened(this.config.wallet.id);
    };

    /**
     * Initializes the consent widget
     */

    PayWithAmazon.prototype.initConsent = function () {
      var self = this;
      var opts = {
        amazonBillingAgreementId: this.billingAgreementId,
        sellerId: this.config.sellerId,
        design: design(this.config.consent),
        onReady: function onReady(consentStatus) {
          self.emit('ready.consent');
          self.setConsent(consentStatus);
        },
        onConsent: this.setConsent,
        onError: this.error
      };
      this.widgets.consent = new window.OffAmazonPayments.Widgets.Consent(opts);
      this.widgets.consent.bind(this.config.consent.id);
      this.opened(this.config.consent.id);
    };

    /**
     * Sets the billingAgreementId based on a widgit init reference
     */

    PayWithAmazon.prototype.setBillingAgreementId = function (ref) {
      this.billingAgreementId = ref.getAmazonBillingAgreementId();
      this.check();
    };

    /**
     * Sets consent state based on an Amazon ConsentStatus
     */

    PayWithAmazon.prototype.setConsent = function (consentStatus) {
      if (typeof consentStatus.getConsentStatus === 'undefined') {
        return;
      }
      this.consent = consentStatus.getConsentStatus() === 'true';
      this.check();
    };

    /**
     * Adds a class to opened widget containers
     */

    PayWithAmazon.prototype.opened = function (id) {
      var elem = document.getElementById(id);
      if (elem) {
        elem.className = "".concat(elem.className, " ").concat(this.config.openedClass);
      }
    };

    /**
     * Handles errors, logging to console and emitting via the 'error' event
     */

    PayWithAmazon.prototype.error = function (err) {
      var error = {
        code: err.getErrorCode(),
        message: err.getErrorMessage()
      };
      if (console) {
        if (Error.captureStackTrace) {
          Error.captureStackTrace(error, this.error);
        }
        console.error(error);
      }
      this.emit('error', error);
    };

    /**
     * Given a number or string, returns a properly-formatted dimension string
     *
     * @param {Number|String} dim
     * @returns {String}
     */

    function dimension(dim) {
      dim = String(dim);
      return dim + (isNaN(parseInt(dim.charAt(dim.length - 1), 10)) ? '' : 'px');
    }

    /**
     * Given a widget configuration, returns a properly-formatted design spec
     *
     * @param {Object} widget Widget options hash
     */

    function design(widget) {
      if (widget.dimensions) {
        return {
          size: widget.dimensions
        };
      }
      return {
        designMode: 'responsive'
      };
    }
  }, {
    'component/emitter': 2,
    'component/bind': 3
  }],
  2: [function (require, module, exports) {
    /**
     * Expose `Emitter`.
     */

    module.exports = Emitter;

    /**
     * Initialize a new `Emitter`.
     *
     * @api public
     */

    function Emitter(obj) {
      if (obj) {
        return mixin(obj);
      }
    }

    /**
     * Mixin the emitter properties.
     *
     * @param {Object} obj
     * @return {Object}
     * @api private
     */

    function mixin(obj) {
      for (var key in Emitter.prototype) {
        obj[key] = Emitter.prototype[key];
      }
      return obj;
    }

    /**
     * Listen on the given `event` with `fn`.
     *
     * @param {String} event
     * @param {Function} fn
     * @return {Emitter}
     * @api public
     */

    Emitter.prototype.on = Emitter.prototype.addEventListener = function (event, fn) {
      this._callbacks = this._callbacks || {};
      (this._callbacks[event] = this._callbacks[event] || []).push(fn);
      return this;
    };

    /**
     * Adds an `event` listener that will be invoked a single
     * time then automatically removed.
     *
     * @param {String} event
     * @param {Function} fn
     * @return {Emitter}
     * @api public
     */

    Emitter.prototype.once = function (event, fn) {
      var self = this;
      this._callbacks = this._callbacks || {};
      function on() {
        self.off(event, on);
        fn.apply(this, arguments);
      }
      on.fn = fn;
      this.on(event, on);
      return this;
    };

    /**
     * Remove the given callback for `event` or all
     * registered callbacks.
     *
     * @param {String} event
     * @param {Function} fn
     * @return {Emitter}
     * @api public
     */

    Emitter.prototype.off = Emitter.prototype.removeListener = Emitter.prototype.removeAllListeners = Emitter.prototype.removeEventListener = function (event, fn) {
      this._callbacks = this._callbacks || {};

      // all
      if (arguments.length == 0) {
        this._callbacks = {};
        return this;
      }

      // specific event
      var callbacks = this._callbacks[event];
      if (!callbacks) {
        return this;
      }

      // remove all handlers
      if (arguments.length == 1) {
        delete this._callbacks[event];
        return this;
      }

      // remove specific handler
      var cb;
      for (var i = 0; i < callbacks.length; i++) {
        cb = callbacks[i];
        if (cb === fn || cb.fn === fn) {
          callbacks.splice(i, 1);
          break;
        }
      }
      return this;
    };

    /**
     * Emit `event` with the given args.
     *
     * @param {String} event
     * @param {Mixed} ...
     * @return {Emitter}
     */

    Emitter.prototype.emit = function (event) {
      this._callbacks = this._callbacks || {};
      var args = [].slice.call(arguments, 1);
      var callbacks = this._callbacks[event];
      if (callbacks) {
        callbacks = callbacks.slice(0);
        for (var i = 0, len = callbacks.length; i < len; ++i) {
          callbacks[i].apply(this, args);
        }
      }
      return this;
    };

    /**
     * Return array of callbacks for `event`.
     *
     * @param {String} event
     * @return {Array}
     * @api public
     */

    Emitter.prototype.listeners = function (event) {
      this._callbacks = this._callbacks || {};
      return this._callbacks[event] || [];
    };

    /**
     * Check if this emitter has `event` handlers.
     *
     * @param {String} event
     * @return {Boolean}
     * @api public
     */

    Emitter.prototype.hasListeners = function (event) {
      return Boolean(this.listeners(event).length);
    };
  }, {}],
  3: [function (require, module, exports) {
    /**
     * Slice reference.
     */

    var slice = [].slice;

    /**
     * Bind `obj` to `fn`.
     *
     * @param {Object} obj
     * @param {Function|String} fn or string
     * @return {Function}
     * @api public
     */

    module.exports = function (obj, fn) {
      if (typeof fn === 'string') {
        fn = obj[fn];
      }
      if (typeof fn !== 'function') {
        throw new Error('bind() requires a function');
      }
      var args = slice.call(arguments, 2);
      return function () {
        return fn.apply(obj, args.concat(slice.call(arguments)));
      };
    };
  }, {}]
}, {}, {
  '1': 'PayWithAmazon'
});

/***/ }),

/***/ 402:
/***/ ((module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Z": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(645);
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0__);
// Imports

var ___CSS_LOADER_EXPORT___ = _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0___default()(function(i){return i[1]});
// Module
___CSS_LOADER_EXPORT___.push([module.id, ".fc-validation-errors li {\n  list-style: disc !important;\n}\n\n.fc-overlay {\n  position: fixed;\n  background-color: rgba(0, 0, 0, 0.8);\n  display: none;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  height: 100%;\n  width: 100%;\n  z-index: 999;\n  font-family: 'Lato', 'Helvetica', 'Arial', 'Sans-Serif', sans-serif;\n}\n.fc-error-message {\n  border: 1px solid #ebccd1;\n  background: #f2dede;\n  border-radius: 4px;\n  color: #a94442;\n  margin: auto;\n  min-width: 200px;\n  max-width: 50%;\n  padding: 20px;\n  position: relative;\n  text-align: left;\n  top: 50%;\n  transform: translateY(-50%);\n}\n.fc-error-message ul {\n  list-style-type: disc;\n  list-style-position: inside;\n  margin-top: 15px;\n}\n.fc-error-message li {\n  list-style-type: disc;\n  list-style-position: inside;\n  margin: 5px 10px;\n}\n\n.fc-loading-indicator {\n  position: relative;\n  top: 50%;\n  margin: auto;\n  font-size: 25px;\n  width: 1em;\n  height: 1em;\n  border-radius: 50%;\n  text-indent: -9999em;\n  -webkit-animation: fc-loading-frames 1.1s infinite ease;\n  animation: fc-loading-frames 1.1s infinite ease;\n  -webkit-transform: translateZ(0);\n  -ms-transform: translateZ(0);\n  transform: translateY(-50%) translateZ(0);\n}\n.fc-loading-indicator-msg {\n  color: white;\n  text-align: center;\n  margin-top: 10%;\n  font-size: 36px;\n}\n@-webkit-keyframes fc-loading-frames {\n  0%,\n  100% {\n    box-shadow: 0 -2.6em 0 0 #ffffff, 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2), 2.5em 0 0 0 rgba(255, 255, 255, 0.2),\n      1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2), 0 2.5em 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2), -2.6em 0 0 0 rgba(255, 255, 255, 0.5),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.7);\n  }\n  12.5% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.7), 1.8em -1.8em 0 0 #ffffff, 2.5em 0 0 0 rgba(255, 255, 255, 0.2),\n      1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2), 0 2.5em 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2), -2.6em 0 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.5);\n  }\n  25% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.5), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.7), 2.5em 0 0 0 #ffffff,\n      1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2), 0 2.5em 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2), -2.6em 0 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  37.5% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.5),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.7), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2),\n      0 2.5em 0 0 rgba(255, 255, 255, 0.2), -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2),\n      -2.6em 0 0 0 rgba(255, 255, 255, 0.2), -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  50% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.5), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.7), 0 2.5em 0 0 #ffffff,\n      -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2), -2.6em 0 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  62.5% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.2), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.5),\n      0 2.5em 0 0 rgba(255, 255, 255, 0.7), -1.8em 1.8em 0 0 #ffffff, -2.6em 0 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  75% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.2), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2),\n      0 2.5em 0 0 rgba(255, 255, 255, 0.5), -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.7), -2.6em 0 0 0 #ffffff,\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  87.5% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.2), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2),\n      0 2.5em 0 0 rgba(255, 255, 255, 0.2), -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.5),\n      -2.6em 0 0 0 rgba(255, 255, 255, 0.7), -1.8em -1.8em 0 0 #ffffff;\n  }\n}\n@keyframes fc-loading-frames {\n  0%,\n  100% {\n    box-shadow: 0 -2.6em 0 0 #ffffff, 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2), 2.5em 0 0 0 rgba(255, 255, 255, 0.2),\n      1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2), 0 2.5em 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2), -2.6em 0 0 0 rgba(255, 255, 255, 0.5),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.7);\n  }\n  12.5% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.7), 1.8em -1.8em 0 0 #ffffff, 2.5em 0 0 0 rgba(255, 255, 255, 0.2),\n      1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2), 0 2.5em 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2), -2.6em 0 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.5);\n  }\n  25% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.5), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.7), 2.5em 0 0 0 #ffffff,\n      1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2), 0 2.5em 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2), -2.6em 0 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  37.5% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.5),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.7), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2),\n      0 2.5em 0 0 rgba(255, 255, 255, 0.2), -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2),\n      -2.6em 0 0 0 rgba(255, 255, 255, 0.2), -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  50% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.5), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.7), 0 2.5em 0 0 #ffffff,\n      -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.2), -2.6em 0 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  62.5% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.2), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.5),\n      0 2.5em 0 0 rgba(255, 255, 255, 0.7), -1.8em 1.8em 0 0 #ffffff, -2.6em 0 0 0 rgba(255, 255, 255, 0.2),\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  75% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.2), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2),\n      0 2.5em 0 0 rgba(255, 255, 255, 0.5), -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.7), -2.6em 0 0 0 #ffffff,\n      -1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2);\n  }\n  87.5% {\n    box-shadow: 0 -2.6em 0 0 rgba(255, 255, 255, 0.2), 1.8em -1.8em 0 0 rgba(255, 255, 255, 0.2),\n      2.5em 0 0 0 rgba(255, 255, 255, 0.2), 1.75em 1.75em 0 0 rgba(255, 255, 255, 0.2),\n      0 2.5em 0 0 rgba(255, 255, 255, 0.2), -1.8em 1.8em 0 0 rgba(255, 255, 255, 0.5),\n      -2.6em 0 0 0 rgba(255, 255, 255, 0.7), -1.8em -1.8em 0 0 #ffffff;\n  }\n}\n", ""]);
// Exports
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (___CSS_LOADER_EXPORT___);


/***/ }),

/***/ 645:
/***/ ((module) => {

"use strict";


/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
// eslint-disable-next-line func-names
module.exports = function (cssWithMappingToString) {
  var list = []; // return the list of modules as css string

  list.toString = function toString() {
    return this.map(function (item) {
      var content = cssWithMappingToString(item);

      if (item[2]) {
        return "@media ".concat(item[2], " {").concat(content, "}");
      }

      return content;
    }).join("");
  }; // import a list of modules into the list
  // eslint-disable-next-line func-names


  list.i = function (modules, mediaQuery, dedupe) {
    if (typeof modules === "string") {
      // eslint-disable-next-line no-param-reassign
      modules = [[null, modules, ""]];
    }

    var alreadyImportedModules = {};

    if (dedupe) {
      for (var i = 0; i < this.length; i++) {
        // eslint-disable-next-line prefer-destructuring
        var id = this[i][0];

        if (id != null) {
          alreadyImportedModules[id] = true;
        }
      }
    }

    for (var _i = 0; _i < modules.length; _i++) {
      var item = [].concat(modules[_i]);

      if (dedupe && alreadyImportedModules[item[0]]) {
        // eslint-disable-next-line no-continue
        continue;
      }

      if (mediaQuery) {
        if (!item[2]) {
          item[2] = mediaQuery;
        } else {
          item[2] = "".concat(mediaQuery, " and ").concat(item[2]);
        }
      }

      list.push(item);
    }
  };

  return list;
};

/***/ }),

/***/ 180:
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;(function(root, factory) {
    'use strict';
    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js, Rhino, and browsers.

    /* istanbul ignore next */
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(829)], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory),
		__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
		(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    } else {}
}(this, function ErrorStackParser(StackFrame) {
    'use strict';

    var FIREFOX_SAFARI_STACK_REGEXP = /(^|@)\S+\:\d+/;
    var CHROME_IE_STACK_REGEXP = /^\s*at .*(\S+\:\d+|\(native\))/m;
    var SAFARI_NATIVE_CODE_REGEXP = /^(eval@)?(\[native code\])?$/;

    function _map(array, fn, thisArg) {
        if (typeof Array.prototype.map === 'function') {
            return array.map(fn, thisArg);
        } else {
            var output = new Array(array.length);
            for (var i = 0; i < array.length; i++) {
                output[i] = fn.call(thisArg, array[i]);
            }
            return output;
        }
    }

    function _filter(array, fn, thisArg) {
        if (typeof Array.prototype.filter === 'function') {
            return array.filter(fn, thisArg);
        } else {
            var output = [];
            for (var i = 0; i < array.length; i++) {
                if (fn.call(thisArg, array[i])) {
                    output.push(array[i]);
                }
            }
            return output;
        }
    }

    function _indexOf(array, target) {
        if (typeof Array.prototype.indexOf === 'function') {
            return array.indexOf(target);
        } else {
            for (var i = 0; i < array.length; i++) {
                if (array[i] === target) {
                    return i;
                }
            }
            return -1;
        }
    }

    return {
        /**
         * Given an Error object, extract the most information from it.
         *
         * @param {Error} error object
         * @return {Array} of StackFrames
         */
        parse: function ErrorStackParser$$parse(error) {
            if (typeof error.stacktrace !== 'undefined' || typeof error['opera#sourceloc'] !== 'undefined') {
                return this.parseOpera(error);
            } else if (error.stack && error.stack.match(CHROME_IE_STACK_REGEXP)) {
                return this.parseV8OrIE(error);
            } else if (error.stack) {
                return this.parseFFOrSafari(error);
            } else {
                throw new Error('Cannot parse given Error object');
            }
        },

        // Separate line and column numbers from a string of the form: (URI:Line:Column)
        extractLocation: function ErrorStackParser$$extractLocation(urlLike) {
            // Fail-fast but return locations like "(native)"
            if (urlLike.indexOf(':') === -1) {
                return [urlLike];
            }

            var regExp = /(.+?)(?:\:(\d+))?(?:\:(\d+))?$/;
            var parts = regExp.exec(urlLike.replace(/[\(\)]/g, ''));
            return [parts[1], parts[2] || undefined, parts[3] || undefined];
        },

        parseV8OrIE: function ErrorStackParser$$parseV8OrIE(error) {
            var filtered = _filter(error.stack.split('\n'), function(line) {
                return !!line.match(CHROME_IE_STACK_REGEXP);
            }, this);

            return _map(filtered, function(line) {
                if (line.indexOf('(eval ') > -1) {
                    // Throw away eval information until we implement stacktrace.js/stackframe#8
                    line = line.replace(/eval code/g, 'eval').replace(/(\(eval at [^\()]*)|(\)\,.*$)/g, '');
                }
                var tokens = line.replace(/^\s+/, '').replace(/\(eval code/g, '(').split(/\s+/).slice(1);
                var locationParts = this.extractLocation(tokens.pop());
                var functionName = tokens.join(' ') || undefined;
                var fileName = _indexOf(['eval', '<anonymous>'], locationParts[0]) > -1 ? undefined : locationParts[0];

                return new StackFrame(functionName, undefined, fileName, locationParts[1], locationParts[2], line);
            }, this);
        },

        parseFFOrSafari: function ErrorStackParser$$parseFFOrSafari(error) {
            var filtered = _filter(error.stack.split('\n'), function(line) {
                return !line.match(SAFARI_NATIVE_CODE_REGEXP);
            }, this);

            return _map(filtered, function(line) {
                // Throw away eval information until we implement stacktrace.js/stackframe#8
                if (line.indexOf(' > eval') > -1) {
                    line = line.replace(/ line (\d+)(?: > eval line \d+)* > eval\:\d+\:\d+/g, ':$1');
                }

                if (line.indexOf('@') === -1 && line.indexOf(':') === -1) {
                    // Safari eval frames only have function names and nothing else
                    return new StackFrame(line);
                } else {
                    var tokens = line.split('@');
                    var locationParts = this.extractLocation(tokens.pop());
                    var functionName = tokens.join('@') || undefined;
                    return new StackFrame(functionName,
                        undefined,
                        locationParts[0],
                        locationParts[1],
                        locationParts[2],
                        line);
                }
            }, this);
        },

        parseOpera: function ErrorStackParser$$parseOpera(e) {
            if (!e.stacktrace || (e.message.indexOf('\n') > -1 &&
                e.message.split('\n').length > e.stacktrace.split('\n').length)) {
                return this.parseOpera9(e);
            } else if (!e.stack) {
                return this.parseOpera10(e);
            } else {
                return this.parseOpera11(e);
            }
        },

        parseOpera9: function ErrorStackParser$$parseOpera9(e) {
            var lineRE = /Line (\d+).*script (?:in )?(\S+)/i;
            var lines = e.message.split('\n');
            var result = [];

            for (var i = 2, len = lines.length; i < len; i += 2) {
                var match = lineRE.exec(lines[i]);
                if (match) {
                    result.push(new StackFrame(undefined, undefined, match[2], match[1], undefined, lines[i]));
                }
            }

            return result;
        },

        parseOpera10: function ErrorStackParser$$parseOpera10(e) {
            var lineRE = /Line (\d+).*script (?:in )?(\S+)(?:: In function (\S+))?$/i;
            var lines = e.stacktrace.split('\n');
            var result = [];

            for (var i = 0, len = lines.length; i < len; i += 2) {
                var match = lineRE.exec(lines[i]);
                if (match) {
                    result.push(
                        new StackFrame(
                            match[3] || undefined,
                            undefined,
                            match[2],
                            match[1],
                            undefined,
                            lines[i]
                        )
                    );
                }
            }

            return result;
        },

        // Opera 10.65+ Error.stack very similar to FF/Safari
        parseOpera11: function ErrorStackParser$$parseOpera11(error) {
            var filtered = _filter(error.stack.split('\n'), function(line) {
                return !!line.match(FIREFOX_SAFARI_STACK_REGEXP) && !line.match(/^Error created at/);
            }, this);

            return _map(filtered, function(line) {
                var tokens = line.split('@');
                var locationParts = this.extractLocation(tokens.pop());
                var functionCall = (tokens.shift() || '');
                var functionName = functionCall
                        .replace(/<anonymous function(: (\w+))?>/, '$2')
                        .replace(/\([^\)]*\)/g, '') || undefined;
                var argsRaw;
                if (functionCall.match(/\(([^\)]*)\)/)) {
                    argsRaw = functionCall.replace(/^[^\(]+\(([^\)]*)\)$/, '$1');
                }
                var args = (argsRaw === undefined || argsRaw === '[arguments not available]') ?
                    undefined : argsRaw.split(',');
                return new StackFrame(
                    functionName,
                    args,
                    locationParts[0],
                    locationParts[1],
                    locationParts[2],
                    line);
            }, this);
        }
    };
}));



/***/ }),

/***/ 486:
/***/ (function(module, exports, __webpack_require__) {

/* module decorator */ module = __webpack_require__.nmd(module);
var __WEBPACK_AMD_DEFINE_RESULT__;/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
;(function() {

  /** Used as a safe reference for `undefined` in pre-ES5 environments. */
  var undefined;

  /** Used as the semantic version number. */
  var VERSION = '4.17.21';

  /** Used as the size to enable large array optimizations. */
  var LARGE_ARRAY_SIZE = 200;

  /** Error message constants. */
  var CORE_ERROR_TEXT = 'Unsupported core-js use. Try https://npms.io/search?q=ponyfill.',
      FUNC_ERROR_TEXT = 'Expected a function',
      INVALID_TEMPL_VAR_ERROR_TEXT = 'Invalid `variable` option passed into `_.template`';

  /** Used to stand-in for `undefined` hash values. */
  var HASH_UNDEFINED = '__lodash_hash_undefined__';

  /** Used as the maximum memoize cache size. */
  var MAX_MEMOIZE_SIZE = 500;

  /** Used as the internal argument placeholder. */
  var PLACEHOLDER = '__lodash_placeholder__';

  /** Used to compose bitmasks for cloning. */
  var CLONE_DEEP_FLAG = 1,
      CLONE_FLAT_FLAG = 2,
      CLONE_SYMBOLS_FLAG = 4;

  /** Used to compose bitmasks for value comparisons. */
  var COMPARE_PARTIAL_FLAG = 1,
      COMPARE_UNORDERED_FLAG = 2;

  /** Used to compose bitmasks for function metadata. */
  var WRAP_BIND_FLAG = 1,
      WRAP_BIND_KEY_FLAG = 2,
      WRAP_CURRY_BOUND_FLAG = 4,
      WRAP_CURRY_FLAG = 8,
      WRAP_CURRY_RIGHT_FLAG = 16,
      WRAP_PARTIAL_FLAG = 32,
      WRAP_PARTIAL_RIGHT_FLAG = 64,
      WRAP_ARY_FLAG = 128,
      WRAP_REARG_FLAG = 256,
      WRAP_FLIP_FLAG = 512;

  /** Used as default options for `_.truncate`. */
  var DEFAULT_TRUNC_LENGTH = 30,
      DEFAULT_TRUNC_OMISSION = '...';

  /** Used to detect hot functions by number of calls within a span of milliseconds. */
  var HOT_COUNT = 800,
      HOT_SPAN = 16;

  /** Used to indicate the type of lazy iteratees. */
  var LAZY_FILTER_FLAG = 1,
      LAZY_MAP_FLAG = 2,
      LAZY_WHILE_FLAG = 3;

  /** Used as references for various `Number` constants. */
  var INFINITY = 1 / 0,
      MAX_SAFE_INTEGER = 9007199254740991,
      MAX_INTEGER = 1.7976931348623157e+308,
      NAN = 0 / 0;

  /** Used as references for the maximum length and index of an array. */
  var MAX_ARRAY_LENGTH = 4294967295,
      MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1,
      HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;

  /** Used to associate wrap methods with their bit flags. */
  var wrapFlags = [
    ['ary', WRAP_ARY_FLAG],
    ['bind', WRAP_BIND_FLAG],
    ['bindKey', WRAP_BIND_KEY_FLAG],
    ['curry', WRAP_CURRY_FLAG],
    ['curryRight', WRAP_CURRY_RIGHT_FLAG],
    ['flip', WRAP_FLIP_FLAG],
    ['partial', WRAP_PARTIAL_FLAG],
    ['partialRight', WRAP_PARTIAL_RIGHT_FLAG],
    ['rearg', WRAP_REARG_FLAG]
  ];

  /** `Object#toString` result references. */
  var argsTag = '[object Arguments]',
      arrayTag = '[object Array]',
      asyncTag = '[object AsyncFunction]',
      boolTag = '[object Boolean]',
      dateTag = '[object Date]',
      domExcTag = '[object DOMException]',
      errorTag = '[object Error]',
      funcTag = '[object Function]',
      genTag = '[object GeneratorFunction]',
      mapTag = '[object Map]',
      numberTag = '[object Number]',
      nullTag = '[object Null]',
      objectTag = '[object Object]',
      promiseTag = '[object Promise]',
      proxyTag = '[object Proxy]',
      regexpTag = '[object RegExp]',
      setTag = '[object Set]',
      stringTag = '[object String]',
      symbolTag = '[object Symbol]',
      undefinedTag = '[object Undefined]',
      weakMapTag = '[object WeakMap]',
      weakSetTag = '[object WeakSet]';

  var arrayBufferTag = '[object ArrayBuffer]',
      dataViewTag = '[object DataView]',
      float32Tag = '[object Float32Array]',
      float64Tag = '[object Float64Array]',
      int8Tag = '[object Int8Array]',
      int16Tag = '[object Int16Array]',
      int32Tag = '[object Int32Array]',
      uint8Tag = '[object Uint8Array]',
      uint8ClampedTag = '[object Uint8ClampedArray]',
      uint16Tag = '[object Uint16Array]',
      uint32Tag = '[object Uint32Array]';

  /** Used to match empty string literals in compiled template source. */
  var reEmptyStringLeading = /\b__p \+= '';/g,
      reEmptyStringMiddle = /\b(__p \+=) '' \+/g,
      reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;

  /** Used to match HTML entities and HTML characters. */
  var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g,
      reUnescapedHtml = /[&<>"']/g,
      reHasEscapedHtml = RegExp(reEscapedHtml.source),
      reHasUnescapedHtml = RegExp(reUnescapedHtml.source);

  /** Used to match template delimiters. */
  var reEscape = /<%-([\s\S]+?)%>/g,
      reEvaluate = /<%([\s\S]+?)%>/g,
      reInterpolate = /<%=([\s\S]+?)%>/g;

  /** Used to match property names within property paths. */
  var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
      reIsPlainProp = /^\w*$/,
      rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

  /**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */
  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g,
      reHasRegExpChar = RegExp(reRegExpChar.source);

  /** Used to match leading whitespace. */
  var reTrimStart = /^\s+/;

  /** Used to match a single whitespace character. */
  var reWhitespace = /\s/;

  /** Used to match wrap detail comments. */
  var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/,
      reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/,
      reSplitDetails = /,? & /;

  /** Used to match words composed of alphanumeric characters. */
  var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;

  /**
   * Used to validate the `validate` option in `_.template` variable.
   *
   * Forbids characters which could potentially change the meaning of the function argument definition:
   * - "()," (modification of function parameters)
   * - "=" (default value)
   * - "[]{}" (destructuring of function parameters)
   * - "/" (beginning of a comment)
   * - whitespace
   */
  var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;

  /** Used to match backslashes in property paths. */
  var reEscapeChar = /\\(\\)?/g;

  /**
   * Used to match
   * [ES template delimiters](http://ecma-international.org/ecma-262/7.0/#sec-template-literal-lexical-components).
   */
  var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;

  /** Used to match `RegExp` flags from their coerced string values. */
  var reFlags = /\w*$/;

  /** Used to detect bad signed hexadecimal string values. */
  var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

  /** Used to detect binary string values. */
  var reIsBinary = /^0b[01]+$/i;

  /** Used to detect host constructors (Safari). */
  var reIsHostCtor = /^\[object .+?Constructor\]$/;

  /** Used to detect octal string values. */
  var reIsOctal = /^0o[0-7]+$/i;

  /** Used to detect unsigned integer values. */
  var reIsUint = /^(?:0|[1-9]\d*)$/;

  /** Used to match Latin Unicode letters (excluding mathematical operators). */
  var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;

  /** Used to ensure capturing order of template delimiters. */
  var reNoMatch = /($^)/;

  /** Used to match unescaped characters in compiled string literals. */
  var reUnescapedString = /['\n\r\u2028\u2029\\]/g;

  /** Used to compose unicode character classes. */
  var rsAstralRange = '\\ud800-\\udfff',
      rsComboMarksRange = '\\u0300-\\u036f',
      reComboHalfMarksRange = '\\ufe20-\\ufe2f',
      rsComboSymbolsRange = '\\u20d0-\\u20ff',
      rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange,
      rsDingbatRange = '\\u2700-\\u27bf',
      rsLowerRange = 'a-z\\xdf-\\xf6\\xf8-\\xff',
      rsMathOpRange = '\\xac\\xb1\\xd7\\xf7',
      rsNonCharRange = '\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf',
      rsPunctuationRange = '\\u2000-\\u206f',
      rsSpaceRange = ' \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000',
      rsUpperRange = 'A-Z\\xc0-\\xd6\\xd8-\\xde',
      rsVarRange = '\\ufe0e\\ufe0f',
      rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;

  /** Used to compose unicode capture groups. */
  var rsApos = "['\u2019]",
      rsAstral = '[' + rsAstralRange + ']',
      rsBreak = '[' + rsBreakRange + ']',
      rsCombo = '[' + rsComboRange + ']',
      rsDigits = '\\d+',
      rsDingbat = '[' + rsDingbatRange + ']',
      rsLower = '[' + rsLowerRange + ']',
      rsMisc = '[^' + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + ']',
      rsFitz = '\\ud83c[\\udffb-\\udfff]',
      rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',
      rsNonAstral = '[^' + rsAstralRange + ']',
      rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}',
      rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]',
      rsUpper = '[' + rsUpperRange + ']',
      rsZWJ = '\\u200d';

  /** Used to compose unicode regexes. */
  var rsMiscLower = '(?:' + rsLower + '|' + rsMisc + ')',
      rsMiscUpper = '(?:' + rsUpper + '|' + rsMisc + ')',
      rsOptContrLower = '(?:' + rsApos + '(?:d|ll|m|re|s|t|ve))?',
      rsOptContrUpper = '(?:' + rsApos + '(?:D|LL|M|RE|S|T|VE))?',
      reOptMod = rsModifier + '?',
      rsOptVar = '[' + rsVarRange + ']?',
      rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',
      rsOrdLower = '\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])',
      rsOrdUpper = '\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])',
      rsSeq = rsOptVar + reOptMod + rsOptJoin,
      rsEmoji = '(?:' + [rsDingbat, rsRegional, rsSurrPair].join('|') + ')' + rsSeq,
      rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';

  /** Used to match apostrophes. */
  var reApos = RegExp(rsApos, 'g');

  /**
   * Used to match [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks) and
   * [combining diacritical marks for symbols](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks_for_Symbols).
   */
  var reComboMark = RegExp(rsCombo, 'g');

  /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
  var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

  /** Used to match complex or compound words. */
  var reUnicodeWord = RegExp([
    rsUpper + '?' + rsLower + '+' + rsOptContrLower + '(?=' + [rsBreak, rsUpper, '$'].join('|') + ')',
    rsMiscUpper + '+' + rsOptContrUpper + '(?=' + [rsBreak, rsUpper + rsMiscLower, '$'].join('|') + ')',
    rsUpper + '?' + rsMiscLower + '+' + rsOptContrLower,
    rsUpper + '+' + rsOptContrUpper,
    rsOrdUpper,
    rsOrdLower,
    rsDigits,
    rsEmoji
  ].join('|'), 'g');

  /** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
  var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange  + rsComboRange + rsVarRange + ']');

  /** Used to detect strings that need a more robust regexp to match words. */
  var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;

  /** Used to assign default `context` object properties. */
  var contextProps = [
    'Array', 'Buffer', 'DataView', 'Date', 'Error', 'Float32Array', 'Float64Array',
    'Function', 'Int8Array', 'Int16Array', 'Int32Array', 'Map', 'Math', 'Object',
    'Promise', 'RegExp', 'Set', 'String', 'Symbol', 'TypeError', 'Uint8Array',
    'Uint8ClampedArray', 'Uint16Array', 'Uint32Array', 'WeakMap',
    '_', 'clearTimeout', 'isFinite', 'parseInt', 'setTimeout'
  ];

  /** Used to make template sourceURLs easier to identify. */
  var templateCounter = -1;

  /** Used to identify `toStringTag` values of typed arrays. */
  var typedArrayTags = {};
  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
  typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
  typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
  typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
  typedArrayTags[uint32Tag] = true;
  typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
  typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
  typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
  typedArrayTags[errorTag] = typedArrayTags[funcTag] =
  typedArrayTags[mapTag] = typedArrayTags[numberTag] =
  typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
  typedArrayTags[setTag] = typedArrayTags[stringTag] =
  typedArrayTags[weakMapTag] = false;

  /** Used to identify `toStringTag` values supported by `_.clone`. */
  var cloneableTags = {};
  cloneableTags[argsTag] = cloneableTags[arrayTag] =
  cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] =
  cloneableTags[boolTag] = cloneableTags[dateTag] =
  cloneableTags[float32Tag] = cloneableTags[float64Tag] =
  cloneableTags[int8Tag] = cloneableTags[int16Tag] =
  cloneableTags[int32Tag] = cloneableTags[mapTag] =
  cloneableTags[numberTag] = cloneableTags[objectTag] =
  cloneableTags[regexpTag] = cloneableTags[setTag] =
  cloneableTags[stringTag] = cloneableTags[symbolTag] =
  cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
  cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
  cloneableTags[errorTag] = cloneableTags[funcTag] =
  cloneableTags[weakMapTag] = false;

  /** Used to map Latin Unicode letters to basic Latin letters. */
  var deburredLetters = {
    // Latin-1 Supplement block.
    '\xc0': 'A',  '\xc1': 'A', '\xc2': 'A', '\xc3': 'A', '\xc4': 'A', '\xc5': 'A',
    '\xe0': 'a',  '\xe1': 'a', '\xe2': 'a', '\xe3': 'a', '\xe4': 'a', '\xe5': 'a',
    '\xc7': 'C',  '\xe7': 'c',
    '\xd0': 'D',  '\xf0': 'd',
    '\xc8': 'E',  '\xc9': 'E', '\xca': 'E', '\xcb': 'E',
    '\xe8': 'e',  '\xe9': 'e', '\xea': 'e', '\xeb': 'e',
    '\xcc': 'I',  '\xcd': 'I', '\xce': 'I', '\xcf': 'I',
    '\xec': 'i',  '\xed': 'i', '\xee': 'i', '\xef': 'i',
    '\xd1': 'N',  '\xf1': 'n',
    '\xd2': 'O',  '\xd3': 'O', '\xd4': 'O', '\xd5': 'O', '\xd6': 'O', '\xd8': 'O',
    '\xf2': 'o',  '\xf3': 'o', '\xf4': 'o', '\xf5': 'o', '\xf6': 'o', '\xf8': 'o',
    '\xd9': 'U',  '\xda': 'U', '\xdb': 'U', '\xdc': 'U',
    '\xf9': 'u',  '\xfa': 'u', '\xfb': 'u', '\xfc': 'u',
    '\xdd': 'Y',  '\xfd': 'y', '\xff': 'y',
    '\xc6': 'Ae', '\xe6': 'ae',
    '\xde': 'Th', '\xfe': 'th',
    '\xdf': 'ss',
    // Latin Extended-A block.
    '\u0100': 'A',  '\u0102': 'A', '\u0104': 'A',
    '\u0101': 'a',  '\u0103': 'a', '\u0105': 'a',
    '\u0106': 'C',  '\u0108': 'C', '\u010a': 'C', '\u010c': 'C',
    '\u0107': 'c',  '\u0109': 'c', '\u010b': 'c', '\u010d': 'c',
    '\u010e': 'D',  '\u0110': 'D', '\u010f': 'd', '\u0111': 'd',
    '\u0112': 'E',  '\u0114': 'E', '\u0116': 'E', '\u0118': 'E', '\u011a': 'E',
    '\u0113': 'e',  '\u0115': 'e', '\u0117': 'e', '\u0119': 'e', '\u011b': 'e',
    '\u011c': 'G',  '\u011e': 'G', '\u0120': 'G', '\u0122': 'G',
    '\u011d': 'g',  '\u011f': 'g', '\u0121': 'g', '\u0123': 'g',
    '\u0124': 'H',  '\u0126': 'H', '\u0125': 'h', '\u0127': 'h',
    '\u0128': 'I',  '\u012a': 'I', '\u012c': 'I', '\u012e': 'I', '\u0130': 'I',
    '\u0129': 'i',  '\u012b': 'i', '\u012d': 'i', '\u012f': 'i', '\u0131': 'i',
    '\u0134': 'J',  '\u0135': 'j',
    '\u0136': 'K',  '\u0137': 'k', '\u0138': 'k',
    '\u0139': 'L',  '\u013b': 'L', '\u013d': 'L', '\u013f': 'L', '\u0141': 'L',
    '\u013a': 'l',  '\u013c': 'l', '\u013e': 'l', '\u0140': 'l', '\u0142': 'l',
    '\u0143': 'N',  '\u0145': 'N', '\u0147': 'N', '\u014a': 'N',
    '\u0144': 'n',  '\u0146': 'n', '\u0148': 'n', '\u014b': 'n',
    '\u014c': 'O',  '\u014e': 'O', '\u0150': 'O',
    '\u014d': 'o',  '\u014f': 'o', '\u0151': 'o',
    '\u0154': 'R',  '\u0156': 'R', '\u0158': 'R',
    '\u0155': 'r',  '\u0157': 'r', '\u0159': 'r',
    '\u015a': 'S',  '\u015c': 'S', '\u015e': 'S', '\u0160': 'S',
    '\u015b': 's',  '\u015d': 's', '\u015f': 's', '\u0161': 's',
    '\u0162': 'T',  '\u0164': 'T', '\u0166': 'T',
    '\u0163': 't',  '\u0165': 't', '\u0167': 't',
    '\u0168': 'U',  '\u016a': 'U', '\u016c': 'U', '\u016e': 'U', '\u0170': 'U', '\u0172': 'U',
    '\u0169': 'u',  '\u016b': 'u', '\u016d': 'u', '\u016f': 'u', '\u0171': 'u', '\u0173': 'u',
    '\u0174': 'W',  '\u0175': 'w',
    '\u0176': 'Y',  '\u0177': 'y', '\u0178': 'Y',
    '\u0179': 'Z',  '\u017b': 'Z', '\u017d': 'Z',
    '\u017a': 'z',  '\u017c': 'z', '\u017e': 'z',
    '\u0132': 'IJ', '\u0133': 'ij',
    '\u0152': 'Oe', '\u0153': 'oe',
    '\u0149': "'n", '\u017f': 's'
  };

  /** Used to map characters to HTML entities. */
  var htmlEscapes = {
    '&': '&amp;',
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&#39;'
  };

  /** Used to map HTML entities to characters. */
  var htmlUnescapes = {
    '&amp;': '&',
    '&lt;': '<',
    '&gt;': '>',
    '&quot;': '"',
    '&#39;': "'"
  };

  /** Used to escape characters for inclusion in compiled string literals. */
  var stringEscapes = {
    '\\': '\\',
    "'": "'",
    '\n': 'n',
    '\r': 'r',
    '\u2028': 'u2028',
    '\u2029': 'u2029'
  };

  /** Built-in method references without a dependency on `root`. */
  var freeParseFloat = parseFloat,
      freeParseInt = parseInt;

  /** Detect free variable `global` from Node.js. */
  var freeGlobal = typeof __webpack_require__.g == 'object' && __webpack_require__.g && __webpack_require__.g.Object === Object && __webpack_require__.g;

  /** Detect free variable `self`. */
  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

  /** Used as a reference to the global object. */
  var root = freeGlobal || freeSelf || Function('return this')();

  /** Detect free variable `exports`. */
  var freeExports =  true && exports && !exports.nodeType && exports;

  /** Detect free variable `module`. */
  var freeModule = freeExports && "object" == 'object' && module && !module.nodeType && module;

  /** Detect the popular CommonJS extension `module.exports`. */
  var moduleExports = freeModule && freeModule.exports === freeExports;

  /** Detect free variable `process` from Node.js. */
  var freeProcess = moduleExports && freeGlobal.process;

  /** Used to access faster Node.js helpers. */
  var nodeUtil = (function() {
    try {
      // Use `util.types` for Node.js 10+.
      var types = freeModule && freeModule.require && freeModule.require('util').types;

      if (types) {
        return types;
      }

      // Legacy `process.binding('util')` for Node.js < 10.
      return freeProcess && freeProcess.binding && freeProcess.binding('util');
    } catch (e) {}
  }());

  /* Node.js helper references. */
  var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer,
      nodeIsDate = nodeUtil && nodeUtil.isDate,
      nodeIsMap = nodeUtil && nodeUtil.isMap,
      nodeIsRegExp = nodeUtil && nodeUtil.isRegExp,
      nodeIsSet = nodeUtil && nodeUtil.isSet,
      nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

  /*--------------------------------------------------------------------------*/

  /**
   * A faster alternative to `Function#apply`, this function invokes `func`
   * with the `this` binding of `thisArg` and the arguments of `args`.
   *
   * @private
   * @param {Function} func The function to invoke.
   * @param {*} thisArg The `this` binding of `func`.
   * @param {Array} args The arguments to invoke `func` with.
   * @returns {*} Returns the result of `func`.
   */
  function apply(func, thisArg, args) {
    switch (args.length) {
      case 0: return func.call(thisArg);
      case 1: return func.call(thisArg, args[0]);
      case 2: return func.call(thisArg, args[0], args[1]);
      case 3: return func.call(thisArg, args[0], args[1], args[2]);
    }
    return func.apply(thisArg, args);
  }

  /**
   * A specialized version of `baseAggregator` for arrays.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} setter The function to set `accumulator` values.
   * @param {Function} iteratee The iteratee to transform keys.
   * @param {Object} accumulator The initial aggregated object.
   * @returns {Function} Returns `accumulator`.
   */
  function arrayAggregator(array, setter, iteratee, accumulator) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      var value = array[index];
      setter(accumulator, value, iteratee(value), array);
    }
    return accumulator;
  }

  /**
   * A specialized version of `_.forEach` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns `array`.
   */
  function arrayEach(array, iteratee) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      if (iteratee(array[index], index, array) === false) {
        break;
      }
    }
    return array;
  }

  /**
   * A specialized version of `_.forEachRight` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns `array`.
   */
  function arrayEachRight(array, iteratee) {
    var length = array == null ? 0 : array.length;

    while (length--) {
      if (iteratee(array[length], length, array) === false) {
        break;
      }
    }
    return array;
  }

  /**
   * A specialized version of `_.every` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {boolean} Returns `true` if all elements pass the predicate check,
   *  else `false`.
   */
  function arrayEvery(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      if (!predicate(array[index], index, array)) {
        return false;
      }
    }
    return true;
  }

  /**
   * A specialized version of `_.filter` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {Array} Returns the new filtered array.
   */
  function arrayFilter(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length,
        resIndex = 0,
        result = [];

    while (++index < length) {
      var value = array[index];
      if (predicate(value, index, array)) {
        result[resIndex++] = value;
      }
    }
    return result;
  }

  /**
   * A specialized version of `_.includes` for arrays without support for
   * specifying an index to search from.
   *
   * @private
   * @param {Array} [array] The array to inspect.
   * @param {*} target The value to search for.
   * @returns {boolean} Returns `true` if `target` is found, else `false`.
   */
  function arrayIncludes(array, value) {
    var length = array == null ? 0 : array.length;
    return !!length && baseIndexOf(array, value, 0) > -1;
  }

  /**
   * This function is like `arrayIncludes` except that it accepts a comparator.
   *
   * @private
   * @param {Array} [array] The array to inspect.
   * @param {*} target The value to search for.
   * @param {Function} comparator The comparator invoked per element.
   * @returns {boolean} Returns `true` if `target` is found, else `false`.
   */
  function arrayIncludesWith(array, value, comparator) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      if (comparator(value, array[index])) {
        return true;
      }
    }
    return false;
  }

  /**
   * A specialized version of `_.map` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   */
  function arrayMap(array, iteratee) {
    var index = -1,
        length = array == null ? 0 : array.length,
        result = Array(length);

    while (++index < length) {
      result[index] = iteratee(array[index], index, array);
    }
    return result;
  }

  /**
   * Appends the elements of `values` to `array`.
   *
   * @private
   * @param {Array} array The array to modify.
   * @param {Array} values The values to append.
   * @returns {Array} Returns `array`.
   */
  function arrayPush(array, values) {
    var index = -1,
        length = values.length,
        offset = array.length;

    while (++index < length) {
      array[offset + index] = values[index];
    }
    return array;
  }

  /**
   * A specialized version of `_.reduce` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {*} [accumulator] The initial value.
   * @param {boolean} [initAccum] Specify using the first element of `array` as
   *  the initial value.
   * @returns {*} Returns the accumulated value.
   */
  function arrayReduce(array, iteratee, accumulator, initAccum) {
    var index = -1,
        length = array == null ? 0 : array.length;

    if (initAccum && length) {
      accumulator = array[++index];
    }
    while (++index < length) {
      accumulator = iteratee(accumulator, array[index], index, array);
    }
    return accumulator;
  }

  /**
   * A specialized version of `_.reduceRight` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {*} [accumulator] The initial value.
   * @param {boolean} [initAccum] Specify using the last element of `array` as
   *  the initial value.
   * @returns {*} Returns the accumulated value.
   */
  function arrayReduceRight(array, iteratee, accumulator, initAccum) {
    var length = array == null ? 0 : array.length;
    if (initAccum && length) {
      accumulator = array[--length];
    }
    while (length--) {
      accumulator = iteratee(accumulator, array[length], length, array);
    }
    return accumulator;
  }

  /**
   * A specialized version of `_.some` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {boolean} Returns `true` if any element passes the predicate check,
   *  else `false`.
   */
  function arraySome(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      if (predicate(array[index], index, array)) {
        return true;
      }
    }
    return false;
  }

  /**
   * Gets the size of an ASCII `string`.
   *
   * @private
   * @param {string} string The string inspect.
   * @returns {number} Returns the string size.
   */
  var asciiSize = baseProperty('length');

  /**
   * Converts an ASCII `string` to an array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the converted array.
   */
  function asciiToArray(string) {
    return string.split('');
  }

  /**
   * Splits an ASCII `string` into an array of its words.
   *
   * @private
   * @param {string} The string to inspect.
   * @returns {Array} Returns the words of `string`.
   */
  function asciiWords(string) {
    return string.match(reAsciiWord) || [];
  }

  /**
   * The base implementation of methods like `_.findKey` and `_.findLastKey`,
   * without support for iteratee shorthands, which iterates over `collection`
   * using `eachFunc`.
   *
   * @private
   * @param {Array|Object} collection The collection to inspect.
   * @param {Function} predicate The function invoked per iteration.
   * @param {Function} eachFunc The function to iterate over `collection`.
   * @returns {*} Returns the found element or its key, else `undefined`.
   */
  function baseFindKey(collection, predicate, eachFunc) {
    var result;
    eachFunc(collection, function(value, key, collection) {
      if (predicate(value, key, collection)) {
        result = key;
        return false;
      }
    });
    return result;
  }

  /**
   * The base implementation of `_.findIndex` and `_.findLastIndex` without
   * support for iteratee shorthands.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {Function} predicate The function invoked per iteration.
   * @param {number} fromIndex The index to search from.
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function baseFindIndex(array, predicate, fromIndex, fromRight) {
    var length = array.length,
        index = fromIndex + (fromRight ? 1 : -1);

    while ((fromRight ? index-- : ++index < length)) {
      if (predicate(array[index], index, array)) {
        return index;
      }
    }
    return -1;
  }

  /**
   * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} value The value to search for.
   * @param {number} fromIndex The index to search from.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function baseIndexOf(array, value, fromIndex) {
    return value === value
      ? strictIndexOf(array, value, fromIndex)
      : baseFindIndex(array, baseIsNaN, fromIndex);
  }

  /**
   * This function is like `baseIndexOf` except that it accepts a comparator.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} value The value to search for.
   * @param {number} fromIndex The index to search from.
   * @param {Function} comparator The comparator invoked per element.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function baseIndexOfWith(array, value, fromIndex, comparator) {
    var index = fromIndex - 1,
        length = array.length;

    while (++index < length) {
      if (comparator(array[index], value)) {
        return index;
      }
    }
    return -1;
  }

  /**
   * The base implementation of `_.isNaN` without support for number objects.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
   */
  function baseIsNaN(value) {
    return value !== value;
  }

  /**
   * The base implementation of `_.mean` and `_.meanBy` without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} array The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {number} Returns the mean.
   */
  function baseMean(array, iteratee) {
    var length = array == null ? 0 : array.length;
    return length ? (baseSum(array, iteratee) / length) : NAN;
  }

  /**
   * The base implementation of `_.property` without support for deep paths.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @returns {Function} Returns the new accessor function.
   */
  function baseProperty(key) {
    return function(object) {
      return object == null ? undefined : object[key];
    };
  }

  /**
   * The base implementation of `_.propertyOf` without support for deep paths.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Function} Returns the new accessor function.
   */
  function basePropertyOf(object) {
    return function(key) {
      return object == null ? undefined : object[key];
    };
  }

  /**
   * The base implementation of `_.reduce` and `_.reduceRight`, without support
   * for iteratee shorthands, which iterates over `collection` using `eachFunc`.
   *
   * @private
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {*} accumulator The initial value.
   * @param {boolean} initAccum Specify using the first or last element of
   *  `collection` as the initial value.
   * @param {Function} eachFunc The function to iterate over `collection`.
   * @returns {*} Returns the accumulated value.
   */
  function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
    eachFunc(collection, function(value, index, collection) {
      accumulator = initAccum
        ? (initAccum = false, value)
        : iteratee(accumulator, value, index, collection);
    });
    return accumulator;
  }

  /**
   * The base implementation of `_.sortBy` which uses `comparer` to define the
   * sort order of `array` and replaces criteria objects with their corresponding
   * values.
   *
   * @private
   * @param {Array} array The array to sort.
   * @param {Function} comparer The function to define sort order.
   * @returns {Array} Returns `array`.
   */
  function baseSortBy(array, comparer) {
    var length = array.length;

    array.sort(comparer);
    while (length--) {
      array[length] = array[length].value;
    }
    return array;
  }

  /**
   * The base implementation of `_.sum` and `_.sumBy` without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} array The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {number} Returns the sum.
   */
  function baseSum(array, iteratee) {
    var result,
        index = -1,
        length = array.length;

    while (++index < length) {
      var current = iteratee(array[index]);
      if (current !== undefined) {
        result = result === undefined ? current : (result + current);
      }
    }
    return result;
  }

  /**
   * The base implementation of `_.times` without support for iteratee shorthands
   * or max array length checks.
   *
   * @private
   * @param {number} n The number of times to invoke `iteratee`.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the array of results.
   */
  function baseTimes(n, iteratee) {
    var index = -1,
        result = Array(n);

    while (++index < n) {
      result[index] = iteratee(index);
    }
    return result;
  }

  /**
   * The base implementation of `_.toPairs` and `_.toPairsIn` which creates an array
   * of key-value pairs for `object` corresponding to the property names of `props`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array} props The property names to get values for.
   * @returns {Object} Returns the key-value pairs.
   */
  function baseToPairs(object, props) {
    return arrayMap(props, function(key) {
      return [key, object[key]];
    });
  }

  /**
   * The base implementation of `_.trim`.
   *
   * @private
   * @param {string} string The string to trim.
   * @returns {string} Returns the trimmed string.
   */
  function baseTrim(string) {
    return string
      ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '')
      : string;
  }

  /**
   * The base implementation of `_.unary` without support for storing metadata.
   *
   * @private
   * @param {Function} func The function to cap arguments for.
   * @returns {Function} Returns the new capped function.
   */
  function baseUnary(func) {
    return function(value) {
      return func(value);
    };
  }

  /**
   * The base implementation of `_.values` and `_.valuesIn` which creates an
   * array of `object` property values corresponding to the property names
   * of `props`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array} props The property names to get values for.
   * @returns {Object} Returns the array of property values.
   */
  function baseValues(object, props) {
    return arrayMap(props, function(key) {
      return object[key];
    });
  }

  /**
   * Checks if a `cache` value for `key` exists.
   *
   * @private
   * @param {Object} cache The cache to query.
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function cacheHas(cache, key) {
    return cache.has(key);
  }

  /**
   * Used by `_.trim` and `_.trimStart` to get the index of the first string symbol
   * that is not found in the character symbols.
   *
   * @private
   * @param {Array} strSymbols The string symbols to inspect.
   * @param {Array} chrSymbols The character symbols to find.
   * @returns {number} Returns the index of the first unmatched string symbol.
   */
  function charsStartIndex(strSymbols, chrSymbols) {
    var index = -1,
        length = strSymbols.length;

    while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
    return index;
  }

  /**
   * Used by `_.trim` and `_.trimEnd` to get the index of the last string symbol
   * that is not found in the character symbols.
   *
   * @private
   * @param {Array} strSymbols The string symbols to inspect.
   * @param {Array} chrSymbols The character symbols to find.
   * @returns {number} Returns the index of the last unmatched string symbol.
   */
  function charsEndIndex(strSymbols, chrSymbols) {
    var index = strSymbols.length;

    while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
    return index;
  }

  /**
   * Gets the number of `placeholder` occurrences in `array`.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} placeholder The placeholder to search for.
   * @returns {number} Returns the placeholder count.
   */
  function countHolders(array, placeholder) {
    var length = array.length,
        result = 0;

    while (length--) {
      if (array[length] === placeholder) {
        ++result;
      }
    }
    return result;
  }

  /**
   * Used by `_.deburr` to convert Latin-1 Supplement and Latin Extended-A
   * letters to basic Latin letters.
   *
   * @private
   * @param {string} letter The matched letter to deburr.
   * @returns {string} Returns the deburred letter.
   */
  var deburrLetter = basePropertyOf(deburredLetters);

  /**
   * Used by `_.escape` to convert characters to HTML entities.
   *
   * @private
   * @param {string} chr The matched character to escape.
   * @returns {string} Returns the escaped character.
   */
  var escapeHtmlChar = basePropertyOf(htmlEscapes);

  /**
   * Used by `_.template` to escape characters for inclusion in compiled string literals.
   *
   * @private
   * @param {string} chr The matched character to escape.
   * @returns {string} Returns the escaped character.
   */
  function escapeStringChar(chr) {
    return '\\' + stringEscapes[chr];
  }

  /**
   * Gets the value at `key` of `object`.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {string} key The key of the property to get.
   * @returns {*} Returns the property value.
   */
  function getValue(object, key) {
    return object == null ? undefined : object[key];
  }

  /**
   * Checks if `string` contains Unicode symbols.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {boolean} Returns `true` if a symbol is found, else `false`.
   */
  function hasUnicode(string) {
    return reHasUnicode.test(string);
  }

  /**
   * Checks if `string` contains a word composed of Unicode symbols.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {boolean} Returns `true` if a word is found, else `false`.
   */
  function hasUnicodeWord(string) {
    return reHasUnicodeWord.test(string);
  }

  /**
   * Converts `iterator` to an array.
   *
   * @private
   * @param {Object} iterator The iterator to convert.
   * @returns {Array} Returns the converted array.
   */
  function iteratorToArray(iterator) {
    var data,
        result = [];

    while (!(data = iterator.next()).done) {
      result.push(data.value);
    }
    return result;
  }

  /**
   * Converts `map` to its key-value pairs.
   *
   * @private
   * @param {Object} map The map to convert.
   * @returns {Array} Returns the key-value pairs.
   */
  function mapToArray(map) {
    var index = -1,
        result = Array(map.size);

    map.forEach(function(value, key) {
      result[++index] = [key, value];
    });
    return result;
  }

  /**
   * Creates a unary function that invokes `func` with its argument transformed.
   *
   * @private
   * @param {Function} func The function to wrap.
   * @param {Function} transform The argument transform.
   * @returns {Function} Returns the new function.
   */
  function overArg(func, transform) {
    return function(arg) {
      return func(transform(arg));
    };
  }

  /**
   * Replaces all `placeholder` elements in `array` with an internal placeholder
   * and returns an array of their indexes.
   *
   * @private
   * @param {Array} array The array to modify.
   * @param {*} placeholder The placeholder to replace.
   * @returns {Array} Returns the new array of placeholder indexes.
   */
  function replaceHolders(array, placeholder) {
    var index = -1,
        length = array.length,
        resIndex = 0,
        result = [];

    while (++index < length) {
      var value = array[index];
      if (value === placeholder || value === PLACEHOLDER) {
        array[index] = PLACEHOLDER;
        result[resIndex++] = index;
      }
    }
    return result;
  }

  /**
   * Converts `set` to an array of its values.
   *
   * @private
   * @param {Object} set The set to convert.
   * @returns {Array} Returns the values.
   */
  function setToArray(set) {
    var index = -1,
        result = Array(set.size);

    set.forEach(function(value) {
      result[++index] = value;
    });
    return result;
  }

  /**
   * Converts `set` to its value-value pairs.
   *
   * @private
   * @param {Object} set The set to convert.
   * @returns {Array} Returns the value-value pairs.
   */
  function setToPairs(set) {
    var index = -1,
        result = Array(set.size);

    set.forEach(function(value) {
      result[++index] = [value, value];
    });
    return result;
  }

  /**
   * A specialized version of `_.indexOf` which performs strict equality
   * comparisons of values, i.e. `===`.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} value The value to search for.
   * @param {number} fromIndex The index to search from.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function strictIndexOf(array, value, fromIndex) {
    var index = fromIndex - 1,
        length = array.length;

    while (++index < length) {
      if (array[index] === value) {
        return index;
      }
    }
    return -1;
  }

  /**
   * A specialized version of `_.lastIndexOf` which performs strict equality
   * comparisons of values, i.e. `===`.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} value The value to search for.
   * @param {number} fromIndex The index to search from.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function strictLastIndexOf(array, value, fromIndex) {
    var index = fromIndex + 1;
    while (index--) {
      if (array[index] === value) {
        return index;
      }
    }
    return index;
  }

  /**
   * Gets the number of symbols in `string`.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {number} Returns the string size.
   */
  function stringSize(string) {
    return hasUnicode(string)
      ? unicodeSize(string)
      : asciiSize(string);
  }

  /**
   * Converts `string` to an array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the converted array.
   */
  function stringToArray(string) {
    return hasUnicode(string)
      ? unicodeToArray(string)
      : asciiToArray(string);
  }

  /**
   * Used by `_.trim` and `_.trimEnd` to get the index of the last non-whitespace
   * character of `string`.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {number} Returns the index of the last non-whitespace character.
   */
  function trimmedEndIndex(string) {
    var index = string.length;

    while (index-- && reWhitespace.test(string.charAt(index))) {}
    return index;
  }

  /**
   * Used by `_.unescape` to convert HTML entities to characters.
   *
   * @private
   * @param {string} chr The matched character to unescape.
   * @returns {string} Returns the unescaped character.
   */
  var unescapeHtmlChar = basePropertyOf(htmlUnescapes);

  /**
   * Gets the size of a Unicode `string`.
   *
   * @private
   * @param {string} string The string inspect.
   * @returns {number} Returns the string size.
   */
  function unicodeSize(string) {
    var result = reUnicode.lastIndex = 0;
    while (reUnicode.test(string)) {
      ++result;
    }
    return result;
  }

  /**
   * Converts a Unicode `string` to an array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the converted array.
   */
  function unicodeToArray(string) {
    return string.match(reUnicode) || [];
  }

  /**
   * Splits a Unicode `string` into an array of its words.
   *
   * @private
   * @param {string} The string to inspect.
   * @returns {Array} Returns the words of `string`.
   */
  function unicodeWords(string) {
    return string.match(reUnicodeWord) || [];
  }

  /*--------------------------------------------------------------------------*/

  /**
   * Create a new pristine `lodash` function using the `context` object.
   *
   * @static
   * @memberOf _
   * @since 1.1.0
   * @category Util
   * @param {Object} [context=root] The context object.
   * @returns {Function} Returns a new `lodash` function.
   * @example
   *
   * _.mixin({ 'foo': _.constant('foo') });
   *
   * var lodash = _.runInContext();
   * lodash.mixin({ 'bar': lodash.constant('bar') });
   *
   * _.isFunction(_.foo);
   * // => true
   * _.isFunction(_.bar);
   * // => false
   *
   * lodash.isFunction(lodash.foo);
   * // => false
   * lodash.isFunction(lodash.bar);
   * // => true
   *
   * // Create a suped-up `defer` in Node.js.
   * var defer = _.runInContext({ 'setTimeout': setImmediate }).defer;
   */
  var runInContext = (function runInContext(context) {
    context = context == null ? root : _.defaults(root.Object(), context, _.pick(root, contextProps));

    /** Built-in constructor references. */
    var Array = context.Array,
        Date = context.Date,
        Error = context.Error,
        Function = context.Function,
        Math = context.Math,
        Object = context.Object,
        RegExp = context.RegExp,
        String = context.String,
        TypeError = context.TypeError;

    /** Used for built-in method references. */
    var arrayProto = Array.prototype,
        funcProto = Function.prototype,
        objectProto = Object.prototype;

    /** Used to detect overreaching core-js shims. */
    var coreJsData = context['__core-js_shared__'];

    /** Used to resolve the decompiled source of functions. */
    var funcToString = funcProto.toString;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /** Used to generate unique IDs. */
    var idCounter = 0;

    /** Used to detect methods masquerading as native. */
    var maskSrcKey = (function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
      return uid ? ('Symbol(src)_1.' + uid) : '';
    }());

    /**
     * Used to resolve the
     * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
     * of values.
     */
    var nativeObjectToString = objectProto.toString;

    /** Used to infer the `Object` constructor. */
    var objectCtorString = funcToString.call(Object);

    /** Used to restore the original `_` reference in `_.noConflict`. */
    var oldDash = root._;

    /** Used to detect if a method is native. */
    var reIsNative = RegExp('^' +
      funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
      .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
    );

    /** Built-in value references. */
    var Buffer = moduleExports ? context.Buffer : undefined,
        Symbol = context.Symbol,
        Uint8Array = context.Uint8Array,
        allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined,
        getPrototype = overArg(Object.getPrototypeOf, Object),
        objectCreate = Object.create,
        propertyIsEnumerable = objectProto.propertyIsEnumerable,
        splice = arrayProto.splice,
        spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined,
        symIterator = Symbol ? Symbol.iterator : undefined,
        symToStringTag = Symbol ? Symbol.toStringTag : undefined;

    var defineProperty = (function() {
      try {
        var func = getNative(Object, 'defineProperty');
        func({}, '', {});
        return func;
      } catch (e) {}
    }());

    /** Mocked built-ins. */
    var ctxClearTimeout = context.clearTimeout !== root.clearTimeout && context.clearTimeout,
        ctxNow = Date && Date.now !== root.Date.now && Date.now,
        ctxSetTimeout = context.setTimeout !== root.setTimeout && context.setTimeout;

    /* Built-in method references for those with the same name as other `lodash` methods. */
    var nativeCeil = Math.ceil,
        nativeFloor = Math.floor,
        nativeGetSymbols = Object.getOwnPropertySymbols,
        nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined,
        nativeIsFinite = context.isFinite,
        nativeJoin = arrayProto.join,
        nativeKeys = overArg(Object.keys, Object),
        nativeMax = Math.max,
        nativeMin = Math.min,
        nativeNow = Date.now,
        nativeParseInt = context.parseInt,
        nativeRandom = Math.random,
        nativeReverse = arrayProto.reverse;

    /* Built-in method references that are verified to be native. */
    var DataView = getNative(context, 'DataView'),
        Map = getNative(context, 'Map'),
        Promise = getNative(context, 'Promise'),
        Set = getNative(context, 'Set'),
        WeakMap = getNative(context, 'WeakMap'),
        nativeCreate = getNative(Object, 'create');

    /** Used to store function metadata. */
    var metaMap = WeakMap && new WeakMap;

    /** Used to lookup unminified function names. */
    var realNames = {};

    /** Used to detect maps, sets, and weakmaps. */
    var dataViewCtorString = toSource(DataView),
        mapCtorString = toSource(Map),
        promiseCtorString = toSource(Promise),
        setCtorString = toSource(Set),
        weakMapCtorString = toSource(WeakMap);

    /** Used to convert symbols to primitives and strings. */
    var symbolProto = Symbol ? Symbol.prototype : undefined,
        symbolValueOf = symbolProto ? symbolProto.valueOf : undefined,
        symbolToString = symbolProto ? symbolProto.toString : undefined;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a `lodash` object which wraps `value` to enable implicit method
     * chain sequences. Methods that operate on and return arrays, collections,
     * and functions can be chained together. Methods that retrieve a single value
     * or may return a primitive value will automatically end the chain sequence
     * and return the unwrapped value. Otherwise, the value must be unwrapped
     * with `_#value`.
     *
     * Explicit chain sequences, which must be unwrapped with `_#value`, may be
     * enabled using `_.chain`.
     *
     * The execution of chained methods is lazy, that is, it's deferred until
     * `_#value` is implicitly or explicitly called.
     *
     * Lazy evaluation allows several methods to support shortcut fusion.
     * Shortcut fusion is an optimization to merge iteratee calls; this avoids
     * the creation of intermediate arrays and can greatly reduce the number of
     * iteratee executions. Sections of a chain sequence qualify for shortcut
     * fusion if the section is applied to an array and iteratees accept only
     * one argument. The heuristic for whether a section qualifies for shortcut
     * fusion is subject to change.
     *
     * Chaining is supported in custom builds as long as the `_#value` method is
     * directly or indirectly included in the build.
     *
     * In addition to lodash methods, wrappers have `Array` and `String` methods.
     *
     * The wrapper `Array` methods are:
     * `concat`, `join`, `pop`, `push`, `shift`, `sort`, `splice`, and `unshift`
     *
     * The wrapper `String` methods are:
     * `replace` and `split`
     *
     * The wrapper methods that support shortcut fusion are:
     * `at`, `compact`, `drop`, `dropRight`, `dropWhile`, `filter`, `find`,
     * `findLast`, `head`, `initial`, `last`, `map`, `reject`, `reverse`, `slice`,
     * `tail`, `take`, `takeRight`, `takeRightWhile`, `takeWhile`, and `toArray`
     *
     * The chainable wrapper methods are:
     * `after`, `ary`, `assign`, `assignIn`, `assignInWith`, `assignWith`, `at`,
     * `before`, `bind`, `bindAll`, `bindKey`, `castArray`, `chain`, `chunk`,
     * `commit`, `compact`, `concat`, `conforms`, `constant`, `countBy`, `create`,
     * `curry`, `debounce`, `defaults`, `defaultsDeep`, `defer`, `delay`,
     * `difference`, `differenceBy`, `differenceWith`, `drop`, `dropRight`,
     * `dropRightWhile`, `dropWhile`, `extend`, `extendWith`, `fill`, `filter`,
     * `flatMap`, `flatMapDeep`, `flatMapDepth`, `flatten`, `flattenDeep`,
     * `flattenDepth`, `flip`, `flow`, `flowRight`, `fromPairs`, `functions`,
     * `functionsIn`, `groupBy`, `initial`, `intersection`, `intersectionBy`,
     * `intersectionWith`, `invert`, `invertBy`, `invokeMap`, `iteratee`, `keyBy`,
     * `keys`, `keysIn`, `map`, `mapKeys`, `mapValues`, `matches`, `matchesProperty`,
     * `memoize`, `merge`, `mergeWith`, `method`, `methodOf`, `mixin`, `negate`,
     * `nthArg`, `omit`, `omitBy`, `once`, `orderBy`, `over`, `overArgs`,
     * `overEvery`, `overSome`, `partial`, `partialRight`, `partition`, `pick`,
     * `pickBy`, `plant`, `property`, `propertyOf`, `pull`, `pullAll`, `pullAllBy`,
     * `pullAllWith`, `pullAt`, `push`, `range`, `rangeRight`, `rearg`, `reject`,
     * `remove`, `rest`, `reverse`, `sampleSize`, `set`, `setWith`, `shuffle`,
     * `slice`, `sort`, `sortBy`, `splice`, `spread`, `tail`, `take`, `takeRight`,
     * `takeRightWhile`, `takeWhile`, `tap`, `throttle`, `thru`, `toArray`,
     * `toPairs`, `toPairsIn`, `toPath`, `toPlainObject`, `transform`, `unary`,
     * `union`, `unionBy`, `unionWith`, `uniq`, `uniqBy`, `uniqWith`, `unset`,
     * `unshift`, `unzip`, `unzipWith`, `update`, `updateWith`, `values`,
     * `valuesIn`, `without`, `wrap`, `xor`, `xorBy`, `xorWith`, `zip`,
     * `zipObject`, `zipObjectDeep`, and `zipWith`
     *
     * The wrapper methods that are **not** chainable by default are:
     * `add`, `attempt`, `camelCase`, `capitalize`, `ceil`, `clamp`, `clone`,
     * `cloneDeep`, `cloneDeepWith`, `cloneWith`, `conformsTo`, `deburr`,
     * `defaultTo`, `divide`, `each`, `eachRight`, `endsWith`, `eq`, `escape`,
     * `escapeRegExp`, `every`, `find`, `findIndex`, `findKey`, `findLast`,
     * `findLastIndex`, `findLastKey`, `first`, `floor`, `forEach`, `forEachRight`,
     * `forIn`, `forInRight`, `forOwn`, `forOwnRight`, `get`, `gt`, `gte`, `has`,
     * `hasIn`, `head`, `identity`, `includes`, `indexOf`, `inRange`, `invoke`,
     * `isArguments`, `isArray`, `isArrayBuffer`, `isArrayLike`, `isArrayLikeObject`,
     * `isBoolean`, `isBuffer`, `isDate`, `isElement`, `isEmpty`, `isEqual`,
     * `isEqualWith`, `isError`, `isFinite`, `isFunction`, `isInteger`, `isLength`,
     * `isMap`, `isMatch`, `isMatchWith`, `isNaN`, `isNative`, `isNil`, `isNull`,
     * `isNumber`, `isObject`, `isObjectLike`, `isPlainObject`, `isRegExp`,
     * `isSafeInteger`, `isSet`, `isString`, `isUndefined`, `isTypedArray`,
     * `isWeakMap`, `isWeakSet`, `join`, `kebabCase`, `last`, `lastIndexOf`,
     * `lowerCase`, `lowerFirst`, `lt`, `lte`, `max`, `maxBy`, `mean`, `meanBy`,
     * `min`, `minBy`, `multiply`, `noConflict`, `noop`, `now`, `nth`, `pad`,
     * `padEnd`, `padStart`, `parseInt`, `pop`, `random`, `reduce`, `reduceRight`,
     * `repeat`, `result`, `round`, `runInContext`, `sample`, `shift`, `size`,
     * `snakeCase`, `some`, `sortedIndex`, `sortedIndexBy`, `sortedLastIndex`,
     * `sortedLastIndexBy`, `startCase`, `startsWith`, `stubArray`, `stubFalse`,
     * `stubObject`, `stubString`, `stubTrue`, `subtract`, `sum`, `sumBy`,
     * `template`, `times`, `toFinite`, `toInteger`, `toJSON`, `toLength`,
     * `toLower`, `toNumber`, `toSafeInteger`, `toString`, `toUpper`, `trim`,
     * `trimEnd`, `trimStart`, `truncate`, `unescape`, `uniqueId`, `upperCase`,
     * `upperFirst`, `value`, and `words`
     *
     * @name _
     * @constructor
     * @category Seq
     * @param {*} value The value to wrap in a `lodash` instance.
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var wrapped = _([1, 2, 3]);
     *
     * // Returns an unwrapped value.
     * wrapped.reduce(_.add);
     * // => 6
     *
     * // Returns a wrapped value.
     * var squares = wrapped.map(square);
     *
     * _.isArray(squares);
     * // => false
     *
     * _.isArray(squares.value());
     * // => true
     */
    function lodash(value) {
      if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {
        if (value instanceof LodashWrapper) {
          return value;
        }
        if (hasOwnProperty.call(value, '__wrapped__')) {
          return wrapperClone(value);
        }
      }
      return new LodashWrapper(value);
    }

    /**
     * The base implementation of `_.create` without support for assigning
     * properties to the created object.
     *
     * @private
     * @param {Object} proto The object to inherit from.
     * @returns {Object} Returns the new object.
     */
    var baseCreate = (function() {
      function object() {}
      return function(proto) {
        if (!isObject(proto)) {
          return {};
        }
        if (objectCreate) {
          return objectCreate(proto);
        }
        object.prototype = proto;
        var result = new object;
        object.prototype = undefined;
        return result;
      };
    }());

    /**
     * The function whose prototype chain sequence wrappers inherit from.
     *
     * @private
     */
    function baseLodash() {
      // No operation performed.
    }

    /**
     * The base constructor for creating `lodash` wrapper objects.
     *
     * @private
     * @param {*} value The value to wrap.
     * @param {boolean} [chainAll] Enable explicit method chain sequences.
     */
    function LodashWrapper(value, chainAll) {
      this.__wrapped__ = value;
      this.__actions__ = [];
      this.__chain__ = !!chainAll;
      this.__index__ = 0;
      this.__values__ = undefined;
    }

    /**
     * By default, the template delimiters used by lodash are like those in
     * embedded Ruby (ERB) as well as ES2015 template strings. Change the
     * following template settings to use alternative delimiters.
     *
     * @static
     * @memberOf _
     * @type {Object}
     */
    lodash.templateSettings = {

      /**
       * Used to detect `data` property values to be HTML-escaped.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      'escape': reEscape,

      /**
       * Used to detect code to be evaluated.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      'evaluate': reEvaluate,

      /**
       * Used to detect `data` property values to inject.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      'interpolate': reInterpolate,

      /**
       * Used to reference the data object in the template text.
       *
       * @memberOf _.templateSettings
       * @type {string}
       */
      'variable': '',

      /**
       * Used to import variables into the compiled template.
       *
       * @memberOf _.templateSettings
       * @type {Object}
       */
      'imports': {

        /**
         * A reference to the `lodash` function.
         *
         * @memberOf _.templateSettings.imports
         * @type {Function}
         */
        '_': lodash
      }
    };

    // Ensure wrappers are instances of `baseLodash`.
    lodash.prototype = baseLodash.prototype;
    lodash.prototype.constructor = lodash;

    LodashWrapper.prototype = baseCreate(baseLodash.prototype);
    LodashWrapper.prototype.constructor = LodashWrapper;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a lazy wrapper object which wraps `value` to enable lazy evaluation.
     *
     * @private
     * @constructor
     * @param {*} value The value to wrap.
     */
    function LazyWrapper(value) {
      this.__wrapped__ = value;
      this.__actions__ = [];
      this.__dir__ = 1;
      this.__filtered__ = false;
      this.__iteratees__ = [];
      this.__takeCount__ = MAX_ARRAY_LENGTH;
      this.__views__ = [];
    }

    /**
     * Creates a clone of the lazy wrapper object.
     *
     * @private
     * @name clone
     * @memberOf LazyWrapper
     * @returns {Object} Returns the cloned `LazyWrapper` object.
     */
    function lazyClone() {
      var result = new LazyWrapper(this.__wrapped__);
      result.__actions__ = copyArray(this.__actions__);
      result.__dir__ = this.__dir__;
      result.__filtered__ = this.__filtered__;
      result.__iteratees__ = copyArray(this.__iteratees__);
      result.__takeCount__ = this.__takeCount__;
      result.__views__ = copyArray(this.__views__);
      return result;
    }

    /**
     * Reverses the direction of lazy iteration.
     *
     * @private
     * @name reverse
     * @memberOf LazyWrapper
     * @returns {Object} Returns the new reversed `LazyWrapper` object.
     */
    function lazyReverse() {
      if (this.__filtered__) {
        var result = new LazyWrapper(this);
        result.__dir__ = -1;
        result.__filtered__ = true;
      } else {
        result = this.clone();
        result.__dir__ *= -1;
      }
      return result;
    }

    /**
     * Extracts the unwrapped value from its lazy wrapper.
     *
     * @private
     * @name value
     * @memberOf LazyWrapper
     * @returns {*} Returns the unwrapped value.
     */
    function lazyValue() {
      var array = this.__wrapped__.value(),
          dir = this.__dir__,
          isArr = isArray(array),
          isRight = dir < 0,
          arrLength = isArr ? array.length : 0,
          view = getView(0, arrLength, this.__views__),
          start = view.start,
          end = view.end,
          length = end - start,
          index = isRight ? end : (start - 1),
          iteratees = this.__iteratees__,
          iterLength = iteratees.length,
          resIndex = 0,
          takeCount = nativeMin(length, this.__takeCount__);

      if (!isArr || (!isRight && arrLength == length && takeCount == length)) {
        return baseWrapperValue(array, this.__actions__);
      }
      var result = [];

      outer:
      while (length-- && resIndex < takeCount) {
        index += dir;

        var iterIndex = -1,
            value = array[index];

        while (++iterIndex < iterLength) {
          var data = iteratees[iterIndex],
              iteratee = data.iteratee,
              type = data.type,
              computed = iteratee(value);

          if (type == LAZY_MAP_FLAG) {
            value = computed;
          } else if (!computed) {
            if (type == LAZY_FILTER_FLAG) {
              continue outer;
            } else {
              break outer;
            }
          }
        }
        result[resIndex++] = value;
      }
      return result;
    }

    // Ensure `LazyWrapper` is an instance of `baseLodash`.
    LazyWrapper.prototype = baseCreate(baseLodash.prototype);
    LazyWrapper.prototype.constructor = LazyWrapper;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a hash object.
     *
     * @private
     * @constructor
     * @param {Array} [entries] The key-value pairs to cache.
     */
    function Hash(entries) {
      var index = -1,
          length = entries == null ? 0 : entries.length;

      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }

    /**
     * Removes all key-value entries from the hash.
     *
     * @private
     * @name clear
     * @memberOf Hash
     */
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
      this.size = 0;
    }

    /**
     * Removes `key` and its value from the hash.
     *
     * @private
     * @name delete
     * @memberOf Hash
     * @param {Object} hash The hash to modify.
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function hashDelete(key) {
      var result = this.has(key) && delete this.__data__[key];
      this.size -= result ? 1 : 0;
      return result;
    }

    /**
     * Gets the hash value for `key`.
     *
     * @private
     * @name get
     * @memberOf Hash
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function hashGet(key) {
      var data = this.__data__;
      if (nativeCreate) {
        var result = data[key];
        return result === HASH_UNDEFINED ? undefined : result;
      }
      return hasOwnProperty.call(data, key) ? data[key] : undefined;
    }

    /**
     * Checks if a hash value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf Hash
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function hashHas(key) {
      var data = this.__data__;
      return nativeCreate ? (data[key] !== undefined) : hasOwnProperty.call(data, key);
    }

    /**
     * Sets the hash `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf Hash
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the hash instance.
     */
    function hashSet(key, value) {
      var data = this.__data__;
      this.size += this.has(key) ? 0 : 1;
      data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
      return this;
    }

    // Add methods to `Hash`.
    Hash.prototype.clear = hashClear;
    Hash.prototype['delete'] = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;

    /*------------------------------------------------------------------------*/

    /**
     * Creates an list cache object.
     *
     * @private
     * @constructor
     * @param {Array} [entries] The key-value pairs to cache.
     */
    function ListCache(entries) {
      var index = -1,
          length = entries == null ? 0 : entries.length;

      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }

    /**
     * Removes all key-value entries from the list cache.
     *
     * @private
     * @name clear
     * @memberOf ListCache
     */
    function listCacheClear() {
      this.__data__ = [];
      this.size = 0;
    }

    /**
     * Removes `key` and its value from the list cache.
     *
     * @private
     * @name delete
     * @memberOf ListCache
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function listCacheDelete(key) {
      var data = this.__data__,
          index = assocIndexOf(data, key);

      if (index < 0) {
        return false;
      }
      var lastIndex = data.length - 1;
      if (index == lastIndex) {
        data.pop();
      } else {
        splice.call(data, index, 1);
      }
      --this.size;
      return true;
    }

    /**
     * Gets the list cache value for `key`.
     *
     * @private
     * @name get
     * @memberOf ListCache
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function listCacheGet(key) {
      var data = this.__data__,
          index = assocIndexOf(data, key);

      return index < 0 ? undefined : data[index][1];
    }

    /**
     * Checks if a list cache value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf ListCache
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function listCacheHas(key) {
      return assocIndexOf(this.__data__, key) > -1;
    }

    /**
     * Sets the list cache `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf ListCache
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the list cache instance.
     */
    function listCacheSet(key, value) {
      var data = this.__data__,
          index = assocIndexOf(data, key);

      if (index < 0) {
        ++this.size;
        data.push([key, value]);
      } else {
        data[index][1] = value;
      }
      return this;
    }

    // Add methods to `ListCache`.
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype['delete'] = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a map cache object to store key-value pairs.
     *
     * @private
     * @constructor
     * @param {Array} [entries] The key-value pairs to cache.
     */
    function MapCache(entries) {
      var index = -1,
          length = entries == null ? 0 : entries.length;

      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }

    /**
     * Removes all key-value entries from the map.
     *
     * @private
     * @name clear
     * @memberOf MapCache
     */
    function mapCacheClear() {
      this.size = 0;
      this.__data__ = {
        'hash': new Hash,
        'map': new (Map || ListCache),
        'string': new Hash
      };
    }

    /**
     * Removes `key` and its value from the map.
     *
     * @private
     * @name delete
     * @memberOf MapCache
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function mapCacheDelete(key) {
      var result = getMapData(this, key)['delete'](key);
      this.size -= result ? 1 : 0;
      return result;
    }

    /**
     * Gets the map value for `key`.
     *
     * @private
     * @name get
     * @memberOf MapCache
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function mapCacheGet(key) {
      return getMapData(this, key).get(key);
    }

    /**
     * Checks if a map value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf MapCache
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function mapCacheHas(key) {
      return getMapData(this, key).has(key);
    }

    /**
     * Sets the map `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf MapCache
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the map cache instance.
     */
    function mapCacheSet(key, value) {
      var data = getMapData(this, key),
          size = data.size;

      data.set(key, value);
      this.size += data.size == size ? 0 : 1;
      return this;
    }

    // Add methods to `MapCache`.
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype['delete'] = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;

    /*------------------------------------------------------------------------*/

    /**
     *
     * Creates an array cache object to store unique values.
     *
     * @private
     * @constructor
     * @param {Array} [values] The values to cache.
     */
    function SetCache(values) {
      var index = -1,
          length = values == null ? 0 : values.length;

      this.__data__ = new MapCache;
      while (++index < length) {
        this.add(values[index]);
      }
    }

    /**
     * Adds `value` to the array cache.
     *
     * @private
     * @name add
     * @memberOf SetCache
     * @alias push
     * @param {*} value The value to cache.
     * @returns {Object} Returns the cache instance.
     */
    function setCacheAdd(value) {
      this.__data__.set(value, HASH_UNDEFINED);
      return this;
    }

    /**
     * Checks if `value` is in the array cache.
     *
     * @private
     * @name has
     * @memberOf SetCache
     * @param {*} value The value to search for.
     * @returns {number} Returns `true` if `value` is found, else `false`.
     */
    function setCacheHas(value) {
      return this.__data__.has(value);
    }

    // Add methods to `SetCache`.
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a stack cache object to store key-value pairs.
     *
     * @private
     * @constructor
     * @param {Array} [entries] The key-value pairs to cache.
     */
    function Stack(entries) {
      var data = this.__data__ = new ListCache(entries);
      this.size = data.size;
    }

    /**
     * Removes all key-value entries from the stack.
     *
     * @private
     * @name clear
     * @memberOf Stack
     */
    function stackClear() {
      this.__data__ = new ListCache;
      this.size = 0;
    }

    /**
     * Removes `key` and its value from the stack.
     *
     * @private
     * @name delete
     * @memberOf Stack
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function stackDelete(key) {
      var data = this.__data__,
          result = data['delete'](key);

      this.size = data.size;
      return result;
    }

    /**
     * Gets the stack value for `key`.
     *
     * @private
     * @name get
     * @memberOf Stack
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function stackGet(key) {
      return this.__data__.get(key);
    }

    /**
     * Checks if a stack value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf Stack
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function stackHas(key) {
      return this.__data__.has(key);
    }

    /**
     * Sets the stack `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf Stack
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the stack cache instance.
     */
    function stackSet(key, value) {
      var data = this.__data__;
      if (data instanceof ListCache) {
        var pairs = data.__data__;
        if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
          pairs.push([key, value]);
          this.size = ++data.size;
          return this;
        }
        data = this.__data__ = new MapCache(pairs);
      }
      data.set(key, value);
      this.size = data.size;
      return this;
    }

    // Add methods to `Stack`.
    Stack.prototype.clear = stackClear;
    Stack.prototype['delete'] = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;

    /*------------------------------------------------------------------------*/

    /**
     * Creates an array of the enumerable property names of the array-like `value`.
     *
     * @private
     * @param {*} value The value to query.
     * @param {boolean} inherited Specify returning inherited property names.
     * @returns {Array} Returns the array of property names.
     */
    function arrayLikeKeys(value, inherited) {
      var isArr = isArray(value),
          isArg = !isArr && isArguments(value),
          isBuff = !isArr && !isArg && isBuffer(value),
          isType = !isArr && !isArg && !isBuff && isTypedArray(value),
          skipIndexes = isArr || isArg || isBuff || isType,
          result = skipIndexes ? baseTimes(value.length, String) : [],
          length = result.length;

      for (var key in value) {
        if ((inherited || hasOwnProperty.call(value, key)) &&
            !(skipIndexes && (
               // Safari 9 has enumerable `arguments.length` in strict mode.
               key == 'length' ||
               // Node.js 0.10 has enumerable non-index properties on buffers.
               (isBuff && (key == 'offset' || key == 'parent')) ||
               // PhantomJS 2 has enumerable non-index properties on typed arrays.
               (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
               // Skip index properties.
               isIndex(key, length)
            ))) {
          result.push(key);
        }
      }
      return result;
    }

    /**
     * A specialized version of `_.sample` for arrays.
     *
     * @private
     * @param {Array} array The array to sample.
     * @returns {*} Returns the random element.
     */
    function arraySample(array) {
      var length = array.length;
      return length ? array[baseRandom(0, length - 1)] : undefined;
    }

    /**
     * A specialized version of `_.sampleSize` for arrays.
     *
     * @private
     * @param {Array} array The array to sample.
     * @param {number} n The number of elements to sample.
     * @returns {Array} Returns the random elements.
     */
    function arraySampleSize(array, n) {
      return shuffleSelf(copyArray(array), baseClamp(n, 0, array.length));
    }

    /**
     * A specialized version of `_.shuffle` for arrays.
     *
     * @private
     * @param {Array} array The array to shuffle.
     * @returns {Array} Returns the new shuffled array.
     */
    function arrayShuffle(array) {
      return shuffleSelf(copyArray(array));
    }

    /**
     * This function is like `assignValue` except that it doesn't assign
     * `undefined` values.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {string} key The key of the property to assign.
     * @param {*} value The value to assign.
     */
    function assignMergeValue(object, key, value) {
      if ((value !== undefined && !eq(object[key], value)) ||
          (value === undefined && !(key in object))) {
        baseAssignValue(object, key, value);
      }
    }

    /**
     * Assigns `value` to `key` of `object` if the existing value is not equivalent
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {string} key The key of the property to assign.
     * @param {*} value The value to assign.
     */
    function assignValue(object, key, value) {
      var objValue = object[key];
      if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
          (value === undefined && !(key in object))) {
        baseAssignValue(object, key, value);
      }
    }

    /**
     * Gets the index at which the `key` is found in `array` of key-value pairs.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {*} key The key to search for.
     * @returns {number} Returns the index of the matched value, else `-1`.
     */
    function assocIndexOf(array, key) {
      var length = array.length;
      while (length--) {
        if (eq(array[length][0], key)) {
          return length;
        }
      }
      return -1;
    }

    /**
     * Aggregates elements of `collection` on `accumulator` with keys transformed
     * by `iteratee` and values set by `setter`.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} setter The function to set `accumulator` values.
     * @param {Function} iteratee The iteratee to transform keys.
     * @param {Object} accumulator The initial aggregated object.
     * @returns {Function} Returns `accumulator`.
     */
    function baseAggregator(collection, setter, iteratee, accumulator) {
      baseEach(collection, function(value, key, collection) {
        setter(accumulator, value, iteratee(value), collection);
      });
      return accumulator;
    }

    /**
     * The base implementation of `_.assign` without support for multiple sources
     * or `customizer` functions.
     *
     * @private
     * @param {Object} object The destination object.
     * @param {Object} source The source object.
     * @returns {Object} Returns `object`.
     */
    function baseAssign(object, source) {
      return object && copyObject(source, keys(source), object);
    }

    /**
     * The base implementation of `_.assignIn` without support for multiple sources
     * or `customizer` functions.
     *
     * @private
     * @param {Object} object The destination object.
     * @param {Object} source The source object.
     * @returns {Object} Returns `object`.
     */
    function baseAssignIn(object, source) {
      return object && copyObject(source, keysIn(source), object);
    }

    /**
     * The base implementation of `assignValue` and `assignMergeValue` without
     * value checks.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {string} key The key of the property to assign.
     * @param {*} value The value to assign.
     */
    function baseAssignValue(object, key, value) {
      if (key == '__proto__' && defineProperty) {
        defineProperty(object, key, {
          'configurable': true,
          'enumerable': true,
          'value': value,
          'writable': true
        });
      } else {
        object[key] = value;
      }
    }

    /**
     * The base implementation of `_.at` without support for individual paths.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {string[]} paths The property paths to pick.
     * @returns {Array} Returns the picked elements.
     */
    function baseAt(object, paths) {
      var index = -1,
          length = paths.length,
          result = Array(length),
          skip = object == null;

      while (++index < length) {
        result[index] = skip ? undefined : get(object, paths[index]);
      }
      return result;
    }

    /**
     * The base implementation of `_.clamp` which doesn't coerce arguments.
     *
     * @private
     * @param {number} number The number to clamp.
     * @param {number} [lower] The lower bound.
     * @param {number} upper The upper bound.
     * @returns {number} Returns the clamped number.
     */
    function baseClamp(number, lower, upper) {
      if (number === number) {
        if (upper !== undefined) {
          number = number <= upper ? number : upper;
        }
        if (lower !== undefined) {
          number = number >= lower ? number : lower;
        }
      }
      return number;
    }

    /**
     * The base implementation of `_.clone` and `_.cloneDeep` which tracks
     * traversed objects.
     *
     * @private
     * @param {*} value The value to clone.
     * @param {boolean} bitmask The bitmask flags.
     *  1 - Deep clone
     *  2 - Flatten inherited properties
     *  4 - Clone symbols
     * @param {Function} [customizer] The function to customize cloning.
     * @param {string} [key] The key of `value`.
     * @param {Object} [object] The parent object of `value`.
     * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
     * @returns {*} Returns the cloned value.
     */
    function baseClone(value, bitmask, customizer, key, object, stack) {
      var result,
          isDeep = bitmask & CLONE_DEEP_FLAG,
          isFlat = bitmask & CLONE_FLAT_FLAG,
          isFull = bitmask & CLONE_SYMBOLS_FLAG;

      if (customizer) {
        result = object ? customizer(value, key, object, stack) : customizer(value);
      }
      if (result !== undefined) {
        return result;
      }
      if (!isObject(value)) {
        return value;
      }
      var isArr = isArray(value);
      if (isArr) {
        result = initCloneArray(value);
        if (!isDeep) {
          return copyArray(value, result);
        }
      } else {
        var tag = getTag(value),
            isFunc = tag == funcTag || tag == genTag;

        if (isBuffer(value)) {
          return cloneBuffer(value, isDeep);
        }
        if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
          result = (isFlat || isFunc) ? {} : initCloneObject(value);
          if (!isDeep) {
            return isFlat
              ? copySymbolsIn(value, baseAssignIn(result, value))
              : copySymbols(value, baseAssign(result, value));
          }
        } else {
          if (!cloneableTags[tag]) {
            return object ? value : {};
          }
          result = initCloneByTag(value, tag, isDeep);
        }
      }
      // Check for circular references and return its corresponding clone.
      stack || (stack = new Stack);
      var stacked = stack.get(value);
      if (stacked) {
        return stacked;
      }
      stack.set(value, result);

      if (isSet(value)) {
        value.forEach(function(subValue) {
          result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
        });
      } else if (isMap(value)) {
        value.forEach(function(subValue, key) {
          result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
        });
      }

      var keysFunc = isFull
        ? (isFlat ? getAllKeysIn : getAllKeys)
        : (isFlat ? keysIn : keys);

      var props = isArr ? undefined : keysFunc(value);
      arrayEach(props || value, function(subValue, key) {
        if (props) {
          key = subValue;
          subValue = value[key];
        }
        // Recursively populate clone (susceptible to call stack limits).
        assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
      });
      return result;
    }

    /**
     * The base implementation of `_.conforms` which doesn't clone `source`.
     *
     * @private
     * @param {Object} source The object of property predicates to conform to.
     * @returns {Function} Returns the new spec function.
     */
    function baseConforms(source) {
      var props = keys(source);
      return function(object) {
        return baseConformsTo(object, source, props);
      };
    }

    /**
     * The base implementation of `_.conformsTo` which accepts `props` to check.
     *
     * @private
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property predicates to conform to.
     * @returns {boolean} Returns `true` if `object` conforms, else `false`.
     */
    function baseConformsTo(object, source, props) {
      var length = props.length;
      if (object == null) {
        return !length;
      }
      object = Object(object);
      while (length--) {
        var key = props[length],
            predicate = source[key],
            value = object[key];

        if ((value === undefined && !(key in object)) || !predicate(value)) {
          return false;
        }
      }
      return true;
    }

    /**
     * The base implementation of `_.delay` and `_.defer` which accepts `args`
     * to provide to `func`.
     *
     * @private
     * @param {Function} func The function to delay.
     * @param {number} wait The number of milliseconds to delay invocation.
     * @param {Array} args The arguments to provide to `func`.
     * @returns {number|Object} Returns the timer id or timeout object.
     */
    function baseDelay(func, wait, args) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      return setTimeout(function() { func.apply(undefined, args); }, wait);
    }

    /**
     * The base implementation of methods like `_.difference` without support
     * for excluding multiple arrays or iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {Array} values The values to exclude.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     */
    function baseDifference(array, values, iteratee, comparator) {
      var index = -1,
          includes = arrayIncludes,
          isCommon = true,
          length = array.length,
          result = [],
          valuesLength = values.length;

      if (!length) {
        return result;
      }
      if (iteratee) {
        values = arrayMap(values, baseUnary(iteratee));
      }
      if (comparator) {
        includes = arrayIncludesWith;
        isCommon = false;
      }
      else if (values.length >= LARGE_ARRAY_SIZE) {
        includes = cacheHas;
        isCommon = false;
        values = new SetCache(values);
      }
      outer:
      while (++index < length) {
        var value = array[index],
            computed = iteratee == null ? value : iteratee(value);

        value = (comparator || value !== 0) ? value : 0;
        if (isCommon && computed === computed) {
          var valuesIndex = valuesLength;
          while (valuesIndex--) {
            if (values[valuesIndex] === computed) {
              continue outer;
            }
          }
          result.push(value);
        }
        else if (!includes(values, computed, comparator)) {
          result.push(value);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.forEach` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     */
    var baseEach = createBaseEach(baseForOwn);

    /**
     * The base implementation of `_.forEachRight` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     */
    var baseEachRight = createBaseEach(baseForOwnRight, true);

    /**
     * The base implementation of `_.every` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} predicate The function invoked per iteration.
     * @returns {boolean} Returns `true` if all elements pass the predicate check,
     *  else `false`
     */
    function baseEvery(collection, predicate) {
      var result = true;
      baseEach(collection, function(value, index, collection) {
        result = !!predicate(value, index, collection);
        return result;
      });
      return result;
    }

    /**
     * The base implementation of methods like `_.max` and `_.min` which accepts a
     * `comparator` to determine the extremum value.
     *
     * @private
     * @param {Array} array The array to iterate over.
     * @param {Function} iteratee The iteratee invoked per iteration.
     * @param {Function} comparator The comparator used to compare values.
     * @returns {*} Returns the extremum value.
     */
    function baseExtremum(array, iteratee, comparator) {
      var index = -1,
          length = array.length;

      while (++index < length) {
        var value = array[index],
            current = iteratee(value);

        if (current != null && (computed === undefined
              ? (current === current && !isSymbol(current))
              : comparator(current, computed)
            )) {
          var computed = current,
              result = value;
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.fill` without an iteratee call guard.
     *
     * @private
     * @param {Array} array The array to fill.
     * @param {*} value The value to fill `array` with.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns `array`.
     */
    function baseFill(array, value, start, end) {
      var length = array.length;

      start = toInteger(start);
      if (start < 0) {
        start = -start > length ? 0 : (length + start);
      }
      end = (end === undefined || end > length) ? length : toInteger(end);
      if (end < 0) {
        end += length;
      }
      end = start > end ? 0 : toLength(end);
      while (start < end) {
        array[start++] = value;
      }
      return array;
    }

    /**
     * The base implementation of `_.filter` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} predicate The function invoked per iteration.
     * @returns {Array} Returns the new filtered array.
     */
    function baseFilter(collection, predicate) {
      var result = [];
      baseEach(collection, function(value, index, collection) {
        if (predicate(value, index, collection)) {
          result.push(value);
        }
      });
      return result;
    }

    /**
     * The base implementation of `_.flatten` with support for restricting flattening.
     *
     * @private
     * @param {Array} array The array to flatten.
     * @param {number} depth The maximum recursion depth.
     * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
     * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
     * @param {Array} [result=[]] The initial result value.
     * @returns {Array} Returns the new flattened array.
     */
    function baseFlatten(array, depth, predicate, isStrict, result) {
      var index = -1,
          length = array.length;

      predicate || (predicate = isFlattenable);
      result || (result = []);

      while (++index < length) {
        var value = array[index];
        if (depth > 0 && predicate(value)) {
          if (depth > 1) {
            // Recursively flatten arrays (susceptible to call stack limits).
            baseFlatten(value, depth - 1, predicate, isStrict, result);
          } else {
            arrayPush(result, value);
          }
        } else if (!isStrict) {
          result[result.length] = value;
        }
      }
      return result;
    }

    /**
     * The base implementation of `baseForOwn` which iterates over `object`
     * properties returned by `keysFunc` and invokes `iteratee` for each property.
     * Iteratee functions may exit iteration early by explicitly returning `false`.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @param {Function} keysFunc The function to get the keys of `object`.
     * @returns {Object} Returns `object`.
     */
    var baseFor = createBaseFor();

    /**
     * This function is like `baseFor` except that it iterates over properties
     * in the opposite order.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @param {Function} keysFunc The function to get the keys of `object`.
     * @returns {Object} Returns `object`.
     */
    var baseForRight = createBaseFor(true);

    /**
     * The base implementation of `_.forOwn` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Object} Returns `object`.
     */
    function baseForOwn(object, iteratee) {
      return object && baseFor(object, iteratee, keys);
    }

    /**
     * The base implementation of `_.forOwnRight` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Object} Returns `object`.
     */
    function baseForOwnRight(object, iteratee) {
      return object && baseForRight(object, iteratee, keys);
    }

    /**
     * The base implementation of `_.functions` which creates an array of
     * `object` function property names filtered from `props`.
     *
     * @private
     * @param {Object} object The object to inspect.
     * @param {Array} props The property names to filter.
     * @returns {Array} Returns the function names.
     */
    function baseFunctions(object, props) {
      return arrayFilter(props, function(key) {
        return isFunction(object[key]);
      });
    }

    /**
     * The base implementation of `_.get` without support for default values.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the property to get.
     * @returns {*} Returns the resolved value.
     */
    function baseGet(object, path) {
      path = castPath(path, object);

      var index = 0,
          length = path.length;

      while (object != null && index < length) {
        object = object[toKey(path[index++])];
      }
      return (index && index == length) ? object : undefined;
    }

    /**
     * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
     * `keysFunc` and `symbolsFunc` to get the enumerable property names and
     * symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Function} keysFunc The function to get the keys of `object`.
     * @param {Function} symbolsFunc The function to get the symbols of `object`.
     * @returns {Array} Returns the array of property names and symbols.
     */
    function baseGetAllKeys(object, keysFunc, symbolsFunc) {
      var result = keysFunc(object);
      return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
    }

    /**
     * The base implementation of `getTag` without fallbacks for buggy environments.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the `toStringTag`.
     */
    function baseGetTag(value) {
      if (value == null) {
        return value === undefined ? undefinedTag : nullTag;
      }
      return (symToStringTag && symToStringTag in Object(value))
        ? getRawTag(value)
        : objectToString(value);
    }

    /**
     * The base implementation of `_.gt` which doesn't coerce arguments.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is greater than `other`,
     *  else `false`.
     */
    function baseGt(value, other) {
      return value > other;
    }

    /**
     * The base implementation of `_.has` without support for deep paths.
     *
     * @private
     * @param {Object} [object] The object to query.
     * @param {Array|string} key The key to check.
     * @returns {boolean} Returns `true` if `key` exists, else `false`.
     */
    function baseHas(object, key) {
      return object != null && hasOwnProperty.call(object, key);
    }

    /**
     * The base implementation of `_.hasIn` without support for deep paths.
     *
     * @private
     * @param {Object} [object] The object to query.
     * @param {Array|string} key The key to check.
     * @returns {boolean} Returns `true` if `key` exists, else `false`.
     */
    function baseHasIn(object, key) {
      return object != null && key in Object(object);
    }

    /**
     * The base implementation of `_.inRange` which doesn't coerce arguments.
     *
     * @private
     * @param {number} number The number to check.
     * @param {number} start The start of the range.
     * @param {number} end The end of the range.
     * @returns {boolean} Returns `true` if `number` is in the range, else `false`.
     */
    function baseInRange(number, start, end) {
      return number >= nativeMin(start, end) && number < nativeMax(start, end);
    }

    /**
     * The base implementation of methods like `_.intersection`, without support
     * for iteratee shorthands, that accepts an array of arrays to inspect.
     *
     * @private
     * @param {Array} arrays The arrays to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of shared values.
     */
    function baseIntersection(arrays, iteratee, comparator) {
      var includes = comparator ? arrayIncludesWith : arrayIncludes,
          length = arrays[0].length,
          othLength = arrays.length,
          othIndex = othLength,
          caches = Array(othLength),
          maxLength = Infinity,
          result = [];

      while (othIndex--) {
        var array = arrays[othIndex];
        if (othIndex && iteratee) {
          array = arrayMap(array, baseUnary(iteratee));
        }
        maxLength = nativeMin(array.length, maxLength);
        caches[othIndex] = !comparator && (iteratee || (length >= 120 && array.length >= 120))
          ? new SetCache(othIndex && array)
          : undefined;
      }
      array = arrays[0];

      var index = -1,
          seen = caches[0];

      outer:
      while (++index < length && result.length < maxLength) {
        var value = array[index],
            computed = iteratee ? iteratee(value) : value;

        value = (comparator || value !== 0) ? value : 0;
        if (!(seen
              ? cacheHas(seen, computed)
              : includes(result, computed, comparator)
            )) {
          othIndex = othLength;
          while (--othIndex) {
            var cache = caches[othIndex];
            if (!(cache
                  ? cacheHas(cache, computed)
                  : includes(arrays[othIndex], computed, comparator))
                ) {
              continue outer;
            }
          }
          if (seen) {
            seen.push(computed);
          }
          result.push(value);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.invert` and `_.invertBy` which inverts
     * `object` with values transformed by `iteratee` and set by `setter`.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} setter The function to set `accumulator` values.
     * @param {Function} iteratee The iteratee to transform values.
     * @param {Object} accumulator The initial inverted object.
     * @returns {Function} Returns `accumulator`.
     */
    function baseInverter(object, setter, iteratee, accumulator) {
      baseForOwn(object, function(value, key, object) {
        setter(accumulator, iteratee(value), key, object);
      });
      return accumulator;
    }

    /**
     * The base implementation of `_.invoke` without support for individual
     * method arguments.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the method to invoke.
     * @param {Array} args The arguments to invoke the method with.
     * @returns {*} Returns the result of the invoked method.
     */
    function baseInvoke(object, path, args) {
      path = castPath(path, object);
      object = parent(object, path);
      var func = object == null ? object : object[toKey(last(path))];
      return func == null ? undefined : apply(func, object, args);
    }

    /**
     * The base implementation of `_.isArguments`.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an `arguments` object,
     */
    function baseIsArguments(value) {
      return isObjectLike(value) && baseGetTag(value) == argsTag;
    }

    /**
     * The base implementation of `_.isArrayBuffer` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array buffer, else `false`.
     */
    function baseIsArrayBuffer(value) {
      return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;
    }

    /**
     * The base implementation of `_.isDate` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a date object, else `false`.
     */
    function baseIsDate(value) {
      return isObjectLike(value) && baseGetTag(value) == dateTag;
    }

    /**
     * The base implementation of `_.isEqual` which supports partial comparisons
     * and tracks traversed objects.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @param {boolean} bitmask The bitmask flags.
     *  1 - Unordered comparison
     *  2 - Partial comparison
     * @param {Function} [customizer] The function to customize comparisons.
     * @param {Object} [stack] Tracks traversed `value` and `other` objects.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     */
    function baseIsEqual(value, other, bitmask, customizer, stack) {
      if (value === other) {
        return true;
      }
      if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
        return value !== value && other !== other;
      }
      return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
    }

    /**
     * A specialized version of `baseIsEqual` for arrays and objects which performs
     * deep comparisons and tracks traversed objects enabling objects with circular
     * references to be compared.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
     * @param {Function} customizer The function to customize comparisons.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Object} [stack] Tracks traversed `object` and `other` objects.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
      var objIsArr = isArray(object),
          othIsArr = isArray(other),
          objTag = objIsArr ? arrayTag : getTag(object),
          othTag = othIsArr ? arrayTag : getTag(other);

      objTag = objTag == argsTag ? objectTag : objTag;
      othTag = othTag == argsTag ? objectTag : othTag;

      var objIsObj = objTag == objectTag,
          othIsObj = othTag == objectTag,
          isSameTag = objTag == othTag;

      if (isSameTag && isBuffer(object)) {
        if (!isBuffer(other)) {
          return false;
        }
        objIsArr = true;
        objIsObj = false;
      }
      if (isSameTag && !objIsObj) {
        stack || (stack = new Stack);
        return (objIsArr || isTypedArray(object))
          ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
          : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
      }
      if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
        var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
            othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object.value() : object,
              othUnwrapped = othIsWrapped ? other.value() : other;

          stack || (stack = new Stack);
          return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
        }
      }
      if (!isSameTag) {
        return false;
      }
      stack || (stack = new Stack);
      return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
    }

    /**
     * The base implementation of `_.isMap` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a map, else `false`.
     */
    function baseIsMap(value) {
      return isObjectLike(value) && getTag(value) == mapTag;
    }

    /**
     * The base implementation of `_.isMatch` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property values to match.
     * @param {Array} matchData The property names, values, and compare flags to match.
     * @param {Function} [customizer] The function to customize comparisons.
     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
     */
    function baseIsMatch(object, source, matchData, customizer) {
      var index = matchData.length,
          length = index,
          noCustomizer = !customizer;

      if (object == null) {
        return !length;
      }
      object = Object(object);
      while (index--) {
        var data = matchData[index];
        if ((noCustomizer && data[2])
              ? data[1] !== object[data[0]]
              : !(data[0] in object)
            ) {
          return false;
        }
      }
      while (++index < length) {
        data = matchData[index];
        var key = data[0],
            objValue = object[key],
            srcValue = data[1];

        if (noCustomizer && data[2]) {
          if (objValue === undefined && !(key in object)) {
            return false;
          }
        } else {
          var stack = new Stack;
          if (customizer) {
            var result = customizer(objValue, srcValue, key, object, source, stack);
          }
          if (!(result === undefined
                ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack)
                : result
              )) {
            return false;
          }
        }
      }
      return true;
    }

    /**
     * The base implementation of `_.isNative` without bad shim checks.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a native function,
     *  else `false`.
     */
    function baseIsNative(value) {
      if (!isObject(value) || isMasked(value)) {
        return false;
      }
      var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }

    /**
     * The base implementation of `_.isRegExp` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.
     */
    function baseIsRegExp(value) {
      return isObjectLike(value) && baseGetTag(value) == regexpTag;
    }

    /**
     * The base implementation of `_.isSet` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a set, else `false`.
     */
    function baseIsSet(value) {
      return isObjectLike(value) && getTag(value) == setTag;
    }

    /**
     * The base implementation of `_.isTypedArray` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
     */
    function baseIsTypedArray(value) {
      return isObjectLike(value) &&
        isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
    }

    /**
     * The base implementation of `_.iteratee`.
     *
     * @private
     * @param {*} [value=_.identity] The value to convert to an iteratee.
     * @returns {Function} Returns the iteratee.
     */
    function baseIteratee(value) {
      // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
      // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
      if (typeof value == 'function') {
        return value;
      }
      if (value == null) {
        return identity;
      }
      if (typeof value == 'object') {
        return isArray(value)
          ? baseMatchesProperty(value[0], value[1])
          : baseMatches(value);
      }
      return property(value);
    }

    /**
     * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     */
    function baseKeys(object) {
      if (!isPrototype(object)) {
        return nativeKeys(object);
      }
      var result = [];
      for (var key in Object(object)) {
        if (hasOwnProperty.call(object, key) && key != 'constructor') {
          result.push(key);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     */
    function baseKeysIn(object) {
      if (!isObject(object)) {
        return nativeKeysIn(object);
      }
      var isProto = isPrototype(object),
          result = [];

      for (var key in object) {
        if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
          result.push(key);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.lt` which doesn't coerce arguments.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is less than `other`,
     *  else `false`.
     */
    function baseLt(value, other) {
      return value < other;
    }

    /**
     * The base implementation of `_.map` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array} Returns the new mapped array.
     */
    function baseMap(collection, iteratee) {
      var index = -1,
          result = isArrayLike(collection) ? Array(collection.length) : [];

      baseEach(collection, function(value, key, collection) {
        result[++index] = iteratee(value, key, collection);
      });
      return result;
    }

    /**
     * The base implementation of `_.matches` which doesn't clone `source`.
     *
     * @private
     * @param {Object} source The object of property values to match.
     * @returns {Function} Returns the new spec function.
     */
    function baseMatches(source) {
      var matchData = getMatchData(source);
      if (matchData.length == 1 && matchData[0][2]) {
        return matchesStrictComparable(matchData[0][0], matchData[0][1]);
      }
      return function(object) {
        return object === source || baseIsMatch(object, source, matchData);
      };
    }

    /**
     * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
     *
     * @private
     * @param {string} path The path of the property to get.
     * @param {*} srcValue The value to match.
     * @returns {Function} Returns the new spec function.
     */
    function baseMatchesProperty(path, srcValue) {
      if (isKey(path) && isStrictComparable(srcValue)) {
        return matchesStrictComparable(toKey(path), srcValue);
      }
      return function(object) {
        var objValue = get(object, path);
        return (objValue === undefined && objValue === srcValue)
          ? hasIn(object, path)
          : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
      };
    }

    /**
     * The base implementation of `_.merge` without support for multiple sources.
     *
     * @private
     * @param {Object} object The destination object.
     * @param {Object} source The source object.
     * @param {number} srcIndex The index of `source`.
     * @param {Function} [customizer] The function to customize merged values.
     * @param {Object} [stack] Tracks traversed source values and their merged
     *  counterparts.
     */
    function baseMerge(object, source, srcIndex, customizer, stack) {
      if (object === source) {
        return;
      }
      baseFor(source, function(srcValue, key) {
        stack || (stack = new Stack);
        if (isObject(srcValue)) {
          baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
        }
        else {
          var newValue = customizer
            ? customizer(safeGet(object, key), srcValue, (key + ''), object, source, stack)
            : undefined;

          if (newValue === undefined) {
            newValue = srcValue;
          }
          assignMergeValue(object, key, newValue);
        }
      }, keysIn);
    }

    /**
     * A specialized version of `baseMerge` for arrays and objects which performs
     * deep merges and tracks traversed objects enabling objects with circular
     * references to be merged.
     *
     * @private
     * @param {Object} object The destination object.
     * @param {Object} source The source object.
     * @param {string} key The key of the value to merge.
     * @param {number} srcIndex The index of `source`.
     * @param {Function} mergeFunc The function to merge values.
     * @param {Function} [customizer] The function to customize assigned values.
     * @param {Object} [stack] Tracks traversed source values and their merged
     *  counterparts.
     */
    function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
      var objValue = safeGet(object, key),
          srcValue = safeGet(source, key),
          stacked = stack.get(srcValue);

      if (stacked) {
        assignMergeValue(object, key, stacked);
        return;
      }
      var newValue = customizer
        ? customizer(objValue, srcValue, (key + ''), object, source, stack)
        : undefined;

      var isCommon = newValue === undefined;

      if (isCommon) {
        var isArr = isArray(srcValue),
            isBuff = !isArr && isBuffer(srcValue),
            isTyped = !isArr && !isBuff && isTypedArray(srcValue);

        newValue = srcValue;
        if (isArr || isBuff || isTyped) {
          if (isArray(objValue)) {
            newValue = objValue;
          }
          else if (isArrayLikeObject(objValue)) {
            newValue = copyArray(objValue);
          }
          else if (isBuff) {
            isCommon = false;
            newValue = cloneBuffer(srcValue, true);
          }
          else if (isTyped) {
            isCommon = false;
            newValue = cloneTypedArray(srcValue, true);
          }
          else {
            newValue = [];
          }
        }
        else if (isPlainObject(srcValue) || isArguments(srcValue)) {
          newValue = objValue;
          if (isArguments(objValue)) {
            newValue = toPlainObject(objValue);
          }
          else if (!isObject(objValue) || isFunction(objValue)) {
            newValue = initCloneObject(srcValue);
          }
        }
        else {
          isCommon = false;
        }
      }
      if (isCommon) {
        // Recursively merge objects and arrays (susceptible to call stack limits).
        stack.set(srcValue, newValue);
        mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
        stack['delete'](srcValue);
      }
      assignMergeValue(object, key, newValue);
    }

    /**
     * The base implementation of `_.nth` which doesn't coerce arguments.
     *
     * @private
     * @param {Array} array The array to query.
     * @param {number} n The index of the element to return.
     * @returns {*} Returns the nth element of `array`.
     */
    function baseNth(array, n) {
      var length = array.length;
      if (!length) {
        return;
      }
      n += n < 0 ? length : 0;
      return isIndex(n, length) ? array[n] : undefined;
    }

    /**
     * The base implementation of `_.orderBy` without param guards.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function[]|Object[]|string[]} iteratees The iteratees to sort by.
     * @param {string[]} orders The sort orders of `iteratees`.
     * @returns {Array} Returns the new sorted array.
     */
    function baseOrderBy(collection, iteratees, orders) {
      if (iteratees.length) {
        iteratees = arrayMap(iteratees, function(iteratee) {
          if (isArray(iteratee)) {
            return function(value) {
              return baseGet(value, iteratee.length === 1 ? iteratee[0] : iteratee);
            }
          }
          return iteratee;
        });
      } else {
        iteratees = [identity];
      }

      var index = -1;
      iteratees = arrayMap(iteratees, baseUnary(getIteratee()));

      var result = baseMap(collection, function(value, key, collection) {
        var criteria = arrayMap(iteratees, function(iteratee) {
          return iteratee(value);
        });
        return { 'criteria': criteria, 'index': ++index, 'value': value };
      });

      return baseSortBy(result, function(object, other) {
        return compareMultiple(object, other, orders);
      });
    }

    /**
     * The base implementation of `_.pick` without support for individual
     * property identifiers.
     *
     * @private
     * @param {Object} object The source object.
     * @param {string[]} paths The property paths to pick.
     * @returns {Object} Returns the new object.
     */
    function basePick(object, paths) {
      return basePickBy(object, paths, function(value, path) {
        return hasIn(object, path);
      });
    }

    /**
     * The base implementation of  `_.pickBy` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The source object.
     * @param {string[]} paths The property paths to pick.
     * @param {Function} predicate The function invoked per property.
     * @returns {Object} Returns the new object.
     */
    function basePickBy(object, paths, predicate) {
      var index = -1,
          length = paths.length,
          result = {};

      while (++index < length) {
        var path = paths[index],
            value = baseGet(object, path);

        if (predicate(value, path)) {
          baseSet(result, castPath(path, object), value);
        }
      }
      return result;
    }

    /**
     * A specialized version of `baseProperty` which supports deep paths.
     *
     * @private
     * @param {Array|string} path The path of the property to get.
     * @returns {Function} Returns the new accessor function.
     */
    function basePropertyDeep(path) {
      return function(object) {
        return baseGet(object, path);
      };
    }

    /**
     * The base implementation of `_.pullAllBy` without support for iteratee
     * shorthands.
     *
     * @private
     * @param {Array} array The array to modify.
     * @param {Array} values The values to remove.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns `array`.
     */
    function basePullAll(array, values, iteratee, comparator) {
      var indexOf = comparator ? baseIndexOfWith : baseIndexOf,
          index = -1,
          length = values.length,
          seen = array;

      if (array === values) {
        values = copyArray(values);
      }
      if (iteratee) {
        seen = arrayMap(array, baseUnary(iteratee));
      }
      while (++index < length) {
        var fromIndex = 0,
            value = values[index],
            computed = iteratee ? iteratee(value) : value;

        while ((fromIndex = indexOf(seen, computed, fromIndex, comparator)) > -1) {
          if (seen !== array) {
            splice.call(seen, fromIndex, 1);
          }
          splice.call(array, fromIndex, 1);
        }
      }
      return array;
    }

    /**
     * The base implementation of `_.pullAt` without support for individual
     * indexes or capturing the removed elements.
     *
     * @private
     * @param {Array} array The array to modify.
     * @param {number[]} indexes The indexes of elements to remove.
     * @returns {Array} Returns `array`.
     */
    function basePullAt(array, indexes) {
      var length = array ? indexes.length : 0,
          lastIndex = length - 1;

      while (length--) {
        var index = indexes[length];
        if (length == lastIndex || index !== previous) {
          var previous = index;
          if (isIndex(index)) {
            splice.call(array, index, 1);
          } else {
            baseUnset(array, index);
          }
        }
      }
      return array;
    }

    /**
     * The base implementation of `_.random` without support for returning
     * floating-point numbers.
     *
     * @private
     * @param {number} lower The lower bound.
     * @param {number} upper The upper bound.
     * @returns {number} Returns the random number.
     */
    function baseRandom(lower, upper) {
      return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
    }

    /**
     * The base implementation of `_.range` and `_.rangeRight` which doesn't
     * coerce arguments.
     *
     * @private
     * @param {number} start The start of the range.
     * @param {number} end The end of the range.
     * @param {number} step The value to increment or decrement by.
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Array} Returns the range of numbers.
     */
    function baseRange(start, end, step, fromRight) {
      var index = -1,
          length = nativeMax(nativeCeil((end - start) / (step || 1)), 0),
          result = Array(length);

      while (length--) {
        result[fromRight ? length : ++index] = start;
        start += step;
      }
      return result;
    }

    /**
     * The base implementation of `_.repeat` which doesn't coerce arguments.
     *
     * @private
     * @param {string} string The string to repeat.
     * @param {number} n The number of times to repeat the string.
     * @returns {string} Returns the repeated string.
     */
    function baseRepeat(string, n) {
      var result = '';
      if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
        return result;
      }
      // Leverage the exponentiation by squaring algorithm for a faster repeat.
      // See https://en.wikipedia.org/wiki/Exponentiation_by_squaring for more details.
      do {
        if (n % 2) {
          result += string;
        }
        n = nativeFloor(n / 2);
        if (n) {
          string += string;
        }
      } while (n);

      return result;
    }

    /**
     * The base implementation of `_.rest` which doesn't validate or coerce arguments.
     *
     * @private
     * @param {Function} func The function to apply a rest parameter to.
     * @param {number} [start=func.length-1] The start position of the rest parameter.
     * @returns {Function} Returns the new function.
     */
    function baseRest(func, start) {
      return setToString(overRest(func, start, identity), func + '');
    }

    /**
     * The base implementation of `_.sample`.
     *
     * @private
     * @param {Array|Object} collection The collection to sample.
     * @returns {*} Returns the random element.
     */
    function baseSample(collection) {
      return arraySample(values(collection));
    }

    /**
     * The base implementation of `_.sampleSize` without param guards.
     *
     * @private
     * @param {Array|Object} collection The collection to sample.
     * @param {number} n The number of elements to sample.
     * @returns {Array} Returns the random elements.
     */
    function baseSampleSize(collection, n) {
      var array = values(collection);
      return shuffleSelf(array, baseClamp(n, 0, array.length));
    }

    /**
     * The base implementation of `_.set`.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {*} value The value to set.
     * @param {Function} [customizer] The function to customize path creation.
     * @returns {Object} Returns `object`.
     */
    function baseSet(object, path, value, customizer) {
      if (!isObject(object)) {
        return object;
      }
      path = castPath(path, object);

      var index = -1,
          length = path.length,
          lastIndex = length - 1,
          nested = object;

      while (nested != null && ++index < length) {
        var key = toKey(path[index]),
            newValue = value;

        if (key === '__proto__' || key === 'constructor' || key === 'prototype') {
          return object;
        }

        if (index != lastIndex) {
          var objValue = nested[key];
          newValue = customizer ? customizer(objValue, key, nested) : undefined;
          if (newValue === undefined) {
            newValue = isObject(objValue)
              ? objValue
              : (isIndex(path[index + 1]) ? [] : {});
          }
        }
        assignValue(nested, key, newValue);
        nested = nested[key];
      }
      return object;
    }

    /**
     * The base implementation of `setData` without support for hot loop shorting.
     *
     * @private
     * @param {Function} func The function to associate metadata with.
     * @param {*} data The metadata.
     * @returns {Function} Returns `func`.
     */
    var baseSetData = !metaMap ? identity : function(func, data) {
      metaMap.set(func, data);
      return func;
    };

    /**
     * The base implementation of `setToString` without support for hot loop shorting.
     *
     * @private
     * @param {Function} func The function to modify.
     * @param {Function} string The `toString` result.
     * @returns {Function} Returns `func`.
     */
    var baseSetToString = !defineProperty ? identity : function(func, string) {
      return defineProperty(func, 'toString', {
        'configurable': true,
        'enumerable': false,
        'value': constant(string),
        'writable': true
      });
    };

    /**
     * The base implementation of `_.shuffle`.
     *
     * @private
     * @param {Array|Object} collection The collection to shuffle.
     * @returns {Array} Returns the new shuffled array.
     */
    function baseShuffle(collection) {
      return shuffleSelf(values(collection));
    }

    /**
     * The base implementation of `_.slice` without an iteratee call guard.
     *
     * @private
     * @param {Array} array The array to slice.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns the slice of `array`.
     */
    function baseSlice(array, start, end) {
      var index = -1,
          length = array.length;

      if (start < 0) {
        start = -start > length ? 0 : (length + start);
      }
      end = end > length ? length : end;
      if (end < 0) {
        end += length;
      }
      length = start > end ? 0 : ((end - start) >>> 0);
      start >>>= 0;

      var result = Array(length);
      while (++index < length) {
        result[index] = array[index + start];
      }
      return result;
    }

    /**
     * The base implementation of `_.some` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} predicate The function invoked per iteration.
     * @returns {boolean} Returns `true` if any element passes the predicate check,
     *  else `false`.
     */
    function baseSome(collection, predicate) {
      var result;

      baseEach(collection, function(value, index, collection) {
        result = predicate(value, index, collection);
        return !result;
      });
      return !!result;
    }

    /**
     * The base implementation of `_.sortedIndex` and `_.sortedLastIndex` which
     * performs a binary search of `array` to determine the index at which `value`
     * should be inserted into `array` in order to maintain its sort order.
     *
     * @private
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @param {boolean} [retHighest] Specify returning the highest qualified index.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     */
    function baseSortedIndex(array, value, retHighest) {
      var low = 0,
          high = array == null ? low : array.length;

      if (typeof value == 'number' && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
        while (low < high) {
          var mid = (low + high) >>> 1,
              computed = array[mid];

          if (computed !== null && !isSymbol(computed) &&
              (retHighest ? (computed <= value) : (computed < value))) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return high;
      }
      return baseSortedIndexBy(array, value, identity, retHighest);
    }

    /**
     * The base implementation of `_.sortedIndexBy` and `_.sortedLastIndexBy`
     * which invokes `iteratee` for `value` and each element of `array` to compute
     * their sort ranking. The iteratee is invoked with one argument; (value).
     *
     * @private
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @param {Function} iteratee The iteratee invoked per element.
     * @param {boolean} [retHighest] Specify returning the highest qualified index.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     */
    function baseSortedIndexBy(array, value, iteratee, retHighest) {
      var low = 0,
          high = array == null ? 0 : array.length;
      if (high === 0) {
        return 0;
      }

      value = iteratee(value);
      var valIsNaN = value !== value,
          valIsNull = value === null,
          valIsSymbol = isSymbol(value),
          valIsUndefined = value === undefined;

      while (low < high) {
        var mid = nativeFloor((low + high) / 2),
            computed = iteratee(array[mid]),
            othIsDefined = computed !== undefined,
            othIsNull = computed === null,
            othIsReflexive = computed === computed,
            othIsSymbol = isSymbol(computed);

        if (valIsNaN) {
          var setLow = retHighest || othIsReflexive;
        } else if (valIsUndefined) {
          setLow = othIsReflexive && (retHighest || othIsDefined);
        } else if (valIsNull) {
          setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
        } else if (valIsSymbol) {
          setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
        } else if (othIsNull || othIsSymbol) {
          setLow = false;
        } else {
          setLow = retHighest ? (computed <= value) : (computed < value);
        }
        if (setLow) {
          low = mid + 1;
        } else {
          high = mid;
        }
      }
      return nativeMin(high, MAX_ARRAY_INDEX);
    }

    /**
     * The base implementation of `_.sortedUniq` and `_.sortedUniqBy` without
     * support for iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     */
    function baseSortedUniq(array, iteratee) {
      var index = -1,
          length = array.length,
          resIndex = 0,
          result = [];

      while (++index < length) {
        var value = array[index],
            computed = iteratee ? iteratee(value) : value;

        if (!index || !eq(computed, seen)) {
          var seen = computed;
          result[resIndex++] = value === 0 ? 0 : value;
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.toNumber` which doesn't ensure correct
     * conversions of binary, hexadecimal, or octal string values.
     *
     * @private
     * @param {*} value The value to process.
     * @returns {number} Returns the number.
     */
    function baseToNumber(value) {
      if (typeof value == 'number') {
        return value;
      }
      if (isSymbol(value)) {
        return NAN;
      }
      return +value;
    }

    /**
     * The base implementation of `_.toString` which doesn't convert nullish
     * values to empty strings.
     *
     * @private
     * @param {*} value The value to process.
     * @returns {string} Returns the string.
     */
    function baseToString(value) {
      // Exit early for strings to avoid a performance hit in some environments.
      if (typeof value == 'string') {
        return value;
      }
      if (isArray(value)) {
        // Recursively convert values (susceptible to call stack limits).
        return arrayMap(value, baseToString) + '';
      }
      if (isSymbol(value)) {
        return symbolToString ? symbolToString.call(value) : '';
      }
      var result = (value + '');
      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
    }

    /**
     * The base implementation of `_.uniqBy` without support for iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     */
    function baseUniq(array, iteratee, comparator) {
      var index = -1,
          includes = arrayIncludes,
          length = array.length,
          isCommon = true,
          result = [],
          seen = result;

      if (comparator) {
        isCommon = false;
        includes = arrayIncludesWith;
      }
      else if (length >= LARGE_ARRAY_SIZE) {
        var set = iteratee ? null : createSet(array);
        if (set) {
          return setToArray(set);
        }
        isCommon = false;
        includes = cacheHas;
        seen = new SetCache;
      }
      else {
        seen = iteratee ? [] : result;
      }
      outer:
      while (++index < length) {
        var value = array[index],
            computed = iteratee ? iteratee(value) : value;

        value = (comparator || value !== 0) ? value : 0;
        if (isCommon && computed === computed) {
          var seenIndex = seen.length;
          while (seenIndex--) {
            if (seen[seenIndex] === computed) {
              continue outer;
            }
          }
          if (iteratee) {
            seen.push(computed);
          }
          result.push(value);
        }
        else if (!includes(seen, computed, comparator)) {
          if (seen !== result) {
            seen.push(computed);
          }
          result.push(value);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.unset`.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {Array|string} path The property path to unset.
     * @returns {boolean} Returns `true` if the property is deleted, else `false`.
     */
    function baseUnset(object, path) {
      path = castPath(path, object);
      object = parent(object, path);
      return object == null || delete object[toKey(last(path))];
    }

    /**
     * The base implementation of `_.update`.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to update.
     * @param {Function} updater The function to produce the updated value.
     * @param {Function} [customizer] The function to customize path creation.
     * @returns {Object} Returns `object`.
     */
    function baseUpdate(object, path, updater, customizer) {
      return baseSet(object, path, updater(baseGet(object, path)), customizer);
    }

    /**
     * The base implementation of methods like `_.dropWhile` and `_.takeWhile`
     * without support for iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to query.
     * @param {Function} predicate The function invoked per iteration.
     * @param {boolean} [isDrop] Specify dropping elements instead of taking them.
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Array} Returns the slice of `array`.
     */
    function baseWhile(array, predicate, isDrop, fromRight) {
      var length = array.length,
          index = fromRight ? length : -1;

      while ((fromRight ? index-- : ++index < length) &&
        predicate(array[index], index, array)) {}

      return isDrop
        ? baseSlice(array, (fromRight ? 0 : index), (fromRight ? index + 1 : length))
        : baseSlice(array, (fromRight ? index + 1 : 0), (fromRight ? length : index));
    }

    /**
     * The base implementation of `wrapperValue` which returns the result of
     * performing a sequence of actions on the unwrapped `value`, where each
     * successive action is supplied the return value of the previous.
     *
     * @private
     * @param {*} value The unwrapped value.
     * @param {Array} actions Actions to perform to resolve the unwrapped value.
     * @returns {*} Returns the resolved value.
     */
    function baseWrapperValue(value, actions) {
      var result = value;
      if (result instanceof LazyWrapper) {
        result = result.value();
      }
      return arrayReduce(actions, function(result, action) {
        return action.func.apply(action.thisArg, arrayPush([result], action.args));
      }, result);
    }

    /**
     * The base implementation of methods like `_.xor`, without support for
     * iteratee shorthands, that accepts an array of arrays to inspect.
     *
     * @private
     * @param {Array} arrays The arrays to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of values.
     */
    function baseXor(arrays, iteratee, comparator) {
      var length = arrays.length;
      if (length < 2) {
        return length ? baseUniq(arrays[0]) : [];
      }
      var index = -1,
          result = Array(length);

      while (++index < length) {
        var array = arrays[index],
            othIndex = -1;

        while (++othIndex < length) {
          if (othIndex != index) {
            result[index] = baseDifference(result[index] || array, arrays[othIndex], iteratee, comparator);
          }
        }
      }
      return baseUniq(baseFlatten(result, 1), iteratee, comparator);
    }

    /**
     * This base implementation of `_.zipObject` which assigns values using `assignFunc`.
     *
     * @private
     * @param {Array} props The property identifiers.
     * @param {Array} values The property values.
     * @param {Function} assignFunc The function to assign values.
     * @returns {Object} Returns the new object.
     */
    function baseZipObject(props, values, assignFunc) {
      var index = -1,
          length = props.length,
          valsLength = values.length,
          result = {};

      while (++index < length) {
        var value = index < valsLength ? values[index] : undefined;
        assignFunc(result, props[index], value);
      }
      return result;
    }

    /**
     * Casts `value` to an empty array if it's not an array like object.
     *
     * @private
     * @param {*} value The value to inspect.
     * @returns {Array|Object} Returns the cast array-like object.
     */
    function castArrayLikeObject(value) {
      return isArrayLikeObject(value) ? value : [];
    }

    /**
     * Casts `value` to `identity` if it's not a function.
     *
     * @private
     * @param {*} value The value to inspect.
     * @returns {Function} Returns cast function.
     */
    function castFunction(value) {
      return typeof value == 'function' ? value : identity;
    }

    /**
     * Casts `value` to a path array if it's not one.
     *
     * @private
     * @param {*} value The value to inspect.
     * @param {Object} [object] The object to query keys on.
     * @returns {Array} Returns the cast property path array.
     */
    function castPath(value, object) {
      if (isArray(value)) {
        return value;
      }
      return isKey(value, object) ? [value] : stringToPath(toString(value));
    }

    /**
     * A `baseRest` alias which can be replaced with `identity` by module
     * replacement plugins.
     *
     * @private
     * @type {Function}
     * @param {Function} func The function to apply a rest parameter to.
     * @returns {Function} Returns the new function.
     */
    var castRest = baseRest;

    /**
     * Casts `array` to a slice if it's needed.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {number} start The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns the cast slice.
     */
    function castSlice(array, start, end) {
      var length = array.length;
      end = end === undefined ? length : end;
      return (!start && end >= length) ? array : baseSlice(array, start, end);
    }

    /**
     * A simple wrapper around the global [`clearTimeout`](https://mdn.io/clearTimeout).
     *
     * @private
     * @param {number|Object} id The timer id or timeout object of the timer to clear.
     */
    var clearTimeout = ctxClearTimeout || function(id) {
      return root.clearTimeout(id);
    };

    /**
     * Creates a clone of  `buffer`.
     *
     * @private
     * @param {Buffer} buffer The buffer to clone.
     * @param {boolean} [isDeep] Specify a deep clone.
     * @returns {Buffer} Returns the cloned buffer.
     */
    function cloneBuffer(buffer, isDeep) {
      if (isDeep) {
        return buffer.slice();
      }
      var length = buffer.length,
          result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

      buffer.copy(result);
      return result;
    }

    /**
     * Creates a clone of `arrayBuffer`.
     *
     * @private
     * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
     * @returns {ArrayBuffer} Returns the cloned array buffer.
     */
    function cloneArrayBuffer(arrayBuffer) {
      var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
      new Uint8Array(result).set(new Uint8Array(arrayBuffer));
      return result;
    }

    /**
     * Creates a clone of `dataView`.
     *
     * @private
     * @param {Object} dataView The data view to clone.
     * @param {boolean} [isDeep] Specify a deep clone.
     * @returns {Object} Returns the cloned data view.
     */
    function cloneDataView(dataView, isDeep) {
      var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
      return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
    }

    /**
     * Creates a clone of `regexp`.
     *
     * @private
     * @param {Object} regexp The regexp to clone.
     * @returns {Object} Returns the cloned regexp.
     */
    function cloneRegExp(regexp) {
      var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
      result.lastIndex = regexp.lastIndex;
      return result;
    }

    /**
     * Creates a clone of the `symbol` object.
     *
     * @private
     * @param {Object} symbol The symbol object to clone.
     * @returns {Object} Returns the cloned symbol object.
     */
    function cloneSymbol(symbol) {
      return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
    }

    /**
     * Creates a clone of `typedArray`.
     *
     * @private
     * @param {Object} typedArray The typed array to clone.
     * @param {boolean} [isDeep] Specify a deep clone.
     * @returns {Object} Returns the cloned typed array.
     */
    function cloneTypedArray(typedArray, isDeep) {
      var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
      return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
    }

    /**
     * Compares values to sort them in ascending order.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {number} Returns the sort order indicator for `value`.
     */
    function compareAscending(value, other) {
      if (value !== other) {
        var valIsDefined = value !== undefined,
            valIsNull = value === null,
            valIsReflexive = value === value,
            valIsSymbol = isSymbol(value);

        var othIsDefined = other !== undefined,
            othIsNull = other === null,
            othIsReflexive = other === other,
            othIsSymbol = isSymbol(other);

        if ((!othIsNull && !othIsSymbol && !valIsSymbol && value > other) ||
            (valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol) ||
            (valIsNull && othIsDefined && othIsReflexive) ||
            (!valIsDefined && othIsReflexive) ||
            !valIsReflexive) {
          return 1;
        }
        if ((!valIsNull && !valIsSymbol && !othIsSymbol && value < other) ||
            (othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol) ||
            (othIsNull && valIsDefined && valIsReflexive) ||
            (!othIsDefined && valIsReflexive) ||
            !othIsReflexive) {
          return -1;
        }
      }
      return 0;
    }

    /**
     * Used by `_.orderBy` to compare multiple properties of a value to another
     * and stable sort them.
     *
     * If `orders` is unspecified, all values are sorted in ascending order. Otherwise,
     * specify an order of "desc" for descending or "asc" for ascending sort order
     * of corresponding values.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {boolean[]|string[]} orders The order to sort by for each property.
     * @returns {number} Returns the sort order indicator for `object`.
     */
    function compareMultiple(object, other, orders) {
      var index = -1,
          objCriteria = object.criteria,
          othCriteria = other.criteria,
          length = objCriteria.length,
          ordersLength = orders.length;

      while (++index < length) {
        var result = compareAscending(objCriteria[index], othCriteria[index]);
        if (result) {
          if (index >= ordersLength) {
            return result;
          }
          var order = orders[index];
          return result * (order == 'desc' ? -1 : 1);
        }
      }
      // Fixes an `Array#sort` bug in the JS engine embedded in Adobe applications
      // that causes it, under certain circumstances, to provide the same value for
      // `object` and `other`. See https://github.com/jashkenas/underscore/pull/1247
      // for more details.
      //
      // This also ensures a stable sort in V8 and other engines.
      // See https://bugs.chromium.org/p/v8/issues/detail?id=90 for more details.
      return object.index - other.index;
    }

    /**
     * Creates an array that is the composition of partially applied arguments,
     * placeholders, and provided arguments into a single array of arguments.
     *
     * @private
     * @param {Array} args The provided arguments.
     * @param {Array} partials The arguments to prepend to those provided.
     * @param {Array} holders The `partials` placeholder indexes.
     * @params {boolean} [isCurried] Specify composing for a curried function.
     * @returns {Array} Returns the new array of composed arguments.
     */
    function composeArgs(args, partials, holders, isCurried) {
      var argsIndex = -1,
          argsLength = args.length,
          holdersLength = holders.length,
          leftIndex = -1,
          leftLength = partials.length,
          rangeLength = nativeMax(argsLength - holdersLength, 0),
          result = Array(leftLength + rangeLength),
          isUncurried = !isCurried;

      while (++leftIndex < leftLength) {
        result[leftIndex] = partials[leftIndex];
      }
      while (++argsIndex < holdersLength) {
        if (isUncurried || argsIndex < argsLength) {
          result[holders[argsIndex]] = args[argsIndex];
        }
      }
      while (rangeLength--) {
        result[leftIndex++] = args[argsIndex++];
      }
      return result;
    }

    /**
     * This function is like `composeArgs` except that the arguments composition
     * is tailored for `_.partialRight`.
     *
     * @private
     * @param {Array} args The provided arguments.
     * @param {Array} partials The arguments to append to those provided.
     * @param {Array} holders The `partials` placeholder indexes.
     * @params {boolean} [isCurried] Specify composing for a curried function.
     * @returns {Array} Returns the new array of composed arguments.
     */
    function composeArgsRight(args, partials, holders, isCurried) {
      var argsIndex = -1,
          argsLength = args.length,
          holdersIndex = -1,
          holdersLength = holders.length,
          rightIndex = -1,
          rightLength = partials.length,
          rangeLength = nativeMax(argsLength - holdersLength, 0),
          result = Array(rangeLength + rightLength),
          isUncurried = !isCurried;

      while (++argsIndex < rangeLength) {
        result[argsIndex] = args[argsIndex];
      }
      var offset = argsIndex;
      while (++rightIndex < rightLength) {
        result[offset + rightIndex] = partials[rightIndex];
      }
      while (++holdersIndex < holdersLength) {
        if (isUncurried || argsIndex < argsLength) {
          result[offset + holders[holdersIndex]] = args[argsIndex++];
        }
      }
      return result;
    }

    /**
     * Copies the values of `source` to `array`.
     *
     * @private
     * @param {Array} source The array to copy values from.
     * @param {Array} [array=[]] The array to copy values to.
     * @returns {Array} Returns `array`.
     */
    function copyArray(source, array) {
      var index = -1,
          length = source.length;

      array || (array = Array(length));
      while (++index < length) {
        array[index] = source[index];
      }
      return array;
    }

    /**
     * Copies properties of `source` to `object`.
     *
     * @private
     * @param {Object} source The object to copy properties from.
     * @param {Array} props The property identifiers to copy.
     * @param {Object} [object={}] The object to copy properties to.
     * @param {Function} [customizer] The function to customize copied values.
     * @returns {Object} Returns `object`.
     */
    function copyObject(source, props, object, customizer) {
      var isNew = !object;
      object || (object = {});

      var index = -1,
          length = props.length;

      while (++index < length) {
        var key = props[index];

        var newValue = customizer
          ? customizer(object[key], source[key], key, object, source)
          : undefined;

        if (newValue === undefined) {
          newValue = source[key];
        }
        if (isNew) {
          baseAssignValue(object, key, newValue);
        } else {
          assignValue(object, key, newValue);
        }
      }
      return object;
    }

    /**
     * Copies own symbols of `source` to `object`.
     *
     * @private
     * @param {Object} source The object to copy symbols from.
     * @param {Object} [object={}] The object to copy symbols to.
     * @returns {Object} Returns `object`.
     */
    function copySymbols(source, object) {
      return copyObject(source, getSymbols(source), object);
    }

    /**
     * Copies own and inherited symbols of `source` to `object`.
     *
     * @private
     * @param {Object} source The object to copy symbols from.
     * @param {Object} [object={}] The object to copy symbols to.
     * @returns {Object} Returns `object`.
     */
    function copySymbolsIn(source, object) {
      return copyObject(source, getSymbolsIn(source), object);
    }

    /**
     * Creates a function like `_.groupBy`.
     *
     * @private
     * @param {Function} setter The function to set accumulator values.
     * @param {Function} [initializer] The accumulator object initializer.
     * @returns {Function} Returns the new aggregator function.
     */
    function createAggregator(setter, initializer) {
      return function(collection, iteratee) {
        var func = isArray(collection) ? arrayAggregator : baseAggregator,
            accumulator = initializer ? initializer() : {};

        return func(collection, setter, getIteratee(iteratee, 2), accumulator);
      };
    }

    /**
     * Creates a function like `_.assign`.
     *
     * @private
     * @param {Function} assigner The function to assign values.
     * @returns {Function} Returns the new assigner function.
     */
    function createAssigner(assigner) {
      return baseRest(function(object, sources) {
        var index = -1,
            length = sources.length,
            customizer = length > 1 ? sources[length - 1] : undefined,
            guard = length > 2 ? sources[2] : undefined;

        customizer = (assigner.length > 3 && typeof customizer == 'function')
          ? (length--, customizer)
          : undefined;

        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          customizer = length < 3 ? undefined : customizer;
          length = 1;
        }
        object = Object(object);
        while (++index < length) {
          var source = sources[index];
          if (source) {
            assigner(object, source, index, customizer);
          }
        }
        return object;
      });
    }

    /**
     * Creates a `baseEach` or `baseEachRight` function.
     *
     * @private
     * @param {Function} eachFunc The function to iterate over a collection.
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new base function.
     */
    function createBaseEach(eachFunc, fromRight) {
      return function(collection, iteratee) {
        if (collection == null) {
          return collection;
        }
        if (!isArrayLike(collection)) {
          return eachFunc(collection, iteratee);
        }
        var length = collection.length,
            index = fromRight ? length : -1,
            iterable = Object(collection);

        while ((fromRight ? index-- : ++index < length)) {
          if (iteratee(iterable[index], index, iterable) === false) {
            break;
          }
        }
        return collection;
      };
    }

    /**
     * Creates a base function for methods like `_.forIn` and `_.forOwn`.
     *
     * @private
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new base function.
     */
    function createBaseFor(fromRight) {
      return function(object, iteratee, keysFunc) {
        var index = -1,
            iterable = Object(object),
            props = keysFunc(object),
            length = props.length;

        while (length--) {
          var key = props[fromRight ? length : ++index];
          if (iteratee(iterable[key], key, iterable) === false) {
            break;
          }
        }
        return object;
      };
    }

    /**
     * Creates a function that wraps `func` to invoke it with the optional `this`
     * binding of `thisArg`.
     *
     * @private
     * @param {Function} func The function to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {*} [thisArg] The `this` binding of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createBind(func, bitmask, thisArg) {
      var isBind = bitmask & WRAP_BIND_FLAG,
          Ctor = createCtor(func);

      function wrapper() {
        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;
        return fn.apply(isBind ? thisArg : this, arguments);
      }
      return wrapper;
    }

    /**
     * Creates a function like `_.lowerFirst`.
     *
     * @private
     * @param {string} methodName The name of the `String` case method to use.
     * @returns {Function} Returns the new case function.
     */
    function createCaseFirst(methodName) {
      return function(string) {
        string = toString(string);

        var strSymbols = hasUnicode(string)
          ? stringToArray(string)
          : undefined;

        var chr = strSymbols
          ? strSymbols[0]
          : string.charAt(0);

        var trailing = strSymbols
          ? castSlice(strSymbols, 1).join('')
          : string.slice(1);

        return chr[methodName]() + trailing;
      };
    }

    /**
     * Creates a function like `_.camelCase`.
     *
     * @private
     * @param {Function} callback The function to combine each word.
     * @returns {Function} Returns the new compounder function.
     */
    function createCompounder(callback) {
      return function(string) {
        return arrayReduce(words(deburr(string).replace(reApos, '')), callback, '');
      };
    }

    /**
     * Creates a function that produces an instance of `Ctor` regardless of
     * whether it was invoked as part of a `new` expression or by `call` or `apply`.
     *
     * @private
     * @param {Function} Ctor The constructor to wrap.
     * @returns {Function} Returns the new wrapped function.
     */
    function createCtor(Ctor) {
      return function() {
        // Use a `switch` statement to work with class constructors. See
        // http://ecma-international.org/ecma-262/7.0/#sec-ecmascript-function-objects-call-thisargument-argumentslist
        // for more details.
        var args = arguments;
        switch (args.length) {
          case 0: return new Ctor;
          case 1: return new Ctor(args[0]);
          case 2: return new Ctor(args[0], args[1]);
          case 3: return new Ctor(args[0], args[1], args[2]);
          case 4: return new Ctor(args[0], args[1], args[2], args[3]);
          case 5: return new Ctor(args[0], args[1], args[2], args[3], args[4]);
          case 6: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
          case 7: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
        }
        var thisBinding = baseCreate(Ctor.prototype),
            result = Ctor.apply(thisBinding, args);

        // Mimic the constructor's `return` behavior.
        // See https://es5.github.io/#x13.2.2 for more details.
        return isObject(result) ? result : thisBinding;
      };
    }

    /**
     * Creates a function that wraps `func` to enable currying.
     *
     * @private
     * @param {Function} func The function to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {number} arity The arity of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createCurry(func, bitmask, arity) {
      var Ctor = createCtor(func);

      function wrapper() {
        var length = arguments.length,
            args = Array(length),
            index = length,
            placeholder = getHolder(wrapper);

        while (index--) {
          args[index] = arguments[index];
        }
        var holders = (length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder)
          ? []
          : replaceHolders(args, placeholder);

        length -= holders.length;
        if (length < arity) {
          return createRecurry(
            func, bitmask, createHybrid, wrapper.placeholder, undefined,
            args, holders, undefined, undefined, arity - length);
        }
        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;
        return apply(fn, this, args);
      }
      return wrapper;
    }

    /**
     * Creates a `_.find` or `_.findLast` function.
     *
     * @private
     * @param {Function} findIndexFunc The function to find the collection index.
     * @returns {Function} Returns the new find function.
     */
    function createFind(findIndexFunc) {
      return function(collection, predicate, fromIndex) {
        var iterable = Object(collection);
        if (!isArrayLike(collection)) {
          var iteratee = getIteratee(predicate, 3);
          collection = keys(collection);
          predicate = function(key) { return iteratee(iterable[key], key, iterable); };
        }
        var index = findIndexFunc(collection, predicate, fromIndex);
        return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined;
      };
    }

    /**
     * Creates a `_.flow` or `_.flowRight` function.
     *
     * @private
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new flow function.
     */
    function createFlow(fromRight) {
      return flatRest(function(funcs) {
        var length = funcs.length,
            index = length,
            prereq = LodashWrapper.prototype.thru;

        if (fromRight) {
          funcs.reverse();
        }
        while (index--) {
          var func = funcs[index];
          if (typeof func != 'function') {
            throw new TypeError(FUNC_ERROR_TEXT);
          }
          if (prereq && !wrapper && getFuncName(func) == 'wrapper') {
            var wrapper = new LodashWrapper([], true);
          }
        }
        index = wrapper ? index : length;
        while (++index < length) {
          func = funcs[index];

          var funcName = getFuncName(func),
              data = funcName == 'wrapper' ? getData(func) : undefined;

          if (data && isLaziable(data[0]) &&
                data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) &&
                !data[4].length && data[9] == 1
              ) {
            wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
          } else {
            wrapper = (func.length == 1 && isLaziable(func))
              ? wrapper[funcName]()
              : wrapper.thru(func);
          }
        }
        return function() {
          var args = arguments,
              value = args[0];

          if (wrapper && args.length == 1 && isArray(value)) {
            return wrapper.plant(value).value();
          }
          var index = 0,
              result = length ? funcs[index].apply(this, args) : value;

          while (++index < length) {
            result = funcs[index].call(this, result);
          }
          return result;
        };
      });
    }

    /**
     * Creates a function that wraps `func` to invoke it with optional `this`
     * binding of `thisArg`, partial application, and currying.
     *
     * @private
     * @param {Function|string} func The function or method name to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {*} [thisArg] The `this` binding of `func`.
     * @param {Array} [partials] The arguments to prepend to those provided to
     *  the new function.
     * @param {Array} [holders] The `partials` placeholder indexes.
     * @param {Array} [partialsRight] The arguments to append to those provided
     *  to the new function.
     * @param {Array} [holdersRight] The `partialsRight` placeholder indexes.
     * @param {Array} [argPos] The argument positions of the new function.
     * @param {number} [ary] The arity cap of `func`.
     * @param {number} [arity] The arity of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary, arity) {
      var isAry = bitmask & WRAP_ARY_FLAG,
          isBind = bitmask & WRAP_BIND_FLAG,
          isBindKey = bitmask & WRAP_BIND_KEY_FLAG,
          isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG),
          isFlip = bitmask & WRAP_FLIP_FLAG,
          Ctor = isBindKey ? undefined : createCtor(func);

      function wrapper() {
        var length = arguments.length,
            args = Array(length),
            index = length;

        while (index--) {
          args[index] = arguments[index];
        }
        if (isCurried) {
          var placeholder = getHolder(wrapper),
              holdersCount = countHolders(args, placeholder);
        }
        if (partials) {
          args = composeArgs(args, partials, holders, isCurried);
        }
        if (partialsRight) {
          args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
        }
        length -= holdersCount;
        if (isCurried && length < arity) {
          var newHolders = replaceHolders(args, placeholder);
          return createRecurry(
            func, bitmask, createHybrid, wrapper.placeholder, thisArg,
            args, newHolders, argPos, ary, arity - length
          );
        }
        var thisBinding = isBind ? thisArg : this,
            fn = isBindKey ? thisBinding[func] : func;

        length = args.length;
        if (argPos) {
          args = reorder(args, argPos);
        } else if (isFlip && length > 1) {
          args.reverse();
        }
        if (isAry && ary < length) {
          args.length = ary;
        }
        if (this && this !== root && this instanceof wrapper) {
          fn = Ctor || createCtor(fn);
        }
        return fn.apply(thisBinding, args);
      }
      return wrapper;
    }

    /**
     * Creates a function like `_.invertBy`.
     *
     * @private
     * @param {Function} setter The function to set accumulator values.
     * @param {Function} toIteratee The function to resolve iteratees.
     * @returns {Function} Returns the new inverter function.
     */
    function createInverter(setter, toIteratee) {
      return function(object, iteratee) {
        return baseInverter(object, setter, toIteratee(iteratee), {});
      };
    }

    /**
     * Creates a function that performs a mathematical operation on two values.
     *
     * @private
     * @param {Function} operator The function to perform the operation.
     * @param {number} [defaultValue] The value used for `undefined` arguments.
     * @returns {Function} Returns the new mathematical operation function.
     */
    function createMathOperation(operator, defaultValue) {
      return function(value, other) {
        var result;
        if (value === undefined && other === undefined) {
          return defaultValue;
        }
        if (value !== undefined) {
          result = value;
        }
        if (other !== undefined) {
          if (result === undefined) {
            return other;
          }
          if (typeof value == 'string' || typeof other == 'string') {
            value = baseToString(value);
            other = baseToString(other);
          } else {
            value = baseToNumber(value);
            other = baseToNumber(other);
          }
          result = operator(value, other);
        }
        return result;
      };
    }

    /**
     * Creates a function like `_.over`.
     *
     * @private
     * @param {Function} arrayFunc The function to iterate over iteratees.
     * @returns {Function} Returns the new over function.
     */
    function createOver(arrayFunc) {
      return flatRest(function(iteratees) {
        iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
        return baseRest(function(args) {
          var thisArg = this;
          return arrayFunc(iteratees, function(iteratee) {
            return apply(iteratee, thisArg, args);
          });
        });
      });
    }

    /**
     * Creates the padding for `string` based on `length`. The `chars` string
     * is truncated if the number of characters exceeds `length`.
     *
     * @private
     * @param {number} length The padding length.
     * @param {string} [chars=' '] The string used as padding.
     * @returns {string} Returns the padding for `string`.
     */
    function createPadding(length, chars) {
      chars = chars === undefined ? ' ' : baseToString(chars);

      var charsLength = chars.length;
      if (charsLength < 2) {
        return charsLength ? baseRepeat(chars, length) : chars;
      }
      var result = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
      return hasUnicode(chars)
        ? castSlice(stringToArray(result), 0, length).join('')
        : result.slice(0, length);
    }

    /**
     * Creates a function that wraps `func` to invoke it with the `this` binding
     * of `thisArg` and `partials` prepended to the arguments it receives.
     *
     * @private
     * @param {Function} func The function to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {*} thisArg The `this` binding of `func`.
     * @param {Array} partials The arguments to prepend to those provided to
     *  the new function.
     * @returns {Function} Returns the new wrapped function.
     */
    function createPartial(func, bitmask, thisArg, partials) {
      var isBind = bitmask & WRAP_BIND_FLAG,
          Ctor = createCtor(func);

      function wrapper() {
        var argsIndex = -1,
            argsLength = arguments.length,
            leftIndex = -1,
            leftLength = partials.length,
            args = Array(leftLength + argsLength),
            fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;

        while (++leftIndex < leftLength) {
          args[leftIndex] = partials[leftIndex];
        }
        while (argsLength--) {
          args[leftIndex++] = arguments[++argsIndex];
        }
        return apply(fn, isBind ? thisArg : this, args);
      }
      return wrapper;
    }

    /**
     * Creates a `_.range` or `_.rangeRight` function.
     *
     * @private
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new range function.
     */
    function createRange(fromRight) {
      return function(start, end, step) {
        if (step && typeof step != 'number' && isIterateeCall(start, end, step)) {
          end = step = undefined;
        }
        // Ensure the sign of `-0` is preserved.
        start = toFinite(start);
        if (end === undefined) {
          end = start;
          start = 0;
        } else {
          end = toFinite(end);
        }
        step = step === undefined ? (start < end ? 1 : -1) : toFinite(step);
        return baseRange(start, end, step, fromRight);
      };
    }

    /**
     * Creates a function that performs a relational operation on two values.
     *
     * @private
     * @param {Function} operator The function to perform the operation.
     * @returns {Function} Returns the new relational operation function.
     */
    function createRelationalOperation(operator) {
      return function(value, other) {
        if (!(typeof value == 'string' && typeof other == 'string')) {
          value = toNumber(value);
          other = toNumber(other);
        }
        return operator(value, other);
      };
    }

    /**
     * Creates a function that wraps `func` to continue currying.
     *
     * @private
     * @param {Function} func The function to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {Function} wrapFunc The function to create the `func` wrapper.
     * @param {*} placeholder The placeholder value.
     * @param {*} [thisArg] The `this` binding of `func`.
     * @param {Array} [partials] The arguments to prepend to those provided to
     *  the new function.
     * @param {Array} [holders] The `partials` placeholder indexes.
     * @param {Array} [argPos] The argument positions of the new function.
     * @param {number} [ary] The arity cap of `func`.
     * @param {number} [arity] The arity of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary, arity) {
      var isCurry = bitmask & WRAP_CURRY_FLAG,
          newHolders = isCurry ? holders : undefined,
          newHoldersRight = isCurry ? undefined : holders,
          newPartials = isCurry ? partials : undefined,
          newPartialsRight = isCurry ? undefined : partials;

      bitmask |= (isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG);
      bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);

      if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
        bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
      }
      var newData = [
        func, bitmask, thisArg, newPartials, newHolders, newPartialsRight,
        newHoldersRight, argPos, ary, arity
      ];

      var result = wrapFunc.apply(undefined, newData);
      if (isLaziable(func)) {
        setData(result, newData);
      }
      result.placeholder = placeholder;
      return setWrapToString(result, func, bitmask);
    }

    /**
     * Creates a function like `_.round`.
     *
     * @private
     * @param {string} methodName The name of the `Math` method to use when rounding.
     * @returns {Function} Returns the new round function.
     */
    function createRound(methodName) {
      var func = Math[methodName];
      return function(number, precision) {
        number = toNumber(number);
        precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
        if (precision && nativeIsFinite(number)) {
          // Shift with exponential notation to avoid floating-point issues.
          // See [MDN](https://mdn.io/round#Examples) for more details.
          var pair = (toString(number) + 'e').split('e'),
              value = func(pair[0] + 'e' + (+pair[1] + precision));

          pair = (toString(value) + 'e').split('e');
          return +(pair[0] + 'e' + (+pair[1] - precision));
        }
        return func(number);
      };
    }

    /**
     * Creates a set object of `values`.
     *
     * @private
     * @param {Array} values The values to add to the set.
     * @returns {Object} Returns the new set.
     */
    var createSet = !(Set && (1 / setToArray(new Set([,-0]))[1]) == INFINITY) ? noop : function(values) {
      return new Set(values);
    };

    /**
     * Creates a `_.toPairs` or `_.toPairsIn` function.
     *
     * @private
     * @param {Function} keysFunc The function to get the keys of a given object.
     * @returns {Function} Returns the new pairs function.
     */
    function createToPairs(keysFunc) {
      return function(object) {
        var tag = getTag(object);
        if (tag == mapTag) {
          return mapToArray(object);
        }
        if (tag == setTag) {
          return setToPairs(object);
        }
        return baseToPairs(object, keysFunc(object));
      };
    }

    /**
     * Creates a function that either curries or invokes `func` with optional
     * `this` binding and partially applied arguments.
     *
     * @private
     * @param {Function|string} func The function or method name to wrap.
     * @param {number} bitmask The bitmask flags.
     *    1 - `_.bind`
     *    2 - `_.bindKey`
     *    4 - `_.curry` or `_.curryRight` of a bound function
     *    8 - `_.curry`
     *   16 - `_.curryRight`
     *   32 - `_.partial`
     *   64 - `_.partialRight`
     *  128 - `_.rearg`
     *  256 - `_.ary`
     *  512 - `_.flip`
     * @param {*} [thisArg] The `this` binding of `func`.
     * @param {Array} [partials] The arguments to be partially applied.
     * @param {Array} [holders] The `partials` placeholder indexes.
     * @param {Array} [argPos] The argument positions of the new function.
     * @param {number} [ary] The arity cap of `func`.
     * @param {number} [arity] The arity of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createWrap(func, bitmask, thisArg, partials, holders, argPos, ary, arity) {
      var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
      if (!isBindKey && typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      var length = partials ? partials.length : 0;
      if (!length) {
        bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
        partials = holders = undefined;
      }
      ary = ary === undefined ? ary : nativeMax(toInteger(ary), 0);
      arity = arity === undefined ? arity : toInteger(arity);
      length -= holders ? holders.length : 0;

      if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
        var partialsRight = partials,
            holdersRight = holders;

        partials = holders = undefined;
      }
      var data = isBindKey ? undefined : getData(func);

      var newData = [
        func, bitmask, thisArg, partials, holders, partialsRight, holdersRight,
        argPos, ary, arity
      ];

      if (data) {
        mergeData(newData, data);
      }
      func = newData[0];
      bitmask = newData[1];
      thisArg = newData[2];
      partials = newData[3];
      holders = newData[4];
      arity = newData[9] = newData[9] === undefined
        ? (isBindKey ? 0 : func.length)
        : nativeMax(newData[9] - length, 0);

      if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
        bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
      }
      if (!bitmask || bitmask == WRAP_BIND_FLAG) {
        var result = createBind(func, bitmask, thisArg);
      } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
        result = createCurry(func, bitmask, arity);
      } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
        result = createPartial(func, bitmask, thisArg, partials);
      } else {
        result = createHybrid.apply(undefined, newData);
      }
      var setter = data ? baseSetData : setData;
      return setWrapToString(setter(result, newData), func, bitmask);
    }

    /**
     * Used by `_.defaults` to customize its `_.assignIn` use to assign properties
     * of source objects to the destination object for all destination properties
     * that resolve to `undefined`.
     *
     * @private
     * @param {*} objValue The destination value.
     * @param {*} srcValue The source value.
     * @param {string} key The key of the property to assign.
     * @param {Object} object The parent object of `objValue`.
     * @returns {*} Returns the value to assign.
     */
    function customDefaultsAssignIn(objValue, srcValue, key, object) {
      if (objValue === undefined ||
          (eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key))) {
        return srcValue;
      }
      return objValue;
    }

    /**
     * Used by `_.defaultsDeep` to customize its `_.merge` use to merge source
     * objects into destination objects that are passed thru.
     *
     * @private
     * @param {*} objValue The destination value.
     * @param {*} srcValue The source value.
     * @param {string} key The key of the property to merge.
     * @param {Object} object The parent object of `objValue`.
     * @param {Object} source The parent object of `srcValue`.
     * @param {Object} [stack] Tracks traversed source values and their merged
     *  counterparts.
     * @returns {*} Returns the value to assign.
     */
    function customDefaultsMerge(objValue, srcValue, key, object, source, stack) {
      if (isObject(objValue) && isObject(srcValue)) {
        // Recursively merge objects and arrays (susceptible to call stack limits).
        stack.set(srcValue, objValue);
        baseMerge(objValue, srcValue, undefined, customDefaultsMerge, stack);
        stack['delete'](srcValue);
      }
      return objValue;
    }

    /**
     * Used by `_.omit` to customize its `_.cloneDeep` use to only clone plain
     * objects.
     *
     * @private
     * @param {*} value The value to inspect.
     * @param {string} key The key of the property to inspect.
     * @returns {*} Returns the uncloned value or `undefined` to defer cloning to `_.cloneDeep`.
     */
    function customOmitClone(value) {
      return isPlainObject(value) ? undefined : value;
    }

    /**
     * A specialized version of `baseIsEqualDeep` for arrays with support for
     * partial deep comparisons.
     *
     * @private
     * @param {Array} array The array to compare.
     * @param {Array} other The other array to compare.
     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
     * @param {Function} customizer The function to customize comparisons.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Object} stack Tracks traversed `array` and `other` objects.
     * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
     */
    function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
          arrLength = array.length,
          othLength = other.length;

      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
        return false;
      }
      // Check that cyclic values are equal.
      var arrStacked = stack.get(array);
      var othStacked = stack.get(other);
      if (arrStacked && othStacked) {
        return arrStacked == other && othStacked == array;
      }
      var index = -1,
          result = true,
          seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined;

      stack.set(array, other);
      stack.set(other, array);

      // Ignore non-index properties.
      while (++index < arrLength) {
        var arrValue = array[index],
            othValue = other[index];

        if (customizer) {
          var compared = isPartial
            ? customizer(othValue, arrValue, index, other, array, stack)
            : customizer(arrValue, othValue, index, array, other, stack);
        }
        if (compared !== undefined) {
          if (compared) {
            continue;
          }
          result = false;
          break;
        }
        // Recursively compare arrays (susceptible to call stack limits).
        if (seen) {
          if (!arraySome(other, function(othValue, othIndex) {
                if (!cacheHas(seen, othIndex) &&
                    (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
                  return seen.push(othIndex);
                }
              })) {
            result = false;
            break;
          }
        } else if (!(
              arrValue === othValue ||
                equalFunc(arrValue, othValue, bitmask, customizer, stack)
            )) {
          result = false;
          break;
        }
      }
      stack['delete'](array);
      stack['delete'](other);
      return result;
    }

    /**
     * A specialized version of `baseIsEqualDeep` for comparing objects of
     * the same `toStringTag`.
     *
     * **Note:** This function only supports comparing values with tags of
     * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {string} tag The `toStringTag` of the objects to compare.
     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
     * @param {Function} customizer The function to customize comparisons.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Object} stack Tracks traversed `object` and `other` objects.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
      switch (tag) {
        case dataViewTag:
          if ((object.byteLength != other.byteLength) ||
              (object.byteOffset != other.byteOffset)) {
            return false;
          }
          object = object.buffer;
          other = other.buffer;

        case arrayBufferTag:
          if ((object.byteLength != other.byteLength) ||
              !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
            return false;
          }
          return true;

        case boolTag:
        case dateTag:
        case numberTag:
          // Coerce booleans to `1` or `0` and dates to milliseconds.
          // Invalid dates are coerced to `NaN`.
          return eq(+object, +other);

        case errorTag:
          return object.name == other.name && object.message == other.message;

        case regexpTag:
        case stringTag:
          // Coerce regexes to strings and treat strings, primitives and objects,
          // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
          // for more details.
          return object == (other + '');

        case mapTag:
          var convert = mapToArray;

        case setTag:
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
          convert || (convert = setToArray);

          if (object.size != other.size && !isPartial) {
            return false;
          }
          // Assume cyclic values are equal.
          var stacked = stack.get(object);
          if (stacked) {
            return stacked == other;
          }
          bitmask |= COMPARE_UNORDERED_FLAG;

          // Recursively compare objects (susceptible to call stack limits).
          stack.set(object, other);
          var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
          stack['delete'](object);
          return result;

        case symbolTag:
          if (symbolValueOf) {
            return symbolValueOf.call(object) == symbolValueOf.call(other);
          }
      }
      return false;
    }

    /**
     * A specialized version of `baseIsEqualDeep` for objects with support for
     * partial deep comparisons.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
     * @param {Function} customizer The function to customize comparisons.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Object} stack Tracks traversed `object` and `other` objects.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
          objProps = getAllKeys(object),
          objLength = objProps.length,
          othProps = getAllKeys(other),
          othLength = othProps.length;

      if (objLength != othLength && !isPartial) {
        return false;
      }
      var index = objLength;
      while (index--) {
        var key = objProps[index];
        if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
          return false;
        }
      }
      // Check that cyclic values are equal.
      var objStacked = stack.get(object);
      var othStacked = stack.get(other);
      if (objStacked && othStacked) {
        return objStacked == other && othStacked == object;
      }
      var result = true;
      stack.set(object, other);
      stack.set(other, object);

      var skipCtor = isPartial;
      while (++index < objLength) {
        key = objProps[index];
        var objValue = object[key],
            othValue = other[key];

        if (customizer) {
          var compared = isPartial
            ? customizer(othValue, objValue, key, other, object, stack)
            : customizer(objValue, othValue, key, object, other, stack);
        }
        // Recursively compare objects (susceptible to call stack limits).
        if (!(compared === undefined
              ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
              : compared
            )) {
          result = false;
          break;
        }
        skipCtor || (skipCtor = key == 'constructor');
      }
      if (result && !skipCtor) {
        var objCtor = object.constructor,
            othCtor = other.constructor;

        // Non `Object` object instances with different constructors are not equal.
        if (objCtor != othCtor &&
            ('constructor' in object && 'constructor' in other) &&
            !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
              typeof othCtor == 'function' && othCtor instanceof othCtor)) {
          result = false;
        }
      }
      stack['delete'](object);
      stack['delete'](other);
      return result;
    }

    /**
     * A specialized version of `baseRest` which flattens the rest array.
     *
     * @private
     * @param {Function} func The function to apply a rest parameter to.
     * @returns {Function} Returns the new function.
     */
    function flatRest(func) {
      return setToString(overRest(func, undefined, flatten), func + '');
    }

    /**
     * Creates an array of own enumerable property names and symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names and symbols.
     */
    function getAllKeys(object) {
      return baseGetAllKeys(object, keys, getSymbols);
    }

    /**
     * Creates an array of own and inherited enumerable property names and
     * symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names and symbols.
     */
    function getAllKeysIn(object) {
      return baseGetAllKeys(object, keysIn, getSymbolsIn);
    }

    /**
     * Gets metadata for `func`.
     *
     * @private
     * @param {Function} func The function to query.
     * @returns {*} Returns the metadata for `func`.
     */
    var getData = !metaMap ? noop : function(func) {
      return metaMap.get(func);
    };

    /**
     * Gets the name of `func`.
     *
     * @private
     * @param {Function} func The function to query.
     * @returns {string} Returns the function name.
     */
    function getFuncName(func) {
      var result = (func.name + ''),
          array = realNames[result],
          length = hasOwnProperty.call(realNames, result) ? array.length : 0;

      while (length--) {
        var data = array[length],
            otherFunc = data.func;
        if (otherFunc == null || otherFunc == func) {
          return data.name;
        }
      }
      return result;
    }

    /**
     * Gets the argument placeholder value for `func`.
     *
     * @private
     * @param {Function} func The function to inspect.
     * @returns {*} Returns the placeholder value.
     */
    function getHolder(func) {
      var object = hasOwnProperty.call(lodash, 'placeholder') ? lodash : func;
      return object.placeholder;
    }

    /**
     * Gets the appropriate "iteratee" function. If `_.iteratee` is customized,
     * this function returns the custom method, otherwise it returns `baseIteratee`.
     * If arguments are provided, the chosen function is invoked with them and
     * its result is returned.
     *
     * @private
     * @param {*} [value] The value to convert to an iteratee.
     * @param {number} [arity] The arity of the created iteratee.
     * @returns {Function} Returns the chosen function or its result.
     */
    function getIteratee() {
      var result = lodash.iteratee || iteratee;
      result = result === iteratee ? baseIteratee : result;
      return arguments.length ? result(arguments[0], arguments[1]) : result;
    }

    /**
     * Gets the data for `map`.
     *
     * @private
     * @param {Object} map The map to query.
     * @param {string} key The reference key.
     * @returns {*} Returns the map data.
     */
    function getMapData(map, key) {
      var data = map.__data__;
      return isKeyable(key)
        ? data[typeof key == 'string' ? 'string' : 'hash']
        : data.map;
    }

    /**
     * Gets the property names, values, and compare flags of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the match data of `object`.
     */
    function getMatchData(object) {
      var result = keys(object),
          length = result.length;

      while (length--) {
        var key = result[length],
            value = object[key];

        result[length] = [key, value, isStrictComparable(value)];
      }
      return result;
    }

    /**
     * Gets the native function at `key` of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {string} key The key of the method to get.
     * @returns {*} Returns the function if it's native, else `undefined`.
     */
    function getNative(object, key) {
      var value = getValue(object, key);
      return baseIsNative(value) ? value : undefined;
    }

    /**
     * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the raw `toStringTag`.
     */
    function getRawTag(value) {
      var isOwn = hasOwnProperty.call(value, symToStringTag),
          tag = value[symToStringTag];

      try {
        value[symToStringTag] = undefined;
        var unmasked = true;
      } catch (e) {}

      var result = nativeObjectToString.call(value);
      if (unmasked) {
        if (isOwn) {
          value[symToStringTag] = tag;
        } else {
          delete value[symToStringTag];
        }
      }
      return result;
    }

    /**
     * Creates an array of the own enumerable symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of symbols.
     */
    var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
      if (object == null) {
        return [];
      }
      object = Object(object);
      return arrayFilter(nativeGetSymbols(object), function(symbol) {
        return propertyIsEnumerable.call(object, symbol);
      });
    };

    /**
     * Creates an array of the own and inherited enumerable symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of symbols.
     */
    var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
      var result = [];
      while (object) {
        arrayPush(result, getSymbols(object));
        object = getPrototype(object);
      }
      return result;
    };

    /**
     * Gets the `toStringTag` of `value`.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the `toStringTag`.
     */
    var getTag = baseGetTag;

    // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
    if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
        (Map && getTag(new Map) != mapTag) ||
        (Promise && getTag(Promise.resolve()) != promiseTag) ||
        (Set && getTag(new Set) != setTag) ||
        (WeakMap && getTag(new WeakMap) != weakMapTag)) {
      getTag = function(value) {
        var result = baseGetTag(value),
            Ctor = result == objectTag ? value.constructor : undefined,
            ctorString = Ctor ? toSource(Ctor) : '';

        if (ctorString) {
          switch (ctorString) {
            case dataViewCtorString: return dataViewTag;
            case mapCtorString: return mapTag;
            case promiseCtorString: return promiseTag;
            case setCtorString: return setTag;
            case weakMapCtorString: return weakMapTag;
          }
        }
        return result;
      };
    }

    /**
     * Gets the view, applying any `transforms` to the `start` and `end` positions.
     *
     * @private
     * @param {number} start The start of the view.
     * @param {number} end The end of the view.
     * @param {Array} transforms The transformations to apply to the view.
     * @returns {Object} Returns an object containing the `start` and `end`
     *  positions of the view.
     */
    function getView(start, end, transforms) {
      var index = -1,
          length = transforms.length;

      while (++index < length) {
        var data = transforms[index],
            size = data.size;

        switch (data.type) {
          case 'drop':      start += size; break;
          case 'dropRight': end -= size; break;
          case 'take':      end = nativeMin(end, start + size); break;
          case 'takeRight': start = nativeMax(start, end - size); break;
        }
      }
      return { 'start': start, 'end': end };
    }

    /**
     * Extracts wrapper details from the `source` body comment.
     *
     * @private
     * @param {string} source The source to inspect.
     * @returns {Array} Returns the wrapper details.
     */
    function getWrapDetails(source) {
      var match = source.match(reWrapDetails);
      return match ? match[1].split(reSplitDetails) : [];
    }

    /**
     * Checks if `path` exists on `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @param {Function} hasFunc The function to check properties.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     */
    function hasPath(object, path, hasFunc) {
      path = castPath(path, object);

      var index = -1,
          length = path.length,
          result = false;

      while (++index < length) {
        var key = toKey(path[index]);
        if (!(result = object != null && hasFunc(object, key))) {
          break;
        }
        object = object[key];
      }
      if (result || ++index != length) {
        return result;
      }
      length = object == null ? 0 : object.length;
      return !!length && isLength(length) && isIndex(key, length) &&
        (isArray(object) || isArguments(object));
    }

    /**
     * Initializes an array clone.
     *
     * @private
     * @param {Array} array The array to clone.
     * @returns {Array} Returns the initialized clone.
     */
    function initCloneArray(array) {
      var length = array.length,
          result = new array.constructor(length);

      // Add properties assigned by `RegExp#exec`.
      if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {
        result.index = array.index;
        result.input = array.input;
      }
      return result;
    }

    /**
     * Initializes an object clone.
     *
     * @private
     * @param {Object} object The object to clone.
     * @returns {Object} Returns the initialized clone.
     */
    function initCloneObject(object) {
      return (typeof object.constructor == 'function' && !isPrototype(object))
        ? baseCreate(getPrototype(object))
        : {};
    }

    /**
     * Initializes an object clone based on its `toStringTag`.
     *
     * **Note:** This function only supports cloning values with tags of
     * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
     *
     * @private
     * @param {Object} object The object to clone.
     * @param {string} tag The `toStringTag` of the object to clone.
     * @param {boolean} [isDeep] Specify a deep clone.
     * @returns {Object} Returns the initialized clone.
     */
    function initCloneByTag(object, tag, isDeep) {
      var Ctor = object.constructor;
      switch (tag) {
        case arrayBufferTag:
          return cloneArrayBuffer(object);

        case boolTag:
        case dateTag:
          return new Ctor(+object);

        case dataViewTag:
          return cloneDataView(object, isDeep);

        case float32Tag: case float64Tag:
        case int8Tag: case int16Tag: case int32Tag:
        case uint8Tag: case uint8ClampedTag: case uint16Tag: case uint32Tag:
          return cloneTypedArray(object, isDeep);

        case mapTag:
          return new Ctor;

        case numberTag:
        case stringTag:
          return new Ctor(object);

        case regexpTag:
          return cloneRegExp(object);

        case setTag:
          return new Ctor;

        case symbolTag:
          return cloneSymbol(object);
      }
    }

    /**
     * Inserts wrapper `details` in a comment at the top of the `source` body.
     *
     * @private
     * @param {string} source The source to modify.
     * @returns {Array} details The details to insert.
     * @returns {string} Returns the modified source.
     */
    function insertWrapDetails(source, details) {
      var length = details.length;
      if (!length) {
        return source;
      }
      var lastIndex = length - 1;
      details[lastIndex] = (length > 1 ? '& ' : '') + details[lastIndex];
      details = details.join(length > 2 ? ', ' : ' ');
      return source.replace(reWrapComment, '{\n/* [wrapped with ' + details + '] */\n');
    }

    /**
     * Checks if `value` is a flattenable `arguments` object or array.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
     */
    function isFlattenable(value) {
      return isArray(value) || isArguments(value) ||
        !!(spreadableSymbol && value && value[spreadableSymbol]);
    }

    /**
     * Checks if `value` is a valid array-like index.
     *
     * @private
     * @param {*} value The value to check.
     * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
     * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
     */
    function isIndex(value, length) {
      var type = typeof value;
      length = length == null ? MAX_SAFE_INTEGER : length;

      return !!length &&
        (type == 'number' ||
          (type != 'symbol' && reIsUint.test(value))) &&
            (value > -1 && value % 1 == 0 && value < length);
    }

    /**
     * Checks if the given arguments are from an iteratee call.
     *
     * @private
     * @param {*} value The potential iteratee value argument.
     * @param {*} index The potential iteratee index or key argument.
     * @param {*} object The potential iteratee object argument.
     * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
     *  else `false`.
     */
    function isIterateeCall(value, index, object) {
      if (!isObject(object)) {
        return false;
      }
      var type = typeof index;
      if (type == 'number'
            ? (isArrayLike(object) && isIndex(index, object.length))
            : (type == 'string' && index in object)
          ) {
        return eq(object[index], value);
      }
      return false;
    }

    /**
     * Checks if `value` is a property name and not a property path.
     *
     * @private
     * @param {*} value The value to check.
     * @param {Object} [object] The object to query keys on.
     * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
     */
    function isKey(value, object) {
      if (isArray(value)) {
        return false;
      }
      var type = typeof value;
      if (type == 'number' || type == 'symbol' || type == 'boolean' ||
          value == null || isSymbol(value)) {
        return true;
      }
      return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
        (object != null && value in Object(object));
    }

    /**
     * Checks if `value` is suitable for use as unique object key.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
     */
    function isKeyable(value) {
      var type = typeof value;
      return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
        ? (value !== '__proto__')
        : (value === null);
    }

    /**
     * Checks if `func` has a lazy counterpart.
     *
     * @private
     * @param {Function} func The function to check.
     * @returns {boolean} Returns `true` if `func` has a lazy counterpart,
     *  else `false`.
     */
    function isLaziable(func) {
      var funcName = getFuncName(func),
          other = lodash[funcName];

      if (typeof other != 'function' || !(funcName in LazyWrapper.prototype)) {
        return false;
      }
      if (func === other) {
        return true;
      }
      var data = getData(other);
      return !!data && func === data[0];
    }

    /**
     * Checks if `func` has its source masked.
     *
     * @private
     * @param {Function} func The function to check.
     * @returns {boolean} Returns `true` if `func` is masked, else `false`.
     */
    function isMasked(func) {
      return !!maskSrcKey && (maskSrcKey in func);
    }

    /**
     * Checks if `func` is capable of being masked.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `func` is maskable, else `false`.
     */
    var isMaskable = coreJsData ? isFunction : stubFalse;

    /**
     * Checks if `value` is likely a prototype object.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
     */
    function isPrototype(value) {
      var Ctor = value && value.constructor,
          proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

      return value === proto;
    }

    /**
     * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` if suitable for strict
     *  equality comparisons, else `false`.
     */
    function isStrictComparable(value) {
      return value === value && !isObject(value);
    }

    /**
     * A specialized version of `matchesProperty` for source values suitable
     * for strict equality comparisons, i.e. `===`.
     *
     * @private
     * @param {string} key The key of the property to get.
     * @param {*} srcValue The value to match.
     * @returns {Function} Returns the new spec function.
     */
    function matchesStrictComparable(key, srcValue) {
      return function(object) {
        if (object == null) {
          return false;
        }
        return object[key] === srcValue &&
          (srcValue !== undefined || (key in Object(object)));
      };
    }

    /**
     * A specialized version of `_.memoize` which clears the memoized function's
     * cache when it exceeds `MAX_MEMOIZE_SIZE`.
     *
     * @private
     * @param {Function} func The function to have its output memoized.
     * @returns {Function} Returns the new memoized function.
     */
    function memoizeCapped(func) {
      var result = memoize(func, function(key) {
        if (cache.size === MAX_MEMOIZE_SIZE) {
          cache.clear();
        }
        return key;
      });

      var cache = result.cache;
      return result;
    }

    /**
     * Merges the function metadata of `source` into `data`.
     *
     * Merging metadata reduces the number of wrappers used to invoke a function.
     * This is possible because methods like `_.bind`, `_.curry`, and `_.partial`
     * may be applied regardless of execution order. Methods like `_.ary` and
     * `_.rearg` modify function arguments, making the order in which they are
     * executed important, preventing the merging of metadata. However, we make
     * an exception for a safe combined case where curried functions have `_.ary`
     * and or `_.rearg` applied.
     *
     * @private
     * @param {Array} data The destination metadata.
     * @param {Array} source The source metadata.
     * @returns {Array} Returns `data`.
     */
    function mergeData(data, source) {
      var bitmask = data[1],
          srcBitmask = source[1],
          newBitmask = bitmask | srcBitmask,
          isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);

      var isCombo =
        ((srcBitmask == WRAP_ARY_FLAG) && (bitmask == WRAP_CURRY_FLAG)) ||
        ((srcBitmask == WRAP_ARY_FLAG) && (bitmask == WRAP_REARG_FLAG) && (data[7].length <= source[8])) ||
        ((srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG)) && (source[7].length <= source[8]) && (bitmask == WRAP_CURRY_FLAG));

      // Exit early if metadata can't be merged.
      if (!(isCommon || isCombo)) {
        return data;
      }
      // Use source `thisArg` if available.
      if (srcBitmask & WRAP_BIND_FLAG) {
        data[2] = source[2];
        // Set when currying a bound function.
        newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
      }
      // Compose partial arguments.
      var value = source[3];
      if (value) {
        var partials = data[3];
        data[3] = partials ? composeArgs(partials, value, source[4]) : value;
        data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
      }
      // Compose partial right arguments.
      value = source[5];
      if (value) {
        partials = data[5];
        data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
        data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
      }
      // Use source `argPos` if available.
      value = source[7];
      if (value) {
        data[7] = value;
      }
      // Use source `ary` if it's smaller.
      if (srcBitmask & WRAP_ARY_FLAG) {
        data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
      }
      // Use source `arity` if one is not provided.
      if (data[9] == null) {
        data[9] = source[9];
      }
      // Use source `func` and merge bitmasks.
      data[0] = source[0];
      data[1] = newBitmask;

      return data;
    }

    /**
     * This function is like
     * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
     * except that it includes inherited enumerable properties.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     */
    function nativeKeysIn(object) {
      var result = [];
      if (object != null) {
        for (var key in Object(object)) {
          result.push(key);
        }
      }
      return result;
    }

    /**
     * Converts `value` to a string using `Object.prototype.toString`.
     *
     * @private
     * @param {*} value The value to convert.
     * @returns {string} Returns the converted string.
     */
    function objectToString(value) {
      return nativeObjectToString.call(value);
    }

    /**
     * A specialized version of `baseRest` which transforms the rest array.
     *
     * @private
     * @param {Function} func The function to apply a rest parameter to.
     * @param {number} [start=func.length-1] The start position of the rest parameter.
     * @param {Function} transform The rest array transform.
     * @returns {Function} Returns the new function.
     */
    function overRest(func, start, transform) {
      start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
      return function() {
        var args = arguments,
            index = -1,
            length = nativeMax(args.length - start, 0),
            array = Array(length);

        while (++index < length) {
          array[index] = args[start + index];
        }
        index = -1;
        var otherArgs = Array(start + 1);
        while (++index < start) {
          otherArgs[index] = args[index];
        }
        otherArgs[start] = transform(array);
        return apply(func, this, otherArgs);
      };
    }

    /**
     * Gets the parent value at `path` of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array} path The path to get the parent value of.
     * @returns {*} Returns the parent value.
     */
    function parent(object, path) {
      return path.length < 2 ? object : baseGet(object, baseSlice(path, 0, -1));
    }

    /**
     * Reorder `array` according to the specified indexes where the element at
     * the first index is assigned as the first element, the element at
     * the second index is assigned as the second element, and so on.
     *
     * @private
     * @param {Array} array The array to reorder.
     * @param {Array} indexes The arranged array indexes.
     * @returns {Array} Returns `array`.
     */
    function reorder(array, indexes) {
      var arrLength = array.length,
          length = nativeMin(indexes.length, arrLength),
          oldArray = copyArray(array);

      while (length--) {
        var index = indexes[length];
        array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined;
      }
      return array;
    }

    /**
     * Gets the value at `key`, unless `key` is "__proto__" or "constructor".
     *
     * @private
     * @param {Object} object The object to query.
     * @param {string} key The key of the property to get.
     * @returns {*} Returns the property value.
     */
    function safeGet(object, key) {
      if (key === 'constructor' && typeof object[key] === 'function') {
        return;
      }

      if (key == '__proto__') {
        return;
      }

      return object[key];
    }

    /**
     * Sets metadata for `func`.
     *
     * **Note:** If this function becomes hot, i.e. is invoked a lot in a short
     * period of time, it will trip its breaker and transition to an identity
     * function to avoid garbage collection pauses in V8. See
     * [V8 issue 2070](https://bugs.chromium.org/p/v8/issues/detail?id=2070)
     * for more details.
     *
     * @private
     * @param {Function} func The function to associate metadata with.
     * @param {*} data The metadata.
     * @returns {Function} Returns `func`.
     */
    var setData = shortOut(baseSetData);

    /**
     * A simple wrapper around the global [`setTimeout`](https://mdn.io/setTimeout).
     *
     * @private
     * @param {Function} func The function to delay.
     * @param {number} wait The number of milliseconds to delay invocation.
     * @returns {number|Object} Returns the timer id or timeout object.
     */
    var setTimeout = ctxSetTimeout || function(func, wait) {
      return root.setTimeout(func, wait);
    };

    /**
     * Sets the `toString` method of `func` to return `string`.
     *
     * @private
     * @param {Function} func The function to modify.
     * @param {Function} string The `toString` result.
     * @returns {Function} Returns `func`.
     */
    var setToString = shortOut(baseSetToString);

    /**
     * Sets the `toString` method of `wrapper` to mimic the source of `reference`
     * with wrapper details in a comment at the top of the source body.
     *
     * @private
     * @param {Function} wrapper The function to modify.
     * @param {Function} reference The reference function.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @returns {Function} Returns `wrapper`.
     */
    function setWrapToString(wrapper, reference, bitmask) {
      var source = (reference + '');
      return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
    }

    /**
     * Creates a function that'll short out and invoke `identity` instead
     * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
     * milliseconds.
     *
     * @private
     * @param {Function} func The function to restrict.
     * @returns {Function} Returns the new shortable function.
     */
    function shortOut(func) {
      var count = 0,
          lastCalled = 0;

      return function() {
        var stamp = nativeNow(),
            remaining = HOT_SPAN - (stamp - lastCalled);

        lastCalled = stamp;
        if (remaining > 0) {
          if (++count >= HOT_COUNT) {
            return arguments[0];
          }
        } else {
          count = 0;
        }
        return func.apply(undefined, arguments);
      };
    }

    /**
     * A specialized version of `_.shuffle` which mutates and sets the size of `array`.
     *
     * @private
     * @param {Array} array The array to shuffle.
     * @param {number} [size=array.length] The size of `array`.
     * @returns {Array} Returns `array`.
     */
    function shuffleSelf(array, size) {
      var index = -1,
          length = array.length,
          lastIndex = length - 1;

      size = size === undefined ? length : size;
      while (++index < size) {
        var rand = baseRandom(index, lastIndex),
            value = array[rand];

        array[rand] = array[index];
        array[index] = value;
      }
      array.length = size;
      return array;
    }

    /**
     * Converts `string` to a property path array.
     *
     * @private
     * @param {string} string The string to convert.
     * @returns {Array} Returns the property path array.
     */
    var stringToPath = memoizeCapped(function(string) {
      var result = [];
      if (string.charCodeAt(0) === 46 /* . */) {
        result.push('');
      }
      string.replace(rePropName, function(match, number, quote, subString) {
        result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
      });
      return result;
    });

    /**
     * Converts `value` to a string key if it's not a string or symbol.
     *
     * @private
     * @param {*} value The value to inspect.
     * @returns {string|symbol} Returns the key.
     */
    function toKey(value) {
      if (typeof value == 'string' || isSymbol(value)) {
        return value;
      }
      var result = (value + '');
      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
    }

    /**
     * Converts `func` to its source code.
     *
     * @private
     * @param {Function} func The function to convert.
     * @returns {string} Returns the source code.
     */
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch (e) {}
        try {
          return (func + '');
        } catch (e) {}
      }
      return '';
    }

    /**
     * Updates wrapper `details` based on `bitmask` flags.
     *
     * @private
     * @returns {Array} details The details to modify.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @returns {Array} Returns `details`.
     */
    function updateWrapDetails(details, bitmask) {
      arrayEach(wrapFlags, function(pair) {
        var value = '_.' + pair[0];
        if ((bitmask & pair[1]) && !arrayIncludes(details, value)) {
          details.push(value);
        }
      });
      return details.sort();
    }

    /**
     * Creates a clone of `wrapper`.
     *
     * @private
     * @param {Object} wrapper The wrapper to clone.
     * @returns {Object} Returns the cloned wrapper.
     */
    function wrapperClone(wrapper) {
      if (wrapper instanceof LazyWrapper) {
        return wrapper.clone();
      }
      var result = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
      result.__actions__ = copyArray(wrapper.__actions__);
      result.__index__  = wrapper.__index__;
      result.__values__ = wrapper.__values__;
      return result;
    }

    /*------------------------------------------------------------------------*/

    /**
     * Creates an array of elements split into groups the length of `size`.
     * If `array` can't be split evenly, the final chunk will be the remaining
     * elements.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to process.
     * @param {number} [size=1] The length of each chunk
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the new array of chunks.
     * @example
     *
     * _.chunk(['a', 'b', 'c', 'd'], 2);
     * // => [['a', 'b'], ['c', 'd']]
     *
     * _.chunk(['a', 'b', 'c', 'd'], 3);
     * // => [['a', 'b', 'c'], ['d']]
     */
    function chunk(array, size, guard) {
      if ((guard ? isIterateeCall(array, size, guard) : size === undefined)) {
        size = 1;
      } else {
        size = nativeMax(toInteger(size), 0);
      }
      var length = array == null ? 0 : array.length;
      if (!length || size < 1) {
        return [];
      }
      var index = 0,
          resIndex = 0,
          result = Array(nativeCeil(length / size));

      while (index < length) {
        result[resIndex++] = baseSlice(array, index, (index += size));
      }
      return result;
    }

    /**
     * Creates an array with all falsey values removed. The values `false`, `null`,
     * `0`, `""`, `undefined`, and `NaN` are falsey.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to compact.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * _.compact([0, 1, false, 2, '', 3]);
     * // => [1, 2, 3]
     */
    function compact(array) {
      var index = -1,
          length = array == null ? 0 : array.length,
          resIndex = 0,
          result = [];

      while (++index < length) {
        var value = array[index];
        if (value) {
          result[resIndex++] = value;
        }
      }
      return result;
    }

    /**
     * Creates a new array concatenating `array` with any additional arrays
     * and/or values.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to concatenate.
     * @param {...*} [values] The values to concatenate.
     * @returns {Array} Returns the new concatenated array.
     * @example
     *
     * var array = [1];
     * var other = _.concat(array, 2, [3], [[4]]);
     *
     * console.log(other);
     * // => [1, 2, 3, [4]]
     *
     * console.log(array);
     * // => [1]
     */
    function concat() {
      var length = arguments.length;
      if (!length) {
        return [];
      }
      var args = Array(length - 1),
          array = arguments[0],
          index = length;

      while (index--) {
        args[index - 1] = arguments[index];
      }
      return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));
    }

    /**
     * Creates an array of `array` values not included in the other given arrays
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons. The order and references of result values are
     * determined by the first array.
     *
     * **Note:** Unlike `_.pullAll`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {...Array} [values] The values to exclude.
     * @returns {Array} Returns the new array of filtered values.
     * @see _.without, _.xor
     * @example
     *
     * _.difference([2, 1], [2, 3]);
     * // => [1]
     */
    var difference = baseRest(function(array, values) {
      return isArrayLikeObject(array)
        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true))
        : [];
    });

    /**
     * This method is like `_.difference` except that it accepts `iteratee` which
     * is invoked for each element of `array` and `values` to generate the criterion
     * by which they're compared. The order and references of result values are
     * determined by the first array. The iteratee is invoked with one argument:
     * (value).
     *
     * **Note:** Unlike `_.pullAllBy`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {...Array} [values] The values to exclude.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * _.differenceBy([2.1, 1.2], [2.3, 3.4], Math.floor);
     * // => [1.2]
     *
     * // The `_.property` iteratee shorthand.
     * _.differenceBy([{ 'x': 2 }, { 'x': 1 }], [{ 'x': 1 }], 'x');
     * // => [{ 'x': 2 }]
     */
    var differenceBy = baseRest(function(array, values) {
      var iteratee = last(values);
      if (isArrayLikeObject(iteratee)) {
        iteratee = undefined;
      }
      return isArrayLikeObject(array)
        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), getIteratee(iteratee, 2))
        : [];
    });

    /**
     * This method is like `_.difference` except that it accepts `comparator`
     * which is invoked to compare elements of `array` to `values`. The order and
     * references of result values are determined by the first array. The comparator
     * is invoked with two arguments: (arrVal, othVal).
     *
     * **Note:** Unlike `_.pullAllWith`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {...Array} [values] The values to exclude.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
     *
     * _.differenceWith(objects, [{ 'x': 1, 'y': 2 }], _.isEqual);
     * // => [{ 'x': 2, 'y': 1 }]
     */
    var differenceWith = baseRest(function(array, values) {
      var comparator = last(values);
      if (isArrayLikeObject(comparator)) {
        comparator = undefined;
      }
      return isArrayLikeObject(array)
        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), undefined, comparator)
        : [];
    });

    /**
     * Creates a slice of `array` with `n` elements dropped from the beginning.
     *
     * @static
     * @memberOf _
     * @since 0.5.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=1] The number of elements to drop.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.drop([1, 2, 3]);
     * // => [2, 3]
     *
     * _.drop([1, 2, 3], 2);
     * // => [3]
     *
     * _.drop([1, 2, 3], 5);
     * // => []
     *
     * _.drop([1, 2, 3], 0);
     * // => [1, 2, 3]
     */
    function drop(array, n, guard) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      n = (guard || n === undefined) ? 1 : toInteger(n);
      return baseSlice(array, n < 0 ? 0 : n, length);
    }

    /**
     * Creates a slice of `array` with `n` elements dropped from the end.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=1] The number of elements to drop.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.dropRight([1, 2, 3]);
     * // => [1, 2]
     *
     * _.dropRight([1, 2, 3], 2);
     * // => [1]
     *
     * _.dropRight([1, 2, 3], 5);
     * // => []
     *
     * _.dropRight([1, 2, 3], 0);
     * // => [1, 2, 3]
     */
    function dropRight(array, n, guard) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      n = (guard || n === undefined) ? 1 : toInteger(n);
      n = length - n;
      return baseSlice(array, 0, n < 0 ? 0 : n);
    }

    /**
     * Creates a slice of `array` excluding elements dropped from the end.
     * Elements are dropped until `predicate` returns falsey. The predicate is
     * invoked with three arguments: (value, index, array).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': true },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': false }
     * ];
     *
     * _.dropRightWhile(users, function(o) { return !o.active; });
     * // => objects for ['barney']
     *
     * // The `_.matches` iteratee shorthand.
     * _.dropRightWhile(users, { 'user': 'pebbles', 'active': false });
     * // => objects for ['barney', 'fred']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.dropRightWhile(users, ['active', false]);
     * // => objects for ['barney']
     *
     * // The `_.property` iteratee shorthand.
     * _.dropRightWhile(users, 'active');
     * // => objects for ['barney', 'fred', 'pebbles']
     */
    function dropRightWhile(array, predicate) {
      return (array && array.length)
        ? baseWhile(array, getIteratee(predicate, 3), true, true)
        : [];
    }

    /**
     * Creates a slice of `array` excluding elements dropped from the beginning.
     * Elements are dropped until `predicate` returns falsey. The predicate is
     * invoked with three arguments: (value, index, array).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': false },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': true }
     * ];
     *
     * _.dropWhile(users, function(o) { return !o.active; });
     * // => objects for ['pebbles']
     *
     * // The `_.matches` iteratee shorthand.
     * _.dropWhile(users, { 'user': 'barney', 'active': false });
     * // => objects for ['fred', 'pebbles']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.dropWhile(users, ['active', false]);
     * // => objects for ['pebbles']
     *
     * // The `_.property` iteratee shorthand.
     * _.dropWhile(users, 'active');
     * // => objects for ['barney', 'fred', 'pebbles']
     */
    function dropWhile(array, predicate) {
      return (array && array.length)
        ? baseWhile(array, getIteratee(predicate, 3), true)
        : [];
    }

    /**
     * Fills elements of `array` with `value` from `start` up to, but not
     * including, `end`.
     *
     * **Note:** This method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 3.2.0
     * @category Array
     * @param {Array} array The array to fill.
     * @param {*} value The value to fill `array` with.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = [1, 2, 3];
     *
     * _.fill(array, 'a');
     * console.log(array);
     * // => ['a', 'a', 'a']
     *
     * _.fill(Array(3), 2);
     * // => [2, 2, 2]
     *
     * _.fill([4, 6, 8, 10], '*', 1, 3);
     * // => [4, '*', '*', 10]
     */
    function fill(array, value, start, end) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      if (start && typeof start != 'number' && isIterateeCall(array, value, start)) {
        start = 0;
        end = length;
      }
      return baseFill(array, value, start, end);
    }

    /**
     * This method is like `_.find` except that it returns the index of the first
     * element `predicate` returns truthy for instead of the element itself.
     *
     * @static
     * @memberOf _
     * @since 1.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param {number} [fromIndex=0] The index to search from.
     * @returns {number} Returns the index of the found element, else `-1`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': false },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': true }
     * ];
     *
     * _.findIndex(users, function(o) { return o.user == 'barney'; });
     * // => 0
     *
     * // The `_.matches` iteratee shorthand.
     * _.findIndex(users, { 'user': 'fred', 'active': false });
     * // => 1
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.findIndex(users, ['active', false]);
     * // => 0
     *
     * // The `_.property` iteratee shorthand.
     * _.findIndex(users, 'active');
     * // => 2
     */
    function findIndex(array, predicate, fromIndex) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return -1;
      }
      var index = fromIndex == null ? 0 : toInteger(fromIndex);
      if (index < 0) {
        index = nativeMax(length + index, 0);
      }
      return baseFindIndex(array, getIteratee(predicate, 3), index);
    }

    /**
     * This method is like `_.findIndex` except that it iterates over elements
     * of `collection` from right to left.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param {number} [fromIndex=array.length-1] The index to search from.
     * @returns {number} Returns the index of the found element, else `-1`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': true },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': false }
     * ];
     *
     * _.findLastIndex(users, function(o) { return o.user == 'pebbles'; });
     * // => 2
     *
     * // The `_.matches` iteratee shorthand.
     * _.findLastIndex(users, { 'user': 'barney', 'active': true });
     * // => 0
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.findLastIndex(users, ['active', false]);
     * // => 2
     *
     * // The `_.property` iteratee shorthand.
     * _.findLastIndex(users, 'active');
     * // => 0
     */
    function findLastIndex(array, predicate, fromIndex) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return -1;
      }
      var index = length - 1;
      if (fromIndex !== undefined) {
        index = toInteger(fromIndex);
        index = fromIndex < 0
          ? nativeMax(length + index, 0)
          : nativeMin(index, length - 1);
      }
      return baseFindIndex(array, getIteratee(predicate, 3), index, true);
    }

    /**
     * Flattens `array` a single level deep.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to flatten.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * _.flatten([1, [2, [3, [4]], 5]]);
     * // => [1, 2, [3, [4]], 5]
     */
    function flatten(array) {
      var length = array == null ? 0 : array.length;
      return length ? baseFlatten(array, 1) : [];
    }

    /**
     * Recursively flattens `array`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to flatten.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * _.flattenDeep([1, [2, [3, [4]], 5]]);
     * // => [1, 2, 3, 4, 5]
     */
    function flattenDeep(array) {
      var length = array == null ? 0 : array.length;
      return length ? baseFlatten(array, INFINITY) : [];
    }

    /**
     * Recursively flatten `array` up to `depth` times.
     *
     * @static
     * @memberOf _
     * @since 4.4.0
     * @category Array
     * @param {Array} array The array to flatten.
     * @param {number} [depth=1] The maximum recursion depth.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * var array = [1, [2, [3, [4]], 5]];
     *
     * _.flattenDepth(array, 1);
     * // => [1, 2, [3, [4]], 5]
     *
     * _.flattenDepth(array, 2);
     * // => [1, 2, 3, [4], 5]
     */
    function flattenDepth(array, depth) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      depth = depth === undefined ? 1 : toInteger(depth);
      return baseFlatten(array, depth);
    }

    /**
     * The inverse of `_.toPairs`; this method returns an object composed
     * from key-value `pairs`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} pairs The key-value pairs.
     * @returns {Object} Returns the new object.
     * @example
     *
     * _.fromPairs([['a', 1], ['b', 2]]);
     * // => { 'a': 1, 'b': 2 }
     */
    function fromPairs(pairs) {
      var index = -1,
          length = pairs == null ? 0 : pairs.length,
          result = {};

      while (++index < length) {
        var pair = pairs[index];
        result[pair[0]] = pair[1];
      }
      return result;
    }

    /**
     * Gets the first element of `array`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @alias first
     * @category Array
     * @param {Array} array The array to query.
     * @returns {*} Returns the first element of `array`.
     * @example
     *
     * _.head([1, 2, 3]);
     * // => 1
     *
     * _.head([]);
     * // => undefined
     */
    function head(array) {
      return (array && array.length) ? array[0] : undefined;
    }

    /**
     * Gets the index at which the first occurrence of `value` is found in `array`
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons. If `fromIndex` is negative, it's used as the
     * offset from the end of `array`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {*} value The value to search for.
     * @param {number} [fromIndex=0] The index to search from.
     * @returns {number} Returns the index of the matched value, else `-1`.
     * @example
     *
     * _.indexOf([1, 2, 1, 2], 2);
     * // => 1
     *
     * // Search from the `fromIndex`.
     * _.indexOf([1, 2, 1, 2], 2, 2);
     * // => 3
     */
    function indexOf(array, value, fromIndex) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return -1;
      }
      var index = fromIndex == null ? 0 : toInteger(fromIndex);
      if (index < 0) {
        index = nativeMax(length + index, 0);
      }
      return baseIndexOf(array, value, index);
    }

    /**
     * Gets all but the last element of `array`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to query.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.initial([1, 2, 3]);
     * // => [1, 2]
     */
    function initial(array) {
      var length = array == null ? 0 : array.length;
      return length ? baseSlice(array, 0, -1) : [];
    }

    /**
     * Creates an array of unique values that are included in all given arrays
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons. The order and references of result values are
     * determined by the first array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @returns {Array} Returns the new array of intersecting values.
     * @example
     *
     * _.intersection([2, 1], [2, 3]);
     * // => [2]
     */
    var intersection = baseRest(function(arrays) {
      var mapped = arrayMap(arrays, castArrayLikeObject);
      return (mapped.length && mapped[0] === arrays[0])
        ? baseIntersection(mapped)
        : [];
    });

    /**
     * This method is like `_.intersection` except that it accepts `iteratee`
     * which is invoked for each element of each `arrays` to generate the criterion
     * by which they're compared. The order and references of result values are
     * determined by the first array. The iteratee is invoked with one argument:
     * (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new array of intersecting values.
     * @example
     *
     * _.intersectionBy([2.1, 1.2], [2.3, 3.4], Math.floor);
     * // => [2.1]
     *
     * // The `_.property` iteratee shorthand.
     * _.intersectionBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
     * // => [{ 'x': 1 }]
     */
    var intersectionBy = baseRest(function(arrays) {
      var iteratee = last(arrays),
          mapped = arrayMap(arrays, castArrayLikeObject);

      if (iteratee === last(mapped)) {
        iteratee = undefined;
      } else {
        mapped.pop();
      }
      return (mapped.length && mapped[0] === arrays[0])
        ? baseIntersection(mapped, getIteratee(iteratee, 2))
        : [];
    });

    /**
     * This method is like `_.intersection` except that it accepts `comparator`
     * which is invoked to compare elements of `arrays`. The order and references
     * of result values are determined by the first array. The comparator is
     * invoked with two arguments: (arrVal, othVal).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of intersecting values.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
     *
     * _.intersectionWith(objects, others, _.isEqual);
     * // => [{ 'x': 1, 'y': 2 }]
     */
    var intersectionWith = baseRest(function(arrays) {
      var comparator = last(arrays),
          mapped = arrayMap(arrays, castArrayLikeObject);

      comparator = typeof comparator == 'function' ? comparator : undefined;
      if (comparator) {
        mapped.pop();
      }
      return (mapped.length && mapped[0] === arrays[0])
        ? baseIntersection(mapped, undefined, comparator)
        : [];
    });

    /**
     * Converts all elements in `array` into a string separated by `separator`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to convert.
     * @param {string} [separator=','] The element separator.
     * @returns {string} Returns the joined string.
     * @example
     *
     * _.join(['a', 'b', 'c'], '~');
     * // => 'a~b~c'
     */
    function join(array, separator) {
      return array == null ? '' : nativeJoin.call(array, separator);
    }

    /**
     * Gets the last element of `array`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to query.
     * @returns {*} Returns the last element of `array`.
     * @example
     *
     * _.last([1, 2, 3]);
     * // => 3
     */
    function last(array) {
      var length = array == null ? 0 : array.length;
      return length ? array[length - 1] : undefined;
    }

    /**
     * This method is like `_.indexOf` except that it iterates over elements of
     * `array` from right to left.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {*} value The value to search for.
     * @param {number} [fromIndex=array.length-1] The index to search from.
     * @returns {number} Returns the index of the matched value, else `-1`.
     * @example
     *
     * _.lastIndexOf([1, 2, 1, 2], 2);
     * // => 3
     *
     * // Search from the `fromIndex`.
     * _.lastIndexOf([1, 2, 1, 2], 2, 2);
     * // => 1
     */
    function lastIndexOf(array, value, fromIndex) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return -1;
      }
      var index = length;
      if (fromIndex !== undefined) {
        index = toInteger(fromIndex);
        index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
      }
      return value === value
        ? strictLastIndexOf(array, value, index)
        : baseFindIndex(array, baseIsNaN, index, true);
    }

    /**
     * Gets the element at index `n` of `array`. If `n` is negative, the nth
     * element from the end is returned.
     *
     * @static
     * @memberOf _
     * @since 4.11.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=0] The index of the element to return.
     * @returns {*} Returns the nth element of `array`.
     * @example
     *
     * var array = ['a', 'b', 'c', 'd'];
     *
     * _.nth(array, 1);
     * // => 'b'
     *
     * _.nth(array, -2);
     * // => 'c';
     */
    function nth(array, n) {
      return (array && array.length) ? baseNth(array, toInteger(n)) : undefined;
    }

    /**
     * Removes all given values from `array` using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * **Note:** Unlike `_.without`, this method mutates `array`. Use `_.remove`
     * to remove elements from an array by predicate.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {...*} [values] The values to remove.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = ['a', 'b', 'c', 'a', 'b', 'c'];
     *
     * _.pull(array, 'a', 'c');
     * console.log(array);
     * // => ['b', 'b']
     */
    var pull = baseRest(pullAll);

    /**
     * This method is like `_.pull` except that it accepts an array of values to remove.
     *
     * **Note:** Unlike `_.difference`, this method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {Array} values The values to remove.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = ['a', 'b', 'c', 'a', 'b', 'c'];
     *
     * _.pullAll(array, ['a', 'c']);
     * console.log(array);
     * // => ['b', 'b']
     */
    function pullAll(array, values) {
      return (array && array.length && values && values.length)
        ? basePullAll(array, values)
        : array;
    }

    /**
     * This method is like `_.pullAll` except that it accepts `iteratee` which is
     * invoked for each element of `array` and `values` to generate the criterion
     * by which they're compared. The iteratee is invoked with one argument: (value).
     *
     * **Note:** Unlike `_.differenceBy`, this method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {Array} values The values to remove.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = [{ 'x': 1 }, { 'x': 2 }, { 'x': 3 }, { 'x': 1 }];
     *
     * _.pullAllBy(array, [{ 'x': 1 }, { 'x': 3 }], 'x');
     * console.log(array);
     * // => [{ 'x': 2 }]
     */
    function pullAllBy(array, values, iteratee) {
      return (array && array.length && values && values.length)
        ? basePullAll(array, values, getIteratee(iteratee, 2))
        : array;
    }

    /**
     * This method is like `_.pullAll` except that it accepts `comparator` which
     * is invoked to compare elements of `array` to `values`. The comparator is
     * invoked with two arguments: (arrVal, othVal).
     *
     * **Note:** Unlike `_.differenceWith`, this method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 4.6.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {Array} values The values to remove.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = [{ 'x': 1, 'y': 2 }, { 'x': 3, 'y': 4 }, { 'x': 5, 'y': 6 }];
     *
     * _.pullAllWith(array, [{ 'x': 3, 'y': 4 }], _.isEqual);
     * console.log(array);
     * // => [{ 'x': 1, 'y': 2 }, { 'x': 5, 'y': 6 }]
     */
    function pullAllWith(array, values, comparator) {
      return (array && array.length && values && values.length)
        ? basePullAll(array, values, undefined, comparator)
        : array;
    }

    /**
     * Removes elements from `array` corresponding to `indexes` and returns an
     * array of removed elements.
     *
     * **Note:** Unlike `_.at`, this method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {...(number|number[])} [indexes] The indexes of elements to remove.
     * @returns {Array} Returns the new array of removed elements.
     * @example
     *
     * var array = ['a', 'b', 'c', 'd'];
     * var pulled = _.pullAt(array, [1, 3]);
     *
     * console.log(array);
     * // => ['a', 'c']
     *
     * console.log(pulled);
     * // => ['b', 'd']
     */
    var pullAt = flatRest(function(array, indexes) {
      var length = array == null ? 0 : array.length,
          result = baseAt(array, indexes);

      basePullAt(array, arrayMap(indexes, function(index) {
        return isIndex(index, length) ? +index : index;
      }).sort(compareAscending));

      return result;
    });

    /**
     * Removes all elements from `array` that `predicate` returns truthy for
     * and returns an array of the removed elements. The predicate is invoked
     * with three arguments: (value, index, array).
     *
     * **Note:** Unlike `_.filter`, this method mutates `array`. Use `_.pull`
     * to pull elements from an array by value.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new array of removed elements.
     * @example
     *
     * var array = [1, 2, 3, 4];
     * var evens = _.remove(array, function(n) {
     *   return n % 2 == 0;
     * });
     *
     * console.log(array);
     * // => [1, 3]
     *
     * console.log(evens);
     * // => [2, 4]
     */
    function remove(array, predicate) {
      var result = [];
      if (!(array && array.length)) {
        return result;
      }
      var index = -1,
          indexes = [],
          length = array.length;

      predicate = getIteratee(predicate, 3);
      while (++index < length) {
        var value = array[index];
        if (predicate(value, index, array)) {
          result.push(value);
          indexes.push(index);
        }
      }
      basePullAt(array, indexes);
      return result;
    }

    /**
     * Reverses `array` so that the first element becomes the last, the second
     * element becomes the second to last, and so on.
     *
     * **Note:** This method mutates `array` and is based on
     * [`Array#reverse`](https://mdn.io/Array/reverse).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = [1, 2, 3];
     *
     * _.reverse(array);
     * // => [3, 2, 1]
     *
     * console.log(array);
     * // => [3, 2, 1]
     */
    function reverse(array) {
      return array == null ? array : nativeReverse.call(array);
    }

    /**
     * Creates a slice of `array` from `start` up to, but not including, `end`.
     *
     * **Note:** This method is used instead of
     * [`Array#slice`](https://mdn.io/Array/slice) to ensure dense arrays are
     * returned.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to slice.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns the slice of `array`.
     */
    function slice(array, start, end) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      if (end && typeof end != 'number' && isIterateeCall(array, start, end)) {
        start = 0;
        end = length;
      }
      else {
        start = start == null ? 0 : toInteger(start);
        end = end === undefined ? length : toInteger(end);
      }
      return baseSlice(array, start, end);
    }

    /**
     * Uses a binary search to determine the lowest index at which `value`
     * should be inserted into `array` in order to maintain its sort order.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     * @example
     *
     * _.sortedIndex([30, 50], 40);
     * // => 1
     */
    function sortedIndex(array, value) {
      return baseSortedIndex(array, value);
    }

    /**
     * This method is like `_.sortedIndex` except that it accepts `iteratee`
     * which is invoked for `value` and each element of `array` to compute their
     * sort ranking. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     * @example
     *
     * var objects = [{ 'x': 4 }, { 'x': 5 }];
     *
     * _.sortedIndexBy(objects, { 'x': 4 }, function(o) { return o.x; });
     * // => 0
     *
     * // The `_.property` iteratee shorthand.
     * _.sortedIndexBy(objects, { 'x': 4 }, 'x');
     * // => 0
     */
    function sortedIndexBy(array, value, iteratee) {
      return baseSortedIndexBy(array, value, getIteratee(iteratee, 2));
    }

    /**
     * This method is like `_.indexOf` except that it performs a binary
     * search on a sorted `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {*} value The value to search for.
     * @returns {number} Returns the index of the matched value, else `-1`.
     * @example
     *
     * _.sortedIndexOf([4, 5, 5, 5, 6], 5);
     * // => 1
     */
    function sortedIndexOf(array, value) {
      var length = array == null ? 0 : array.length;
      if (length) {
        var index = baseSortedIndex(array, value);
        if (index < length && eq(array[index], value)) {
          return index;
        }
      }
      return -1;
    }

    /**
     * This method is like `_.sortedIndex` except that it returns the highest
     * index at which `value` should be inserted into `array` in order to
     * maintain its sort order.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     * @example
     *
     * _.sortedLastIndex([4, 5, 5, 5, 6], 5);
     * // => 4
     */
    function sortedLastIndex(array, value) {
      return baseSortedIndex(array, value, true);
    }

    /**
     * This method is like `_.sortedLastIndex` except that it accepts `iteratee`
     * which is invoked for `value` and each element of `array` to compute their
     * sort ranking. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     * @example
     *
     * var objects = [{ 'x': 4 }, { 'x': 5 }];
     *
     * _.sortedLastIndexBy(objects, { 'x': 4 }, function(o) { return o.x; });
     * // => 1
     *
     * // The `_.property` iteratee shorthand.
     * _.sortedLastIndexBy(objects, { 'x': 4 }, 'x');
     * // => 1
     */
    function sortedLastIndexBy(array, value, iteratee) {
      return baseSortedIndexBy(array, value, getIteratee(iteratee, 2), true);
    }

    /**
     * This method is like `_.lastIndexOf` except that it performs a binary
     * search on a sorted `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {*} value The value to search for.
     * @returns {number} Returns the index of the matched value, else `-1`.
     * @example
     *
     * _.sortedLastIndexOf([4, 5, 5, 5, 6], 5);
     * // => 3
     */
    function sortedLastIndexOf(array, value) {
      var length = array == null ? 0 : array.length;
      if (length) {
        var index = baseSortedIndex(array, value, true) - 1;
        if (eq(array[index], value)) {
          return index;
        }
      }
      return -1;
    }

    /**
     * This method is like `_.uniq` except that it's designed and optimized
     * for sorted arrays.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * _.sortedUniq([1, 1, 2]);
     * // => [1, 2]
     */
    function sortedUniq(array) {
      return (array && array.length)
        ? baseSortedUniq(array)
        : [];
    }

    /**
     * This method is like `_.uniqBy` except that it's designed and optimized
     * for sorted arrays.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * _.sortedUniqBy([1.1, 1.2, 2.3, 2.4], Math.floor);
     * // => [1.1, 2.3]
     */
    function sortedUniqBy(array, iteratee) {
      return (array && array.length)
        ? baseSortedUniq(array, getIteratee(iteratee, 2))
        : [];
    }

    /**
     * Gets all but the first element of `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.tail([1, 2, 3]);
     * // => [2, 3]
     */
    function tail(array) {
      var length = array == null ? 0 : array.length;
      return length ? baseSlice(array, 1, length) : [];
    }

    /**
     * Creates a slice of `array` with `n` elements taken from the beginning.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=1] The number of elements to take.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.take([1, 2, 3]);
     * // => [1]
     *
     * _.take([1, 2, 3], 2);
     * // => [1, 2]
     *
     * _.take([1, 2, 3], 5);
     * // => [1, 2, 3]
     *
     * _.take([1, 2, 3], 0);
     * // => []
     */
    function take(array, n, guard) {
      if (!(array && array.length)) {
        return [];
      }
      n = (guard || n === undefined) ? 1 : toInteger(n);
      return baseSlice(array, 0, n < 0 ? 0 : n);
    }

    /**
     * Creates a slice of `array` with `n` elements taken from the end.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=1] The number of elements to take.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.takeRight([1, 2, 3]);
     * // => [3]
     *
     * _.takeRight([1, 2, 3], 2);
     * // => [2, 3]
     *
     * _.takeRight([1, 2, 3], 5);
     * // => [1, 2, 3]
     *
     * _.takeRight([1, 2, 3], 0);
     * // => []
     */
    function takeRight(array, n, guard) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      n = (guard || n === undefined) ? 1 : toInteger(n);
      n = length - n;
      return baseSlice(array, n < 0 ? 0 : n, length);
    }

    /**
     * Creates a slice of `array` with elements taken from the end. Elements are
     * taken until `predicate` returns falsey. The predicate is invoked with
     * three arguments: (value, index, array).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': true },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': false }
     * ];
     *
     * _.takeRightWhile(users, function(o) { return !o.active; });
     * // => objects for ['fred', 'pebbles']
     *
     * // The `_.matches` iteratee shorthand.
     * _.takeRightWhile(users, { 'user': 'pebbles', 'active': false });
     * // => objects for ['pebbles']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.takeRightWhile(users, ['active', false]);
     * // => objects for ['fred', 'pebbles']
     *
     * // The `_.property` iteratee shorthand.
     * _.takeRightWhile(users, 'active');
     * // => []
     */
    function takeRightWhile(array, predicate) {
      return (array && array.length)
        ? baseWhile(array, getIteratee(predicate, 3), false, true)
        : [];
    }

    /**
     * Creates a slice of `array` with elements taken from the beginning. Elements
     * are taken until `predicate` returns falsey. The predicate is invoked with
     * three arguments: (value, index, array).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': false },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': true }
     * ];
     *
     * _.takeWhile(users, function(o) { return !o.active; });
     * // => objects for ['barney', 'fred']
     *
     * // The `_.matches` iteratee shorthand.
     * _.takeWhile(users, { 'user': 'barney', 'active': false });
     * // => objects for ['barney']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.takeWhile(users, ['active', false]);
     * // => objects for ['barney', 'fred']
     *
     * // The `_.property` iteratee shorthand.
     * _.takeWhile(users, 'active');
     * // => []
     */
    function takeWhile(array, predicate) {
      return (array && array.length)
        ? baseWhile(array, getIteratee(predicate, 3))
        : [];
    }

    /**
     * Creates an array of unique values, in order, from all given arrays using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @returns {Array} Returns the new array of combined values.
     * @example
     *
     * _.union([2], [1, 2]);
     * // => [2, 1]
     */
    var union = baseRest(function(arrays) {
      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
    });

    /**
     * This method is like `_.union` except that it accepts `iteratee` which is
     * invoked for each element of each `arrays` to generate the criterion by
     * which uniqueness is computed. Result values are chosen from the first
     * array in which the value occurs. The iteratee is invoked with one argument:
     * (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new array of combined values.
     * @example
     *
     * _.unionBy([2.1], [1.2, 2.3], Math.floor);
     * // => [2.1, 1.2]
     *
     * // The `_.property` iteratee shorthand.
     * _.unionBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
     * // => [{ 'x': 1 }, { 'x': 2 }]
     */
    var unionBy = baseRest(function(arrays) {
      var iteratee = last(arrays);
      if (isArrayLikeObject(iteratee)) {
        iteratee = undefined;
      }
      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee, 2));
    });

    /**
     * This method is like `_.union` except that it accepts `comparator` which
     * is invoked to compare elements of `arrays`. Result values are chosen from
     * the first array in which the value occurs. The comparator is invoked
     * with two arguments: (arrVal, othVal).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of combined values.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
     *
     * _.unionWith(objects, others, _.isEqual);
     * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]
     */
    var unionWith = baseRest(function(arrays) {
      var comparator = last(arrays);
      comparator = typeof comparator == 'function' ? comparator : undefined;
      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined, comparator);
    });

    /**
     * Creates a duplicate-free version of an array, using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons, in which only the first occurrence of each element
     * is kept. The order of result values is determined by the order they occur
     * in the array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * _.uniq([2, 1, 2]);
     * // => [2, 1]
     */
    function uniq(array) {
      return (array && array.length) ? baseUniq(array) : [];
    }

    /**
     * This method is like `_.uniq` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the criterion by which
     * uniqueness is computed. The order of result values is determined by the
     * order they occur in the array. The iteratee is invoked with one argument:
     * (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * _.uniqBy([2.1, 1.2, 2.3], Math.floor);
     * // => [2.1, 1.2]
     *
     * // The `_.property` iteratee shorthand.
     * _.uniqBy([{ 'x': 1 }, { 'x': 2 }, { 'x': 1 }], 'x');
     * // => [{ 'x': 1 }, { 'x': 2 }]
     */
    function uniqBy(array, iteratee) {
      return (array && array.length) ? baseUniq(array, getIteratee(iteratee, 2)) : [];
    }

    /**
     * This method is like `_.uniq` except that it accepts `comparator` which
     * is invoked to compare elements of `array`. The order of result values is
     * determined by the order they occur in the array.The comparator is invoked
     * with two arguments: (arrVal, othVal).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 2 }];
     *
     * _.uniqWith(objects, _.isEqual);
     * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }]
     */
    function uniqWith(array, comparator) {
      comparator = typeof comparator == 'function' ? comparator : undefined;
      return (array && array.length) ? baseUniq(array, undefined, comparator) : [];
    }

    /**
     * This method is like `_.zip` except that it accepts an array of grouped
     * elements and creates an array regrouping the elements to their pre-zip
     * configuration.
     *
     * @static
     * @memberOf _
     * @since 1.2.0
     * @category Array
     * @param {Array} array The array of grouped elements to process.
     * @returns {Array} Returns the new array of regrouped elements.
     * @example
     *
     * var zipped = _.zip(['a', 'b'], [1, 2], [true, false]);
     * // => [['a', 1, true], ['b', 2, false]]
     *
     * _.unzip(zipped);
     * // => [['a', 'b'], [1, 2], [true, false]]
     */
    function unzip(array) {
      if (!(array && array.length)) {
        return [];
      }
      var length = 0;
      array = arrayFilter(array, function(group) {
        if (isArrayLikeObject(group)) {
          length = nativeMax(group.length, length);
          return true;
        }
      });
      return baseTimes(length, function(index) {
        return arrayMap(array, baseProperty(index));
      });
    }

    /**
     * This method is like `_.unzip` except that it accepts `iteratee` to specify
     * how regrouped values should be combined. The iteratee is invoked with the
     * elements of each group: (...group).
     *
     * @static
     * @memberOf _
     * @since 3.8.0
     * @category Array
     * @param {Array} array The array of grouped elements to process.
     * @param {Function} [iteratee=_.identity] The function to combine
     *  regrouped values.
     * @returns {Array} Returns the new array of regrouped elements.
     * @example
     *
     * var zipped = _.zip([1, 2], [10, 20], [100, 200]);
     * // => [[1, 10, 100], [2, 20, 200]]
     *
     * _.unzipWith(zipped, _.add);
     * // => [3, 30, 300]
     */
    function unzipWith(array, iteratee) {
      if (!(array && array.length)) {
        return [];
      }
      var result = unzip(array);
      if (iteratee == null) {
        return result;
      }
      return arrayMap(result, function(group) {
        return apply(iteratee, undefined, group);
      });
    }

    /**
     * Creates an array excluding all given values using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * **Note:** Unlike `_.pull`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {...*} [values] The values to exclude.
     * @returns {Array} Returns the new array of filtered values.
     * @see _.difference, _.xor
     * @example
     *
     * _.without([2, 1, 2, 3], 1, 2);
     * // => [3]
     */
    var without = baseRest(function(array, values) {
      return isArrayLikeObject(array)
        ? baseDifference(array, values)
        : [];
    });

    /**
     * Creates an array of unique values that is the
     * [symmetric difference](https://en.wikipedia.org/wiki/Symmetric_difference)
     * of the given arrays. The order of result values is determined by the order
     * they occur in the arrays.
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @returns {Array} Returns the new array of filtered values.
     * @see _.difference, _.without
     * @example
     *
     * _.xor([2, 1], [2, 3]);
     * // => [1, 3]
     */
    var xor = baseRest(function(arrays) {
      return baseXor(arrayFilter(arrays, isArrayLikeObject));
    });

    /**
     * This method is like `_.xor` except that it accepts `iteratee` which is
     * invoked for each element of each `arrays` to generate the criterion by
     * which by which they're compared. The order of result values is determined
     * by the order they occur in the arrays. The iteratee is invoked with one
     * argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * _.xorBy([2.1, 1.2], [2.3, 3.4], Math.floor);
     * // => [1.2, 3.4]
     *
     * // The `_.property` iteratee shorthand.
     * _.xorBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
     * // => [{ 'x': 2 }]
     */
    var xorBy = baseRest(function(arrays) {
      var iteratee = last(arrays);
      if (isArrayLikeObject(iteratee)) {
        iteratee = undefined;
      }
      return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee, 2));
    });

    /**
     * This method is like `_.xor` except that it accepts `comparator` which is
     * invoked to compare elements of `arrays`. The order of result values is
     * determined by the order they occur in the arrays. The comparator is invoked
     * with two arguments: (arrVal, othVal).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
     *
     * _.xorWith(objects, others, _.isEqual);
     * // => [{ 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]
     */
    var xorWith = baseRest(function(arrays) {
      var comparator = last(arrays);
      comparator = typeof comparator == 'function' ? comparator : undefined;
      return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined, comparator);
    });

    /**
     * Creates an array of grouped elements, the first of which contains the
     * first elements of the given arrays, the second of which contains the
     * second elements of the given arrays, and so on.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {...Array} [arrays] The arrays to process.
     * @returns {Array} Returns the new array of grouped elements.
     * @example
     *
     * _.zip(['a', 'b'], [1, 2], [true, false]);
     * // => [['a', 1, true], ['b', 2, false]]
     */
    var zip = baseRest(unzip);

    /**
     * This method is like `_.fromPairs` except that it accepts two arrays,
     * one of property identifiers and one of corresponding values.
     *
     * @static
     * @memberOf _
     * @since 0.4.0
     * @category Array
     * @param {Array} [props=[]] The property identifiers.
     * @param {Array} [values=[]] The property values.
     * @returns {Object} Returns the new object.
     * @example
     *
     * _.zipObject(['a', 'b'], [1, 2]);
     * // => { 'a': 1, 'b': 2 }
     */
    function zipObject(props, values) {
      return baseZipObject(props || [], values || [], assignValue);
    }

    /**
     * This method is like `_.zipObject` except that it supports property paths.
     *
     * @static
     * @memberOf _
     * @since 4.1.0
     * @category Array
     * @param {Array} [props=[]] The property identifiers.
     * @param {Array} [values=[]] The property values.
     * @returns {Object} Returns the new object.
     * @example
     *
     * _.zipObjectDeep(['a.b[0].c', 'a.b[1].d'], [1, 2]);
     * // => { 'a': { 'b': [{ 'c': 1 }, { 'd': 2 }] } }
     */
    function zipObjectDeep(props, values) {
      return baseZipObject(props || [], values || [], baseSet);
    }

    /**
     * This method is like `_.zip` except that it accepts `iteratee` to specify
     * how grouped values should be combined. The iteratee is invoked with the
     * elements of each group: (...group).
     *
     * @static
     * @memberOf _
     * @since 3.8.0
     * @category Array
     * @param {...Array} [arrays] The arrays to process.
     * @param {Function} [iteratee=_.identity] The function to combine
     *  grouped values.
     * @returns {Array} Returns the new array of grouped elements.
     * @example
     *
     * _.zipWith([1, 2], [10, 20], [100, 200], function(a, b, c) {
     *   return a + b + c;
     * });
     * // => [111, 222]
     */
    var zipWith = baseRest(function(arrays) {
      var length = arrays.length,
          iteratee = length > 1 ? arrays[length - 1] : undefined;

      iteratee = typeof iteratee == 'function' ? (arrays.pop(), iteratee) : undefined;
      return unzipWith(arrays, iteratee);
    });

    /*------------------------------------------------------------------------*/

    /**
     * Creates a `lodash` wrapper instance that wraps `value` with explicit method
     * chain sequences enabled. The result of such sequences must be unwrapped
     * with `_#value`.
     *
     * @static
     * @memberOf _
     * @since 1.3.0
     * @category Seq
     * @param {*} value The value to wrap.
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'age': 36 },
     *   { 'user': 'fred',    'age': 40 },
     *   { 'user': 'pebbles', 'age': 1 }
     * ];
     *
     * var youngest = _
     *   .chain(users)
     *   .sortBy('age')
     *   .map(function(o) {
     *     return o.user + ' is ' + o.age;
     *   })
     *   .head()
     *   .value();
     * // => 'pebbles is 1'
     */
    function chain(value) {
      var result = lodash(value);
      result.__chain__ = true;
      return result;
    }

    /**
     * This method invokes `interceptor` and returns `value`. The interceptor
     * is invoked with one argument; (value). The purpose of this method is to
     * "tap into" a method chain sequence in order to modify intermediate results.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Seq
     * @param {*} value The value to provide to `interceptor`.
     * @param {Function} interceptor The function to invoke.
     * @returns {*} Returns `value`.
     * @example
     *
     * _([1, 2, 3])
     *  .tap(function(array) {
     *    // Mutate input array.
     *    array.pop();
     *  })
     *  .reverse()
     *  .value();
     * // => [2, 1]
     */
    function tap(value, interceptor) {
      interceptor(value);
      return value;
    }

    /**
     * This method is like `_.tap` except that it returns the result of `interceptor`.
     * The purpose of this method is to "pass thru" values replacing intermediate
     * results in a method chain sequence.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Seq
     * @param {*} value The value to provide to `interceptor`.
     * @param {Function} interceptor The function to invoke.
     * @returns {*} Returns the result of `interceptor`.
     * @example
     *
     * _('  abc  ')
     *  .chain()
     *  .trim()
     *  .thru(function(value) {
     *    return [value];
     *  })
     *  .value();
     * // => ['abc']
     */
    function thru(value, interceptor) {
      return interceptor(value);
    }

    /**
     * This method is the wrapper version of `_.at`.
     *
     * @name at
     * @memberOf _
     * @since 1.0.0
     * @category Seq
     * @param {...(string|string[])} [paths] The property paths to pick.
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }, 4] };
     *
     * _(object).at(['a[0].b.c', 'a[1]']).value();
     * // => [3, 4]
     */
    var wrapperAt = flatRest(function(paths) {
      var length = paths.length,
          start = length ? paths[0] : 0,
          value = this.__wrapped__,
          interceptor = function(object) { return baseAt(object, paths); };

      if (length > 1 || this.__actions__.length ||
          !(value instanceof LazyWrapper) || !isIndex(start)) {
        return this.thru(interceptor);
      }
      value = value.slice(start, +start + (length ? 1 : 0));
      value.__actions__.push({
        'func': thru,
        'args': [interceptor],
        'thisArg': undefined
      });
      return new LodashWrapper(value, this.__chain__).thru(function(array) {
        if (length && !array.length) {
          array.push(undefined);
        }
        return array;
      });
    });

    /**
     * Creates a `lodash` wrapper instance with explicit method chain sequences enabled.
     *
     * @name chain
     * @memberOf _
     * @since 0.1.0
     * @category Seq
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36 },
     *   { 'user': 'fred',   'age': 40 }
     * ];
     *
     * // A sequence without explicit chaining.
     * _(users).head();
     * // => { 'user': 'barney', 'age': 36 }
     *
     * // A sequence with explicit chaining.
     * _(users)
     *   .chain()
     *   .head()
     *   .pick('user')
     *   .value();
     * // => { 'user': 'barney' }
     */
    function wrapperChain() {
      return chain(this);
    }

    /**
     * Executes the chain sequence and returns the wrapped result.
     *
     * @name commit
     * @memberOf _
     * @since 3.2.0
     * @category Seq
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var array = [1, 2];
     * var wrapped = _(array).push(3);
     *
     * console.log(array);
     * // => [1, 2]
     *
     * wrapped = wrapped.commit();
     * console.log(array);
     * // => [1, 2, 3]
     *
     * wrapped.last();
     * // => 3
     *
     * console.log(array);
     * // => [1, 2, 3]
     */
    function wrapperCommit() {
      return new LodashWrapper(this.value(), this.__chain__);
    }

    /**
     * Gets the next value on a wrapped object following the
     * [iterator protocol](https://mdn.io/iteration_protocols#iterator).
     *
     * @name next
     * @memberOf _
     * @since 4.0.0
     * @category Seq
     * @returns {Object} Returns the next iterator value.
     * @example
     *
     * var wrapped = _([1, 2]);
     *
     * wrapped.next();
     * // => { 'done': false, 'value': 1 }
     *
     * wrapped.next();
     * // => { 'done': false, 'value': 2 }
     *
     * wrapped.next();
     * // => { 'done': true, 'value': undefined }
     */
    function wrapperNext() {
      if (this.__values__ === undefined) {
        this.__values__ = toArray(this.value());
      }
      var done = this.__index__ >= this.__values__.length,
          value = done ? undefined : this.__values__[this.__index__++];

      return { 'done': done, 'value': value };
    }

    /**
     * Enables the wrapper to be iterable.
     *
     * @name Symbol.iterator
     * @memberOf _
     * @since 4.0.0
     * @category Seq
     * @returns {Object} Returns the wrapper object.
     * @example
     *
     * var wrapped = _([1, 2]);
     *
     * wrapped[Symbol.iterator]() === wrapped;
     * // => true
     *
     * Array.from(wrapped);
     * // => [1, 2]
     */
    function wrapperToIterator() {
      return this;
    }

    /**
     * Creates a clone of the chain sequence planting `value` as the wrapped value.
     *
     * @name plant
     * @memberOf _
     * @since 3.2.0
     * @category Seq
     * @param {*} value The value to plant.
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var wrapped = _([1, 2]).map(square);
     * var other = wrapped.plant([3, 4]);
     *
     * other.value();
     * // => [9, 16]
     *
     * wrapped.value();
     * // => [1, 4]
     */
    function wrapperPlant(value) {
      var result,
          parent = this;

      while (parent instanceof baseLodash) {
        var clone = wrapperClone(parent);
        clone.__index__ = 0;
        clone.__values__ = undefined;
        if (result) {
          previous.__wrapped__ = clone;
        } else {
          result = clone;
        }
        var previous = clone;
        parent = parent.__wrapped__;
      }
      previous.__wrapped__ = value;
      return result;
    }

    /**
     * This method is the wrapper version of `_.reverse`.
     *
     * **Note:** This method mutates the wrapped array.
     *
     * @name reverse
     * @memberOf _
     * @since 0.1.0
     * @category Seq
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var array = [1, 2, 3];
     *
     * _(array).reverse().value()
     * // => [3, 2, 1]
     *
     * console.log(array);
     * // => [3, 2, 1]
     */
    function wrapperReverse() {
      var value = this.__wrapped__;
      if (value instanceof LazyWrapper) {
        var wrapped = value;
        if (this.__actions__.length) {
          wrapped = new LazyWrapper(this);
        }
        wrapped = wrapped.reverse();
        wrapped.__actions__.push({
          'func': thru,
          'args': [reverse],
          'thisArg': undefined
        });
        return new LodashWrapper(wrapped, this.__chain__);
      }
      return this.thru(reverse);
    }

    /**
     * Executes the chain sequence to resolve the unwrapped value.
     *
     * @name value
     * @memberOf _
     * @since 0.1.0
     * @alias toJSON, valueOf
     * @category Seq
     * @returns {*} Returns the resolved unwrapped value.
     * @example
     *
     * _([1, 2, 3]).value();
     * // => [1, 2, 3]
     */
    function wrapperValue() {
      return baseWrapperValue(this.__wrapped__, this.__actions__);
    }

    /*------------------------------------------------------------------------*/

    /**
     * Creates an object composed of keys generated from the results of running
     * each element of `collection` thru `iteratee`. The corresponding value of
     * each key is the number of times the key was returned by `iteratee`. The
     * iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 0.5.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
     * @returns {Object} Returns the composed aggregate object.
     * @example
     *
     * _.countBy([6.1, 4.2, 6.3], Math.floor);
     * // => { '4': 1, '6': 2 }
     *
     * // The `_.property` iteratee shorthand.
     * _.countBy(['one', 'two', 'three'], 'length');
     * // => { '3': 2, '5': 1 }
     */
    var countBy = createAggregator(function(result, value, key) {
      if (hasOwnProperty.call(result, key)) {
        ++result[key];
      } else {
        baseAssignValue(result, key, 1);
      }
    });

    /**
     * Checks if `predicate` returns truthy for **all** elements of `collection`.
     * Iteration is stopped once `predicate` returns falsey. The predicate is
     * invoked with three arguments: (value, index|key, collection).
     *
     * **Note:** This method returns `true` for
     * [empty collections](https://en.wikipedia.org/wiki/Empty_set) because
     * [everything is true](https://en.wikipedia.org/wiki/Vacuous_truth) of
     * elements of empty collections.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {boolean} Returns `true` if all elements pass the predicate check,
     *  else `false`.
     * @example
     *
     * _.every([true, 1, null, 'yes'], Boolean);
     * // => false
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36, 'active': false },
     *   { 'user': 'fred',   'age': 40, 'active': false }
     * ];
     *
     * // The `_.matches` iteratee shorthand.
     * _.every(users, { 'user': 'barney', 'active': false });
     * // => false
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.every(users, ['active', false]);
     * // => true
     *
     * // The `_.property` iteratee shorthand.
     * _.every(users, 'active');
     * // => false
     */
    function every(collection, predicate, guard) {
      var func = isArray(collection) ? arrayEvery : baseEvery;
      if (guard && isIterateeCall(collection, predicate, guard)) {
        predicate = undefined;
      }
      return func(collection, getIteratee(predicate, 3));
    }

    /**
     * Iterates over elements of `collection`, returning an array of all elements
     * `predicate` returns truthy for. The predicate is invoked with three
     * arguments: (value, index|key, collection).
     *
     * **Note:** Unlike `_.remove`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new filtered array.
     * @see _.reject
     * @example
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36, 'active': true },
     *   { 'user': 'fred',   'age': 40, 'active': false }
     * ];
     *
     * _.filter(users, function(o) { return !o.active; });
     * // => objects for ['fred']
     *
     * // The `_.matches` iteratee shorthand.
     * _.filter(users, { 'age': 36, 'active': true });
     * // => objects for ['barney']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.filter(users, ['active', false]);
     * // => objects for ['fred']
     *
     * // The `_.property` iteratee shorthand.
     * _.filter(users, 'active');
     * // => objects for ['barney']
     *
     * // Combining several predicates using `_.overEvery` or `_.overSome`.
     * _.filter(users, _.overSome([{ 'age': 36 }, ['age', 40]]));
     * // => objects for ['fred', 'barney']
     */
    function filter(collection, predicate) {
      var func = isArray(collection) ? arrayFilter : baseFilter;
      return func(collection, getIteratee(predicate, 3));
    }

    /**
     * Iterates over elements of `collection`, returning the first element
     * `predicate` returns truthy for. The predicate is invoked with three
     * arguments: (value, index|key, collection).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param {number} [fromIndex=0] The index to search from.
     * @returns {*} Returns the matched element, else `undefined`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'age': 36, 'active': true },
     *   { 'user': 'fred',    'age': 40, 'active': false },
     *   { 'user': 'pebbles', 'age': 1,  'active': true }
     * ];
     *
     * _.find(users, function(o) { return o.age < 40; });
     * // => object for 'barney'
     *
     * // The `_.matches` iteratee shorthand.
     * _.find(users, { 'age': 1, 'active': true });
     * // => object for 'pebbles'
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.find(users, ['active', false]);
     * // => object for 'fred'
     *
     * // The `_.property` iteratee shorthand.
     * _.find(users, 'active');
     * // => object for 'barney'
     */
    var find = createFind(findIndex);

    /**
     * This method is like `_.find` except that it iterates over elements of
     * `collection` from right to left.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param {number} [fromIndex=collection.length-1] The index to search from.
     * @returns {*} Returns the matched element, else `undefined`.
     * @example
     *
     * _.findLast([1, 2, 3, 4], function(n) {
     *   return n % 2 == 1;
     * });
     * // => 3
     */
    var findLast = createFind(findLastIndex);

    /**
     * Creates a flattened array of values by running each element in `collection`
     * thru `iteratee` and flattening the mapped results. The iteratee is invoked
     * with three arguments: (value, index|key, collection).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * function duplicate(n) {
     *   return [n, n];
     * }
     *
     * _.flatMap([1, 2], duplicate);
     * // => [1, 1, 2, 2]
     */
    function flatMap(collection, iteratee) {
      return baseFlatten(map(collection, iteratee), 1);
    }

    /**
     * This method is like `_.flatMap` except that it recursively flattens the
     * mapped results.
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * function duplicate(n) {
     *   return [[[n, n]]];
     * }
     *
     * _.flatMapDeep([1, 2], duplicate);
     * // => [1, 1, 2, 2]
     */
    function flatMapDeep(collection, iteratee) {
      return baseFlatten(map(collection, iteratee), INFINITY);
    }

    /**
     * This method is like `_.flatMap` except that it recursively flattens the
     * mapped results up to `depth` times.
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @param {number} [depth=1] The maximum recursion depth.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * function duplicate(n) {
     *   return [[[n, n]]];
     * }
     *
     * _.flatMapDepth([1, 2], duplicate, 2);
     * // => [[1, 1], [2, 2]]
     */
    function flatMapDepth(collection, iteratee, depth) {
      depth = depth === undefined ? 1 : toInteger(depth);
      return baseFlatten(map(collection, iteratee), depth);
    }

    /**
     * Iterates over elements of `collection` and invokes `iteratee` for each element.
     * The iteratee is invoked with three arguments: (value, index|key, collection).
     * Iteratee functions may exit iteration early by explicitly returning `false`.
     *
     * **Note:** As with other "Collections" methods, objects with a "length"
     * property are iterated like arrays. To avoid this behavior use `_.forIn`
     * or `_.forOwn` for object iteration.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @alias each
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     * @see _.forEachRight
     * @example
     *
     * _.forEach([1, 2], function(value) {
     *   console.log(value);
     * });
     * // => Logs `1` then `2`.
     *
     * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'a' then 'b' (iteration order is not guaranteed).
     */
    function forEach(collection, iteratee) {
      var func = isArray(collection) ? arrayEach : baseEach;
      return func(collection, getIteratee(iteratee, 3));
    }

    /**
     * This method is like `_.forEach` except that it iterates over elements of
     * `collection` from right to left.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @alias eachRight
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     * @see _.forEach
     * @example
     *
     * _.forEachRight([1, 2], function(value) {
     *   console.log(value);
     * });
     * // => Logs `2` then `1`.
     */
    function forEachRight(collection, iteratee) {
      var func = isArray(collection) ? arrayEachRight : baseEachRight;
      return func(collection, getIteratee(iteratee, 3));
    }

    /**
     * Creates an object composed of keys generated from the results of running
     * each element of `collection` thru `iteratee`. The order of grouped values
     * is determined by the order they occur in `collection`. The corresponding
     * value of each key is an array of elements responsible for generating the
     * key. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
     * @returns {Object} Returns the composed aggregate object.
     * @example
     *
     * _.groupBy([6.1, 4.2, 6.3], Math.floor);
     * // => { '4': [4.2], '6': [6.1, 6.3] }
     *
     * // The `_.property` iteratee shorthand.
     * _.groupBy(['one', 'two', 'three'], 'length');
     * // => { '3': ['one', 'two'], '5': ['three'] }
     */
    var groupBy = createAggregator(function(result, value, key) {
      if (hasOwnProperty.call(result, key)) {
        result[key].push(value);
      } else {
        baseAssignValue(result, key, [value]);
      }
    });

    /**
     * Checks if `value` is in `collection`. If `collection` is a string, it's
     * checked for a substring of `value`, otherwise
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * is used for equality comparisons. If `fromIndex` is negative, it's used as
     * the offset from the end of `collection`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object|string} collection The collection to inspect.
     * @param {*} value The value to search for.
     * @param {number} [fromIndex=0] The index to search from.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
     * @returns {boolean} Returns `true` if `value` is found, else `false`.
     * @example
     *
     * _.includes([1, 2, 3], 1);
     * // => true
     *
     * _.includes([1, 2, 3], 1, 2);
     * // => false
     *
     * _.includes({ 'a': 1, 'b': 2 }, 1);
     * // => true
     *
     * _.includes('abcd', 'bc');
     * // => true
     */
    function includes(collection, value, fromIndex, guard) {
      collection = isArrayLike(collection) ? collection : values(collection);
      fromIndex = (fromIndex && !guard) ? toInteger(fromIndex) : 0;

      var length = collection.length;
      if (fromIndex < 0) {
        fromIndex = nativeMax(length + fromIndex, 0);
      }
      return isString(collection)
        ? (fromIndex <= length && collection.indexOf(value, fromIndex) > -1)
        : (!!length && baseIndexOf(collection, value, fromIndex) > -1);
    }

    /**
     * Invokes the method at `path` of each element in `collection`, returning
     * an array of the results of each invoked method. Any additional arguments
     * are provided to each invoked method. If `path` is a function, it's invoked
     * for, and `this` bound to, each element in `collection`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Array|Function|string} path The path of the method to invoke or
     *  the function invoked per iteration.
     * @param {...*} [args] The arguments to invoke each method with.
     * @returns {Array} Returns the array of results.
     * @example
     *
     * _.invokeMap([[5, 1, 7], [3, 2, 1]], 'sort');
     * // => [[1, 5, 7], [1, 2, 3]]
     *
     * _.invokeMap([123, 456], String.prototype.split, '');
     * // => [['1', '2', '3'], ['4', '5', '6']]
     */
    var invokeMap = baseRest(function(collection, path, args) {
      var index = -1,
          isFunc = typeof path == 'function',
          result = isArrayLike(collection) ? Array(collection.length) : [];

      baseEach(collection, function(value) {
        result[++index] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
      });
      return result;
    });

    /**
     * Creates an object composed of keys generated from the results of running
     * each element of `collection` thru `iteratee`. The corresponding value of
     * each key is the last element responsible for generating the key. The
     * iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
     * @returns {Object} Returns the composed aggregate object.
     * @example
     *
     * var array = [
     *   { 'dir': 'left', 'code': 97 },
     *   { 'dir': 'right', 'code': 100 }
     * ];
     *
     * _.keyBy(array, function(o) {
     *   return String.fromCharCode(o.code);
     * });
     * // => { 'a': { 'dir': 'left', 'code': 97 }, 'd': { 'dir': 'right', 'code': 100 } }
     *
     * _.keyBy(array, 'dir');
     * // => { 'left': { 'dir': 'left', 'code': 97 }, 'right': { 'dir': 'right', 'code': 100 } }
     */
    var keyBy = createAggregator(function(result, value, key) {
      baseAssignValue(result, key, value);
    });

    /**
     * Creates an array of values by running each element in `collection` thru
     * `iteratee`. The iteratee is invoked with three arguments:
     * (value, index|key, collection).
     *
     * Many lodash methods are guarded to work as iteratees for methods like
     * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
     *
     * The guarded methods are:
     * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,
     * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,
     * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,
     * `template`, `trim`, `trimEnd`, `trimStart`, and `words`
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new mapped array.
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * _.map([4, 8], square);
     * // => [16, 64]
     *
     * _.map({ 'a': 4, 'b': 8 }, square);
     * // => [16, 64] (iteration order is not guaranteed)
     *
     * var users = [
     *   { 'user': 'barney' },
     *   { 'user': 'fred' }
     * ];
     *
     * // The `_.property` iteratee shorthand.
     * _.map(users, 'user');
     * // => ['barney', 'fred']
     */
    function map(collection, iteratee) {
      var func = isArray(collection) ? arrayMap : baseMap;
      return func(collection, getIteratee(iteratee, 3));
    }

    /**
     * This method is like `_.sortBy` except that it allows specifying the sort
     * orders of the iteratees to sort by. If `orders` is unspecified, all values
     * are sorted in ascending order. Otherwise, specify an order of "desc" for
     * descending or "asc" for ascending sort order of corresponding values.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Array[]|Function[]|Object[]|string[]} [iteratees=[_.identity]]
     *  The iteratees to sort by.
     * @param {string[]} [orders] The sort orders of `iteratees`.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
     * @returns {Array} Returns the new sorted array.
     * @example
     *
     * var users = [
     *   { 'user': 'fred',   'age': 48 },
     *   { 'user': 'barney', 'age': 34 },
     *   { 'user': 'fred',   'age': 40 },
     *   { 'user': 'barney', 'age': 36 }
     * ];
     *
     * // Sort by `user` in ascending order and by `age` in descending order.
     * _.orderBy(users, ['user', 'age'], ['asc', 'desc']);
     * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 40]]
     */
    function orderBy(collection, iteratees, orders, guard) {
      if (collection == null) {
        return [];
      }
      if (!isArray(iteratees)) {
        iteratees = iteratees == null ? [] : [iteratees];
      }
      orders = guard ? undefined : orders;
      if (!isArray(orders)) {
        orders = orders == null ? [] : [orders];
      }
      return baseOrderBy(collection, iteratees, orders);
    }

    /**
     * Creates an array of elements split into two groups, the first of which
     * contains elements `predicate` returns truthy for, the second of which
     * contains elements `predicate` returns falsey for. The predicate is
     * invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the array of grouped elements.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'age': 36, 'active': false },
     *   { 'user': 'fred',    'age': 40, 'active': true },
     *   { 'user': 'pebbles', 'age': 1,  'active': false }
     * ];
     *
     * _.partition(users, function(o) { return o.active; });
     * // => objects for [['fred'], ['barney', 'pebbles']]
     *
     * // The `_.matches` iteratee shorthand.
     * _.partition(users, { 'age': 1, 'active': false });
     * // => objects for [['pebbles'], ['barney', 'fred']]
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.partition(users, ['active', false]);
     * // => objects for [['barney', 'pebbles'], ['fred']]
     *
     * // The `_.property` iteratee shorthand.
     * _.partition(users, 'active');
     * // => objects for [['fred'], ['barney', 'pebbles']]
     */
    var partition = createAggregator(function(result, value, key) {
      result[key ? 0 : 1].push(value);
    }, function() { return [[], []]; });

    /**
     * Reduces `collection` to a value which is the accumulated result of running
     * each element in `collection` thru `iteratee`, where each successive
     * invocation is supplied the return value of the previous. If `accumulator`
     * is not given, the first element of `collection` is used as the initial
     * value. The iteratee is invoked with four arguments:
     * (accumulator, value, index|key, collection).
     *
     * Many lodash methods are guarded to work as iteratees for methods like
     * `_.reduce`, `_.reduceRight`, and `_.transform`.
     *
     * The guarded methods are:
     * `assign`, `defaults`, `defaultsDeep`, `includes`, `merge`, `orderBy`,
     * and `sortBy`
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @param {*} [accumulator] The initial value.
     * @returns {*} Returns the accumulated value.
     * @see _.reduceRight
     * @example
     *
     * _.reduce([1, 2], function(sum, n) {
     *   return sum + n;
     * }, 0);
     * // => 3
     *
     * _.reduce({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {
     *   (result[value] || (result[value] = [])).push(key);
     *   return result;
     * }, {});
     * // => { '1': ['a', 'c'], '2': ['b'] } (iteration order is not guaranteed)
     */
    function reduce(collection, iteratee, accumulator) {
      var func = isArray(collection) ? arrayReduce : baseReduce,
          initAccum = arguments.length < 3;

      return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEach);
    }

    /**
     * This method is like `_.reduce` except that it iterates over elements of
     * `collection` from right to left.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @param {*} [accumulator] The initial value.
     * @returns {*} Returns the accumulated value.
     * @see _.reduce
     * @example
     *
     * var array = [[0, 1], [2, 3], [4, 5]];
     *
     * _.reduceRight(array, function(flattened, other) {
     *   return flattened.concat(other);
     * }, []);
     * // => [4, 5, 2, 3, 0, 1]
     */
    function reduceRight(collection, iteratee, accumulator) {
      var func = isArray(collection) ? arrayReduceRight : baseReduce,
          initAccum = arguments.length < 3;

      return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEachRight);
    }

    /**
     * The opposite of `_.filter`; this method returns the elements of `collection`
     * that `predicate` does **not** return truthy for.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new filtered array.
     * @see _.filter
     * @example
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36, 'active': false },
     *   { 'user': 'fred',   'age': 40, 'active': true }
     * ];
     *
     * _.reject(users, function(o) { return !o.active; });
     * // => objects for ['fred']
     *
     * // The `_.matches` iteratee shorthand.
     * _.reject(users, { 'age': 40, 'active': true });
     * // => objects for ['barney']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.reject(users, ['active', false]);
     * // => objects for ['fred']
     *
     * // The `_.property` iteratee shorthand.
     * _.reject(users, 'active');
     * // => objects for ['barney']
     */
    function reject(collection, predicate) {
      var func = isArray(collection) ? arrayFilter : baseFilter;
      return func(collection, negate(getIteratee(predicate, 3)));
    }

    /**
     * Gets a random element from `collection`.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to sample.
     * @returns {*} Returns the random element.
     * @example
     *
     * _.sample([1, 2, 3, 4]);
     * // => 2
     */
    function sample(collection) {
      var func = isArray(collection) ? arraySample : baseSample;
      return func(collection);
    }

    /**
     * Gets `n` random elements at unique keys from `collection` up to the
     * size of `collection`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to sample.
     * @param {number} [n=1] The number of elements to sample.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the random elements.
     * @example
     *
     * _.sampleSize([1, 2, 3], 2);
     * // => [3, 1]
     *
     * _.sampleSize([1, 2, 3], 4);
     * // => [2, 3, 1]
     */
    function sampleSize(collection, n, guard) {
      if ((guard ? isIterateeCall(collection, n, guard) : n === undefined)) {
        n = 1;
      } else {
        n = toInteger(n);
      }
      var func = isArray(collection) ? arraySampleSize : baseSampleSize;
      return func(collection, n);
    }

    /**
     * Creates an array of shuffled values, using a version of the
     * [Fisher-Yates shuffle](https://en.wikipedia.org/wiki/Fisher-Yates_shuffle).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to shuffle.
     * @returns {Array} Returns the new shuffled array.
     * @example
     *
     * _.shuffle([1, 2, 3, 4]);
     * // => [4, 1, 3, 2]
     */
    function shuffle(collection) {
      var func = isArray(collection) ? arrayShuffle : baseShuffle;
      return func(collection);
    }

    /**
     * Gets the size of `collection` by returning its length for array-like
     * values or the number of own enumerable string keyed properties for objects.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object|string} collection The collection to inspect.
     * @returns {number} Returns the collection size.
     * @example
     *
     * _.size([1, 2, 3]);
     * // => 3
     *
     * _.size({ 'a': 1, 'b': 2 });
     * // => 2
     *
     * _.size('pebbles');
     * // => 7
     */
    function size(collection) {
      if (collection == null) {
        return 0;
      }
      if (isArrayLike(collection)) {
        return isString(collection) ? stringSize(collection) : collection.length;
      }
      var tag = getTag(collection);
      if (tag == mapTag || tag == setTag) {
        return collection.size;
      }
      return baseKeys(collection).length;
    }

    /**
     * Checks if `predicate` returns truthy for **any** element of `collection`.
     * Iteration is stopped once `predicate` returns truthy. The predicate is
     * invoked with three arguments: (value, index|key, collection).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {boolean} Returns `true` if any element passes the predicate check,
     *  else `false`.
     * @example
     *
     * _.some([null, 0, 'yes', false], Boolean);
     * // => true
     *
     * var users = [
     *   { 'user': 'barney', 'active': true },
     *   { 'user': 'fred',   'active': false }
     * ];
     *
     * // The `_.matches` iteratee shorthand.
     * _.some(users, { 'user': 'barney', 'active': false });
     * // => false
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.some(users, ['active', false]);
     * // => true
     *
     * // The `_.property` iteratee shorthand.
     * _.some(users, 'active');
     * // => true
     */
    function some(collection, predicate, guard) {
      var func = isArray(collection) ? arraySome : baseSome;
      if (guard && isIterateeCall(collection, predicate, guard)) {
        predicate = undefined;
      }
      return func(collection, getIteratee(predicate, 3));
    }

    /**
     * Creates an array of elements, sorted in ascending order by the results of
     * running each element in a collection thru each iteratee. This method
     * performs a stable sort, that is, it preserves the original sort order of
     * equal elements. The iteratees are invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {...(Function|Function[])} [iteratees=[_.identity]]
     *  The iteratees to sort by.
     * @returns {Array} Returns the new sorted array.
     * @example
     *
     * var users = [
     *   { 'user': 'fred',   'age': 48 },
     *   { 'user': 'barney', 'age': 36 },
     *   { 'user': 'fred',   'age': 30 },
     *   { 'user': 'barney', 'age': 34 }
     * ];
     *
     * _.sortBy(users, [function(o) { return o.user; }]);
     * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 30]]
     *
     * _.sortBy(users, ['user', 'age']);
     * // => objects for [['barney', 34], ['barney', 36], ['fred', 30], ['fred', 48]]
     */
    var sortBy = baseRest(function(collection, iteratees) {
      if (collection == null) {
        return [];
      }
      var length = iteratees.length;
      if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
        iteratees = [];
      } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
        iteratees = [iteratees[0]];
      }
      return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
    });

    /*------------------------------------------------------------------------*/

    /**
     * Gets the timestamp of the number of milliseconds that have elapsed since
     * the Unix epoch (1 January 1970 00:00:00 UTC).
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Date
     * @returns {number} Returns the timestamp.
     * @example
     *
     * _.defer(function(stamp) {
     *   console.log(_.now() - stamp);
     * }, _.now());
     * // => Logs the number of milliseconds it took for the deferred invocation.
     */
    var now = ctxNow || function() {
      return root.Date.now();
    };

    /*------------------------------------------------------------------------*/

    /**
     * The opposite of `_.before`; this method creates a function that invokes
     * `func` once it's called `n` or more times.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {number} n The number of calls before `func` is invoked.
     * @param {Function} func The function to restrict.
     * @returns {Function} Returns the new restricted function.
     * @example
     *
     * var saves = ['profile', 'settings'];
     *
     * var done = _.after(saves.length, function() {
     *   console.log('done saving!');
     * });
     *
     * _.forEach(saves, function(type) {
     *   asyncSave({ 'type': type, 'complete': done });
     * });
     * // => Logs 'done saving!' after the two async saves have completed.
     */
    function after(n, func) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      n = toInteger(n);
      return function() {
        if (--n < 1) {
          return func.apply(this, arguments);
        }
      };
    }

    /**
     * Creates a function that invokes `func`, with up to `n` arguments,
     * ignoring any additional arguments.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {Function} func The function to cap arguments for.
     * @param {number} [n=func.length] The arity cap.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Function} Returns the new capped function.
     * @example
     *
     * _.map(['6', '8', '10'], _.ary(parseInt, 1));
     * // => [6, 8, 10]
     */
    function ary(func, n, guard) {
      n = guard ? undefined : n;
      n = (func && n == null) ? func.length : n;
      return createWrap(func, WRAP_ARY_FLAG, undefined, undefined, undefined, undefined, n);
    }

    /**
     * Creates a function that invokes `func`, with the `this` binding and arguments
     * of the created function, while it's called less than `n` times. Subsequent
     * calls to the created function return the result of the last `func` invocation.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {number} n The number of calls at which `func` is no longer invoked.
     * @param {Function} func The function to restrict.
     * @returns {Function} Returns the new restricted function.
     * @example
     *
     * jQuery(element).on('click', _.before(5, addContactToList));
     * // => Allows adding up to 4 contacts to the list.
     */
    function before(n, func) {
      var result;
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      n = toInteger(n);
      return function() {
        if (--n > 0) {
          result = func.apply(this, arguments);
        }
        if (n <= 1) {
          func = undefined;
        }
        return result;
      };
    }

    /**
     * Creates a function that invokes `func` with the `this` binding of `thisArg`
     * and `partials` prepended to the arguments it receives.
     *
     * The `_.bind.placeholder` value, which defaults to `_` in monolithic builds,
     * may be used as a placeholder for partially applied arguments.
     *
     * **Note:** Unlike native `Function#bind`, this method doesn't set the "length"
     * property of bound functions.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to bind.
     * @param {*} thisArg The `this` binding of `func`.
     * @param {...*} [partials] The arguments to be partially applied.
     * @returns {Function} Returns the new bound function.
     * @example
     *
     * function greet(greeting, punctuation) {
     *   return greeting + ' ' + this.user + punctuation;
     * }
     *
     * var object = { 'user': 'fred' };
     *
     * var bound = _.bind(greet, object, 'hi');
     * bound('!');
     * // => 'hi fred!'
     *
     * // Bound with placeholders.
     * var bound = _.bind(greet, object, _, '!');
     * bound('hi');
     * // => 'hi fred!'
     */
    var bind = baseRest(function(func, thisArg, partials) {
      var bitmask = WRAP_BIND_FLAG;
      if (partials.length) {
        var holders = replaceHolders(partials, getHolder(bind));
        bitmask |= WRAP_PARTIAL_FLAG;
      }
      return createWrap(func, bitmask, thisArg, partials, holders);
    });

    /**
     * Creates a function that invokes the method at `object[key]` with `partials`
     * prepended to the arguments it receives.
     *
     * This method differs from `_.bind` by allowing bound functions to reference
     * methods that may be redefined or don't yet exist. See
     * [Peter Michaux's article](http://peter.michaux.ca/articles/lazy-function-definition-pattern)
     * for more details.
     *
     * The `_.bindKey.placeholder` value, which defaults to `_` in monolithic
     * builds, may be used as a placeholder for partially applied arguments.
     *
     * @static
     * @memberOf _
     * @since 0.10.0
     * @category Function
     * @param {Object} object The object to invoke the method on.
     * @param {string} key The key of the method.
     * @param {...*} [partials] The arguments to be partially applied.
     * @returns {Function} Returns the new bound function.
     * @example
     *
     * var object = {
     *   'user': 'fred',
     *   'greet': function(greeting, punctuation) {
     *     return greeting + ' ' + this.user + punctuation;
     *   }
     * };
     *
     * var bound = _.bindKey(object, 'greet', 'hi');
     * bound('!');
     * // => 'hi fred!'
     *
     * object.greet = function(greeting, punctuation) {
     *   return greeting + 'ya ' + this.user + punctuation;
     * };
     *
     * bound('!');
     * // => 'hiya fred!'
     *
     * // Bound with placeholders.
     * var bound = _.bindKey(object, 'greet', _, '!');
     * bound('hi');
     * // => 'hiya fred!'
     */
    var bindKey = baseRest(function(object, key, partials) {
      var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
      if (partials.length) {
        var holders = replaceHolders(partials, getHolder(bindKey));
        bitmask |= WRAP_PARTIAL_FLAG;
      }
      return createWrap(key, bitmask, object, partials, holders);
    });

    /**
     * Creates a function that accepts arguments of `func` and either invokes
     * `func` returning its result, if at least `arity` number of arguments have
     * been provided, or returns a function that accepts the remaining `func`
     * arguments, and so on. The arity of `func` may be specified if `func.length`
     * is not sufficient.
     *
     * The `_.curry.placeholder` value, which defaults to `_` in monolithic builds,
     * may be used as a placeholder for provided arguments.
     *
     * **Note:** This method doesn't set the "length" property of curried functions.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Function
     * @param {Function} func The function to curry.
     * @param {number} [arity=func.length] The arity of `func`.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Function} Returns the new curried function.
     * @example
     *
     * var abc = function(a, b, c) {
     *   return [a, b, c];
     * };
     *
     * var curried = _.curry(abc);
     *
     * curried(1)(2)(3);
     * // => [1, 2, 3]
     *
     * curried(1, 2)(3);
     * // => [1, 2, 3]
     *
     * curried(1, 2, 3);
     * // => [1, 2, 3]
     *
     * // Curried with placeholders.
     * curried(1)(_, 3)(2);
     * // => [1, 2, 3]
     */
    function curry(func, arity, guard) {
      arity = guard ? undefined : arity;
      var result = createWrap(func, WRAP_CURRY_FLAG, undefined, undefined, undefined, undefined, undefined, arity);
      result.placeholder = curry.placeholder;
      return result;
    }

    /**
     * This method is like `_.curry` except that arguments are applied to `func`
     * in the manner of `_.partialRight` instead of `_.partial`.
     *
     * The `_.curryRight.placeholder` value, which defaults to `_` in monolithic
     * builds, may be used as a placeholder for provided arguments.
     *
     * **Note:** This method doesn't set the "length" property of curried functions.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {Function} func The function to curry.
     * @param {number} [arity=func.length] The arity of `func`.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Function} Returns the new curried function.
     * @example
     *
     * var abc = function(a, b, c) {
     *   return [a, b, c];
     * };
     *
     * var curried = _.curryRight(abc);
     *
     * curried(3)(2)(1);
     * // => [1, 2, 3]
     *
     * curried(2, 3)(1);
     * // => [1, 2, 3]
     *
     * curried(1, 2, 3);
     * // => [1, 2, 3]
     *
     * // Curried with placeholders.
     * curried(3)(1, _)(2);
     * // => [1, 2, 3]
     */
    function curryRight(func, arity, guard) {
      arity = guard ? undefined : arity;
      var result = createWrap(func, WRAP_CURRY_RIGHT_FLAG, undefined, undefined, undefined, undefined, undefined, arity);
      result.placeholder = curryRight.placeholder;
      return result;
    }

    /**
     * Creates a debounced function that delays invoking `func` until after `wait`
     * milliseconds have elapsed since the last time the debounced function was
     * invoked. The debounced function comes with a `cancel` method to cancel
     * delayed `func` invocations and a `flush` method to immediately invoke them.
     * Provide `options` to indicate whether `func` should be invoked on the
     * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
     * with the last arguments provided to the debounced function. Subsequent
     * calls to the debounced function return the result of the last `func`
     * invocation.
     *
     * **Note:** If `leading` and `trailing` options are `true`, `func` is
     * invoked on the trailing edge of the timeout only if the debounced function
     * is invoked more than once during the `wait` timeout.
     *
     * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
     * until to the next tick, similar to `setTimeout` with a timeout of `0`.
     *
     * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
     * for details over the differences between `_.debounce` and `_.throttle`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to debounce.
     * @param {number} [wait=0] The number of milliseconds to delay.
     * @param {Object} [options={}] The options object.
     * @param {boolean} [options.leading=false]
     *  Specify invoking on the leading edge of the timeout.
     * @param {number} [options.maxWait]
     *  The maximum time `func` is allowed to be delayed before it's invoked.
     * @param {boolean} [options.trailing=true]
     *  Specify invoking on the trailing edge of the timeout.
     * @returns {Function} Returns the new debounced function.
     * @example
     *
     * // Avoid costly calculations while the window size is in flux.
     * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
     *
     * // Invoke `sendMail` when clicked, debouncing subsequent calls.
     * jQuery(element).on('click', _.debounce(sendMail, 300, {
     *   'leading': true,
     *   'trailing': false
     * }));
     *
     * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
     * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
     * var source = new EventSource('/stream');
     * jQuery(source).on('message', debounced);
     *
     * // Cancel the trailing debounced invocation.
     * jQuery(window).on('popstate', debounced.cancel);
     */
    function debounce(func, wait, options) {
      var lastArgs,
          lastThis,
          maxWait,
          result,
          timerId,
          lastCallTime,
          lastInvokeTime = 0,
          leading = false,
          maxing = false,
          trailing = true;

      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      wait = toNumber(wait) || 0;
      if (isObject(options)) {
        leading = !!options.leading;
        maxing = 'maxWait' in options;
        maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
        trailing = 'trailing' in options ? !!options.trailing : trailing;
      }

      function invokeFunc(time) {
        var args = lastArgs,
            thisArg = lastThis;

        lastArgs = lastThis = undefined;
        lastInvokeTime = time;
        result = func.apply(thisArg, args);
        return result;
      }

      function leadingEdge(time) {
        // Reset any `maxWait` timer.
        lastInvokeTime = time;
        // Start the timer for the trailing edge.
        timerId = setTimeout(timerExpired, wait);
        // Invoke the leading edge.
        return leading ? invokeFunc(time) : result;
      }

      function remainingWait(time) {
        var timeSinceLastCall = time - lastCallTime,
            timeSinceLastInvoke = time - lastInvokeTime,
            timeWaiting = wait - timeSinceLastCall;

        return maxing
          ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke)
          : timeWaiting;
      }

      function shouldInvoke(time) {
        var timeSinceLastCall = time - lastCallTime,
            timeSinceLastInvoke = time - lastInvokeTime;

        // Either this is the first call, activity has stopped and we're at the
        // trailing edge, the system time has gone backwards and we're treating
        // it as the trailing edge, or we've hit the `maxWait` limit.
        return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
          (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
      }

      function timerExpired() {
        var time = now();
        if (shouldInvoke(time)) {
          return trailingEdge(time);
        }
        // Restart the timer.
        timerId = setTimeout(timerExpired, remainingWait(time));
      }

      function trailingEdge(time) {
        timerId = undefined;

        // Only invoke if we have `lastArgs` which means `func` has been
        // debounced at least once.
        if (trailing && lastArgs) {
          return invokeFunc(time);
        }
        lastArgs = lastThis = undefined;
        return result;
      }

      function cancel() {
        if (timerId !== undefined) {
          clearTimeout(timerId);
        }
        lastInvokeTime = 0;
        lastArgs = lastCallTime = lastThis = timerId = undefined;
      }

      function flush() {
        return timerId === undefined ? result : trailingEdge(now());
      }

      function debounced() {
        var time = now(),
            isInvoking = shouldInvoke(time);

        lastArgs = arguments;
        lastThis = this;
        lastCallTime = time;

        if (isInvoking) {
          if (timerId === undefined) {
            return leadingEdge(lastCallTime);
          }
          if (maxing) {
            // Handle invocations in a tight loop.
            clearTimeout(timerId);
            timerId = setTimeout(timerExpired, wait);
            return invokeFunc(lastCallTime);
          }
        }
        if (timerId === undefined) {
          timerId = setTimeout(timerExpired, wait);
        }
        return result;
      }
      debounced.cancel = cancel;
      debounced.flush = flush;
      return debounced;
    }

    /**
     * Defers invoking the `func` until the current call stack has cleared. Any
     * additional arguments are provided to `func` when it's invoked.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to defer.
     * @param {...*} [args] The arguments to invoke `func` with.
     * @returns {number} Returns the timer id.
     * @example
     *
     * _.defer(function(text) {
     *   console.log(text);
     * }, 'deferred');
     * // => Logs 'deferred' after one millisecond.
     */
    var defer = baseRest(function(func, args) {
      return baseDelay(func, 1, args);
    });

    /**
     * Invokes `func` after `wait` milliseconds. Any additional arguments are
     * provided to `func` when it's invoked.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to delay.
     * @param {number} wait The number of milliseconds to delay invocation.
     * @param {...*} [args] The arguments to invoke `func` with.
     * @returns {number} Returns the timer id.
     * @example
     *
     * _.delay(function(text) {
     *   console.log(text);
     * }, 1000, 'later');
     * // => Logs 'later' after one second.
     */
    var delay = baseRest(function(func, wait, args) {
      return baseDelay(func, toNumber(wait) || 0, args);
    });

    /**
     * Creates a function that invokes `func` with arguments reversed.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Function
     * @param {Function} func The function to flip arguments for.
     * @returns {Function} Returns the new flipped function.
     * @example
     *
     * var flipped = _.flip(function() {
     *   return _.toArray(arguments);
     * });
     *
     * flipped('a', 'b', 'c', 'd');
     * // => ['d', 'c', 'b', 'a']
     */
    function flip(func) {
      return createWrap(func, WRAP_FLIP_FLAG);
    }

    /**
     * Creates a function that memoizes the result of `func`. If `resolver` is
     * provided, it determines the cache key for storing the result based on the
     * arguments provided to the memoized function. By default, the first argument
     * provided to the memoized function is used as the map cache key. The `func`
     * is invoked with the `this` binding of the memoized function.
     *
     * **Note:** The cache is exposed as the `cache` property on the memoized
     * function. Its creation may be customized by replacing the `_.memoize.Cache`
     * constructor with one whose instances implement the
     * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
     * method interface of `clear`, `delete`, `get`, `has`, and `set`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to have its output memoized.
     * @param {Function} [resolver] The function to resolve the cache key.
     * @returns {Function} Returns the new memoized function.
     * @example
     *
     * var object = { 'a': 1, 'b': 2 };
     * var other = { 'c': 3, 'd': 4 };
     *
     * var values = _.memoize(_.values);
     * values(object);
     * // => [1, 2]
     *
     * values(other);
     * // => [3, 4]
     *
     * object.a = 2;
     * values(object);
     * // => [1, 2]
     *
     * // Modify the result cache.
     * values.cache.set(object, ['a', 'b']);
     * values(object);
     * // => ['a', 'b']
     *
     * // Replace `_.memoize.Cache`.
     * _.memoize.Cache = WeakMap;
     */
    function memoize(func, resolver) {
      if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      var memoized = function() {
        var args = arguments,
            key = resolver ? resolver.apply(this, args) : args[0],
            cache = memoized.cache;

        if (cache.has(key)) {
          return cache.get(key);
        }
        var result = func.apply(this, args);
        memoized.cache = cache.set(key, result) || cache;
        return result;
      };
      memoized.cache = new (memoize.Cache || MapCache);
      return memoized;
    }

    // Expose `MapCache`.
    memoize.Cache = MapCache;

    /**
     * Creates a function that negates the result of the predicate `func`. The
     * `func` predicate is invoked with the `this` binding and arguments of the
     * created function.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {Function} predicate The predicate to negate.
     * @returns {Function} Returns the new negated function.
     * @example
     *
     * function isEven(n) {
     *   return n % 2 == 0;
     * }
     *
     * _.filter([1, 2, 3, 4, 5, 6], _.negate(isEven));
     * // => [1, 3, 5]
     */
    function negate(predicate) {
      if (typeof predicate != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      return function() {
        var args = arguments;
        switch (args.length) {
          case 0: return !predicate.call(this);
          case 1: return !predicate.call(this, args[0]);
          case 2: return !predicate.call(this, args[0], args[1]);
          case 3: return !predicate.call(this, args[0], args[1], args[2]);
        }
        return !predicate.apply(this, args);
      };
    }

    /**
     * Creates a function that is restricted to invoking `func` once. Repeat calls
     * to the function return the value of the first invocation. The `func` is
     * invoked with the `this` binding and arguments of the created function.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to restrict.
     * @returns {Function} Returns the new restricted function.
     * @example
     *
     * var initialize = _.once(createApplication);
     * initialize();
     * initialize();
     * // => `createApplication` is invoked once
     */
    function once(func) {
      return before(2, func);
    }

    /**
     * Creates a function that invokes `func` with its arguments transformed.
     *
     * @static
     * @since 4.0.0
     * @memberOf _
     * @category Function
     * @param {Function} func The function to wrap.
     * @param {...(Function|Function[])} [transforms=[_.identity]]
     *  The argument transforms.
     * @returns {Function} Returns the new function.
     * @example
     *
     * function doubled(n) {
     *   return n * 2;
     * }
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var func = _.overArgs(function(x, y) {
     *   return [x, y];
     * }, [square, doubled]);
     *
     * func(9, 3);
     * // => [81, 6]
     *
     * func(10, 5);
     * // => [100, 10]
     */
    var overArgs = castRest(function(func, transforms) {
      transforms = (transforms.length == 1 && isArray(transforms[0]))
        ? arrayMap(transforms[0], baseUnary(getIteratee()))
        : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));

      var funcsLength = transforms.length;
      return baseRest(function(args) {
        var index = -1,
            length = nativeMin(args.length, funcsLength);

        while (++index < length) {
          args[index] = transforms[index].call(this, args[index]);
        }
        return apply(func, this, args);
      });
    });

    /**
     * Creates a function that invokes `func` with `partials` prepended to the
     * arguments it receives. This method is like `_.bind` except it does **not**
     * alter the `this` binding.
     *
     * The `_.partial.placeholder` value, which defaults to `_` in monolithic
     * builds, may be used as a placeholder for partially applied arguments.
     *
     * **Note:** This method doesn't set the "length" property of partially
     * applied functions.
     *
     * @static
     * @memberOf _
     * @since 0.2.0
     * @category Function
     * @param {Function} func The function to partially apply arguments to.
     * @param {...*} [partials] The arguments to be partially applied.
     * @returns {Function} Returns the new partially applied function.
     * @example
     *
     * function greet(greeting, name) {
     *   return greeting + ' ' + name;
     * }
     *
     * var sayHelloTo = _.partial(greet, 'hello');
     * sayHelloTo('fred');
     * // => 'hello fred'
     *
     * // Partially applied with placeholders.
     * var greetFred = _.partial(greet, _, 'fred');
     * greetFred('hi');
     * // => 'hi fred'
     */
    var partial = baseRest(function(func, partials) {
      var holders = replaceHolders(partials, getHolder(partial));
      return createWrap(func, WRAP_PARTIAL_FLAG, undefined, partials, holders);
    });

    /**
     * This method is like `_.partial` except that partially applied arguments
     * are appended to the arguments it receives.
     *
     * The `_.partialRight.placeholder` value, which defaults to `_` in monolithic
     * builds, may be used as a placeholder for partially applied arguments.
     *
     * **Note:** This method doesn't set the "length" property of partially
     * applied functions.
     *
     * @static
     * @memberOf _
     * @since 1.0.0
     * @category Function
     * @param {Function} func The function to partially apply arguments to.
     * @param {...*} [partials] The arguments to be partially applied.
     * @returns {Function} Returns the new partially applied function.
     * @example
     *
     * function greet(greeting, name) {
     *   return greeting + ' ' + name;
     * }
     *
     * var greetFred = _.partialRight(greet, 'fred');
     * greetFred('hi');
     * // => 'hi fred'
     *
     * // Partially applied with placeholders.
     * var sayHelloTo = _.partialRight(greet, 'hello', _);
     * sayHelloTo('fred');
     * // => 'hello fred'
     */
    var partialRight = baseRest(function(func, partials) {
      var holders = replaceHolders(partials, getHolder(partialRight));
      return createWrap(func, WRAP_PARTIAL_RIGHT_FLAG, undefined, partials, holders);
    });

    /**
     * Creates a function that invokes `func` with arguments arranged according
     * to the specified `indexes` where the argument value at the first index is
     * provided as the first argument, the argument value at the second index is
     * provided as the second argument, and so on.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {Function} func The function to rearrange arguments for.
     * @param {...(number|number[])} indexes The arranged argument indexes.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var rearged = _.rearg(function(a, b, c) {
     *   return [a, b, c];
     * }, [2, 0, 1]);
     *
     * rearged('b', 'c', 'a')
     * // => ['a', 'b', 'c']
     */
    var rearg = flatRest(function(func, indexes) {
      return createWrap(func, WRAP_REARG_FLAG, undefined, undefined, undefined, indexes);
    });

    /**
     * Creates a function that invokes `func` with the `this` binding of the
     * created function and arguments from `start` and beyond provided as
     * an array.
     *
     * **Note:** This method is based on the
     * [rest parameter](https://mdn.io/rest_parameters).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Function
     * @param {Function} func The function to apply a rest parameter to.
     * @param {number} [start=func.length-1] The start position of the rest parameter.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var say = _.rest(function(what, names) {
     *   return what + ' ' + _.initial(names).join(', ') +
     *     (_.size(names) > 1 ? ', & ' : '') + _.last(names);
     * });
     *
     * say('hello', 'fred', 'barney', 'pebbles');
     * // => 'hello fred, barney, & pebbles'
     */
    function rest(func, start) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      start = start === undefined ? start : toInteger(start);
      return baseRest(func, start);
    }

    /**
     * Creates a function that invokes `func` with the `this` binding of the
     * create function and an array of arguments much like
     * [`Function#apply`](http://www.ecma-international.org/ecma-262/7.0/#sec-function.prototype.apply).
     *
     * **Note:** This method is based on the
     * [spread operator](https://mdn.io/spread_operator).
     *
     * @static
     * @memberOf _
     * @since 3.2.0
     * @category Function
     * @param {Function} func The function to spread arguments over.
     * @param {number} [start=0] The start position of the spread.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var say = _.spread(function(who, what) {
     *   return who + ' says ' + what;
     * });
     *
     * say(['fred', 'hello']);
     * // => 'fred says hello'
     *
     * var numbers = Promise.all([
     *   Promise.resolve(40),
     *   Promise.resolve(36)
     * ]);
     *
     * numbers.then(_.spread(function(x, y) {
     *   return x + y;
     * }));
     * // => a Promise of 76
     */
    function spread(func, start) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      start = start == null ? 0 : nativeMax(toInteger(start), 0);
      return baseRest(function(args) {
        var array = args[start],
            otherArgs = castSlice(args, 0, start);

        if (array) {
          arrayPush(otherArgs, array);
        }
        return apply(func, this, otherArgs);
      });
    }

    /**
     * Creates a throttled function that only invokes `func` at most once per
     * every `wait` milliseconds. The throttled function comes with a `cancel`
     * method to cancel delayed `func` invocations and a `flush` method to
     * immediately invoke them. Provide `options` to indicate whether `func`
     * should be invoked on the leading and/or trailing edge of the `wait`
     * timeout. The `func` is invoked with the last arguments provided to the
     * throttled function. Subsequent calls to the throttled function return the
     * result of the last `func` invocation.
     *
     * **Note:** If `leading` and `trailing` options are `true`, `func` is
     * invoked on the trailing edge of the timeout only if the throttled function
     * is invoked more than once during the `wait` timeout.
     *
     * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
     * until to the next tick, similar to `setTimeout` with a timeout of `0`.
     *
     * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
     * for details over the differences between `_.throttle` and `_.debounce`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to throttle.
     * @param {number} [wait=0] The number of milliseconds to throttle invocations to.
     * @param {Object} [options={}] The options object.
     * @param {boolean} [options.leading=true]
     *  Specify invoking on the leading edge of the timeout.
     * @param {boolean} [options.trailing=true]
     *  Specify invoking on the trailing edge of the timeout.
     * @returns {Function} Returns the new throttled function.
     * @example
     *
     * // Avoid excessively updating the position while scrolling.
     * jQuery(window).on('scroll', _.throttle(updatePosition, 100));
     *
     * // Invoke `renewToken` when the click event is fired, but not more than once every 5 minutes.
     * var throttled = _.throttle(renewToken, 300000, { 'trailing': false });
     * jQuery(element).on('click', throttled);
     *
     * // Cancel the trailing throttled invocation.
     * jQuery(window).on('popstate', throttled.cancel);
     */
    function throttle(func, wait, options) {
      var leading = true,
          trailing = true;

      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      if (isObject(options)) {
        leading = 'leading' in options ? !!options.leading : leading;
        trailing = 'trailing' in options ? !!options.trailing : trailing;
      }
      return debounce(func, wait, {
        'leading': leading,
        'maxWait': wait,
        'trailing': trailing
      });
    }

    /**
     * Creates a function that accepts up to one argument, ignoring any
     * additional arguments.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Function
     * @param {Function} func The function to cap arguments for.
     * @returns {Function} Returns the new capped function.
     * @example
     *
     * _.map(['6', '8', '10'], _.unary(parseInt));
     * // => [6, 8, 10]
     */
    function unary(func) {
      return ary(func, 1);
    }

    /**
     * Creates a function that provides `value` to `wrapper` as its first
     * argument. Any additional arguments provided to the function are appended
     * to those provided to the `wrapper`. The wrapper is invoked with the `this`
     * binding of the created function.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {*} value The value to wrap.
     * @param {Function} [wrapper=identity] The wrapper function.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var p = _.wrap(_.escape, function(func, text) {
     *   return '<p>' + func(text) + '</p>';
     * });
     *
     * p('fred, barney, & pebbles');
     * // => '<p>fred, barney, &amp; pebbles</p>'
     */
    function wrap(value, wrapper) {
      return partial(castFunction(wrapper), value);
    }

    /*------------------------------------------------------------------------*/

    /**
     * Casts `value` as an array if it's not one.
     *
     * @static
     * @memberOf _
     * @since 4.4.0
     * @category Lang
     * @param {*} value The value to inspect.
     * @returns {Array} Returns the cast array.
     * @example
     *
     * _.castArray(1);
     * // => [1]
     *
     * _.castArray({ 'a': 1 });
     * // => [{ 'a': 1 }]
     *
     * _.castArray('abc');
     * // => ['abc']
     *
     * _.castArray(null);
     * // => [null]
     *
     * _.castArray(undefined);
     * // => [undefined]
     *
     * _.castArray();
     * // => []
     *
     * var array = [1, 2, 3];
     * console.log(_.castArray(array) === array);
     * // => true
     */
    function castArray() {
      if (!arguments.length) {
        return [];
      }
      var value = arguments[0];
      return isArray(value) ? value : [value];
    }

    /**
     * Creates a shallow clone of `value`.
     *
     * **Note:** This method is loosely based on the
     * [structured clone algorithm](https://mdn.io/Structured_clone_algorithm)
     * and supports cloning arrays, array buffers, booleans, date objects, maps,
     * numbers, `Object` objects, regexes, sets, strings, symbols, and typed
     * arrays. The own enumerable properties of `arguments` objects are cloned
     * as plain objects. An empty object is returned for uncloneable values such
     * as error objects, functions, DOM nodes, and WeakMaps.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to clone.
     * @returns {*} Returns the cloned value.
     * @see _.cloneDeep
     * @example
     *
     * var objects = [{ 'a': 1 }, { 'b': 2 }];
     *
     * var shallow = _.clone(objects);
     * console.log(shallow[0] === objects[0]);
     * // => true
     */
    function clone(value) {
      return baseClone(value, CLONE_SYMBOLS_FLAG);
    }

    /**
     * This method is like `_.clone` except that it accepts `customizer` which
     * is invoked to produce the cloned value. If `customizer` returns `undefined`,
     * cloning is handled by the method instead. The `customizer` is invoked with
     * up to four arguments; (value [, index|key, object, stack]).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to clone.
     * @param {Function} [customizer] The function to customize cloning.
     * @returns {*} Returns the cloned value.
     * @see _.cloneDeepWith
     * @example
     *
     * function customizer(value) {
     *   if (_.isElement(value)) {
     *     return value.cloneNode(false);
     *   }
     * }
     *
     * var el = _.cloneWith(document.body, customizer);
     *
     * console.log(el === document.body);
     * // => false
     * console.log(el.nodeName);
     * // => 'BODY'
     * console.log(el.childNodes.length);
     * // => 0
     */
    function cloneWith(value, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
    }

    /**
     * This method is like `_.clone` except that it recursively clones `value`.
     *
     * @static
     * @memberOf _
     * @since 1.0.0
     * @category Lang
     * @param {*} value The value to recursively clone.
     * @returns {*} Returns the deep cloned value.
     * @see _.clone
     * @example
     *
     * var objects = [{ 'a': 1 }, { 'b': 2 }];
     *
     * var deep = _.cloneDeep(objects);
     * console.log(deep[0] === objects[0]);
     * // => false
     */
    function cloneDeep(value) {
      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
    }

    /**
     * This method is like `_.cloneWith` except that it recursively clones `value`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to recursively clone.
     * @param {Function} [customizer] The function to customize cloning.
     * @returns {*} Returns the deep cloned value.
     * @see _.cloneWith
     * @example
     *
     * function customizer(value) {
     *   if (_.isElement(value)) {
     *     return value.cloneNode(true);
     *   }
     * }
     *
     * var el = _.cloneDeepWith(document.body, customizer);
     *
     * console.log(el === document.body);
     * // => false
     * console.log(el.nodeName);
     * // => 'BODY'
     * console.log(el.childNodes.length);
     * // => 20
     */
    function cloneDeepWith(value, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
    }

    /**
     * Checks if `object` conforms to `source` by invoking the predicate
     * properties of `source` with the corresponding property values of `object`.
     *
     * **Note:** This method is equivalent to `_.conforms` when `source` is
     * partially applied.
     *
     * @static
     * @memberOf _
     * @since 4.14.0
     * @category Lang
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property predicates to conform to.
     * @returns {boolean} Returns `true` if `object` conforms, else `false`.
     * @example
     *
     * var object = { 'a': 1, 'b': 2 };
     *
     * _.conformsTo(object, { 'b': function(n) { return n > 1; } });
     * // => true
     *
     * _.conformsTo(object, { 'b': function(n) { return n > 2; } });
     * // => false
     */
    function conformsTo(object, source) {
      return source == null || baseConformsTo(object, source, keys(source));
    }

    /**
     * Performs a
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * comparison between two values to determine if they are equivalent.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     * @example
     *
     * var object = { 'a': 1 };
     * var other = { 'a': 1 };
     *
     * _.eq(object, object);
     * // => true
     *
     * _.eq(object, other);
     * // => false
     *
     * _.eq('a', 'a');
     * // => true
     *
     * _.eq('a', Object('a'));
     * // => false
     *
     * _.eq(NaN, NaN);
     * // => true
     */
    function eq(value, other) {
      return value === other || (value !== value && other !== other);
    }

    /**
     * Checks if `value` is greater than `other`.
     *
     * @static
     * @memberOf _
     * @since 3.9.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is greater than `other`,
     *  else `false`.
     * @see _.lt
     * @example
     *
     * _.gt(3, 1);
     * // => true
     *
     * _.gt(3, 3);
     * // => false
     *
     * _.gt(1, 3);
     * // => false
     */
    var gt = createRelationalOperation(baseGt);

    /**
     * Checks if `value` is greater than or equal to `other`.
     *
     * @static
     * @memberOf _
     * @since 3.9.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is greater than or equal to
     *  `other`, else `false`.
     * @see _.lte
     * @example
     *
     * _.gte(3, 1);
     * // => true
     *
     * _.gte(3, 3);
     * // => true
     *
     * _.gte(1, 3);
     * // => false
     */
    var gte = createRelationalOperation(function(value, other) {
      return value >= other;
    });

    /**
     * Checks if `value` is likely an `arguments` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an `arguments` object,
     *  else `false`.
     * @example
     *
     * _.isArguments(function() { return arguments; }());
     * // => true
     *
     * _.isArguments([1, 2, 3]);
     * // => false
     */
    var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
      return isObjectLike(value) && hasOwnProperty.call(value, 'callee') &&
        !propertyIsEnumerable.call(value, 'callee');
    };

    /**
     * Checks if `value` is classified as an `Array` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array, else `false`.
     * @example
     *
     * _.isArray([1, 2, 3]);
     * // => true
     *
     * _.isArray(document.body.children);
     * // => false
     *
     * _.isArray('abc');
     * // => false
     *
     * _.isArray(_.noop);
     * // => false
     */
    var isArray = Array.isArray;

    /**
     * Checks if `value` is classified as an `ArrayBuffer` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array buffer, else `false`.
     * @example
     *
     * _.isArrayBuffer(new ArrayBuffer(2));
     * // => true
     *
     * _.isArrayBuffer(new Array(2));
     * // => false
     */
    var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;

    /**
     * Checks if `value` is array-like. A value is considered array-like if it's
     * not a function and has a `value.length` that's an integer greater than or
     * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
     * @example
     *
     * _.isArrayLike([1, 2, 3]);
     * // => true
     *
     * _.isArrayLike(document.body.children);
     * // => true
     *
     * _.isArrayLike('abc');
     * // => true
     *
     * _.isArrayLike(_.noop);
     * // => false
     */
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }

    /**
     * This method is like `_.isArrayLike` except that it also checks if `value`
     * is an object.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array-like object,
     *  else `false`.
     * @example
     *
     * _.isArrayLikeObject([1, 2, 3]);
     * // => true
     *
     * _.isArrayLikeObject(document.body.children);
     * // => true
     *
     * _.isArrayLikeObject('abc');
     * // => false
     *
     * _.isArrayLikeObject(_.noop);
     * // => false
     */
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }

    /**
     * Checks if `value` is classified as a boolean primitive or object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a boolean, else `false`.
     * @example
     *
     * _.isBoolean(false);
     * // => true
     *
     * _.isBoolean(null);
     * // => false
     */
    function isBoolean(value) {
      return value === true || value === false ||
        (isObjectLike(value) && baseGetTag(value) == boolTag);
    }

    /**
     * Checks if `value` is a buffer.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
     * @example
     *
     * _.isBuffer(new Buffer(2));
     * // => true
     *
     * _.isBuffer(new Uint8Array(2));
     * // => false
     */
    var isBuffer = nativeIsBuffer || stubFalse;

    /**
     * Checks if `value` is classified as a `Date` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a date object, else `false`.
     * @example
     *
     * _.isDate(new Date);
     * // => true
     *
     * _.isDate('Mon April 23 2012');
     * // => false
     */
    var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;

    /**
     * Checks if `value` is likely a DOM element.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a DOM element, else `false`.
     * @example
     *
     * _.isElement(document.body);
     * // => true
     *
     * _.isElement('<body>');
     * // => false
     */
    function isElement(value) {
      return isObjectLike(value) && value.nodeType === 1 && !isPlainObject(value);
    }

    /**
     * Checks if `value` is an empty object, collection, map, or set.
     *
     * Objects are considered empty if they have no own enumerable string keyed
     * properties.
     *
     * Array-like values such as `arguments` objects, arrays, buffers, strings, or
     * jQuery-like collections are considered empty if they have a `length` of `0`.
     * Similarly, maps and sets are considered empty if they have a `size` of `0`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is empty, else `false`.
     * @example
     *
     * _.isEmpty(null);
     * // => true
     *
     * _.isEmpty(true);
     * // => true
     *
     * _.isEmpty(1);
     * // => true
     *
     * _.isEmpty([1, 2, 3]);
     * // => false
     *
     * _.isEmpty({ 'a': 1 });
     * // => false
     */
    function isEmpty(value) {
      if (value == null) {
        return true;
      }
      if (isArrayLike(value) &&
          (isArray(value) || typeof value == 'string' || typeof value.splice == 'function' ||
            isBuffer(value) || isTypedArray(value) || isArguments(value))) {
        return !value.length;
      }
      var tag = getTag(value);
      if (tag == mapTag || tag == setTag) {
        return !value.size;
      }
      if (isPrototype(value)) {
        return !baseKeys(value).length;
      }
      for (var key in value) {
        if (hasOwnProperty.call(value, key)) {
          return false;
        }
      }
      return true;
    }

    /**
     * Performs a deep comparison between two values to determine if they are
     * equivalent.
     *
     * **Note:** This method supports comparing arrays, array buffers, booleans,
     * date objects, error objects, maps, numbers, `Object` objects, regexes,
     * sets, strings, symbols, and typed arrays. `Object` objects are compared
     * by their own, not inherited, enumerable properties. Functions and DOM
     * nodes are compared by strict equality, i.e. `===`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     * @example
     *
     * var object = { 'a': 1 };
     * var other = { 'a': 1 };
     *
     * _.isEqual(object, other);
     * // => true
     *
     * object === other;
     * // => false
     */
    function isEqual(value, other) {
      return baseIsEqual(value, other);
    }

    /**
     * This method is like `_.isEqual` except that it accepts `customizer` which
     * is invoked to compare values. If `customizer` returns `undefined`, comparisons
     * are handled by the method instead. The `customizer` is invoked with up to
     * six arguments: (objValue, othValue [, index|key, object, other, stack]).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @param {Function} [customizer] The function to customize comparisons.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     * @example
     *
     * function isGreeting(value) {
     *   return /^h(?:i|ello)$/.test(value);
     * }
     *
     * function customizer(objValue, othValue) {
     *   if (isGreeting(objValue) && isGreeting(othValue)) {
     *     return true;
     *   }
     * }
     *
     * var array = ['hello', 'goodbye'];
     * var other = ['hi', 'goodbye'];
     *
     * _.isEqualWith(array, other, customizer);
     * // => true
     */
    function isEqualWith(value, other, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      var result = customizer ? customizer(value, other) : undefined;
      return result === undefined ? baseIsEqual(value, other, undefined, customizer) : !!result;
    }

    /**
     * Checks if `value` is an `Error`, `EvalError`, `RangeError`, `ReferenceError`,
     * `SyntaxError`, `TypeError`, or `URIError` object.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an error object, else `false`.
     * @example
     *
     * _.isError(new Error);
     * // => true
     *
     * _.isError(Error);
     * // => false
     */
    function isError(value) {
      if (!isObjectLike(value)) {
        return false;
      }
      var tag = baseGetTag(value);
      return tag == errorTag || tag == domExcTag ||
        (typeof value.message == 'string' && typeof value.name == 'string' && !isPlainObject(value));
    }

    /**
     * Checks if `value` is a finite primitive number.
     *
     * **Note:** This method is based on
     * [`Number.isFinite`](https://mdn.io/Number/isFinite).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a finite number, else `false`.
     * @example
     *
     * _.isFinite(3);
     * // => true
     *
     * _.isFinite(Number.MIN_VALUE);
     * // => true
     *
     * _.isFinite(Infinity);
     * // => false
     *
     * _.isFinite('3');
     * // => false
     */
    function isFinite(value) {
      return typeof value == 'number' && nativeIsFinite(value);
    }

    /**
     * Checks if `value` is classified as a `Function` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a function, else `false`.
     * @example
     *
     * _.isFunction(_);
     * // => true
     *
     * _.isFunction(/abc/);
     * // => false
     */
    function isFunction(value) {
      if (!isObject(value)) {
        return false;
      }
      // The use of `Object#toString` avoids issues with the `typeof` operator
      // in Safari 9 which returns 'object' for typed arrays and other constructors.
      var tag = baseGetTag(value);
      return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
    }

    /**
     * Checks if `value` is an integer.
     *
     * **Note:** This method is based on
     * [`Number.isInteger`](https://mdn.io/Number/isInteger).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an integer, else `false`.
     * @example
     *
     * _.isInteger(3);
     * // => true
     *
     * _.isInteger(Number.MIN_VALUE);
     * // => false
     *
     * _.isInteger(Infinity);
     * // => false
     *
     * _.isInteger('3');
     * // => false
     */
    function isInteger(value) {
      return typeof value == 'number' && value == toInteger(value);
    }

    /**
     * Checks if `value` is a valid array-like length.
     *
     * **Note:** This method is loosely based on
     * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
     * @example
     *
     * _.isLength(3);
     * // => true
     *
     * _.isLength(Number.MIN_VALUE);
     * // => false
     *
     * _.isLength(Infinity);
     * // => false
     *
     * _.isLength('3');
     * // => false
     */
    function isLength(value) {
      return typeof value == 'number' &&
        value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }

    /**
     * Checks if `value` is the
     * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
     * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an object, else `false`.
     * @example
     *
     * _.isObject({});
     * // => true
     *
     * _.isObject([1, 2, 3]);
     * // => true
     *
     * _.isObject(_.noop);
     * // => true
     *
     * _.isObject(null);
     * // => false
     */
    function isObject(value) {
      var type = typeof value;
      return value != null && (type == 'object' || type == 'function');
    }

    /**
     * Checks if `value` is object-like. A value is object-like if it's not `null`
     * and has a `typeof` result of "object".
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
     * @example
     *
     * _.isObjectLike({});
     * // => true
     *
     * _.isObjectLike([1, 2, 3]);
     * // => true
     *
     * _.isObjectLike(_.noop);
     * // => false
     *
     * _.isObjectLike(null);
     * // => false
     */
    function isObjectLike(value) {
      return value != null && typeof value == 'object';
    }

    /**
     * Checks if `value` is classified as a `Map` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a map, else `false`.
     * @example
     *
     * _.isMap(new Map);
     * // => true
     *
     * _.isMap(new WeakMap);
     * // => false
     */
    var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;

    /**
     * Performs a partial deep comparison between `object` and `source` to
     * determine if `object` contains equivalent property values.
     *
     * **Note:** This method is equivalent to `_.matches` when `source` is
     * partially applied.
     *
     * Partial comparisons will match empty array and empty object `source`
     * values against any array or object value, respectively. See `_.isEqual`
     * for a list of supported value comparisons.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property values to match.
     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
     * @example
     *
     * var object = { 'a': 1, 'b': 2 };
     *
     * _.isMatch(object, { 'b': 2 });
     * // => true
     *
     * _.isMatch(object, { 'b': 1 });
     * // => false
     */
    function isMatch(object, source) {
      return object === source || baseIsMatch(object, source, getMatchData(source));
    }

    /**
     * This method is like `_.isMatch` except that it accepts `customizer` which
     * is invoked to compare values. If `customizer` returns `undefined`, comparisons
     * are handled by the method instead. The `customizer` is invoked with five
     * arguments: (objValue, srcValue, index|key, object, source).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property values to match.
     * @param {Function} [customizer] The function to customize comparisons.
     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
     * @example
     *
     * function isGreeting(value) {
     *   return /^h(?:i|ello)$/.test(value);
     * }
     *
     * function customizer(objValue, srcValue) {
     *   if (isGreeting(objValue) && isGreeting(srcValue)) {
     *     return true;
     *   }
     * }
     *
     * var object = { 'greeting': 'hello' };
     * var source = { 'greeting': 'hi' };
     *
     * _.isMatchWith(object, source, customizer);
     * // => true
     */
    function isMatchWith(object, source, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return baseIsMatch(object, source, getMatchData(source), customizer);
    }

    /**
     * Checks if `value` is `NaN`.
     *
     * **Note:** This method is based on
     * [`Number.isNaN`](https://mdn.io/Number/isNaN) and is not the same as
     * global [`isNaN`](https://mdn.io/isNaN) which returns `true` for
     * `undefined` and other non-number values.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
     * @example
     *
     * _.isNaN(NaN);
     * // => true
     *
     * _.isNaN(new Number(NaN));
     * // => true
     *
     * isNaN(undefined);
     * // => true
     *
     * _.isNaN(undefined);
     * // => false
     */
    function isNaN(value) {
      // An `NaN` primitive is the only value that is not equal to itself.
      // Perform the `toStringTag` check first to avoid errors with some
      // ActiveX objects in IE.
      return isNumber(value) && value != +value;
    }

    /**
     * Checks if `value` is a pristine native function.
     *
     * **Note:** This method can't reliably detect native functions in the presence
     * of the core-js package because core-js circumvents this kind of detection.
     * Despite multiple requests, the core-js maintainer has made it clear: any
     * attempt to fix the detection will be obstructed. As a result, we're left
     * with little choice but to throw an error. Unfortunately, this also affects
     * packages, like [babel-polyfill](https://www.npmjs.com/package/babel-polyfill),
     * which rely on core-js.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a native function,
     *  else `false`.
     * @example
     *
     * _.isNative(Array.prototype.push);
     * // => true
     *
     * _.isNative(_);
     * // => false
     */
    function isNative(value) {
      if (isMaskable(value)) {
        throw new Error(CORE_ERROR_TEXT);
      }
      return baseIsNative(value);
    }

    /**
     * Checks if `value` is `null`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is `null`, else `false`.
     * @example
     *
     * _.isNull(null);
     * // => true
     *
     * _.isNull(void 0);
     * // => false
     */
    function isNull(value) {
      return value === null;
    }

    /**
     * Checks if `value` is `null` or `undefined`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is nullish, else `false`.
     * @example
     *
     * _.isNil(null);
     * // => true
     *
     * _.isNil(void 0);
     * // => true
     *
     * _.isNil(NaN);
     * // => false
     */
    function isNil(value) {
      return value == null;
    }

    /**
     * Checks if `value` is classified as a `Number` primitive or object.
     *
     * **Note:** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
     * classified as numbers, use the `_.isFinite` method.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a number, else `false`.
     * @example
     *
     * _.isNumber(3);
     * // => true
     *
     * _.isNumber(Number.MIN_VALUE);
     * // => true
     *
     * _.isNumber(Infinity);
     * // => true
     *
     * _.isNumber('3');
     * // => false
     */
    function isNumber(value) {
      return typeof value == 'number' ||
        (isObjectLike(value) && baseGetTag(value) == numberTag);
    }

    /**
     * Checks if `value` is a plain object, that is, an object created by the
     * `Object` constructor or one with a `[[Prototype]]` of `null`.
     *
     * @static
     * @memberOf _
     * @since 0.8.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     * }
     *
     * _.isPlainObject(new Foo);
     * // => false
     *
     * _.isPlainObject([1, 2, 3]);
     * // => false
     *
     * _.isPlainObject({ 'x': 0, 'y': 0 });
     * // => true
     *
     * _.isPlainObject(Object.create(null));
     * // => true
     */
    function isPlainObject(value) {
      if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
        return false;
      }
      var proto = getPrototype(value);
      if (proto === null) {
        return true;
      }
      var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;
      return typeof Ctor == 'function' && Ctor instanceof Ctor &&
        funcToString.call(Ctor) == objectCtorString;
    }

    /**
     * Checks if `value` is classified as a `RegExp` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.
     * @example
     *
     * _.isRegExp(/abc/);
     * // => true
     *
     * _.isRegExp('/abc/');
     * // => false
     */
    var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;

    /**
     * Checks if `value` is a safe integer. An integer is safe if it's an IEEE-754
     * double precision number which isn't the result of a rounded unsafe integer.
     *
     * **Note:** This method is based on
     * [`Number.isSafeInteger`](https://mdn.io/Number/isSafeInteger).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a safe integer, else `false`.
     * @example
     *
     * _.isSafeInteger(3);
     * // => true
     *
     * _.isSafeInteger(Number.MIN_VALUE);
     * // => false
     *
     * _.isSafeInteger(Infinity);
     * // => false
     *
     * _.isSafeInteger('3');
     * // => false
     */
    function isSafeInteger(value) {
      return isInteger(value) && value >= -MAX_SAFE_INTEGER && value <= MAX_SAFE_INTEGER;
    }

    /**
     * Checks if `value` is classified as a `Set` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a set, else `false`.
     * @example
     *
     * _.isSet(new Set);
     * // => true
     *
     * _.isSet(new WeakSet);
     * // => false
     */
    var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

    /**
     * Checks if `value` is classified as a `String` primitive or object.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a string, else `false`.
     * @example
     *
     * _.isString('abc');
     * // => true
     *
     * _.isString(1);
     * // => false
     */
    function isString(value) {
      return typeof value == 'string' ||
        (!isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag);
    }

    /**
     * Checks if `value` is classified as a `Symbol` primitive or object.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
     * @example
     *
     * _.isSymbol(Symbol.iterator);
     * // => true
     *
     * _.isSymbol('abc');
     * // => false
     */
    function isSymbol(value) {
      return typeof value == 'symbol' ||
        (isObjectLike(value) && baseGetTag(value) == symbolTag);
    }

    /**
     * Checks if `value` is classified as a typed array.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
     * @example
     *
     * _.isTypedArray(new Uint8Array);
     * // => true
     *
     * _.isTypedArray([]);
     * // => false
     */
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

    /**
     * Checks if `value` is `undefined`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is `undefined`, else `false`.
     * @example
     *
     * _.isUndefined(void 0);
     * // => true
     *
     * _.isUndefined(null);
     * // => false
     */
    function isUndefined(value) {
      return value === undefined;
    }

    /**
     * Checks if `value` is classified as a `WeakMap` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a weak map, else `false`.
     * @example
     *
     * _.isWeakMap(new WeakMap);
     * // => true
     *
     * _.isWeakMap(new Map);
     * // => false
     */
    function isWeakMap(value) {
      return isObjectLike(value) && getTag(value) == weakMapTag;
    }

    /**
     * Checks if `value` is classified as a `WeakSet` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a weak set, else `false`.
     * @example
     *
     * _.isWeakSet(new WeakSet);
     * // => true
     *
     * _.isWeakSet(new Set);
     * // => false
     */
    function isWeakSet(value) {
      return isObjectLike(value) && baseGetTag(value) == weakSetTag;
    }

    /**
     * Checks if `value` is less than `other`.
     *
     * @static
     * @memberOf _
     * @since 3.9.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is less than `other`,
     *  else `false`.
     * @see _.gt
     * @example
     *
     * _.lt(1, 3);
     * // => true
     *
     * _.lt(3, 3);
     * // => false
     *
     * _.lt(3, 1);
     * // => false
     */
    var lt = createRelationalOperation(baseLt);

    /**
     * Checks if `value` is less than or equal to `other`.
     *
     * @static
     * @memberOf _
     * @since 3.9.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is less than or equal to
     *  `other`, else `false`.
     * @see _.gte
     * @example
     *
     * _.lte(1, 3);
     * // => true
     *
     * _.lte(3, 3);
     * // => true
     *
     * _.lte(3, 1);
     * // => false
     */
    var lte = createRelationalOperation(function(value, other) {
      return value <= other;
    });

    /**
     * Converts `value` to an array.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {Array} Returns the converted array.
     * @example
     *
     * _.toArray({ 'a': 1, 'b': 2 });
     * // => [1, 2]
     *
     * _.toArray('abc');
     * // => ['a', 'b', 'c']
     *
     * _.toArray(1);
     * // => []
     *
     * _.toArray(null);
     * // => []
     */
    function toArray(value) {
      if (!value) {
        return [];
      }
      if (isArrayLike(value)) {
        return isString(value) ? stringToArray(value) : copyArray(value);
      }
      if (symIterator && value[symIterator]) {
        return iteratorToArray(value[symIterator]());
      }
      var tag = getTag(value),
          func = tag == mapTag ? mapToArray : (tag == setTag ? setToArray : values);

      return func(value);
    }

    /**
     * Converts `value` to a finite number.
     *
     * @static
     * @memberOf _
     * @since 4.12.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted number.
     * @example
     *
     * _.toFinite(3.2);
     * // => 3.2
     *
     * _.toFinite(Number.MIN_VALUE);
     * // => 5e-324
     *
     * _.toFinite(Infinity);
     * // => 1.7976931348623157e+308
     *
     * _.toFinite('3.2');
     * // => 3.2
     */
    function toFinite(value) {
      if (!value) {
        return value === 0 ? value : 0;
      }
      value = toNumber(value);
      if (value === INFINITY || value === -INFINITY) {
        var sign = (value < 0 ? -1 : 1);
        return sign * MAX_INTEGER;
      }
      return value === value ? value : 0;
    }

    /**
     * Converts `value` to an integer.
     *
     * **Note:** This method is loosely based on
     * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.toInteger(3.2);
     * // => 3
     *
     * _.toInteger(Number.MIN_VALUE);
     * // => 0
     *
     * _.toInteger(Infinity);
     * // => 1.7976931348623157e+308
     *
     * _.toInteger('3.2');
     * // => 3
     */
    function toInteger(value) {
      var result = toFinite(value),
          remainder = result % 1;

      return result === result ? (remainder ? result - remainder : result) : 0;
    }

    /**
     * Converts `value` to an integer suitable for use as the length of an
     * array-like object.
     *
     * **Note:** This method is based on
     * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.toLength(3.2);
     * // => 3
     *
     * _.toLength(Number.MIN_VALUE);
     * // => 0
     *
     * _.toLength(Infinity);
     * // => 4294967295
     *
     * _.toLength('3.2');
     * // => 3
     */
    function toLength(value) {
      return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
    }

    /**
     * Converts `value` to a number.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to process.
     * @returns {number} Returns the number.
     * @example
     *
     * _.toNumber(3.2);
     * // => 3.2
     *
     * _.toNumber(Number.MIN_VALUE);
     * // => 5e-324
     *
     * _.toNumber(Infinity);
     * // => Infinity
     *
     * _.toNumber('3.2');
     * // => 3.2
     */
    function toNumber(value) {
      if (typeof value == 'number') {
        return value;
      }
      if (isSymbol(value)) {
        return NAN;
      }
      if (isObject(value)) {
        var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
        value = isObject(other) ? (other + '') : other;
      }
      if (typeof value != 'string') {
        return value === 0 ? value : +value;
      }
      value = baseTrim(value);
      var isBinary = reIsBinary.test(value);
      return (isBinary || reIsOctal.test(value))
        ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
        : (reIsBadHex.test(value) ? NAN : +value);
    }

    /**
     * Converts `value` to a plain object flattening inherited enumerable string
     * keyed properties of `value` to own properties of the plain object.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {Object} Returns the converted plain object.
     * @example
     *
     * function Foo() {
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.assign({ 'a': 1 }, new Foo);
     * // => { 'a': 1, 'b': 2 }
     *
     * _.assign({ 'a': 1 }, _.toPlainObject(new Foo));
     * // => { 'a': 1, 'b': 2, 'c': 3 }
     */
    function toPlainObject(value) {
      return copyObject(value, keysIn(value));
    }

    /**
     * Converts `value` to a safe integer. A safe integer can be compared and
     * represented correctly.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.toSafeInteger(3.2);
     * // => 3
     *
     * _.toSafeInteger(Number.MIN_VALUE);
     * // => 0
     *
     * _.toSafeInteger(Infinity);
     * // => 9007199254740991
     *
     * _.toSafeInteger('3.2');
     * // => 3
     */
    function toSafeInteger(value) {
      return value
        ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER)
        : (value === 0 ? value : 0);
    }

    /**
     * Converts `value` to a string. An empty string is returned for `null`
     * and `undefined` values. The sign of `-0` is preserved.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {string} Returns the converted string.
     * @example
     *
     * _.toString(null);
     * // => ''
     *
     * _.toString(-0);
     * // => '-0'
     *
     * _.toString([1, 2, 3]);
     * // => '1,2,3'
     */
    function toString(value) {
      return value == null ? '' : baseToString(value);
    }

    /*------------------------------------------------------------------------*/

    /**
     * Assigns own enumerable string keyed properties of source objects to the
     * destination object. Source objects are applied from left to right.
     * Subsequent sources overwrite property assignments of previous sources.
     *
     * **Note:** This method mutates `object` and is loosely based on
     * [`Object.assign`](https://mdn.io/Object/assign).
     *
     * @static
     * @memberOf _
     * @since 0.10.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @see _.assignIn
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     * }
     *
     * function Bar() {
     *   this.c = 3;
     * }
     *
     * Foo.prototype.b = 2;
     * Bar.prototype.d = 4;
     *
     * _.assign({ 'a': 0 }, new Foo, new Bar);
     * // => { 'a': 1, 'c': 3 }
     */
    var assign = createAssigner(function(object, source) {
      if (isPrototype(source) || isArrayLike(source)) {
        copyObject(source, keys(source), object);
        return;
      }
      for (var key in source) {
        if (hasOwnProperty.call(source, key)) {
          assignValue(object, key, source[key]);
        }
      }
    });

    /**
     * This method is like `_.assign` except that it iterates over own and
     * inherited source properties.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @alias extend
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @see _.assign
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     * }
     *
     * function Bar() {
     *   this.c = 3;
     * }
     *
     * Foo.prototype.b = 2;
     * Bar.prototype.d = 4;
     *
     * _.assignIn({ 'a': 0 }, new Foo, new Bar);
     * // => { 'a': 1, 'b': 2, 'c': 3, 'd': 4 }
     */
    var assignIn = createAssigner(function(object, source) {
      copyObject(source, keysIn(source), object);
    });

    /**
     * This method is like `_.assignIn` except that it accepts `customizer`
     * which is invoked to produce the assigned values. If `customizer` returns
     * `undefined`, assignment is handled by the method instead. The `customizer`
     * is invoked with five arguments: (objValue, srcValue, key, object, source).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @alias extendWith
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} sources The source objects.
     * @param {Function} [customizer] The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @see _.assignWith
     * @example
     *
     * function customizer(objValue, srcValue) {
     *   return _.isUndefined(objValue) ? srcValue : objValue;
     * }
     *
     * var defaults = _.partialRight(_.assignInWith, customizer);
     *
     * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
     * // => { 'a': 1, 'b': 2 }
     */
    var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
      copyObject(source, keysIn(source), object, customizer);
    });

    /**
     * This method is like `_.assign` except that it accepts `customizer`
     * which is invoked to produce the assigned values. If `customizer` returns
     * `undefined`, assignment is handled by the method instead. The `customizer`
     * is invoked with five arguments: (objValue, srcValue, key, object, source).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} sources The source objects.
     * @param {Function} [customizer] The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @see _.assignInWith
     * @example
     *
     * function customizer(objValue, srcValue) {
     *   return _.isUndefined(objValue) ? srcValue : objValue;
     * }
     *
     * var defaults = _.partialRight(_.assignWith, customizer);
     *
     * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
     * // => { 'a': 1, 'b': 2 }
     */
    var assignWith = createAssigner(function(object, source, srcIndex, customizer) {
      copyObject(source, keys(source), object, customizer);
    });

    /**
     * Creates an array of values corresponding to `paths` of `object`.
     *
     * @static
     * @memberOf _
     * @since 1.0.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {...(string|string[])} [paths] The property paths to pick.
     * @returns {Array} Returns the picked values.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }, 4] };
     *
     * _.at(object, ['a[0].b.c', 'a[1]']);
     * // => [3, 4]
     */
    var at = flatRest(baseAt);

    /**
     * Creates an object that inherits from the `prototype` object. If a
     * `properties` object is given, its own enumerable string keyed properties
     * are assigned to the created object.
     *
     * @static
     * @memberOf _
     * @since 2.3.0
     * @category Object
     * @param {Object} prototype The object to inherit from.
     * @param {Object} [properties] The properties to assign to the object.
     * @returns {Object} Returns the new object.
     * @example
     *
     * function Shape() {
     *   this.x = 0;
     *   this.y = 0;
     * }
     *
     * function Circle() {
     *   Shape.call(this);
     * }
     *
     * Circle.prototype = _.create(Shape.prototype, {
     *   'constructor': Circle
     * });
     *
     * var circle = new Circle;
     * circle instanceof Circle;
     * // => true
     *
     * circle instanceof Shape;
     * // => true
     */
    function create(prototype, properties) {
      var result = baseCreate(prototype);
      return properties == null ? result : baseAssign(result, properties);
    }

    /**
     * Assigns own and inherited enumerable string keyed properties of source
     * objects to the destination object for all destination properties that
     * resolve to `undefined`. Source objects are applied from left to right.
     * Once a property is set, additional values of the same property are ignored.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @see _.defaultsDeep
     * @example
     *
     * _.defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
     * // => { 'a': 1, 'b': 2 }
     */
    var defaults = baseRest(function(object, sources) {
      object = Object(object);

      var index = -1;
      var length = sources.length;
      var guard = length > 2 ? sources[2] : undefined;

      if (guard && isIterateeCall(sources[0], sources[1], guard)) {
        length = 1;
      }

      while (++index < length) {
        var source = sources[index];
        var props = keysIn(source);
        var propsIndex = -1;
        var propsLength = props.length;

        while (++propsIndex < propsLength) {
          var key = props[propsIndex];
          var value = object[key];

          if (value === undefined ||
              (eq(value, objectProto[key]) && !hasOwnProperty.call(object, key))) {
            object[key] = source[key];
          }
        }
      }

      return object;
    });

    /**
     * This method is like `_.defaults` except that it recursively assigns
     * default properties.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 3.10.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @see _.defaults
     * @example
     *
     * _.defaultsDeep({ 'a': { 'b': 2 } }, { 'a': { 'b': 1, 'c': 3 } });
     * // => { 'a': { 'b': 2, 'c': 3 } }
     */
    var defaultsDeep = baseRest(function(args) {
      args.push(undefined, customDefaultsMerge);
      return apply(mergeWith, undefined, args);
    });

    /**
     * This method is like `_.find` except that it returns the key of the first
     * element `predicate` returns truthy for instead of the element itself.
     *
     * @static
     * @memberOf _
     * @since 1.1.0
     * @category Object
     * @param {Object} object The object to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {string|undefined} Returns the key of the matched element,
     *  else `undefined`.
     * @example
     *
     * var users = {
     *   'barney':  { 'age': 36, 'active': true },
     *   'fred':    { 'age': 40, 'active': false },
     *   'pebbles': { 'age': 1,  'active': true }
     * };
     *
     * _.findKey(users, function(o) { return o.age < 40; });
     * // => 'barney' (iteration order is not guaranteed)
     *
     * // The `_.matches` iteratee shorthand.
     * _.findKey(users, { 'age': 1, 'active': true });
     * // => 'pebbles'
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.findKey(users, ['active', false]);
     * // => 'fred'
     *
     * // The `_.property` iteratee shorthand.
     * _.findKey(users, 'active');
     * // => 'barney'
     */
    function findKey(object, predicate) {
      return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);
    }

    /**
     * This method is like `_.findKey` except that it iterates over elements of
     * a collection in the opposite order.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Object
     * @param {Object} object The object to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {string|undefined} Returns the key of the matched element,
     *  else `undefined`.
     * @example
     *
     * var users = {
     *   'barney':  { 'age': 36, 'active': true },
     *   'fred':    { 'age': 40, 'active': false },
     *   'pebbles': { 'age': 1,  'active': true }
     * };
     *
     * _.findLastKey(users, function(o) { return o.age < 40; });
     * // => returns 'pebbles' assuming `_.findKey` returns 'barney'
     *
     * // The `_.matches` iteratee shorthand.
     * _.findLastKey(users, { 'age': 36, 'active': true });
     * // => 'barney'
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.findLastKey(users, ['active', false]);
     * // => 'fred'
     *
     * // The `_.property` iteratee shorthand.
     * _.findLastKey(users, 'active');
     * // => 'pebbles'
     */
    function findLastKey(object, predicate) {
      return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);
    }

    /**
     * Iterates over own and inherited enumerable string keyed properties of an
     * object and invokes `iteratee` for each property. The iteratee is invoked
     * with three arguments: (value, key, object). Iteratee functions may exit
     * iteration early by explicitly returning `false`.
     *
     * @static
     * @memberOf _
     * @since 0.3.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns `object`.
     * @see _.forInRight
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.forIn(new Foo, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'a', 'b', then 'c' (iteration order is not guaranteed).
     */
    function forIn(object, iteratee) {
      return object == null
        ? object
        : baseFor(object, getIteratee(iteratee, 3), keysIn);
    }

    /**
     * This method is like `_.forIn` except that it iterates over properties of
     * `object` in the opposite order.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns `object`.
     * @see _.forIn
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.forInRight(new Foo, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'c', 'b', then 'a' assuming `_.forIn` logs 'a', 'b', then 'c'.
     */
    function forInRight(object, iteratee) {
      return object == null
        ? object
        : baseForRight(object, getIteratee(iteratee, 3), keysIn);
    }

    /**
     * Iterates over own enumerable string keyed properties of an object and
     * invokes `iteratee` for each property. The iteratee is invoked with three
     * arguments: (value, key, object). Iteratee functions may exit iteration
     * early by explicitly returning `false`.
     *
     * @static
     * @memberOf _
     * @since 0.3.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns `object`.
     * @see _.forOwnRight
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.forOwn(new Foo, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'a' then 'b' (iteration order is not guaranteed).
     */
    function forOwn(object, iteratee) {
      return object && baseForOwn(object, getIteratee(iteratee, 3));
    }

    /**
     * This method is like `_.forOwn` except that it iterates over properties of
     * `object` in the opposite order.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns `object`.
     * @see _.forOwn
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.forOwnRight(new Foo, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'b' then 'a' assuming `_.forOwn` logs 'a' then 'b'.
     */
    function forOwnRight(object, iteratee) {
      return object && baseForOwnRight(object, getIteratee(iteratee, 3));
    }

    /**
     * Creates an array of function property names from own enumerable properties
     * of `object`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to inspect.
     * @returns {Array} Returns the function names.
     * @see _.functionsIn
     * @example
     *
     * function Foo() {
     *   this.a = _.constant('a');
     *   this.b = _.constant('b');
     * }
     *
     * Foo.prototype.c = _.constant('c');
     *
     * _.functions(new Foo);
     * // => ['a', 'b']
     */
    function functions(object) {
      return object == null ? [] : baseFunctions(object, keys(object));
    }

    /**
     * Creates an array of function property names from own and inherited
     * enumerable properties of `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to inspect.
     * @returns {Array} Returns the function names.
     * @see _.functions
     * @example
     *
     * function Foo() {
     *   this.a = _.constant('a');
     *   this.b = _.constant('b');
     * }
     *
     * Foo.prototype.c = _.constant('c');
     *
     * _.functionsIn(new Foo);
     * // => ['a', 'b', 'c']
     */
    function functionsIn(object) {
      return object == null ? [] : baseFunctions(object, keysIn(object));
    }

    /**
     * Gets the value at `path` of `object`. If the resolved value is
     * `undefined`, the `defaultValue` is returned in its place.
     *
     * @static
     * @memberOf _
     * @since 3.7.0
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the property to get.
     * @param {*} [defaultValue] The value returned for `undefined` resolved values.
     * @returns {*} Returns the resolved value.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
     *
     * _.get(object, 'a[0].b.c');
     * // => 3
     *
     * _.get(object, ['a', '0', 'b', 'c']);
     * // => 3
     *
     * _.get(object, 'a.b.c', 'default');
     * // => 'default'
     */
    function get(object, path, defaultValue) {
      var result = object == null ? undefined : baseGet(object, path);
      return result === undefined ? defaultValue : result;
    }

    /**
     * Checks if `path` is a direct property of `object`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     * @example
     *
     * var object = { 'a': { 'b': 2 } };
     * var other = _.create({ 'a': _.create({ 'b': 2 }) });
     *
     * _.has(object, 'a');
     * // => true
     *
     * _.has(object, 'a.b');
     * // => true
     *
     * _.has(object, ['a', 'b']);
     * // => true
     *
     * _.has(other, 'a');
     * // => false
     */
    function has(object, path) {
      return object != null && hasPath(object, path, baseHas);
    }

    /**
     * Checks if `path` is a direct or inherited property of `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     * @example
     *
     * var object = _.create({ 'a': _.create({ 'b': 2 }) });
     *
     * _.hasIn(object, 'a');
     * // => true
     *
     * _.hasIn(object, 'a.b');
     * // => true
     *
     * _.hasIn(object, ['a', 'b']);
     * // => true
     *
     * _.hasIn(object, 'b');
     * // => false
     */
    function hasIn(object, path) {
      return object != null && hasPath(object, path, baseHasIn);
    }

    /**
     * Creates an object composed of the inverted keys and values of `object`.
     * If `object` contains duplicate values, subsequent values overwrite
     * property assignments of previous values.
     *
     * @static
     * @memberOf _
     * @since 0.7.0
     * @category Object
     * @param {Object} object The object to invert.
     * @returns {Object} Returns the new inverted object.
     * @example
     *
     * var object = { 'a': 1, 'b': 2, 'c': 1 };
     *
     * _.invert(object);
     * // => { '1': 'c', '2': 'b' }
     */
    var invert = createInverter(function(result, value, key) {
      if (value != null &&
          typeof value.toString != 'function') {
        value = nativeObjectToString.call(value);
      }

      result[value] = key;
    }, constant(identity));

    /**
     * This method is like `_.invert` except that the inverted object is generated
     * from the results of running each element of `object` thru `iteratee`. The
     * corresponding inverted value of each inverted key is an array of keys
     * responsible for generating the inverted value. The iteratee is invoked
     * with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.1.0
     * @category Object
     * @param {Object} object The object to invert.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Object} Returns the new inverted object.
     * @example
     *
     * var object = { 'a': 1, 'b': 2, 'c': 1 };
     *
     * _.invertBy(object);
     * // => { '1': ['a', 'c'], '2': ['b'] }
     *
     * _.invertBy(object, function(value) {
     *   return 'group' + value;
     * });
     * // => { 'group1': ['a', 'c'], 'group2': ['b'] }
     */
    var invertBy = createInverter(function(result, value, key) {
      if (value != null &&
          typeof value.toString != 'function') {
        value = nativeObjectToString.call(value);
      }

      if (hasOwnProperty.call(result, value)) {
        result[value].push(key);
      } else {
        result[value] = [key];
      }
    }, getIteratee);

    /**
     * Invokes the method at `path` of `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the method to invoke.
     * @param {...*} [args] The arguments to invoke the method with.
     * @returns {*} Returns the result of the invoked method.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': [1, 2, 3, 4] } }] };
     *
     * _.invoke(object, 'a[0].b.c.slice', 1, 3);
     * // => [2, 3]
     */
    var invoke = baseRest(baseInvoke);

    /**
     * Creates an array of the own enumerable property names of `object`.
     *
     * **Note:** Non-object values are coerced to objects. See the
     * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
     * for more details.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.keys(new Foo);
     * // => ['a', 'b'] (iteration order is not guaranteed)
     *
     * _.keys('hi');
     * // => ['0', '1']
     */
    function keys(object) {
      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
    }

    /**
     * Creates an array of the own and inherited enumerable property names of `object`.
     *
     * **Note:** Non-object values are coerced to objects.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.keysIn(new Foo);
     * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
     */
    function keysIn(object) {
      return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
    }

    /**
     * The opposite of `_.mapValues`; this method creates an object with the
     * same values as `object` and keys generated by running each own enumerable
     * string keyed property of `object` thru `iteratee`. The iteratee is invoked
     * with three arguments: (value, key, object).
     *
     * @static
     * @memberOf _
     * @since 3.8.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns the new mapped object.
     * @see _.mapValues
     * @example
     *
     * _.mapKeys({ 'a': 1, 'b': 2 }, function(value, key) {
     *   return key + value;
     * });
     * // => { 'a1': 1, 'b2': 2 }
     */
    function mapKeys(object, iteratee) {
      var result = {};
      iteratee = getIteratee(iteratee, 3);

      baseForOwn(object, function(value, key, object) {
        baseAssignValue(result, iteratee(value, key, object), value);
      });
      return result;
    }

    /**
     * Creates an object with the same keys as `object` and values generated
     * by running each own enumerable string keyed property of `object` thru
     * `iteratee`. The iteratee is invoked with three arguments:
     * (value, key, object).
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns the new mapped object.
     * @see _.mapKeys
     * @example
     *
     * var users = {
     *   'fred':    { 'user': 'fred',    'age': 40 },
     *   'pebbles': { 'user': 'pebbles', 'age': 1 }
     * };
     *
     * _.mapValues(users, function(o) { return o.age; });
     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
     *
     * // The `_.property` iteratee shorthand.
     * _.mapValues(users, 'age');
     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
     */
    function mapValues(object, iteratee) {
      var result = {};
      iteratee = getIteratee(iteratee, 3);

      baseForOwn(object, function(value, key, object) {
        baseAssignValue(result, key, iteratee(value, key, object));
      });
      return result;
    }

    /**
     * This method is like `_.assign` except that it recursively merges own and
     * inherited enumerable string keyed properties of source objects into the
     * destination object. Source properties that resolve to `undefined` are
     * skipped if a destination value exists. Array and plain object properties
     * are merged recursively. Other objects and value types are overridden by
     * assignment. Source objects are applied from left to right. Subsequent
     * sources overwrite property assignments of previous sources.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 0.5.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = {
     *   'a': [{ 'b': 2 }, { 'd': 4 }]
     * };
     *
     * var other = {
     *   'a': [{ 'c': 3 }, { 'e': 5 }]
     * };
     *
     * _.merge(object, other);
     * // => { 'a': [{ 'b': 2, 'c': 3 }, { 'd': 4, 'e': 5 }] }
     */
    var merge = createAssigner(function(object, source, srcIndex) {
      baseMerge(object, source, srcIndex);
    });

    /**
     * This method is like `_.merge` except that it accepts `customizer` which
     * is invoked to produce the merged values of the destination and source
     * properties. If `customizer` returns `undefined`, merging is handled by the
     * method instead. The `customizer` is invoked with six arguments:
     * (objValue, srcValue, key, object, source, stack).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} sources The source objects.
     * @param {Function} customizer The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @example
     *
     * function customizer(objValue, srcValue) {
     *   if (_.isArray(objValue)) {
     *     return objValue.concat(srcValue);
     *   }
     * }
     *
     * var object = { 'a': [1], 'b': [2] };
     * var other = { 'a': [3], 'b': [4] };
     *
     * _.mergeWith(object, other, customizer);
     * // => { 'a': [1, 3], 'b': [2, 4] }
     */
    var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {
      baseMerge(object, source, srcIndex, customizer);
    });

    /**
     * The opposite of `_.pick`; this method creates an object composed of the
     * own and inherited enumerable property paths of `object` that are not omitted.
     *
     * **Note:** This method is considerably slower than `_.pick`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The source object.
     * @param {...(string|string[])} [paths] The property paths to omit.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.omit(object, ['a', 'c']);
     * // => { 'b': '2' }
     */
    var omit = flatRest(function(object, paths) {
      var result = {};
      if (object == null) {
        return result;
      }
      var isDeep = false;
      paths = arrayMap(paths, function(path) {
        path = castPath(path, object);
        isDeep || (isDeep = path.length > 1);
        return path;
      });
      copyObject(object, getAllKeysIn(object), result);
      if (isDeep) {
        result = baseClone(result, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
      }
      var length = paths.length;
      while (length--) {
        baseUnset(result, paths[length]);
      }
      return result;
    });

    /**
     * The opposite of `_.pickBy`; this method creates an object composed of
     * the own and inherited enumerable string keyed properties of `object` that
     * `predicate` doesn't return truthy for. The predicate is invoked with two
     * arguments: (value, key).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The source object.
     * @param {Function} [predicate=_.identity] The function invoked per property.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.omitBy(object, _.isNumber);
     * // => { 'b': '2' }
     */
    function omitBy(object, predicate) {
      return pickBy(object, negate(getIteratee(predicate)));
    }

    /**
     * Creates an object composed of the picked `object` properties.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The source object.
     * @param {...(string|string[])} [paths] The property paths to pick.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.pick(object, ['a', 'c']);
     * // => { 'a': 1, 'c': 3 }
     */
    var pick = flatRest(function(object, paths) {
      return object == null ? {} : basePick(object, paths);
    });

    /**
     * Creates an object composed of the `object` properties `predicate` returns
     * truthy for. The predicate is invoked with two arguments: (value, key).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The source object.
     * @param {Function} [predicate=_.identity] The function invoked per property.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.pickBy(object, _.isNumber);
     * // => { 'a': 1, 'c': 3 }
     */
    function pickBy(object, predicate) {
      if (object == null) {
        return {};
      }
      var props = arrayMap(getAllKeysIn(object), function(prop) {
        return [prop];
      });
      predicate = getIteratee(predicate);
      return basePickBy(object, props, function(value, path) {
        return predicate(value, path[0]);
      });
    }

    /**
     * This method is like `_.get` except that if the resolved value is a
     * function it's invoked with the `this` binding of its parent object and
     * its result is returned.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the property to resolve.
     * @param {*} [defaultValue] The value returned for `undefined` resolved values.
     * @returns {*} Returns the resolved value.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c1': 3, 'c2': _.constant(4) } }] };
     *
     * _.result(object, 'a[0].b.c1');
     * // => 3
     *
     * _.result(object, 'a[0].b.c2');
     * // => 4
     *
     * _.result(object, 'a[0].b.c3', 'default');
     * // => 'default'
     *
     * _.result(object, 'a[0].b.c3', _.constant('default'));
     * // => 'default'
     */
    function result(object, path, defaultValue) {
      path = castPath(path, object);

      var index = -1,
          length = path.length;

      // Ensure the loop is entered when path is empty.
      if (!length) {
        length = 1;
        object = undefined;
      }
      while (++index < length) {
        var value = object == null ? undefined : object[toKey(path[index])];
        if (value === undefined) {
          index = length;
          value = defaultValue;
        }
        object = isFunction(value) ? value.call(object) : value;
      }
      return object;
    }

    /**
     * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
     * it's created. Arrays are created for missing index properties while objects
     * are created for all other missing properties. Use `_.setWith` to customize
     * `path` creation.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 3.7.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
     *
     * _.set(object, 'a[0].b.c', 4);
     * console.log(object.a[0].b.c);
     * // => 4
     *
     * _.set(object, ['x', '0', 'y', 'z'], 5);
     * console.log(object.x[0].y.z);
     * // => 5
     */
    function set(object, path, value) {
      return object == null ? object : baseSet(object, path, value);
    }

    /**
     * This method is like `_.set` except that it accepts `customizer` which is
     * invoked to produce the objects of `path`.  If `customizer` returns `undefined`
     * path creation is handled by the method instead. The `customizer` is invoked
     * with three arguments: (nsValue, key, nsObject).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {*} value The value to set.
     * @param {Function} [customizer] The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = {};
     *
     * _.setWith(object, '[0][1]', 'a', Object);
     * // => { '0': { '1': 'a' } }
     */
    function setWith(object, path, value, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return object == null ? object : baseSet(object, path, value, customizer);
    }

    /**
     * Creates an array of own enumerable string keyed-value pairs for `object`
     * which can be consumed by `_.fromPairs`. If `object` is a map or set, its
     * entries are returned.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @alias entries
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the key-value pairs.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.toPairs(new Foo);
     * // => [['a', 1], ['b', 2]] (iteration order is not guaranteed)
     */
    var toPairs = createToPairs(keys);

    /**
     * Creates an array of own and inherited enumerable string keyed-value pairs
     * for `object` which can be consumed by `_.fromPairs`. If `object` is a map
     * or set, its entries are returned.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @alias entriesIn
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the key-value pairs.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.toPairsIn(new Foo);
     * // => [['a', 1], ['b', 2], ['c', 3]] (iteration order is not guaranteed)
     */
    var toPairsIn = createToPairs(keysIn);

    /**
     * An alternative to `_.reduce`; this method transforms `object` to a new
     * `accumulator` object which is the result of running each of its own
     * enumerable string keyed properties thru `iteratee`, with each invocation
     * potentially mutating the `accumulator` object. If `accumulator` is not
     * provided, a new object with the same `[[Prototype]]` will be used. The
     * iteratee is invoked with four arguments: (accumulator, value, key, object).
     * Iteratee functions may exit iteration early by explicitly returning `false`.
     *
     * @static
     * @memberOf _
     * @since 1.3.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @param {*} [accumulator] The custom accumulator value.
     * @returns {*} Returns the accumulated value.
     * @example
     *
     * _.transform([2, 3, 4], function(result, n) {
     *   result.push(n *= n);
     *   return n % 2 == 0;
     * }, []);
     * // => [4, 9]
     *
     * _.transform({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {
     *   (result[value] || (result[value] = [])).push(key);
     * }, {});
     * // => { '1': ['a', 'c'], '2': ['b'] }
     */
    function transform(object, iteratee, accumulator) {
      var isArr = isArray(object),
          isArrLike = isArr || isBuffer(object) || isTypedArray(object);

      iteratee = getIteratee(iteratee, 4);
      if (accumulator == null) {
        var Ctor = object && object.constructor;
        if (isArrLike) {
          accumulator = isArr ? new Ctor : [];
        }
        else if (isObject(object)) {
          accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};
        }
        else {
          accumulator = {};
        }
      }
      (isArrLike ? arrayEach : baseForOwn)(object, function(value, index, object) {
        return iteratee(accumulator, value, index, object);
      });
      return accumulator;
    }

    /**
     * Removes the property at `path` of `object`.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to unset.
     * @returns {boolean} Returns `true` if the property is deleted, else `false`.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 7 } }] };
     * _.unset(object, 'a[0].b.c');
     * // => true
     *
     * console.log(object);
     * // => { 'a': [{ 'b': {} }] };
     *
     * _.unset(object, ['a', '0', 'b', 'c']);
     * // => true
     *
     * console.log(object);
     * // => { 'a': [{ 'b': {} }] };
     */
    function unset(object, path) {
      return object == null ? true : baseUnset(object, path);
    }

    /**
     * This method is like `_.set` except that accepts `updater` to produce the
     * value to set. Use `_.updateWith` to customize `path` creation. The `updater`
     * is invoked with one argument: (value).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.6.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {Function} updater The function to produce the updated value.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
     *
     * _.update(object, 'a[0].b.c', function(n) { return n * n; });
     * console.log(object.a[0].b.c);
     * // => 9
     *
     * _.update(object, 'x[0].y.z', function(n) { return n ? n + 1 : 0; });
     * console.log(object.x[0].y.z);
     * // => 0
     */
    function update(object, path, updater) {
      return object == null ? object : baseUpdate(object, path, castFunction(updater));
    }

    /**
     * This method is like `_.update` except that it accepts `customizer` which is
     * invoked to produce the objects of `path`.  If `customizer` returns `undefined`
     * path creation is handled by the method instead. The `customizer` is invoked
     * with three arguments: (nsValue, key, nsObject).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.6.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {Function} updater The function to produce the updated value.
     * @param {Function} [customizer] The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = {};
     *
     * _.updateWith(object, '[0][1]', _.constant('a'), Object);
     * // => { '0': { '1': 'a' } }
     */
    function updateWith(object, path, updater, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return object == null ? object : baseUpdate(object, path, castFunction(updater), customizer);
    }

    /**
     * Creates an array of the own enumerable string keyed property values of `object`.
     *
     * **Note:** Non-object values are coerced to objects.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property values.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.values(new Foo);
     * // => [1, 2] (iteration order is not guaranteed)
     *
     * _.values('hi');
     * // => ['h', 'i']
     */
    function values(object) {
      return object == null ? [] : baseValues(object, keys(object));
    }

    /**
     * Creates an array of the own and inherited enumerable string keyed property
     * values of `object`.
     *
     * **Note:** Non-object values are coerced to objects.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property values.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.valuesIn(new Foo);
     * // => [1, 2, 3] (iteration order is not guaranteed)
     */
    function valuesIn(object) {
      return object == null ? [] : baseValues(object, keysIn(object));
    }

    /*------------------------------------------------------------------------*/

    /**
     * Clamps `number` within the inclusive `lower` and `upper` bounds.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Number
     * @param {number} number The number to clamp.
     * @param {number} [lower] The lower bound.
     * @param {number} upper The upper bound.
     * @returns {number} Returns the clamped number.
     * @example
     *
     * _.clamp(-10, -5, 5);
     * // => -5
     *
     * _.clamp(10, -5, 5);
     * // => 5
     */
    function clamp(number, lower, upper) {
      if (upper === undefined) {
        upper = lower;
        lower = undefined;
      }
      if (upper !== undefined) {
        upper = toNumber(upper);
        upper = upper === upper ? upper : 0;
      }
      if (lower !== undefined) {
        lower = toNumber(lower);
        lower = lower === lower ? lower : 0;
      }
      return baseClamp(toNumber(number), lower, upper);
    }

    /**
     * Checks if `n` is between `start` and up to, but not including, `end`. If
     * `end` is not specified, it's set to `start` with `start` then set to `0`.
     * If `start` is greater than `end` the params are swapped to support
     * negative ranges.
     *
     * @static
     * @memberOf _
     * @since 3.3.0
     * @category Number
     * @param {number} number The number to check.
     * @param {number} [start=0] The start of the range.
     * @param {number} end The end of the range.
     * @returns {boolean} Returns `true` if `number` is in the range, else `false`.
     * @see _.range, _.rangeRight
     * @example
     *
     * _.inRange(3, 2, 4);
     * // => true
     *
     * _.inRange(4, 8);
     * // => true
     *
     * _.inRange(4, 2);
     * // => false
     *
     * _.inRange(2, 2);
     * // => false
     *
     * _.inRange(1.2, 2);
     * // => true
     *
     * _.inRange(5.2, 4);
     * // => false
     *
     * _.inRange(-3, -2, -6);
     * // => true
     */
    function inRange(number, start, end) {
      start = toFinite(start);
      if (end === undefined) {
        end = start;
        start = 0;
      } else {
        end = toFinite(end);
      }
      number = toNumber(number);
      return baseInRange(number, start, end);
    }

    /**
     * Produces a random number between the inclusive `lower` and `upper` bounds.
     * If only one argument is provided a number between `0` and the given number
     * is returned. If `floating` is `true`, or either `lower` or `upper` are
     * floats, a floating-point number is returned instead of an integer.
     *
     * **Note:** JavaScript follows the IEEE-754 standard for resolving
     * floating-point values which can produce unexpected results.
     *
     * @static
     * @memberOf _
     * @since 0.7.0
     * @category Number
     * @param {number} [lower=0] The lower bound.
     * @param {number} [upper=1] The upper bound.
     * @param {boolean} [floating] Specify returning a floating-point number.
     * @returns {number} Returns the random number.
     * @example
     *
     * _.random(0, 5);
     * // => an integer between 0 and 5
     *
     * _.random(5);
     * // => also an integer between 0 and 5
     *
     * _.random(5, true);
     * // => a floating-point number between 0 and 5
     *
     * _.random(1.2, 5.2);
     * // => a floating-point number between 1.2 and 5.2
     */
    function random(lower, upper, floating) {
      if (floating && typeof floating != 'boolean' && isIterateeCall(lower, upper, floating)) {
        upper = floating = undefined;
      }
      if (floating === undefined) {
        if (typeof upper == 'boolean') {
          floating = upper;
          upper = undefined;
        }
        else if (typeof lower == 'boolean') {
          floating = lower;
          lower = undefined;
        }
      }
      if (lower === undefined && upper === undefined) {
        lower = 0;
        upper = 1;
      }
      else {
        lower = toFinite(lower);
        if (upper === undefined) {
          upper = lower;
          lower = 0;
        } else {
          upper = toFinite(upper);
        }
      }
      if (lower > upper) {
        var temp = lower;
        lower = upper;
        upper = temp;
      }
      if (floating || lower % 1 || upper % 1) {
        var rand = nativeRandom();
        return nativeMin(lower + (rand * (upper - lower + freeParseFloat('1e-' + ((rand + '').length - 1)))), upper);
      }
      return baseRandom(lower, upper);
    }

    /*------------------------------------------------------------------------*/

    /**
     * Converts `string` to [camel case](https://en.wikipedia.org/wiki/CamelCase).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the camel cased string.
     * @example
     *
     * _.camelCase('Foo Bar');
     * // => 'fooBar'
     *
     * _.camelCase('--foo-bar--');
     * // => 'fooBar'
     *
     * _.camelCase('__FOO_BAR__');
     * // => 'fooBar'
     */
    var camelCase = createCompounder(function(result, word, index) {
      word = word.toLowerCase();
      return result + (index ? capitalize(word) : word);
    });

    /**
     * Converts the first character of `string` to upper case and the remaining
     * to lower case.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to capitalize.
     * @returns {string} Returns the capitalized string.
     * @example
     *
     * _.capitalize('FRED');
     * // => 'Fred'
     */
    function capitalize(string) {
      return upperFirst(toString(string).toLowerCase());
    }

    /**
     * Deburrs `string` by converting
     * [Latin-1 Supplement](https://en.wikipedia.org/wiki/Latin-1_Supplement_(Unicode_block)#Character_table)
     * and [Latin Extended-A](https://en.wikipedia.org/wiki/Latin_Extended-A)
     * letters to basic Latin letters and removing
     * [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to deburr.
     * @returns {string} Returns the deburred string.
     * @example
     *
     * _.deburr('déjà vu');
     * // => 'deja vu'
     */
    function deburr(string) {
      string = toString(string);
      return string && string.replace(reLatin, deburrLetter).replace(reComboMark, '');
    }

    /**
     * Checks if `string` ends with the given target string.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to inspect.
     * @param {string} [target] The string to search for.
     * @param {number} [position=string.length] The position to search up to.
     * @returns {boolean} Returns `true` if `string` ends with `target`,
     *  else `false`.
     * @example
     *
     * _.endsWith('abc', 'c');
     * // => true
     *
     * _.endsWith('abc', 'b');
     * // => false
     *
     * _.endsWith('abc', 'b', 2);
     * // => true
     */
    function endsWith(string, target, position) {
      string = toString(string);
      target = baseToString(target);

      var length = string.length;
      position = position === undefined
        ? length
        : baseClamp(toInteger(position), 0, length);

      var end = position;
      position -= target.length;
      return position >= 0 && string.slice(position, end) == target;
    }

    /**
     * Converts the characters "&", "<", ">", '"', and "'" in `string` to their
     * corresponding HTML entities.
     *
     * **Note:** No other characters are escaped. To escape additional
     * characters use a third-party library like [_he_](https://mths.be/he).
     *
     * Though the ">" character is escaped for symmetry, characters like
     * ">" and "/" don't need escaping in HTML and have no special meaning
     * unless they're part of a tag or unquoted attribute value. See
     * [Mathias Bynens's article](https://mathiasbynens.be/notes/ambiguous-ampersands)
     * (under "semi-related fun fact") for more details.
     *
     * When working with HTML you should always
     * [quote attribute values](http://wonko.com/post/html-escaping) to reduce
     * XSS vectors.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category String
     * @param {string} [string=''] The string to escape.
     * @returns {string} Returns the escaped string.
     * @example
     *
     * _.escape('fred, barney, & pebbles');
     * // => 'fred, barney, &amp; pebbles'
     */
    function escape(string) {
      string = toString(string);
      return (string && reHasUnescapedHtml.test(string))
        ? string.replace(reUnescapedHtml, escapeHtmlChar)
        : string;
    }

    /**
     * Escapes the `RegExp` special characters "^", "$", "\", ".", "*", "+",
     * "?", "(", ")", "[", "]", "{", "}", and "|" in `string`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to escape.
     * @returns {string} Returns the escaped string.
     * @example
     *
     * _.escapeRegExp('[lodash](https://lodash.com/)');
     * // => '\[lodash\]\(https://lodash\.com/\)'
     */
    function escapeRegExp(string) {
      string = toString(string);
      return (string && reHasRegExpChar.test(string))
        ? string.replace(reRegExpChar, '\\$&')
        : string;
    }

    /**
     * Converts `string` to
     * [kebab case](https://en.wikipedia.org/wiki/Letter_case#Special_case_styles).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the kebab cased string.
     * @example
     *
     * _.kebabCase('Foo Bar');
     * // => 'foo-bar'
     *
     * _.kebabCase('fooBar');
     * // => 'foo-bar'
     *
     * _.kebabCase('__FOO_BAR__');
     * // => 'foo-bar'
     */
    var kebabCase = createCompounder(function(result, word, index) {
      return result + (index ? '-' : '') + word.toLowerCase();
    });

    /**
     * Converts `string`, as space separated words, to lower case.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the lower cased string.
     * @example
     *
     * _.lowerCase('--Foo-Bar--');
     * // => 'foo bar'
     *
     * _.lowerCase('fooBar');
     * // => 'foo bar'
     *
     * _.lowerCase('__FOO_BAR__');
     * // => 'foo bar'
     */
    var lowerCase = createCompounder(function(result, word, index) {
      return result + (index ? ' ' : '') + word.toLowerCase();
    });

    /**
     * Converts the first character of `string` to lower case.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the converted string.
     * @example
     *
     * _.lowerFirst('Fred');
     * // => 'fred'
     *
     * _.lowerFirst('FRED');
     * // => 'fRED'
     */
    var lowerFirst = createCaseFirst('toLowerCase');

    /**
     * Pads `string` on the left and right sides if it's shorter than `length`.
     * Padding characters are truncated if they can't be evenly divided by `length`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to pad.
     * @param {number} [length=0] The padding length.
     * @param {string} [chars=' '] The string used as padding.
     * @returns {string} Returns the padded string.
     * @example
     *
     * _.pad('abc', 8);
     * // => '  abc   '
     *
     * _.pad('abc', 8, '_-');
     * // => '_-abc_-_'
     *
     * _.pad('abc', 3);
     * // => 'abc'
     */
    function pad(string, length, chars) {
      string = toString(string);
      length = toInteger(length);

      var strLength = length ? stringSize(string) : 0;
      if (!length || strLength >= length) {
        return string;
      }
      var mid = (length - strLength) / 2;
      return (
        createPadding(nativeFloor(mid), chars) +
        string +
        createPadding(nativeCeil(mid), chars)
      );
    }

    /**
     * Pads `string` on the right side if it's shorter than `length`. Padding
     * characters are truncated if they exceed `length`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to pad.
     * @param {number} [length=0] The padding length.
     * @param {string} [chars=' '] The string used as padding.
     * @returns {string} Returns the padded string.
     * @example
     *
     * _.padEnd('abc', 6);
     * // => 'abc   '
     *
     * _.padEnd('abc', 6, '_-');
     * // => 'abc_-_'
     *
     * _.padEnd('abc', 3);
     * // => 'abc'
     */
    function padEnd(string, length, chars) {
      string = toString(string);
      length = toInteger(length);

      var strLength = length ? stringSize(string) : 0;
      return (length && strLength < length)
        ? (string + createPadding(length - strLength, chars))
        : string;
    }

    /**
     * Pads `string` on the left side if it's shorter than `length`. Padding
     * characters are truncated if they exceed `length`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to pad.
     * @param {number} [length=0] The padding length.
     * @param {string} [chars=' '] The string used as padding.
     * @returns {string} Returns the padded string.
     * @example
     *
     * _.padStart('abc', 6);
     * // => '   abc'
     *
     * _.padStart('abc', 6, '_-');
     * // => '_-_abc'
     *
     * _.padStart('abc', 3);
     * // => 'abc'
     */
    function padStart(string, length, chars) {
      string = toString(string);
      length = toInteger(length);

      var strLength = length ? stringSize(string) : 0;
      return (length && strLength < length)
        ? (createPadding(length - strLength, chars) + string)
        : string;
    }

    /**
     * Converts `string` to an integer of the specified radix. If `radix` is
     * `undefined` or `0`, a `radix` of `10` is used unless `value` is a
     * hexadecimal, in which case a `radix` of `16` is used.
     *
     * **Note:** This method aligns with the
     * [ES5 implementation](https://es5.github.io/#x15.1.2.2) of `parseInt`.
     *
     * @static
     * @memberOf _
     * @since 1.1.0
     * @category String
     * @param {string} string The string to convert.
     * @param {number} [radix=10] The radix to interpret `value` by.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.parseInt('08');
     * // => 8
     *
     * _.map(['6', '08', '10'], _.parseInt);
     * // => [6, 8, 10]
     */
    function parseInt(string, radix, guard) {
      if (guard || radix == null) {
        radix = 0;
      } else if (radix) {
        radix = +radix;
      }
      return nativeParseInt(toString(string).replace(reTrimStart, ''), radix || 0);
    }

    /**
     * Repeats the given string `n` times.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to repeat.
     * @param {number} [n=1] The number of times to repeat the string.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {string} Returns the repeated string.
     * @example
     *
     * _.repeat('*', 3);
     * // => '***'
     *
     * _.repeat('abc', 2);
     * // => 'abcabc'
     *
     * _.repeat('abc', 0);
     * // => ''
     */
    function repeat(string, n, guard) {
      if ((guard ? isIterateeCall(string, n, guard) : n === undefined)) {
        n = 1;
      } else {
        n = toInteger(n);
      }
      return baseRepeat(toString(string), n);
    }

    /**
     * Replaces matches for `pattern` in `string` with `replacement`.
     *
     * **Note:** This method is based on
     * [`String#replace`](https://mdn.io/String/replace).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to modify.
     * @param {RegExp|string} pattern The pattern to replace.
     * @param {Function|string} replacement The match replacement.
     * @returns {string} Returns the modified string.
     * @example
     *
     * _.replace('Hi Fred', 'Fred', 'Barney');
     * // => 'Hi Barney'
     */
    function replace() {
      var args = arguments,
          string = toString(args[0]);

      return args.length < 3 ? string : string.replace(args[1], args[2]);
    }

    /**
     * Converts `string` to
     * [snake case](https://en.wikipedia.org/wiki/Snake_case).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the snake cased string.
     * @example
     *
     * _.snakeCase('Foo Bar');
     * // => 'foo_bar'
     *
     * _.snakeCase('fooBar');
     * // => 'foo_bar'
     *
     * _.snakeCase('--FOO-BAR--');
     * // => 'foo_bar'
     */
    var snakeCase = createCompounder(function(result, word, index) {
      return result + (index ? '_' : '') + word.toLowerCase();
    });

    /**
     * Splits `string` by `separator`.
     *
     * **Note:** This method is based on
     * [`String#split`](https://mdn.io/String/split).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to split.
     * @param {RegExp|string} separator The separator pattern to split by.
     * @param {number} [limit] The length to truncate results to.
     * @returns {Array} Returns the string segments.
     * @example
     *
     * _.split('a-b-c', '-', 2);
     * // => ['a', 'b']
     */
    function split(string, separator, limit) {
      if (limit && typeof limit != 'number' && isIterateeCall(string, separator, limit)) {
        separator = limit = undefined;
      }
      limit = limit === undefined ? MAX_ARRAY_LENGTH : limit >>> 0;
      if (!limit) {
        return [];
      }
      string = toString(string);
      if (string && (
            typeof separator == 'string' ||
            (separator != null && !isRegExp(separator))
          )) {
        separator = baseToString(separator);
        if (!separator && hasUnicode(string)) {
          return castSlice(stringToArray(string), 0, limit);
        }
      }
      return string.split(separator, limit);
    }

    /**
     * Converts `string` to
     * [start case](https://en.wikipedia.org/wiki/Letter_case#Stylistic_or_specialised_usage).
     *
     * @static
     * @memberOf _
     * @since 3.1.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the start cased string.
     * @example
     *
     * _.startCase('--foo-bar--');
     * // => 'Foo Bar'
     *
     * _.startCase('fooBar');
     * // => 'Foo Bar'
     *
     * _.startCase('__FOO_BAR__');
     * // => 'FOO BAR'
     */
    var startCase = createCompounder(function(result, word, index) {
      return result + (index ? ' ' : '') + upperFirst(word);
    });

    /**
     * Checks if `string` starts with the given target string.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to inspect.
     * @param {string} [target] The string to search for.
     * @param {number} [position=0] The position to search from.
     * @returns {boolean} Returns `true` if `string` starts with `target`,
     *  else `false`.
     * @example
     *
     * _.startsWith('abc', 'a');
     * // => true
     *
     * _.startsWith('abc', 'b');
     * // => false
     *
     * _.startsWith('abc', 'b', 1);
     * // => true
     */
    function startsWith(string, target, position) {
      string = toString(string);
      position = position == null
        ? 0
        : baseClamp(toInteger(position), 0, string.length);

      target = baseToString(target);
      return string.slice(position, position + target.length) == target;
    }

    /**
     * Creates a compiled template function that can interpolate data properties
     * in "interpolate" delimiters, HTML-escape interpolated data properties in
     * "escape" delimiters, and execute JavaScript in "evaluate" delimiters. Data
     * properties may be accessed as free variables in the template. If a setting
     * object is given, it takes precedence over `_.templateSettings` values.
     *
     * **Note:** In the development build `_.template` utilizes
     * [sourceURLs](http://www.html5rocks.com/en/tutorials/developertools/sourcemaps/#toc-sourceurl)
     * for easier debugging.
     *
     * For more information on precompiling templates see
     * [lodash's custom builds documentation](https://lodash.com/custom-builds).
     *
     * For more information on Chrome extension sandboxes see
     * [Chrome's extensions documentation](https://developer.chrome.com/extensions/sandboxingEval).
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category String
     * @param {string} [string=''] The template string.
     * @param {Object} [options={}] The options object.
     * @param {RegExp} [options.escape=_.templateSettings.escape]
     *  The HTML "escape" delimiter.
     * @param {RegExp} [options.evaluate=_.templateSettings.evaluate]
     *  The "evaluate" delimiter.
     * @param {Object} [options.imports=_.templateSettings.imports]
     *  An object to import into the template as free variables.
     * @param {RegExp} [options.interpolate=_.templateSettings.interpolate]
     *  The "interpolate" delimiter.
     * @param {string} [options.sourceURL='lodash.templateSources[n]']
     *  The sourceURL of the compiled template.
     * @param {string} [options.variable='obj']
     *  The data object variable name.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Function} Returns the compiled template function.
     * @example
     *
     * // Use the "interpolate" delimiter to create a compiled template.
     * var compiled = _.template('hello <%= user %>!');
     * compiled({ 'user': 'fred' });
     * // => 'hello fred!'
     *
     * // Use the HTML "escape" delimiter to escape data property values.
     * var compiled = _.template('<b><%- value %></b>');
     * compiled({ 'value': '<script>' });
     * // => '<b>&lt;script&gt;</b>'
     *
     * // Use the "evaluate" delimiter to execute JavaScript and generate HTML.
     * var compiled = _.template('<% _.forEach(users, function(user) { %><li><%- user %></li><% }); %>');
     * compiled({ 'users': ['fred', 'barney'] });
     * // => '<li>fred</li><li>barney</li>'
     *
     * // Use the internal `print` function in "evaluate" delimiters.
     * var compiled = _.template('<% print("hello " + user); %>!');
     * compiled({ 'user': 'barney' });
     * // => 'hello barney!'
     *
     * // Use the ES template literal delimiter as an "interpolate" delimiter.
     * // Disable support by replacing the "interpolate" delimiter.
     * var compiled = _.template('hello ${ user }!');
     * compiled({ 'user': 'pebbles' });
     * // => 'hello pebbles!'
     *
     * // Use backslashes to treat delimiters as plain text.
     * var compiled = _.template('<%= "\\<%- value %\\>" %>');
     * compiled({ 'value': 'ignored' });
     * // => '<%- value %>'
     *
     * // Use the `imports` option to import `jQuery` as `jq`.
     * var text = '<% jq.each(users, function(user) { %><li><%- user %></li><% }); %>';
     * var compiled = _.template(text, { 'imports': { 'jq': jQuery } });
     * compiled({ 'users': ['fred', 'barney'] });
     * // => '<li>fred</li><li>barney</li>'
     *
     * // Use the `sourceURL` option to specify a custom sourceURL for the template.
     * var compiled = _.template('hello <%= user %>!', { 'sourceURL': '/basic/greeting.jst' });
     * compiled(data);
     * // => Find the source of "greeting.jst" under the Sources tab or Resources panel of the web inspector.
     *
     * // Use the `variable` option to ensure a with-statement isn't used in the compiled template.
     * var compiled = _.template('hi <%= data.user %>!', { 'variable': 'data' });
     * compiled.source;
     * // => function(data) {
     * //   var __t, __p = '';
     * //   __p += 'hi ' + ((__t = ( data.user )) == null ? '' : __t) + '!';
     * //   return __p;
     * // }
     *
     * // Use custom template delimiters.
     * _.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
     * var compiled = _.template('hello {{ user }}!');
     * compiled({ 'user': 'mustache' });
     * // => 'hello mustache!'
     *
     * // Use the `source` property to inline compiled templates for meaningful
     * // line numbers in error messages and stack traces.
     * fs.writeFileSync(path.join(process.cwd(), 'jst.js'), '\
     *   var JST = {\
     *     "main": ' + _.template(mainText).source + '\
     *   };\
     * ');
     */
    function template(string, options, guard) {
      // Based on John Resig's `tmpl` implementation
      // (http://ejohn.org/blog/javascript-micro-templating/)
      // and Laura Doktorova's doT.js (https://github.com/olado/doT).
      var settings = lodash.templateSettings;

      if (guard && isIterateeCall(string, options, guard)) {
        options = undefined;
      }
      string = toString(string);
      options = assignInWith({}, options, settings, customDefaultsAssignIn);

      var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn),
          importsKeys = keys(imports),
          importsValues = baseValues(imports, importsKeys);

      var isEscaping,
          isEvaluating,
          index = 0,
          interpolate = options.interpolate || reNoMatch,
          source = "__p += '";

      // Compile the regexp to match each delimiter.
      var reDelimiters = RegExp(
        (options.escape || reNoMatch).source + '|' +
        interpolate.source + '|' +
        (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + '|' +
        (options.evaluate || reNoMatch).source + '|$'
      , 'g');

      // Use a sourceURL for easier debugging.
      // The sourceURL gets injected into the source that's eval-ed, so be careful
      // to normalize all kinds of whitespace, so e.g. newlines (and unicode versions of it) can't sneak in
      // and escape the comment, thus injecting code that gets evaled.
      var sourceURL = '//# sourceURL=' +
        (hasOwnProperty.call(options, 'sourceURL')
          ? (options.sourceURL + '').replace(/\s/g, ' ')
          : ('lodash.templateSources[' + (++templateCounter) + ']')
        ) + '\n';

      string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
        interpolateValue || (interpolateValue = esTemplateValue);

        // Escape characters that can't be included in string literals.
        source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);

        // Replace delimiters with snippets.
        if (escapeValue) {
          isEscaping = true;
          source += "' +\n__e(" + escapeValue + ") +\n'";
        }
        if (evaluateValue) {
          isEvaluating = true;
          source += "';\n" + evaluateValue + ";\n__p += '";
        }
        if (interpolateValue) {
          source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
        }
        index = offset + match.length;

        // The JS engine embedded in Adobe products needs `match` returned in
        // order to produce the correct `offset` value.
        return match;
      });

      source += "';\n";

      // If `variable` is not specified wrap a with-statement around the generated
      // code to add the data object to the top of the scope chain.
      var variable = hasOwnProperty.call(options, 'variable') && options.variable;
      if (!variable) {
        source = 'with (obj) {\n' + source + '\n}\n';
      }
      // Throw an error if a forbidden character was found in `variable`, to prevent
      // potential command injection attacks.
      else if (reForbiddenIdentifierChars.test(variable)) {
        throw new Error(INVALID_TEMPL_VAR_ERROR_TEXT);
      }

      // Cleanup code by stripping empty strings.
      source = (isEvaluating ? source.replace(reEmptyStringLeading, '') : source)
        .replace(reEmptyStringMiddle, '$1')
        .replace(reEmptyStringTrailing, '$1;');

      // Frame code as the function body.
      source = 'function(' + (variable || 'obj') + ') {\n' +
        (variable
          ? ''
          : 'obj || (obj = {});\n'
        ) +
        "var __t, __p = ''" +
        (isEscaping
           ? ', __e = _.escape'
           : ''
        ) +
        (isEvaluating
          ? ', __j = Array.prototype.join;\n' +
            "function print() { __p += __j.call(arguments, '') }\n"
          : ';\n'
        ) +
        source +
        'return __p\n}';

      var result = attempt(function() {
        return Function(importsKeys, sourceURL + 'return ' + source)
          .apply(undefined, importsValues);
      });

      // Provide the compiled function's source by its `toString` method or
      // the `source` property as a convenience for inlining compiled templates.
      result.source = source;
      if (isError(result)) {
        throw result;
      }
      return result;
    }

    /**
     * Converts `string`, as a whole, to lower case just like
     * [String#toLowerCase](https://mdn.io/toLowerCase).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the lower cased string.
     * @example
     *
     * _.toLower('--Foo-Bar--');
     * // => '--foo-bar--'
     *
     * _.toLower('fooBar');
     * // => 'foobar'
     *
     * _.toLower('__FOO_BAR__');
     * // => '__foo_bar__'
     */
    function toLower(value) {
      return toString(value).toLowerCase();
    }

    /**
     * Converts `string`, as a whole, to upper case just like
     * [String#toUpperCase](https://mdn.io/toUpperCase).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the upper cased string.
     * @example
     *
     * _.toUpper('--foo-bar--');
     * // => '--FOO-BAR--'
     *
     * _.toUpper('fooBar');
     * // => 'FOOBAR'
     *
     * _.toUpper('__foo_bar__');
     * // => '__FOO_BAR__'
     */
    function toUpper(value) {
      return toString(value).toUpperCase();
    }

    /**
     * Removes leading and trailing whitespace or specified characters from `string`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to trim.
     * @param {string} [chars=whitespace] The characters to trim.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {string} Returns the trimmed string.
     * @example
     *
     * _.trim('  abc  ');
     * // => 'abc'
     *
     * _.trim('-_-abc-_-', '_-');
     * // => 'abc'
     *
     * _.map(['  foo  ', '  bar  '], _.trim);
     * // => ['foo', 'bar']
     */
    function trim(string, chars, guard) {
      string = toString(string);
      if (string && (guard || chars === undefined)) {
        return baseTrim(string);
      }
      if (!string || !(chars = baseToString(chars))) {
        return string;
      }
      var strSymbols = stringToArray(string),
          chrSymbols = stringToArray(chars),
          start = charsStartIndex(strSymbols, chrSymbols),
          end = charsEndIndex(strSymbols, chrSymbols) + 1;

      return castSlice(strSymbols, start, end).join('');
    }

    /**
     * Removes trailing whitespace or specified characters from `string`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to trim.
     * @param {string} [chars=whitespace] The characters to trim.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {string} Returns the trimmed string.
     * @example
     *
     * _.trimEnd('  abc  ');
     * // => '  abc'
     *
     * _.trimEnd('-_-abc-_-', '_-');
     * // => '-_-abc'
     */
    function trimEnd(string, chars, guard) {
      string = toString(string);
      if (string && (guard || chars === undefined)) {
        return string.slice(0, trimmedEndIndex(string) + 1);
      }
      if (!string || !(chars = baseToString(chars))) {
        return string;
      }
      var strSymbols = stringToArray(string),
          end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;

      return castSlice(strSymbols, 0, end).join('');
    }

    /**
     * Removes leading whitespace or specified characters from `string`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to trim.
     * @param {string} [chars=whitespace] The characters to trim.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {string} Returns the trimmed string.
     * @example
     *
     * _.trimStart('  abc  ');
     * // => 'abc  '
     *
     * _.trimStart('-_-abc-_-', '_-');
     * // => 'abc-_-'
     */
    function trimStart(string, chars, guard) {
      string = toString(string);
      if (string && (guard || chars === undefined)) {
        return string.replace(reTrimStart, '');
      }
      if (!string || !(chars = baseToString(chars))) {
        return string;
      }
      var strSymbols = stringToArray(string),
          start = charsStartIndex(strSymbols, stringToArray(chars));

      return castSlice(strSymbols, start).join('');
    }

    /**
     * Truncates `string` if it's longer than the given maximum string length.
     * The last characters of the truncated string are replaced with the omission
     * string which defaults to "...".
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to truncate.
     * @param {Object} [options={}] The options object.
     * @param {number} [options.length=30] The maximum string length.
     * @param {string} [options.omission='...'] The string to indicate text is omitted.
     * @param {RegExp|string} [options.separator] The separator pattern to truncate to.
     * @returns {string} Returns the truncated string.
     * @example
     *
     * _.truncate('hi-diddly-ho there, neighborino');
     * // => 'hi-diddly-ho there, neighbo...'
     *
     * _.truncate('hi-diddly-ho there, neighborino', {
     *   'length': 24,
     *   'separator': ' '
     * });
     * // => 'hi-diddly-ho there,...'
     *
     * _.truncate('hi-diddly-ho there, neighborino', {
     *   'length': 24,
     *   'separator': /,? +/
     * });
     * // => 'hi-diddly-ho there...'
     *
     * _.truncate('hi-diddly-ho there, neighborino', {
     *   'omission': ' [...]'
     * });
     * // => 'hi-diddly-ho there, neig [...]'
     */
    function truncate(string, options) {
      var length = DEFAULT_TRUNC_LENGTH,
          omission = DEFAULT_TRUNC_OMISSION;

      if (isObject(options)) {
        var separator = 'separator' in options ? options.separator : separator;
        length = 'length' in options ? toInteger(options.length) : length;
        omission = 'omission' in options ? baseToString(options.omission) : omission;
      }
      string = toString(string);

      var strLength = string.length;
      if (hasUnicode(string)) {
        var strSymbols = stringToArray(string);
        strLength = strSymbols.length;
      }
      if (length >= strLength) {
        return string;
      }
      var end = length - stringSize(omission);
      if (end < 1) {
        return omission;
      }
      var result = strSymbols
        ? castSlice(strSymbols, 0, end).join('')
        : string.slice(0, end);

      if (separator === undefined) {
        return result + omission;
      }
      if (strSymbols) {
        end += (result.length - end);
      }
      if (isRegExp(separator)) {
        if (string.slice(end).search(separator)) {
          var match,
              substring = result;

          if (!separator.global) {
            separator = RegExp(separator.source, toString(reFlags.exec(separator)) + 'g');
          }
          separator.lastIndex = 0;
          while ((match = separator.exec(substring))) {
            var newEnd = match.index;
          }
          result = result.slice(0, newEnd === undefined ? end : newEnd);
        }
      } else if (string.indexOf(baseToString(separator), end) != end) {
        var index = result.lastIndexOf(separator);
        if (index > -1) {
          result = result.slice(0, index);
        }
      }
      return result + omission;
    }

    /**
     * The inverse of `_.escape`; this method converts the HTML entities
     * `&amp;`, `&lt;`, `&gt;`, `&quot;`, and `&#39;` in `string` to
     * their corresponding characters.
     *
     * **Note:** No other HTML entities are unescaped. To unescape additional
     * HTML entities use a third-party library like [_he_](https://mths.be/he).
     *
     * @static
     * @memberOf _
     * @since 0.6.0
     * @category String
     * @param {string} [string=''] The string to unescape.
     * @returns {string} Returns the unescaped string.
     * @example
     *
     * _.unescape('fred, barney, &amp; pebbles');
     * // => 'fred, barney, & pebbles'
     */
    function unescape(string) {
      string = toString(string);
      return (string && reHasEscapedHtml.test(string))
        ? string.replace(reEscapedHtml, unescapeHtmlChar)
        : string;
    }

    /**
     * Converts `string`, as space separated words, to upper case.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the upper cased string.
     * @example
     *
     * _.upperCase('--foo-bar');
     * // => 'FOO BAR'
     *
     * _.upperCase('fooBar');
     * // => 'FOO BAR'
     *
     * _.upperCase('__foo_bar__');
     * // => 'FOO BAR'
     */
    var upperCase = createCompounder(function(result, word, index) {
      return result + (index ? ' ' : '') + word.toUpperCase();
    });

    /**
     * Converts the first character of `string` to upper case.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the converted string.
     * @example
     *
     * _.upperFirst('fred');
     * // => 'Fred'
     *
     * _.upperFirst('FRED');
     * // => 'FRED'
     */
    var upperFirst = createCaseFirst('toUpperCase');

    /**
     * Splits `string` into an array of its words.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to inspect.
     * @param {RegExp|string} [pattern] The pattern to match words.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the words of `string`.
     * @example
     *
     * _.words('fred, barney, & pebbles');
     * // => ['fred', 'barney', 'pebbles']
     *
     * _.words('fred, barney, & pebbles', /[^, ]+/g);
     * // => ['fred', 'barney', '&', 'pebbles']
     */
    function words(string, pattern, guard) {
      string = toString(string);
      pattern = guard ? undefined : pattern;

      if (pattern === undefined) {
        return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
      }
      return string.match(pattern) || [];
    }

    /*------------------------------------------------------------------------*/

    /**
     * Attempts to invoke `func`, returning either the result or the caught error
     * object. Any additional arguments are provided to `func` when it's invoked.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Util
     * @param {Function} func The function to attempt.
     * @param {...*} [args] The arguments to invoke `func` with.
     * @returns {*} Returns the `func` result or error object.
     * @example
     *
     * // Avoid throwing errors for invalid selectors.
     * var elements = _.attempt(function(selector) {
     *   return document.querySelectorAll(selector);
     * }, '>_>');
     *
     * if (_.isError(elements)) {
     *   elements = [];
     * }
     */
    var attempt = baseRest(function(func, args) {
      try {
        return apply(func, undefined, args);
      } catch (e) {
        return isError(e) ? e : new Error(e);
      }
    });

    /**
     * Binds methods of an object to the object itself, overwriting the existing
     * method.
     *
     * **Note:** This method doesn't set the "length" property of bound functions.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {Object} object The object to bind and assign the bound methods to.
     * @param {...(string|string[])} methodNames The object method names to bind.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var view = {
     *   'label': 'docs',
     *   'click': function() {
     *     console.log('clicked ' + this.label);
     *   }
     * };
     *
     * _.bindAll(view, ['click']);
     * jQuery(element).on('click', view.click);
     * // => Logs 'clicked docs' when clicked.
     */
    var bindAll = flatRest(function(object, methodNames) {
      arrayEach(methodNames, function(key) {
        key = toKey(key);
        baseAssignValue(object, key, bind(object[key], object));
      });
      return object;
    });

    /**
     * Creates a function that iterates over `pairs` and invokes the corresponding
     * function of the first predicate to return truthy. The predicate-function
     * pairs are invoked with the `this` binding and arguments of the created
     * function.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {Array} pairs The predicate-function pairs.
     * @returns {Function} Returns the new composite function.
     * @example
     *
     * var func = _.cond([
     *   [_.matches({ 'a': 1 }),           _.constant('matches A')],
     *   [_.conforms({ 'b': _.isNumber }), _.constant('matches B')],
     *   [_.stubTrue,                      _.constant('no match')]
     * ]);
     *
     * func({ 'a': 1, 'b': 2 });
     * // => 'matches A'
     *
     * func({ 'a': 0, 'b': 1 });
     * // => 'matches B'
     *
     * func({ 'a': '1', 'b': '2' });
     * // => 'no match'
     */
    function cond(pairs) {
      var length = pairs == null ? 0 : pairs.length,
          toIteratee = getIteratee();

      pairs = !length ? [] : arrayMap(pairs, function(pair) {
        if (typeof pair[1] != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        return [toIteratee(pair[0]), pair[1]];
      });

      return baseRest(function(args) {
        var index = -1;
        while (++index < length) {
          var pair = pairs[index];
          if (apply(pair[0], this, args)) {
            return apply(pair[1], this, args);
          }
        }
      });
    }

    /**
     * Creates a function that invokes the predicate properties of `source` with
     * the corresponding property values of a given object, returning `true` if
     * all predicates return truthy, else `false`.
     *
     * **Note:** The created function is equivalent to `_.conformsTo` with
     * `source` partially applied.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {Object} source The object of property predicates to conform to.
     * @returns {Function} Returns the new spec function.
     * @example
     *
     * var objects = [
     *   { 'a': 2, 'b': 1 },
     *   { 'a': 1, 'b': 2 }
     * ];
     *
     * _.filter(objects, _.conforms({ 'b': function(n) { return n > 1; } }));
     * // => [{ 'a': 1, 'b': 2 }]
     */
    function conforms(source) {
      return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
    }

    /**
     * Creates a function that returns `value`.
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Util
     * @param {*} value The value to return from the new function.
     * @returns {Function} Returns the new constant function.
     * @example
     *
     * var objects = _.times(2, _.constant({ 'a': 1 }));
     *
     * console.log(objects);
     * // => [{ 'a': 1 }, { 'a': 1 }]
     *
     * console.log(objects[0] === objects[1]);
     * // => true
     */
    function constant(value) {
      return function() {
        return value;
      };
    }

    /**
     * Checks `value` to determine whether a default value should be returned in
     * its place. The `defaultValue` is returned if `value` is `NaN`, `null`,
     * or `undefined`.
     *
     * @static
     * @memberOf _
     * @since 4.14.0
     * @category Util
     * @param {*} value The value to check.
     * @param {*} defaultValue The default value.
     * @returns {*} Returns the resolved value.
     * @example
     *
     * _.defaultTo(1, 10);
     * // => 1
     *
     * _.defaultTo(undefined, 10);
     * // => 10
     */
    function defaultTo(value, defaultValue) {
      return (value == null || value !== value) ? defaultValue : value;
    }

    /**
     * Creates a function that returns the result of invoking the given functions
     * with the `this` binding of the created function, where each successive
     * invocation is supplied the return value of the previous.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Util
     * @param {...(Function|Function[])} [funcs] The functions to invoke.
     * @returns {Function} Returns the new composite function.
     * @see _.flowRight
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var addSquare = _.flow([_.add, square]);
     * addSquare(1, 2);
     * // => 9
     */
    var flow = createFlow();

    /**
     * This method is like `_.flow` except that it creates a function that
     * invokes the given functions from right to left.
     *
     * @static
     * @since 3.0.0
     * @memberOf _
     * @category Util
     * @param {...(Function|Function[])} [funcs] The functions to invoke.
     * @returns {Function} Returns the new composite function.
     * @see _.flow
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var addSquare = _.flowRight([square, _.add]);
     * addSquare(1, 2);
     * // => 9
     */
    var flowRight = createFlow(true);

    /**
     * This method returns the first argument it receives.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {*} value Any value.
     * @returns {*} Returns `value`.
     * @example
     *
     * var object = { 'a': 1 };
     *
     * console.log(_.identity(object) === object);
     * // => true
     */
    function identity(value) {
      return value;
    }

    /**
     * Creates a function that invokes `func` with the arguments of the created
     * function. If `func` is a property name, the created function returns the
     * property value for a given element. If `func` is an array or object, the
     * created function returns `true` for elements that contain the equivalent
     * source properties, otherwise it returns `false`.
     *
     * @static
     * @since 4.0.0
     * @memberOf _
     * @category Util
     * @param {*} [func=_.identity] The value to convert to a callback.
     * @returns {Function} Returns the callback.
     * @example
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36, 'active': true },
     *   { 'user': 'fred',   'age': 40, 'active': false }
     * ];
     *
     * // The `_.matches` iteratee shorthand.
     * _.filter(users, _.iteratee({ 'user': 'barney', 'active': true }));
     * // => [{ 'user': 'barney', 'age': 36, 'active': true }]
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.filter(users, _.iteratee(['user', 'fred']));
     * // => [{ 'user': 'fred', 'age': 40 }]
     *
     * // The `_.property` iteratee shorthand.
     * _.map(users, _.iteratee('user'));
     * // => ['barney', 'fred']
     *
     * // Create custom iteratee shorthands.
     * _.iteratee = _.wrap(_.iteratee, function(iteratee, func) {
     *   return !_.isRegExp(func) ? iteratee(func) : function(string) {
     *     return func.test(string);
     *   };
     * });
     *
     * _.filter(['abc', 'def'], /ef/);
     * // => ['def']
     */
    function iteratee(func) {
      return baseIteratee(typeof func == 'function' ? func : baseClone(func, CLONE_DEEP_FLAG));
    }

    /**
     * Creates a function that performs a partial deep comparison between a given
     * object and `source`, returning `true` if the given object has equivalent
     * property values, else `false`.
     *
     * **Note:** The created function is equivalent to `_.isMatch` with `source`
     * partially applied.
     *
     * Partial comparisons will match empty array and empty object `source`
     * values against any array or object value, respectively. See `_.isEqual`
     * for a list of supported value comparisons.
     *
     * **Note:** Multiple values can be checked by combining several matchers
     * using `_.overSome`
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Util
     * @param {Object} source The object of property values to match.
     * @returns {Function} Returns the new spec function.
     * @example
     *
     * var objects = [
     *   { 'a': 1, 'b': 2, 'c': 3 },
     *   { 'a': 4, 'b': 5, 'c': 6 }
     * ];
     *
     * _.filter(objects, _.matches({ 'a': 4, 'c': 6 }));
     * // => [{ 'a': 4, 'b': 5, 'c': 6 }]
     *
     * // Checking for several possible values
     * _.filter(objects, _.overSome([_.matches({ 'a': 1 }), _.matches({ 'a': 4 })]));
     * // => [{ 'a': 1, 'b': 2, 'c': 3 }, { 'a': 4, 'b': 5, 'c': 6 }]
     */
    function matches(source) {
      return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
    }

    /**
     * Creates a function that performs a partial deep comparison between the
     * value at `path` of a given object to `srcValue`, returning `true` if the
     * object value is equivalent, else `false`.
     *
     * **Note:** Partial comparisons will match empty array and empty object
     * `srcValue` values against any array or object value, respectively. See
     * `_.isEqual` for a list of supported value comparisons.
     *
     * **Note:** Multiple values can be checked by combining several matchers
     * using `_.overSome`
     *
     * @static
     * @memberOf _
     * @since 3.2.0
     * @category Util
     * @param {Array|string} path The path of the property to get.
     * @param {*} srcValue The value to match.
     * @returns {Function} Returns the new spec function.
     * @example
     *
     * var objects = [
     *   { 'a': 1, 'b': 2, 'c': 3 },
     *   { 'a': 4, 'b': 5, 'c': 6 }
     * ];
     *
     * _.find(objects, _.matchesProperty('a', 4));
     * // => { 'a': 4, 'b': 5, 'c': 6 }
     *
     * // Checking for several possible values
     * _.filter(objects, _.overSome([_.matchesProperty('a', 1), _.matchesProperty('a', 4)]));
     * // => [{ 'a': 1, 'b': 2, 'c': 3 }, { 'a': 4, 'b': 5, 'c': 6 }]
     */
    function matchesProperty(path, srcValue) {
      return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
    }

    /**
     * Creates a function that invokes the method at `path` of a given object.
     * Any additional arguments are provided to the invoked method.
     *
     * @static
     * @memberOf _
     * @since 3.7.0
     * @category Util
     * @param {Array|string} path The path of the method to invoke.
     * @param {...*} [args] The arguments to invoke the method with.
     * @returns {Function} Returns the new invoker function.
     * @example
     *
     * var objects = [
     *   { 'a': { 'b': _.constant(2) } },
     *   { 'a': { 'b': _.constant(1) } }
     * ];
     *
     * _.map(objects, _.method('a.b'));
     * // => [2, 1]
     *
     * _.map(objects, _.method(['a', 'b']));
     * // => [2, 1]
     */
    var method = baseRest(function(path, args) {
      return function(object) {
        return baseInvoke(object, path, args);
      };
    });

    /**
     * The opposite of `_.method`; this method creates a function that invokes
     * the method at a given path of `object`. Any additional arguments are
     * provided to the invoked method.
     *
     * @static
     * @memberOf _
     * @since 3.7.0
     * @category Util
     * @param {Object} object The object to query.
     * @param {...*} [args] The arguments to invoke the method with.
     * @returns {Function} Returns the new invoker function.
     * @example
     *
     * var array = _.times(3, _.constant),
     *     object = { 'a': array, 'b': array, 'c': array };
     *
     * _.map(['a[2]', 'c[0]'], _.methodOf(object));
     * // => [2, 0]
     *
     * _.map([['a', '2'], ['c', '0']], _.methodOf(object));
     * // => [2, 0]
     */
    var methodOf = baseRest(function(object, args) {
      return function(path) {
        return baseInvoke(object, path, args);
      };
    });

    /**
     * Adds all own enumerable string keyed function properties of a source
     * object to the destination object. If `object` is a function, then methods
     * are added to its prototype as well.
     *
     * **Note:** Use `_.runInContext` to create a pristine `lodash` function to
     * avoid conflicts caused by modifying the original.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {Function|Object} [object=lodash] The destination object.
     * @param {Object} source The object of functions to add.
     * @param {Object} [options={}] The options object.
     * @param {boolean} [options.chain=true] Specify whether mixins are chainable.
     * @returns {Function|Object} Returns `object`.
     * @example
     *
     * function vowels(string) {
     *   return _.filter(string, function(v) {
     *     return /[aeiou]/i.test(v);
     *   });
     * }
     *
     * _.mixin({ 'vowels': vowels });
     * _.vowels('fred');
     * // => ['e']
     *
     * _('fred').vowels().value();
     * // => ['e']
     *
     * _.mixin({ 'vowels': vowels }, { 'chain': false });
     * _('fred').vowels();
     * // => ['e']
     */
    function mixin(object, source, options) {
      var props = keys(source),
          methodNames = baseFunctions(source, props);

      if (options == null &&
          !(isObject(source) && (methodNames.length || !props.length))) {
        options = source;
        source = object;
        object = this;
        methodNames = baseFunctions(source, keys(source));
      }
      var chain = !(isObject(options) && 'chain' in options) || !!options.chain,
          isFunc = isFunction(object);

      arrayEach(methodNames, function(methodName) {
        var func = source[methodName];
        object[methodName] = func;
        if (isFunc) {
          object.prototype[methodName] = function() {
            var chainAll = this.__chain__;
            if (chain || chainAll) {
              var result = object(this.__wrapped__),
                  actions = result.__actions__ = copyArray(this.__actions__);

              actions.push({ 'func': func, 'args': arguments, 'thisArg': object });
              result.__chain__ = chainAll;
              return result;
            }
            return func.apply(object, arrayPush([this.value()], arguments));
          };
        }
      });

      return object;
    }

    /**
     * Reverts the `_` variable to its previous value and returns a reference to
     * the `lodash` function.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @returns {Function} Returns the `lodash` function.
     * @example
     *
     * var lodash = _.noConflict();
     */
    function noConflict() {
      if (root._ === this) {
        root._ = oldDash;
      }
      return this;
    }

    /**
     * This method returns `undefined`.
     *
     * @static
     * @memberOf _
     * @since 2.3.0
     * @category Util
     * @example
     *
     * _.times(2, _.noop);
     * // => [undefined, undefined]
     */
    function noop() {
      // No operation performed.
    }

    /**
     * Creates a function that gets the argument at index `n`. If `n` is negative,
     * the nth argument from the end is returned.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {number} [n=0] The index of the argument to return.
     * @returns {Function} Returns the new pass-thru function.
     * @example
     *
     * var func = _.nthArg(1);
     * func('a', 'b', 'c', 'd');
     * // => 'b'
     *
     * var func = _.nthArg(-2);
     * func('a', 'b', 'c', 'd');
     * // => 'c'
     */
    function nthArg(n) {
      n = toInteger(n);
      return baseRest(function(args) {
        return baseNth(args, n);
      });
    }

    /**
     * Creates a function that invokes `iteratees` with the arguments it receives
     * and returns their results.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {...(Function|Function[])} [iteratees=[_.identity]]
     *  The iteratees to invoke.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var func = _.over([Math.max, Math.min]);
     *
     * func(1, 2, 3, 4);
     * // => [4, 1]
     */
    var over = createOver(arrayMap);

    /**
     * Creates a function that checks if **all** of the `predicates` return
     * truthy when invoked with the arguments it receives.
     *
     * Following shorthands are possible for providing predicates.
     * Pass an `Object` and it will be used as an parameter for `_.matches` to create the predicate.
     * Pass an `Array` of parameters for `_.matchesProperty` and the predicate will be created using them.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {...(Function|Function[])} [predicates=[_.identity]]
     *  The predicates to check.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var func = _.overEvery([Boolean, isFinite]);
     *
     * func('1');
     * // => true
     *
     * func(null);
     * // => false
     *
     * func(NaN);
     * // => false
     */
    var overEvery = createOver(arrayEvery);

    /**
     * Creates a function that checks if **any** of the `predicates` return
     * truthy when invoked with the arguments it receives.
     *
     * Following shorthands are possible for providing predicates.
     * Pass an `Object` and it will be used as an parameter for `_.matches` to create the predicate.
     * Pass an `Array` of parameters for `_.matchesProperty` and the predicate will be created using them.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {...(Function|Function[])} [predicates=[_.identity]]
     *  The predicates to check.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var func = _.overSome([Boolean, isFinite]);
     *
     * func('1');
     * // => true
     *
     * func(null);
     * // => true
     *
     * func(NaN);
     * // => false
     *
     * var matchesFunc = _.overSome([{ 'a': 1 }, { 'a': 2 }])
     * var matchesPropertyFunc = _.overSome([['a', 1], ['a', 2]])
     */
    var overSome = createOver(arraySome);

    /**
     * Creates a function that returns the value at `path` of a given object.
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Util
     * @param {Array|string} path The path of the property to get.
     * @returns {Function} Returns the new accessor function.
     * @example
     *
     * var objects = [
     *   { 'a': { 'b': 2 } },
     *   { 'a': { 'b': 1 } }
     * ];
     *
     * _.map(objects, _.property('a.b'));
     * // => [2, 1]
     *
     * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
     * // => [1, 2]
     */
    function property(path) {
      return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
    }

    /**
     * The opposite of `_.property`; this method creates a function that returns
     * the value at a given path of `object`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Util
     * @param {Object} object The object to query.
     * @returns {Function} Returns the new accessor function.
     * @example
     *
     * var array = [0, 1, 2],
     *     object = { 'a': array, 'b': array, 'c': array };
     *
     * _.map(['a[2]', 'c[0]'], _.propertyOf(object));
     * // => [2, 0]
     *
     * _.map([['a', '2'], ['c', '0']], _.propertyOf(object));
     * // => [2, 0]
     */
    function propertyOf(object) {
      return function(path) {
        return object == null ? undefined : baseGet(object, path);
      };
    }

    /**
     * Creates an array of numbers (positive and/or negative) progressing from
     * `start` up to, but not including, `end`. A step of `-1` is used if a negative
     * `start` is specified without an `end` or `step`. If `end` is not specified,
     * it's set to `start` with `start` then set to `0`.
     *
     * **Note:** JavaScript follows the IEEE-754 standard for resolving
     * floating-point values which can produce unexpected results.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {number} [start=0] The start of the range.
     * @param {number} end The end of the range.
     * @param {number} [step=1] The value to increment or decrement by.
     * @returns {Array} Returns the range of numbers.
     * @see _.inRange, _.rangeRight
     * @example
     *
     * _.range(4);
     * // => [0, 1, 2, 3]
     *
     * _.range(-4);
     * // => [0, -1, -2, -3]
     *
     * _.range(1, 5);
     * // => [1, 2, 3, 4]
     *
     * _.range(0, 20, 5);
     * // => [0, 5, 10, 15]
     *
     * _.range(0, -4, -1);
     * // => [0, -1, -2, -3]
     *
     * _.range(1, 4, 0);
     * // => [1, 1, 1]
     *
     * _.range(0);
     * // => []
     */
    var range = createRange();

    /**
     * This method is like `_.range` except that it populates values in
     * descending order.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {number} [start=0] The start of the range.
     * @param {number} end The end of the range.
     * @param {number} [step=1] The value to increment or decrement by.
     * @returns {Array} Returns the range of numbers.
     * @see _.inRange, _.range
     * @example
     *
     * _.rangeRight(4);
     * // => [3, 2, 1, 0]
     *
     * _.rangeRight(-4);
     * // => [-3, -2, -1, 0]
     *
     * _.rangeRight(1, 5);
     * // => [4, 3, 2, 1]
     *
     * _.rangeRight(0, 20, 5);
     * // => [15, 10, 5, 0]
     *
     * _.rangeRight(0, -4, -1);
     * // => [-3, -2, -1, 0]
     *
     * _.rangeRight(1, 4, 0);
     * // => [1, 1, 1]
     *
     * _.rangeRight(0);
     * // => []
     */
    var rangeRight = createRange(true);

    /**
     * This method returns a new empty array.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {Array} Returns the new empty array.
     * @example
     *
     * var arrays = _.times(2, _.stubArray);
     *
     * console.log(arrays);
     * // => [[], []]
     *
     * console.log(arrays[0] === arrays[1]);
     * // => false
     */
    function stubArray() {
      return [];
    }

    /**
     * This method returns `false`.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {boolean} Returns `false`.
     * @example
     *
     * _.times(2, _.stubFalse);
     * // => [false, false]
     */
    function stubFalse() {
      return false;
    }

    /**
     * This method returns a new empty object.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {Object} Returns the new empty object.
     * @example
     *
     * var objects = _.times(2, _.stubObject);
     *
     * console.log(objects);
     * // => [{}, {}]
     *
     * console.log(objects[0] === objects[1]);
     * // => false
     */
    function stubObject() {
      return {};
    }

    /**
     * This method returns an empty string.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {string} Returns the empty string.
     * @example
     *
     * _.times(2, _.stubString);
     * // => ['', '']
     */
    function stubString() {
      return '';
    }

    /**
     * This method returns `true`.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {boolean} Returns `true`.
     * @example
     *
     * _.times(2, _.stubTrue);
     * // => [true, true]
     */
    function stubTrue() {
      return true;
    }

    /**
     * Invokes the iteratee `n` times, returning an array of the results of
     * each invocation. The iteratee is invoked with one argument; (index).
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {number} n The number of times to invoke `iteratee`.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the array of results.
     * @example
     *
     * _.times(3, String);
     * // => ['0', '1', '2']
     *
     *  _.times(4, _.constant(0));
     * // => [0, 0, 0, 0]
     */
    function times(n, iteratee) {
      n = toInteger(n);
      if (n < 1 || n > MAX_SAFE_INTEGER) {
        return [];
      }
      var index = MAX_ARRAY_LENGTH,
          length = nativeMin(n, MAX_ARRAY_LENGTH);

      iteratee = getIteratee(iteratee);
      n -= MAX_ARRAY_LENGTH;

      var result = baseTimes(length, iteratee);
      while (++index < n) {
        iteratee(index);
      }
      return result;
    }

    /**
     * Converts `value` to a property path array.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {*} value The value to convert.
     * @returns {Array} Returns the new property path array.
     * @example
     *
     * _.toPath('a.b.c');
     * // => ['a', 'b', 'c']
     *
     * _.toPath('a[0].b.c');
     * // => ['a', '0', 'b', 'c']
     */
    function toPath(value) {
      if (isArray(value)) {
        return arrayMap(value, toKey);
      }
      return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));
    }

    /**
     * Generates a unique ID. If `prefix` is given, the ID is appended to it.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {string} [prefix=''] The value to prefix the ID with.
     * @returns {string} Returns the unique ID.
     * @example
     *
     * _.uniqueId('contact_');
     * // => 'contact_104'
     *
     * _.uniqueId();
     * // => '105'
     */
    function uniqueId(prefix) {
      var id = ++idCounter;
      return toString(prefix) + id;
    }

    /*------------------------------------------------------------------------*/

    /**
     * Adds two numbers.
     *
     * @static
     * @memberOf _
     * @since 3.4.0
     * @category Math
     * @param {number} augend The first number in an addition.
     * @param {number} addend The second number in an addition.
     * @returns {number} Returns the total.
     * @example
     *
     * _.add(6, 4);
     * // => 10
     */
    var add = createMathOperation(function(augend, addend) {
      return augend + addend;
    }, 0);

    /**
     * Computes `number` rounded up to `precision`.
     *
     * @static
     * @memberOf _
     * @since 3.10.0
     * @category Math
     * @param {number} number The number to round up.
     * @param {number} [precision=0] The precision to round up to.
     * @returns {number} Returns the rounded up number.
     * @example
     *
     * _.ceil(4.006);
     * // => 5
     *
     * _.ceil(6.004, 2);
     * // => 6.01
     *
     * _.ceil(6040, -2);
     * // => 6100
     */
    var ceil = createRound('ceil');

    /**
     * Divide two numbers.
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Math
     * @param {number} dividend The first number in a division.
     * @param {number} divisor The second number in a division.
     * @returns {number} Returns the quotient.
     * @example
     *
     * _.divide(6, 4);
     * // => 1.5
     */
    var divide = createMathOperation(function(dividend, divisor) {
      return dividend / divisor;
    }, 1);

    /**
     * Computes `number` rounded down to `precision`.
     *
     * @static
     * @memberOf _
     * @since 3.10.0
     * @category Math
     * @param {number} number The number to round down.
     * @param {number} [precision=0] The precision to round down to.
     * @returns {number} Returns the rounded down number.
     * @example
     *
     * _.floor(4.006);
     * // => 4
     *
     * _.floor(0.046, 2);
     * // => 0.04
     *
     * _.floor(4060, -2);
     * // => 4000
     */
    var floor = createRound('floor');

    /**
     * Computes the maximum value of `array`. If `array` is empty or falsey,
     * `undefined` is returned.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Math
     * @param {Array} array The array to iterate over.
     * @returns {*} Returns the maximum value.
     * @example
     *
     * _.max([4, 2, 8, 6]);
     * // => 8
     *
     * _.max([]);
     * // => undefined
     */
    function max(array) {
      return (array && array.length)
        ? baseExtremum(array, identity, baseGt)
        : undefined;
    }

    /**
     * This method is like `_.max` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the criterion by which
     * the value is ranked. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {*} Returns the maximum value.
     * @example
     *
     * var objects = [{ 'n': 1 }, { 'n': 2 }];
     *
     * _.maxBy(objects, function(o) { return o.n; });
     * // => { 'n': 2 }
     *
     * // The `_.property` iteratee shorthand.
     * _.maxBy(objects, 'n');
     * // => { 'n': 2 }
     */
    function maxBy(array, iteratee) {
      return (array && array.length)
        ? baseExtremum(array, getIteratee(iteratee, 2), baseGt)
        : undefined;
    }

    /**
     * Computes the mean of the values in `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @returns {number} Returns the mean.
     * @example
     *
     * _.mean([4, 2, 8, 6]);
     * // => 5
     */
    function mean(array) {
      return baseMean(array, identity);
    }

    /**
     * This method is like `_.mean` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the value to be averaged.
     * The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {number} Returns the mean.
     * @example
     *
     * var objects = [{ 'n': 4 }, { 'n': 2 }, { 'n': 8 }, { 'n': 6 }];
     *
     * _.meanBy(objects, function(o) { return o.n; });
     * // => 5
     *
     * // The `_.property` iteratee shorthand.
     * _.meanBy(objects, 'n');
     * // => 5
     */
    function meanBy(array, iteratee) {
      return baseMean(array, getIteratee(iteratee, 2));
    }

    /**
     * Computes the minimum value of `array`. If `array` is empty or falsey,
     * `undefined` is returned.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Math
     * @param {Array} array The array to iterate over.
     * @returns {*} Returns the minimum value.
     * @example
     *
     * _.min([4, 2, 8, 6]);
     * // => 2
     *
     * _.min([]);
     * // => undefined
     */
    function min(array) {
      return (array && array.length)
        ? baseExtremum(array, identity, baseLt)
        : undefined;
    }

    /**
     * This method is like `_.min` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the criterion by which
     * the value is ranked. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {*} Returns the minimum value.
     * @example
     *
     * var objects = [{ 'n': 1 }, { 'n': 2 }];
     *
     * _.minBy(objects, function(o) { return o.n; });
     * // => { 'n': 1 }
     *
     * // The `_.property` iteratee shorthand.
     * _.minBy(objects, 'n');
     * // => { 'n': 1 }
     */
    function minBy(array, iteratee) {
      return (array && array.length)
        ? baseExtremum(array, getIteratee(iteratee, 2), baseLt)
        : undefined;
    }

    /**
     * Multiply two numbers.
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Math
     * @param {number} multiplier The first number in a multiplication.
     * @param {number} multiplicand The second number in a multiplication.
     * @returns {number} Returns the product.
     * @example
     *
     * _.multiply(6, 4);
     * // => 24
     */
    var multiply = createMathOperation(function(multiplier, multiplicand) {
      return multiplier * multiplicand;
    }, 1);

    /**
     * Computes `number` rounded to `precision`.
     *
     * @static
     * @memberOf _
     * @since 3.10.0
     * @category Math
     * @param {number} number The number to round.
     * @param {number} [precision=0] The precision to round to.
     * @returns {number} Returns the rounded number.
     * @example
     *
     * _.round(4.006);
     * // => 4
     *
     * _.round(4.006, 2);
     * // => 4.01
     *
     * _.round(4060, -2);
     * // => 4100
     */
    var round = createRound('round');

    /**
     * Subtract two numbers.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {number} minuend The first number in a subtraction.
     * @param {number} subtrahend The second number in a subtraction.
     * @returns {number} Returns the difference.
     * @example
     *
     * _.subtract(6, 4);
     * // => 2
     */
    var subtract = createMathOperation(function(minuend, subtrahend) {
      return minuend - subtrahend;
    }, 0);

    /**
     * Computes the sum of the values in `array`.
     *
     * @static
     * @memberOf _
     * @since 3.4.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @returns {number} Returns the sum.
     * @example
     *
     * _.sum([4, 2, 8, 6]);
     * // => 20
     */
    function sum(array) {
      return (array && array.length)
        ? baseSum(array, identity)
        : 0;
    }

    /**
     * This method is like `_.sum` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the value to be summed.
     * The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {number} Returns the sum.
     * @example
     *
     * var objects = [{ 'n': 4 }, { 'n': 2 }, { 'n': 8 }, { 'n': 6 }];
     *
     * _.sumBy(objects, function(o) { return o.n; });
     * // => 20
     *
     * // The `_.property` iteratee shorthand.
     * _.sumBy(objects, 'n');
     * // => 20
     */
    function sumBy(array, iteratee) {
      return (array && array.length)
        ? baseSum(array, getIteratee(iteratee, 2))
        : 0;
    }

    /*------------------------------------------------------------------------*/

    // Add methods that return wrapped values in chain sequences.
    lodash.after = after;
    lodash.ary = ary;
    lodash.assign = assign;
    lodash.assignIn = assignIn;
    lodash.assignInWith = assignInWith;
    lodash.assignWith = assignWith;
    lodash.at = at;
    lodash.before = before;
    lodash.bind = bind;
    lodash.bindAll = bindAll;
    lodash.bindKey = bindKey;
    lodash.castArray = castArray;
    lodash.chain = chain;
    lodash.chunk = chunk;
    lodash.compact = compact;
    lodash.concat = concat;
    lodash.cond = cond;
    lodash.conforms = conforms;
    lodash.constant = constant;
    lodash.countBy = countBy;
    lodash.create = create;
    lodash.curry = curry;
    lodash.curryRight = curryRight;
    lodash.debounce = debounce;
    lodash.defaults = defaults;
    lodash.defaultsDeep = defaultsDeep;
    lodash.defer = defer;
    lodash.delay = delay;
    lodash.difference = difference;
    lodash.differenceBy = differenceBy;
    lodash.differenceWith = differenceWith;
    lodash.drop = drop;
    lodash.dropRight = dropRight;
    lodash.dropRightWhile = dropRightWhile;
    lodash.dropWhile = dropWhile;
    lodash.fill = fill;
    lodash.filter = filter;
    lodash.flatMap = flatMap;
    lodash.flatMapDeep = flatMapDeep;
    lodash.flatMapDepth = flatMapDepth;
    lodash.flatten = flatten;
    lodash.flattenDeep = flattenDeep;
    lodash.flattenDepth = flattenDepth;
    lodash.flip = flip;
    lodash.flow = flow;
    lodash.flowRight = flowRight;
    lodash.fromPairs = fromPairs;
    lodash.functions = functions;
    lodash.functionsIn = functionsIn;
    lodash.groupBy = groupBy;
    lodash.initial = initial;
    lodash.intersection = intersection;
    lodash.intersectionBy = intersectionBy;
    lodash.intersectionWith = intersectionWith;
    lodash.invert = invert;
    lodash.invertBy = invertBy;
    lodash.invokeMap = invokeMap;
    lodash.iteratee = iteratee;
    lodash.keyBy = keyBy;
    lodash.keys = keys;
    lodash.keysIn = keysIn;
    lodash.map = map;
    lodash.mapKeys = mapKeys;
    lodash.mapValues = mapValues;
    lodash.matches = matches;
    lodash.matchesProperty = matchesProperty;
    lodash.memoize = memoize;
    lodash.merge = merge;
    lodash.mergeWith = mergeWith;
    lodash.method = method;
    lodash.methodOf = methodOf;
    lodash.mixin = mixin;
    lodash.negate = negate;
    lodash.nthArg = nthArg;
    lodash.omit = omit;
    lodash.omitBy = omitBy;
    lodash.once = once;
    lodash.orderBy = orderBy;
    lodash.over = over;
    lodash.overArgs = overArgs;
    lodash.overEvery = overEvery;
    lodash.overSome = overSome;
    lodash.partial = partial;
    lodash.partialRight = partialRight;
    lodash.partition = partition;
    lodash.pick = pick;
    lodash.pickBy = pickBy;
    lodash.property = property;
    lodash.propertyOf = propertyOf;
    lodash.pull = pull;
    lodash.pullAll = pullAll;
    lodash.pullAllBy = pullAllBy;
    lodash.pullAllWith = pullAllWith;
    lodash.pullAt = pullAt;
    lodash.range = range;
    lodash.rangeRight = rangeRight;
    lodash.rearg = rearg;
    lodash.reject = reject;
    lodash.remove = remove;
    lodash.rest = rest;
    lodash.reverse = reverse;
    lodash.sampleSize = sampleSize;
    lodash.set = set;
    lodash.setWith = setWith;
    lodash.shuffle = shuffle;
    lodash.slice = slice;
    lodash.sortBy = sortBy;
    lodash.sortedUniq = sortedUniq;
    lodash.sortedUniqBy = sortedUniqBy;
    lodash.split = split;
    lodash.spread = spread;
    lodash.tail = tail;
    lodash.take = take;
    lodash.takeRight = takeRight;
    lodash.takeRightWhile = takeRightWhile;
    lodash.takeWhile = takeWhile;
    lodash.tap = tap;
    lodash.throttle = throttle;
    lodash.thru = thru;
    lodash.toArray = toArray;
    lodash.toPairs = toPairs;
    lodash.toPairsIn = toPairsIn;
    lodash.toPath = toPath;
    lodash.toPlainObject = toPlainObject;
    lodash.transform = transform;
    lodash.unary = unary;
    lodash.union = union;
    lodash.unionBy = unionBy;
    lodash.unionWith = unionWith;
    lodash.uniq = uniq;
    lodash.uniqBy = uniqBy;
    lodash.uniqWith = uniqWith;
    lodash.unset = unset;
    lodash.unzip = unzip;
    lodash.unzipWith = unzipWith;
    lodash.update = update;
    lodash.updateWith = updateWith;
    lodash.values = values;
    lodash.valuesIn = valuesIn;
    lodash.without = without;
    lodash.words = words;
    lodash.wrap = wrap;
    lodash.xor = xor;
    lodash.xorBy = xorBy;
    lodash.xorWith = xorWith;
    lodash.zip = zip;
    lodash.zipObject = zipObject;
    lodash.zipObjectDeep = zipObjectDeep;
    lodash.zipWith = zipWith;

    // Add aliases.
    lodash.entries = toPairs;
    lodash.entriesIn = toPairsIn;
    lodash.extend = assignIn;
    lodash.extendWith = assignInWith;

    // Add methods to `lodash.prototype`.
    mixin(lodash, lodash);

    /*------------------------------------------------------------------------*/

    // Add methods that return unwrapped values in chain sequences.
    lodash.add = add;
    lodash.attempt = attempt;
    lodash.camelCase = camelCase;
    lodash.capitalize = capitalize;
    lodash.ceil = ceil;
    lodash.clamp = clamp;
    lodash.clone = clone;
    lodash.cloneDeep = cloneDeep;
    lodash.cloneDeepWith = cloneDeepWith;
    lodash.cloneWith = cloneWith;
    lodash.conformsTo = conformsTo;
    lodash.deburr = deburr;
    lodash.defaultTo = defaultTo;
    lodash.divide = divide;
    lodash.endsWith = endsWith;
    lodash.eq = eq;
    lodash.escape = escape;
    lodash.escapeRegExp = escapeRegExp;
    lodash.every = every;
    lodash.find = find;
    lodash.findIndex = findIndex;
    lodash.findKey = findKey;
    lodash.findLast = findLast;
    lodash.findLastIndex = findLastIndex;
    lodash.findLastKey = findLastKey;
    lodash.floor = floor;
    lodash.forEach = forEach;
    lodash.forEachRight = forEachRight;
    lodash.forIn = forIn;
    lodash.forInRight = forInRight;
    lodash.forOwn = forOwn;
    lodash.forOwnRight = forOwnRight;
    lodash.get = get;
    lodash.gt = gt;
    lodash.gte = gte;
    lodash.has = has;
    lodash.hasIn = hasIn;
    lodash.head = head;
    lodash.identity = identity;
    lodash.includes = includes;
    lodash.indexOf = indexOf;
    lodash.inRange = inRange;
    lodash.invoke = invoke;
    lodash.isArguments = isArguments;
    lodash.isArray = isArray;
    lodash.isArrayBuffer = isArrayBuffer;
    lodash.isArrayLike = isArrayLike;
    lodash.isArrayLikeObject = isArrayLikeObject;
    lodash.isBoolean = isBoolean;
    lodash.isBuffer = isBuffer;
    lodash.isDate = isDate;
    lodash.isElement = isElement;
    lodash.isEmpty = isEmpty;
    lodash.isEqual = isEqual;
    lodash.isEqualWith = isEqualWith;
    lodash.isError = isError;
    lodash.isFinite = isFinite;
    lodash.isFunction = isFunction;
    lodash.isInteger = isInteger;
    lodash.isLength = isLength;
    lodash.isMap = isMap;
    lodash.isMatch = isMatch;
    lodash.isMatchWith = isMatchWith;
    lodash.isNaN = isNaN;
    lodash.isNative = isNative;
    lodash.isNil = isNil;
    lodash.isNull = isNull;
    lodash.isNumber = isNumber;
    lodash.isObject = isObject;
    lodash.isObjectLike = isObjectLike;
    lodash.isPlainObject = isPlainObject;
    lodash.isRegExp = isRegExp;
    lodash.isSafeInteger = isSafeInteger;
    lodash.isSet = isSet;
    lodash.isString = isString;
    lodash.isSymbol = isSymbol;
    lodash.isTypedArray = isTypedArray;
    lodash.isUndefined = isUndefined;
    lodash.isWeakMap = isWeakMap;
    lodash.isWeakSet = isWeakSet;
    lodash.join = join;
    lodash.kebabCase = kebabCase;
    lodash.last = last;
    lodash.lastIndexOf = lastIndexOf;
    lodash.lowerCase = lowerCase;
    lodash.lowerFirst = lowerFirst;
    lodash.lt = lt;
    lodash.lte = lte;
    lodash.max = max;
    lodash.maxBy = maxBy;
    lodash.mean = mean;
    lodash.meanBy = meanBy;
    lodash.min = min;
    lodash.minBy = minBy;
    lodash.stubArray = stubArray;
    lodash.stubFalse = stubFalse;
    lodash.stubObject = stubObject;
    lodash.stubString = stubString;
    lodash.stubTrue = stubTrue;
    lodash.multiply = multiply;
    lodash.nth = nth;
    lodash.noConflict = noConflict;
    lodash.noop = noop;
    lodash.now = now;
    lodash.pad = pad;
    lodash.padEnd = padEnd;
    lodash.padStart = padStart;
    lodash.parseInt = parseInt;
    lodash.random = random;
    lodash.reduce = reduce;
    lodash.reduceRight = reduceRight;
    lodash.repeat = repeat;
    lodash.replace = replace;
    lodash.result = result;
    lodash.round = round;
    lodash.runInContext = runInContext;
    lodash.sample = sample;
    lodash.size = size;
    lodash.snakeCase = snakeCase;
    lodash.some = some;
    lodash.sortedIndex = sortedIndex;
    lodash.sortedIndexBy = sortedIndexBy;
    lodash.sortedIndexOf = sortedIndexOf;
    lodash.sortedLastIndex = sortedLastIndex;
    lodash.sortedLastIndexBy = sortedLastIndexBy;
    lodash.sortedLastIndexOf = sortedLastIndexOf;
    lodash.startCase = startCase;
    lodash.startsWith = startsWith;
    lodash.subtract = subtract;
    lodash.sum = sum;
    lodash.sumBy = sumBy;
    lodash.template = template;
    lodash.times = times;
    lodash.toFinite = toFinite;
    lodash.toInteger = toInteger;
    lodash.toLength = toLength;
    lodash.toLower = toLower;
    lodash.toNumber = toNumber;
    lodash.toSafeInteger = toSafeInteger;
    lodash.toString = toString;
    lodash.toUpper = toUpper;
    lodash.trim = trim;
    lodash.trimEnd = trimEnd;
    lodash.trimStart = trimStart;
    lodash.truncate = truncate;
    lodash.unescape = unescape;
    lodash.uniqueId = uniqueId;
    lodash.upperCase = upperCase;
    lodash.upperFirst = upperFirst;

    // Add aliases.
    lodash.each = forEach;
    lodash.eachRight = forEachRight;
    lodash.first = head;

    mixin(lodash, (function() {
      var source = {};
      baseForOwn(lodash, function(func, methodName) {
        if (!hasOwnProperty.call(lodash.prototype, methodName)) {
          source[methodName] = func;
        }
      });
      return source;
    }()), { 'chain': false });

    /*------------------------------------------------------------------------*/

    /**
     * The semantic version number.
     *
     * @static
     * @memberOf _
     * @type {string}
     */
    lodash.VERSION = VERSION;

    // Assign default placeholders.
    arrayEach(['bind', 'bindKey', 'curry', 'curryRight', 'partial', 'partialRight'], function(methodName) {
      lodash[methodName].placeholder = lodash;
    });

    // Add `LazyWrapper` methods for `_.drop` and `_.take` variants.
    arrayEach(['drop', 'take'], function(methodName, index) {
      LazyWrapper.prototype[methodName] = function(n) {
        n = n === undefined ? 1 : nativeMax(toInteger(n), 0);

        var result = (this.__filtered__ && !index)
          ? new LazyWrapper(this)
          : this.clone();

        if (result.__filtered__) {
          result.__takeCount__ = nativeMin(n, result.__takeCount__);
        } else {
          result.__views__.push({
            'size': nativeMin(n, MAX_ARRAY_LENGTH),
            'type': methodName + (result.__dir__ < 0 ? 'Right' : '')
          });
        }
        return result;
      };

      LazyWrapper.prototype[methodName + 'Right'] = function(n) {
        return this.reverse()[methodName](n).reverse();
      };
    });

    // Add `LazyWrapper` methods that accept an `iteratee` value.
    arrayEach(['filter', 'map', 'takeWhile'], function(methodName, index) {
      var type = index + 1,
          isFilter = type == LAZY_FILTER_FLAG || type == LAZY_WHILE_FLAG;

      LazyWrapper.prototype[methodName] = function(iteratee) {
        var result = this.clone();
        result.__iteratees__.push({
          'iteratee': getIteratee(iteratee, 3),
          'type': type
        });
        result.__filtered__ = result.__filtered__ || isFilter;
        return result;
      };
    });

    // Add `LazyWrapper` methods for `_.head` and `_.last`.
    arrayEach(['head', 'last'], function(methodName, index) {
      var takeName = 'take' + (index ? 'Right' : '');

      LazyWrapper.prototype[methodName] = function() {
        return this[takeName](1).value()[0];
      };
    });

    // Add `LazyWrapper` methods for `_.initial` and `_.tail`.
    arrayEach(['initial', 'tail'], function(methodName, index) {
      var dropName = 'drop' + (index ? '' : 'Right');

      LazyWrapper.prototype[methodName] = function() {
        return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
      };
    });

    LazyWrapper.prototype.compact = function() {
      return this.filter(identity);
    };

    LazyWrapper.prototype.find = function(predicate) {
      return this.filter(predicate).head();
    };

    LazyWrapper.prototype.findLast = function(predicate) {
      return this.reverse().find(predicate);
    };

    LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
      if (typeof path == 'function') {
        return new LazyWrapper(this);
      }
      return this.map(function(value) {
        return baseInvoke(value, path, args);
      });
    });

    LazyWrapper.prototype.reject = function(predicate) {
      return this.filter(negate(getIteratee(predicate)));
    };

    LazyWrapper.prototype.slice = function(start, end) {
      start = toInteger(start);

      var result = this;
      if (result.__filtered__ && (start > 0 || end < 0)) {
        return new LazyWrapper(result);
      }
      if (start < 0) {
        result = result.takeRight(-start);
      } else if (start) {
        result = result.drop(start);
      }
      if (end !== undefined) {
        end = toInteger(end);
        result = end < 0 ? result.dropRight(-end) : result.take(end - start);
      }
      return result;
    };

    LazyWrapper.prototype.takeRightWhile = function(predicate) {
      return this.reverse().takeWhile(predicate).reverse();
    };

    LazyWrapper.prototype.toArray = function() {
      return this.take(MAX_ARRAY_LENGTH);
    };

    // Add `LazyWrapper` methods to `lodash.prototype`.
    baseForOwn(LazyWrapper.prototype, function(func, methodName) {
      var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName),
          isTaker = /^(?:head|last)$/.test(methodName),
          lodashFunc = lodash[isTaker ? ('take' + (methodName == 'last' ? 'Right' : '')) : methodName],
          retUnwrapped = isTaker || /^find/.test(methodName);

      if (!lodashFunc) {
        return;
      }
      lodash.prototype[methodName] = function() {
        var value = this.__wrapped__,
            args = isTaker ? [1] : arguments,
            isLazy = value instanceof LazyWrapper,
            iteratee = args[0],
            useLazy = isLazy || isArray(value);

        var interceptor = function(value) {
          var result = lodashFunc.apply(lodash, arrayPush([value], args));
          return (isTaker && chainAll) ? result[0] : result;
        };

        if (useLazy && checkIteratee && typeof iteratee == 'function' && iteratee.length != 1) {
          // Avoid lazy use if the iteratee has a "length" value other than `1`.
          isLazy = useLazy = false;
        }
        var chainAll = this.__chain__,
            isHybrid = !!this.__actions__.length,
            isUnwrapped = retUnwrapped && !chainAll,
            onlyLazy = isLazy && !isHybrid;

        if (!retUnwrapped && useLazy) {
          value = onlyLazy ? value : new LazyWrapper(this);
          var result = func.apply(value, args);
          result.__actions__.push({ 'func': thru, 'args': [interceptor], 'thisArg': undefined });
          return new LodashWrapper(result, chainAll);
        }
        if (isUnwrapped && onlyLazy) {
          return func.apply(this, args);
        }
        result = this.thru(interceptor);
        return isUnwrapped ? (isTaker ? result.value()[0] : result.value()) : result;
      };
    });

    // Add `Array` methods to `lodash.prototype`.
    arrayEach(['pop', 'push', 'shift', 'sort', 'splice', 'unshift'], function(methodName) {
      var func = arrayProto[methodName],
          chainName = /^(?:push|sort|unshift)$/.test(methodName) ? 'tap' : 'thru',
          retUnwrapped = /^(?:pop|shift)$/.test(methodName);

      lodash.prototype[methodName] = function() {
        var args = arguments;
        if (retUnwrapped && !this.__chain__) {
          var value = this.value();
          return func.apply(isArray(value) ? value : [], args);
        }
        return this[chainName](function(value) {
          return func.apply(isArray(value) ? value : [], args);
        });
      };
    });

    // Map minified method names to their real names.
    baseForOwn(LazyWrapper.prototype, function(func, methodName) {
      var lodashFunc = lodash[methodName];
      if (lodashFunc) {
        var key = lodashFunc.name + '';
        if (!hasOwnProperty.call(realNames, key)) {
          realNames[key] = [];
        }
        realNames[key].push({ 'name': methodName, 'func': lodashFunc });
      }
    });

    realNames[createHybrid(undefined, WRAP_BIND_KEY_FLAG).name] = [{
      'name': 'wrapper',
      'func': undefined
    }];

    // Add methods to `LazyWrapper`.
    LazyWrapper.prototype.clone = lazyClone;
    LazyWrapper.prototype.reverse = lazyReverse;
    LazyWrapper.prototype.value = lazyValue;

    // Add chain sequence methods to the `lodash` wrapper.
    lodash.prototype.at = wrapperAt;
    lodash.prototype.chain = wrapperChain;
    lodash.prototype.commit = wrapperCommit;
    lodash.prototype.next = wrapperNext;
    lodash.prototype.plant = wrapperPlant;
    lodash.prototype.reverse = wrapperReverse;
    lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;

    // Add lazy aliases.
    lodash.prototype.first = lodash.prototype.head;

    if (symIterator) {
      lodash.prototype[symIterator] = wrapperToIterator;
    }
    return lodash;
  });

  /*--------------------------------------------------------------------------*/

  // Export lodash.
  var _ = runInContext();

  // Some AMD build optimizers, like r.js, check for condition patterns like:
  if (true) {
    // Expose Lodash on the global object to prevent errors when Lodash is
    // loaded by a script tag in the presence of an AMD loader.
    // See http://requirejs.org/docs/errors.html#mismatch for more details.
    // Use `_.noConflict` to remove Lodash from the global object.
    root._ = _;

    // Define as an anonymous module so, through path mapping, it can be
    // referenced as the "underscore" module.
    !(__WEBPACK_AMD_DEFINE_RESULT__ = (function() {
      return _;
    }).call(exports, __webpack_require__, exports, module),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
  }
  // Check for `exports` after `define` in case a build optimizer adds it.
  else {}
}.call(this));


/***/ }),

/***/ 43:
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_RESULT__;/*
* loglevel - https://github.com/pimterry/loglevel
*
* Copyright (c) 2013 Tim Perry
* Licensed under the MIT license.
*/
(function (root, definition) {
    "use strict";
    if (true) {
        !(__WEBPACK_AMD_DEFINE_FACTORY__ = (definition),
		__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
		(__WEBPACK_AMD_DEFINE_FACTORY__.call(exports, __webpack_require__, exports, module)) :
		__WEBPACK_AMD_DEFINE_FACTORY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    } else {}
}(this, function () {
    "use strict";

    // Slightly dubious tricks to cut down minimized file size
    var noop = function() {};
    var undefinedType = "undefined";
    var isIE = (typeof window !== undefinedType) && (typeof window.navigator !== undefinedType) && (
        /Trident\/|MSIE /.test(window.navigator.userAgent)
    );

    var logMethods = [
        "trace",
        "debug",
        "info",
        "warn",
        "error"
    ];

    // Cross-browser bind equivalent that works at least back to IE6
    function bindMethod(obj, methodName) {
        var method = obj[methodName];
        if (typeof method.bind === 'function') {
            return method.bind(obj);
        } else {
            try {
                return Function.prototype.bind.call(method, obj);
            } catch (e) {
                // Missing bind shim or IE8 + Modernizr, fallback to wrapping
                return function() {
                    return Function.prototype.apply.apply(method, [obj, arguments]);
                };
            }
        }
    }

    // Trace() doesn't print the message in IE, so for that case we need to wrap it
    function traceForIE() {
        if (console.log) {
            if (console.log.apply) {
                console.log.apply(console, arguments);
            } else {
                // In old IE, native console methods themselves don't have apply().
                Function.prototype.apply.apply(console.log, [console, arguments]);
            }
        }
        if (console.trace) console.trace();
    }

    // Build the best logging method possible for this env
    // Wherever possible we want to bind, not wrap, to preserve stack traces
    function realMethod(methodName) {
        if (methodName === 'debug') {
            methodName = 'log';
        }

        if (typeof console === undefinedType) {
            return false; // No method possible, for now - fixed later by enableLoggingWhenConsoleArrives
        } else if (methodName === 'trace' && isIE) {
            return traceForIE;
        } else if (console[methodName] !== undefined) {
            return bindMethod(console, methodName);
        } else if (console.log !== undefined) {
            return bindMethod(console, 'log');
        } else {
            return noop;
        }
    }

    // These private functions always need `this` to be set properly

    function replaceLoggingMethods(level, loggerName) {
        /*jshint validthis:true */
        for (var i = 0; i < logMethods.length; i++) {
            var methodName = logMethods[i];
            this[methodName] = (i < level) ?
                noop :
                this.methodFactory(methodName, level, loggerName);
        }

        // Define log.log as an alias for log.debug
        this.log = this.debug;
    }

    // In old IE versions, the console isn't present until you first open it.
    // We build realMethod() replacements here that regenerate logging methods
    function enableLoggingWhenConsoleArrives(methodName, level, loggerName) {
        return function () {
            if (typeof console !== undefinedType) {
                replaceLoggingMethods.call(this, level, loggerName);
                this[methodName].apply(this, arguments);
            }
        };
    }

    // By default, we use closely bound real methods wherever possible, and
    // otherwise we wait for a console to appear, and then try again.
    function defaultMethodFactory(methodName, level, loggerName) {
        /*jshint validthis:true */
        return realMethod(methodName) ||
               enableLoggingWhenConsoleArrives.apply(this, arguments);
    }

    function Logger(name, defaultLevel, factory) {
      var self = this;
      var currentLevel;

      var storageKey = "loglevel";
      if (typeof name === "string") {
        storageKey += ":" + name;
      } else if (typeof name === "symbol") {
        storageKey = undefined;
      }

      function persistLevelIfPossible(levelNum) {
          var levelName = (logMethods[levelNum] || 'silent').toUpperCase();

          if (typeof window === undefinedType || !storageKey) return;

          // Use localStorage if available
          try {
              window.localStorage[storageKey] = levelName;
              return;
          } catch (ignore) {}

          // Use session cookie as fallback
          try {
              window.document.cookie =
                encodeURIComponent(storageKey) + "=" + levelName + ";";
          } catch (ignore) {}
      }

      function getPersistedLevel() {
          var storedLevel;

          if (typeof window === undefinedType || !storageKey) return;

          try {
              storedLevel = window.localStorage[storageKey];
          } catch (ignore) {}

          // Fallback to cookies if local storage gives us nothing
          if (typeof storedLevel === undefinedType) {
              try {
                  var cookie = window.document.cookie;
                  var location = cookie.indexOf(
                      encodeURIComponent(storageKey) + "=");
                  if (location !== -1) {
                      storedLevel = /^([^;]+)/.exec(cookie.slice(location))[1];
                  }
              } catch (ignore) {}
          }

          // If the stored level is not valid, treat it as if nothing was stored.
          if (self.levels[storedLevel] === undefined) {
              storedLevel = undefined;
          }

          return storedLevel;
      }

      /*
       *
       * Public logger API - see https://github.com/pimterry/loglevel for details
       *
       */

      self.name = name;

      self.levels = { "TRACE": 0, "DEBUG": 1, "INFO": 2, "WARN": 3,
          "ERROR": 4, "SILENT": 5};

      self.methodFactory = factory || defaultMethodFactory;

      self.getLevel = function () {
          return currentLevel;
      };

      self.setLevel = function (level, persist) {
          if (typeof level === "string" && self.levels[level.toUpperCase()] !== undefined) {
              level = self.levels[level.toUpperCase()];
          }
          if (typeof level === "number" && level >= 0 && level <= self.levels.SILENT) {
              currentLevel = level;
              if (persist !== false) {  // defaults to true
                  persistLevelIfPossible(level);
              }
              replaceLoggingMethods.call(self, level, name);
              if (typeof console === undefinedType && level < self.levels.SILENT) {
                  return "No console available for logging";
              }
          } else {
              throw "log.setLevel() called with invalid level: " + level;
          }
      };

      self.setDefaultLevel = function (level) {
          if (!getPersistedLevel()) {
              self.setLevel(level, false);
          }
      };

      self.enableAll = function(persist) {
          self.setLevel(self.levels.TRACE, persist);
      };

      self.disableAll = function(persist) {
          self.setLevel(self.levels.SILENT, persist);
      };

      // Initialize with the right level
      var initialLevel = getPersistedLevel();
      if (initialLevel == null) {
          initialLevel = defaultLevel == null ? "WARN" : defaultLevel;
      }
      self.setLevel(initialLevel, false);
    }

    /*
     *
     * Top-level API
     *
     */

    var defaultLogger = new Logger();

    var _loggersByName = {};
    defaultLogger.getLogger = function getLogger(name) {
        if ((typeof name !== "symbol" && typeof name !== "string") || name === "") {
          throw new TypeError("You must supply a name when creating a logger.");
        }

        var logger = _loggersByName[name];
        if (!logger) {
          logger = _loggersByName[name] = new Logger(
            name, defaultLogger.getLevel(), defaultLogger.methodFactory);
        }
        return logger;
    };

    // Grab the current global log variable in case of overwrite
    var _log = (typeof window !== undefinedType) ? window.log : undefined;
    defaultLogger.noConflict = function() {
        if (typeof window !== undefinedType &&
               window.log === defaultLogger) {
            window.log = _log;
        }

        return defaultLogger;
    };

    defaultLogger.getLoggers = function getLoggers() {
        return _loggersByName;
    };

    // ES6 default export, for compatibility
    defaultLogger['default'] = defaultLogger;

    return defaultLogger;
}));


/***/ }),

/***/ 829:
/***/ (function(module, exports) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;(function (root, factory) {
    'use strict';
    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js, Rhino, and browsers.

    /* istanbul ignore next */
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory),
		__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
		(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    } else {}
}(this, function () {
    'use strict';
    function _isNumber(n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
    }

    function StackFrame(functionName, args, fileName, lineNumber, columnNumber, source) {
        if (functionName !== undefined) {
            this.setFunctionName(functionName);
        }
        if (args !== undefined) {
            this.setArgs(args);
        }
        if (fileName !== undefined) {
            this.setFileName(fileName);
        }
        if (lineNumber !== undefined) {
            this.setLineNumber(lineNumber);
        }
        if (columnNumber !== undefined) {
            this.setColumnNumber(columnNumber);
        }
        if (source !== undefined) {
            this.setSource(source);
        }
    }

    StackFrame.prototype = {
        getFunctionName: function () {
            return this.functionName;
        },
        setFunctionName: function (v) {
            this.functionName = String(v);
        },

        getArgs: function () {
            return this.args;
        },
        setArgs: function (v) {
            if (Object.prototype.toString.call(v) !== '[object Array]') {
                throw new TypeError('Args must be an Array');
            }
            this.args = v;
        },

        // NOTE: Property name may be misleading as it includes the path,
        // but it somewhat mirrors V8's JavaScriptStackTraceApi
        // https://code.google.com/p/v8/wiki/JavaScriptStackTraceApi and Gecko's
        // http://mxr.mozilla.org/mozilla-central/source/xpcom/base/nsIException.idl#14
        getFileName: function () {
            return this.fileName;
        },
        setFileName: function (v) {
            this.fileName = String(v);
        },

        getLineNumber: function () {
            return this.lineNumber;
        },
        setLineNumber: function (v) {
            if (!_isNumber(v)) {
                throw new TypeError('Line Number must be a Number');
            }
            this.lineNumber = Number(v);
        },

        getColumnNumber: function () {
            return this.columnNumber;
        },
        setColumnNumber: function (v) {
            if (!_isNumber(v)) {
                throw new TypeError('Column Number must be a Number');
            }
            this.columnNumber = Number(v);
        },

        getSource: function () {
            return this.source;
        },
        setSource: function (v) {
            this.source = String(v);
        },

        toString: function() {
            var functionName = this.getFunctionName() || '{anonymous}';
            var args = '(' + (this.getArgs() || []).join(',') + ')';
            var fileName = this.getFileName() ? ('@' + this.getFileName()) : '';
            var lineNumber = _isNumber(this.getLineNumber()) ? (':' + this.getLineNumber()) : '';
            var columnNumber = _isNumber(this.getColumnNumber()) ? (':' + this.getColumnNumber()) : '';
            return functionName + args + fileName + lineNumber + columnNumber;
        }
    };

    return StackFrame;
}));


/***/ }),

/***/ 962:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(379);
/* harmony import */ var _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _node_modules_css_loader_dist_cjs_js_style_css__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(402);

            

var options = {};

options.insert = "head";
options.singleton = false;

var update = _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0___default()(_node_modules_css_loader_dist_cjs_js_style_css__WEBPACK_IMPORTED_MODULE_1__/* .default */ .Z, options);



/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (_node_modules_css_loader_dist_cjs_js_style_css__WEBPACK_IMPORTED_MODULE_1__/* .default.locals */ .Z.locals || {});

/***/ }),

/***/ 379:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var isOldIE = function isOldIE() {
  var memo;
  return function memorize() {
    if (typeof memo === 'undefined') {
      // Test for IE <= 9 as proposed by Browserhacks
      // @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
      // Tests for existence of standard globals is to allow style-loader
      // to operate correctly into non-standard environments
      // @see https://github.com/webpack-contrib/style-loader/issues/177
      memo = Boolean(window && document && document.all && !window.atob);
    }

    return memo;
  };
}();

var getTarget = function getTarget() {
  var memo = {};
  return function memorize(target) {
    if (typeof memo[target] === 'undefined') {
      var styleTarget = document.querySelector(target); // Special case to return head of iframe instead of iframe itself

      if (window.HTMLIFrameElement && styleTarget instanceof window.HTMLIFrameElement) {
        try {
          // This will throw an exception if access to iframe is blocked
          // due to cross-origin restrictions
          styleTarget = styleTarget.contentDocument.head;
        } catch (e) {
          // istanbul ignore next
          styleTarget = null;
        }
      }

      memo[target] = styleTarget;
    }

    return memo[target];
  };
}();

var stylesInDom = [];

function getIndexByIdentifier(identifier) {
  var result = -1;

  for (var i = 0; i < stylesInDom.length; i++) {
    if (stylesInDom[i].identifier === identifier) {
      result = i;
      break;
    }
  }

  return result;
}

function modulesToDom(list, options) {
  var idCountMap = {};
  var identifiers = [];

  for (var i = 0; i < list.length; i++) {
    var item = list[i];
    var id = options.base ? item[0] + options.base : item[0];
    var count = idCountMap[id] || 0;
    var identifier = "".concat(id, " ").concat(count);
    idCountMap[id] = count + 1;
    var index = getIndexByIdentifier(identifier);
    var obj = {
      css: item[1],
      media: item[2],
      sourceMap: item[3]
    };

    if (index !== -1) {
      stylesInDom[index].references++;
      stylesInDom[index].updater(obj);
    } else {
      stylesInDom.push({
        identifier: identifier,
        updater: addStyle(obj, options),
        references: 1
      });
    }

    identifiers.push(identifier);
  }

  return identifiers;
}

function insertStyleElement(options) {
  var style = document.createElement('style');
  var attributes = options.attributes || {};

  if (typeof attributes.nonce === 'undefined') {
    var nonce =  true ? __webpack_require__.nc : 0;

    if (nonce) {
      attributes.nonce = nonce;
    }
  }

  Object.keys(attributes).forEach(function (key) {
    style.setAttribute(key, attributes[key]);
  });

  if (typeof options.insert === 'function') {
    options.insert(style);
  } else {
    var target = getTarget(options.insert || 'head');

    if (!target) {
      throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");
    }

    target.appendChild(style);
  }

  return style;
}

function removeStyleElement(style) {
  // istanbul ignore if
  if (style.parentNode === null) {
    return false;
  }

  style.parentNode.removeChild(style);
}
/* istanbul ignore next  */


var replaceText = function replaceText() {
  var textStore = [];
  return function replace(index, replacement) {
    textStore[index] = replacement;
    return textStore.filter(Boolean).join('\n');
  };
}();

function applyToSingletonTag(style, index, remove, obj) {
  var css = remove ? '' : obj.media ? "@media ".concat(obj.media, " {").concat(obj.css, "}") : obj.css; // For old IE

  /* istanbul ignore if  */

  if (style.styleSheet) {
    style.styleSheet.cssText = replaceText(index, css);
  } else {
    var cssNode = document.createTextNode(css);
    var childNodes = style.childNodes;

    if (childNodes[index]) {
      style.removeChild(childNodes[index]);
    }

    if (childNodes.length) {
      style.insertBefore(cssNode, childNodes[index]);
    } else {
      style.appendChild(cssNode);
    }
  }
}

function applyToTag(style, options, obj) {
  var css = obj.css;
  var media = obj.media;
  var sourceMap = obj.sourceMap;

  if (media) {
    style.setAttribute('media', media);
  } else {
    style.removeAttribute('media');
  }

  if (sourceMap && typeof btoa !== 'undefined') {
    css += "\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))), " */");
  } // For old IE

  /* istanbul ignore if  */


  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    while (style.firstChild) {
      style.removeChild(style.firstChild);
    }

    style.appendChild(document.createTextNode(css));
  }
}

var singleton = null;
var singletonCounter = 0;

function addStyle(obj, options) {
  var style;
  var update;
  var remove;

  if (options.singleton) {
    var styleIndex = singletonCounter++;
    style = singleton || (singleton = insertStyleElement(options));
    update = applyToSingletonTag.bind(null, style, styleIndex, false);
    remove = applyToSingletonTag.bind(null, style, styleIndex, true);
  } else {
    style = insertStyleElement(options);
    update = applyToTag.bind(null, style, options);

    remove = function remove() {
      removeStyleElement(style);
    };
  }

  update(obj);
  return function updateStyle(newObj) {
    if (newObj) {
      if (newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap) {
        return;
      }

      update(obj = newObj);
    } else {
      remove();
    }
  };
}

module.exports = function (list, options) {
  options = options || {}; // Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
  // tags it will allow on a page

  if (!options.singleton && typeof options.singleton !== 'boolean') {
    options.singleton = isOldIE();
  }

  list = list || [];
  var lastIdentifiers = modulesToDom(list, options);
  return function update(newList) {
    newList = newList || [];

    if (Object.prototype.toString.call(newList) !== '[object Array]') {
      return;
    }

    for (var i = 0; i < lastIdentifiers.length; i++) {
      var identifier = lastIdentifiers[i];
      var index = getIndexByIdentifier(identifier);
      stylesInDom[index].references--;
    }

    var newLastIdentifiers = modulesToDom(newList, options);

    for (var _i = 0; _i < lastIdentifiers.length; _i++) {
      var _identifier = lastIdentifiers[_i];

      var _index = getIndexByIdentifier(_identifier);

      if (stylesInDom[_index].references === 0) {
        stylesInDom[_index].updater();

        stylesInDom.splice(_index, 1);
      }
    }

    lastIdentifiers = newLastIdentifiers;
  };
};

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			loaded: false,
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/node module decorator */
/******/ 	(() => {
/******/ 		__webpack_require__.nmd = (module) => {
/******/ 			module.paths = [];
/******/ 			if (!module.children) module.children = [];
/******/ 			return module;
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";

;// CONCATENATED MODULE: ./src/lib/api.js
/* eslint-disable no-undef */



function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

var Api = /*#__PURE__*/function () {
  function Api() {
    _classCallCheck(this, Api);
  }
  _createClass(Api, [{
    key: "getLandingPage",
    value:
    /**
     * Retrieve the campaign information
     */
    function getLandingPage(landingPageId) {
      return new Promise(function (resolve, reject) {
        var url = [Api.apiUrl, 'landingPages', landingPageId, 'info'].join('/');
        Util.logDebug('getLandingPage: request url:', url);
        window.fetch(url, Api.fetchOptions).then(Api.checkStatus).then(Api.parseJSON).then(function (res) {
          if (res.programId) {
            window.apm.addLabels({
              programId: res.programId
            });
          }
          Util.logDebug('getLandingPage: res:', res);
          resolve(res);
        })["catch"](function (err) {
          Util.logError('getLandingPage: fail:', err);
          reject(err);
        });
      });
    }

    /**
     * Retrieve information about the prospect
     */
  }, {
    key: "getProspectByWebToken",
    value: function getProspectByWebToken(webToken) {
      var modelName = 'People';
      if (cjs.config.page && cjs.config.page === 'update-recurly-account') {
        modelName = 'RecurlyAccounts';
      }
      var url = "".concat(Api.apiUrl, "/").concat(modelName, "/findByWebToken?token=").concat(encodeURIComponent(webToken));
      Util.logDebug('getProspectByWebToken: request url:', url);
      return window.fetch(url, Api.fetchOptions).then(Api.checkStatus).then(Api.parseJSON).then(function (res) {
        Util.logDebug('getProspectByWebToken: res:', res);
        if (res.id) {
          window.apm.setUserContext({
            id: res.id
          });
        }
        if (typeof res.error !== 'undefined') {
          Util.logError('getProspectByWebToken error:', res.error);
          return Promise.reject(res.error);
        }
        cjs.person = res;
        return res;
      })["catch"](function (err) {
        Util.logError('getProspectByWebToken: fail:', err);
        return Promise.reject(err);
      });
    }

    /**
     * Retrieve person information using checksum
     */
  }, {
    key: "getPersonByChecksum",
    value: function getPersonByChecksum(checksum, params) {
      var filter = '';
      if (params.eid) {
        filter = JSON.stringify({
          include: {
            relation: 'events',
            scope: {
              where: {
                id: params.eid
              }
            }
          }
        });
      }
      var modelName = 'People';
      if (cjs.config.page && cjs.config.page === 'update-recurly-account') {
        modelName = 'RecurlyAccounts';
      }
      var url = "".concat(Api.apiUrl, "/").concat(modelName, "/findByChecksum?checksum=").concat(encodeURIComponent(checksum), "&filter=").concat(encodeURIComponent(filter));
      Util.logDebug('getPersonByChecksum: request url:', url);
      return window.fetch(url, Api.fetchOptions).then(Api.checkStatus).then(Api.parseJSON).then(function (res) {
        Util.logDebug('getPersonByChecksum: res:', res);
        if (typeof res.error !== 'undefined') {
          Util.logError('getPersonByChecksum error:', res.error);
          return Promise.reject(res.error);
        }
        cjs.person = res;
        return res;
      })["catch"](function (err) {
        Util.logError('getPersonByChecksum: fail:', err);
        return Promise.reject(err);
      });
    }

    /**
     * Retrieve information about the product
     */
  }, {
    key: "getProductBySKU",
    value: function getProductBySKU(productSKU) {
      return new Promise(function (resolve, reject) {
        var urlParams = '/products/findOne';
        urlParams = "".concat(urlParams, "?filter[where][programId]=").concat(cjs.landingPage.programId);
        urlParams = "".concat(urlParams, "&filter[where][sku]=").concat(productSKU);
        var url = Api.apiUrl + urlParams;
        Util.logDebug('getProductBySKU: request url:', url);
        window.fetch(url, Api.fetchOptions).then(Api.checkStatus).then(Api.parseJSON).then(function (res) {
          Util.logDebug('getProductBySKU: res:', res);
          cjs.product = res;
          resolve(res);
        })["catch"](function (err) {
          Util.logError('getProductBySKU: fail:', err);
          Util.logDebug(err);
          reject(err);
        });
      });
    }

    /**
     * Add a prospect
     */
  }, {
    key: "addProspect",
    value: function addProspect(data) {
      return new Promise(function (resolve, reject) {
        var payload = {
          method: 'post',
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        };
        window.fetch("".concat(Api.landingPageUrl, "/addProspect"), payload).then(Api.checkStatus).then(function (response) {
          response.json().then(function (content) {
            if (typeof content.error !== 'undefined' && content.error.code !== 'ALREADY_ACTIVE') {
              Util.logDebug('Api.addProspect content.error:', content.error);
              reject(content.error);
            } else if (typeof content.error !== 'undefined' && content.error.code === 'ALREADY_ACTIVE') {
              Util.logDebug('Api.addProspect PersonActiveError:', content.error);
              reject(content.error);
            } else if (typeof response.statusText !== 'undefined' && response.statusText === 'Conflict') {
              Util.logDebug('Api.addProspect Conflict:', response.statusText);
              reject(response.statusText);
            } else {
              Util.logDebug('Api.addProspect res:', content);
              resolve({
                webToken: response.headers.get('X-Person-Token'),
                prospect: content
              });
            }
          });
        })["catch"](function (err) {
          Util.logDebug("Api.addProspect err: ".concat(err.message), err);
          reject(err);
        });
      });
    }

    /**
     * Add a member
     */
  }, {
    key: "addMember",
    value: function addMember(data) {
      return new Promise(function (resolve, reject) {
        var payload = {
          method: 'post',
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        };
        window.fetch("".concat(Api.landingPageUrl, "/addMember"), payload).then(Api.checkStatus).then(function (response) {
          response.json().then(function (content) {
            if (typeof content.error !== 'undefined') {
              Util.logDebug('Api.addMember res.error:', content.error);
              return reject(content.error);
            }
            Util.logDebug('Api.addMember res:', content);
            return resolve({
              webToken: response.headers.get('X-Person-Token'),
              member: content
            });
          });
        })["catch"](function (err) {
          Util.logDebug("Api.addMember err: ".concat(err.message), err);
          reject(err);
        });
      });
    }

    /**
     * Update a member
     */
  }, {
    key: "updateMember",
    value: function updateMember(data) {
      return new Promise(function (resolve, reject) {
        var payload = {
          method: 'post',
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        };
        window.fetch("".concat(Api.landingPageUrl, "/updateMember"), payload).then(Api.checkStatus).then(function (response) {
          response.json().then(function (content) {
            if (typeof content.error !== 'undefined') {
              Util.logDebug('Api.updateMember res.error:', content.error);
              return reject(content.error);
            }
            Util.logDebug('Api.updateMember res:', content);
            return resolve({
              webToken: response.headers.get('X-Person-Token'),
              member: content
            });
          });
        })["catch"](function (err) {
          Util.logDebug("Api.updateMember err: ".concat(err.message), err);
          reject(err);
        });
      });
    }

    /**
     * Gift Purchase
     */
  }, {
    key: "giftPurchase",
    value: function giftPurchase(data) {
      return new Promise(function (resolve, reject) {
        var payload = {
          method: 'post',
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        };
        window.fetch("".concat(Api.landingPageUrl, "/gift/purchase"), payload).then(Api.checkStatus).then(function (response) {
          response.json().then(function (content) {
            if (typeof content.error !== 'undefined') {
              Util.logDebug('Api.giftPurchase. res.error:', content.error);
              return reject(content.error);
            }
            Util.logDebug('Api.giftPurchase. res:', content);
            return resolve({
              webToken: response.headers.get('X-Person-Token'),
              member: content
            });
          });
        })["catch"](function (err) {
          Util.logDebug("Api.giftPurchase. err: ".concat(err.message), err);
          reject(err);
        });
      });
    }

    /**
     * Gift Redeem
     */
  }, {
    key: "giftRedeem",
    value: function giftRedeem(data) {
      return new Promise(function (resolve, reject) {
        var payload = {
          method: 'post',
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        };
        window.fetch("".concat(Api.landingPageUrl, "/gift/redeem"), payload).then(Api.checkStatus).then(function (response) {
          response.json().then(function (content) {
            if (typeof content.error !== 'undefined') {
              Util.logDebug('Api.giftRedeem. res.error:', content.error);
              return reject(content.error);
            }
            Util.logDebug('Api.giftRedeem. res:', content);
            return resolve({
              webToken: response.headers.get('X-Person-Token'),
              member: content
            });
          });
        })["catch"](function (err) {
          Util.logDebug("Api.giftRedeem. err: ".concat(err.message), err);
          reject(err);
        });
      });
    }

    /**
     * Update request
     */
  }, {
    key: "updateRequest",
    value: function updateRequest(data) {
      return new Promise(function (resolve, reject) {
        var payload = {
          method: 'post',
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        };
        window.fetch("".concat(Api.landingPageUrl, "/updateRequest"), payload).then(Api.checkStatus).then(function (response) {
          response.json().then(function (content) {
            if (typeof content.error !== 'undefined') {
              Util.logDebug('Api.updateRequest res.error:', content.error);
              return reject(content.error);
            }
            Util.logDebug('Api.updateRequest res:', content);
            return resolve();
          });
        })["catch"](function (err) {
          Util.logDebug("Api.updateRequest err: ".concat(err.message), err);
          reject(err);
        });
      });
    }

    /**
     * Update recurly account request
     */
  }, {
    key: "addRecurlyAccount",
    value: function addRecurlyAccount(data) {
      return new Promise(function (resolve, reject) {
        var payload = {
          method: 'post',
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        };
        window.fetch("".concat(Api.landingPageUrl, "/addRecurlyAccount"), payload).then(Api.checkStatus).then(function (response) {
          response.json().then(function (content) {
            if (typeof content.error !== 'undefined') {
              Util.logDebug('Api.addRecurlyAccount res.error:', content.error);
              return reject(content.error);
            }
            Util.logDebug('Api.addRecurlyAccount res:', content);
            return resolve();
          });
        })["catch"](function (err) {
          Util.logDebug("Api.addRecurlyAccount err: ".concat(err.message), err);
          reject(err);
        });
      });
    }

    /**
     * Update recurly account
     */
  }, {
    key: "updateRecurlyAccount",
    value: function updateRecurlyAccount(data) {
      return new Promise(function (resolve, reject) {
        var payload = {
          method: 'post',
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        };
        window.fetch("".concat(Api.landingPageUrl, "/updateRecurlyAccount"), payload).then(Api.checkStatus).then(function (response) {
          response.json().then(function (content) {
            if (typeof content.error !== 'undefined') {
              Util.logDebug('Api.updateRecurlyAccount res.error:', content.error);
              return reject(content.error);
            }
            Util.logDebug('Api.updateRecurlyAccount res:', content);
            return resolve();
          });
        })["catch"](function (err) {
          Util.logDebug("Api.updateRecurlyAccount err: ".concat(err.message), err);
          reject(err);
        });
      });
    }
  }], [{
    key: "fetchOptions",
    get: function get() {
      return {
        mode: 'cors'
      };
    }
  }, {
    key: "apiUrl",
    get: function get() {
      return cjs.config.apiUrl;
    }
  }, {
    key: "landingPageId",
    get: function get() {
      return cjs.config.landingPageId;
    }
  }, {
    key: "landingPageUrl",
    get: function get() {
      return "".concat(Api.apiUrl, "/landingPages/").concat(Api.landingPageId);
    }

    /**
     * Check the status of the response
     */
  }, {
    key: "checkStatus",
    value: function checkStatus(response) {
      if (response.statusCode >= 500) {
        var err = new Error(response.statusText);
        err.response = response;
        throw err;
      }
      return response;
    }

    /**
     * Return the json version of the response
     */
  }, {
    key: "parseJSON",
    value: function parseJSON(response) {
      return response.json();
    }
  }]);
  return Api;
}();
var api = new Api();

// EXTERNAL MODULE: ./node_modules/lodash/lodash.js
var lodash = __webpack_require__(486);
var lodash_default = /*#__PURE__*/__webpack_require__.n(lodash);
;// CONCATENATED MODULE: ./src/pages/add-recurly-account.js
/* eslint-disable no-undef */



function add_recurly_account_typeof(obj) { "@babel/helpers - typeof"; return add_recurly_account_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, add_recurly_account_typeof(obj); }
function add_recurly_account_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function add_recurly_account_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, add_recurly_account_toPropertyKey(descriptor.key), descriptor); } }
function add_recurly_account_createClass(Constructor, protoProps, staticProps) { if (protoProps) add_recurly_account_defineProperties(Constructor.prototype, protoProps); if (staticProps) add_recurly_account_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function add_recurly_account_toPropertyKey(arg) { var key = add_recurly_account_toPrimitive(arg, "string"); return add_recurly_account_typeof(key) === "symbol" ? key : String(key); }
function add_recurly_account_toPrimitive(input, hint) { if (add_recurly_account_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (add_recurly_account_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


var AddRecurlyAccountPage = /*#__PURE__*/function () {
  function AddRecurlyAccountPage() {
    add_recurly_account_classCallCheck(this, AddRecurlyAccountPage);
  }
  add_recurly_account_createClass(AddRecurlyAccountPage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      Util.startLoading();
      return Util.processPageRequest('add-recurly-account', 'addRecurlyAccount').then(function () {
        return Util.logDebug('add-recurly-account.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("add-recurly-account.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the One Step page
     */
  }, {
    key: "init",
    value: function init() {
      Dom.initializeOneStepPage();
    }
  }]);
  return AddRecurlyAccountPage;
}();
var addRecurlyAccountPage = new AddRecurlyAccountPage();

;// CONCATENATED MODULE: ./src/lib/trusted-form.js


function trusted_form_typeof(obj) { "@babel/helpers - typeof"; return trusted_form_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, trusted_form_typeof(obj); }
function trusted_form_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function trusted_form_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, trusted_form_toPropertyKey(descriptor.key), descriptor); } }
function trusted_form_createClass(Constructor, protoProps, staticProps) { if (protoProps) trusted_form_defineProperties(Constructor.prototype, protoProps); if (staticProps) trusted_form_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function trusted_form_toPropertyKey(arg) { var key = trusted_form_toPrimitive(arg, "string"); return trusted_form_typeof(key) === "symbol" ? key : String(key); }
function trusted_form_toPrimitive(input, hint) { if (trusted_form_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (trusted_form_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

var TrustedForm = /*#__PURE__*/function () {
  function TrustedForm() {
    trusted_form_classCallCheck(this, TrustedForm);
  }
  trusted_form_createClass(TrustedForm, [{
    key: "run",
    value:
    /**
     * Add the TrustedForm code to the page
     */
    function run(member) {
      return new Promise(function (resolve) {
        Util.logDebug('Running TrustedFrom code');

        // Set the value of the checkbox in the DOM to true of a person subscribed
        if (member.options.zinioSubscription === true) {
          $('#zinio').attr('checked', true);
        }
        var field = 'xxTrustedFormCertUrl';
        var provideReferrer = false;
        var tf = document.createElement('script');
        tf.type = 'text/javascript';
        tf.async = true;
        tf.src = 'http' + (
        // eslint-disable-line prefer-template
        document.location.protocol === 'https:' ? 's' : '') + '://api.trustedform.com/trustedform.js?provide_referrer=' + escape(provideReferrer) + '&field=' + escape(field) + '&l=' + new Date().getTime() + Math.random();
        var s = document.getElementsByTagName('script')[0];
        s.parentNode.insertBefore(tf, s);

        // Listen on the global callback to send the data
        window.trustedFormCertUrlCallback = function (certificateUrl) {
          Util.startLoading();
          Util.logDebug("TrustedForm.run(): global callback triggered: ".concat(certificateUrl));
          resolve(certificateUrl);
        };
      });
    }
  }]);
  return TrustedForm;
}();
var trustedForm = new TrustedForm();

;// CONCATENATED MODULE: ./src/lib/validate.js
function validate_typeof(obj) { "@babel/helpers - typeof"; return validate_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, validate_typeof(obj); }
function validate_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function validate_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, validate_toPropertyKey(descriptor.key), descriptor); } }
function validate_createClass(Constructor, protoProps, staticProps) { if (protoProps) validate_defineProperties(Constructor.prototype, protoProps); if (staticProps) validate_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function validate_toPropertyKey(arg) { var key = validate_toPrimitive(arg, "string"); return validate_typeof(key) === "symbol" ? key : String(key); }
function validate_toPrimitive(input, hint) { if (validate_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (validate_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable no-undef, max-len */


var Validate = /*#__PURE__*/function () {
  function Validate() {
    validate_classCallCheck(this, Validate);
  }
  validate_createClass(Validate, [{
    key: "runValidation",
    value: function runValidation(data) {
      return new Promise(function (resolve, reject) {
        var constraints = Validate.getValidationContstraints(data);
        window.validate.async(data, constraints, {
          fullMessages: false
        }).then(resolve, function (errors) {
          return reject({
            validationErrors: errors
          });
        });
      });
    }

    /**
     * Get validation constraints based on fields
     * @returns {Object}
     */
  }], [{
    key: "getPersonConstraints",
    value: function getPersonConstraints() {
      return {
        'person.firstName': {
          presence: {
            message: 'First Name is required'
          },
          length: {
            minimum: 2,
            message: 'First Name appears to be incomplete - at least two characters are required'
          }
        },
        'person.lastName': {
          presence: {
            message: 'Last Name is required'
          },
          length: {
            minimum: 2,
            message: 'Last Name appears to be incomplete - at least two characters are required'
          }
        },
        'person.email': {
          presence: {
            message: 'Email Address is required'
          },
          email: {
            message: 'Email Address appears to be incorrectly formatted'
          }
        },
        'person.emailVerify': {
          presence: {
            message: 'Email Address must be validated (entered twice)'
          },
          equality: {
            attribute: 'person.email',
            message: 'Email Address must be validated (entered twice).'
          }
        },
        'person.street': {
          presence: {
            message: 'Mailing Address is required'
          }
        },
        'person.city': {
          presence: {
            message: 'City is required'
          }
        },
        'person.state': {
          presence: {
            message: 'State/Province is required'
          }
        },
        'person.zip': {
          validateZip: 'person.country'
        },
        'person.country': {
          presence: {
            message: 'Country is required'
          }
        },
        'person.streetBilling': {
          presence: {
            message: 'Billing Mailing Address is required'
          }
        },
        'person.cityBilling': {
          presence: {
            message: 'Billing City is required'
          }
        },
        'person.stateBilling': {
          presence: {
            message: 'Billing State/Province is required'
          }
        },
        'person.zipBilling': {
          validateZip: 'person.countryBilling'
        },
        'person.countryBilling': {
          presence: {
            message: 'Billing Country is required'
          }
        },
        'person.streetShipping': {
          presence: {
            message: 'Shipping Mailing Address is required'
          }
        },
        'person.cityShipping': {
          presence: {
            message: 'Shipping City is required'
          }
        },
        'person.stateShipping': {
          presence: {
            message: 'Shipping State/Province is required'
          }
        },
        'person.zipShipping': {
          validateZip: 'person.countryShipping'
        },
        'person.countryShipping': {
          presence: {
            message: 'Shipping Country is required'
          }
        }
      };
    }
  }, {
    key: "getOptionsConstraints",
    value: function getOptionsConstraints() {
      return {
        'options.giftCode': {
          presence: {
            message: "Don't forget to enter the gift code to redeem offer!"
          }
        },
        'options.productSKU': {
          presence: {
            message: "Don't forget to choose a product!"
          }
        },
        'options.recurlySubscription': {
          presence: {
            message: "Don't forget to choose your Subscription!"
          }
        },
        'options.landingPageId': {
          presence: {
            message: 'Please make your plan selection.'
          }
        },
        'options.password': {
          presence: {
            message: "Don't forget to enter the password to access your account!"
          },
          format: {
            pattern: lodash_default().get(cjs.fields, 'password[0].dataset.pattern', '.*'),
            flags: 'i',
            message: lodash_default().get(cjs.fields, 'password[0].dataset.message', "Don't forget to enter the password to access your account")
          }
        },
        'options.confirmPassword': {
          presence: {
            message: 'Please re-enter the password to access your account!'
          },
          equality: {
            attribute: 'options.password',
            message: 'Password and confirm password do not match.'
          }
        }
      };
    }
  }, {
    key: "getCardConstraints",
    value: function getCardConstraints() {
      return {
        'billingOptions.ccFirstSix': {
          presence: {
            message: 'Credit Card number is required'
          },
          length: {
            minimum: 6,
            maximum: 6,
            message: 'Number is not a valid credit card number'
          }
        },
        'billingOptions.ccYear': {
          presence: {
            message: 'Expiration Date (year) is required'
          },
          length: {
            minimum: 2,
            maximum: 4,
            message: 'Expiration Date (year) appears to be incorrectly formatted (must be between 2 and 4 digits)'
          }
        },
        'billingOptions.ccMonth': {
          presence: {
            message: 'Expiration Date (month) is required'
          },
          length: {
            minimum: 2,
            maximum: 2,
            message: 'Expiration Date (month) appears to be incorrectly formatted (must 2 digits)'
          }
        }
      };
    }
  }, {
    key: "getValidationContstraints",
    value: function getValidationContstraints(data) {
      var constraints = {};

      // Get all the fields on page
      var supportedFields = Util.getFields();
      var personConstraints = Validate.getPersonConstraints();
      var optionsConstraints = Validate.getOptionsConstraints();
      Object.keys(data).forEach(function (key) {
        if (supportedFields[key] || key === 'billingOptions') {
          switch (key) {
            case 'person':
              // Only add the constraint for existing fields on page
              Object.keys(supportedFields[key]).forEach(function (field) {
                if (typeof cjs.fields[field] !== 'undefined' && personConstraints["person.".concat(field)] && typeof data.person[field] !== 'undefined') {
                  constraints["person.".concat(field)] = personConstraints["person.".concat(field)];
                }
              });
              break;
            case 'billingOptions':
              if (typeof data.billingOptions.ccFirstSix !== 'undefined' || typeof data.billingOptions.ccYear !== 'undefined' || typeof data.billingOptions.ccMonth !== 'undefined') {
                lodash_default().merge(constraints, Validate.getCardConstraints());
              }
              break;
            case 'options':
              // Only add the constraint for existing fields on page
              Object.keys(supportedFields[key]).forEach(function (field) {
                if (typeof cjs.fields[field] !== 'undefined' && optionsConstraints["options.".concat(field)] && typeof data.options[field] !== 'undefined') {
                  constraints["options.".concat(field)] = optionsConstraints["options.".concat(field)];
                }
              });
              break;
            default:
              break;
          }
        }
      });

      // Check for the preferences fields and add to the fields area
      if (cjs.config && cjs.config.preferences) {
        Object.keys(cjs.config.preferences).forEach(function (fieldRef) {
          var fieldlabel = cjs.config.preferences[fieldRef].label;
          if (cjs.config.preferences[fieldRef] && data.person && typeof data.person.preferences[fieldRef] !== 'undefined') {
            constraints["person.preferences.".concat(fieldRef)] = {};
            if (cjs.config.preferences[fieldRef].required) {
              constraints["person.preferences.".concat(fieldRef)].presence = {
                message: "".concat(fieldlabel, " is required")
              };
            }
          }
        });
      }
      var stateFields = {
        state: 'country',
        stateBilling: 'countryBilling',
        stateShipping: 'countryShipping'
      };
      Object.keys(stateFields).forEach(function (key) {
        if (typeof cjs.fields.phone !== 'undefined' && typeof cjs.fields[key] !== 'undefined' && !(data.person["".concat(stateFields[key])] == 'US' || data.person["".concat(stateFields[key])] == 'CA')) {
          constraints['person.phone'] = {
            presence: {
              message: 'Phone is required'
            }
          };
        }
      });
      return constraints;
    }
  }]);
  return Validate;
}();
var validate = new Validate();

;// CONCATENATED MODULE: ./src/pages/checkout.js
/* eslint-disable */



function checkout_typeof(obj) { "@babel/helpers - typeof"; return checkout_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, checkout_typeof(obj); }
function _defineProperty(obj, key, value) { key = checkout_toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function checkout_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function checkout_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, checkout_toPropertyKey(descriptor.key), descriptor); } }
function checkout_createClass(Constructor, protoProps, staticProps) { if (protoProps) checkout_defineProperties(Constructor.prototype, protoProps); if (staticProps) checkout_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function checkout_toPropertyKey(arg) { var key = checkout_toPrimitive(arg, "string"); return checkout_typeof(key) === "symbol" ? key : String(key); }
function checkout_toPrimitive(input, hint) { if (checkout_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (checkout_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }





var CheckoutPage = /*#__PURE__*/function () {
  function CheckoutPage() {
    checkout_classCallCheck(this, CheckoutPage);
  }
  checkout_createClass(CheckoutPage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      var submithandler = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'creditcard';
      var externalToken = arguments.length > 1 ? arguments[1] : undefined;
      Util.startLoading();
      return this.process(submithandler, externalToken).then(function () {
        return Util.logDebug('checkout.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("checkout.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the CheckoutPage
     * @returns {Promise}
     */
  }, {
    key: "init",
    value: function init() {
      return new Promise(function (resolve, reject) {
        api.getProspectByWebToken(Dom.getUrlParam('personWebToken')).then(function () {
          if (!cjs.landingPage.workflow.zinioSubscription) {
            delete cjs.fields.zinio;
          }
          if (cjs.landingPage.workflow.selectFulfillment) {
            return api.getProductBySKU(Dom.getUrlParam('productSKU'));
          }
          return null;
        }).then(function () {
          if (typeof cjs.person === 'undefined') {
            return Promise.reject(new Error("CJS.Person is undefined! Webtoken: ".concat(Dom.getUrlParam('personWebToken'))));
          }
          return null;
        }).then(function () {
          window.recurly.configure(cjs.landingPage.recurlyPublicKey);
          Dom.fillPlaceholders();
          Dom.referenceFields();
          Dom.setCountryListeners();
          // Populate Currency field
          Dom.populateCurrencySelect(cjs.fields.currency);
          if (typeof cjs.fields.ccMonth !== 'undefined') {
            Dom.addCcMonths(cjs.fields.ccMonth);
          }
          if (typeof cjs.fields.ccYear !== 'undefined') {
            Dom.addCcYears(cjs.fields.ccYear);
          }
          if (cjs.product) {
            Dom.addProductImage(cjs.product, '#product-image');
          }
          // Check if plan selection exists and accordingly set the landingPageId
          if (typeof cjs.fields.landingPageId !== 'undefined') {
            // Add listener to the radio option of plan
            Dom.setLandinPageEventListener(cjs.fields.landingPageId);
          }

          // Setup tax info and listeners
          Dom.setTaxInfoAndAddressListener();
        }).then(function () {
          return resolve();
        })["catch"](function (err) {
          Util.logDebug("checkout.init: error: ".concat(err.message), err);
          reject(err);
        });
      });
    }

    /**
     * Process the CheckoutPage
     */
  }, {
    key: "process",
    value: function process(submithandler) {
      var externalToken = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return new Promise(function (resolve, reject) {
        // First we disable the inputs
        Util.disableInputs();
        var password;
        var confirmPassword = null;
        var productSKU = cjs.product ? cjs.product.sku : null;
        var currency = Dom.getUrlParam('currency');
        if (!currency || currency == null) {
          currency = 'USD';
        }
        if (typeof cjs.fields.productSKU !== 'undefined') {
          // Get the product info
          productSKU = Dom.getElementValue(cjs.fields.productSKU);
        }
        if (typeof cjs.fields.password !== 'undefined') {
          // Get the password
          password = Dom.getElementValue(cjs.fields.password);
        }
        if (typeof cjs.fields.confirmPassword !== 'undefined') {
          // Get the password
          confirmPassword = Dom.getElementValue(cjs.fields.confirmPassword);
        }
        if (typeof cjs.fields.currency !== 'undefined') {
          // Get the product info
          currency = Dom.getElementValue(cjs.fields.currency);
        }

        // prepare the member data for validation payload
        var personData = _.merge(cjs.person, Dom.getMemberDetails(cjs.fields));

        // Format Person Info
        personData = Util.formatPersonAddress(personData);

        // Create a new person
        var member = {
          person: personData,
          options: {
            productSKU: productSKU,
            currency: currency,
            password: password,
            confirmPassword: confirmPassword,
            trustedFormCertUrl: null,
            zinioSubscription: cjs.fields.zinio ? cjs.fields.zinio.is(':checked') : null,
            addressFieldVisibility: Dom.addressFieldVisibility()
          },
          billingOptions: {},
          context: Util.getContext()
        };

        // If skipMemberCheck config is true, lets pass it in data options
        if (_.get(cjs, 'config.skipMemberCheck', null)) {
          member.options.skipMemberCheck = true;
        }
        var card = Dom.getMemberCard(cjs.fields);

        // Create the recurly requestToken
        var requestToken = {
          first_name: _.get(member, 'person.firstName', null),
          last_name: _.get(member, 'person.lastName', null),
          address1: _.get(member, 'person.street', null),
          city: _.get(member, 'person.city', null),
          state: _.get(member, 'person.state', null),
          postal_code: _.get(member, 'person.zip', null),
          country: _.get(member, 'person.country', null),
          currency: currency
        };

        // Do cc validation only if the current billingInfo is not valid
        // and there is any cc data to validate
        if (submithandler == 'creditcard') {
          member.billingOptions = {
            ccType: _.get(card, 'type', null),
            ccYear: _.get(card, 'year', null),
            ccMonth: _.get(card, 'month', null),
            ccFirstSix: _.get(card, 'firstSix', null),
            ccLastFour: _.get(card, 'lastFour', null),
            billingToken: null
          };

          // Create the recurly requestToken
          requestToken = {
            number: _.get(card, 'number', null),
            month: _.get(card, 'month', null),
            year: _.get(card, 'year', null),
            first_name: _.get(member, 'person.firstName', null),
            last_name: _.get(member, 'person.lastName', null),
            address1: _.get(member, 'person.street', null),
            city: _.get(member, 'person.city', null),
            state: _.get(member, 'person.state', null),
            postal_code: _.get(member, 'person.zip', null),
            country: _.get(member, 'person.country', null),
            currency: currency
          };
        }
        validate.runValidation(member).then(function () {
          if (typeof cjs.landingPage.integrations.leadconduit !== 'undefined' && cjs.landingPage.integrations.leadconduit === true) {
            return trustedForm.run(member).then(function (trustedFormCertUrl) {
              return member.options.trustedFormCertUrl = trustedFormCertUrl;
            });
          }
          Util.logDebug('checkout.process: Skipping TrustedForm code: LeadConduit integration disabled');
          return null;
        }).then(function () {
          Util.startLoading();
          if (externalToken) {
            return {
              id: externalToken
            };
          }
          return Dom.getRecurlyToken(requestToken, submithandler);
        }).then(function (token) {
          if (token) {
            member.billingOptions.billingToken = token.id;
            member.billingOptions.billingMethod = submithandler;
          }
          return api.addMember(member);
        }).then(function (res) {
          if (res.member && res.member.membership && res.member.membership.id) {
            localStorage.setItem('fullcube.membership.id', res.member.membership.id);
            localStorage.setItem('fullcube.membership.personId', res.member.membership.personId);
          }
          Util.logDebug('checkout.process: success:', res);
          Util.stopLoading();
          Dom.clearInputFields();
          Dom.navigateTo("".concat(cjs.config.nextPage, "?personWebToken=").concat(res.webToken));
          resolve(res);
        })["catch"](function (err) {
          var contactSupportMessage = Util.prepareSupportMessage();
          Util.stopLoading();
          if (typeof err.validationErrors !== 'undefined') {
            Util.logDebug("checkout.process: validationErrors not undefined: ".concat(err.message), err);
            var errorMsg = '<b>Sorry, there was a problem with the information:</b>';
            errorMsg += Util.parseValidationErrors(err.validationErrors);
            Util.showError(errorMsg);
            resolve();
          } else if (err.code === 'validation') {
            Util.logDebug("checkout.process: validation error code: ".concat(err.message), err);
            var _errorMsg = '<b>Sorry, there was a problem validating your credit card.</b>';
            _errorMsg += '<p>Please verify the number and expiration date on your credit card</p>';
            Util.showError(_errorMsg);
            resolve();
          } else if (err.code === 'INVALID_ADDRESS' && err.message) {
            Util.logDebug("landing.process: Address validation error occurred: ".concat(err.message), err);
            var _errorMsg2 = "<b>No address match was found for the information you entered. Please reenter\n            your mailing address.</b>";
            Util.showError(_errorMsg2);
            resolve();
          } else if (err.code === 'ADDRESS_CORRECTION' && err.details && err.details.correctedAddress) {
            // Check if the address fields exists on page and populate with corrected adrress
            Dom.setDefaults({
              street: _.get(err.details.correctedAddress, 'street'),
              city: _.get(err.details.correctedAddress, 'city'),
              state: _.get(err.details.correctedAddress, 'state'),
              zip: _.get(err.details.correctedAddress, 'zip'),
              country: _.get(err.details.correctedAddress, 'country')
            });
            if (_.get(err.details.correctedAddress, 'addressType')) {
              var _Dom$setDefaults;
              var addressType = _.capitalize(_.get(err.details.correctedAddress, 'addressType'));
              Dom.setDefaults((_Dom$setDefaults = {}, _defineProperty(_Dom$setDefaults, "street".concat(addressType), _.get(err.details.correctedAddress, 'street')), _defineProperty(_Dom$setDefaults, "city".concat(addressType), _.get(err.details.correctedAddress, 'city')), _defineProperty(_Dom$setDefaults, "state".concat(addressType), _.get(err.details.correctedAddress, 'state')), _defineProperty(_Dom$setDefaults, "zip".concat(addressType), _.get(err.details.correctedAddress, 'zip')), _defineProperty(_Dom$setDefaults, "country".concat(addressType), _.get(err.details.correctedAddress, 'country')), _Dom$setDefaults));
            }
            Util.logDebug("landing.process: Updated the address with corrected information: ".concat(err.message), err);
            var _errorMsg3 = "<b>Upon validation, one or more parts of your mailing address have been corrected.\n             Please review the changes and resubmit.</b>";
            Util.showError(_errorMsg3);
            resolve();
          } else if (err.code === 'PAYMENT_ERROR' && err.message) {
            Util.logDebug("checkout.process: PaymentError occurred: ".concat(err.message), err);
            var _errorMsg4 = '<b>Oops! There seems to be a problem processing  your payment.</b>';
            _errorMsg4 += "<p>".concat(err.message, "</p>");

            // If the error is due to the Fraud system checks, show custpm error message
            if (err.message.includes('Fraudulent Transaction')) {
              _errorMsg4 = 'Oops! There seems to be a problem processing your payment. Please try another payment method.';
            }
            Util.showError(_errorMsg4);
            resolve();
          } else if (_.includes(['paypal-not-configured', 'paypal-canceled', 'paypal-error'], err.code)) {
            Util.logDebug("one-step.process: validation error code: ".concat(err.message), err);
            var _errorMsg5 = '<b>Sorry, there was a problem authorizing your payment.</b>';
            _errorMsg5 += "<p>".concat(err.message, "</p>");
            Util.showError(_errorMsg5);
            resolve();
          } else if (err.code === 'PAYMENT_ERROR' && err.customer_message) {
            Util.logDebug("checkout.process: a PAYMENT_ERROR occurred: ".concat(err.message), err);
            var _errorMsg6 = '<b>Oops! There seems to be a problem with your credit card.</b>';
            _errorMsg6 += "<p>".concat(err.customer_message, "</p>");
            Util.showError(_errorMsg6);
            resolve();
          } else if (err.code === 'ALREADY_ACTIVE') {
            Util.logDebug("checkout.process: an ALREADY_ACTIVE error occurred: ".concat(err.message), err);
            Util.logDebug('checkout.process: Redirecting to thanks page anyway');
            Util.stopLoading();
            Dom.navigateTo(cjs.config.nextPage);
            resolve();
          } else {
            Util.logDebug("checkout.process: an unknown error occurred: ".concat(err.message), err);
            Util.showError("<b>Unknown error. ".concat(contactSupportMessage, "</b>"));
            reject(err);
          }
        });
      });
    }
  }]);
  return CheckoutPage;
}();
var checkoutPage = new CheckoutPage();

;// CONCATENATED MODULE: ./src/pages/gift-purchase.js
/* eslint-disable no-undef */



function gift_purchase_typeof(obj) { "@babel/helpers - typeof"; return gift_purchase_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, gift_purchase_typeof(obj); }
function gift_purchase_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function gift_purchase_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, gift_purchase_toPropertyKey(descriptor.key), descriptor); } }
function gift_purchase_createClass(Constructor, protoProps, staticProps) { if (protoProps) gift_purchase_defineProperties(Constructor.prototype, protoProps); if (staticProps) gift_purchase_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function gift_purchase_toPropertyKey(arg) { var key = gift_purchase_toPrimitive(arg, "string"); return gift_purchase_typeof(key) === "symbol" ? key : String(key); }
function gift_purchase_toPrimitive(input, hint) { if (gift_purchase_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (gift_purchase_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


var GiftPurchasePage = /*#__PURE__*/function () {
  function GiftPurchasePage() {
    gift_purchase_classCallCheck(this, GiftPurchasePage);
  }
  gift_purchase_createClass(GiftPurchasePage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      Util.startLoading();
      return Util.processPageRequest('gift-purchase', 'giftPurchase').then(function () {
        return Util.logDebug('gift-purchase.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("gift-purchase.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the Purchase page
     */
  }, {
    key: "init",
    value: function init() {
      Dom.initializeOneStepPage();
    }
  }]);
  return GiftPurchasePage;
}();
var giftPurchasePage = new GiftPurchasePage();

;// CONCATENATED MODULE: ./src/pages/gift-redeem.js
/* eslint-disable no-undef */



function gift_redeem_typeof(obj) { "@babel/helpers - typeof"; return gift_redeem_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, gift_redeem_typeof(obj); }
function gift_redeem_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function gift_redeem_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, gift_redeem_toPropertyKey(descriptor.key), descriptor); } }
function gift_redeem_createClass(Constructor, protoProps, staticProps) { if (protoProps) gift_redeem_defineProperties(Constructor.prototype, protoProps); if (staticProps) gift_redeem_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function gift_redeem_toPropertyKey(arg) { var key = gift_redeem_toPrimitive(arg, "string"); return gift_redeem_typeof(key) === "symbol" ? key : String(key); }
function gift_redeem_toPrimitive(input, hint) { if (gift_redeem_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (gift_redeem_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


var GiftRedeemPage = /*#__PURE__*/function () {
  function GiftRedeemPage() {
    gift_redeem_classCallCheck(this, GiftRedeemPage);
  }
  gift_redeem_createClass(GiftRedeemPage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      Util.startLoading();
      return Util.processPageRequest('gift-redeem', 'giftRedeem').then(function () {
        return Util.logDebug('gift-redeem.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("gift-redeem.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the Redeem page
     */
  }, {
    key: "init",
    value: function init() {
      Dom.initializeOneStepPage();
    }
  }]);
  return GiftRedeemPage;
}();
var giftRedeemPage = new GiftRedeemPage();

;// CONCATENATED MODULE: ./src/pages/landing.js
/* eslint-disable no-undef */



function landing_typeof(obj) { "@babel/helpers - typeof"; return landing_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, landing_typeof(obj); }
function landing_defineProperty(obj, key, value) { key = landing_toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function landing_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function landing_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, landing_toPropertyKey(descriptor.key), descriptor); } }
function landing_createClass(Constructor, protoProps, staticProps) { if (protoProps) landing_defineProperties(Constructor.prototype, protoProps); if (staticProps) landing_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function landing_toPropertyKey(arg) { var key = landing_toPrimitive(arg, "string"); return landing_typeof(key) === "symbol" ? key : String(key); }
function landing_toPrimitive(input, hint) { if (landing_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (landing_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }




var LandingPage = /*#__PURE__*/function () {
  function LandingPage() {
    landing_classCallCheck(this, LandingPage);
  }
  landing_createClass(LandingPage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      Util.startLoading();
      return this.process().then(function () {
        return Util.logDebug('landing.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("landing.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the LandingPage
     */
  }, {
    key: "init",
    value: function init() {
      if (!cjs.landingPage.workflow.selectFulfillment) {
        delete cjs.fields.productSKU;
      }
      if (!Dom.getElementLength(cjs.fields.emailVerify)) {
        delete cjs.fields.emailVerify;
      }
      Dom.referenceFields();
      Dom.setCountryListeners();

      // Populate Currency field
      Dom.populateCurrencySelect(cjs.fields.currency);

      // Check if plan selection exists and accordingly set the landingPageId
      if (typeof cjs.fields.landingPageId !== 'undefined') {
        // Add listener to the radio option of plan
        Dom.setLandinPageEventListener(cjs.fields.landingPageId);
      }
      Dom.setDefaults();

      // Setup tax info and listeners
      if (typeof cjs.landingPage.recurlyPublicKey !== 'undefined') {
        window.recurly.configure(cjs.landingPage.recurlyPublicKey);
        Dom.setTaxInfoAndAddressListener();
      }
    }

    /**
     * Process the LandingPage
     */
  }, {
    key: "process",
    value: function process() {
      return new Promise(function (resolve, reject) {
        // First we disable the inputs
        Util.disableInputs();
        var productSKU;
        var password;
        var confirmPassword = null;
        var currency = Dom.getUrlParam('currency');
        if (!currency || currency == null) {
          currency = 'USD';
        }
        var landingPageId = null;
        if (typeof cjs.fields.productSKU !== 'undefined') {
          // Get the product info
          productSKU = Dom.getElementValue(cjs.fields.productSKU);
        }
        if (typeof cjs.fields.password !== 'undefined') {
          // Get the password
          password = Dom.getElementValue(cjs.fields.password);
        }
        if (typeof cjs.fields.confirmPassword !== 'undefined') {
          // Get the password
          confirmPassword = Dom.getElementValue(cjs.fields.confirmPassword);
        }
        if (typeof cjs.fields.currency !== 'undefined') {
          // Get the currency selected
          currency = Dom.getElementValue(cjs.fields.currency);
        }
        if (typeof cjs.fields.landingPageId !== 'undefined') {
          // Get the landingPageId selected
          landingPageId = Dom.getElementValue(cjs.fields.landingPageId);
        }
        var prospect = {
          person: Dom.getMemberDetails(cjs.fields),
          context: Util.getContext(),
          options: {
            productSKU: productSKU,
            currency: currency,
            landingPageId: landingPageId,
            password: password,
            confirmPassword: confirmPassword,
            addressFieldVisibility: Dom.addressFieldVisibility()
          }
        };

        // Format Person Info
        prospect.person = Util.formatPersonAddress(prospect.person);
        validate.runValidation(prospect).then(function () {
          if (!window.Autopilot) {
            Util.logDebug('landing.process: Autopilot not found, skipping');
            return null;
          }
          window.Autopilot.run('associate', prospect.person.email, function () {
            Util.logDebug("landing.process: Running Autopilot associate for ".concat(prospect.person.email));
            return null;
          });
          return null;
        }).then(function () {
          return api.addProspect(prospect);
        }).then(function (res) {
          Util.logDebug('landing.process: success:', res);
          var redirectUrl = cjs.config.nextPage;
          redirectUrl += "?landingPageId=".concat(cjs.landingPage.id);
          redirectUrl += "&personWebToken=".concat(res.webToken);
          if (productSKU != null) {
            redirectUrl += "&productSKU=".concat(productSKU);
          }
          if (currency) {
            redirectUrl += "&currency=".concat(currency);
          }
          Dom.getUtmCodePairs().forEach(function (utmCodePair) {
            redirectUrl = "".concat(redirectUrl, "&").concat(utmCodePair);
          });
          Util.stopLoading();
          Dom.navigateTo(redirectUrl);
          resolve(res);
        })["catch"](function (err) {
          var contactSupportMessage = Util.prepareSupportMessage();
          Util.stopLoading();
          if (typeof err.validationErrors !== 'undefined') {
            Util.logDebug("landing.process: a validation error occurred: ".concat(err.message), err);
            var errorMsg = '<b>Sorry, there was a problem with the information:</b>';
            errorMsg += Util.parseValidationErrors(err.validationErrors);
            Util.showError(errorMsg);
            resolve();
          } else if (err.code === 'ALREADY_ACTIVE') {
            Util.logDebug("landing.process: a PersonActiveError error occurred: ".concat(err.message), err);
            var _errorMsg = "<b>We're sorry! It appears you have already signed up. ".concat(contactSupportMessage, " </b>");
            Util.showError(_errorMsg);
            resolve();
          } else if (err.code === 'INVALID_ADDRESS' && err.message) {
            Util.logDebug("landing.process: Address validation error occurred: ".concat(err.message), err);
            var _errorMsg2 = "<b>No address match was found for the information you entered. Please reenter\n            your mailing address.</b>";
            Util.showError(_errorMsg2);
            resolve();
          } else if (err.code === 'ADDRESS_CORRECTION' && err.details && err.details.correctedAddress) {
            // Check if the address fields exists on page and populate with corrected adrress
            Dom.setDefaults({
              street: _.get(err.details.correctedAddress, 'street'),
              city: _.get(err.details.correctedAddress, 'city'),
              state: _.get(err.details.correctedAddress, 'state'),
              zip: _.get(err.details.correctedAddress, 'zip'),
              country: _.get(err.details.correctedAddress, 'country')
            });
            if (_.get(err.details.correctedAddress, 'addressType')) {
              var _Dom$setDefaults;
              var addressType = _.capitalize(_.get(err.details.correctedAddress, 'addressType'));
              Dom.setDefaults((_Dom$setDefaults = {}, landing_defineProperty(_Dom$setDefaults, "street".concat(addressType), _.get(err.details.correctedAddress, 'street')), landing_defineProperty(_Dom$setDefaults, "city".concat(addressType), _.get(err.details.correctedAddress, 'city')), landing_defineProperty(_Dom$setDefaults, "state".concat(addressType), _.get(err.details.correctedAddress, 'state')), landing_defineProperty(_Dom$setDefaults, "zip".concat(addressType), _.get(err.details.correctedAddress, 'zip')), landing_defineProperty(_Dom$setDefaults, "country".concat(addressType), _.get(err.details.correctedAddress, 'country')), _Dom$setDefaults));
            }
            Util.logDebug("landing.process: Updated the address with corrected information: ".concat(err.message), err);
            var _errorMsg3 = "<b>Upon validation, one or more parts of your mailing address have been corrected.\n             Please review the changes and resubmit.</b>";
            Util.showError(_errorMsg3);
            resolve();
          } else {
            Util.logDebug("landing.process: an unknown error occurred: ".concat(err.message), err);
            Util.showError("<b>Unknown error. ".concat(contactSupportMessage, ".</b>"));
            reject(err);
          }
        });
      });
    }
  }]);
  return LandingPage;
}();
var landingPage = new LandingPage();

;// CONCATENATED MODULE: ./src/pages/one-step.js
/* eslint-disable no-undef */



function one_step_typeof(obj) { "@babel/helpers - typeof"; return one_step_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, one_step_typeof(obj); }
function one_step_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function one_step_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, one_step_toPropertyKey(descriptor.key), descriptor); } }
function one_step_createClass(Constructor, protoProps, staticProps) { if (protoProps) one_step_defineProperties(Constructor.prototype, protoProps); if (staticProps) one_step_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function one_step_toPropertyKey(arg) { var key = one_step_toPrimitive(arg, "string"); return one_step_typeof(key) === "symbol" ? key : String(key); }
function one_step_toPrimitive(input, hint) { if (one_step_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (one_step_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


var OneStepPage = /*#__PURE__*/function () {
  function OneStepPage() {
    one_step_classCallCheck(this, OneStepPage);
  }
  one_step_createClass(OneStepPage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      Util.startLoading();
      return Util.processPageRequest('one-step', 'addMember').then(function () {
        return Util.logDebug('gift-purchase.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("gift-purchase.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the One Step page
     */
  }, {
    key: "init",
    value: function init() {
      Dom.initializeOneStepPage();
    }
  }]);
  return OneStepPage;
}();
var oneStepPage = new OneStepPage();

;// CONCATENATED MODULE: ./src/pages/update-recurly-account.js
/* eslint-disable no-undef */



function update_recurly_account_typeof(obj) { "@babel/helpers - typeof"; return update_recurly_account_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, update_recurly_account_typeof(obj); }
function update_recurly_account_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function update_recurly_account_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, update_recurly_account_toPropertyKey(descriptor.key), descriptor); } }
function update_recurly_account_createClass(Constructor, protoProps, staticProps) { if (protoProps) update_recurly_account_defineProperties(Constructor.prototype, protoProps); if (staticProps) update_recurly_account_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function update_recurly_account_toPropertyKey(arg) { var key = update_recurly_account_toPrimitive(arg, "string"); return update_recurly_account_typeof(key) === "symbol" ? key : String(key); }
function update_recurly_account_toPrimitive(input, hint) { if (update_recurly_account_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (update_recurly_account_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


var UpdateRecurlyAccountPage = /*#__PURE__*/function () {
  function UpdateRecurlyAccountPage() {
    update_recurly_account_classCallCheck(this, UpdateRecurlyAccountPage);
  }
  update_recurly_account_createClass(UpdateRecurlyAccountPage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      Util.startLoading();
      return Util.processPageRequest('update-recurly-account', 'updateRecurlyAccount', true).then(function () {
        return Util.logDebug('update-recurly-account.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("update-recurly-account.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the One Step page
     */
  }, {
    key: "init",
    value: function init() {
      Dom.initializeOneStepPage();
    }
  }]);
  return UpdateRecurlyAccountPage;
}();
var updateRecurlyAccountPage = new UpdateRecurlyAccountPage();

;// CONCATENATED MODULE: ./src/pages/update-request.js
/* eslint-disable no-undef */



function update_request_typeof(obj) { "@babel/helpers - typeof"; return update_request_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, update_request_typeof(obj); }
function update_request_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function update_request_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, update_request_toPropertyKey(descriptor.key), descriptor); } }
function update_request_createClass(Constructor, protoProps, staticProps) { if (protoProps) update_request_defineProperties(Constructor.prototype, protoProps); if (staticProps) update_request_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function update_request_toPropertyKey(arg) { var key = update_request_toPrimitive(arg, "string"); return update_request_typeof(key) === "symbol" ? key : String(key); }
function update_request_toPrimitive(input, hint) { if (update_request_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (update_request_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


var UpdateRequestPage = /*#__PURE__*/function () {
  function UpdateRequestPage() {
    update_request_classCallCheck(this, UpdateRequestPage);
  }
  update_request_createClass(UpdateRequestPage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      Util.startLoading();
      Util.processPageRequest('update-request', 'updateRequest').then(function () {
        return Util.logDebug('updateRequest.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("updateRequest.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the One Step page
     */
  }, {
    key: "init",
    value: function init() {
      Dom.initializeOneStepPage();
    }
  }]);
  return UpdateRequestPage;
}();
var updateRequestPage = new UpdateRequestPage();

;// CONCATENATED MODULE: ./src/pages/update.js
/* eslint-disable no-undef */



function update_typeof(obj) { "@babel/helpers - typeof"; return update_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, update_typeof(obj); }
function update_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function update_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, update_toPropertyKey(descriptor.key), descriptor); } }
function update_createClass(Constructor, protoProps, staticProps) { if (protoProps) update_defineProperties(Constructor.prototype, protoProps); if (staticProps) update_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function update_toPropertyKey(arg) { var key = update_toPrimitive(arg, "string"); return update_typeof(key) === "symbol" ? key : String(key); }
function update_toPrimitive(input, hint) { if (update_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (update_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


var UpdatePage = /*#__PURE__*/function () {
  function UpdatePage() {
    update_classCallCheck(this, UpdatePage);
  }
  update_createClass(UpdatePage, [{
    key: "handleSubmit",
    value:
    /**
     * Handle the submit
     */
    function handleSubmit() {
      Util.startLoading();
      return Util.processPageRequest('update', 'updateMember', true).then(function () {
        return Util.logDebug('update.handleSubmit: success');
      })["catch"](function (err) {
        return Util.logError("update.handleSubmit: error: ".concat(err.message), err);
      });
    }

    /**
     * Initialize the One Step page
     */
  }, {
    key: "init",
    value: function init() {
      Dom.initializeOneStepPage();
    }
  }]);
  return UpdatePage;
}();
var updatePage = new UpdatePage();

;// CONCATENATED MODULE: ./src/lib/dom.js
/* eslint-disable no-undef */



function dom_typeof(obj) { "@babel/helpers - typeof"; return dom_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, dom_typeof(obj); }
function dom_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function dom_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, dom_toPropertyKey(descriptor.key), descriptor); } }
function dom_createClass(Constructor, protoProps, staticProps) { if (protoProps) dom_defineProperties(Constructor.prototype, protoProps); if (staticProps) dom_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function dom_toPropertyKey(arg) { var key = dom_toPrimitive(arg, "string"); return dom_typeof(key) === "symbol" ? key : String(key); }
function dom_toPrimitive(input, hint) { if (dom_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (dom_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }












var Dom = /*#__PURE__*/function () {
  function Dom() {
    dom_classCallCheck(this, Dom);
  }
  dom_createClass(Dom, null, [{
    key: "initializeOneStepPage",
    value:
    /**
     * Helper method to initialize one step pages
     */
    function initializeOneStepPage() {
      if (!cjs.landingPage.workflow.selectFulfillment) {
        delete cjs.fields.productSKU;
      }
      if (!cjs.landingPage.workflow.zinioSubscription) {
        delete cjs.fields.zinio;
      }
      window.recurly.configure(cjs.landingPage.recurlyPublicKey);
      if (!Dom.getElementLength(cjs.fields.emailVerify)) {
        delete cjs.fields.emailVerify;
      }
      Dom.referenceFields();
      if (typeof cjs.fields.ccMonth !== 'undefined') {
        Dom.addCcMonths(cjs.fields.ccMonth);
      }
      if (typeof cjs.fields.ccYear !== 'undefined') {
        Dom.addCcYears(cjs.fields.ccYear);
      }
      Dom.setCountryListeners();

      // Populate Currency field
      Dom.populateCurrencySelect(cjs.fields.currency);

      // Check if plan selection exists and accordingly set the landingPageId
      if (typeof cjs.fields.landingPageId !== 'undefined') {
        // Add listener to the radio option of plan
        Dom.setLandinPageEventListener(cjs.fields.landingPageId);
      }
      Dom.setDefaults();
      // Setup tax info and listeners
      Dom.setTaxInfoAndAddressListener();
    }

    /**
     * Return a map of all the jQuery referenced elements in the input map
     */
  }, {
    key: "referenceFields",
    value: function referenceFields() {
      // Prepare the result object
      var fields = {};
      Object.keys(cjs.fields).forEach(function (fieldRef) {
        var fieldId = cjs.fields[fieldRef];

        // Get a reference to the object using jQuery
        var field = $(fieldId);
        field.addClass('fc-campaign');

        // Log an error if the field is not found
        if (!field.length) {
          Util.logError("Element could not be found: ".concat(fieldId));
        }

        // Set the reference to the result object
        fields[fieldRef] = field;
      });

      // Check for the preferences fields and add to the fields area
      if (cjs.config.preferences) {
        fields.preferences = {};
        Object.keys(cjs.config.preferences).forEach(function (fieldRef) {
          var field = $("#fc-".concat(fieldRef));
          field.addClass('fc-campaign');

          // Log an error if the field is not found
          if (!field.length) {
            Util.logError("Element could not be found: #fc-".concat(fieldRef));
          }
          // Set the reference to the result object
          fields.preferences[fieldRef] = field;
        });
      }
      cjs.fields = fields;
    }

    /**
     * Clear the values of all of the fields
     */
  }, {
    key: "clearInputFields",
    value: function clearInputFields() {
      Object.keys(cjs.fields).forEach(function (fieldRef) {
        $(cjs.fields[fieldRef]).val('');
      });
    }

    /**
     * Fill all the placeholders with the person data
     */
  }, {
    key: "fillPlaceholders",
    value: function fillPlaceholders() {
      // The fields we want to fill
      var fields = ['firstName', 'lastName', 'street', 'city', 'country', 'state', 'zip', 'email', 'billingInfo.ccFirstSix', 'billingInfo.ccLastFour', 'billingInfo.ccMonth', 'billingInfo.ccType', 'billingInfo.ccYear', 'memberId'];
      fields.forEach(function (field) {
        // Escape special chars while building the css class selector
        var cssSelector = field.replace('.', '\\.');
        var reference = $(".person_".concat(cssSelector));
        var placeholderValue = lodash_default().get(cjs.person, field, false);
        if (placeholderValue && reference.length) {
          reference.html(placeholderValue);
        }
      });
    }

    /**
     * Get the Credit Card details from the form
     x */
  }, {
    key: "getMemberCard",
    value: function getMemberCard(fields) {
      return {
        number: Dom.getElementValue(fields.ccNumber),
        month: Dom.getElementValue(fields.ccMonth),
        year: Dom.getElementValue(fields.ccYear),
        type: window.recurly.validate.cardType(fields.ccNumber),
        firstSix: Dom.getElementValue(fields.ccNumber).slice(0, 6),
        lastFour: Dom.getElementValue(fields.ccNumber).slice(-4)
      };
    }

    /**
     * Get the person details
     */
  }, {
    key: "getMemberDetails",
    value: function getMemberDetails(fields) {
      var memberDetails = {};
      Object.keys(fields).forEach(function (fieldRef) {
        if (fieldRef !== 'productSKU' && fieldRef !== 'preferences') {
          memberDetails[fieldRef] = Dom.getElementValue(fields[fieldRef]);
        }
      });

      // Set the country if empty, when not present on landing page
      var stateFields = ['state', 'stateBilling', 'stateShipping'];
      var countryFields = ['country', 'countryBilling', 'countryShipping'];
      stateFields.forEach(function (state) {
        countryFields.forEach(function (country) {
          if (!memberDetails[country] && Dom.getDefaultCountry(state) !== '' && typeof cjs.fields[state] !== 'undefined') {
            memberDetails[country] = Dom.getDefaultCountry(state);
          }
        });
      });
      if (cjs.config.preferences) {
        memberDetails.preferences = {};
        Object.keys(cjs.config.preferences).forEach(function (fieldRef) {
          memberDetails.preferences[fieldRef] = Dom.getElementValue(fields.preferences[fieldRef]);
        });
      }
      return memberDetails;
    }

    /**
     * Redirect the user to another page
     */
  }, {
    key: "navigateTo",
    value: function navigateTo(page) {
      Util.logDebug("Dom.navigateTo: ".concat(page));
      window.location.assign(page);
    }

    /**
     * Check if address fieldset exists
     */
  }, {
    key: "addressFieldVisibility",
    value: function addressFieldVisibility() {
      var addressFieldVisibility = true;
      var addressFields = ['street', 'city', 'state', 'zip'];
      addressFields.forEach(function (field) {
        if (!cjs.fields[field]) {
          addressFieldVisibility = false;
        }
      });
      return addressFieldVisibility;
    }

    /**
     * Get the recurly token based on the billingInfo
     */
  }, {
    key: "getRecurlyToken",
    value: function getRecurlyToken(billingInfo) {
      var submithandler = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'creditcard';
      var options = null;
      if (submithandler === 'creditcard') {
        options = billingInfo;
        submithandler = 'token';
      } else if (submithandler === 'paypal') {
        options = {
          description: 'Subscription payment'
        };
      }
      return new Promise(function (resolve, reject) {
        window.recurly[submithandler](options, function (err, token) {
          if (err) {
            return reject(err);
          }
          return resolve(token);
        });
      });
    }

    /**
     * Helper method to add an array with options to a select element
     */
  }, {
    key: "addOptionsToSelect",
    value: function addOptionsToSelect(options, select) {
      if (typeof options === 'undefined' || typeof select === 'undefined') {
        Util.logError('Unexpected parameters addOptionsToSelect');
      }

      // Set the label as first entry
      var productLabel = lodash_default().get(select, '[0].dataset.productlabel', 'Select a Product');

      // Empty the existing select options
      select.empty();
      select.append($('<option>', {
        value: '',
        text: productLabel
      }));

      // Add all options to the select box
      options.forEach(function (option) {
        var selectItem = {
          value: option.sku,
          text: option.name
        };
        if (!option.available) {
          selectItem.disabled = 'disabled';
          selectItem.text = "".concat(selectItem.text, " (Unavailable)");
        }
        select.append($('<option>', selectItem));
      });
    }

    /**
     * Helper method to add a list of months to credit card month element
     */
  }, {
    key: "addCcMonths",
    value: function addCcMonths(select) {
      var months = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];
      select.append($('<option>', {
        value: '',
        text: 'Month'
      }));
      months.forEach(function (month) {
        select.append($('<option>', {
          value: month,
          text: month
        }));
      });
    }

    /**
     * Helper method to add a list of months to credit card month element
     */
  }, {
    key: "addCcYears",
    value: function addCcYears(select) {
      var now = new Date();
      var thisYear = now.getFullYear();
      var years = [];
      for (var i = 0; i <= 20; i++) {
        years.push(thisYear + i);
      }
      select.append($('<option>', {
        value: '',
        text: 'Year'
      }));
      years.forEach(function (year) {
        select.append($('<option>', {
          value: year,
          text: year
        }));
      });
    }

    /**
     * Add a single Product Image to a div
     */
  }, {
    key: "addProductImage",
    value: function addProductImage(product, target) {
      var div = $('<div>', {
        "class": 'fc-product-image'
      });
      var img = $('<img>', {
        src: product.imageUrl
      });
      div.append(img);
      div.append("<div class=\"fc-product-name\">".concat(product.name, "</div>"));
      $(target).append(div);
    }

    /**
     * Helper method to add text to an element
     */
  }, {
    key: "getElementValue",
    value: function getElementValue(element) {
      var elementType = element.attr('type');
      if (elementType === 'radio') {
        element.selector = element.filter(':checked');
        var elementValue = $(element.selector).val();
        if (typeof elementValue === 'undefined') {
          elementValue = '';
        }
        return elementValue;
      }
      if (elementType === 'checkbox') {
        if ($(element).is(':checked')) {
          return 'Yes';
        }
        return 'No';
      }
      return element.val();
    }

    /**
     * Helper method to get element value by ID
     */
  }, {
    key: "getElementValueById",
    value: function getElementValueById(element) {
      return $(element).val();
    }

    /**
     * Return the url with query params appended
     */
  }, {
    key: "appendQueryString",
    value: function appendQueryString(url, queryStringParts) {
      var firstSeperator = url.indexOf('?') === -1 ? '?' : '&';
      var queryString = queryStringParts.join('&');
      return url + firstSeperator + queryString;
    }

    /**
     * Helper method to get length of an element
     */
  }, {
    key: "getElementLength",
    value: function getElementLength(element) {
      return $(element).length;
    }

    /**
     * Return a map of all the UTM Parameters
     */
  }, {
    key: "getUtmParams",
    value: function getUtmParams() {
      var params = Dom.getUrlParams();
      return {
        source: params.utm_source ? params.utm_source : '',
        medium: params.utm_medium ? params.utm_medium : '',
        term: params.utm_term ? params.utm_term : '',
        content: params.utm_content ? params.utm_content : '',
        name: params.utm_campaign ? params.utm_campaign : ''
      };
    }

    /**
     * Set country fields and listeners
     */
  }, {
    key: "setCountryListeners",
    value: function setCountryListeners() {
      var countryFields = ['country', 'countryBilling', 'countryShipping'];
      var stateFields = ['state', 'stateBilling', 'stateShipping'];
      countryFields.forEach(function (country) {
        if (typeof cjs.fields[country] !== 'undefined') {
          // Populate the country options
          Dom.populateCountrySelect(cjs.fields[country]);
        }
      });
      stateFields.forEach(function (state) {
        if (typeof cjs.fields[state] !== 'undefined') {
          // Add listener to the seelct option of country
          var countryField = '#fc-country';
          if (state == 'stateBilling') {
            countryField = '#fc-country-billing';
          } else if (state == 'stateShipping') {
            countryField = '#fc-country-shipping';
          }
          Dom.populateStatesSelect(cjs.fields[state], Dom.getDefaultCountry(state, countryField));
          Dom.setCountryEventListener(cjs.fields[state], countryField);
        }
      });

      // Allow address copy from billing to shipping via fc-address-copy field
      $('#fc-address-copy').change(function () {
        if ($(this).is(':checked')) {
          var addressfields = {
            countryBilling: '#fc-country-shipping',
            streetBilling: '#fc-street-shipping',
            cityBilling: '#fc-city-shipping',
            zipBilling: '#fc-zip-shipping',
            stateBilling: '#fc-state-shipping'
          };
          Object.keys(addressfields).forEach(function (fieldRef) {
            if (typeof cjs.fields[fieldRef] !== 'undefined') {
              var fieldValue = Dom.getElementValue(cjs.fields[fieldRef]);
              if (fieldValue !== 'undefined') {
                $(addressfields[fieldRef]).val(fieldValue);
              }
            }
          });
        }
      });
    }

    /**
     * Return all available UTM codes in pairs
     */
  }, {
    key: "getUtmCodePairs",
    value: function getUtmCodePairs() {
      var params = Dom.getUrlParams();
      var utmCodes = ['utm_source', 'utm_medium', 'utm_term', 'utm_content', 'utm_campaign'];
      return utmCodes.filter(function (utmCode) {
        return typeof params[utmCode] !== 'undefined';
      }).map(function (utmCode) {
        return "".concat(utmCode, "=").concat(params[utmCode]);
      });
    }

    /**
     * Return all the url params
     */
  }, {
    key: "getUrlParams",
    value: function getUrlParams() {
      var params = [];
      var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
      for (var i = 0; i < hashes.length; i++) {
        var hash = hashes[i].split('=');
        params.push(hash[0]);
        params[hash[0]] = hash[1];
      }
      return params;
    }

    /**
     * Return one url param or false if it does not exist
     */
  }, {
    key: "getUrlParam",
    value: function getUrlParam(param) {
      var params = Dom.getUrlParams();
      return typeof params[param] === 'undefined' ? false : params[param];
    }
  }, {
    key: "populateStatesSelect",
    value: function populateStatesSelect(select, country) {
      var options = Util.getStates(country);

      // If no states are found, hide the field and lable, unhide otherwise
      if (!options.length) {
        select.hide();
        $("label[for=".concat(select[0].id, "]")).hide();
      } else {
        select.show();
        $("label[for=".concat(select[0].id, "]")).show();
      }
      var stateLabel = lodash_default().get(select, '[0].dataset.statelabel', null);

      // Empty the existing state options
      select.empty();
      if (stateLabel) {
        select.append($('<option>', {
          value: '',
          text: stateLabel
        }));
      }
      return options.forEach(function (option) {
        return select.append($('<option>', {
          value: option.code,
          text: option.name
        }));
      });
    }
  }, {
    key: "populateCountrySelect",
    value: function populateCountrySelect(select, country) {
      var options = Util.getCountries(country);

      // Empty the existing state options
      select.empty();
      return options.forEach(function (option) {
        return select.append($('<option>', {
          value: option.code,
          text: option.name
        }));
      });
    }
  }, {
    key: "populateCurrencySelect",
    value: function populateCurrencySelect(select) {
      if (typeof cjs.fields.currency !== 'undefined') {
        var options = Util.getCurrencies();

        // Empty the existing state options
        select.empty();
        return options.forEach(function (option) {
          return select.append($('<option>', {
            value: option.code,
            text: option.name
          }));
        });
      }
    }
  }, {
    key: "populateSubscriptionSelect",
    value: function populateSubscriptionSelect(select, subscriptions) {
      var options = [];
      lodash_default()(subscriptions).forEach(function (subscription) {
        if (subscription && subscription.subscription_uuid && subscription.plan) {
          options.push({
            code: subscription.subscription_uuid,
            name: subscription.plan.name
          });
        }
      });

      // Empty the existing select options
      select.empty();
      return options.forEach(function (option) {
        return select.append($('<option>', {
          value: option.code,
          text: option.name
        }));
      });
    }
  }, {
    key: "getDefaultCountry",
    value: function getDefaultCountry(stateField) {
      var countryField = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var defaultCountry = countryField ? $(countryField).val() : 'US';

      // Check if the country was set on state field via dataset properties
      if (stateField && cjs.fields[stateField]) {
        defaultCountry = lodash_default().get(cjs.fields[stateField], '[0].dataset.country', defaultCountry);
      }

      // Check if the country was set via url params
      defaultCountry = stateField === 'state' && Dom.getUrlParam('country') ? Dom.getUrlParam('country') : String(defaultCountry);
      return defaultCountry;
    }

    /**
     * Trigger the handle submit for each process
     */
  }, {
    key: "processAutoSubmit",
    value: function processAutoSubmit() {
      // Require current page
      var page = null;
      try {
        switch (cjs.config.page) {
          case 'add-recurly-account':
            page = new AddRecurlyAccountPage();
            break;
          case 'checkout':
            page = new CheckoutPage();
            break;
          case 'gift-purchase':
            page = new GiftPurchasePage();
            break;
          case 'gift-redeem':
            page = new GiftRedeemPage();
            break;
          case 'landing':
            page = new LandingPage();
            break;
          case 'one-step':
            page = new OneStepPage();
            break;
          case 'update-recurly-account':
            page = new UpdateRecurlyAccountPage();
            break;
          case 'update-request':
            page = new UpdateRequestPage();
            break;
          case 'update':
            page = new UpdatePage();
            break;
        }
      } catch (err) {
        return Promise.reject(err);
      }
      return page.handleSubmit().then(function () {
        return resolve();
      })["catch"](function (err) {
        Util.logDebug("dom.processAutoSubmit: error: ".concat(err.message), err);
        reject(err);
      });
    }

    /**
     * Add eventlistener to country select options
     */
  }, {
    key: "setCountryEventListener",
    value: function setCountryEventListener(stateField, countryField) {
      var countrySelector = document.querySelector(countryField);
      if (countrySelector) {
        // Set eventlistener to the country select list
        countrySelector.addEventListener('change', function () {
          return Dom.populateStatesSelect(stateField, countrySelector.value);
        });
      }
    }

    /**
     * Add eventlistener to plan selection field
     */
  }, {
    key: "setLandinPageEventListener",
    value: function setLandinPageEventListener(planSelector) {
      var planSelectors = $(planSelector);
      if (planSelectors) {
        var _loop = function _loop(i) {
          planSelectors[i].addEventListener('click', function () {
            Util.switchLandingPage(planSelectors[i].value);
          });
        };
        // Set eventlistener to plan selectors
        for (var i = 0; i < planSelectors.length; i++) {
          _loop(i);
        }

        // If radio option is already selected, switch to selected landingPageId
        var landingPageId = Dom.getElementValue(cjs.fields.landingPageId);
        if (landingPageId) {
          Util.switchLandingPage(landingPageId);
        }
      }
    }

    /**
     * Add Tax info and eventlistener for address fields to update tax
     */
  }, {
    key: "setTaxInfoAndAddressListener",
    value: function setTaxInfoAndAddressListener() {
      var zipValue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      if (Dom.getElementLength('#fc-payment-summary')) {
        var zipSelector = document.querySelector('#fc-zip');
        if (zipSelector) {
          // Set eventlistener to the country select list
          zipSelector.addEventListener('change', function () {
            return Dom.setTaxInfoAndAddressListener(zipSelector.value);
          });
          zipValue = zipSelector.value;
        }

        // Get the current currency status
        var currency = Dom.getUrlParam('currency');
        if (!currency || currency == null) {
          currency = 'USD';
        }
        if (typeof cjs.fields.currency !== 'undefined') {
          // Get the product info
          currency = Dom.getElementValue(cjs.fields.currency);
        }
        var pricing = recurly.Pricing();
        pricing.plan(cjs.landingPage.workflow.workflowTaskPlanId, {
          quantity: 1
        }).currency(currency).address({
          country: lodash_default().get(cjs.person, 'country', 'US'),
          postal_code: zipValue ? zipValue : lodash_default().get(cjs.person, 'zip', null)
        })["catch"](function (err) {
          Util.logDebug("dom.setTaxInfoAndAddressListener: error: ".concat(err.message), err);
        }).done(function (price) {
          Util.logDebug('om.setTaxInfoAndAddressListener: success: calculated tax amount');
        });
        pricing.attach(document.querySelector('#fc-payment-summary'));
      }
    }
  }, {
    key: "setDefaults",
    value: function setDefaults(params) {
      if (!params) {
        params = Dom.getUrlParams();
      }

      // If the checksum exists do a lookup by checksum and prepopulate data
      if (typeof params.checksum !== 'undefined') {
        return new Promise(function (resolve, reject) {
          api.getPersonByChecksum(params.checksum, params).then(function (personInfo) {
            // Make sure the required select data for state is available for populating
            if (typeof cjs.fields.state !== 'undefined') {
              var defaultCountry = personInfo.country ? personInfo.country : Dom.getDefaultCountry();
              Dom.populateStatesSelect(cjs.fields.state, defaultCountry);
            }

            // Lets store the checksum verification status
            cjs.checksumVerified = true;

            // If the billing details exists, make sure those are valid
            if (personInfo.billingInfo) {
              var ccMonth = personInfo.billingInfo.ccMonth;
              var ccYear = personInfo.billingInfo.ccYear;
              var today = new Date();
              var selDate = new Date();
              if (today.getTime() < selDate.setFullYear(ccYear, ccMonth)) {
                cjs.billingInfoValid = true;
              }
            }
            params = lodash_default().assign(params, personInfo);
            delete params.checksum;
            if (personInfo.events) {
              var eventInfo = lodash_default().head(personInfo.events);
              if (eventInfo && eventInfo.data && eventInfo.data.updateRequest) {
                var updateRequest = eventInfo.data.updateRequest;
                params = lodash_default().assign(params, updateRequest.person);
              }
            }
            if (personInfo.subscriptions && cjs.fields.recurlySubscription) {
              Dom.populateSubscriptionSelect(cjs.fields.recurlySubscription, personInfo.subscriptions);
            }
            return Dom.setDefaults(params);
          }).then(function () {
            return Dom.fillPlaceholders(params);
          }).then(function () {
            return resolve();
          })["catch"](function (err) {
            // Lets store the checksum verification status
            cjs.checksumVerified = false;
            Util.logDebug("dom.setDefaults: error: ".concat(err.message), err);
            reject(err);
          });
        });
      }
      var fields = ['firstName', 'lastName', 'street', 'city', 'country', 'state', 'zip', 'streetBilling', 'cityBilling', 'countryBilling', 'stateBilling', 'zipBilling', 'streetShipping', 'cityShipping', 'countryShipping', 'stateShipping', 'zipShipping', 'email', 'giftCode', 'productSKU', 'password', 'confirmPassword'];
      fields.forEach(function (field) {
        if (cjs.fields[field]) {
          var reference = $(cjs.fields[field][0]);
          if (typeof params[field] !== 'undefined' && reference.length) {
            $(cjs.fields[field]).val(decodeURI(params[field]));
          }
        }
      });

      // After processing the page defaults, try to autosubmit if requested via url params
      if (Dom.getUrlParam('autosubmit') === 'true') {
        // Get the submit button from config
        Dom.processAutoSubmit();
      }
      return null;
    }
  }]);
  return Dom;
}();
;// CONCATENATED MODULE: ./src/lib/options.js


function options_typeof(obj) { "@babel/helpers - typeof"; return options_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, options_typeof(obj); }
function options_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function options_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, options_toPropertyKey(descriptor.key), descriptor); } }
function options_createClass(Constructor, protoProps, staticProps) { if (protoProps) options_defineProperties(Constructor.prototype, protoProps); if (staticProps) options_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function options_toPropertyKey(arg) { var key = options_toPrimitive(arg, "string"); return options_typeof(key) === "symbol" ? key : String(key); }
function options_toPrimitive(input, hint) { if (options_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (options_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var Options = /*#__PURE__*/function () {
  function Options() {
    options_classCallCheck(this, Options);
  }
  options_createClass(Options, null, [{
    key: "getCurrenciesOptions",
    value:
    /**
     * Currencies data list , referenced from recurly
     * @returns [Object]
     */
    function getCurrenciesOptions() {
      return [{
        name: 'United States Dollars',
        code: 'USD'
      }, {
        name: 'Euros',
        code: 'EUR'
      }, {
        name: 'British Pounds',
        code: 'GBP'
      }, {
        name: 'Argentine Peso',
        code: 'ARS'
      }, {
        name: 'Australian Dollars',
        code: 'AUD'
      }, {
        name: 'Canadian Dollars',
        code: 'CAD'
      }, {
        name: 'Chilean Peso',
        code: 'CLP  '
      }, {
        name: 'Colombian Peso',
        code: 'COP'
      }, {
        name: 'Brazilian Real',
        code: 'BRL'
      }, {
        name: 'Chinese Yuan',
        code: 'CNY'
      }, {
        name: 'Czech Korunas',
        code: 'CZK'
      }, {
        name: 'Danish Krones',
        code: 'DKK'
      }, {
        name: 'Hungarian Forints',
        code: 'HUF'
      }, {
        name: 'Hong Kong Dollars',
        code: 'HKD'
      }, {
        name: 'Israeli New Sheqel',
        code: 'ILS'
      }, {
        name: 'Indian Rupee',
        code: 'INR'
      }, {
        name: 'Icelandic Krónas',
        code: 'ISK'
      }, {
        name: 'Japanese Yen',
        code: 'JPY'
      }, {
        name: 'South Korean Won',
        code: 'KRW'
      }, {
        name: 'Mexican Peso',
        code: 'MXN'
      }, {
        name: 'Norwegian Krones',
        code: 'NOK'
      }, {
        name: 'New Zealand Dollars',
        code: 'NZD'
      }, {
        name: 'Polish Zloty',
        code: 'PLN'
      }, {
        name: 'Singapore Dollars',
        code: 'SGD'
      }, {
        name: 'Swedish Kronas',
        code: 'SEK'
      }, {
        name: 'Russian Ruble',
        code: 'RUB'
      }, {
        name: 'Swiss Francs',
        code: 'CHF'
      }, {
        name: 'Thai Baht',
        code: 'THB'
      }, {
        name: 'Venezuelan Bolívar',
        code: 'VEF'
      }, {
        name: 'South African Rand',
        code: 'ZAR'
      }];
    }

    /**
     * Countries data list , referenced from https://gist.github.com/Keeguon/2310008
     * @returns [Object]
     */
  }, {
    key: "getCountriesOptions",
    value: function getCountriesOptions() {
      return [{
        name: 'United States',
        code: 'US',
        phone_code: '+1'
      }, {
        name: 'Canada',
        code: 'CA',
        phone_code: '+1'
      }, {
        name: 'Afghanistan',
        code: 'AF',
        phone_code: '+93'
      }, {
        name: 'Albania',
        code: 'AL',
        phone_code: '+355'
      }, {
        name: 'Algeria',
        code: 'DZ',
        phone_code: '+213'
      }, {
        name: 'American Samoa',
        code: 'AS',
        phone_code: '+1'
      }, {
        name: 'Andorra',
        code: 'AD',
        phone_code: '+376'
      }, {
        name: 'Angola',
        code: 'AO',
        phone_code: '+244'
      }, {
        name: 'Anguilla',
        code: 'AI',
        phone_code: '+1'
      }, {
        name: 'Antigua',
        code: 'AG',
        phone_code: '+1'
      }, {
        name: 'Argentina',
        code: 'AR',
        phone_code: '+54'
      }, {
        name: 'Armenia',
        code: 'AM',
        phone_code: '+374'
      }, {
        name: 'Aruba',
        code: 'AW',
        phone_code: '+297'
      }, {
        name: 'Australia',
        code: 'AU',
        phone_code: '+61'
      }, {
        name: 'Austria',
        code: 'AT',
        phone_code: '+43'
      }, {
        name: 'Azerbaijan',
        code: 'AZ',
        phone_code: '+994'
      }, {
        name: 'Bahrain',
        code: 'BH',
        phone_code: '+973'
      }, {
        name: 'Bangladesh',
        code: 'BD',
        phone_code: '+880'
      }, {
        name: 'Barbados',
        code: 'BB',
        phone_code: '+1'
      }, {
        name: 'Belarus',
        code: 'BY',
        phone_code: '+375'
      }, {
        name: 'Belgium',
        code: 'BE',
        phone_code: '+32'
      }, {
        name: 'Belize',
        code: 'BZ',
        phone_code: '+501'
      }, {
        name: 'Benin',
        code: 'BJ',
        phone_code: '+229'
      }, {
        name: 'Bermuda',
        code: 'BM',
        phone_code: '+1'
      }, {
        name: 'Bhutan',
        code: 'BT',
        phone_code: '+975'
      }, {
        name: 'Bolivia',
        code: 'BO',
        phone_code: '+591'
      }, {
        code: 'BQ',
        name: 'Bonaire, Sint Eustatius and Saba',
        phone_code: '+599'
      }, {
        name: 'Bosnia and Herzegovina',
        code: 'BA',
        phone_code: '+387'
      }, {
        name: 'Botswana',
        code: 'BW',
        phone_code: '+267'
      }, {
        name: 'Brazil',
        code: 'BR',
        phone_code: '+55'
      }, {
        name: 'British Indian Ocean Territory',
        code: 'IO',
        phone_code: '+246'
      }, {
        name: 'British Virgin Islands',
        code: 'VG',
        phone_code: '+1'
      }, {
        name: 'Brunei',
        code: 'BN',
        phone_code: '+673'
      }, {
        name: 'Bulgaria',
        code: 'BG',
        phone_code: '+359'
      }, {
        name: 'Burkina Faso',
        code: 'BF',
        phone_code: '+226'
      }, {
        name: 'Burma Myanmar',
        code: 'MM',
        phone_code: '+95'
      }, {
        name: 'Burundi',
        code: 'BI',
        phone_code: '+257'
      }, {
        name: 'Cambodia',
        code: 'KH',
        phone_code: '+855'
      }, {
        name: 'Cameroon',
        code: 'CM',
        phone_code: '+237'
      }, {
        name: 'Cape Verde',
        code: 'CV',
        phone_code: '+238'
      }, {
        name: 'Cayman Islands',
        code: 'KY',
        phone_code: '+1'
      }, {
        name: 'Central African Republic',
        code: 'CF',
        phone_code: '+236'
      }, {
        name: 'Chad',
        code: 'ID',
        phone_code: '+235'
      }, {
        name: 'Chile',
        code: 'CL',
        phone_code: '+56'
      }, {
        name: 'China',
        code: 'CN',
        phone_code: '+86'
      }, {
        name: 'Colombia',
        code: 'CO',
        phone_code: '+57'
      }, {
        name: 'Comoros',
        code: 'KM',
        phone_code: '+269'
      }, {
        name: 'Cook Islands',
        code: 'CK',
        phone_code: '+682'
      }, {
        name: 'Costa Rica',
        code: 'CR',
        phone_code: '+506'
      }, {
        name: 'Côte dIvoire',
        code: 'CI',
        phone_code: '+225'
      }, {
        name: 'Croatia',
        code: 'HR',
        phone_code: '+385'
      }, {
        name: 'Cuba',
        code: 'CU',
        phone_code: '+53'
      }, {
        code: 'CW',
        name: 'Curaçao',
        phone_code: '+599'
      }, {
        name: 'Cyprus',
        code: 'CY',
        phone_code: '+357'
      }, {
        name: 'Czech Republic',
        code: 'CZ',
        phone_code: '+420'
      }, {
        name: 'Democratic Republic of Congo',
        code: 'CD',
        phone_code: '+243'
      }, {
        name: 'Denmark',
        code: 'DK',
        phone_code: '+45'
      }, {
        name: 'Djibouti',
        code: 'DJ',
        phone_code: '+253'
      }, {
        name: 'Dominica',
        code: 'DM',
        phone_code: '+1'
      }, {
        name: 'Dominican Republic',
        code: 'DO',
        phone_code: '+1'
      }, {
        name: 'Ecuador',
        code: 'EC',
        phone_code: '+593'
      }, {
        name: 'Egypt',
        code: 'EG',
        phone_code: '+20'
      }, {
        name: 'El Salvador',
        code: 'SV',
        phone_code: '+503'
      }, {
        name: 'Equatorial Guinea',
        code: 'GQ',
        phone_code: '+240'
      }, {
        name: 'Eritrea',
        code: 'ER',
        phone_code: '+291'
      }, {
        name: 'Estonia',
        code: 'EE',
        phone_code: '+372'
      }, {
        name: 'Ethiopia',
        code: 'ET',
        phone_code: '+251'
      }, {
        name: 'Falkland Islands',
        code: 'FK',
        phone_code: '+500'
      }, {
        name: 'Faroe Islands',
        code: 'FO',
        phone_code: '+298'
      }, {
        name: 'Federated States of Micronesia',
        code: 'FM',
        phone_code: '+691'
      }, {
        name: 'Fiji',
        code: 'FJ',
        phone_code: '+679'
      }, {
        name: 'Finland',
        code: 'FI',
        phone_code: '+358'
      }, {
        name: 'France',
        code: 'FR',
        phone_code: '+33'
      }, {
        name: 'French Guiana',
        code: 'GF',
        phone_code: '+594'
      }, {
        name: 'French Polynesia',
        code: 'PF',
        phone_code: '+689'
      }, {
        name: 'Gabon',
        code: 'GA',
        phone_code: '+241'
      }, {
        name: 'Georgia',
        code: 'GE',
        phone_code: '+995'
      }, {
        name: 'Germany',
        code: 'DE',
        phone_code: '+49'
      }, {
        name: 'Ghana',
        code: 'GH',
        phone_code: '+233'
      }, {
        name: 'Gibraltar',
        code: 'GI',
        phone_code: '+350'
      }, {
        name: 'Greece',
        code: 'GR',
        phone_code: '+30'
      }, {
        name: 'Greenland',
        code: 'GL',
        phone_code: '+299'
      }, {
        name: 'Grenada',
        code: 'GD',
        phone_code: '+1'
      }, {
        name: 'Guadeloupe',
        code: 'GP',
        phone_code: '+590'
      }, {
        name: 'Guam',
        code: 'GU',
        phone_code: '+1'
      }, {
        name: 'Guatemala',
        code: 'GT',
        phone_code: '+502'
      }, {
        name: 'Guinea',
        code: 'GN',
        phone_code: '+224'
      }, {
        name: 'Guinea-Bissau',
        code: 'GW',
        phone_code: '+245'
      }, {
        name: 'Guyana',
        code: 'GY',
        phone_code: '+592'
      }, {
        name: 'Haiti',
        code: 'HT',
        phone_code: '+509'
      }, {
        name: 'Honduras',
        code: 'HN',
        phone_code: '+504'
      }, {
        name: 'Hong Kong',
        code: 'HK',
        phone_code: '+852'
      }, {
        name: 'Hungary',
        code: 'HU',
        phone_code: '+36'
      }, {
        name: 'Iceland',
        code: 'IS',
        phone_code: '+354'
      }, {
        name: 'India',
        code: 'IN',
        phone_code: '+91'
      }, {
        name: 'Indonesia',
        code: 'ID',
        phone_code: '+62'
      }, {
        name: 'Iran',
        code: 'IR',
        phone_code: '+98'
      }, {
        name: 'Iraq',
        code: 'IQ',
        phone_code: '+964'
      }, {
        name: 'Ireland',
        code: 'IE',
        phone_code: '+353'
      }, {
        name: 'Israel',
        code: 'IL',
        phone_code: '+972'
      }, {
        name: 'Italy',
        code: 'IT',
        phone_code: '+39'
      }, {
        name: 'Jamaica',
        code: 'JM',
        phone_code: '+1'
      }, {
        name: 'Japan',
        code: 'JP',
        phone_code: '+81'
      }, {
        name: 'Jordan',
        code: 'JO',
        phone_code: '+962'
      }, {
        name: 'Kazakhstan',
        code: 'KZ',
        phone_code: '+7'
      }, {
        name: 'Kenya',
        code: 'KE',
        phone_code: '+254'
      }, {
        name: 'Kiribati',
        code: 'KI',
        phone_code: '+686'
      }, {
        name: 'Kosovo',
        code: 'XK',
        phone_code: '+383'
      }, {
        name: 'Kuwait',
        code: 'KW',
        phone_code: '+965'
      }, {
        name: 'Kyrgyzstan',
        code: 'KG',
        phone_code: '+996'
      }, {
        name: 'Laos',
        code: 'LA',
        phone_code: '+856'
      }, {
        name: 'Latvia',
        code: 'LV',
        phone_code: '+371'
      }, {
        name: 'Lebanon',
        code: 'LB',
        phone_code: '+961'
      }, {
        name: 'Lesotho',
        code: 'LS',
        phone_code: '+266'
      }, {
        name: 'Liberia',
        code: 'LR',
        phone_code: '+231'
      }, {
        name: 'Libya',
        code: 'LY',
        phone_code: '+218'
      }, {
        name: 'Liechtenstein',
        code: 'LI',
        phone_code: '+423'
      }, {
        name: 'Lithuania',
        code: 'LT',
        phone_code: '+370'
      }, {
        name: 'Luxembourg',
        code: 'LU',
        phone_code: '+352'
      }, {
        name: 'Macau',
        code: 'MO',
        phone_code: '+853'
      }, {
        name: 'Macedonia',
        code: 'MK',
        phone_code: '+389'
      }, {
        name: 'Madagascar',
        code: 'MG',
        phone_code: '+261'
      }, {
        name: 'Malawi',
        code: 'MW',
        phone_code: '+265'
      }, {
        name: 'Malaysia',
        code: 'MY',
        phone_code: '+60'
      }, {
        name: 'Maldives',
        code: 'MV',
        phone_code: '+960'
      }, {
        name: 'Mali',
        code: 'ML',
        phone_code: '+223'
      }, {
        name: 'Malta',
        code: 'MT',
        phone_code: '+356'
      }, {
        name: 'Marshall Islands',
        code: 'MH',
        phone_code: '+692'
      }, {
        name: 'Martinique',
        code: 'MQ',
        phone_code: '+596'
      }, {
        name: 'Mauritania',
        code: 'MR',
        phone_code: '+222'
      }, {
        name: 'Mauritius',
        code: 'MU',
        phone_code: '+230'
      }, {
        name: 'Mayotte',
        code: 'YT',
        phone_code: '+262'
      }, {
        name: 'Mexico',
        code: 'MX',
        phone_code: '+52'
      }, {
        name: 'Moldova',
        code: 'MD',
        phone_code: '+373'
      }, {
        name: 'Monaco',
        code: 'MC',
        phone_code: '+377'
      }, {
        name: 'Mongolia',
        code: 'MN',
        phone_code: '+976'
      }, {
        name: 'Montenegro',
        code: 'ME',
        phone_code: '+382'
      }, {
        name: 'Montserrat',
        code: 'MS',
        phone_code: '+1'
      }, {
        name: 'Morocco',
        code: 'MA',
        phone_code: '+212'
      }, {
        name: 'Mozambique',
        code: 'MZ',
        phone_code: '+258'
      }, {
        name: 'Namibia',
        code: 'NA',
        phone_code: '+264'
      }, {
        name: 'Nauru',
        code: 'NR',
        phone_code: '+674'
      }, {
        name: 'Nepal',
        code: 'NP',
        phone_code: '+977'
      }, {
        name: 'Netherlands',
        code: 'NL',
        phone_code: '+31'
      }, {
        name: 'Netherlands Antilles',
        code: 'AN',
        phone_code: '+599'
      }, {
        name: 'New Caledonia',
        code: 'NC',
        phone_code: '+687'
      }, {
        name: 'New Zealand',
        code: 'NZ',
        phone_code: '+64'
      }, {
        name: 'Nicaragua',
        code: 'NI',
        phone_code: '+505'
      }, {
        name: 'Niger',
        code: 'NE',
        phone_code: '+227'
      }, {
        name: 'Nigeria',
        code: 'NG',
        phone_code: '+234'
      }, {
        name: 'Niue',
        code: 'NU',
        phone_code: '+683'
      }, {
        name: 'Norfolk Island',
        code: 'NF',
        phone_code: '+672'
      }, {
        name: 'North Korea',
        code: 'KP',
        phone_code: '+850'
      }, {
        name: 'Northern Mariana Islands',
        code: 'MP',
        phone_code: '+1'
      }, {
        name: 'Norway',
        code: 'NO',
        phone_code: '+47'
      }, {
        name: 'Oman',
        code: 'OM',
        phone_code: '+968'
      }, {
        name: 'Pakistan',
        code: 'PK',
        phone_code: '+92'
      }, {
        name: 'Palau',
        code: 'PW',
        phone_code: '+680'
      }, {
        name: 'Palestine',
        code: 'PS',
        phone_code: '+970'
      }, {
        name: 'Panama',
        code: 'PA',
        phone_code: '+507'
      }, {
        name: 'Papua New Guinea',
        code: 'PG',
        phone_code: '+675'
      }, {
        name: 'Paraguay',
        code: 'PY',
        phone_code: '+595'
      }, {
        name: 'Peru',
        code: 'PE',
        phone_code: '+51'
      }, {
        name: 'Philippines',
        code: 'PH',
        phone_code: '+63'
      }, {
        name: 'Poland',
        code: 'PL',
        phone_code: '+48'
      }, {
        name: 'Portugal',
        code: 'PT',
        phone_code: '+351'
      }, {
        name: 'Puerto Rico',
        code: 'PR',
        phone_code: '+1'
      }, {
        name: 'Qatar',
        code: 'QA',
        phone_code: '+974'
      }, {
        name: 'Republic of the Congo',
        code: 'CG',
        phone_code: '+242'
      }, {
        name: 'Réunion',
        code: 'RE',
        phone_code: '+262'
      }, {
        name: 'Romania',
        code: 'RO',
        phone_code: '+40'
      }, {
        name: 'Russia',
        code: 'RU',
        phone_code: '+7'
      }, {
        name: 'Rwanda',
        code: 'RW',
        phone_code: '+250'
      }, {
        name: 'Saint Barthélemy',
        code: 'BL',
        phone_code: '+590'
      }, {
        name: 'Saint Helena',
        code: 'SH',
        phone_code: '+290'
      }, {
        name: 'Saint Kitts and Nevis',
        code: 'KN',
        phone_code: '+1'
      }, {
        name: 'Saint Martin',
        code: 'MF',
        phone_code: '+590'
      }, {
        name: 'Saint Pierre and Miquelon',
        code: 'PM',
        phone_code: '+508'
      }, {
        name: 'Saint Vincent and the Grenadines',
        code: 'VC',
        phone_code: '+1'
      }, {
        name: 'Samoa',
        code: 'WS',
        phone_code: '+685'
      }, {
        name: 'San Marino',
        code: 'SM',
        phone_code: '+378'
      }, {
        name: 'São Tomé and Príncipe',
        code: 'ST',
        phone_code: '+239'
      }, {
        name: 'Saudi Arabia',
        code: 'SA',
        phone_code: '+966'
      }, {
        name: 'Senegal',
        code: 'SN',
        phone_code: '+221'
      }, {
        name: 'Serbia',
        code: 'RS',
        phone_code: '+381'
      }, {
        name: 'Seychelles',
        code: 'SC',
        phone_code: '+248'
      }, {
        name: 'Sierra Leone',
        code: 'SL',
        phone_code: '+232'
      }, {
        name: 'Singapore',
        code: 'SG',
        phone_code: '+65'
      }, {
        name: 'Slovakia',
        code: 'SK',
        phone_code: '+421'
      }, {
        name: 'Slovenia',
        code: 'SI',
        phone_code: '+386'
      }, {
        name: 'Solomon Islands',
        code: 'SB',
        phone_code: '+677'
      }, {
        name: 'Somalia',
        code: 'SO',
        phone_code: '+252'
      }, {
        code: 'SS',
        name: 'South Sudan',
        phone_code: '+211'
      }, {
        name: 'South Africa',
        code: 'ZA',
        phone_code: '+27'
      }, {
        name: 'South Korea',
        code: 'KR',
        phone_code: '+82'
      }, {
        name: 'Spain',
        code: 'ES',
        phone_code: '+34'
      }, {
        name: 'Sri Lanka',
        code: 'LK',
        phone_code: '+94'
      }, {
        name: 'St. Lucia',
        code: 'LC',
        phone_code: '+1'
      }, {
        name: 'Sudan',
        code: 'SD',
        phone_code: '+249'
      }, {
        name: 'Suriname',
        code: 'SR',
        phone_code: '+597'
      }, {
        name: 'Swaziland',
        code: 'SZ',
        phone_code: '+268'
      }, {
        name: 'Sweden',
        code: 'SE',
        phone_code: '+46'
      }, {
        name: 'Switzerland',
        code: 'CH',
        phone_code: '+41'
      }, {
        code: 'SX',
        name: 'Sint Maarten (Dutch part)',
        phone_code: '+1'
      }, {
        name: 'Syria',
        code: 'SY',
        phone_code: '+963'
      }, {
        name: 'Taiwan',
        code: 'TW',
        phone_code: '+886'
      }, {
        name: 'Tajikistan',
        code: 'TJ',
        phone_code: '+992'
      }, {
        name: 'Tanzania',
        code: 'TZ',
        phone_code: '+255'
      }, {
        name: 'Thailand',
        code: 'TH',
        phone_code: '+66'
      }, {
        name: 'The Bahamas',
        code: 'BS',
        phone_code: '+1'
      }, {
        name: 'The Gambia',
        code: 'GM',
        phone_code: '+220'
      }, {
        name: 'Timor-Leste',
        code: 'TL',
        phone_code: '+670'
      }, {
        name: 'Togo',
        code: 'TG',
        phone_code: '+228'
      }, {
        name: 'Tokelau',
        code: 'TK',
        phone_code: '+690'
      }, {
        name: 'Tonga',
        code: 'TO',
        phone_code: '+676'
      }, {
        name: 'Trinidad and Tobago',
        code: 'TT',
        phone_code: '+1'
      }, {
        name: 'Tunisia',
        code: 'TN',
        phone_code: '+216'
      }, {
        name: 'Turkey',
        code: 'TR',
        phone_code: '+90'
      }, {
        name: 'Turkmenistan',
        code: 'TM',
        phone_code: '+993'
      }, {
        name: 'Turks and Caicos Islands',
        code: 'TC',
        phone_code: '+1'
      }, {
        name: 'Tuvalu',
        code: 'TV',
        phone_code: '+688'
      }, {
        name: 'Uganda',
        code: 'UG',
        phone_code: '+256'
      }, {
        name: 'Ukraine',
        code: 'UA',
        phone_code: '+380'
      }, {
        name: 'United Arab Emirates',
        code: 'AE',
        phone_code: '+971'
      }, {
        name: 'United Kingdom',
        code: 'GB',
        phone_code: '+44'
      }, {
        name: 'Uruguay',
        code: 'UY',
        phone_code: '+598'
      }, {
        name: 'US Virgin Islands',
        code: 'VI',
        phone_code: '+1'
      }, {
        name: 'Uzbekistan',
        code: 'UZ',
        phone_code: '+998'
      }, {
        name: 'Vanuatu',
        code: 'VU',
        phone_code: '+678'
      }, {
        name: 'Vatican City',
        code: 'VA',
        phone_code: '+39'
      }, {
        name: 'Venezuela',
        code: 'VE',
        phone_code: '+58'
      }, {
        name: 'Vietnam',
        code: 'VN',
        phone_code: '+84'
      }, {
        name: 'Wallis and Futuna',
        code: 'WF',
        phone_code: '+681'
      }, {
        name: 'Yemen',
        code: 'YE',
        phone_code: '+967'
      }, {
        name: 'Zambia',
        code: 'ZM',
        phone_code: '+260'
      }, {
        name: 'Zimbabwe',
        code: 'ZW',
        phone_code: '+263'
      }];
    }

    /**
     * State data list
     * @returns [Object]
     * Referenced form https://github.com/commerceguys/addressing/tree/master/resources/subdivision
     * and https://github.com/SB250173/ecom-21_2018/tree/master/modules/modules/ubercart/uc_country/config/install
     */
  }, {
    key: "getStatesOptions",
    value: function getStatesOptions(country) {
      switch (country) {
        case 'US':
          return [{
            code: 'AL',
            name: 'Alabama'
          }, {
            code: 'AK',
            name: 'Alaska'
          }, {
            code: 'AZ',
            name: 'Arizona'
          }, {
            code: 'AR',
            name: 'Arkansas'
          }, {
            code: 'CA',
            name: 'California'
          }, {
            code: 'CO',
            name: 'Colorado'
          }, {
            code: 'CT',
            name: 'Connecticut'
          }, {
            code: 'DC',
            name: 'District of Columbia'
          }, {
            code: 'DE',
            name: 'Delaware'
          }, {
            code: 'FL',
            name: 'Florida'
          }, {
            code: 'GA',
            name: 'Georgia'
          }, {
            code: 'HI',
            name: 'Hawaii'
          }, {
            code: 'ID',
            name: 'Idaho'
          }, {
            code: 'IL',
            name: 'Illinois'
          }, {
            code: 'IN',
            name: 'Indiana'
          }, {
            code: 'IA',
            name: 'Iowa'
          }, {
            code: 'KS',
            name: 'Kansas'
          }, {
            code: 'KY',
            name: 'Kentucky'
          }, {
            code: 'LA',
            name: 'Louisiana'
          }, {
            code: 'ME',
            name: 'Maine'
          }, {
            code: 'MD',
            name: 'Maryland'
          }, {
            code: 'MA',
            name: 'Massachusetts'
          }, {
            code: 'MI',
            name: 'Michigan'
          }, {
            code: 'MN',
            name: 'Minnesota'
          }, {
            code: 'MS',
            name: 'Mississippi'
          }, {
            code: 'MO',
            name: 'Missouri'
          }, {
            code: 'MT',
            name: 'Montana'
          }, {
            code: 'NE',
            name: 'Nebraska'
          }, {
            code: 'NV',
            name: 'Nevada'
          }, {
            code: 'NH',
            name: 'New Hampshire'
          }, {
            code: 'NJ',
            name: 'New Jersey'
          }, {
            code: 'NM',
            name: 'New Mexico'
          }, {
            code: 'NY',
            name: 'New York'
          }, {
            code: 'NC',
            name: 'North Carolina'
          }, {
            code: 'ND',
            name: 'North Dakota'
          }, {
            code: 'OH',
            name: 'Ohio'
          }, {
            code: 'OK',
            name: 'Oklahoma'
          }, {
            code: 'OR',
            name: 'Oregon'
          }, {
            code: 'PA',
            name: 'Pennsylvania'
          }, {
            code: 'RI',
            name: 'Rhode Island'
          }, {
            code: 'SC',
            name: 'South Carolina'
          }, {
            code: 'SD',
            name: 'South Dakota'
          }, {
            code: 'TN',
            name: 'Tennessee'
          }, {
            code: 'TX',
            name: 'Texas'
          }, {
            code: 'UT',
            name: 'Utah'
          }, {
            code: 'VT',
            name: 'Vermont'
          }, {
            code: 'VA',
            name: 'Virginia'
          }, {
            code: 'WA',
            name: 'Washington'
          }, {
            code: 'WV',
            name: 'West Virginia'
          }, {
            code: 'WI',
            name: 'Wisconsin'
          }, {
            code: 'WY',
            name: 'Wyoming'
          }];
        case 'CA':
          return [{
            code: 'AB',
            name: 'Alberta'
          }, {
            code: 'BC',
            name: 'British Columbia'
          }, {
            code: 'LB',
            name: 'Labrador'
          }, {
            code: 'MB',
            name: 'Manitoba'
          }, {
            code: 'NB',
            name: 'New Brunswick'
          }, {
            code: 'NF',
            name: 'Newfoundland'
          }, {
            code: 'NS',
            name: 'Nova Scotia'
          }, {
            code: 'NU',
            name: 'Nunavut'
          }, {
            code: 'NW',
            name: 'Northwest Territories'
          }, {
            code: 'ON',
            name: 'Ontario'
          }, {
            code: 'PE',
            name: 'Prince Edward Island'
          }, {
            code: 'QC',
            name: 'Quebec'
          }, {
            code: 'SK',
            name: 'Saskatchewen'
          }, {
            code: 'YU',
            name: 'Yukon'
          }];
        case 'AF':
          return [{
            code: 'BADAKHSHAN',
            name: 'Badakhshan'
          }, {
            code: 'BADGHIS',
            name: 'Badghis'
          }, {
            code: 'BAGHLAN',
            name: 'Baghlan'
          }, {
            code: 'BALKH',
            name: 'Balkh'
          }, {
            code: 'BAMIAN',
            name: 'Bamian'
          }, {
            code: 'FARAH',
            name: 'Farah'
          }, {
            code: 'FARYAB',
            name: 'Faryab'
          }, {
            code: 'GHAZNI',
            name: 'Ghazni'
          }, {
            code: 'GHOWR',
            name: 'Ghowr'
          }, {
            code: 'HELMAND',
            name: 'Helmand'
          }, {
            code: 'HERAT',
            name: 'Herat'
          }, {
            code: 'JOWZJAN',
            name: 'Jowzjan'
          }, {
            code: 'KABOL',
            name: 'Kabol'
          }, {
            code: 'KANDAHAR',
            name: 'Kandahar'
          }, {
            code: 'KAPISA',
            name: 'Kapisa'
          }, {
            code: 'KONAR',
            name: 'Konar'
          }, {
            code: 'KONDOZ',
            name: 'Kondoz'
          }, {
            code: 'LAGHMAN',
            name: 'Laghman'
          }, {
            code: 'LOWGAR',
            name: 'Lowgar'
          }, {
            code: 'NANGARHAR',
            name: 'Nangarhar'
          }, {
            code: 'NIMRUZ',
            name: 'Nimruz'
          }, {
            code: 'ORUZGAN',
            name: 'Oruzgan'
          }, {
            code: 'PAKTIA',
            name: 'Paktia'
          }, {
            code: 'PAKTIKA',
            name: 'Paktika'
          }, {
            code: 'PARVAN',
            name: 'Parvan'
          }, {
            code: 'SAMANGAN',
            name: 'Samangan'
          }, {
            code: 'SAR-E POL',
            name: 'Sar-e Pol'
          }, {
            code: 'TAKHAR',
            name: 'Takhar'
          }, {
            code: 'VARDAK',
            name: 'Vardak'
          }, {
            code: 'ZABOL',
            name: 'Zabol'
          }];
        case 'AL':
          return [{
            code: 'BERAT',
            name: 'Berat'
          }, {
            code: 'BULQIZE',
            name: 'Bulqize'
          }, {
            code: 'DELVINE',
            name: 'Delvine'
          }, {
            code: 'DEVOLL (BILISHT)',
            name: 'Devoll (Bilisht)'
          }, {
            code: 'DIBER (PESHKOPI)',
            name: 'Diber (Peshkopi)'
          }, {
            code: 'DURRES',
            name: 'Durres'
          }, {
            code: 'ELBASAN',
            name: 'Elbasan'
          }, {
            code: 'FIER',
            name: 'Fier'
          }, {
            code: 'GJIROKASTER',
            name: 'Gjirokaster'
          }, {
            code: 'GRAMSH',
            name: 'Gramsh'
          }, {
            code: 'HAS (KRUME)',
            name: 'Has (Krume)'
          }, {
            code: 'KAVAJE',
            name: 'Kavaje'
          }, {
            code: 'KOLONJE (ERSEKE)',
            name: 'Kolonje (Erseke)'
          }, {
            code: 'KORCE',
            name: 'Korce'
          }, {
            code: 'KRUJE',
            name: 'Kruje'
          }, {
            code: 'KUCOVE',
            name: 'Kucove'
          }, {
            code: 'KUKES',
            name: 'Kukes'
          }, {
            code: 'KURBIN',
            name: 'Kurbin'
          }, {
            code: 'LEZHE',
            name: 'Lezhe'
          }, {
            code: 'LIBRAZHD',
            name: 'Librazhd'
          }, {
            code: 'LUSHNJE',
            name: 'Lushnje'
          }, {
            code: 'MALESI E MADHE (KOPLIK)',
            name: 'Malesi e Madhe (Koplik)'
          }, {
            code: 'MALLAKASTER (BALLSH)',
            name: 'Mallakaster (Ballsh)'
          }, {
            code: 'MAT (BURREL)',
            name: 'Mat (Burrel)'
          }, {
            code: 'MIRDITE (RRESHEN)',
            name: 'Mirdite (Rreshen)'
          }, {
            code: 'PEQIN',
            name: 'Peqin'
          }, {
            code: 'PERMET',
            name: 'Permet'
          }, {
            code: 'POGRADEC',
            name: 'Pogradec'
          }, {
            code: 'PUKE',
            name: 'Puke'
          }, {
            code: 'SARANDE',
            name: 'Sarande'
          }, {
            code: 'SHKODER',
            name: 'Shkoder'
          }, {
            code: 'SKRAPAR (COROVODE)',
            name: 'Skrapar (Corovode)'
          }, {
            code: 'TEPELENE',
            name: 'Tepelene'
          }, {
            code: 'TIRANE (TIRANA)',
            name: 'Tirane (Tirana)'
          }, {
            code: 'TIRANE (TIRANA)',
            name: 'Tirane (Tirana)'
          }, {
            code: 'TROPOJE (BAJRAM CURRI)',
            name: 'Tropoje (Bajram Curri)'
          }, {
            code: 'VLORE',
            name: 'Vlore'
          }];
        case 'DZ':
          return [{
            code: 'ADRAR',
            name: 'Adrar'
          }, {
            code: 'AIN DEFLA',
            name: 'Ain Defla'
          }, {
            code: 'AIN TEMOUCHENT',
            name: 'Ain Temouchent'
          }, {
            code: 'ALGER',
            name: 'Alger'
          }, {
            code: 'ANNABA',
            name: 'Annaba'
          }, {
            code: 'BATNA',
            name: 'Batna'
          }, {
            code: 'BECHAR',
            name: 'Bechar'
          }, {
            code: 'BEJAIA',
            name: 'Bejaia'
          }, {
            code: 'BISKRA',
            name: 'Biskra'
          }, {
            code: 'BLIDA',
            name: 'Blida'
          }, {
            code: 'BORDJ BOU ARRERIDJ',
            name: 'Bordj Bou Arreridj'
          }, {
            code: 'BOUIRA',
            name: 'Bouira'
          }, {
            code: 'BOUMERDES',
            name: 'Boumerdes'
          }, {
            code: 'CHLEF',
            name: 'Chlef'
          }, {
            code: 'CONSTANTINE',
            name: 'Constantine'
          }, {
            code: 'DJELFA',
            name: 'Djelfa'
          }, {
            code: 'EL BAYADH',
            name: 'El Bayadh'
          }, {
            code: 'EL OUED',
            name: 'El Oued'
          }, {
            code: 'EL TARF',
            name: 'El Tarf'
          }, {
            code: 'GHARDAIA',
            name: 'Ghardaia'
          }, {
            code: 'GUELMA',
            name: 'Guelma'
          }, {
            code: 'ILLIZI',
            name: 'Illizi'
          }, {
            code: 'JIJEL',
            name: 'Jijel'
          }, {
            code: 'KHENCHELA',
            name: 'Khenchela'
          }, {
            code: 'LAGHOUAT',
            name: 'Laghouat'
          }, {
            code: 'MSILA',
            name: 'MSila'
          }, {
            code: 'MASCARA',
            name: 'Mascara'
          }, {
            code: 'MEDEA',
            name: 'Medea'
          }, {
            code: 'MILA',
            name: 'Mila'
          }, {
            code: 'MOSTAGANEM',
            name: 'Mostaganem'
          }, {
            code: 'NAAMA',
            name: 'Naama'
          }, {
            code: 'ORAN',
            name: 'Oran'
          }, {
            code: 'OUARGLA',
            name: 'Ouargla'
          }, {
            code: 'OUM EL BOUAGHI',
            name: 'Oum el Bouaghi'
          }, {
            code: 'RELIZANE',
            name: 'Relizane'
          }, {
            code: 'SAIDA',
            name: 'Saida'
          }, {
            code: 'SETIF',
            name: 'Setif'
          }, {
            code: 'SIDI BEL ABBES',
            name: 'Sidi Bel Abbes'
          }, {
            code: 'SKIKDA',
            name: 'Skikda'
          }, {
            code: 'SOUK AHRAS',
            name: 'Souk Ahras'
          }, {
            code: 'TAMANGHASSET',
            name: 'Tamanghasset'
          }, {
            code: 'TEBESSA',
            name: 'Tebessa'
          }, {
            code: 'TIARET',
            name: 'Tiaret'
          }, {
            code: 'TINDOUF',
            name: 'Tindouf'
          }, {
            code: 'TIPAZA',
            name: 'Tipaza'
          }, {
            code: 'TISSEMSILT',
            name: 'Tissemsilt'
          }, {
            code: 'TIZI OUZOU',
            name: 'Tizi Ouzou'
          }, {
            code: 'TLEMCEN',
            name: 'Tlemcen'
          }];
        case 'AS':
          return [{
            code: 'EASTERN',
            name: 'Eastern'
          }, {
            code: 'MANUA',
            name: 'Manua'
          }, {
            code: 'ROSE ISLAND',
            name: 'Rose Island'
          }, {
            code: 'SWAINS ISLAND',
            name: 'Swains Island'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'AO':
          return [{
            code: 'ANDORRA LA VELLA',
            name: 'Andorra la Vella'
          }, {
            code: 'BENGO',
            name: 'Bengo'
          }, {
            code: 'BENGUELA',
            name: 'Benguela'
          }, {
            code: 'BIE',
            name: 'Bie'
          }, {
            code: 'CABINDA',
            name: 'Cabinda'
          }, {
            code: 'CANILLO',
            name: 'Canillo'
          }, {
            code: 'CUANDO CUBANGO',
            name: 'Cuando Cubango'
          }, {
            code: 'CUANZA NORTE',
            name: 'Cuanza Norte'
          }, {
            code: 'CUANZA SUL',
            name: 'Cuanza Sul'
          }, {
            code: 'CUNENE',
            name: 'Cunene'
          }, {
            code: 'ENCAMP',
            name: 'Encamp'
          }, {
            code: 'ESCALDES-ENGORDANY',
            name: 'Escaldes-Engordany'
          }, {
            code: 'HUAMBO',
            name: 'Huambo'
          }, {
            code: 'HUILA',
            name: 'Huila'
          }, {
            code: 'LA MASSANA',
            name: 'La Massana'
          }, {
            code: 'LUANDA',
            name: 'Luanda'
          }, {
            code: 'LUNDA NORTE',
            name: 'Lunda Norte'
          }, {
            code: 'LUNDA SUL',
            name: 'Lunda Sul'
          }, {
            code: 'MALANJE',
            name: 'Malanje'
          }, {
            code: 'MOXICO',
            name: 'Moxico'
          }, {
            code: 'NAMIBE',
            name: 'Namibe'
          }, {
            code: 'ORDINO',
            name: 'Ordino'
          }, {
            code: 'SANT JULIA DE LORIA',
            name: 'Sant Julia de Loria'
          }, {
            code: 'UIGE',
            name: 'Uige'
          }, {
            code: 'ZAIRE',
            name: 'Zaire'
          }];
        case 'AR':
          return [{
            code: 'ANTARTICA E ISLAS DEL ATLANTICO SUR',
            name: 'Antartica e Islas del Atlantico Sur'
          }, {
            code: 'BUENOS AIRES',
            name: 'Buenos Aires'
          }, {
            code: 'BUENOS AIRES CAPITAL FEDERAL',
            name: 'Buenos Aires Capital Federal'
          }, {
            code: 'CATAMARCA',
            name: 'Catamarca'
          }, {
            code: 'CHACO',
            name: 'Chaco'
          }, {
            code: 'CHUBUT',
            name: 'Chubut'
          }, {
            code: 'CORDOBA',
            name: 'Cordoba'
          }, {
            code: 'CORRIENTES',
            name: 'Corrientes'
          }, {
            code: 'ENTRE RIOS',
            name: 'Entre Rios'
          }, {
            code: 'FORMOSA',
            name: 'Formosa'
          }, {
            code: 'JUJUY',
            name: 'Jujuy'
          }, {
            code: 'LA PAMPA',
            name: 'La Pampa'
          }, {
            code: 'LA RIOJA',
            name: 'La Rioja'
          }, {
            code: 'MENDOZA',
            name: 'Mendoza'
          }, {
            code: 'MISIONES',
            name: 'Misiones'
          }, {
            code: 'NEUQUEN',
            name: 'Neuquen'
          }, {
            code: 'RIO NEGRO',
            name: 'Rio Negro'
          }, {
            code: 'SALTA',
            name: 'Salta'
          }, {
            code: 'SAN JUAN',
            name: 'San Juan'
          }, {
            code: 'SAN LUIS',
            name: 'San Luis'
          }, {
            code: 'SANTA CRUZ',
            name: 'Santa Cruz'
          }, {
            code: 'SANTA FE',
            name: 'Santa Fe'
          }, {
            code: 'SANTIAGO DEL ESTERO',
            name: 'Santiago del Estero'
          }, {
            code: 'TIERRA DEL FUEGO',
            name: 'Tierra del Fuego'
          }, {
            code: 'TUCUMAN',
            name: 'Tucuman'
          }];
        case 'AM':
          return [{
            code: 'ARAGATSOTN',
            name: 'Aragatsotn'
          }, {
            code: 'ARARAT',
            name: 'Ararat'
          }, {
            code: 'ARMAVIR',
            name: 'Armavir'
          }, {
            code: 'GEGHARKUNIK',
            name: 'Gegharkunik'
          }, {
            code: 'KOTAYK',
            name: 'Kotayk'
          }, {
            code: 'LORRI',
            name: 'Lorri'
          }, {
            code: 'SHIRAK',
            name: 'Shirak'
          }, {
            code: 'SYUNIK',
            name: 'Syunik'
          }, {
            code: 'TAVUSH',
            name: 'Tavush'
          }, {
            code: 'VAYOTS DZOR',
            name: 'Vayots Dzor'
          }, {
            code: 'YEREVAN',
            name: 'Yerevan'
          }];
        case 'AW':
          return [{
            code: 'ARUBA',
            name: 'Aruba'
          }];
        case 'AU':
          return [{
            code: 'AUSTRALIAN CAPITAL TERRITORY',
            name: 'Australian Capital Territory'
          }, {
            code: 'NEW SOUTH WALES',
            name: 'New South Wales'
          }, {
            code: 'NORTHERN TERRITORY',
            name: 'Northern Territory'
          }, {
            code: 'QUEENSLAND',
            name: 'Queensland'
          }, {
            code: 'SOUTH AUSTRALIA',
            name: 'South Australia'
          }, {
            code: 'TASMANIA',
            name: 'Tasmania'
          }, {
            code: 'VICTORIA',
            name: 'Victoria'
          }, {
            code: 'WESTERN AUSTRALIA',
            name: 'Western Australia'
          }];
        case 'AT':
          return [{
            code: 'BURGENLAND',
            name: 'Burgenland'
          }, {
            code: 'KAERNTEN',
            name: 'Kaernten'
          }, {
            code: 'NIEDEROESTERREICH',
            name: 'Niederoesterreich'
          }, {
            code: 'OBEROESTERREICH',
            name: 'Oberoesterreich'
          }, {
            code: 'SALZBURG',
            name: 'Salzburg'
          }, {
            code: 'STEIERMARK',
            name: 'Steiermark'
          }, {
            code: 'TIROL',
            name: 'Tirol'
          }, {
            code: 'VORARLBERG',
            name: 'Vorarlberg'
          }, {
            code: 'WIEN',
            name: 'Wien'
          }];
        case 'AZ':
          return [{
            code: 'ABSERON RAYONU',
            name: 'Abseron Rayonu'
          }, {
            code: 'AGCABADI RAYONU',
            name: 'Agcabadi Rayonu'
          }, {
            code: 'AGDAM RAYONU',
            name: 'Agdam Rayonu'
          }, {
            code: 'AGDAS RAYONU',
            name: 'Agdas Rayonu'
          }, {
            code: 'AGSTAFA RAYONU',
            name: 'Agstafa Rayonu'
          }, {
            code: 'AGSU RAYONU',
            name: 'Agsu Rayonu'
          }, {
            code: 'ALI BAYRAMLI SAHARI',
            name: 'Ali Bayramli Sahari'
          }, {
            code: 'ASTARA RAYONU',
            name: 'Astara Rayonu'
          }, {
            code: 'BAKI SAHARI',
            name: 'Baki Sahari'
          }, {
            code: 'BALAKAN RAYONU',
            name: 'Balakan Rayonu'
          }, {
            code: 'BARDA RAYONU',
            name: 'Barda Rayonu'
          }, {
            code: 'BEYLAQAN RAYONU',
            name: 'Beylaqan Rayonu'
          }, {
            code: 'BILASUVAR RAYONU',
            name: 'Bilasuvar Rayonu'
          }, {
            code: 'CABRAYIL RAYONU',
            name: 'Cabrayil Rayonu'
          }, {
            code: 'CALILABAD RAYONU',
            name: 'Calilabad Rayonu'
          }, {
            code: 'DASKASAN RAYONU',
            name: 'Daskasan Rayonu'
          }, {
            code: 'DAVACI RAYONU',
            name: 'Davaci Rayonu'
          }, {
            code: 'FUZULI RAYONU',
            name: 'Fuzuli Rayonu'
          }, {
            code: 'GADABAY RAYONU',
            name: 'Gadabay Rayonu'
          }, {
            code: 'GANCA SAHARI',
            name: 'Ganca Sahari'
          }, {
            code: 'GORANBOY RAYONU',
            name: 'Goranboy Rayonu'
          }, {
            code: 'GOYCAY RAYONU',
            name: 'Goycay Rayonu'
          }, {
            code: 'HACIQABUL RAYONU',
            name: 'Haciqabul Rayonu'
          }, {
            code: 'IMISLI RAYONU',
            name: 'Imisli Rayonu'
          }, {
            code: 'ISMAYILLI RAYONU',
            name: 'Ismayilli Rayonu'
          }, {
            code: 'KALBACAR RAYONU',
            name: 'Kalbacar Rayonu'
          }, {
            code: 'KURDAMIR RAYONU',
            name: 'Kurdamir Rayonu'
          }, {
            code: 'LACIN RAYONU',
            name: 'Lacin Rayonu'
          }, {
            code: 'LANKARAN RAYONU',
            name: 'Lankaran Rayonu'
          }, {
            code: 'LANKARAN SAHARI',
            name: 'Lankaran Sahari'
          }, {
            code: 'LERIK RAYONU',
            name: 'Lerik Rayonu'
          }, {
            code: 'MASALLI RAYONU',
            name: 'Masalli Rayonu'
          }, {
            code: 'MINGACEVIR SAHARI',
            name: 'Mingacevir Sahari'
          }, {
            code: 'NAFTALAN SAHARI',
            name: 'Naftalan Sahari'
          }, {
            code: 'NAXCIVAN MUXTAR RESPUBLIKASI',
            name: 'Naxcivan Muxtar Respublikasi'
          }, {
            code: 'NEFTCALA RAYONU',
            name: 'Neftcala Rayonu'
          }, {
            code: 'OGUZ RAYONU',
            name: 'Oguz Rayonu'
          }, {
            code: 'QABALA RAYONU',
            name: 'Qabala Rayonu'
          }, {
            code: 'QAX RAYONU',
            name: 'Qax Rayonu'
          }, {
            code: 'QAZAX RAYONU',
            name: 'Qazax Rayonu'
          }, {
            code: 'QOBUSTAN RAYONU',
            name: 'Qobustan Rayonu'
          }, {
            code: 'QUBA RAYONU',
            name: 'Quba Rayonu'
          }, {
            code: 'QUBADLI RAYONU',
            name: 'Qubadli Rayonu'
          }, {
            code: 'QUSAR RAYONU',
            name: 'Qusar Rayonu'
          }, {
            code: 'SAATLI RAYONU',
            name: 'Saatli Rayonu'
          }, {
            code: 'SABIRABAD RAYONU',
            name: 'Sabirabad Rayonu'
          }, {
            code: 'SAKI RAYONU',
            name: 'Saki Rayonu'
          }, {
            code: 'SAKI SAHARI',
            name: 'Saki Sahari'
          }, {
            code: 'SALYAN RAYONU',
            name: 'Salyan Rayonu'
          }, {
            code: 'SAMAXI RAYONU',
            name: 'Samaxi Rayonu'
          }, {
            code: 'SAMKIR RAYONU',
            name: 'Samkir Rayonu'
          }, {
            code: 'SAMUX RAYONU',
            name: 'Samux Rayonu'
          }, {
            code: 'SIYAZAN RAYONU',
            name: 'Siyazan Rayonu'
          }, {
            code: 'SUMQAYIT SAHARI',
            name: 'Sumqayit Sahari'
          }, {
            code: 'SUSA RAYONU',
            name: 'Susa Rayonu'
          }, {
            code: 'SUSA SAHARI',
            name: 'Susa Sahari'
          }, {
            code: 'TARTAR RAYONU',
            name: 'Tartar Rayonu'
          }, {
            code: 'TOVUZ RAYONU',
            name: 'Tovuz Rayonu'
          }, {
            code: 'UCAR RAYONU',
            name: 'Ucar Rayonu'
          }, {
            code: 'XACMAZ RAYONU',
            name: 'Xacmaz Rayonu'
          }, {
            code: 'XANKANDI SAHARI',
            name: 'Xankandi Sahari'
          }, {
            code: 'XANLAR RAYONU',
            name: 'Xanlar Rayonu'
          }, {
            code: 'XIZI RAYONU',
            name: 'Xizi Rayonu'
          }, {
            code: 'XOCALI RAYONU',
            name: 'Xocali Rayonu'
          }, {
            code: 'XOCAVAND RAYONU',
            name: 'Xocavand Rayonu'
          }, {
            code: 'YARDIMLI RAYONU',
            name: 'Yardimli Rayonu'
          }, {
            code: 'YEVLAX RAYONU',
            name: 'Yevlax Rayonu'
          }, {
            code: 'YEVLAX SAHARI',
            name: 'Yevlax Sahari'
          }, {
            code: 'ZANGILAN RAYONU',
            name: 'Zangilan Rayonu'
          }, {
            code: 'ZAQATALA RAYONU',
            name: 'Zaqatala Rayonu'
          }, {
            code: 'ZARDAB RAYONU',
            name: 'Zardab Rayonu'
          }];
        case 'BS':
          return [{
            code: 'ACKLINS AND CROOKED ISLANDS',
            name: 'Acklins and Crooked Islands'
          }, {
            code: 'BIMINI',
            name: 'Bimini'
          }, {
            code: 'CAT ISLAND',
            name: 'Cat Island'
          }, {
            code: 'EXUMA',
            name: 'Exuma'
          }, {
            code: 'FREEPORT',
            name: 'Freeport'
          }, {
            code: 'FRESH CREEK',
            name: 'Fresh Creek'
          }, {
            code: 'GOVERNORS HARBOUR',
            name: 'Governors Harbour'
          }, {
            code: 'GREEN TURTLE CAY',
            name: 'Green Turtle Cay'
          }, {
            code: 'HARBOUR ISLAND',
            name: 'Harbour Island'
          }, {
            code: 'HIGH ROCK',
            name: 'High Rock'
          }, {
            code: 'INAGUA',
            name: 'Inagua'
          }, {
            code: 'KEMPS BAY',
            name: 'Kemps Bay'
          }, {
            code: 'LONG ISLAND',
            name: 'Long Island'
          }, {
            code: 'MARSH HARBOUR',
            name: 'Marsh Harbour'
          }, {
            code: 'MAYAGUANA',
            name: 'Mayaguana'
          }, {
            code: 'NEW PROVIDENCE',
            name: 'New Providence'
          }, {
            code: 'NICHOLLS TOWN AND BERRY ISLANDS',
            name: 'Nicholls Town and Berry Islands'
          }, {
            code: 'RAGGED ISLAND',
            name: 'Ragged Island'
          }, {
            code: 'ROCK SOUND',
            name: 'Rock Sound'
          }, {
            code: 'SAN SALVADOR AND RUM CAY',
            name: 'San Salvador and Rum Cay'
          }, {
            code: 'SANDY POINT',
            name: 'Sandy Point'
          }];
        case 'BH':
          return [{
            code: 'AL HADD',
            name: 'Al Hadd'
          }, {
            code: 'AL MANAMAH',
            name: 'Al Manamah'
          }, {
            code: 'AL MINTAQAH AL GHARBIYAH',
            name: 'Al Mintaqah al Gharbiyah'
          }, {
            code: 'AL MINTAQAH AL WUSTA',
            name: 'Al Mintaqah al Wusta'
          }, {
            code: 'AL MINTAQAH ASH SHAMALIYAH',
            name: 'Al Mintaqah ash Shamaliyah'
          }, {
            code: 'AL MUHARRAQ',
            name: 'Al Muharraq'
          }, {
            code: 'AR RIFA WA AL MINTAQAH AL JANUBIYAH',
            name: 'Ar Rifa wa al Mintaqah al Janubiyah'
          }, {
            code: 'JIDD HAFS',
            name: 'Jidd Hafs'
          }, {
            code: 'JUZUR HAWAR',
            name: 'Juzur Hawar'
          }, {
            code: 'MADINAT ISA',
            name: 'Madinat Isa'
          }, {
            code: 'MADINAT HAMAD',
            name: 'Madinat Hamad'
          }, {
            code: 'SITRAH',
            name: 'Sitrah'
          }];
        case 'BD':
          return [{
            code: 'BARGUNA',
            name: 'Barguna'
          }, {
            code: 'BARISAL',
            name: 'Barisal'
          }, {
            code: 'BHOLA',
            name: 'Bhola'
          }, {
            code: 'JHALOKATI',
            name: 'Jhalokati'
          }, {
            code: 'PATUAKHALI',
            name: 'Patuakhali'
          }, {
            code: 'PIROJPUR',
            name: 'Pirojpur'
          }, {
            code: 'BANDARBAN',
            name: 'Bandarban'
          }, {
            code: 'BRAHMANBARIA',
            name: 'Brahmanbaria'
          }, {
            code: 'CHANDPUR',
            name: 'Chandpur'
          }, {
            code: 'CHITTAGONG',
            name: 'Chittagong'
          }, {
            code: 'COMILLA',
            name: 'Comilla'
          }, {
            code: 'COXS BAZAR',
            name: 'Coxs Bazar'
          }, {
            code: 'FENI',
            name: 'Feni'
          }, {
            code: 'KHAGRACHARI',
            name: 'Khagrachari'
          }, {
            code: 'LAKSHMIPUR',
            name: 'Lakshmipur'
          }, {
            code: 'NOAKHALI',
            name: 'Noakhali'
          }, {
            code: 'RANGAMATI',
            name: 'Rangamati'
          }, {
            code: 'DHAKA',
            name: 'Dhaka'
          }, {
            code: 'FARIDPUR',
            name: 'Faridpur'
          }, {
            code: 'GAZIPUR',
            name: 'Gazipur'
          }, {
            code: 'GOPALGANJ',
            name: 'Gopalganj'
          }, {
            code: 'JAMALPUR',
            name: 'Jamalpur'
          }, {
            code: 'KISHOREGANJ',
            name: 'Kishoreganj'
          }, {
            code: 'MADARIPUR',
            name: 'Madaripur'
          }, {
            code: 'MANIKGANJ',
            name: 'Manikganj'
          }, {
            code: 'MUNSHIGANJ',
            name: 'Munshiganj'
          }, {
            code: 'MYMENSINGH',
            name: 'Mymensingh'
          }, {
            code: 'NARAYANGANJ',
            name: 'Narayanganj'
          }, {
            code: 'NARSINGDI',
            name: 'Narsingdi'
          }, {
            code: 'NETROKONA',
            name: 'Netrokona'
          }, {
            code: 'RAJBARI',
            name: 'Rajbari'
          }, {
            code: 'SHARIATPUR',
            name: 'Shariatpur'
          }, {
            code: 'SHERPUR',
            name: 'Sherpur'
          }, {
            code: 'TANGAIL',
            name: 'Tangail'
          }, {
            code: 'BAGERHAT',
            name: 'Bagerhat'
          }, {
            code: 'CHUADANGA',
            name: 'Chuadanga'
          }, {
            code: 'JESSORE',
            name: 'Jessore'
          }, {
            code: 'JHENAIDAH',
            name: 'Jhenaidah'
          }, {
            code: 'KHULNA',
            name: 'Khulna'
          }, {
            code: 'KUSHTIA',
            name: 'Kushtia'
          }, {
            code: 'MAGURA',
            name: 'Magura'
          }, {
            code: 'MEHERPUR',
            name: 'Meherpur'
          }, {
            code: 'NARAIL',
            name: 'Narail'
          }, {
            code: 'SATKHIRA',
            name: 'Satkhira'
          }, {
            code: 'BOGRA',
            name: 'Bogra'
          }, {
            code: 'DINAJPUR',
            name: 'Dinajpur'
          }, {
            code: 'GAIBANDHA',
            name: 'Gaibandha'
          }, {
            code: 'JAIPURHAT',
            name: 'Jaipurhat'
          }, {
            code: 'KURIGRAM',
            name: 'Kurigram'
          }, {
            code: 'LALMONIRHAT',
            name: 'Lalmonirhat'
          }, {
            code: 'NAOGAON',
            name: 'Naogaon'
          }, {
            code: 'NATORE',
            name: 'Natore'
          }, {
            code: 'NAWABGANJ',
            name: 'Nawabganj'
          }, {
            code: 'NILPHAMARI',
            name: 'Nilphamari'
          }, {
            code: 'PABNA',
            name: 'Pabna'
          }, {
            code: 'PANCHAGARH',
            name: 'Panchagarh'
          }, {
            code: 'RAJSHAHI',
            name: 'Rajshahi'
          }, {
            code: 'RANGPUR',
            name: 'Rangpur'
          }, {
            code: 'SIRAJGANJ',
            name: 'Sirajganj'
          }, {
            code: 'THAKURGAON',
            name: 'Thakurgaon'
          }, {
            code: 'HABIGANJ',
            name: 'Habiganj'
          }, {
            code: 'MAULVI BAZAR',
            name: 'Maulvi bazar'
          }, {
            code: 'SUNAMGANJ',
            name: 'Sunamganj'
          }, {
            code: 'SYLHET',
            name: 'Sylhet'
          }];
        case 'BB':
          return [{
            code: 'BRIDGETOWN',
            name: 'Bridgetown'
          }, {
            code: 'CHRIST CHURCH',
            name: 'Christ Church'
          }, {
            code: 'SAINT ANDREW',
            name: 'Saint Andrew'
          }, {
            code: 'SAINT GEORGE',
            name: 'Saint George'
          }, {
            code: 'SAINT JAMES',
            name: 'Saint James'
          }, {
            code: 'SAINT JOHN',
            name: 'Saint John'
          }, {
            code: 'SAINT JOSEPH',
            name: 'Saint Joseph'
          }, {
            code: 'SAINT LUCY',
            name: 'Saint Lucy'
          }, {
            code: 'SAINT MICHAEL',
            name: 'Saint Michael'
          }, {
            code: 'SAINT PETER',
            name: 'Saint Peter'
          }, {
            code: 'SAINT PHILIP',
            name: 'Saint Philip'
          }, {
            code: 'SAINT THOMAS',
            name: 'Saint Thomas'
          }];
        case 'BY':
          return [{
            code: 'BRESTSKAYA (BREST)',
            name: 'Brestskaya (Brest)'
          }, {
            code: 'HOMYELSKAYA (HOMYEL)',
            name: 'Homyelskaya (Homyel)'
          }, {
            code: 'HORAD MINSK',
            name: 'Horad Minsk'
          }, {
            code: 'HRODZYENSKAYA (HRODNA)',
            name: 'Hrodzyenskaya (Hrodna)'
          }, {
            code: 'MAHILYOWSKAYA (MAHILYOW)',
            name: 'Mahilyowskaya (Mahilyow)'
          }, {
            code: 'MINSKAYA',
            name: 'Minskaya'
          }, {
            code: 'VITSYEBSKAYA (VITSYEBSK)',
            name: 'Vitsyebskaya (Vitsyebsk)'
          }];
        case 'BE':
          return [{
            code: 'ANTWERPEN',
            name: 'Antwerpen'
          }, {
            code: 'BRABANT WALLON',
            name: 'Brabant Wallon'
          }, {
            code: 'BRUSSELS CAPITOL REGION',
            name: 'Brussels Capitol Region'
          }, {
            code: 'HAINAUT',
            name: 'Hainaut'
          }, {
            code: 'LIEGE',
            name: 'Liege'
          }, {
            code: 'LIMBURG',
            name: 'Limburg'
          }, {
            code: 'LUXEMBOURG',
            name: 'Luxembourg'
          }, {
            code: 'NAMUR',
            name: 'Namur'
          }, {
            code: 'OOST-VLAANDEREN',
            name: 'Oost-Vlaanderen'
          }, {
            code: 'VLAAMS BRABANT',
            name: 'Vlaams Brabant'
          }, {
            code: 'WEST-VLAANDEREN',
            name: 'West-Vlaanderen'
          }];
        case 'BZ':
          return [{
            code: 'BELIZE',
            name: 'Belize'
          }, {
            code: 'CAYO',
            name: 'Cayo'
          }, {
            code: 'COROZAL',
            name: 'Corozal'
          }, {
            code: 'ORANGE WALK',
            name: 'Orange Walk'
          }, {
            code: 'STANN CREEK',
            name: 'Stann Creek'
          }, {
            code: 'TOLEDO',
            name: 'Toledo'
          }];
        case 'BJ':
          return [{
            code: 'ALIBORI',
            name: 'Alibori'
          }, {
            code: 'ATAKORA',
            name: 'Atakora'
          }, {
            code: 'ATLANTIQUE',
            name: 'Atlantique'
          }, {
            code: 'BORGOU',
            name: 'Borgou'
          }, {
            code: 'COLLINES',
            name: 'Collines'
          }, {
            code: 'COUFFO',
            name: 'Couffo'
          }, {
            code: 'DONGA',
            name: 'Donga'
          }, {
            code: 'LITTORAL',
            name: 'Littoral'
          }, {
            code: 'MONO',
            name: 'Mono'
          }, {
            code: 'OUEME',
            name: 'Oueme'
          }, {
            code: 'PLATEAU',
            name: 'Plateau'
          }, {
            code: 'ZOU',
            name: 'Zou'
          }];
        case 'BM':
          return [{
            code: 'DEVONSHIRE',
            name: 'Devonshire'
          }, {
            code: 'HAMILTON',
            name: 'Hamilton'
          }, {
            code: 'HAMILTON',
            name: 'Hamilton'
          }, {
            code: 'PAGET',
            name: 'Paget'
          }, {
            code: 'PEMBROKE',
            name: 'Pembroke'
          }, {
            code: 'SAINT GEORGE',
            name: 'Saint George'
          }, {
            code: 'SAINT GEORGES',
            name: 'Saint Georges'
          }, {
            code: 'SANDYS',
            name: 'Sandys'
          }, {
            code: 'SMITHS',
            name: 'Smiths'
          }, {
            code: 'SOUTHAMPTON',
            name: 'Southampton'
          }, {
            code: 'WARWICK',
            name: 'Warwick'
          }];
        case 'BT':
          return [{
            code: 'BUMTHANG',
            name: 'Bumthang'
          }, {
            code: 'CHHUKHA',
            name: 'Chhukha'
          }, {
            code: 'CHIRANG',
            name: 'Chirang'
          }, {
            code: 'DAGA',
            name: 'Daga'
          }, {
            code: 'GEYLEGPHUG',
            name: 'Geylegphug'
          }, {
            code: 'HA',
            name: 'Ha'
          }, {
            code: 'LHUNTSHI',
            name: 'Lhuntshi'
          }, {
            code: 'MONGAR',
            name: 'Mongar'
          }, {
            code: 'PARO',
            name: 'Paro'
          }, {
            code: 'PEMAGATSEL',
            name: 'Pemagatsel'
          }, {
            code: 'PUNAKHA',
            name: 'Punakha'
          }, {
            code: 'SAMCHI',
            name: 'Samchi'
          }, {
            code: 'SAMDRUP JONGKHAR',
            name: 'Samdrup Jongkhar'
          }, {
            code: 'SHEMGANG',
            name: 'Shemgang'
          }, {
            code: 'TASHIGANG',
            name: 'Tashigang'
          }, {
            code: 'THIMPHU',
            name: 'Thimphu'
          }, {
            code: 'TONGSA',
            name: 'Tongsa'
          }, {
            code: 'WANGDI PHODRANG',
            name: 'Wangdi Phodrang'
          }];
        case 'BO':
          return [{
            code: 'BENI',
            name: 'Beni'
          }, {
            code: 'CHUQUISACA',
            name: 'Chuquisaca'
          }, {
            code: 'COCHABAMBA',
            name: 'Cochabamba'
          }, {
            code: 'LA PAZ',
            name: 'La Paz'
          }, {
            code: 'ORURO',
            name: 'Oruro'
          }, {
            code: 'PANDO',
            name: 'Pando'
          }, {
            code: 'POTOSI',
            name: 'Potosi'
          }, {
            code: 'SANTA CRUZ',
            name: 'Santa Cruz'
          }, {
            code: 'TARIJA',
            name: 'Tarija'
          }];
        case 'BA':
          return [{
            code: 'FEDERATION OF BOSNIA AND HERZEGOVINA',
            name: 'Federation of Bosnia and Herzegovina'
          }, {
            code: 'REPUBLIKA SRPSKA',
            name: 'Republika Srpska'
          }];
        case 'BW':
          return [{
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'CHOBE',
            name: 'Chobe'
          }, {
            code: 'FRANCISTOWN',
            name: 'Francistown'
          }, {
            code: 'GABORONE',
            name: 'Gaborone'
          }, {
            code: 'GHANZI',
            name: 'Ghanzi'
          }, {
            code: 'KGALAGADI',
            name: 'Kgalagadi'
          }, {
            code: 'KGATLENG',
            name: 'Kgatleng'
          }, {
            code: 'KWENENG',
            name: 'Kweneng'
          }, {
            code: 'LOBATSE',
            name: 'Lobatse'
          }, {
            code: 'NGAMILAND',
            name: 'Ngamiland'
          }, {
            code: 'NORTH-EAST',
            name: 'North-East'
          }, {
            code: 'SELEBI-PIKWE',
            name: 'Selebi-Pikwe'
          }, {
            code: 'SOUTH-EAST',
            name: 'South-East'
          }, {
            code: 'SOUTHERN',
            name: 'Southern'
          }];
        case 'BR':
          return [{
            code: 'ACRE',
            name: 'Acre'
          }, {
            code: 'ALAGOAS',
            name: 'Alagoas'
          }, {
            code: 'AMAPA',
            name: 'Amapa'
          }, {
            code: 'AMAZONAS',
            name: 'Amazonas'
          }, {
            code: 'BAHIA',
            name: 'Bahia'
          }, {
            code: 'CEARA',
            name: 'Ceara'
          }, {
            code: 'DISTRITO FEDERAL',
            name: 'Distrito Federal'
          }, {
            code: 'ESPIRITO SANTO',
            name: 'Espirito Santo'
          }, {
            code: 'GOIAS',
            name: 'Goias'
          }, {
            code: 'MARANHAO',
            name: 'Maranhao'
          }, {
            code: 'MATO GROSSO',
            name: 'Mato Grosso'
          }, {
            code: 'MATO GROSSO DO SUL',
            name: 'Mato Grosso do Sul'
          }, {
            code: 'MINAS GERAIS',
            name: 'Minas Gerais'
          }, {
            code: 'PARA',
            name: 'Para'
          }, {
            code: 'PARAIBA',
            name: 'Paraiba'
          }, {
            code: 'PARANA',
            name: 'Parana'
          }, {
            code: 'PERNAMBUCO',
            name: 'Pernambuco'
          }, {
            code: 'PIAUI',
            name: 'Piaui'
          }, {
            code: 'RIO DE JANEIRO',
            name: 'Rio de Janeiro'
          }, {
            code: 'RIO GRANDE DO NORTE',
            name: 'Rio Grande do Norte'
          }, {
            code: 'RIO GRANDE DO SUL',
            name: 'Rio Grande do Sul'
          }, {
            code: 'RONDONIA',
            name: 'Rondonia'
          }, {
            code: 'RORAIMA',
            name: 'Roraima'
          }, {
            code: 'SANTA CATARINA',
            name: 'Santa Catarina'
          }, {
            code: 'SAO PAULO',
            name: 'Sao Paulo'
          }, {
            code: 'SERGIPE',
            name: 'Sergipe'
          }, {
            code: 'TOCANTINS',
            name: 'Tocantins'
          }];
        case 'VG':
          return [{
            code: 'ANEGADA',
            name: 'Anegada'
          }, {
            code: 'JOST VAN DYKE',
            name: 'Jost Van Dyke'
          }, {
            code: 'TORTOLA',
            name: 'Tortola'
          }, {
            code: 'VIRGIN GORDA',
            name: 'Virgin Gorda'
          }];
        case 'BN':
          return [{
            code: 'BELAIT',
            name: 'Belait'
          }, {
            code: 'BRUNEI AND MUARA',
            name: 'Brunei and Muara'
          }, {
            code: 'TEMBURONG',
            name: 'Temburong'
          }, {
            code: 'TUTONG',
            name: 'Tutong'
          }];
        case 'BG':
          return [{
            code: 'BLAGOEVGRAD',
            name: 'Blagoevgrad'
          }, {
            code: 'BURGAS',
            name: 'Burgas'
          }, {
            code: 'DOBRICH',
            name: 'Dobrich'
          }, {
            code: 'GABROVO',
            name: 'Gabrovo'
          }, {
            code: 'KHASKOVO',
            name: 'Khaskovo'
          }, {
            code: 'KURDZHALI',
            name: 'Kurdzhali'
          }, {
            code: 'KYUSTENDIL',
            name: 'Kyustendil'
          }, {
            code: 'LOVECH',
            name: 'Lovech'
          }, {
            code: 'MONTANA',
            name: 'Montana'
          }, {
            code: 'PAZARDZHIK',
            name: 'Pazardzhik'
          }, {
            code: 'PERNIK',
            name: 'Pernik'
          }, {
            code: 'PLEVEN',
            name: 'Pleven'
          }, {
            code: 'PLOVDIV',
            name: 'Plovdiv'
          }, {
            code: 'RAZGRAD',
            name: 'Razgrad'
          }, {
            code: 'RUSE',
            name: 'Ruse'
          }, {
            code: 'SHUMEN',
            name: 'Shumen'
          }, {
            code: 'SILISTRA',
            name: 'Silistra'
          }, {
            code: 'SLIVEN',
            name: 'Sliven'
          }, {
            code: 'SMOLYAN',
            name: 'Smolyan'
          }, {
            code: 'SOFIYA',
            name: 'Sofiya'
          }, {
            code: 'SOFIYA-GRAD',
            name: 'Sofiya-Grad'
          }, {
            code: 'STARA ZAGORA',
            name: 'Stara Zagora'
          }, {
            code: 'TURGOVISHTE',
            name: 'Turgovishte'
          }, {
            code: 'VARNA',
            name: 'Varna'
          }, {
            code: 'VELIKO TURNOVO',
            name: 'Veliko Turnovo'
          }, {
            code: 'VIDIN',
            name: 'Vidin'
          }, {
            code: 'VRATSA',
            name: 'Vratsa'
          }, {
            code: 'YAMBOL',
            name: 'Yambol'
          }];
        case 'BF':
          return [{
            code: 'BALE',
            name: 'Bale'
          }, {
            code: 'BAM',
            name: 'Bam'
          }, {
            code: 'BANWA',
            name: 'Banwa'
          }, {
            code: 'BAZEGA',
            name: 'Bazega'
          }, {
            code: 'BOUGOURIBA',
            name: 'Bougouriba'
          }, {
            code: 'BOULGOU',
            name: 'Boulgou'
          }, {
            code: 'BOULKIEMDE',
            name: 'Boulkiemde'
          }, {
            code: 'COMOE',
            name: 'Comoe'
          }, {
            code: 'GANZOURGOU',
            name: 'Ganzourgou'
          }, {
            code: 'GNAGNA',
            name: 'Gnagna'
          }, {
            code: 'GOURMA',
            name: 'Gourma'
          }, {
            code: 'HOUET',
            name: 'Houet'
          }, {
            code: 'IOBA',
            name: 'Ioba'
          }, {
            code: 'KADIOGO',
            name: 'Kadiogo'
          }, {
            code: 'KENEDOUGOU',
            name: 'Kenedougou'
          }, {
            code: 'KOMANDJARI',
            name: 'Komandjari'
          }, {
            code: 'KOMPIENGA',
            name: 'Kompienga'
          }, {
            code: 'KOSSI',
            name: 'Kossi'
          }, {
            code: 'KOUPELOGO',
            name: 'Koupelogo'
          }, {
            code: 'KOURITENGA',
            name: 'Kouritenga'
          }, {
            code: 'KOURWEOGO',
            name: 'Kourweogo'
          }, {
            code: 'LERABA',
            name: 'Leraba'
          }, {
            code: 'LOROUM',
            name: 'Loroum'
          }, {
            code: 'MOUHOUN',
            name: 'Mouhoun'
          }, {
            code: 'NAHOURI',
            name: 'Nahouri'
          }, {
            code: 'NAMENTENGA',
            name: 'Namentenga'
          }, {
            code: 'NAUMBIEL',
            name: 'Naumbiel'
          }, {
            code: 'NAYALA',
            name: 'Nayala'
          }, {
            code: 'OUBRITENGA',
            name: 'Oubritenga'
          }, {
            code: 'OUDALAN',
            name: 'Oudalan'
          }, {
            code: 'PASSORE',
            name: 'Passore'
          }, {
            code: 'PONI',
            name: 'Poni'
          }, {
            code: 'SAMENTENGA',
            name: 'Samentenga'
          }, {
            code: 'SANGUIE',
            name: 'Sanguie'
          }, {
            code: 'SENO',
            name: 'Seno'
          }, {
            code: 'SISSILI',
            name: 'Sissili'
          }, {
            code: 'SOUM',
            name: 'Soum'
          }, {
            code: 'SOUROU',
            name: 'Sourou'
          }, {
            code: 'TAPOA',
            name: 'Tapoa'
          }, {
            code: 'TUY',
            name: 'Tuy'
          }, {
            code: 'YAGHA',
            name: 'Yagha'
          }, {
            code: 'YATENGA',
            name: 'Yatenga'
          }, {
            code: 'ZIRO',
            name: 'Ziro'
          }, {
            code: 'ZONDOMO',
            name: 'Zondomo'
          }, {
            code: 'ZOUNDWEOGO',
            name: 'Zoundweogo'
          }];
        case 'MM':
          return [{
            code: 'AYEYARWADY',
            name: 'Ayeyarwady'
          }, {
            code: 'BAGO',
            name: 'Bago'
          }, {
            code: 'CHIN STATE',
            name: 'Chin State'
          }, {
            code: 'KACHIN STATE',
            name: 'Kachin State'
          }, {
            code: 'KAYAH STATE',
            name: 'Kayah State'
          }, {
            code: 'KAYIN STATE',
            name: 'Kayin State'
          }, {
            code: 'MAGWAY',
            name: 'Magway'
          }, {
            code: 'MANDALAY',
            name: 'Mandalay'
          }, {
            code: 'MON STATE',
            name: 'Mon State'
          }, {
            code: 'RAKHINE STATE',
            name: 'Rakhine State'
          }, {
            code: 'SAGAING',
            name: 'Sagaing'
          }, {
            code: 'SHAN STATE',
            name: 'Shan State'
          }, {
            code: 'TANINTHARYI',
            name: 'Tanintharyi'
          }, {
            code: 'YANGON',
            name: 'Yangon'
          }];
        case 'BI':
          return [{
            code: 'BUBANZA',
            name: 'Bubanza'
          }, {
            code: 'BUJUMBURA',
            name: 'Bujumbura'
          }, {
            code: 'BURURI',
            name: 'Bururi'
          }, {
            code: 'CANKUZO',
            name: 'Cankuzo'
          }, {
            code: 'CIBITOKE',
            name: 'Cibitoke'
          }, {
            code: 'GITEGA',
            name: 'Gitega'
          }, {
            code: 'KARUZI',
            name: 'Karuzi'
          }, {
            code: 'KAYANZA',
            name: 'Kayanza'
          }, {
            code: 'KIRUNDO',
            name: 'Kirundo'
          }, {
            code: 'MAKAMBA',
            name: 'Makamba'
          }, {
            code: 'MURAMVYA',
            name: 'Muramvya'
          }, {
            code: 'MUYINGA',
            name: 'Muyinga'
          }, {
            code: 'MWARO',
            name: 'Mwaro'
          }, {
            code: 'NGOZI',
            name: 'Ngozi'
          }, {
            code: 'RUTANA',
            name: 'Rutana'
          }, {
            code: 'RUYIGI',
            name: 'Ruyigi'
          }];
        case 'KH':
          return [{
            code: 'BANTEAY MEAN CHEAY',
            name: 'Banteay Mean Cheay'
          }, {
            code: 'BATDAMBANG',
            name: 'Batdambang'
          }, {
            code: 'KAMPONG CHAM',
            name: 'Kampong Cham'
          }, {
            code: 'KAMPONG CHHNANG',
            name: 'Kampong Chhnang'
          }, {
            code: 'KAMPONG SPOE',
            name: 'Kampong Spoe'
          }, {
            code: 'KAMPONG THUM',
            name: 'Kampong Thum'
          }, {
            code: 'KAMPOT',
            name: 'Kampot'
          }, {
            code: 'KANDAL',
            name: 'Kandal'
          }, {
            code: 'KAOH KONG',
            name: 'Kaoh Kong'
          }, {
            code: 'KEB',
            name: 'Keb'
          }, {
            code: 'KRACHEH',
            name: 'Kracheh'
          }, {
            code: 'MONDOL KIRI',
            name: 'Mondol Kiri'
          }, {
            code: 'OTDAR MEAN CHEAY',
            name: 'Otdar Mean Cheay'
          }, {
            code: 'PAILIN',
            name: 'Pailin'
          }, {
            code: 'PHNUM PENH',
            name: 'Phnum Penh'
          }, {
            code: 'POUTHISAT',
            name: 'Pouthisat'
          }, {
            code: 'PREAH SEIHANU (SIHANOUKVILLE)',
            name: 'Preah Seihanu (Sihanoukville)'
          }, {
            code: 'PREAH VIHEAR',
            name: 'Preah Vihear'
          }, {
            code: 'PREY VENG',
            name: 'Prey Veng'
          }, {
            code: 'ROTANAH KIRI',
            name: 'Rotanah Kiri'
          }, {
            code: 'SIEM REAB',
            name: 'Siem Reab'
          }, {
            code: 'STOENG TRENG',
            name: 'Stoeng Treng'
          }, {
            code: 'SVAY RIENG',
            name: 'Svay Rieng'
          }, {
            code: 'TAKEV',
            name: 'Takev'
          }];
        case 'CM':
          return [{
            code: 'ADAMAOUA',
            name: 'Adamaoua'
          }, {
            code: 'CENTRE',
            name: 'Centre'
          }, {
            code: 'EST',
            name: 'Est'
          }, {
            code: 'EXTREME-NORD',
            name: 'Extreme-Nord'
          }, {
            code: 'LITTORAL',
            name: 'Littoral'
          }, {
            code: 'NORD',
            name: 'Nord'
          }, {
            code: 'NORD-OUEST',
            name: 'Nord-Ouest'
          }, {
            code: 'OUEST',
            name: 'Ouest'
          }, {
            code: 'SUD',
            name: 'Sud'
          }, {
            code: 'SUD-OUEST',
            name: 'Sud-Ouest'
          }];
        case 'CV':
          return [{
            code: 'BOA VISTA',
            name: 'Boa Vista'
          }, {
            code: 'BRAVA',
            name: 'Brava'
          }, {
            code: 'MAIO',
            name: 'Maio'
          }, {
            code: 'MOSTEIROS',
            name: 'Mosteiros'
          }, {
            code: 'PAUL',
            name: 'Paul'
          }, {
            code: 'PORTO NOVO',
            name: 'Porto Novo'
          }, {
            code: 'PRAIA',
            name: 'Praia'
          }, {
            code: 'RIBEIRA GRANDE',
            name: 'Ribeira Grande'
          }, {
            code: 'SAL',
            name: 'Sal'
          }, {
            code: 'SANTA CATARINA',
            name: 'Santa Catarina'
          }, {
            code: 'SANTA CRUZ',
            name: 'Santa Cruz'
          }, {
            code: 'SAO DOMINGOS',
            name: 'Sao Domingos'
          }, {
            code: 'SAO FILIPE',
            name: 'Sao Filipe'
          }, {
            code: 'SAO NICOLAU',
            name: 'Sao Nicolau'
          }, {
            code: 'SAO VICENTE',
            name: 'Sao Vicente'
          }, {
            code: 'TARRAFAL',
            name: 'Tarrafal'
          }];
        case 'KF':
          return [{
            code: 'CREEK',
            name: 'Creek'
          }, {
            code: 'EASTERN',
            name: 'Eastern'
          }, {
            code: 'MIDLAND',
            name: 'Midland'
          }, {
            code: 'SOUTH TOWN',
            name: 'South Town'
          }, {
            code: 'SPOT BAY',
            name: 'Spot Bay'
          }, {
            code: 'STAKE BAY',
            name: 'Stake Bay'
          }, {
            code: 'WEST END',
            name: 'West End'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'CF':
          return [{
            code: 'BAMINGUI-BANGORAN',
            name: 'Bamingui-Bangoran'
          }, {
            code: 'BANGUI',
            name: 'Bangui'
          }, {
            code: 'BASSE-KOTTO',
            name: 'Basse-Kotto'
          }, {
            code: 'GRIBINGUI',
            name: 'Gribingui'
          }, {
            code: 'HAUT-MBOMOU',
            name: 'Haut-Mbomou'
          }, {
            code: 'HAUTE-KOTTO',
            name: 'Haute-Kotto'
          }, {
            code: 'HAUTE-SANGHA',
            name: 'Haute-Sangha'
          }, {
            code: 'KEMO-GRIBINGUI',
            name: 'Kemo-Gribingui'
          }, {
            code: 'LOBAYE',
            name: 'Lobaye'
          }, {
            code: 'MBOMOU',
            name: 'Mbomou'
          }, {
            code: 'NANA-MAMBERE',
            name: 'Nana-Mambere'
          }, {
            code: 'OMBELLA-MPOKO',
            name: 'Ombella-Mpoko'
          }, {
            code: 'OUAKA',
            name: 'Ouaka'
          }, {
            code: 'OUHAM',
            name: 'Ouham'
          }, {
            code: 'OUHAM-PENDE',
            name: 'Ouham-Pende'
          }, {
            code: 'SANGHA',
            name: 'Sangha'
          }, {
            code: 'VAKAGA',
            name: 'Vakaga'
          }];
        case 'CD':
          return [{
            code: 'BATHA',
            name: 'Batha'
          }, {
            code: 'BILTINE',
            name: 'Biltine'
          }, {
            code: 'BORKOU-ENNEDI-TIBESTI',
            name: 'Borkou-Ennedi-Tibesti'
          }, {
            code: 'CHARI-BAGUIRMI',
            name: 'Chari-Baguirmi'
          }, {
            code: 'GUERA',
            name: 'Guera'
          }, {
            code: 'KANEM',
            name: 'Kanem'
          }, {
            code: 'LAC',
            name: 'Lac'
          }, {
            code: 'LOGONE OCCIDENTAL',
            name: 'Logone Occidental'
          }, {
            code: 'LOGONE ORIENTAL',
            name: 'Logone Oriental'
          }, {
            code: 'MAYO-KEBBI',
            name: 'Mayo-Kebbi'
          }, {
            code: 'MOYEN-CHARI',
            name: 'Moyen-Chari'
          }, {
            code: 'OUADDAI',
            name: 'Ouaddai'
          }, {
            code: 'SALAMAT',
            name: 'Salamat'
          }, {
            code: 'TANDJILE',
            name: 'Tandjile'
          }];
        case 'CL':
          return [{
            code: 'AISEN DEL GENERAL CARLOS IBANEZ DEL CAMPO',
            name: 'Aisen del General Carlos Ibanez del Campo'
          }, {
            code: 'ANTOFAGASTA',
            name: 'Antofagasta'
          }, {
            code: 'ARAUCANIA',
            name: 'Araucania'
          }, {
            code: 'ATACAMA',
            name: 'Atacama'
          }, {
            code: 'BIO-BIO',
            name: 'Bio-Bio'
          }, {
            code: 'COQUIMBO',
            name: 'Coquimbo'
          }, {
            code: 'LIBERTADOR GENERAL BERNARDO OHIGGINS',
            name: 'Libertador General Bernardo OHiggins'
          }, {
            code: 'LOS LAGOS',
            name: 'Los Lagos'
          }, {
            code: 'MAGALLANES Y DE LA ANTARTICA CHILENA',
            name: 'Magallanes y de la Antartica Chilena'
          }, {
            code: 'MAULE',
            name: 'Maule'
          }, {
            code: 'REGION METROPOLITANA (SANTIAGO)',
            name: 'Region Metropolitana (Santiago)'
          }, {
            code: 'TARAPACA',
            name: 'Tarapaca'
          }, {
            code: 'VALPARAISO',
            name: 'Valparaiso'
          }];
        case 'CN':
          return [{
            code: 'ANHUI',
            name: 'Anhui'
          }, {
            code: 'BEIJING',
            name: 'Beijing'
          }, {
            code: 'CHONGQING',
            name: 'Chongqing'
          }, {
            code: 'FUJIAN',
            name: 'Fujian'
          }, {
            code: 'GANSU',
            name: 'Gansu'
          }, {
            code: 'GUANGDONG',
            name: 'Guangdong'
          }, {
            code: 'GUANGXI',
            name: 'Guangxi'
          }, {
            code: 'GUIZHOU',
            name: 'Guizhou'
          }, {
            code: 'HAINAN',
            name: 'Hainan'
          }, {
            code: 'HEBEI',
            name: 'Hebei'
          }, {
            code: 'HEILONGJIANG',
            name: 'Heilongjiang'
          }, {
            code: 'HENAN',
            name: 'Henan'
          }, {
            code: 'HUBEI',
            name: 'Hubei'
          }, {
            code: 'HUNAN',
            name: 'Hunan'
          }, {
            code: 'JIANGSU',
            name: 'Jiangsu'
          }, {
            code: 'JIANGXI',
            name: 'Jiangxi'
          }, {
            code: 'JILIN',
            name: 'Jilin'
          }, {
            code: 'LIAONING',
            name: 'Liaoning'
          }, {
            code: 'NEI MONGOL',
            name: 'Nei Mongol'
          }, {
            code: 'NINGXIA',
            name: 'Ningxia'
          }, {
            code: 'QINGHAI',
            name: 'Qinghai'
          }, {
            code: 'SHAANXI',
            name: 'Shaanxi'
          }, {
            code: 'SHANDONG',
            name: 'Shandong'
          }, {
            code: 'SHANGHAI',
            name: 'Shanghai'
          }, {
            code: 'SHANXI',
            name: 'Shanxi'
          }, {
            code: 'SICHUAN',
            name: 'Sichuan'
          }, {
            code: 'TIANJIN',
            name: 'Tianjin'
          }, {
            code: 'XINJIANG',
            name: 'Xinjiang'
          }, {
            code: 'XIZANG (TIBET)',
            name: 'Xizang (Tibet)'
          }, {
            code: 'YUNNAN',
            name: 'Yunnan'
          }, {
            code: 'ZHEJIANG',
            name: 'Zhejiang'
          }];
        case 'CO':
          return [{
            code: 'AMAZONAS',
            name: 'Amazonas'
          }, {
            code: 'ANTIOQUIA',
            name: 'Antioquia'
          }, {
            code: 'ARAUCA',
            name: 'Arauca'
          }, {
            code: 'ATLANTICO',
            name: 'Atlantico'
          }, {
            code: 'BOLIVAR',
            name: 'Bolivar'
          }, {
            code: 'BOYACA',
            name: 'Boyaca'
          }, {
            code: 'CALDAS',
            name: 'Caldas'
          }, {
            code: 'CAQUETA',
            name: 'Caqueta'
          }, {
            code: 'CASANARE',
            name: 'Casanare'
          }, {
            code: 'CAUCA',
            name: 'Cauca'
          }, {
            code: 'CESAR',
            name: 'Cesar'
          }, {
            code: 'CHOCO',
            name: 'Choco'
          }, {
            code: 'CORDOBA',
            name: 'Cordoba'
          }, {
            code: 'CUNDINAMARCA',
            name: 'Cundinamarca'
          }, {
            code: 'DISTRITO CAPITAL DE SANTA FE DE BOGOTA',
            name: 'Distrito Capital de Santa Fe de Bogota'
          }, {
            code: 'GUAINIA',
            name: 'Guainia'
          }, {
            code: 'GUAVIARE',
            name: 'Guaviare'
          }, {
            code: 'HUILA',
            name: 'Huila'
          }, {
            code: 'LA GUAJIRA',
            name: 'La Guajira'
          }, {
            code: 'MAGDALENA',
            name: 'Magdalena'
          }, {
            code: 'META',
            name: 'Meta'
          }, {
            code: 'NARINO',
            name: 'Narino'
          }, {
            code: 'NORTE DE SANTANDER',
            name: 'Norte de Santander'
          }, {
            code: 'PUTUMAYO',
            name: 'Putumayo'
          }, {
            code: 'QUINDIO',
            name: 'Quindio'
          }, {
            code: 'RISARALDA',
            name: 'Risaralda'
          }, {
            code: 'SAN ANDRES Y PROVIDENCIA',
            name: 'San Andres y Providencia'
          }, {
            code: 'SANTANDER',
            name: 'Santander'
          }, {
            code: 'SUCRE',
            name: 'Sucre'
          }, {
            code: 'TOLIMA',
            name: 'Tolima'
          }, {
            code: 'VALLE DEL CAUCA',
            name: 'Valle del Cauca'
          }, {
            code: 'VAUPES',
            name: 'Vaupes'
          }, {
            code: 'VICHADA',
            name: 'Vichada'
          }];
        case 'KM':
          return [{
            code: 'ANJOUAN (NZWANI)',
            name: 'Anjouan (Nzwani)'
          }, {
            code: 'DOMONI',
            name: 'Domoni'
          }, {
            code: 'FOMBONI',
            name: 'Fomboni'
          }, {
            code: 'GRANDE COMORE (NJAZIDJA)',
            name: 'Grande Comore (Njazidja)'
          }, {
            code: 'MOHELI (MWALI)',
            name: 'Moheli (Mwali)'
          }, {
            code: 'MORONI',
            name: 'Moroni'
          }, {
            code: 'MOUTSAMOUDOU',
            name: 'Moutsamoudou'
          }];
        case 'CD':
          return [{
            code: 'BANDUNDU',
            name: 'Bandundu'
          }, {
            code: 'BAS-CONGO',
            name: 'Bas-Congo'
          }, {
            code: 'EQUATEUR',
            name: 'Equateur'
          }, {
            code: 'KASAI-OCCIDENTAL',
            name: 'Kasai-Occidental'
          }, {
            code: 'KASAI-ORIENTAL',
            name: 'Kasai-Oriental'
          }, {
            code: 'KATANGA',
            name: 'Katanga'
          }, {
            code: 'KINSHASA',
            name: 'Kinshasa'
          }, {
            code: 'MANIEMA',
            name: 'Maniema'
          }, {
            code: 'NORD-KIVU',
            name: 'Nord-Kivu'
          }, {
            code: 'ORIENTALE',
            name: 'Orientale'
          }, {
            code: 'SUD-KIVU',
            name: 'Sud-Kivu'
          }];
        case 'CG':
          return [{
            code: 'BOUENZA',
            name: 'Bouenza'
          }, {
            code: 'BRAZZAVILLE',
            name: 'Brazzaville'
          }, {
            code: 'CUVETTE',
            name: 'Cuvette'
          }, {
            code: 'KOUILOU',
            name: 'Kouilou'
          }, {
            code: 'LEKOUMOU',
            name: 'Lekoumou'
          }, {
            code: 'LIKOUALA',
            name: 'Likouala'
          }, {
            code: 'NIARI',
            name: 'Niari'
          }, {
            code: 'PLATEAUX',
            name: 'Plateaux'
          }, {
            code: 'POOL',
            name: 'Pool'
          }, {
            code: 'SANGHA',
            name: 'Sangha'
          }];
        case 'CK':
          return [{
            code: 'AITUTAKI',
            name: 'Aitutaki'
          }, {
            code: 'ATIU',
            name: 'Atiu'
          }, {
            code: 'AVARUA',
            name: 'Avarua'
          }, {
            code: 'MANGAIA',
            name: 'Mangaia'
          }, {
            code: 'MANIHIKI',
            name: 'Manihiki'
          }, {
            code: 'MANUAE',
            name: 'Manuae'
          }, {
            code: 'MAUKE',
            name: 'Mauke'
          }, {
            code: 'MITIARO',
            name: 'Mitiaro'
          }, {
            code: 'NASSAU ISLAND',
            name: 'Nassau Island'
          }, {
            code: 'PALMERSTON',
            name: 'Palmerston'
          }, {
            code: 'PENRHYN',
            name: 'Penrhyn'
          }, {
            code: 'PUKAPUKA',
            name: 'Pukapuka'
          }, {
            code: 'RAKAHANGA',
            name: 'Rakahanga'
          }, {
            code: 'RAROTONGA',
            name: 'Rarotonga'
          }, {
            code: 'SUWARROW',
            name: 'Suwarrow'
          }, {
            code: 'TAKUTEA',
            name: 'Takutea'
          }];
        case 'CR':
          return [{
            code: 'ALAJUELA',
            name: 'Alajuela'
          }, {
            code: 'CARTAGO',
            name: 'Cartago'
          }, {
            code: 'GUANACASTE',
            name: 'Guanacaste'
          }, {
            code: 'HEREDIA',
            name: 'Heredia'
          }, {
            code: 'LIMON',
            name: 'Limon'
          }, {
            code: 'PUNTARENAS',
            name: 'Puntarenas'
          }, {
            code: 'SAN JOSE',
            name: 'San Jose'
          }];
        case 'CI':
          return [{
            code: 'ABENGOUROU',
            name: 'Abengourou'
          }, {
            code: 'ABIDJAN',
            name: 'Abidjan'
          }, {
            code: 'ABOISSO',
            name: 'Aboisso'
          }, {
            code: 'ADIAKE',
            name: 'Adiake'
          }, {
            code: 'ADZOPE',
            name: 'Adzope'
          }, {
            code: 'AGBOVILLE',
            name: 'Agboville'
          }, {
            code: 'AGNIBILEKROU',
            name: 'Agnibilekrou'
          }, {
            code: 'ALEPE',
            name: 'Alepe'
          }, {
            code: 'BANGOLO',
            name: 'Bangolo'
          }, {
            code: 'BEOUMI',
            name: 'Beoumi'
          }, {
            code: 'BIANKOUMA',
            name: 'Biankouma'
          }, {
            code: 'BOCANDA',
            name: 'Bocanda'
          }, {
            code: 'BONDOUKOU',
            name: 'Bondoukou'
          }, {
            code: 'BONGOUANOU',
            name: 'Bongouanou'
          }, {
            code: 'BOUAFLE',
            name: 'Bouafle'
          }, {
            code: 'BOUAKE',
            name: 'Bouake'
          }, {
            code: 'BOUNA',
            name: 'Bouna'
          }, {
            code: 'BOUNDIALI',
            name: 'Boundiali'
          }, {
            code: 'DABAKALA',
            name: 'Dabakala'
          }, {
            code: 'DABON',
            name: 'Dabon'
          }, {
            code: 'DALOA',
            name: 'Daloa'
          }, {
            code: 'DANANE',
            name: 'Danane'
          }, {
            code: 'DAOUKRO',
            name: 'Daoukro'
          }, {
            code: 'DIMBOKRO',
            name: 'Dimbokro'
          }, {
            code: 'DIVO',
            name: 'Divo'
          }, {
            code: 'DUEKOUE',
            name: 'Duekoue'
          }, {
            code: 'FERKESSEDOUGOU',
            name: 'Ferkessedougou'
          }, {
            code: 'GAGNOA',
            name: 'Gagnoa'
          }, {
            code: 'GRAND BASSAM',
            name: 'Grand Bassam'
          }, {
            code: 'GRAND-LAHOU',
            name: 'Grand-Lahou'
          }, {
            code: 'GUIGLO',
            name: 'Guiglo'
          }, {
            code: 'ISSIA',
            name: 'Issia'
          }, {
            code: 'JACQUEVILLE',
            name: 'Jacqueville'
          }, {
            code: 'KATIOLA',
            name: 'Katiola'
          }, {
            code: 'KORHOGO',
            name: 'Korhogo'
          }, {
            code: 'LAKOTA',
            name: 'Lakota'
          }, {
            code: 'MAN',
            name: 'Man'
          }, {
            code: 'MANKONO',
            name: 'Mankono'
          }, {
            code: 'MBAHIAKRO',
            name: 'Mbahiakro'
          }, {
            code: 'ODIENNE',
            name: 'Odienne'
          }, {
            code: 'OUME',
            name: 'Oume'
          }, {
            code: 'SAKASSOU',
            name: 'Sakassou'
          }, {
            code: 'SAN-PEDRO',
            name: 'San-Pedro'
          }, {
            code: 'SASSANDRA',
            name: 'Sassandra'
          }, {
            code: 'SEGUELA',
            name: 'Seguela'
          }, {
            code: 'SINFRA',
            name: 'Sinfra'
          }, {
            code: 'SOUBRE',
            name: 'Soubre'
          }, {
            code: 'TABOU',
            name: 'Tabou'
          }, {
            code: 'TANDA',
            name: 'Tanda'
          }, {
            code: 'TIASSALE',
            name: 'Tiassale'
          }, {
            code: 'TIEBISSOU',
            name: 'Tiebissou'
          }, {
            code: 'TINGRELA',
            name: 'Tingrela'
          }, {
            code: 'TOUBA',
            name: 'Touba'
          }, {
            code: 'TOULEPLEU',
            name: 'Toulepleu'
          }, {
            code: 'TOUMODI',
            name: 'Toumodi'
          }, {
            code: 'VAVOUA',
            name: 'Vavoua'
          }, {
            code: 'YAMOUSSOUKRO',
            name: 'Yamoussoukro'
          }, {
            code: 'ZUENOULA',
            name: 'Zuenoula'
          }];
        case 'HR':
          return [{
            code: 'BJELOVARSKO-BILOGORSKA ZUPANIJA',
            name: 'Bjelovarsko-Bilogorska Zupanija'
          }, {
            code: 'BRODSKO-POSAVSKA ZUPANIJA',
            name: 'Brodsko-Posavska Zupanija'
          }, {
            code: 'DUBROVACKO-NERETVANSKA ZUPANIJA',
            name: 'Dubrovacko-Neretvanska Zupanija'
          }, {
            code: 'ISTARSKA ZUPANIJA',
            name: 'Istarska Zupanija'
          }, {
            code: 'KARLOVACKA ZUPANIJA',
            name: 'Karlovacka Zupanija'
          }, {
            code: 'KOPRIVNICKO-KRIZEVACKA ZUPANIJA',
            name: 'Koprivnicko-Krizevacka Zupanija'
          }, {
            code: 'KRAPINSKO-ZAGORSKA ZUPANIJA',
            name: 'Krapinsko-Zagorska Zupanija'
          }, {
            code: 'LICKO-SENJSKA ZUPANIJA',
            name: 'Licko-Senjska Zupanija'
          }, {
            code: 'MEDIMURSKA ZUPANIJA',
            name: 'Medimurska Zupanija'
          }, {
            code: 'OSJECKO-BARANJSKA ZUPANIJA',
            name: 'Osjecko-Baranjska Zupanija'
          }, {
            code: 'POZESKO-SLAVONSKA ZUPANIJA',
            name: 'Pozesko-Slavonska Zupanija'
          }, {
            code: 'PRIMORSKO-GORANSKA ZUPANIJA',
            name: 'Primorsko-Goranska Zupanija'
          }, {
            code: 'SIBENSKO-KNINSKA ZUPANIJA',
            name: 'Sibensko-Kninska Zupanija'
          }, {
            code: 'SISACKO-MOSLAVACKA ZUPANIJA',
            name: 'Sisacko-Moslavacka Zupanija'
          }, {
            code: 'SPLITSKO-DALMATINSKA ZUPANIJA',
            name: 'Splitsko-Dalmatinska Zupanija'
          }, {
            code: 'VARAZDINSKA ZUPANIJA',
            name: 'Varazdinska Zupanija'
          }, {
            code: 'VIROVITICKO-PODRAVSKA ZUPANIJA',
            name: 'Viroviticko-Podravska Zupanija'
          }, {
            code: 'VUKOVARSKO-SRIJEMSKA ZUPANIJA',
            name: 'Vukovarsko-Srijemska Zupanija'
          }, {
            code: 'ZADARSKA ZUPANIJA',
            name: 'Zadarska Zupanija'
          }, {
            code: 'ZAGREB',
            name: 'Zagreb'
          }, {
            code: 'ZAGREBACKA ZUPANIJA',
            name: 'Zagrebacka Zupanija'
          }];
        case 'CU':
          return [{
            code: 'CAMAGUEY',
            name: 'Camaguey'
          }, {
            code: 'CIEGO DE AVILA',
            name: 'Ciego de Avila'
          }, {
            code: 'CIENFUEGOS',
            name: 'Cienfuegos'
          }, {
            code: 'CIUDAD DE LA HABANA',
            name: 'Ciudad de La Habana'
          }, {
            code: 'GRANMA',
            name: 'Granma'
          }, {
            code: 'GUANTANAMO',
            name: 'Guantanamo'
          }, {
            code: 'HOLGUIN',
            name: 'Holguin'
          }, {
            code: 'ISLA DE LA JUVENTUD',
            name: 'Isla de la Juventud'
          }, {
            code: 'LA HABANA',
            name: 'La Habana'
          }, {
            code: 'LAS TUNAS',
            name: 'Las Tunas'
          }, {
            code: 'MATANZAS',
            name: 'Matanzas'
          }, {
            code: 'PINAR DEL RIO',
            name: 'Pinar del Rio'
          }, {
            code: 'SANCTI SPIRITUS',
            name: 'Sancti Spiritus'
          }, {
            code: 'SANTIAGO DE CUBA',
            name: 'Santiago de Cuba'
          }, {
            code: 'VILLA CLARA',
            name: 'Villa Clara'
          }];
        case 'CY':
          return [{
            code: 'FAMAGUSTA',
            name: 'Famagusta'
          }, {
            code: 'KYRENIA',
            name: 'Kyrenia'
          }, {
            code: 'LARNACA',
            name: 'Larnaca'
          }, {
            code: 'LIMASSOL',
            name: 'Limassol'
          }, {
            code: 'NICOSIA',
            name: 'Nicosia'
          }, {
            code: 'PAPHOS',
            name: 'Paphos'
          }];
        case 'CZ':
          return [{
            code: 'BRNENSKY',
            name: 'Brnensky'
          }, {
            code: 'BUDEJOVICKY',
            name: 'Budejovicky'
          }, {
            code: 'JIHLAVSKY',
            name: 'Jihlavsky'
          }, {
            code: 'KARLOVARSKY',
            name: 'Karlovarsky'
          }, {
            code: 'KRALOVEHRADECKY',
            name: 'Kralovehradecky'
          }, {
            code: 'LIBERECKY',
            name: 'Liberecky'
          }, {
            code: 'OLOMOUCKY',
            name: 'Olomoucky'
          }, {
            code: 'OSTRAVSKY',
            name: 'Ostravsky'
          }, {
            code: 'PARDUBICKY',
            name: 'Pardubicky'
          }, {
            code: 'PLZENSKY',
            name: 'Plzensky'
          }, {
            code: 'PRAHA',
            name: 'Praha'
          }, {
            code: 'STREDOCESKY',
            name: 'Stredocesky'
          }, {
            code: 'USTECKY',
            name: 'Ustecky'
          }, {
            code: 'ZLINSKY',
            name: 'Zlinsky'
          }];
        case 'DK':
          return [{
            code: 'ARHUS',
            name: 'Arhus'
          }, {
            code: 'BORNHOLM',
            name: 'Bornholm'
          }, {
            code: 'FREDERICKSBERG',
            name: 'Fredericksberg'
          }, {
            code: 'FREDERIKSBORG',
            name: 'Frederiksborg'
          }, {
            code: 'FYN',
            name: 'Fyn'
          }, {
            code: 'KOBENHAVN',
            name: 'Kobenhavn'
          }, {
            code: 'KOBENHAVNS',
            name: 'Kobenhavns'
          }, {
            code: 'NORDJYLLAND',
            name: 'Nordjylland'
          }, {
            code: 'RIBE',
            name: 'Ribe'
          }, {
            code: 'RINGKOBING',
            name: 'Ringkobing'
          }, {
            code: 'ROSKILDE',
            name: 'Roskilde'
          }, {
            code: 'SONDERJYLLAND',
            name: 'Sonderjylland'
          }, {
            code: 'STORSTROM',
            name: 'Storstrom'
          }, {
            code: 'VEJLE',
            name: 'Vejle'
          }, {
            code: 'VESTSJALLAND',
            name: 'Vestsjalland'
          }, {
            code: 'VIBORG',
            name: 'Viborg'
          }];
        case 'DJ':
          return [{
            code: 'ALI SABIH',
            name: 'Ali Sabih'
          }, {
            code: 'DIKHIL',
            name: 'Dikhil'
          }, {
            code: 'DJIBOUTI',
            name: 'Djibouti'
          }, {
            code: 'OBOCK',
            name: 'Obock'
          }, {
            code: 'TADJOURA',
            name: 'Tadjoura'
          }];
        case 'DM':
          return [{
            code: 'SAINT ANDREW',
            name: 'Saint Andrew'
          }, {
            code: 'SAINT DAVID',
            name: 'Saint David'
          }, {
            code: 'SAINT GEORGE',
            name: 'Saint George'
          }, {
            code: 'SAINT JOHN',
            name: 'Saint John'
          }, {
            code: 'SAINT JOSEPH',
            name: 'Saint Joseph'
          }, {
            code: 'SAINT LUKE',
            name: 'Saint Luke'
          }, {
            code: 'SAINT MARK',
            name: 'Saint Mark'
          }, {
            code: 'SAINT PATRICK',
            name: 'Saint Patrick'
          }, {
            code: 'SAINT PAUL',
            name: 'Saint Paul'
          }, {
            code: 'SAINT PETER',
            name: 'Saint Peter'
          }];
        case 'DO':
          return [{
            code: 'AZUA',
            name: 'Azua'
          }, {
            code: 'BAORUCO',
            name: 'Baoruco'
          }, {
            code: 'BARAHONA',
            name: 'Barahona'
          }, {
            code: 'DAJABON',
            name: 'Dajabon'
          }, {
            code: 'DISTRITO NACIONAL',
            name: 'Distrito Nacional'
          }, {
            code: 'DUARTE',
            name: 'Duarte'
          }, {
            code: 'EL SEIBO',
            name: 'El Seibo'
          }, {
            code: 'ELIAS PINA',
            name: 'Elias Pina'
          }, {
            code: 'ESPAILLAT',
            name: 'Espaillat'
          }, {
            code: 'HATO MAYOR',
            name: 'Hato Mayor'
          }, {
            code: 'INDEPENDENCIA',
            name: 'Independencia'
          }, {
            code: 'LA ALTAGRACIA',
            name: 'La Altagracia'
          }, {
            code: 'LA ROMANA',
            name: 'La Romana'
          }, {
            code: 'LA VEGA',
            name: 'La Vega'
          }, {
            code: 'MARIA TRINIDAD SANCHEZ',
            name: 'Maria Trinidad Sanchez'
          }, {
            code: 'MONSENOR NOUEL',
            name: 'Monsenor Nouel'
          }, {
            code: 'MONTE CRISTI',
            name: 'Monte Cristi'
          }, {
            code: 'MONTE PLATA',
            name: 'Monte Plata'
          }, {
            code: 'PEDERNALES',
            name: 'Pedernales'
          }, {
            code: 'PERAVIA',
            name: 'Peravia'
          }, {
            code: 'PUERTO PLATA',
            name: 'Puerto Plata'
          }, {
            code: 'SALCEDO',
            name: 'Salcedo'
          }, {
            code: 'SAMANA',
            name: 'Samana'
          }, {
            code: 'SAN CRISTOBAL',
            name: 'San Cristobal'
          }, {
            code: 'SAN JUAN',
            name: 'San Juan'
          }, {
            code: 'SAN PEDRO DE MACORIS',
            name: 'San Pedro de Macoris'
          }, {
            code: 'SANCHEZ RAMIREZ',
            name: 'Sanchez Ramirez'
          }, {
            code: 'SANTIAGO',
            name: 'Santiago'
          }, {
            code: 'SANTIAGO RODRIGUEZ',
            name: 'Santiago Rodriguez'
          }, {
            code: 'VALVERDE',
            name: 'Valverde'
          }];
        case 'EC':
          return [{
            code: 'AZUAY',
            name: 'Azuay'
          }, {
            code: 'BOLIVAR',
            name: 'Bolivar'
          }, {
            code: 'CANAR',
            name: 'Canar'
          }, {
            code: 'CARCHI',
            name: 'Carchi'
          }, {
            code: 'CHIMBORAZO',
            name: 'Chimborazo'
          }, {
            code: 'COTOPAXI',
            name: 'Cotopaxi'
          }, {
            code: 'EL ORO',
            name: 'El Oro'
          }, {
            code: 'ESMERALDAS',
            name: 'Esmeraldas'
          }, {
            code: 'GALAPAGOS',
            name: 'Galapagos'
          }, {
            code: 'GUAYAS',
            name: 'Guayas'
          }, {
            code: 'IMBABURA',
            name: 'Imbabura'
          }, {
            code: 'LOJA',
            name: 'Loja'
          }, {
            code: 'LOS RIOS',
            name: 'Los Rios'
          }, {
            code: 'MANABI',
            name: 'Manabi'
          }, {
            code: 'MORONA-SANTIAGO',
            name: 'Morona-Santiago'
          }, {
            code: 'NAPO',
            name: 'Napo'
          }, {
            code: 'ORELLANA',
            name: 'Orellana'
          }, {
            code: 'PASTAZA',
            name: 'Pastaza'
          }, {
            code: 'PICHINCHA',
            name: 'Pichincha'
          }, {
            code: 'SUCUMBIOS',
            name: 'Sucumbios'
          }, {
            code: 'TUNGURAHUA',
            name: 'Tungurahua'
          }, {
            code: 'ZAMORA-CHINCHIPE',
            name: 'Zamora-Chinchipe'
          }];
        case 'EG':
          return [{
            code: 'AD DAQAHLIYAH',
            name: 'Ad Daqahliyah'
          }, {
            code: 'AL BAHR AL AHMAR',
            name: 'Al Bahr al Ahmar'
          }, {
            code: 'AL BUHAYRAH',
            name: 'Al Buhayrah'
          }, {
            code: 'AL FAYYUM',
            name: 'Al Fayyum'
          }, {
            code: 'AL GHARBIYAH',
            name: 'Al Gharbiyah'
          }, {
            code: 'AL ISKANDARIYAH',
            name: 'Al Iskandariyah'
          }, {
            code: 'AL ISMAILIYAH',
            name: 'Al Ismailiyah'
          }, {
            code: 'AL JIZAH',
            name: 'Al Jizah'
          }, {
            code: 'AL MINUFIYAH',
            name: 'Al Minufiyah'
          }, {
            code: 'AL MINYA',
            name: 'Al Minya'
          }, {
            code: 'AL QAHIRAH',
            name: 'Al Qahirah'
          }, {
            code: 'AL QALYUBIYAH',
            name: 'Al Qalyubiyah'
          }, {
            code: 'AL WADI AL JADID',
            name: 'Al Wadi al Jadid'
          }, {
            code: 'AS SUWAYS',
            name: 'As Suways'
          }, {
            code: 'ASH SHARQIYAH',
            name: 'Ash Sharqiyah'
          }, {
            code: 'ASWAN',
            name: 'Aswan'
          }, {
            code: 'ASYUT',
            name: 'Asyut'
          }, {
            code: 'BANI SUWAYF',
            name: 'Bani Suwayf'
          }, {
            code: 'BUR SAID',
            name: 'Bur Said'
          }, {
            code: 'DUMYAT',
            name: 'Dumyat'
          }, {
            code: 'JANUB SINA',
            name: 'Janub Sina'
          }, {
            code: 'KAFR ASH SHAYKH',
            name: 'Kafr ash Shaykh'
          }, {
            code: 'MATRUH',
            name: 'Matruh'
          }, {
            code: 'QINA',
            name: 'Qina'
          }, {
            code: 'SHAMAL SINA',
            name: 'Shamal Sina'
          }, {
            code: 'SUHAJ',
            name: 'Suhaj'
          }];
        case 'SV':
          return [{
            code: 'AHUACHAPAN',
            name: 'Ahuachapan'
          }, {
            code: 'CABANAS',
            name: 'Cabanas'
          }, {
            code: 'CHALATENANGO',
            name: 'Chalatenango'
          }, {
            code: 'CUSCATLAN',
            name: 'Cuscatlan'
          }, {
            code: 'LA LIBERTAD',
            name: 'La Libertad'
          }, {
            code: 'LA PAZ',
            name: 'La Paz'
          }, {
            code: 'LA UNION',
            name: 'La Union'
          }, {
            code: 'MORAZAN',
            name: 'Morazan'
          }, {
            code: 'SAN MIGUEL',
            name: 'San Miguel'
          }, {
            code: 'SAN SALVADOR',
            name: 'San Salvador'
          }, {
            code: 'SAN VICENTE',
            name: 'San Vicente'
          }, {
            code: 'SANTA ANA',
            name: 'Santa Ana'
          }, {
            code: 'SONSONATE',
            name: 'Sonsonate'
          }, {
            code: 'USULUTAN',
            name: 'Usulutan'
          }];
        case 'GQ':
          return [{
            code: 'ANNOBON',
            name: 'Annobon'
          }, {
            code: 'BIOKO NORTE',
            name: 'Bioko Norte'
          }, {
            code: 'BIOKO SUR',
            name: 'Bioko Sur'
          }, {
            code: 'CENTRO SUR',
            name: 'Centro Sur'
          }, {
            code: 'KIE-NTEM',
            name: 'Kie-Ntem'
          }, {
            code: 'LITORAL',
            name: 'Litoral'
          }, {
            code: 'WELE-NZAS',
            name: 'Wele-Nzas'
          }];
        case 'ER':
          return [{
            code: 'AKALE GUZAY',
            name: 'Akale Guzay'
          }, {
            code: 'BARKA',
            name: 'Barka'
          }, {
            code: 'DENKEL',
            name: 'Denkel'
          }, {
            code: 'HAMASEN',
            name: 'Hamasen'
          }, {
            code: 'SAHIL',
            name: 'Sahil'
          }, {
            code: 'SEMHAR',
            name: 'Semhar'
          }, {
            code: 'SENHIT',
            name: 'Senhit'
          }, {
            code: 'SERAYE',
            name: 'Seraye'
          }];
        case 'EE':
          return [{
            code: 'HARJUMAA (TALLINN)',
            name: 'Harjumaa (Tallinn)'
          }, {
            code: 'HIIUMAA (KARDLA)',
            name: 'Hiiumaa (Kardla)'
          }, {
            code: 'IDA-VIRUMAA (JOHVI)',
            name: 'Ida-Virumaa (Johvi)'
          }, {
            code: 'JARVAMAA (PAIDE)',
            name: 'Jarvamaa (Paide)'
          }, {
            code: 'JOGEVAMAA (JOGEVA)',
            name: 'Jogevamaa (Jogeva)'
          }, {
            code: 'LAANE-VIRUMAA (RAKVERE)',
            name: 'Laane-Virumaa (Rakvere)'
          }, {
            code: 'LAANEMAA (HAAPSALU)',
            name: 'Laanemaa (Haapsalu)'
          }, {
            code: 'PARNUMAA (PARNU)',
            name: 'Parnumaa (Parnu)'
          }, {
            code: 'POLVAMAA (POLVA)',
            name: 'Polvamaa (Polva)'
          }, {
            code: 'RAPLAMAA (RAPLA)',
            name: 'Raplamaa (Rapla)'
          }, {
            code: 'SAAREMAA (KUESSAARE)',
            name: 'Saaremaa (Kuessaare)'
          }, {
            code: 'TARTUMAA (TARTU)',
            name: 'Tartumaa (Tartu)'
          }, {
            code: 'VALGAMAA (VALGA)',
            name: 'Valgamaa (Valga)'
          }, {
            code: 'VILJANDIMAA (VILJANDI)',
            name: 'Viljandimaa (Viljandi)'
          }, {
            code: 'VORUMAA (VORU)',
            name: 'Vorumaa (Voru)'
          }];
        case 'ET':
          return [{
            code: 'ADIS ABEBA (ADDIS ABABA)',
            name: 'Adis Abeba (Addis Ababa)'
          }, {
            code: 'AFAR',
            name: 'Afar'
          }, {
            code: 'AMARA',
            name: 'Amara'
          }, {
            code: 'DIRE DAWA',
            name: 'Dire Dawa'
          }, {
            code: 'GAMBELA HIZBOCH',
            name: 'Gambela Hizboch'
          }, {
            code: 'HARERI HIZB',
            name: 'Hareri Hizb'
          }, {
            code: 'OROMIYA',
            name: 'Oromiya'
          }, {
            code: 'SUMALE',
            name: 'Sumale'
          }, {
            code: 'TIGRAY',
            name: 'Tigray'
          }, {
            code: 'YEDEBUB BIHEROCH BIHERESEBOCH NA HIZBOCH',
            name: 'YeDebub Biheroch Bihereseboch na Hizboch'
          }];
        case 'FO':
          return [{
            code: 'BORDOY',
            name: 'Bordoy'
          }, {
            code: 'EYSTUROY',
            name: 'Eysturoy'
          }, {
            code: 'MYKINES',
            name: 'Mykines'
          }, {
            code: 'SANDOY',
            name: 'Sandoy'
          }, {
            code: 'SKUVOY',
            name: 'Skuvoy'
          }, {
            code: 'STREYMOY',
            name: 'Streymoy'
          }, {
            code: 'SUDUROY',
            name: 'Suduroy'
          }, {
            code: 'TVOROYRI',
            name: 'Tvoroyri'
          }, {
            code: 'VAGAR',
            name: 'Vagar'
          }];
        case 'FJ':
          return [{
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'EASTERN',
            name: 'Eastern'
          }, {
            code: 'NORTHERN',
            name: 'Northern'
          }, {
            code: 'ROTUMA',
            name: 'Rotuma'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'FI':
          return [{
            code: 'ALAND',
            name: 'Aland'
          }, {
            code: 'ETELA-SUOMEN LAANI',
            name: 'Etela-Suomen Laani'
          }, {
            code: 'ITA-SUOMEN LAANI',
            name: 'Ita-Suomen Laani'
          }, {
            code: 'LANSI-SUOMEN LAANI',
            name: 'Lansi-Suomen Laani'
          }, {
            code: 'LAPPI',
            name: 'Lappi'
          }, {
            code: 'OULUN LAANI',
            name: 'Oulun Laani'
          }];
        case 'FR':
          return [{
            code: 'ALSACE',
            name: 'Alsace'
          }, {
            code: 'AQUITAINE',
            name: 'Aquitaine'
          }, {
            code: 'AUVERGNE',
            name: 'Auvergne'
          }, {
            code: 'BASSE-NORMANDIE',
            name: 'Basse-Normandie'
          }, {
            code: 'BOURGOGNE',
            name: 'Bourgogne'
          }, {
            code: 'BRETAGNE',
            name: 'Bretagne'
          }, {
            code: 'CENTRE',
            name: 'Centre'
          }, {
            code: 'CHAMPAGNE-ARDENNE',
            name: 'Champagne-Ardenne'
          }, {
            code: 'CORSE',
            name: 'Corse'
          }, {
            code: 'FRANCHE-COMTE',
            name: 'Franche-Comte'
          }, {
            code: 'HAUTE-NORMANDIE',
            name: 'Haute-Normandie'
          }, {
            code: 'ILE-DE-FRANCE',
            name: 'Ile-de-France'
          }, {
            code: 'LANGUEDOC-ROUSSILLON',
            name: 'Languedoc-Roussillon'
          }, {
            code: 'LIMOUSIN',
            name: 'Limousin'
          }, {
            code: 'LORRAINE',
            name: 'Lorraine'
          }, {
            code: 'MIDI-PYRENEES',
            name: 'Midi-Pyrenees'
          }, {
            code: 'NORD-PAS-DE-CALAIS',
            name: 'Nord-Pas-de-Calais'
          }, {
            code: 'PAYS DE LA LOIRE',
            name: 'Pays de la Loire'
          }, {
            code: 'PICARDIE',
            name: 'Picardie'
          }, {
            code: 'POITOU-CHARENTES',
            name: 'Poitou-Charentes'
          }, {
            code: 'PROVENCE-ALPES-COTE DAZUR',
            name: 'Provence-Alpes-Cote dAzur'
          }, {
            code: 'RHONE-ALPES',
            name: 'Rhone-Alpes'
          }];
        case 'GF':
          return [{
            code: 'FRENCH GUIANA',
            name: 'French Guiana'
          }];
        case 'PF':
          return [{
            code: 'ARCHIPEL DES MARQUISES',
            name: 'Archipel des Marquises'
          }, {
            code: 'ARCHIPEL DES TUAMOTU',
            name: 'Archipel des Tuamotu'
          }, {
            code: 'ARCHIPEL DES TUBUAI',
            name: 'Archipel des Tubuai'
          }, {
            code: 'ILES DU VENT',
            name: 'Iles du Vent'
          }, {
            code: 'ILES SOUS-LE-VENT',
            name: 'Iles Sous-le-Vent'
          }];
        case 'GH':
          return [{
            code: 'ESTUAIRE',
            name: 'Estuaire'
          }, {
            code: 'HAUT-OGOOUE',
            name: 'Haut-Ogooue'
          }, {
            code: 'MOYEN-OGOOUE',
            name: 'Moyen-Ogooue'
          }, {
            code: 'NGOUNIE',
            name: 'Ngounie'
          }, {
            code: 'NYANGA',
            name: 'Nyanga'
          }, {
            code: 'OGOOUE-IVINDO',
            name: 'Ogooue-Ivindo'
          }, {
            code: 'OGOOUE-LOLO',
            name: 'Ogooue-Lolo'
          }, {
            code: 'OGOOUE-MARITIME',
            name: 'Ogooue-Maritime'
          }, {
            code: 'WOLEU-NTEM',
            name: 'Woleu-Ntem'
          }];
        case 'GE':
          return [{
            code: 'ABASHIS',
            name: 'Abashis'
          }, {
            code: 'ABKHAZIA OR APKHAZETIS AVTONOMIURI RESPUBLIKA (SOKHUMI)',
            name: 'Abkhazia or Apkhazetis Avtonomiuri Respublika (Sokhumi)'
          }, {
            code: 'ADIGENIS',
            name: 'Adigenis'
          }, {
            code: 'AJARIA OR ACHARIS AVTONOMIURI RESPUBLIKA (BATUMI)',
            name: 'Ajaria or Acharis Avtonomiuri Respublika (Batumi)'
          }, {
            code: 'AKHALGORIS',
            name: 'Akhalgoris'
          }, {
            code: 'AKHALKALAKIS',
            name: 'Akhalkalakis'
          }, {
            code: 'AKHALTSIKHIS',
            name: 'Akhaltsikhis'
          }, {
            code: 'AKHMETIS',
            name: 'Akhmetis'
          }, {
            code: 'AMBROLAURIS',
            name: 'Ambrolauris'
          }, {
            code: 'ASPINDZIS',
            name: 'Aspindzis'
          }, {
            code: 'BAGHDATIS',
            name: 'Baghdatis'
          }, {
            code: 'BOLNISIS',
            name: 'Bolnisis'
          }, {
            code: 'BORJOMIS',
            name: 'Borjomis'
          }, {
            code: 'CHKHOROTSQUS',
            name: 'Chkhorotsqus'
          }, {
            code: 'CHOKHATAURIS',
            name: 'Chokhatauris'
          }, {
            code: 'CHIATURA',
            name: 'Chiatura'
          }, {
            code: 'DEDOPLISTSQAROS',
            name: 'Dedoplistsqaros'
          }, {
            code: 'DMANISIS',
            name: 'Dmanisis'
          }, {
            code: 'DUSHETIS',
            name: 'Dushetis'
          }, {
            code: 'GARDABANIS',
            name: 'Gardabanis'
          }, {
            code: 'GORI',
            name: 'Gori'
          }, {
            code: 'GORIS',
            name: 'Goris'
          }, {
            code: 'GURJAANIS',
            name: 'Gurjaanis'
          }, {
            code: 'JAVIS',
            name: 'Javis'
          }, {
            code: 'KARELIS',
            name: 'Karelis'
          }, {
            code: 'KUTAISI',
            name: 'Kutaisi'
          }, {
            code: 'KASPIS',
            name: 'Kaspis'
          }, {
            code: 'KHARAGAULIS',
            name: 'Kharagaulis'
          }, {
            code: 'KHASHURIS',
            name: 'Khashuris'
          }, {
            code: 'KHOBIS',
            name: 'Khobis'
          }, {
            code: 'KHONIS',
            name: 'Khonis'
          }, {
            code: 'LAGODEKHIS',
            name: 'Lagodekhis'
          }, {
            code: 'LANCHKHUTIS',
            name: 'Lanchkhutis'
          }, {
            code: 'LENTEKHIS',
            name: 'Lentekhis'
          }, {
            code: 'MARNEULIS',
            name: 'Marneulis'
          }, {
            code: 'MARTVILIS',
            name: 'Martvilis'
          }, {
            code: 'MESTIIS',
            name: 'Mestiis'
          }, {
            code: 'MTSKHETIS',
            name: 'Mtskhetis'
          }, {
            code: 'NINOTSMINDIS',
            name: 'Ninotsmindis'
          }, {
            code: 'ONIS',
            name: 'Onis'
          }, {
            code: 'OZURGETIS',
            name: 'Ozurgetis'
          }, {
            code: 'POTI',
            name: 'Poti'
          }, {
            code: 'QAZBEGIS',
            name: 'Qazbegis'
          }, {
            code: 'QVARLIS',
            name: 'Qvarlis'
          }, {
            code: 'RUSTAVI',
            name: 'Rustavi'
          }, {
            code: 'SACHKHERIS',
            name: 'Sachkheris'
          }, {
            code: 'SAGAREJOS',
            name: 'Sagarejos'
          }, {
            code: 'SAMTREDIIS',
            name: 'Samtrediis'
          }, {
            code: 'SENAKIS',
            name: 'Senakis'
          }, {
            code: 'SIGHNAGHIS',
            name: 'Sighnaghis'
          }, {
            code: 'TBILISI',
            name: 'Tbilisi'
          }, {
            code: 'TELAVIS',
            name: 'Telavis'
          }, {
            code: 'TERJOLIS',
            name: 'Terjolis'
          }, {
            code: 'TETRITSQAROS',
            name: 'Tetritsqaros'
          }, {
            code: 'TIANETIS',
            name: 'Tianetis'
          }, {
            code: 'TQIBULI',
            name: 'Tqibuli'
          }, {
            code: 'TSAGERIS',
            name: 'Tsageris'
          }, {
            code: 'TSALENJIKHIS',
            name: 'Tsalenjikhis'
          }, {
            code: 'TSALKIS',
            name: 'Tsalkis'
          }, {
            code: 'TSQALTUBO',
            name: 'Tsqaltubo'
          }, {
            code: 'VANIS',
            name: 'Vanis'
          }, {
            code: 'ZESTAPONIS',
            name: 'Zestaponis'
          }, {
            code: 'ZUGDIDI',
            name: 'Zugdidi'
          }, {
            code: 'ZUGDIDIS',
            name: 'Zugdidis'
          }];
        case 'DE':
          return [{
            code: 'BADEN-WUERTTEMBERG',
            name: 'Baden-Wuerttemberg'
          }, {
            code: 'BAYERN',
            name: 'Bayern'
          }, {
            code: 'BERLIN',
            name: 'Berlin'
          }, {
            code: 'BRANDENBURG',
            name: 'Brandenburg'
          }, {
            code: 'BREMEN',
            name: 'Bremen'
          }, {
            code: 'HAMBURG',
            name: 'Hamburg'
          }, {
            code: 'HESSEN',
            name: 'Hessen'
          }, {
            code: 'MECKLENBURG-VORPOMMERN',
            name: 'Mecklenburg-Vorpommern'
          }, {
            code: 'NIEDERSACHSEN',
            name: 'Niedersachsen'
          }, {
            code: 'NORDRHEIN-WESTFALEN',
            name: 'Nordrhein-Westfalen'
          }, {
            code: 'RHEINLAND-PFALZ',
            name: 'Rheinland-Pfalz'
          }, {
            code: 'SAARLAND',
            name: 'Saarland'
          }, {
            code: 'SACHSEN',
            name: 'Sachsen'
          }, {
            code: 'SACHSEN-ANHALT',
            name: 'Sachsen-Anhalt'
          }, {
            code: 'SCHLESWIG-HOLSTEIN',
            name: 'Schleswig-Holstein'
          }, {
            code: 'THUERINGEN',
            name: 'Thueringen'
          }];
        case 'GH':
          return [{
            code: 'ASHANTI',
            name: 'Ashanti'
          }, {
            code: 'BRONG-AHAFO',
            name: 'Brong-Ahafo'
          }, {
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'EASTERN',
            name: 'Eastern'
          }, {
            code: 'GREATER ACCRA',
            name: 'Greater Accra'
          }, {
            code: 'NORTHERN',
            name: 'Northern'
          }, {
            code: 'UPPER EAST',
            name: 'Upper East'
          }, {
            code: 'UPPER WEST',
            name: 'Upper West'
          }, {
            code: 'VOLTA',
            name: 'Volta'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'GI':
          return [{
            code: 'GIBRALTAR',
            name: 'Gibraltar'
          }];
        case 'GR':
          return [{
            code: 'AITOLIA KAI AKARNANIA',
            name: 'Aitolia kai Akarnania'
          }, {
            code: 'AKHAIA',
            name: 'Akhaia'
          }, {
            code: 'ARGOLIS',
            name: 'Argolis'
          }, {
            code: 'ARKADHIA',
            name: 'Arkadhia'
          }, {
            code: 'ARTA',
            name: 'Arta'
          }, {
            code: 'ATTIKI',
            name: 'Attiki'
          }, {
            code: 'AYION OROS (MT. ATHOS)',
            name: 'Ayion Oros (Mt. Athos)'
          }, {
            code: 'DHODHEKANISOS',
            name: 'Dhodhekanisos'
          }, {
            code: 'DRAMA',
            name: 'Drama'
          }, {
            code: 'EVRITANIA',
            name: 'Evritania'
          }, {
            code: 'EVROS',
            name: 'Evros'
          }, {
            code: 'EVVOIA',
            name: 'Evvoia'
          }, {
            code: 'FLORINA',
            name: 'Florina'
          }, {
            code: 'FOKIS',
            name: 'Fokis'
          }, {
            code: 'FTHIOTIS',
            name: 'Fthiotis'
          }, {
            code: 'GREVENA',
            name: 'Grevena'
          }, {
            code: 'ILIA',
            name: 'Ilia'
          }, {
            code: 'IMATHIA',
            name: 'Imathia'
          }, {
            code: 'IOANNINA',
            name: 'Ioannina'
          }, {
            code: 'IRAKLEION',
            name: 'Irakleion'
          }, {
            code: 'KARDHITSA',
            name: 'Kardhitsa'
          }, {
            code: 'KASTORIA',
            name: 'Kastoria'
          }, {
            code: 'KAVALA',
            name: 'Kavala'
          }, {
            code: 'KEFALLINIA',
            name: 'Kefallinia'
          }, {
            code: 'KERKYRA',
            name: 'Kerkyra'
          }, {
            code: 'KHALKIDHIKI',
            name: 'Khalkidhiki'
          }, {
            code: 'KHANIA',
            name: 'Khania'
          }, {
            code: 'KHIOS',
            name: 'Khios'
          }, {
            code: 'KIKLADHES',
            name: 'Kikladhes'
          }, {
            code: 'KILKIS',
            name: 'Kilkis'
          }, {
            code: 'KORINTHIA',
            name: 'Korinthia'
          }, {
            code: 'KOZANI',
            name: 'Kozani'
          }, {
            code: 'LAKONIA',
            name: 'Lakonia'
          }, {
            code: 'LARISA',
            name: 'Larisa'
          }, {
            code: 'LASITHI',
            name: 'Lasithi'
          }, {
            code: 'LESVOS',
            name: 'Lesvos'
          }, {
            code: 'LEVKAS',
            name: 'Levkas'
          }, {
            code: 'MAGNISIA',
            name: 'Magnisia'
          }, {
            code: 'MESSINIA',
            name: 'Messinia'
          }, {
            code: 'PELLA',
            name: 'Pella'
          }, {
            code: 'PIERIA',
            name: 'Pieria'
          }, {
            code: 'PREVEZA',
            name: 'Preveza'
          }, {
            code: 'RETHIMNI',
            name: 'Rethimni'
          }, {
            code: 'RODHOPI',
            name: 'Rodhopi'
          }, {
            code: 'SAMOS',
            name: 'Samos'
          }, {
            code: 'SERRAI',
            name: 'Serrai'
          }, {
            code: 'THESPROTIA',
            name: 'Thesprotia'
          }, {
            code: 'THESSALONIKI',
            name: 'Thessaloniki'
          }, {
            code: 'TRIKALA',
            name: 'Trikala'
          }, {
            code: 'VOIOTIA',
            name: 'Voiotia'
          }, {
            code: 'XANTHI',
            name: 'Xanthi'
          }, {
            code: 'ZAKINTHOS',
            name: 'Zakinthos'
          }];
        case 'GL':
          return [{
            code: 'AVANNAA (NORDGRONLAND)',
            name: 'Avannaa (Nordgronland)'
          }, {
            code: 'KITAA (VESTGRONLAND)',
            name: 'Kitaa (Vestgronland)'
          }, {
            code: 'TUNU (OSTGRONLAND)',
            name: 'Tunu (Ostgronland)'
          }];
        case 'GD':
          return [{
            code: 'CARRIACOU AND PETIT MARTINIQUE',
            name: 'Carriacou and Petit Martinique'
          }, {
            code: 'SAINT ANDREW',
            name: 'Saint Andrew'
          }, {
            code: 'SAINT DAVID',
            name: 'Saint David'
          }, {
            code: 'SAINT GEORGE',
            name: 'Saint George'
          }, {
            code: 'SAINT JOHN',
            name: 'Saint John'
          }, {
            code: 'SAINT MARK',
            name: 'Saint Mark'
          }, {
            code: 'SAINT PATRICK',
            name: 'Saint Patrick'
          }];
        case 'GP':
          return [{
            code: 'BASSE-TERRE',
            name: 'Basse-Terre'
          }, {
            code: 'GRANDE-TERRE',
            name: 'Grande-Terre'
          }, {
            code: 'ILES DE LA PETITE TERRE',
            name: 'Iles de la Petite Terre'
          }, {
            code: 'ILES DES SAINTES',
            name: 'Iles des Saintes'
          }, {
            code: 'MARIE-GALANTE',
            name: 'Marie-Galante'
          }];
        case 'GU':
          return [{
            code: 'GUAM',
            name: 'Guam'
          }];
        case 'GT':
          return [{
            code: 'ALTA VERAPAZ',
            name: 'Alta Verapaz'
          }, {
            code: 'BAJA VERAPAZ',
            name: 'Baja Verapaz'
          }, {
            code: 'CHIMALTENANGO',
            name: 'Chimaltenango'
          }, {
            code: 'CHIQUIMULA',
            name: 'Chiquimula'
          }, {
            code: 'EL PROGRESO',
            name: 'El Progreso'
          }, {
            code: 'ESCUINTLA',
            name: 'Escuintla'
          }, {
            code: 'GUATEMALA',
            name: 'Guatemala'
          }, {
            code: 'HUEHUETENANGO',
            name: 'Huehuetenango'
          }, {
            code: 'IZABAL',
            name: 'Izabal'
          }, {
            code: 'JALAPA',
            name: 'Jalapa'
          }, {
            code: 'JUTIAPA',
            name: 'Jutiapa'
          }, {
            code: 'PETEN',
            name: 'Peten'
          }, {
            code: 'QUETZALTENANGO',
            name: 'Quetzaltenango'
          }, {
            code: 'QUICHE',
            name: 'Quiche'
          }, {
            code: 'RETALHULEU',
            name: 'Retalhuleu'
          }, {
            code: 'SACATEPEQUEZ',
            name: 'Sacatepequez'
          }, {
            code: 'SAN MARCOS',
            name: 'San Marcos'
          }, {
            code: 'SANTA ROSA',
            name: 'Santa Rosa'
          }, {
            code: 'SOLOLA',
            name: 'Solola'
          }, {
            code: 'SUCHITEPEQUEZ',
            name: 'Suchitepequez'
          }, {
            code: 'TOTONICAPAN',
            name: 'Totonicapan'
          }, {
            code: 'ZACAPA',
            name: 'Zacapa'
          }];
        case 'GN':
          return [{
            code: 'BEYLA',
            name: 'Beyla'
          }, {
            code: 'BOFFA',
            name: 'Boffa'
          }, {
            code: 'BOKE',
            name: 'Boke'
          }, {
            code: 'CONAKRY',
            name: 'Conakry'
          }, {
            code: 'COYAH',
            name: 'Coyah'
          }, {
            code: 'DABOLA',
            name: 'Dabola'
          }, {
            code: 'DALABA',
            name: 'Dalaba'
          }, {
            code: 'DINGUIRAYE',
            name: 'Dinguiraye'
          }, {
            code: 'DUBREKA',
            name: 'Dubreka'
          }, {
            code: 'FARANAH',
            name: 'Faranah'
          }, {
            code: 'FORECARIAH',
            name: 'Forecariah'
          }, {
            code: 'FRIA',
            name: 'Fria'
          }, {
            code: 'GAOUAL',
            name: 'Gaoual'
          }, {
            code: 'GUECKEDOU',
            name: 'Gueckedou'
          }, {
            code: 'KANKAN',
            name: 'Kankan'
          }, {
            code: 'KEROUANE',
            name: 'Kerouane'
          }, {
            code: 'KINDIA',
            name: 'Kindia'
          }, {
            code: 'KISSIDOUGOU',
            name: 'Kissidougou'
          }, {
            code: 'KOUBIA',
            name: 'Koubia'
          }, {
            code: 'KOUNDARA',
            name: 'Koundara'
          }, {
            code: 'KOUROUSSA',
            name: 'Kouroussa'
          }, {
            code: 'LABE',
            name: 'Labe'
          }, {
            code: 'LELOUMA',
            name: 'Lelouma'
          }, {
            code: 'LOLA',
            name: 'Lola'
          }, {
            code: 'MACENTA',
            name: 'Macenta'
          }, {
            code: 'MALI',
            name: 'Mali'
          }, {
            code: 'MAMOU',
            name: 'Mamou'
          }, {
            code: 'MANDIANA',
            name: 'Mandiana'
          }, {
            code: 'NZEREKORE',
            name: 'Nzerekore'
          }, {
            code: 'PITA',
            name: 'Pita'
          }, {
            code: 'SIGUIRI',
            name: 'Siguiri'
          }, {
            code: 'TELIMELE',
            name: 'Telimele'
          }, {
            code: 'TOUGUE',
            name: 'Tougue'
          }, {
            code: 'YOMOU',
            name: 'Yomou'
          }];
        case 'GW':
          return [{
            code: 'BAFATA',
            name: 'Bafata'
          }, {
            code: 'BIOMBO',
            name: 'Biombo'
          }, {
            code: 'BISSAU',
            name: 'Bissau'
          }, {
            code: 'BOLAMA-BIJAGOS',
            name: 'Bolama-Bijagos'
          }, {
            code: 'CACHEU',
            name: 'Cacheu'
          }, {
            code: 'GABU',
            name: 'Gabu'
          }, {
            code: 'OIO',
            name: 'Oio'
          }, {
            code: 'QUINARA',
            name: 'Quinara'
          }, {
            code: 'TOMBALI',
            name: 'Tombali'
          }];
        case 'GY':
          return [{
            code: 'BARIMA-WAINI',
            name: 'Barima-Waini'
          }, {
            code: 'CUYUNI-MAZARUNI',
            name: 'Cuyuni-Mazaruni'
          }, {
            code: 'DEMERARA-MAHAICA',
            name: 'Demerara-Mahaica'
          }, {
            code: 'EAST BERBICE-CORENTYNE',
            name: 'East Berbice-Corentyne'
          }, {
            code: 'ESSEQUIBO ISLANDS-WEST DEMERARA',
            name: 'Essequibo Islands-West Demerara'
          }, {
            code: 'MAHAICA-BERBICE',
            name: 'Mahaica-Berbice'
          }, {
            code: 'POMEROON-SUPENAAM',
            name: 'Pomeroon-Supenaam'
          }, {
            code: 'POTARO-SIPARUNI',
            name: 'Potaro-Siparuni'
          }, {
            code: 'UPPER DEMERARA-BERBICE',
            name: 'Upper Demerara-Berbice'
          }, {
            code: 'UPPER TAKUTU-UPPER ESSEQUIBO',
            name: 'Upper Takutu-Upper Essequibo'
          }];
        case 'HT':
          return [{
            code: 'ARTIBONITE',
            name: 'Artibonite'
          }, {
            code: 'CENTRE',
            name: 'Centre'
          }, {
            code: 'GRANDANSE',
            name: 'GrandAnse'
          }, {
            code: 'NORD',
            name: 'Nord'
          }, {
            code: 'NORD-EST',
            name: 'Nord-Est'
          }, {
            code: 'NORD-OUEST',
            name: 'Nord-Ouest'
          }, {
            code: 'OUEST',
            name: 'Ouest'
          }, {
            code: 'SUD',
            name: 'Sud'
          }, {
            code: 'SUD-EST',
            name: 'Sud-Est'
          }];
        case 'HN':
          return [{
            code: 'ATLANTIDA',
            name: 'Atlantida'
          }, {
            code: 'CHOLUTECA',
            name: 'Choluteca'
          }, {
            code: 'COLON',
            name: 'Colon'
          }, {
            code: 'COMAYAGUA',
            name: 'Comayagua'
          }, {
            code: 'COPAN',
            name: 'Copan'
          }, {
            code: 'CORTES',
            name: 'Cortes'
          }, {
            code: 'EL PARAISO',
            name: 'El Paraiso'
          }, {
            code: 'FRANCISCO MORAZAN',
            name: 'Francisco Morazan'
          }, {
            code: 'GRACIAS A DIOS',
            name: 'Gracias a Dios'
          }, {
            code: 'INTIBUCA',
            name: 'Intibuca'
          }, {
            code: 'ISLAS DE LA BAHIA',
            name: 'Islas de la Bahia'
          }, {
            code: 'LA PAZ',
            name: 'La Paz'
          }, {
            code: 'LEMPIRA',
            name: 'Lempira'
          }, {
            code: 'OCOTEPEQUE',
            name: 'Ocotepeque'
          }, {
            code: 'OLANCHO',
            name: 'Olancho'
          }, {
            code: 'SANTA BARBARA',
            name: 'Santa Barbara'
          }, {
            code: 'VALLE',
            name: 'Valle'
          }, {
            code: 'YORO',
            name: 'Yoro'
          }];
        case 'HK':
          return [{
            code: 'HONG KONG',
            name: 'Hong Kong'
          }];
        case 'HU':
          return [{
            code: 'BACS-KISKUN',
            name: 'Bacs-Kiskun'
          }, {
            code: 'BARANYA',
            name: 'Baranya'
          }, {
            code: 'BEKES',
            name: 'Bekes'
          }, {
            code: 'BEKESCSABA',
            name: 'Bekescsaba'
          }, {
            code: 'BORSOD-ABAUJ-ZEMPLEN',
            name: 'Borsod-Abauj-Zemplen'
          }, {
            code: 'BUDAPEST',
            name: 'Budapest'
          }, {
            code: 'CSONGRAD',
            name: 'Csongrad'
          }, {
            code: 'DEBRECEN',
            name: 'Debrecen'
          }, {
            code: 'DUNAUJVAROS',
            name: 'Dunaujvaros'
          }, {
            code: 'EGER',
            name: 'Eger'
          }, {
            code: 'FEJER',
            name: 'Fejer'
          }, {
            code: 'GYOR',
            name: 'Gyor'
          }, {
            code: 'GYOR-MOSON-SOPRON',
            name: 'Gyor-Moson-Sopron'
          }, {
            code: 'HAJDU-BIHAR',
            name: 'Hajdu-Bihar'
          }, {
            code: 'HEVES',
            name: 'Heves'
          }, {
            code: 'HODMEZOVASARHELY',
            name: 'Hodmezovasarhely'
          }, {
            code: 'JASZ-NAGYKUN-SZOLNOK',
            name: 'Jasz-Nagykun-Szolnok'
          }, {
            code: 'KAPOSVAR',
            name: 'Kaposvar'
          }, {
            code: 'KECSKEMET',
            name: 'Kecskemet'
          }, {
            code: 'KOMAROM-ESZTERGOM',
            name: 'Komarom-Esztergom'
          }, {
            code: 'MISKOLC',
            name: 'Miskolc'
          }, {
            code: 'NAGYKANIZSA',
            name: 'Nagykanizsa'
          }, {
            code: 'NOGRAD',
            name: 'Nograd'
          }, {
            code: 'NYIREGYHAZA',
            name: 'Nyiregyhaza'
          }, {
            code: 'PECS',
            name: 'Pecs'
          }, {
            code: 'PEST',
            name: 'Pest'
          }, {
            code: 'SOMOGY',
            name: 'Somogy'
          }, {
            code: 'SOPRON',
            name: 'Sopron'
          }, {
            code: 'SZABOLCS-SZATMAR-BEREG',
            name: 'Szabolcs-Szatmar-Bereg'
          }, {
            code: 'SZEGED',
            name: 'Szeged'
          }, {
            code: 'SZEKESFEHERVAR',
            name: 'Szekesfehervar'
          }, {
            code: 'SZOLNOK',
            name: 'Szolnok'
          }, {
            code: 'SZOMBATHELY',
            name: 'Szombathely'
          }, {
            code: 'TATABANYA',
            name: 'Tatabanya'
          }, {
            code: 'TOLNA',
            name: 'Tolna'
          }, {
            code: 'VAS',
            name: 'Vas'
          }, {
            code: 'VESZPREM',
            name: 'Veszprem'
          }, {
            code: 'VESZPREM',
            name: 'Veszprem'
          }, {
            code: 'ZALA',
            name: 'Zala'
          }, {
            code: 'ZALAEGERSZEG',
            name: 'Zalaegerszeg'
          }];
        case 'IS':
          return [{
            code: 'AKRANES',
            name: 'Akranes'
          }, {
            code: 'AKUREYRI',
            name: 'Akureyri'
          }, {
            code: 'ARNESSYSLA',
            name: 'Arnessysla'
          }, {
            code: 'AUSTUR-BARDHASTRANDARSYSLA',
            name: 'Austur-Bardhastrandarsysla'
          }, {
            code: 'AUSTUR-HUNAVATNSSYSLA',
            name: 'Austur-Hunavatnssysla'
          }, {
            code: 'AUSTUR-SKAFTAFELLSSYSLA',
            name: 'Austur-Skaftafellssysla'
          }, {
            code: 'BORGARFJARDHARSYSLA',
            name: 'Borgarfjardharsysla'
          }, {
            code: 'DALASYSLA',
            name: 'Dalasysla'
          }, {
            code: 'EYJAFJARDHARSYSLA',
            name: 'Eyjafjardharsysla'
          }, {
            code: 'GULLBRINGUSYSLA',
            name: 'Gullbringusysla'
          }, {
            code: 'HAFNARFJORDHUR',
            name: 'Hafnarfjordhur'
          }, {
            code: 'HUSAVIK',
            name: 'Husavik'
          }, {
            code: 'ISAFJORDHUR',
            name: 'Isafjordhur'
          }, {
            code: 'KEFLAVIK',
            name: 'Keflavik'
          }, {
            code: 'KJOSARSYSLA',
            name: 'Kjosarsysla'
          }, {
            code: 'KOPAVOGUR',
            name: 'Kopavogur'
          }, {
            code: 'MYRASYSLA',
            name: 'Myrasysla'
          }, {
            code: 'NESKAUPSTADHUR',
            name: 'Neskaupstadhur'
          }, {
            code: 'NORDHUR-ISAFJARDHARSYSLA',
            name: 'Nordhur-Isafjardharsysla'
          }, {
            code: 'NORDHUR-MULASYS-LA',
            name: 'Nordhur-Mulasys-la'
          }, {
            code: 'NORDHUR-THINGEYJARSYSLA',
            name: 'Nordhur-Thingeyjarsysla'
          }, {
            code: 'OLAFSFJORDHUR',
            name: 'Olafsfjordhur'
          }, {
            code: 'RANGARVALLASYSLA',
            name: 'Rangarvallasysla'
          }, {
            code: 'REYKJAVIK',
            name: 'Reykjavik'
          }, {
            code: 'SAUDHARKROKUR',
            name: 'Saudharkrokur'
          }, {
            code: 'SEYDHISFJORDHUR',
            name: 'Seydhisfjordhur'
          }, {
            code: 'SIGLUFJORDHUR',
            name: 'Siglufjordhur'
          }, {
            code: 'SKAGAFJARDHARSYSLA',
            name: 'Skagafjardharsysla'
          }, {
            code: 'SNAEFELLSNES-OG HNAPPADALSSYSLA',
            name: 'Snaefellsnes-og Hnappadalssysla'
          }, {
            code: 'STRANDASYSLA',
            name: 'Strandasysla'
          }, {
            code: 'SUDHUR-MULASYSLA',
            name: 'Sudhur-Mulasysla'
          }, {
            code: 'SUDHUR-THINGEYJARSYSLA',
            name: 'Sudhur-Thingeyjarsysla'
          }, {
            code: 'VESTTMANNAEYJAR',
            name: 'Vesttmannaeyjar'
          }, {
            code: 'VESTUR-BARDHASTRANDARSYSLA',
            name: 'Vestur-Bardhastrandarsysla'
          }, {
            code: 'VESTUR-HUNAVATNSSYSLA',
            name: 'Vestur-Hunavatnssysla'
          }, {
            code: 'VESTUR-ISAFJARDHARSYSLA',
            name: 'Vestur-Isafjardharsysla'
          }, {
            code: 'VESTUR-SKAFTAFELLSSYSLA',
            name: 'Vestur-Skaftafellssysla'
          }];
        case 'IN':
          return [{
            code: 'ANDAMAN AND NICOBAR ISLANDS',
            name: 'Andaman and Nicobar Islands'
          }, {
            code: 'ANDHRA PRADESH',
            name: 'Andhra Pradesh'
          }, {
            code: 'ARUNACHAL PRADESH',
            name: 'Arunachal Pradesh'
          }, {
            code: 'ASSAM',
            name: 'Assam'
          }, {
            code: 'BIHAR',
            name: 'Bihar'
          }, {
            code: 'CHANDIGARH',
            name: 'Chandigarh'
          }, {
            code: 'CHHATTISGARH',
            name: 'Chhattisgarh'
          }, {
            code: 'DADRA AND NAGAR HAVELI',
            name: 'Dadra and Nagar Haveli'
          }, {
            code: 'DAMAN AND DIU',
            name: 'Daman and Diu'
          }, {
            code: 'DELHI',
            name: 'Delhi'
          }, {
            code: 'GOA',
            name: 'Goa'
          }, {
            code: 'GUJARAT',
            name: 'Gujarat'
          }, {
            code: 'HARYANA',
            name: 'Haryana'
          }, {
            code: 'HIMACHAL PRADESH',
            name: 'Himachal Pradesh'
          }, {
            code: 'JAMMU AND KASHMIR',
            name: 'Jammu and Kashmir'
          }, {
            code: 'JHARKHAND',
            name: 'Jharkhand'
          }, {
            code: 'KARNATAKA',
            name: 'Karnataka'
          }, {
            code: 'KERALA',
            name: 'Kerala'
          }, {
            code: 'LAKSHADWEEP',
            name: 'Lakshadweep'
          }, {
            code: 'MADHYA PRADESH',
            name: 'Madhya Pradesh'
          }, {
            code: 'MAHARASHTRA',
            name: 'Maharashtra'
          }, {
            code: 'MANIPUR',
            name: 'Manipur'
          }, {
            code: 'MEGHALAYA',
            name: 'Meghalaya'
          }, {
            code: 'MIZORAM',
            name: 'Mizoram'
          }, {
            code: 'NAGALAND',
            name: 'Nagaland'
          }, {
            code: 'ORISSA',
            name: 'Orissa'
          }, {
            code: 'PONDICHERRY',
            name: 'Pondicherry'
          }, {
            code: 'PUNJAB',
            name: 'Punjab'
          }, {
            code: 'RAJASTHAN',
            name: 'Rajasthan'
          }, {
            code: 'SIKKIM',
            name: 'Sikkim'
          }, {
            code: 'TAMIL NADU',
            name: 'Tamil Nadu'
          }, {
            code: 'TRIPURA',
            name: 'Tripura'
          }, {
            code: 'UTTAR PRADESH',
            name: 'Uttar Pradesh'
          }, {
            code: 'UTTARANCHAL',
            name: 'Uttaranchal'
          }, {
            code: 'WEST BENGAL',
            name: 'West Bengal'
          }];
        case 'ID':
          return [{
            code: 'ACEH',
            name: 'Aceh'
          }, {
            code: 'BALI',
            name: 'Bali'
          }, {
            code: 'BANTEN',
            name: 'Banten'
          }, {
            code: 'BENGKULU',
            name: 'Bengkulu'
          }, {
            code: 'EAST TIMOR',
            name: 'East Timor'
          }, {
            code: 'GORONTALO',
            name: 'Gorontalo'
          }, {
            code: 'IRIAN JAYA',
            name: 'Irian Jaya'
          }, {
            code: 'JAKARTA RAYA',
            name: 'Jakarta Raya'
          }, {
            code: 'JAMBI',
            name: 'Jambi'
          }, {
            code: 'JAWA BARAT',
            name: 'Jawa Barat'
          }, {
            code: 'JAWA TENGAH',
            name: 'Jawa Tengah'
          }, {
            code: 'JAWA TIMUR',
            name: 'Jawa Timur'
          }, {
            code: 'KALIMANTAN BARAT',
            name: 'Kalimantan Barat'
          }, {
            code: 'KALIMANTAN SELATAN',
            name: 'Kalimantan Selatan'
          }, {
            code: 'KALIMANTAN TENGAH',
            name: 'Kalimantan Tengah'
          }, {
            code: 'KALIMANTAN TIMUR',
            name: 'Kalimantan Timur'
          }, {
            code: 'KEPULAUAN BANGKA BELITUNG',
            name: 'Kepulauan Bangka Belitung'
          }, {
            code: 'LAMPUNG',
            name: 'Lampung'
          }, {
            code: 'MALUKU',
            name: 'Maluku'
          }, {
            code: 'MALUKU UTARA',
            name: 'Maluku Utara'
          }, {
            code: 'NUSA TENGGARA BARAT',
            name: 'Nusa Tenggara Barat'
          }, {
            code: 'NUSA TENGGARA TIMUR',
            name: 'Nusa Tenggara Timur'
          }, {
            code: 'RIAU',
            name: 'Riau'
          }, {
            code: 'SULAWESI SELATAN',
            name: 'Sulawesi Selatan'
          }, {
            code: 'SULAWESI TENGAH',
            name: 'Sulawesi Tengah'
          }, {
            code: 'SULAWESI TENGGARA',
            name: 'Sulawesi Tenggara'
          }, {
            code: 'SULAWESI UTARA',
            name: 'Sulawesi Utara'
          }, {
            code: 'SUMATERA BARAT',
            name: 'Sumatera Barat'
          }, {
            code: 'SUMATERA SELATAN',
            name: 'Sumatera Selatan'
          }, {
            code: 'SUMATERA UTARA',
            name: 'Sumatera Utara'
          }, {
            code: 'YOGYAKARTA',
            name: 'Yogyakarta'
          }];
        case 'IR':
          return [{
            code: 'ARDABIL',
            name: 'Ardabil'
          }, {
            code: 'AZARBAYJAN-E GHARBI',
            name: 'Azarbayjan-e Gharbi'
          }, {
            code: 'AZARBAYJAN-E SHARQI',
            name: 'Azarbayjan-e Sharqi'
          }, {
            code: 'BUSHEHR',
            name: 'Bushehr'
          }, {
            code: 'CHAHAR MAHALL VA BAKHTIARI',
            name: 'Chahar Mahall va Bakhtiari'
          }, {
            code: 'ESFAHAN',
            name: 'Esfahan'
          }, {
            code: 'FARS',
            name: 'Fars'
          }, {
            code: 'GILAN',
            name: 'Gilan'
          }, {
            code: 'GOLESTAN',
            name: 'Golestan'
          }, {
            code: 'HAMADAN',
            name: 'Hamadan'
          }, {
            code: 'HORMOZGAN',
            name: 'Hormozgan'
          }, {
            code: 'ILAM',
            name: 'Ilam'
          }, {
            code: 'KERMAN',
            name: 'Kerman'
          }, {
            code: 'KERMANSHAH',
            name: 'Kermanshah'
          }, {
            code: 'KHORASAN',
            name: 'Khorasan'
          }, {
            code: 'KHUZESTAN',
            name: 'Khuzestan'
          }, {
            code: 'KOHGILUYEH VA BUYER AHMAD',
            name: 'Kohgiluyeh va Buyer Ahmad'
          }, {
            code: 'KORDESTAN',
            name: 'Kordestan'
          }, {
            code: 'LORESTAN',
            name: 'Lorestan'
          }, {
            code: 'MARKAZI',
            name: 'Markazi'
          }, {
            code: 'MAZANDARAN',
            name: 'Mazandaran'
          }, {
            code: 'QAZVIN',
            name: 'Qazvin'
          }, {
            code: 'QOM',
            name: 'Qom'
          }, {
            code: 'SEMNAN',
            name: 'Semnan'
          }, {
            code: 'SISTAN VA BALUCHESTAN',
            name: 'Sistan va Baluchestan'
          }, {
            code: 'TEHRAN',
            name: 'Tehran'
          }, {
            code: 'YAZD',
            name: 'Yazd'
          }, {
            code: 'ZANJAN',
            name: 'Zanjan'
          }];
        case 'IQ':
          return [{
            code: 'AL ANBAR',
            name: 'Al Anbar'
          }, {
            code: 'AL BASRAH',
            name: 'Al Basrah'
          }, {
            code: 'AL MUTHANNA',
            name: 'Al Muthanna'
          }, {
            code: 'AL QADISIYAH',
            name: 'Al Qadisiyah'
          }, {
            code: 'AN NAJAF',
            name: 'An Najaf'
          }, {
            code: 'ARBIL',
            name: 'Arbil'
          }, {
            code: 'AS SULAYMANIYAH',
            name: 'As Sulaymaniyah'
          }, {
            code: 'AT TAMIM',
            name: 'At Tamim'
          }, {
            code: 'BABIL',
            name: 'Babil'
          }, {
            code: 'BAGHDAD',
            name: 'Baghdad'
          }, {
            code: 'DAHUK',
            name: 'Dahuk'
          }, {
            code: 'DHI QAR',
            name: 'Dhi Qar'
          }, {
            code: 'DIYALA',
            name: 'Diyala'
          }, {
            code: 'KARBALA',
            name: 'Karbala'
          }, {
            code: 'MAYSAN',
            name: 'Maysan'
          }, {
            code: 'NINAWA',
            name: 'Ninawa'
          }, {
            code: 'SALAH AD DIN',
            name: 'Salah ad Din'
          }, {
            code: 'WASIT',
            name: 'Wasit'
          }];
        case 'IE':
          return [{
            code: 'CARLOW',
            name: 'Carlow'
          }, {
            code: 'CAVAN',
            name: 'Cavan'
          }, {
            code: 'CLARE',
            name: 'Clare'
          }, {
            code: 'CORK',
            name: 'Cork'
          }, {
            code: 'DONEGAL',
            name: 'Donegal'
          }, {
            code: 'DUBLIN',
            name: 'Dublin'
          }, {
            code: 'GALWAY',
            name: 'Galway'
          }, {
            code: 'KERRY',
            name: 'Kerry'
          }, {
            code: 'KILDARE',
            name: 'Kildare'
          }, {
            code: 'KILKENNY',
            name: 'Kilkenny'
          }, {
            code: 'LAOIS',
            name: 'Laois'
          }, {
            code: 'LEITRIM',
            name: 'Leitrim'
          }, {
            code: 'LIMERICK',
            name: 'Limerick'
          }, {
            code: 'LONGFORD',
            name: 'Longford'
          }, {
            code: 'LOUTH',
            name: 'Louth'
          }, {
            code: 'MAYO',
            name: 'Mayo'
          }, {
            code: 'MEATH',
            name: 'Meath'
          }, {
            code: 'MONAGHAN',
            name: 'Monaghan'
          }, {
            code: 'OFFALY',
            name: 'Offaly'
          }, {
            code: 'ROSCOMMON',
            name: 'Roscommon'
          }, {
            code: 'SLIGO',
            name: 'Sligo'
          }, {
            code: 'TIPPERARY',
            name: 'Tipperary'
          }, {
            code: 'WATERFORD',
            name: 'Waterford'
          }, {
            code: 'WESTMEATH',
            name: 'Westmeath'
          }, {
            code: 'WEXFORD',
            name: 'Wexford'
          }, {
            code: 'WICKLOW',
            name: 'Wicklow'
          }];
        case 'IL':
          return [{
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'HAIFA',
            name: 'Haifa'
          }, {
            code: 'JERUSALEM',
            name: 'Jerusalem'
          }, {
            code: 'NORTHERN',
            name: 'Northern'
          }, {
            code: 'SOUTHERN',
            name: 'Southern'
          }, {
            code: 'TEL AVIV',
            name: 'Tel Aviv'
          }];
        case 'IT':
          return [{
            code: 'ABRUZZO',
            name: 'Abruzzo'
          }, {
            code: 'BASILICATA',
            name: 'Basilicata'
          }, {
            code: 'CALABRIA',
            name: 'Calabria'
          }, {
            code: 'CAMPANIA',
            name: 'Campania'
          }, {
            code: 'EMILIA-ROMAGNA',
            name: 'Emilia-Romagna'
          }, {
            code: 'FRIULI-VENEZIA GIULIA',
            name: 'Friuli-Venezia Giulia'
          }, {
            code: 'LAZIO',
            name: 'Lazio'
          }, {
            code: 'LIGURIA',
            name: 'Liguria'
          }, {
            code: 'LOMBARDIA',
            name: 'Lombardia'
          }, {
            code: 'MARCHE',
            name: 'Marche'
          }, {
            code: 'MOLISE',
            name: 'Molise'
          }, {
            code: 'PIEMONTE',
            name: 'Piemonte'
          }, {
            code: 'PUGLIA',
            name: 'Puglia'
          }, {
            code: 'SARDEGNA',
            name: 'Sardegna'
          }, {
            code: 'SICILIA',
            name: 'Sicilia'
          }, {
            code: 'TOSCANA',
            name: 'Toscana'
          }, {
            code: 'TRENTINO-ALTO ADIGE',
            name: 'Trentino-Alto Adige'
          }, {
            code: 'UMBRIA',
            name: 'Umbria'
          }, {
            code: 'VALLE DAOSTA',
            name: 'Valle dAosta'
          }, {
            code: 'VENETO',
            name: 'Veneto'
          }];
        case 'JM':
          return [{
            code: 'CLARENDON',
            name: 'Clarendon'
          }, {
            code: 'HANOVER',
            name: 'Hanover'
          }, {
            code: 'KINGSTON',
            name: 'Kingston'
          }, {
            code: 'MANCHESTER',
            name: 'Manchester'
          }, {
            code: 'PORTLAND',
            name: 'Portland'
          }, {
            code: 'SAINT ANDREW',
            name: 'Saint Andrew'
          }, {
            code: 'SAINT ANN',
            name: 'Saint Ann'
          }, {
            code: 'SAINT CATHERINE',
            name: 'Saint Catherine'
          }, {
            code: 'SAINT ELIZABETH',
            name: 'Saint Elizabeth'
          }, {
            code: 'SAINT JAMES',
            name: 'Saint James'
          }, {
            code: 'SAINT MARY',
            name: 'Saint Mary'
          }, {
            code: 'SAINT THOMAS',
            name: 'Saint Thomas'
          }, {
            code: 'TRELAWNY',
            name: 'Trelawny'
          }, {
            code: 'WESTMORELAND',
            name: 'Westmoreland'
          }];
        case 'JP':
          return [{
            code: 'AICHI',
            name: 'Aichi'
          }, {
            code: 'AKITA',
            name: 'Akita'
          }, {
            code: 'AOMORI',
            name: 'Aomori'
          }, {
            code: 'CHIBA',
            name: 'Chiba'
          }, {
            code: 'EHIME',
            name: 'Ehime'
          }, {
            code: 'FUKUI',
            name: 'Fukui'
          }, {
            code: 'FUKUOKA',
            name: 'Fukuoka'
          }, {
            code: 'FUKUSHIMA',
            name: 'Fukushima'
          }, {
            code: 'GIFU',
            name: 'Gifu'
          }, {
            code: 'GUMMA',
            name: 'Gumma'
          }, {
            code: 'HIROSHIMA',
            name: 'Hiroshima'
          }, {
            code: 'HOKKAIDO',
            name: 'Hokkaido'
          }, {
            code: 'HYOGO',
            name: 'Hyogo'
          }, {
            code: 'IBARAKI',
            name: 'Ibaraki'
          }, {
            code: 'ISHIKAWA',
            name: 'Ishikawa'
          }, {
            code: 'IWATE',
            name: 'Iwate'
          }, {
            code: 'KAGAWA',
            name: 'Kagawa'
          }, {
            code: 'KAGOSHIMA',
            name: 'Kagoshima'
          }, {
            code: 'KANAGAWA',
            name: 'Kanagawa'
          }, {
            code: 'KOCHI',
            name: 'Kochi'
          }, {
            code: 'KUMAMOTO',
            name: 'Kumamoto'
          }, {
            code: 'KYOTO',
            name: 'Kyoto'
          }, {
            code: 'MIE',
            name: 'Mie'
          }, {
            code: 'MIYAGI',
            name: 'Miyagi'
          }, {
            code: 'MIYAZAKI',
            name: 'Miyazaki'
          }, {
            code: 'NAGANO',
            name: 'Nagano'
          }, {
            code: 'NAGASAKI',
            name: 'Nagasaki'
          }, {
            code: 'NARA',
            name: 'Nara'
          }, {
            code: 'NIIGATA',
            name: 'Niigata'
          }, {
            code: 'OITA',
            name: 'Oita'
          }, {
            code: 'OKAYAMA',
            name: 'Okayama'
          }, {
            code: 'OKINAWA',
            name: 'Okinawa'
          }, {
            code: 'OSAKA',
            name: 'Osaka'
          }, {
            code: 'SAGA',
            name: 'Saga'
          }, {
            code: 'SAITAMA',
            name: 'Saitama'
          }, {
            code: 'SHIGA',
            name: 'Shiga'
          }, {
            code: 'SHIMANE',
            name: 'Shimane'
          }, {
            code: 'SHIZUOKA',
            name: 'Shizuoka'
          }, {
            code: 'TOCHIGI',
            name: 'Tochigi'
          }, {
            code: 'TOKUSHIMA',
            name: 'Tokushima'
          }, {
            code: 'TOKYO',
            name: 'Tokyo'
          }, {
            code: 'TOTTORI',
            name: 'Tottori'
          }, {
            code: 'TOYAMA',
            name: 'Toyama'
          }, {
            code: 'WAKAYAMA',
            name: 'Wakayama'
          }, {
            code: 'YAMAGATA',
            name: 'Yamagata'
          }, {
            code: 'YAMAGUCHI',
            name: 'Yamaguchi'
          }, {
            code: 'YAMANASHI',
            name: 'Yamanashi'
          }];
        case 'JO':
          return [{
            code: 'AMMAN',
            name: 'Amman'
          }, {
            code: 'AJLUN',
            name: 'Ajlun'
          }, {
            code: 'AL AQABAH',
            name: 'Al Aqabah'
          }, {
            code: 'AL BALQA',
            name: 'Al Balqa'
          }, {
            code: 'AL KARAK',
            name: 'Al Karak'
          }, {
            code: 'AL MAFRAQ',
            name: 'Al Mafraq'
          }, {
            code: 'AT TAFILAH',
            name: 'At Tafilah'
          }, {
            code: 'AZ ZARQA',
            name: 'Az Zarqa'
          }, {
            code: 'IRBID',
            name: 'Irbid'
          }, {
            code: 'JARASH',
            name: 'Jarash'
          }, {
            code: 'MAAN',
            name: 'Man'
          }, {
            code: 'MADABA',
            name: 'Madaba'
          }];
        case 'KZ':
          return [{
            code: 'ALMATY',
            name: 'Almaty'
          }, {
            code: 'AQMOLA',
            name: 'Aqmola'
          }, {
            code: 'AQTOBE',
            name: 'Aqtobe'
          }, {
            code: 'ASTANA',
            name: 'Astana'
          }, {
            code: 'ATYRAU',
            name: 'Atyrau'
          }, {
            code: 'BATYS QAZAQSTAN',
            name: 'Batys Qazaqstan'
          }, {
            code: 'BAYQONGYR',
            name: 'Bayqongyr'
          }, {
            code: 'MANGGHYSTAU',
            name: 'Mangghystau'
          }, {
            code: 'ONGTUSTIK QAZAQSTAN',
            name: 'Ongtustik Qazaqstan'
          }, {
            code: 'PAVLODAR',
            name: 'Pavlodar'
          }, {
            code: 'QARAGHANDY',
            name: 'Qaraghandy'
          }, {
            code: 'QOSTANAY',
            name: 'Qostanay'
          }, {
            code: 'QYZYLORDA',
            name: 'Qyzylorda'
          }, {
            code: 'SHYGHYS QAZAQSTAN',
            name: 'Shyghys Qazaqstan'
          }, {
            code: 'SOLTUSTIK QAZAQSTAN',
            name: 'Soltustik Qazaqstan'
          }, {
            code: 'ZHAMBYL',
            name: 'Zhambyl'
          }];
        case 'KE':
          return [{
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'COAST',
            name: 'Coast'
          }, {
            code: 'EASTERN',
            name: 'Eastern'
          }, {
            code: 'NAIROBI AREA',
            name: 'Nairobi Area'
          }, {
            code: 'NORTH EASTERN',
            name: 'North Eastern'
          }, {
            code: 'NYANZA',
            name: 'Nyanza'
          }, {
            code: 'RIFT VALLEY',
            name: 'Rift Valley'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'KI':
          return [{
            code: 'ABAIANG',
            name: 'Abaiang'
          }, {
            code: 'ABEMAMA',
            name: 'Abemama'
          }, {
            code: 'ARANUKA',
            name: 'Aranuka'
          }, {
            code: 'ARORAE',
            name: 'Arorae'
          }, {
            code: 'BANABA',
            name: 'Banaba'
          }, {
            code: 'BANABA',
            name: 'Banaba'
          }, {
            code: 'BERU',
            name: 'Beru'
          }, {
            code: 'BUTARITARI',
            name: 'Butaritari'
          }, {
            code: 'CENTRAL GILBERTS',
            name: 'Central Gilberts'
          }, {
            code: 'GILBERT ISLANDS',
            name: 'Gilbert Islands'
          }, {
            code: 'KANTON',
            name: 'Kanton'
          }, {
            code: 'KIRITIMATI',
            name: 'Kiritimati'
          }, {
            code: 'KURIA',
            name: 'Kuria'
          }, {
            code: 'LINE ISLANDS',
            name: 'Line Islands'
          }, {
            code: 'LINE ISLANDS',
            name: 'Line Islands'
          }, {
            code: 'MAIANA',
            name: 'Maiana'
          }, {
            code: 'MAKIN',
            name: 'Makin'
          }, {
            code: 'MARAKEI',
            name: 'Marakei'
          }, {
            code: 'NIKUNAU',
            name: 'Nikunau'
          }, {
            code: 'NONOUTI',
            name: 'Nonouti'
          }, {
            code: 'NORTHERN GILBERTS',
            name: 'Northern Gilberts'
          }, {
            code: 'ONOTOA',
            name: 'Onotoa'
          }, {
            code: 'PHOENIX ISLANDS',
            name: 'Phoenix Islands'
          }, {
            code: 'SOUTHERN GILBERTS',
            name: 'Southern Gilberts'
          }, {
            code: 'TABITEUEA',
            name: 'Tabiteuea'
          }, {
            code: 'TABUAERAN',
            name: 'Tabuaeran'
          }, {
            code: 'TAMANA',
            name: 'Tamana'
          }, {
            code: 'TARAWA',
            name: 'Tarawa'
          }, {
            code: 'TARAWA',
            name: 'Tarawa'
          }, {
            code: 'TERAINA',
            name: 'Teraina'
          }];
        case 'KP':
          return [{
            code: 'CHAGANG-DO (CHAGANG PROVINCE)',
            name: 'Chagang-do (Chagang Province)'
          }, {
            code: 'HAMGYONG-BUKTO (NORTH HAMGYONG PROVINCE)',
            name: 'Hamgyong-bukto (North Hamgyong Province)'
          }, {
            code: 'HAMGYONG-NAMDO (SOUTH HAMGYONG PROVINCE)',
            name: 'Hamgyong-namdo (South Hamgyong Province)'
          }, {
            code: 'HWANGHAE-BUKTO (NORTH HWANGHAE PROVINCE)',
            name: 'Hwanghae-bukto (North Hwanghae Province)'
          }, {
            code: 'HWANGHAE-NAMDO (SOUTH HWANGHAE PROVINCE)',
            name: 'Hwanghae-namdo (South Hwanghae Province)'
          }, {
            code: 'KAESONG-SI (KAESONG CITY)',
            name: 'Kaesong-si (Kaesong City)'
          }, {
            code: 'KANGWON-DO (KANGWON PROVINCE)',
            name: 'Kangwon-do (Kangwon Province)'
          }, {
            code: 'NAMPO-SI (NAMPO CITY)',
            name: 'Nampo-si (Nampo City)'
          }, {
            code: 'PYONGAN-BUKTO (NORTH PYONGAN PROVINCE)',
            name: 'Pyongan-bukto (North Pyongan Province)'
          }, {
            code: 'PYONGAN-NAMDO (SOUTH PYONGAN PROVINCE)',
            name: 'Pyongan-namdo (South Pyongan Province)'
          }, {
            code: 'PYONGYANG-SI (PYONGYANG CITY)',
            name: 'Pyongyang-si (Pyongyang City)'
          }, {
            code: 'YANGGANG-DO (YANGGANG PROVINCE)',
            name: 'Yanggang-do (Yanggang Province)'
          }];
        case 'KR':
          return [{
            code: 'CHUNGCHONG-BUKTO',
            name: 'Chungchong-bukto'
          }, {
            code: 'CHUNGCHONG-NAMDO',
            name: 'Chungchong-namdo'
          }, {
            code: 'CHEJU-DO',
            name: 'Cheju-do'
          }, {
            code: 'CHOLLA-BUKTO',
            name: 'Cholla-bukto'
          }, {
            code: 'CHOLLA-NAMDO',
            name: 'Cholla-namdo'
          }, {
            code: 'INCHON-GWANGYOKSI',
            name: 'Inchon-gwangyoksi'
          }, {
            code: 'KANGWON-DO',
            name: 'Kangwon-do'
          }, {
            code: 'KWANGJU-GWANGYOKSI',
            name: 'Kwangju-gwangyoksi'
          }, {
            code: 'KYONGGI-DO',
            name: 'Kyonggi-do'
          }, {
            code: 'KYONGSANG-BUKTO',
            name: 'Kyongsang-bukto'
          }, {
            code: 'KYONGSANG-NAMDO',
            name: 'Kyongsang-namdo'
          }, {
            code: 'PUSAN-GWANGYOKSI',
            name: 'Pusan-gwangyoksi'
          }, {
            code: 'SOUL-TUKPYOLSI',
            name: 'Soul-tukpyolsi'
          }, {
            code: 'TAEGU-GWANGYOKSI',
            name: 'Taegu-gwangyoksi'
          }, {
            code: 'TAEJON-GWANGYOKSI',
            name: 'Taejon-gwangyoksi'
          }, {
            code: 'ULSAN-GWANGYOKSI',
            name: 'Ulsan-gwangyoksi'
          }];
        case 'KW':
          return [{
            code: 'AL ASIMAH',
            name: 'Al Asimah'
          }, {
            code: 'AL AHMADI',
            name: 'Al Ahmadi'
          }, {
            code: 'AL FARWANIYAH',
            name: 'Al Farwaniyah'
          }, {
            code: 'AL JAHRA',
            name: 'Al Jahra'
          }, {
            code: 'HAWALLI',
            name: 'Hawalli'
          }];
        case 'KG':
          return [{
            code: 'BATKEN OBLASTY',
            name: 'Batken Oblasty'
          }, {
            code: 'BISHKEK SHAARY',
            name: 'Bishkek Shaary'
          }, {
            code: 'CHUY OBLASTY (BISHKEK)',
            name: 'Chuy Oblasty (Bishkek)'
          }, {
            code: 'JALAL-ABAD OBLASTY',
            name: 'Jalal-Abad Oblasty'
          }, {
            code: 'NARYN OBLASTY',
            name: 'Naryn Oblasty'
          }, {
            code: 'OSH OBLASTY',
            name: 'Osh Oblasty'
          }, {
            code: 'TALAS OBLASTY',
            name: 'Talas Oblasty'
          }, {
            code: 'YSYK-KOL OBLASTY (KARAKOL)',
            name: 'Ysyk-Kol Oblasty (Karakol)'
          }];
        case 'LA':
          return [{
            code: 'ATTAPU',
            name: 'Attapu'
          }, {
            code: 'BOKEO',
            name: 'Bokeo'
          }, {
            code: 'BOLIKHAMXAI',
            name: 'Bolikhamxai'
          }, {
            code: 'CHAMPASAK',
            name: 'Champasak'
          }, {
            code: 'HOUAPHAN',
            name: 'Houaphan'
          }, {
            code: 'KHAMMOUAN',
            name: 'Khammouan'
          }, {
            code: 'LOUANGNAMTHA',
            name: 'Louangnamtha'
          }, {
            code: 'LOUANGPHABANG',
            name: 'Louangphabang'
          }, {
            code: 'OUDOMXAI',
            name: 'Oudomxai'
          }, {
            code: 'PHONGSALI',
            name: 'Phongsali'
          }, {
            code: 'SALAVAN',
            name: 'Salavan'
          }, {
            code: 'SAVANNAKHET',
            name: 'Savannakhet'
          }, {
            code: 'VIANGCHAN',
            name: 'Viangchan'
          }, {
            code: 'VIANGCHAN',
            name: 'Viangchan'
          }, {
            code: 'XAIGNABOULI',
            name: 'Xaignabouli'
          }, {
            code: 'XAISOMBOUN',
            name: 'Xaisomboun'
          }, {
            code: 'XEKONG',
            name: 'Xekong'
          }, {
            code: 'XIANGKHOANG',
            name: 'Xiangkhoang'
          }];
        case 'LV':
          return [{
            code: 'AIZKRAUKLES RAJONS',
            name: 'Aizkraukles Rajons'
          }, {
            code: 'ALUKSNES RAJONS',
            name: 'Aluksnes Rajons'
          }, {
            code: 'BALVU RAJONS',
            name: 'Balvu Rajons'
          }, {
            code: 'BAUSKAS RAJONS',
            name: 'Bauskas Rajons'
          }, {
            code: 'CESU RAJONS',
            name: 'Cesu Rajons'
          }, {
            code: 'DAUGAVPILS',
            name: 'Daugavpils'
          }, {
            code: 'DAUGAVPILS RAJONS',
            name: 'Daugavpils Rajons'
          }, {
            code: 'DOBELES RAJONS',
            name: 'Dobeles Rajons'
          }, {
            code: 'GULBENES RAJONS',
            name: 'Gulbenes Rajons'
          }, {
            code: 'JEKABPILS RAJONS',
            name: 'Jekabpils Rajons'
          }, {
            code: 'JELGAVA',
            name: 'Jelgava'
          }, {
            code: 'JELGAVAS RAJONS',
            name: 'Jelgavas Rajons'
          }, {
            code: 'JURMALA',
            name: 'Jurmala'
          }, {
            code: 'KRASLAVAS RAJONS',
            name: 'Kraslavas Rajons'
          }, {
            code: 'KULDIGAS RAJONS',
            name: 'Kuldigas Rajons'
          }, {
            code: 'LEIPAJA',
            name: 'Leipaja'
          }, {
            code: 'LIEPAJAS RAJONS',
            name: 'Liepajas Rajons'
          }, {
            code: 'LIMBAZU RAJONS',
            name: 'Limbazu Rajons'
          }, {
            code: 'LUDZAS RAJONS',
            name: 'Ludzas Rajons'
          }, {
            code: 'MADONAS RAJONS',
            name: 'Madonas Rajons'
          }, {
            code: 'OGRES RAJONS',
            name: 'Ogres Rajons'
          }, {
            code: 'PREILU RAJONS',
            name: 'Preilu Rajons'
          }, {
            code: 'REZEKNE',
            name: 'Rezekne'
          }, {
            code: 'REZEKNES RAJONS',
            name: 'Rezeknes Rajons'
          }, {
            code: 'RIGA',
            name: 'Riga'
          }, {
            code: 'RIGAS RAJONS',
            name: 'Rigas Rajons'
          }, {
            code: 'SALDUS RAJONS',
            name: 'Saldus Rajons'
          }, {
            code: 'TALSU RAJONS',
            name: 'Talsu Rajons'
          }, {
            code: 'TUKUMA RAJONS',
            name: 'Tukuma Rajons'
          }, {
            code: 'VALKAS RAJONS',
            name: 'Valkas Rajons'
          }, {
            code: 'VALMIERAS RAJONS',
            name: 'Valmieras Rajons'
          }, {
            code: 'VENTSPILS',
            name: 'Ventspils'
          }, {
            code: 'VENTSPILS RAJONS',
            name: 'Ventspils Rajons'
          }];
        case 'LB':
          return [{
            code: 'BEYROUTH',
            name: 'Beyrouth'
          }, {
            code: 'ECH CHIMAL',
            name: 'Ech Chimal'
          }, {
            code: 'EJ JNOUB',
            name: 'Ej Jnoub'
          }, {
            code: 'EL BEKAA',
            name: 'El Bekaa'
          }, {
            code: 'JABAL LOUBNANE',
            name: 'Jabal Loubnane'
          }];
        case 'LS':
          return [{
            code: 'BEREA',
            name: 'Berea'
          }, {
            code: 'BUTHA-BUTHE',
            name: 'Butha-Buthe'
          }, {
            code: 'LERIBE',
            name: 'Leribe'
          }, {
            code: 'MAFETENG',
            name: 'Mafeteng'
          }, {
            code: 'MASERU',
            name: 'Maseru'
          }, {
            code: 'MOHALES HOEK',
            name: 'Mohales Hoek'
          }, {
            code: 'MOKHOTLONG',
            name: 'Mokhotlong'
          }, {
            code: 'QACHAS NEK',
            name: 'Qachas Nek'
          }, {
            code: 'QUTHING',
            name: 'Quthing'
          }, {
            code: 'THABA-TSEKA',
            name: 'Thaba-Tseka'
          }];
        case 'LR':
          return [{
            code: 'BOMI',
            name: 'Bomi'
          }, {
            code: 'BONG',
            name: 'Bong'
          }, {
            code: 'GRAND BASSA',
            name: 'Grand Bassa'
          }, {
            code: 'GRAND CAPE MOUNT',
            name: 'Grand Cape Mount'
          }, {
            code: 'GRAND GEDEH',
            name: 'Grand Gedeh'
          }, {
            code: 'GRAND KRU',
            name: 'Grand Kru'
          }, {
            code: 'LOFA',
            name: 'Lofa'
          }, {
            code: 'MARGIBI',
            name: 'Margibi'
          }, {
            code: 'MARYLAND',
            name: 'Maryland'
          }, {
            code: 'MONTSERRADO',
            name: 'Montserrado'
          }, {
            code: 'NIMBA',
            name: 'Nimba'
          }, {
            code: 'RIVER CESS',
            name: 'River Cess'
          }, {
            code: 'SINOE',
            name: 'Sinoe'
          }];
        case 'LY':
          return [{
            code: 'AJDABIYA',
            name: 'Ajdabiya'
          }, {
            code: 'AL AZIZIYAH',
            name: 'Al Aziziyah'
          }, {
            code: 'AL FATIH',
            name: 'Al Fatih'
          }, {
            code: 'AL JABAL AL AKHDAR',
            name: 'Al Jabal al Akhdar'
          }, {
            code: 'AL JUFRAH',
            name: 'Al Jufrah'
          }, {
            code: 'AL KHUMS',
            name: 'Al Khums'
          }, {
            code: 'AL KUFRAH',
            name: 'Al Kufrah'
          }, {
            code: 'AN NUQAT AL KHAMS',
            name: 'An Nuqat al Khams'
          }, {
            code: 'ASH SHATI',
            name: 'Ash Shati'
          }, {
            code: 'AWBARI',
            name: 'Awbari'
          }, {
            code: 'AZ ZAWIYAH',
            name: 'Az Zawiyah'
          }, {
            code: 'BANGHAZI',
            name: 'Banghazi'
          }, {
            code: 'DARNAH',
            name: 'Darnah'
          }, {
            code: 'GHADAMIS',
            name: 'Ghadamis'
          }, {
            code: 'GHARYAN',
            name: 'Gharyan'
          }, {
            code: 'MISRATAH',
            name: 'Misratah'
          }, {
            code: 'MURZUQ',
            name: 'Murzuq'
          }, {
            code: 'SABHA',
            name: 'Sabha'
          }, {
            code: 'SAWFAJJIN',
            name: 'Sawfajjin'
          }, {
            code: 'SURT',
            name: 'Surt'
          }, {
            code: 'TARABULUS',
            name: 'Tarabulus'
          }, {
            code: 'TARHUNAH',
            name: 'Tarhunah'
          }, {
            code: 'TUBRUQ',
            name: 'Tubruq'
          }, {
            code: 'YAFRAN',
            name: 'Yafran'
          }, {
            code: 'ZLITAN',
            name: 'Zlitan'
          }];
        case 'LI':
          return [{
            code: 'BALZERS',
            name: 'Balzers'
          }, {
            code: 'ESCHEN',
            name: 'Eschen'
          }, {
            code: 'GAMPRIN',
            name: 'Gamprin'
          }, {
            code: 'MAUREN',
            name: 'Mauren'
          }, {
            code: 'PLANKEN',
            name: 'Planken'
          }, {
            code: 'RUGGELL',
            name: 'Ruggell'
          }, {
            code: 'SCHAAN',
            name: 'Schaan'
          }, {
            code: 'SCHELLENBERG',
            name: 'Schellenberg'
          }, {
            code: 'TRIESEN',
            name: 'Triesen'
          }, {
            code: 'TRIESENBERG',
            name: 'Triesenberg'
          }, {
            code: 'VADUZ',
            name: 'Vaduz'
          }];
        case 'LT':
          return [{
            code: 'AKMENES RAJONAS',
            name: 'Akmenes Rajonas'
          }, {
            code: 'ALYTAUS RAJONAS',
            name: 'Alytaus Rajonas'
          }, {
            code: 'ALYTUS',
            name: 'Alytus'
          }, {
            code: 'ANYKSCIU RAJONAS',
            name: 'Anyksciu Rajonas'
          }, {
            code: 'BIRSTONAS',
            name: 'Birstonas'
          }, {
            code: 'BIRZU RAJONAS',
            name: 'Birzu Rajonas'
          }, {
            code: 'DRUSKININKAI',
            name: 'Druskininkai'
          }, {
            code: 'IGNALINOS RAJONAS',
            name: 'Ignalinos Rajonas'
          }, {
            code: 'JONAVOS RAJONAS',
            name: 'Jonavos Rajonas'
          }, {
            code: 'JONISKIO RAJONAS',
            name: 'Joniskio Rajonas'
          }, {
            code: 'JURBARKO RAJONAS',
            name: 'Jurbarko Rajonas'
          }, {
            code: 'KAISIADORIU RAJONAS',
            name: 'Kaisiadoriu Rajonas'
          }, {
            code: 'KAUNAS',
            name: 'Kaunas'
          }, {
            code: 'KAUNO RAJONAS',
            name: 'Kauno Rajonas'
          }, {
            code: 'KEDAINIU RAJONAS',
            name: 'Kedainiu Rajonas'
          }, {
            code: 'KELMES RAJONAS',
            name: 'Kelmes Rajonas'
          }, {
            code: 'KLAIPEDA',
            name: 'Klaipeda'
          }, {
            code: 'KLAIPEDOS RAJONAS',
            name: 'Klaipedos Rajonas'
          }, {
            code: 'KRETINGOS RAJONAS',
            name: 'Kretingos Rajonas'
          }, {
            code: 'KUPISKIO RAJONAS',
            name: 'Kupiskio Rajonas'
          }, {
            code: 'LAZDIJU RAJONAS',
            name: 'Lazdiju Rajonas'
          }, {
            code: 'MARIJAMPOLE',
            name: 'Marijampole'
          }, {
            code: 'MARIJAMPOLES RAJONAS',
            name: 'Marijampoles Rajonas'
          }, {
            code: 'MAZEIKIU RAJONAS',
            name: 'Mazeikiu Rajonas'
          }, {
            code: 'MOLETU RAJONAS',
            name: 'Moletu Rajonas'
          }, {
            code: 'NERINGA PAKRUOJO RAJONAS',
            name: 'Neringa Pakruojo Rajonas'
          }, {
            code: 'PALANGA',
            name: 'Palanga'
          }, {
            code: 'PANEVEZIO RAJONAS',
            name: 'Panevezio Rajonas'
          }, {
            code: 'PANEVEZYS',
            name: 'Panevezys'
          }, {
            code: 'PASVALIO RAJONAS',
            name: 'Pasvalio Rajonas'
          }, {
            code: 'PLUNGES RAJONAS',
            name: 'Plunges Rajonas'
          }, {
            code: 'PRIENU RAJONAS',
            name: 'Prienu Rajonas'
          }, {
            code: 'RADVILISKIO RAJONAS',
            name: 'Radviliskio Rajonas'
          }, {
            code: 'RASEINIU RAJONAS',
            name: 'Raseiniu Rajonas'
          }, {
            code: 'ROKISKIO RAJONAS',
            name: 'Rokiskio Rajonas'
          }, {
            code: 'SAKIU RAJONAS',
            name: 'Sakiu Rajonas'
          }, {
            code: 'SALCININKU RAJONAS',
            name: 'Salcininku Rajonas'
          }, {
            code: 'SIAULIAI',
            name: 'Siauliai'
          }, {
            code: 'SIAULIU RAJONAS',
            name: 'Siauliu Rajonas'
          }, {
            code: 'SILALES RAJONAS',
            name: 'Silales Rajonas'
          }, {
            code: 'SILUTES RAJONAS',
            name: 'Silutes Rajonas'
          }, {
            code: 'SIRVINTU RAJONAS',
            name: 'Sirvintu Rajonas'
          }, {
            code: 'SKUODO RAJONAS',
            name: 'Skuodo Rajonas'
          }, {
            code: 'SVENCIONIU RAJONAS',
            name: 'Svencioniu Rajonas'
          }, {
            code: 'TAURAGES RAJONAS',
            name: 'Taurages Rajonas'
          }, {
            code: 'TELSIU RAJONAS',
            name: 'Telsiu Rajonas'
          }, {
            code: 'TRAKU RAJONAS',
            name: 'Traku Rajonas'
          }, {
            code: 'UKMERGES RAJONAS',
            name: 'Ukmerges Rajonas'
          }, {
            code: 'UTENOS RAJONAS',
            name: 'Utenos Rajonas'
          }, {
            code: 'VARENOS RAJONAS',
            name: 'Varenos Rajonas'
          }, {
            code: 'VILKAVISKIO RAJONAS',
            name: 'Vilkaviskio Rajonas'
          }, {
            code: 'VILNIAUS RAJONAS',
            name: 'Vilniaus Rajonas'
          }, {
            code: 'VILNIUS',
            name: 'Vilnius'
          }, {
            code: 'ZARASU RAJONAS',
            name: 'Zarasu Rajonas'
          }];
        case 'LU':
          return [{
            code: 'DIEKIRCH',
            name: 'Diekirch'
          }, {
            code: 'GREVENMACHER',
            name: 'Grevenmacher'
          }, {
            code: 'LUXEMBOURG',
            name: 'Luxembourg'
          }];
        case 'MO':
          return [{
            code: 'MACAU',
            name: 'Macau'
          }];
        case 'MK':
          return [{
            code: 'ARACINOVO',
            name: 'Aracinovo'
          }, {
            code: 'BAC',
            name: 'Bac'
          }, {
            code: 'BELCISTA',
            name: 'Belcista'
          }, {
            code: 'BEROVO',
            name: 'Berovo'
          }, {
            code: 'BISTRICA',
            name: 'Bistrica'
          }, {
            code: 'BITOLA',
            name: 'Bitola'
          }, {
            code: 'BLATEC',
            name: 'Blatec'
          }, {
            code: 'BOGDANCI',
            name: 'Bogdanci'
          }, {
            code: 'BOGOMILA',
            name: 'Bogomila'
          }, {
            code: 'BOGOVINJE',
            name: 'Bogovinje'
          }, {
            code: 'BOSILOVO',
            name: 'Bosilovo'
          }, {
            code: 'BRVENICA',
            name: 'Brvenica'
          }, {
            code: 'CAIR (SKOPJE)',
            name: 'Cair (Skopje)'
          }, {
            code: 'CAPARI',
            name: 'Capari'
          }, {
            code: 'CASKA',
            name: 'Caska'
          }, {
            code: 'CEGRANE',
            name: 'Cegrane'
          }, {
            code: 'CENTAR (SKOPJE)',
            name: 'Centar (Skopje)'
          }, {
            code: 'CENTAR ZUPA',
            name: 'Centar Zupa'
          }, {
            code: 'CESINOVO',
            name: 'Cesinovo'
          }, {
            code: 'CUCER-SANDEVO',
            name: 'Cucer-Sandevo'
          }, {
            code: 'DEBAR',
            name: 'Debar'
          }, {
            code: 'DELCEVO',
            name: 'Delcevo'
          }, {
            code: 'DELOGOZDI',
            name: 'Delogozdi'
          }, {
            code: 'DEMIR HISAR',
            name: 'Demir Hisar'
          }, {
            code: 'DEMIR KAPIJA',
            name: 'Demir Kapija'
          }, {
            code: 'DOBRUSEVO',
            name: 'Dobrusevo'
          }, {
            code: 'DOLNA BANJICA',
            name: 'Dolna Banjica'
          }, {
            code: 'DOLNENI',
            name: 'Dolneni'
          }, {
            code: 'DORCE PETROV (SKOPJE)',
            name: 'Dorce Petrov (Skopje)'
          }, {
            code: 'DRUGOVO',
            name: 'Drugovo'
          }, {
            code: 'DZEPCISTE',
            name: 'Dzepciste'
          }, {
            code: 'GAZI BABA (SKOPJE)',
            name: 'Gazi Baba (Skopje)'
          }, {
            code: 'GEVGELIJA',
            name: 'Gevgelija'
          }, {
            code: 'GOSTIVAR',
            name: 'Gostivar'
          }, {
            code: 'GRADSKO',
            name: 'Gradsko'
          }, {
            code: 'ILINDEN',
            name: 'Ilinden'
          }, {
            code: 'IZVOR',
            name: 'Izvor'
          }, {
            code: 'JEGUNOVCE',
            name: 'Jegunovce'
          }, {
            code: 'KAMENJANE',
            name: 'Kamenjane'
          }, {
            code: 'KARBINCI',
            name: 'Karbinci'
          }, {
            code: 'KARPOS (SKOPJE)',
            name: 'Karpos (Skopje)'
          }, {
            code: 'KAVADARCI',
            name: 'Kavadarci'
          }, {
            code: 'KICEVO',
            name: 'Kicevo'
          }, {
            code: 'KISELA VODA (SKOPJE)',
            name: 'Kisela Voda (Skopje)'
          }, {
            code: 'KLECEVCE',
            name: 'Klecevce'
          }, {
            code: 'KOCANI',
            name: 'Kocani'
          }, {
            code: 'KONCE',
            name: 'Konce'
          }, {
            code: 'KONDOVO',
            name: 'Kondovo'
          }, {
            code: 'KONOPISTE',
            name: 'Konopiste'
          }, {
            code: 'KOSEL',
            name: 'Kosel'
          }, {
            code: 'KRATOVO',
            name: 'Kratovo'
          }, {
            code: 'KRIVA PALANKA',
            name: 'Kriva Palanka'
          }, {
            code: 'KRIVOGASTANI',
            name: 'Krivogastani'
          }, {
            code: 'KRUSEVO',
            name: 'Krusevo'
          }, {
            code: 'KUKLIS',
            name: 'Kuklis'
          }, {
            code: 'KUKURECANI',
            name: 'Kukurecani'
          }, {
            code: 'KUMANOVO',
            name: 'Kumanovo'
          }, {
            code: 'LABUNISTA',
            name: 'Labunista'
          }, {
            code: 'LIPKOVO',
            name: 'Lipkovo'
          }, {
            code: 'LOZOVO',
            name: 'Lozovo'
          }, {
            code: 'LUKOVO',
            name: 'Lukovo'
          }, {
            code: 'MAKEDONSKA KAMENICA',
            name: 'Makedonska Kamenica'
          }, {
            code: 'MAKEDONSKI BROD',
            name: 'Makedonski Brod'
          }, {
            code: 'MAVROVI ANOVI',
            name: 'Mavrovi Anovi'
          }, {
            code: 'MESEISTA',
            name: 'Meseista'
          }, {
            code: 'MIRAVCI',
            name: 'Miravci'
          }, {
            code: 'MOGILA',
            name: 'Mogila'
          }, {
            code: 'MURTINO',
            name: 'Murtino'
          }, {
            code: 'NEGOTINO',
            name: 'Negotino'
          }, {
            code: 'NEGOTINO-POLOSKA',
            name: 'Negotino-Poloska'
          }, {
            code: 'NOVACI',
            name: 'Novaci'
          }, {
            code: 'NOVO SELO',
            name: 'Novo Selo'
          }, {
            code: 'OBLESEVO',
            name: 'Oblesevo'
          }, {
            code: 'OHRID',
            name: 'Ohrid'
          }, {
            code: 'ORASAC',
            name: 'Orasac'
          }, {
            code: 'ORIZARI',
            name: 'Orizari'
          }, {
            code: 'OSLOMEJ',
            name: 'Oslomej'
          }, {
            code: 'PEHCEVO',
            name: 'Pehcevo'
          }, {
            code: 'PETROVEC',
            name: 'Petrovec'
          }, {
            code: 'PLASNIA',
            name: 'Plasnia'
          }, {
            code: 'PODARES',
            name: 'Podares'
          }, {
            code: 'PRILEP',
            name: 'Prilep'
          }, {
            code: 'PROBISTIP',
            name: 'Probistip'
          }, {
            code: 'RADOVIS',
            name: 'Radovis'
          }, {
            code: 'RANKOVCE',
            name: 'Rankovce'
          }, {
            code: 'RESEN',
            name: 'Resen'
          }, {
            code: 'ROSOMAN',
            name: 'Rosoman'
          }, {
            code: 'ROSTUSA',
            name: 'Rostusa'
          }, {
            code: 'SAMOKOV',
            name: 'Samokov'
          }, {
            code: 'SARAJ',
            name: 'Saraj'
          }, {
            code: 'SIPKOVICA',
            name: 'Sipkovica'
          }, {
            code: 'SOPISTE',
            name: 'Sopiste'
          }, {
            code: 'SOPOTNIKA',
            name: 'Sopotnika'
          }, {
            code: 'SRBINOVO',
            name: 'Srbinovo'
          }, {
            code: 'STAR DOJRAN',
            name: 'Star Dojran'
          }, {
            code: 'STARAVINA',
            name: 'Staravina'
          }, {
            code: 'STARO NAGORICANE',
            name: 'Staro Nagoricane'
          }, {
            code: 'STIP',
            name: 'Stip'
          }, {
            code: 'STRUGA',
            name: 'Struga'
          }, {
            code: 'STRUMICA',
            name: 'Strumica'
          }, {
            code: 'STUDENICANI',
            name: 'Studenicani'
          }, {
            code: 'SUTO ORIZARI (SKOPJE)',
            name: 'Suto Orizari (Skopje)'
          }, {
            code: 'SVETI NIKOLE',
            name: 'Sveti Nikole'
          }, {
            code: 'TEARCE',
            name: 'Tearce'
          }, {
            code: 'TETOVO',
            name: 'Tetovo'
          }, {
            code: 'TOPOLCANI',
            name: 'Topolcani'
          }, {
            code: 'VALANDOVO',
            name: 'Valandovo'
          }, {
            code: 'VASILEVO',
            name: 'Vasilevo'
          }, {
            code: 'VELES',
            name: 'Veles'
          }, {
            code: 'VELESTA',
            name: 'Velesta'
          }, {
            code: 'VEVCANI',
            name: 'Vevcani'
          }, {
            code: 'VINICA',
            name: 'Vinica'
          }, {
            code: 'VITOLISTE',
            name: 'Vitoliste'
          }, {
            code: 'VRANESTICA',
            name: 'Vranestica'
          }, {
            code: 'VRAPCISTE',
            name: 'Vrapciste'
          }, {
            code: 'VRATNICA',
            name: 'Vratnica'
          }, {
            code: 'VRUTOK',
            name: 'Vrutok'
          }, {
            code: 'ZAJAS',
            name: 'Zajas'
          }, {
            code: 'ZELENIKOVO',
            name: 'Zelenikovo'
          }, {
            code: 'ZILENO',
            name: 'Zileno'
          }, {
            code: 'ZITOSE',
            name: 'Zitose'
          }, {
            code: 'ZLETOVO',
            name: 'Zletovo'
          }, {
            code: 'ZRNOVCI',
            name: 'Zrnovci'
          }];
        case 'MG':
          return [{
            code: 'ANTANANARIVO',
            name: 'Antananarivo'
          }, {
            code: 'ANTSIRANANA',
            name: 'Antsiranana'
          }, {
            code: 'FIANARANTSOA',
            name: 'Fianarantsoa'
          }, {
            code: 'MAHAJANGA',
            name: 'Mahajanga'
          }, {
            code: 'TOAMASINA',
            name: 'Toamasina'
          }, {
            code: 'TOLIARA',
            name: 'Toliara'
          }];
        case 'MW':
          return [{
            code: 'BALAKA',
            name: 'Balaka'
          }, {
            code: 'BLANTYRE',
            name: 'Blantyre'
          }, {
            code: 'CHIKWAWA',
            name: 'Chikwawa'
          }, {
            code: 'CHIRADZULU',
            name: 'Chiradzulu'
          }, {
            code: 'CHITIPA',
            name: 'Chitipa'
          }, {
            code: 'DEDZA',
            name: 'Dedza'
          }, {
            code: 'DOWA',
            name: 'Dowa'
          }, {
            code: 'KARONGA',
            name: 'Karonga'
          }, {
            code: 'KASUNGU',
            name: 'Kasungu'
          }, {
            code: 'LIKOMA',
            name: 'Likoma'
          }, {
            code: 'LILONGWE',
            name: 'Lilongwe'
          }, {
            code: 'MACHINGA (KASUPE)',
            name: 'Machinga (Kasupe)'
          }, {
            code: 'MANGOCHI',
            name: 'Mangochi'
          }, {
            code: 'MCHINJI',
            name: 'Mchinji'
          }, {
            code: 'MULANJE',
            name: 'Mulanje'
          }, {
            code: 'MWANZA',
            name: 'Mwanza'
          }, {
            code: 'MZIMBA',
            name: 'Mzimba'
          }, {
            code: 'NKHATA BAY',
            name: 'Nkhata Bay'
          }, {
            code: 'NKHOTAKOTA',
            name: 'Nkhotakota'
          }, {
            code: 'NSANJE',
            name: 'Nsanje'
          }, {
            code: 'NTCHEU',
            name: 'Ntcheu'
          }, {
            code: 'NTCHISI',
            name: 'Ntchisi'
          }, {
            code: 'PHALOMBE',
            name: 'Phalombe'
          }, {
            code: 'RUMPHI',
            name: 'Rumphi'
          }, {
            code: 'SALIMA',
            name: 'Salima'
          }, {
            code: 'THYOLO',
            name: 'Thyolo'
          }, {
            code: 'ZOMBA',
            name: 'Zomba'
          }];
        case 'MY':
          return [{
            code: 'JOHOR',
            name: 'Johor'
          }, {
            code: 'KEDAH',
            name: 'Kedah'
          }, {
            code: 'KELANTAN',
            name: 'Kelantan'
          }, {
            code: 'LABUAN',
            name: 'Labuan'
          }, {
            code: 'MELAKA',
            name: 'Melaka'
          }, {
            code: 'NEGERI SEMBILAN',
            name: 'Negeri Sembilan'
          }, {
            code: 'PAHANG',
            name: 'Pahang'
          }, {
            code: 'PERAK',
            name: 'Perak'
          }, {
            code: 'PERLIS',
            name: 'Perlis'
          }, {
            code: 'PULAU PINANG',
            name: 'Pulau Pinang'
          }, {
            code: 'SABAH',
            name: 'Sabah'
          }, {
            code: 'SARAWAK',
            name: 'Sarawak'
          }, {
            code: 'SELANGOR',
            name: 'Selangor'
          }, {
            code: 'TERENGGANU',
            name: 'Terengganu'
          }, {
            code: 'WILAYAH PERSEKUTUAN',
            name: 'Wilayah Persekutuan'
          }];
        case 'MV':
          return [{
            code: 'ALIFU',
            name: 'Alifu'
          }, {
            code: 'BAA',
            name: 'Baa'
          }, {
            code: 'DHAALU',
            name: 'Dhaalu'
          }, {
            code: 'FAAFU',
            name: 'Faafu'
          }, {
            code: 'GAAFU ALIFU',
            name: 'Gaafu Alifu'
          }, {
            code: 'GAAFU DHAALU',
            name: 'Gaafu Dhaalu'
          }, {
            code: 'GNAVIYANI',
            name: 'Gnaviyani'
          }, {
            code: 'HAA ALIFU',
            name: 'Haa Alifu'
          }, {
            code: 'HAA DHAALU',
            name: 'Haa Dhaalu'
          }, {
            code: 'KAAFU',
            name: 'Kaafu'
          }, {
            code: 'LAAMU',
            name: 'Laamu'
          }, {
            code: 'LHAVIYANI',
            name: 'Lhaviyani'
          }, {
            code: 'MAALE',
            name: 'Maale'
          }, {
            code: 'MEEMU',
            name: 'Meemu'
          }, {
            code: 'NOONU',
            name: 'Noonu'
          }, {
            code: 'RAA',
            name: 'Raa'
          }, {
            code: 'SEENU',
            name: 'Seenu'
          }, {
            code: 'SHAVIYANI',
            name: 'Shaviyani'
          }, {
            code: 'THAA',
            name: 'Thaa'
          }, {
            code: 'VAAVU',
            name: 'Vaavu'
          }];
        case 'ML':
          return [{
            code: 'GAO',
            name: 'Gao'
          }, {
            code: 'KAYES',
            name: 'Kayes'
          }, {
            code: 'KIDAL',
            name: 'Kidal'
          }, {
            code: 'KOULIKORO',
            name: 'Koulikoro'
          }, {
            code: 'MOPTI',
            name: 'Mopti'
          }, {
            code: 'SEGOU',
            name: 'Segou'
          }, {
            code: 'SIKASSO',
            name: 'Sikasso'
          }, {
            code: 'TOMBOUCTOU',
            name: 'Tombouctou'
          }];
        case 'MT':
          return [{
            code: 'VALLETTA',
            name: 'Valletta'
          }];
        case 'MH':
          return [{
            code: 'AILINGINAE',
            name: 'Ailinginae'
          }, {
            code: 'AILINGLAPLAP',
            name: 'Ailinglaplap'
          }, {
            code: 'AILUK',
            name: 'Ailuk'
          }, {
            code: 'ARNO',
            name: 'Arno'
          }, {
            code: 'AUR',
            name: 'Aur'
          }, {
            code: 'BIKAR',
            name: 'Bikar'
          }, {
            code: 'BIKINI',
            name: 'Bikini'
          }, {
            code: 'BOKAK',
            name: 'Bokak'
          }, {
            code: 'EBON',
            name: 'Ebon'
          }, {
            code: 'ENEWETAK',
            name: 'Enewetak'
          }, {
            code: 'ERIKUB',
            name: 'Erikub'
          }, {
            code: 'JABAT',
            name: 'Jabat'
          }, {
            code: 'JALUIT',
            name: 'Jaluit'
          }, {
            code: 'JEMO',
            name: 'Jemo'
          }, {
            code: 'KILI',
            name: 'Kili'
          }, {
            code: 'KWAJALEIN',
            name: 'Kwajalein'
          }, {
            code: 'LAE',
            name: 'Lae'
          }, {
            code: 'LIB',
            name: 'Lib'
          }, {
            code: 'LIKIEP',
            name: 'Likiep'
          }, {
            code: 'MAJURO',
            name: 'Majuro'
          }, {
            code: 'MALOELAP',
            name: 'Maloelap'
          }, {
            code: 'MEJIT',
            name: 'Mejit'
          }, {
            code: 'MILI',
            name: 'Mili'
          }, {
            code: 'NAMORIK',
            name: 'Namorik'
          }, {
            code: 'NAMU',
            name: 'Namu'
          }, {
            code: 'RONGELAP',
            name: 'Rongelap'
          }, {
            code: 'RONGRIK',
            name: 'Rongrik'
          }, {
            code: 'TOKE',
            name: 'Toke'
          }, {
            code: 'UJAE',
            name: 'Ujae'
          }, {
            code: 'UJELANG',
            name: 'Ujelang'
          }, {
            code: 'UTIRIK',
            name: 'Utirik'
          }, {
            code: 'WOTHO',
            name: 'Wotho'
          }, {
            code: 'WOTJE',
            name: 'Wotje'
          }];
        case 'MQ':
          return [{
            code: 'MARTINIQUE',
            name: 'Martinique'
          }];
        case 'MR':
          return [{
            code: 'ADRAR',
            name: 'Adrar'
          }, {
            code: 'ASSABA',
            name: 'Assaba'
          }, {
            code: 'BRAKNA',
            name: 'Brakna'
          }, {
            code: 'DAKHLET NOUADHIBOU',
            name: 'Dakhlet Nouadhibou'
          }, {
            code: 'GORGOL',
            name: 'Gorgol'
          }, {
            code: 'GUIDIMAKA',
            name: 'Guidimaka'
          }, {
            code: 'HODH ECH CHARGUI',
            name: 'Hodh Ech Chargui'
          }, {
            code: 'HODH EL GHARBI',
            name: 'Hodh El Gharbi'
          }, {
            code: 'INCHIRI',
            name: 'Inchiri'
          }, {
            code: 'NOUAKCHOTT',
            name: 'Nouakchott'
          }, {
            code: 'TAGANT',
            name: 'Tagant'
          }, {
            code: 'TIRIS ZEMMOUR',
            name: 'Tiris Zemmour'
          }, {
            code: 'TRARZA',
            name: 'Trarza'
          }];
        case 'MU':
          return [{
            code: 'AGALEGA ISLANDS',
            name: 'Agalega Islands'
          }, {
            code: 'BLACK RIVER',
            name: 'Black River'
          }, {
            code: 'CARGADOS CARAJOS SHOALS',
            name: 'Cargados Carajos Shoals'
          }, {
            code: 'FLACQ',
            name: 'Flacq'
          }, {
            code: 'GRAND PORT',
            name: 'Grand Port'
          }, {
            code: 'MOKA',
            name: 'Moka'
          }, {
            code: 'PAMPLEMOUSSES',
            name: 'Pamplemousses'
          }, {
            code: 'PLAINES WILHEMS',
            name: 'Plaines Wilhems'
          }, {
            code: 'PORT LOUIS',
            name: 'Port Louis'
          }, {
            code: 'RIVIERE DU REMPART',
            name: 'Riviere du Rempart'
          }, {
            code: 'RODRIGUES',
            name: 'Rodrigues'
          }, {
            code: 'SAVANNE',
            name: 'Savanne'
          }];
        case 'YT':
          return [{
            code: 'MAYOTTE',
            name: 'Mayotte'
          }];
        case 'MX':
          return [{
            code: 'AGUASCALIENTES',
            name: 'Aguascalientes'
          }, {
            code: 'BAJA CALIFORNIA',
            name: 'Baja California'
          }, {
            code: 'BAJA CALIFORNIA SUR',
            name: 'Baja California Sur'
          }, {
            code: 'CAMPECHE',
            name: 'Campeche'
          }, {
            code: 'CHIAPAS',
            name: 'Chiapas'
          }, {
            code: 'CHIHUAHUA',
            name: 'Chihuahua'
          }, {
            code: 'COAHUILA DE ZARAGOZA',
            name: 'Coahuila de Zaragoza'
          }, {
            code: 'COLIMA',
            name: 'Colima'
          }, {
            code: 'DISTRITO FEDERAL',
            name: 'Distrito Federal'
          }, {
            code: 'DURANGO',
            name: 'Durango'
          }, {
            code: 'GUANAJUATO',
            name: 'Guanajuato'
          }, {
            code: 'GUERRERO',
            name: 'Guerrero'
          }, {
            code: 'HIDALGO',
            name: 'Hidalgo'
          }, {
            code: 'JALISCO',
            name: 'Jalisco'
          }, {
            code: 'MEXICO',
            name: 'Mexico'
          }, {
            code: 'MICHOACAN DE OCAMPO',
            name: 'Michoacan de Ocampo'
          }, {
            code: 'MORELOS',
            name: 'Morelos'
          }, {
            code: 'NAYARIT',
            name: 'Nayarit'
          }, {
            code: 'NUEVO LEON',
            name: 'Nuevo Leon'
          }, {
            code: 'OAXACA',
            name: 'Oaxaca'
          }, {
            code: 'PUEBLA',
            name: 'Puebla'
          }, {
            code: 'QUERETARO DE ARTEAGA',
            name: 'Queretaro de Arteaga'
          }, {
            code: 'QUINTANA ROO',
            name: 'Quintana Roo'
          }, {
            code: 'SAN LUIS POTOSI',
            name: 'San Luis Potosi'
          }, {
            code: 'SINALOA',
            name: 'Sinaloa'
          }, {
            code: 'SONORA',
            name: 'Sonora'
          }, {
            code: 'TABASCO',
            name: 'Tabasco'
          }, {
            code: 'TAMAULIPAS',
            name: 'Tamaulipas'
          }, {
            code: 'TLAXCALA',
            name: 'Tlaxcala'
          }, {
            code: 'VERACRUZ-LLAVE',
            name: 'Veracruz-Llave'
          }, {
            code: 'YUCATAN',
            name: 'Yucatan'
          }, {
            code: 'ZACATECAS',
            name: 'Zacatecas'
          }];
        case 'MD':
          return [{
            code: 'BALTI',
            name: 'Balti'
          }, {
            code: 'CAHUL',
            name: 'Cahul'
          }, {
            code: 'CHISINAU',
            name: 'Chisinau'
          }, {
            code: 'CHISINAU',
            name: 'Chisinau'
          }, {
            code: 'DUBASARI',
            name: 'Dubasari'
          }, {
            code: 'EDINET',
            name: 'Edinet'
          }, {
            code: 'GAGAUZIA',
            name: 'Gagauzia'
          }, {
            code: 'LAPUSNA',
            name: 'Lapusna'
          }, {
            code: 'ORHEI',
            name: 'Orhei'
          }, {
            code: 'SOROCA',
            name: 'Soroca'
          }, {
            code: 'TIGHINA',
            name: 'Tighina'
          }, {
            code: 'UNGHENI',
            name: 'Ungheni'
          }];
        case 'MC':
          return [{
            code: 'FONTVIEILLE',
            name: 'Fontvieille'
          }, {
            code: 'LA CONDAMINE',
            name: 'La Condamine'
          }, {
            code: 'MONACO-VILLE',
            name: 'Monaco-Ville'
          }, {
            code: 'MONTE-CARLO',
            name: 'Monte-Carlo'
          }];
        case 'MN':
          return [{
            code: 'ARHANGAY',
            name: 'Arhangay'
          }, {
            code: 'BAYAN-OLGIY',
            name: 'Bayan-Olgiy'
          }, {
            code: 'BAYANHONGOR',
            name: 'Bayanhongor'
          }, {
            code: 'BULGAN',
            name: 'Bulgan'
          }, {
            code: 'DARHAN',
            name: 'Darhan'
          }, {
            code: 'DORNOD',
            name: 'Dornod'
          }, {
            code: 'DORNOGOVI',
            name: 'Dornogovi'
          }, {
            code: 'DUNDGOVI',
            name: 'Dundgovi'
          }, {
            code: 'DZAVHAN',
            name: 'Dzavhan'
          }, {
            code: 'ERDENET',
            name: 'Erdenet'
          }, {
            code: 'GOVI-ALTAY',
            name: 'Govi-Altay'
          }, {
            code: 'HENTIY',
            name: 'Hentiy'
          }, {
            code: 'HOVD',
            name: 'Hovd'
          }, {
            code: 'HOVSGOL',
            name: 'Hovsgol'
          }, {
            code: 'OMNOGOVI',
            name: 'Omnogovi'
          }, {
            code: 'OVORHANGAY',
            name: 'Ovorhangay'
          }, {
            code: 'SELENGE',
            name: 'Selenge'
          }, {
            code: 'SUHBAATAR',
            name: 'Suhbaatar'
          }, {
            code: 'TOV',
            name: 'Tov'
          }, {
            code: 'ULAANBAATAR',
            name: 'Ulaanbaatar'
          }, {
            code: 'UVS',
            name: 'Uvs'
          }];
        case 'MS':
          return [{
            code: 'SAINT ANTHONY',
            name: 'Saint Anthony'
          }, {
            code: 'SAINT GEORGES',
            name: 'Saint Georges'
          }, {
            code: 'SAINT PETERS',
            name: 'Saint Peters'
          }];
        case 'MA':
          return [{
            code: 'AGADIR',
            name: 'Agadir'
          }, {
            code: 'AL HOCEIMA',
            name: 'Al Hoceima'
          }, {
            code: 'AZILAL',
            name: 'Azilal'
          }, {
            code: 'BEN SLIMANE',
            name: 'Ben Slimane'
          }, {
            code: 'BENI MELLAL',
            name: 'Beni Mellal'
          }, {
            code: 'BOULEMANE',
            name: 'Boulemane'
          }, {
            code: 'CASABLANCA',
            name: 'Casablanca'
          }, {
            code: 'CHAOUEN',
            name: 'Chaouen'
          }, {
            code: 'EL JADIDA',
            name: 'El Jadida'
          }, {
            code: 'EL KELAA DES SRARHNA',
            name: 'El Kelaa des Srarhna'
          }, {
            code: 'ER RACHIDIA',
            name: 'Er Rachidia'
          }, {
            code: 'ESSAOUIRA',
            name: 'Essaouira'
          }, {
            code: 'FES',
            name: 'Fes'
          }, {
            code: 'FIGUIG',
            name: 'Figuig'
          }, {
            code: 'GUELMIM',
            name: 'Guelmim'
          }, {
            code: 'IFRANE',
            name: 'Ifrane'
          }, {
            code: 'KENITRA',
            name: 'Kenitra'
          }, {
            code: 'KHEMISSET',
            name: 'Khemisset'
          }, {
            code: 'KHENIFRA',
            name: 'Khenifra'
          }, {
            code: 'KHOURIBGA',
            name: 'Khouribga'
          }, {
            code: 'LAAYOUNE',
            name: 'Laayoune'
          }, {
            code: 'LARACHE',
            name: 'Larache'
          }, {
            code: 'MARRAKECH',
            name: 'Marrakech'
          }, {
            code: 'MEKNES',
            name: 'Meknes'
          }, {
            code: 'NADOR',
            name: 'Nador'
          }, {
            code: 'OUARZAZATE',
            name: 'Ouarzazate'
          }, {
            code: 'OUJDA',
            name: 'Oujda'
          }, {
            code: 'RABAT-SALE',
            name: 'Rabat-Sale'
          }, {
            code: 'SAFI',
            name: 'Safi'
          }, {
            code: 'SETTAT',
            name: 'Settat'
          }, {
            code: 'SIDI KACEM',
            name: 'Sidi Kacem'
          }, {
            code: 'TAN-TAN',
            name: 'Tan-Tan'
          }, {
            code: 'TANGER',
            name: 'Tanger'
          }, {
            code: 'TAOUNATE',
            name: 'Taounate'
          }, {
            code: 'TAROUDANNT',
            name: 'Taroudannt'
          }, {
            code: 'TATA',
            name: 'Tata'
          }, {
            code: 'TAZA',
            name: 'Taza'
          }, {
            code: 'TETOUAN',
            name: 'Tetouan'
          }, {
            code: 'TIZNIT',
            name: 'Tiznit'
          }];
        case 'MZ':
          return [{
            code: 'CABO DELGADO',
            name: 'Cabo Delgado'
          }, {
            code: 'GAZA',
            name: 'Gaza'
          }, {
            code: 'INHAMBANE',
            name: 'Inhambane'
          }, {
            code: 'MANICA',
            name: 'Manica'
          }, {
            code: 'MAPUTO',
            name: 'Maputo'
          }, {
            code: 'NAMPULA',
            name: 'Nampula'
          }, {
            code: 'NIASSA',
            name: 'Niassa'
          }, {
            code: 'SOFALA',
            name: 'Sofala'
          }, {
            code: 'TETE',
            name: 'Tete'
          }, {
            code: 'ZAMBEZIA',
            name: 'Zambezia'
          }];
        case 'NA':
          return [{
            code: 'CAPRIVI',
            name: 'Caprivi'
          }, {
            code: 'ERONGO',
            name: 'Erongo'
          }, {
            code: 'HARDAP',
            name: 'Hardap'
          }, {
            code: 'KARAS',
            name: 'Karas'
          }, {
            code: 'KHOMAS',
            name: 'Khomas'
          }, {
            code: 'KUNENE',
            name: 'Kunene'
          }, {
            code: 'OHANGWENA',
            name: 'Ohangwena'
          }, {
            code: 'OKAVANGO',
            name: 'Okavango'
          }, {
            code: 'OMAHEKE',
            name: 'Omaheke'
          }, {
            code: 'OMUSATI',
            name: 'Omusati'
          }, {
            code: 'OSHANA',
            name: 'Oshana'
          }, {
            code: 'OSHIKOTO',
            name: 'Oshikoto'
          }, {
            code: 'OTJOZONDJUPA',
            name: 'Otjozondjupa'
          }];
        case 'NR':
          return [{
            code: 'AIWO',
            name: 'Aiwo'
          }, {
            code: 'ANABAR',
            name: 'Anabar'
          }, {
            code: 'ANETAN',
            name: 'Anetan'
          }, {
            code: 'ANIBARE',
            name: 'Anibare'
          }, {
            code: 'BAITI',
            name: 'Baiti'
          }, {
            code: 'BOE',
            name: 'Boe'
          }, {
            code: 'BUADA',
            name: 'Buada'
          }, {
            code: 'DENIGOMODU',
            name: 'Denigomodu'
          }, {
            code: 'EWA',
            name: 'Ewa'
          }, {
            code: 'IJUW',
            name: 'Ijuw'
          }, {
            code: 'MENENG',
            name: 'Meneng'
          }, {
            code: 'NIBOK',
            name: 'Nibok'
          }, {
            code: 'UABOE',
            name: 'Uaboe'
          }, {
            code: 'YAREN',
            name: 'Yaren'
          }];
        case 'NP':
          return [{
            code: 'BAGMATI',
            name: 'Bagmati'
          }, {
            code: 'BHERI',
            name: 'Bheri'
          }, {
            code: 'DHAWALAGIRI',
            name: 'Dhawalagiri'
          }, {
            code: 'GANDAKI',
            name: 'Gandaki'
          }, {
            code: 'JANAKPUR',
            name: 'Janakpur'
          }, {
            code: 'KARNALI',
            name: 'Karnali'
          }, {
            code: 'KOSI',
            name: 'Kosi'
          }, {
            code: 'LUMBINI',
            name: 'Lumbini'
          }, {
            code: 'MAHAKALI',
            name: 'Mahakali'
          }, {
            code: 'MECHI',
            name: 'Mechi'
          }, {
            code: 'NARAYANI',
            name: 'Narayani'
          }, {
            code: 'RAPTI',
            name: 'Rapti'
          }, {
            code: 'SAGARMATHA',
            name: 'Sagarmatha'
          }, {
            code: 'SETI',
            name: 'Seti'
          }];
        case 'NL':
          return [{
            code: 'DRENTHE',
            name: 'Drenthe'
          }, {
            code: 'FLEVOLAND',
            name: 'Flevoland'
          }, {
            code: 'FRIESLAND',
            name: 'Friesland'
          }, {
            code: 'GELDERLAND',
            name: 'Gelderland'
          }, {
            code: 'GRONINGEN',
            name: 'Groningen'
          }, {
            code: 'LIMBURG',
            name: 'Limburg'
          }, {
            code: 'NOORD-BRABANT',
            name: 'Noord-Brabant'
          }, {
            code: 'NOORD-HOLLAND',
            name: 'Noord-Holland'
          }, {
            code: 'OVERIJSSEL',
            name: 'Overijssel'
          }, {
            code: 'UTRECHT',
            name: 'Utrecht'
          }, {
            code: 'ZEELAND',
            name: 'Zeeland'
          }, {
            code: 'ZUID-HOLLAND',
            name: 'Zuid-Holland'
          }];
        case 'AN':
          return [{
            code: 'NETHERLANDS ANTILLES',
            name: 'Netherlands Antilles'
          }];
        case 'NC':
          return [{
            code: 'ILES LOYAUTE',
            name: 'Iles Loyaute'
          }, {
            code: 'NORD',
            name: 'Nord'
          }, {
            code: 'SUD',
            name: 'Sud'
          }];
        case 'NZ':
          return [{
            code: 'AKAROA',
            name: 'Akaroa'
          }, {
            code: 'AMURI',
            name: 'Amuri'
          }, {
            code: 'ASHBURTON',
            name: 'Ashburton'
          }, {
            code: 'BAY OF ISLANDS',
            name: 'Bay of Islands'
          }, {
            code: 'BRUCE',
            name: 'Bruce'
          }, {
            code: 'BULLER',
            name: 'Buller'
          }, {
            code: 'CHATHAM ISLANDS',
            name: 'Chatham Islands'
          }, {
            code: 'CHEVIOT',
            name: 'Cheviot'
          }, {
            code: 'CLIFTON',
            name: 'Clifton'
          }, {
            code: 'CLUTHA',
            name: 'Clutha'
          }, {
            code: 'COOK',
            name: 'Cook'
          }, {
            code: 'DANNEVIRKE',
            name: 'Dannevirke'
          }, {
            code: 'EGMONT',
            name: 'Egmont'
          }, {
            code: 'EKETAHUNA',
            name: 'Eketahuna'
          }, {
            code: 'ELLESMERE',
            name: 'Ellesmere'
          }, {
            code: 'ELTHAM',
            name: 'Eltham'
          }, {
            code: 'EYRE',
            name: 'Eyre'
          }, {
            code: 'FEATHERSTON',
            name: 'Featherston'
          }, {
            code: 'FRANKLIN',
            name: 'Franklin'
          }, {
            code: 'GOLDEN BAY',
            name: 'Golden Bay'
          }, {
            code: 'GREAT BARRIER ISLAND',
            name: 'Great Barrier Island'
          }, {
            code: 'GREY',
            name: 'Grey'
          }, {
            code: 'HAURAKI PLAINS',
            name: 'Hauraki Plains'
          }, {
            code: 'HAWERA',
            name: 'Hawera'
          }, {
            code: 'HAWKES BAY',
            name: 'Hawkes Bay'
          }, {
            code: 'HEATHCOTE',
            name: 'Heathcote'
          }, {
            code: 'HIKURANGI',
            name: 'Hikurangi'
          }, {
            code: 'HOBSON',
            name: 'Hobson'
          }, {
            code: 'HOKIANGA',
            name: 'Hokianga'
          }, {
            code: 'HOROWHENUA',
            name: 'Horowhenua'
          }, {
            code: 'HURUNUI',
            name: 'Hurunui'
          }, {
            code: 'HUTT',
            name: 'Hutt'
          }, {
            code: 'INANGAHUA',
            name: 'Inangahua'
          }, {
            code: 'INGLEWOOD',
            name: 'Inglewood'
          }, {
            code: 'KAIKOURA',
            name: 'Kaikoura'
          }, {
            code: 'KAIRANGA',
            name: 'Kairanga'
          }, {
            code: 'KIWITEA',
            name: 'Kiwitea'
          }, {
            code: 'LAKE',
            name: 'Lake'
          }, {
            code: 'MACKENZIE',
            name: 'Mackenzie'
          }, {
            code: 'MALVERN',
            name: 'Malvern'
          }, {
            code: 'MANAIA',
            name: 'Manaia'
          }, {
            code: 'MANAWATU',
            name: 'Manawatu'
          }, {
            code: 'MANGONUI',
            name: 'Mangonui'
          }, {
            code: 'MANIOTOTO',
            name: 'Maniototo'
          }, {
            code: 'MARLBOROUGH',
            name: 'Marlborough'
          }, {
            code: 'MASTERTON',
            name: 'Masterton'
          }, {
            code: 'MATAMATA',
            name: 'Matamata'
          }, {
            code: 'MOUNT HERBERT',
            name: 'Mount Herbert'
          }, {
            code: 'OHINEMURI',
            name: 'Ohinemuri'
          }, {
            code: 'OPOTIKI',
            name: 'Opotiki'
          }, {
            code: 'OROUA',
            name: 'Oroua'
          }, {
            code: 'OTAMATEA',
            name: 'Otamatea'
          }, {
            code: 'OTOROHANGA',
            name: 'Otorohanga'
          }, {
            code: 'OXFORD',
            name: 'Oxford'
          }, {
            code: 'PAHIATUA',
            name: 'Pahiatua'
          }, {
            code: 'PAPARUA',
            name: 'Paparua'
          }, {
            code: 'PATEA',
            name: 'Patea'
          }, {
            code: 'PIAKO',
            name: 'Piako'
          }, {
            code: 'POHANGINA',
            name: 'Pohangina'
          }, {
            code: 'RAGLAN',
            name: 'Raglan'
          }, {
            code: 'RANGIORA',
            name: 'Rangiora'
          }, {
            code: 'RANGITIKEI',
            name: 'Rangitikei'
          }, {
            code: 'RODNEY',
            name: 'Rodney'
          }, {
            code: 'ROTORUA',
            name: 'Rotorua'
          }, {
            code: 'RUNANGA',
            name: 'Runanga'
          }, {
            code: 'SAINT KILDA',
            name: 'Saint Kilda'
          }, {
            code: 'SILVERPEAKS',
            name: 'Silverpeaks'
          }, {
            code: 'SOUTHLAND',
            name: 'Southland'
          }, {
            code: 'STEWART ISLAND',
            name: 'Stewart Island'
          }, {
            code: 'STRATFORD',
            name: 'Stratford'
          }, {
            code: 'STRATHALLAN',
            name: 'Strathallan'
          }, {
            code: 'TARANAKI',
            name: 'Taranaki'
          }, {
            code: 'TAUMARUNUI',
            name: 'Taumarunui'
          }, {
            code: 'TAUPO',
            name: 'Taupo'
          }, {
            code: 'TAURANGA',
            name: 'Tauranga'
          }, {
            code: 'THAMES-COROMANDEL',
            name: 'Thames-Coromandel'
          }, {
            code: 'TUAPEKA',
            name: 'Tuapeka'
          }, {
            code: 'VINCENT',
            name: 'Vincent'
          }, {
            code: 'WAIAPU',
            name: 'Waiapu'
          }, {
            code: 'WAIHEKE',
            name: 'Waiheke'
          }, {
            code: 'WAIHEMO',
            name: 'Waihemo'
          }, {
            code: 'WAIKATO',
            name: 'Waikato'
          }, {
            code: 'WAIKOHU',
            name: 'Waikohu'
          }, {
            code: 'WAIMAIRI',
            name: 'Waimairi'
          }, {
            code: 'WAIMARINO',
            name: 'Waimarino'
          }, {
            code: 'WAIMATE',
            name: 'Waimate'
          }, {
            code: 'WAIMATE WEST',
            name: 'Waimate West'
          }, {
            code: 'WAIMEA',
            name: 'Waimea'
          }, {
            code: 'WAIPA',
            name: 'Waipa'
          }, {
            code: 'WAIPAWA',
            name: 'Waipawa'
          }, {
            code: 'WAIPUKURAU',
            name: 'Waipukurau'
          }, {
            code: 'WAIRARAPA SOUTH',
            name: 'Wairarapa South'
          }, {
            code: 'WAIREWA',
            name: 'Wairewa'
          }, {
            code: 'WAIROA',
            name: 'Wairoa'
          }, {
            code: 'WAITAKI',
            name: 'Waitaki'
          }, {
            code: 'WAITOMO',
            name: 'Waitomo'
          }, {
            code: 'WAITOTARA',
            name: 'Waitotara'
          }, {
            code: 'WALLACE',
            name: 'Wallace'
          }, {
            code: 'WANGANUI',
            name: 'Wanganui'
          }, {
            code: 'WAVERLEY',
            name: 'Waverley'
          }, {
            code: 'WESTLAND',
            name: 'Westland'
          }, {
            code: 'WHAKATANE',
            name: 'Whakatane'
          }, {
            code: 'WHANGAREI',
            name: 'Whangarei'
          }, {
            code: 'WHANGAROA',
            name: 'Whangaroa'
          }, {
            code: 'WOODVILLE',
            name: 'Woodville'
          }];
        case 'NI':
          return [{
            code: 'ATLANTICO NORTE',
            name: 'Atlantico Norte'
          }, {
            code: 'ATLANTICO SUR',
            name: 'Atlantico Sur'
          }, {
            code: 'BOACO',
            name: 'Boaco'
          }, {
            code: 'CARAZO',
            name: 'Carazo'
          }, {
            code: 'CHINANDEGA',
            name: 'Chinandega'
          }, {
            code: 'CHONTALES',
            name: 'Chontales'
          }, {
            code: 'ESTELI',
            name: 'Esteli'
          }, {
            code: 'GRANADA',
            name: 'Granada'
          }, {
            code: 'JINOTEGA',
            name: 'Jinotega'
          }, {
            code: 'LEON',
            name: 'Leon'
          }, {
            code: 'MADRIZ',
            name: 'Madriz'
          }, {
            code: 'MANAGUA',
            name: 'Managua'
          }, {
            code: 'MASAYA',
            name: 'Masaya'
          }, {
            code: 'MATAGALPA',
            name: 'Matagalpa'
          }, {
            code: 'NUEVA SEGOVIA',
            name: 'Nueva Segovia'
          }, {
            code: 'RIO SAN JUAN',
            name: 'Rio San Juan'
          }, {
            code: 'RIVAS',
            name: 'Rivas'
          }];
        case 'NE':
          return [{
            code: 'AGADEZ',
            name: 'Agadez'
          }, {
            code: 'DIFFA',
            name: 'Diffa'
          }, {
            code: 'DOSSO',
            name: 'Dosso'
          }, {
            code: 'MARADI',
            name: 'Maradi'
          }, {
            code: 'NIAMEY',
            name: 'Niamey'
          }, {
            code: 'TAHOUA',
            name: 'Tahoua'
          }, {
            code: 'TILLABERI',
            name: 'Tillaberi'
          }, {
            code: 'ZINDER',
            name: 'Zinder'
          }];
        case 'NG':
          return [{
            code: 'ABIA',
            name: 'Abia'
          }, {
            code: 'ABUJA FEDERAL CAPITAL TERRITORY',
            name: 'Abuja Federal Capital Territory'
          }, {
            code: 'ADAMAWA',
            name: 'Adamawa'
          }, {
            code: 'AKWA IBOM',
            name: 'Akwa Ibom'
          }, {
            code: 'ANAMBRA',
            name: 'Anambra'
          }, {
            code: 'BAUCHI',
            name: 'Bauchi'
          }, {
            code: 'BAYELSA',
            name: 'Bayelsa'
          }, {
            code: 'BENUE',
            name: 'Benue'
          }, {
            code: 'BORNO',
            name: 'Borno'
          }, {
            code: 'CROSS RIVER',
            name: 'Cross River'
          }, {
            code: 'DELTA',
            name: 'Delta'
          }, {
            code: 'EBONYI',
            name: 'Ebonyi'
          }, {
            code: 'EDO',
            name: 'Edo'
          }, {
            code: 'EKITI',
            name: 'Ekiti'
          }, {
            code: 'ENUGU',
            name: 'Enugu'
          }, {
            code: 'GOMBE',
            name: 'Gombe'
          }, {
            code: 'IMO',
            name: 'Imo'
          }, {
            code: 'JIGAWA',
            name: 'Jigawa'
          }, {
            code: 'KADUNA',
            name: 'Kaduna'
          }, {
            code: 'KANO',
            name: 'Kano'
          }, {
            code: 'KATSINA',
            name: 'Katsina'
          }, {
            code: 'KEBBI',
            name: 'Kebbi'
          }, {
            code: 'KOGI',
            name: 'Kogi'
          }, {
            code: 'KWARA',
            name: 'Kwara'
          }, {
            code: 'LAGOS',
            name: 'Lagos'
          }, {
            code: 'NASSARAWA',
            name: 'Nassarawa'
          }, {
            code: 'NIGER',
            name: 'Niger'
          }, {
            code: 'OGUN',
            name: 'Ogun'
          }, {
            code: 'ONDO',
            name: 'Ondo'
          }, {
            code: 'OSUN',
            name: 'Osun'
          }, {
            code: 'OYO',
            name: 'Oyo'
          }, {
            code: 'PLATEAU',
            name: 'Plateau'
          }, {
            code: 'RIVERS',
            name: 'Rivers'
          }, {
            code: 'SOKOTO',
            name: 'Sokoto'
          }, {
            code: 'TARABA',
            name: 'Taraba'
          }, {
            code: 'YOBE',
            name: 'Yobe'
          }, {
            code: 'ZAMFARA',
            name: 'Zamfara'
          }];
        case 'NU':
          return [{
            code: 'NIUE',
            name: 'Niue'
          }];
        case 'NF':
          return [{
            code: 'NORFOLK ISLAND',
            name: 'Norfolk Island'
          }];
        case 'MP':
          return [{
            code: 'NORTHERN ISLANDS',
            name: 'Northern Islands'
          }, {
            code: 'ROTA',
            name: 'Rota'
          }, {
            code: 'SAIPAN',
            name: 'Saipan'
          }, {
            code: 'TINIAN',
            name: 'Tinian'
          }];
        case 'NO':
          return [{
            code: 'AKERSHUS',
            name: 'Akershus'
          }, {
            code: 'AUST-AGDER',
            name: 'Aust-Agder'
          }, {
            code: 'BUSKERUD',
            name: 'Buskerud'
          }, {
            code: 'FINNMARK',
            name: 'Finnmark'
          }, {
            code: 'HEDMARK',
            name: 'Hedmark'
          }, {
            code: 'HORDALAND',
            name: 'Hordaland'
          }, {
            code: 'MORE OG ROMSDAL',
            name: 'More og Romsdal'
          }, {
            code: 'NORD-TRONDELAG',
            name: 'Nord-Trondelag'
          }, {
            code: 'NORDLAND',
            name: 'Nordland'
          }, {
            code: 'OPPLAND',
            name: 'Oppland'
          }, {
            code: 'OSLO',
            name: 'Oslo'
          }, {
            code: 'OSTFOLD',
            name: 'Ostfold'
          }, {
            code: 'ROGALAND',
            name: 'Rogaland'
          }, {
            code: 'SOGN OG FJORDANE',
            name: 'Sogn og Fjordane'
          }, {
            code: 'SOR-TRONDELAG',
            name: 'Sor-Trondelag'
          }, {
            code: 'TELEMARK',
            name: 'Telemark'
          }, {
            code: 'TROMS',
            name: 'Troms'
          }, {
            code: 'VEST-AGDER',
            name: 'Vest-Agder'
          }, {
            code: 'VESTFOLD',
            name: 'Vestfold'
          }];
        case 'OM':
          return [{
            code: 'AD DAKHILIYAH',
            name: 'Ad Dakhiliyah'
          }, {
            code: 'AL BATINAH',
            name: 'Al Batinah'
          }, {
            code: 'AL WUSTA',
            name: 'Al Wusta'
          }, {
            code: 'ASH SHARQIYAH',
            name: 'Ash Sharqiyah'
          }, {
            code: 'AZ ZAHIRAH',
            name: 'Az Zahirah'
          }, {
            code: 'MASQAT',
            name: 'Masqat'
          }, {
            code: 'MUSANDAM',
            name: 'Musandam'
          }, {
            code: 'ZUFAR',
            name: 'Zufar'
          }];
        case 'PK':
          return [{
            code: 'BALOCHISTAN',
            name: 'Balochistan'
          }, {
            code: 'FEDERALLY ADMINISTERED TRIBAL AREAS',
            name: 'Federally Administered Tribal Areas'
          }, {
            code: 'ISLAMABAD CAPITAL TERRITORY',
            name: 'Islamabad Capital Territory'
          }, {
            code: 'NORTH-WEST FRONTIER PROVINCE',
            name: 'North-West Frontier Province'
          }, {
            code: 'PUNJAB',
            name: 'Punjab'
          }, {
            code: 'SINDH',
            name: 'Sindh'
          }];
        case 'PW':
          return [{
            code: 'AIMELIIK',
            name: 'Aimeliik'
          }, {
            code: 'AIRAI',
            name: 'Airai'
          }, {
            code: 'ANGAUR',
            name: 'Angaur'
          }, {
            code: 'HATOBOHEI',
            name: 'Hatobohei'
          }, {
            code: 'KAYANGEL',
            name: 'Kayangel'
          }, {
            code: 'KOROR',
            name: 'Koror'
          }, {
            code: 'MELEKEOK',
            name: 'Melekeok'
          }, {
            code: 'NGARAARD',
            name: 'Ngaraard'
          }, {
            code: 'NGARCHELONG',
            name: 'Ngarchelong'
          }, {
            code: 'NGARDMAU',
            name: 'Ngardmau'
          }, {
            code: 'NGATPANG',
            name: 'Ngatpang'
          }, {
            code: 'NGCHESAR',
            name: 'Ngchesar'
          }, {
            code: 'NGEREMLENGUI',
            name: 'Ngeremlengui'
          }, {
            code: 'NGIWAL',
            name: 'Ngiwal'
          }, {
            code: 'PALAU ISLAND',
            name: 'Palau Island'
          }, {
            code: 'PELELIU',
            name: 'Peleliu'
          }, {
            code: 'SONSORAL',
            name: 'Sonsoral'
          }, {
            code: 'TOBI',
            name: 'Tobi'
          }];
        case 'PA':
          return [{
            code: 'BOCAS DEL TORO',
            name: 'Bocas del Toro'
          }, {
            code: 'CHIRIQUI',
            name: 'Chiriqui'
          }, {
            code: 'COCLE',
            name: 'Cocle'
          }, {
            code: 'COLON',
            name: 'Colon'
          }, {
            code: 'DARIEN',
            name: 'Darien'
          }, {
            code: 'HERRERA',
            name: 'Herrera'
          }, {
            code: 'LOS SANTOS',
            name: 'Los Santos'
          }, {
            code: 'PANAMA',
            name: 'Panama'
          }, {
            code: 'SAN BLAS',
            name: 'San Blas'
          }, {
            code: 'VERAGUAS',
            name: 'Veraguas'
          }];
        case 'PG':
          return [{
            code: 'BOUGAINVILLE',
            name: 'Bougainville'
          }, {
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'CHIMBU',
            name: 'Chimbu'
          }, {
            code: 'EAST NEW BRITAIN',
            name: 'East New Britain'
          }, {
            code: 'EAST SEPIK',
            name: 'East Sepik'
          }, {
            code: 'EASTERN HIGHLANDS',
            name: 'Eastern Highlands'
          }, {
            code: 'ENGA',
            name: 'Enga'
          }, {
            code: 'GULF',
            name: 'Gulf'
          }, {
            code: 'MADANG',
            name: 'Madang'
          }, {
            code: 'MANUS',
            name: 'Manus'
          }, {
            code: 'MILNE BAY',
            name: 'Milne Bay'
          }, {
            code: 'MOROBE',
            name: 'Morobe'
          }, {
            code: 'NATIONAL CAPITAL',
            name: 'National Capital'
          }, {
            code: 'NEW IRELAND',
            name: 'New Ireland'
          }, {
            code: 'NORTHERN',
            name: 'Northern'
          }, {
            code: 'SANDAUN',
            name: 'Sandaun'
          }, {
            code: 'SOUTHERN HIGHLANDS',
            name: 'Southern Highlands'
          }, {
            code: 'WEST NEW BRITAIN',
            name: 'West New Britain'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }, {
            code: 'WESTERN HIGHLANDS',
            name: 'Western Highlands'
          }];
        case 'PY':
          return [{
            code: 'ALTO PARAGUAY',
            name: 'Alto Paraguay'
          }, {
            code: 'ALTO PARANA',
            name: 'Alto Parana'
          }, {
            code: 'AMAMBAY',
            name: 'Amambay'
          }, {
            code: 'ASUNCION (CITY)',
            name: 'Asuncion (city)'
          }, {
            code: 'BOQUERON',
            name: 'Boqueron'
          }, {
            code: 'CAAGUAZU',
            name: 'Caaguazu'
          }, {
            code: 'CAAZAPA',
            name: 'Caazapa'
          }, {
            code: 'CANINDEYU',
            name: 'Canindeyu'
          }, {
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'CONCEPCION',
            name: 'Concepcion'
          }, {
            code: 'CORDILLERA',
            name: 'Cordillera'
          }, {
            code: 'GUAIRA',
            name: 'Guaira'
          }, {
            code: 'ITAPUA',
            name: 'Itapua'
          }, {
            code: 'MISIONES',
            name: 'Misiones'
          }, {
            code: 'NEEMBUCU',
            name: 'Neembucu'
          }, {
            code: 'PARAGUARI',
            name: 'Paraguari'
          }, {
            code: 'PRESIDENTE HAYES',
            name: 'Presidente Hayes'
          }, {
            code: 'SAN PEDRO',
            name: 'San Pedro'
          }];
        case 'PE':
          return [{
            code: 'AMAZONAS',
            name: 'Amazonas'
          }, {
            code: 'ANCASH',
            name: 'Ancash'
          }, {
            code: 'APURIMAC',
            name: 'Apurimac'
          }, {
            code: 'AREQUIPA',
            name: 'Arequipa'
          }, {
            code: 'AYACUCHO',
            name: 'Ayacucho'
          }, {
            code: 'CAJAMARCA',
            name: 'Cajamarca'
          }, {
            code: 'CALLAO',
            name: 'Callao'
          }, {
            code: 'CUSCO',
            name: 'Cusco'
          }, {
            code: 'HUANCAVELICA',
            name: 'Huancavelica'
          }, {
            code: 'HUANUCO',
            name: 'Huanuco'
          }, {
            code: 'ICA',
            name: 'Ica'
          }, {
            code: 'JUNIN',
            name: 'Junin'
          }, {
            code: 'LA LIBERTAD',
            name: 'La Libertad'
          }, {
            code: 'LAMBAYEQUE',
            name: 'Lambayeque'
          }, {
            code: 'LIMA',
            name: 'Lima'
          }, {
            code: 'LORETO',
            name: 'Loreto'
          }, {
            code: 'MADRE DE DIOS',
            name: 'Madre de Dios'
          }, {
            code: 'MOQUEGUA',
            name: 'Moquegua'
          }, {
            code: 'PASCO',
            name: 'Pasco'
          }, {
            code: 'PIURA',
            name: 'Piura'
          }, {
            code: 'PUNO',
            name: 'Puno'
          }, {
            code: 'SAN MARTIN',
            name: 'San Martin'
          }, {
            code: 'TACNA',
            name: 'Tacna'
          }, {
            code: 'TUMBES',
            name: 'Tumbes'
          }, {
            code: 'UCAYALI',
            name: 'Ucayali'
          }];
        case 'PH':
          return [{
            code: 'ABRA',
            name: 'Abra'
          }, {
            code: 'AGUSAN DEL NORTE',
            name: 'Agusan del Norte'
          }, {
            code: 'AGUSAN DEL SUR',
            name: 'Agusan del Sur'
          }, {
            code: 'AKLAN',
            name: 'Aklan'
          }, {
            code: 'ALBAY',
            name: 'Albay'
          }, {
            code: 'ANGELES',
            name: 'Angeles'
          }, {
            code: 'ANTIQUE',
            name: 'Antique'
          }, {
            code: 'AURORA',
            name: 'Aurora'
          }, {
            code: 'BACOLOD',
            name: 'Bacolod'
          }, {
            code: 'BAGO',
            name: 'Bago'
          }, {
            code: 'BAGUIO',
            name: 'Baguio'
          }, {
            code: 'BAIS',
            name: 'Bais'
          }, {
            code: 'BASILAN',
            name: 'Basilan'
          }, {
            code: 'BASILAN CITY',
            name: 'Basilan City'
          }, {
            code: 'BATAAN',
            name: 'Bataan'
          }, {
            code: 'BATANES',
            name: 'Batanes'
          }, {
            code: 'BATANGAS',
            name: 'Batangas'
          }, {
            code: 'BATANGAS CITY',
            name: 'Batangas City'
          }, {
            code: 'BENGUET',
            name: 'Benguet'
          }, {
            code: 'BOHOL',
            name: 'Bohol'
          }, {
            code: 'BUKIDNON',
            name: 'Bukidnon'
          }, {
            code: 'BULACAN',
            name: 'Bulacan'
          }, {
            code: 'BUTUAN',
            name: 'Butuan'
          }, {
            code: 'CABANATUAN',
            name: 'Cabanatuan'
          }, {
            code: 'CADIZ',
            name: 'Cadiz'
          }, {
            code: 'CAGAYAN',
            name: 'Cagayan'
          }, {
            code: 'CAGAYAN DE ORO',
            name: 'Cagayan de Oro'
          }, {
            code: 'CALBAYOG',
            name: 'Calbayog'
          }, {
            code: 'CALOOCAN',
            name: 'Caloocan'
          }, {
            code: 'CAMARINES NORTE',
            name: 'Camarines Norte'
          }, {
            code: 'CAMARINES SUR',
            name: 'Camarines Sur'
          }, {
            code: 'CAMIGUIN',
            name: 'Camiguin'
          }, {
            code: 'CANLAON',
            name: 'Canlaon'
          }, {
            code: 'CAPIZ',
            name: 'Capiz'
          }, {
            code: 'CATANDUANES',
            name: 'Catanduanes'
          }, {
            code: 'CAVITE',
            name: 'Cavite'
          }, {
            code: 'CAVITE CITY',
            name: 'Cavite City'
          }, {
            code: 'CEBU',
            name: 'Cebu'
          }, {
            code: 'CEBU CITY',
            name: 'Cebu City'
          }, {
            code: 'COTABATO',
            name: 'Cotabato'
          }, {
            code: 'DAGUPAN',
            name: 'Dagupan'
          }, {
            code: 'DANAO',
            name: 'Danao'
          }, {
            code: 'DAPITAN',
            name: 'Dapitan'
          }, {
            code: 'DAVAO CITY DAVAO',
            name: 'Davao City Davao'
          }, {
            code: 'DAVAO DEL SUR',
            name: 'Davao del Sur'
          }, {
            code: 'DAVAO ORIENTAL',
            name: 'Davao Oriental'
          }, {
            code: 'DIPOLOG',
            name: 'Dipolog'
          }, {
            code: 'DUMAGUETE',
            name: 'Dumaguete'
          }, {
            code: 'EASTERN SAMAR',
            name: 'Eastern Samar'
          }, {
            code: 'GENERAL SANTOS',
            name: 'General Santos'
          }, {
            code: 'GINGOOG',
            name: 'Gingoog'
          }, {
            code: 'IFUGAO',
            name: 'Ifugao'
          }, {
            code: 'ILIGAN',
            name: 'Iligan'
          }, {
            code: 'ILOCOS NORTE',
            name: 'Ilocos Norte'
          }, {
            code: 'ILOCOS SUR',
            name: 'Ilocos Sur'
          }, {
            code: 'ILOILO',
            name: 'Iloilo'
          }, {
            code: 'ILOILO CITY',
            name: 'Iloilo City'
          }, {
            code: 'IRIGA',
            name: 'Iriga'
          }, {
            code: 'ISABELA',
            name: 'Isabela'
          }, {
            code: 'KALINGA-APAYAO',
            name: 'Kalinga-Apayao'
          }, {
            code: 'LA CARLOTA',
            name: 'La Carlota'
          }, {
            code: 'LA UNION',
            name: 'La Union'
          }, {
            code: 'LAGUNA',
            name: 'Laguna'
          }, {
            code: 'LANAO DEL NORTE',
            name: 'Lanao del Norte'
          }, {
            code: 'LANAO DEL SUR',
            name: 'Lanao del Sur'
          }, {
            code: 'LAOAG',
            name: 'Laoag'
          }, {
            code: 'LAPU-LAPU',
            name: 'Lapu-Lapu'
          }, {
            code: 'LEGASPI',
            name: 'Legaspi'
          }, {
            code: 'LEYTE',
            name: 'Leyte'
          }, {
            code: 'LIPA',
            name: 'Lipa'
          }, {
            code: 'LUCENA',
            name: 'Lucena'
          }, {
            code: 'MAGUINDANAO',
            name: 'Maguindanao'
          }, {
            code: 'MANDAUE',
            name: 'Mandaue'
          }, {
            code: 'MANILA',
            name: 'Manila'
          }, {
            code: 'MARAWI',
            name: 'Marawi'
          }, {
            code: 'MARINDUQUE',
            name: 'Marinduque'
          }, {
            code: 'MASBATE',
            name: 'Masbate'
          }, {
            code: 'MINDORO OCCIDENTAL',
            name: 'Mindoro Occidental'
          }, {
            code: 'MINDORO ORIENTAL',
            name: 'Mindoro Oriental'
          }, {
            code: 'MISAMIS OCCIDENTAL',
            name: 'Misamis Occidental'
          }, {
            code: 'MISAMIS ORIENTAL',
            name: 'Misamis Oriental'
          }, {
            code: 'MOUNTAIN',
            name: 'Mountain'
          }, {
            code: 'NAGA',
            name: 'Naga'
          }, {
            code: 'NEGROS OCCIDENTAL',
            name: 'Negros Occidental'
          }, {
            code: 'NEGROS ORIENTAL',
            name: 'Negros Oriental'
          }, {
            code: 'NORTH COTABATO',
            name: 'North Cotabato'
          }, {
            code: 'NORTHERN SAMAR',
            name: 'Northern Samar'
          }, {
            code: 'NUEVA ECIJA',
            name: 'Nueva Ecija'
          }, {
            code: 'NUEVA VIZCAYA',
            name: 'Nueva Vizcaya'
          }, {
            code: 'OLONGAPO',
            name: 'Olongapo'
          }, {
            code: 'ORMOC',
            name: 'Ormoc'
          }, {
            code: 'OROQUIETA',
            name: 'Oroquieta'
          }, {
            code: 'OZAMIS',
            name: 'Ozamis'
          }, {
            code: 'PAGADIAN',
            name: 'Pagadian'
          }, {
            code: 'PALAWAN',
            name: 'Palawan'
          }, {
            code: 'PALAYAN',
            name: 'Palayan'
          }, {
            code: 'PAMPANGA',
            name: 'Pampanga'
          }, {
            code: 'PANGASINAN',
            name: 'Pangasinan'
          }, {
            code: 'PASAY',
            name: 'Pasay'
          }, {
            code: 'PUERTO PRINCESA',
            name: 'Puerto Princesa'
          }, {
            code: 'QUEZON',
            name: 'Quezon'
          }, {
            code: 'QUEZON CITY',
            name: 'Quezon City'
          }, {
            code: 'QUIRINO',
            name: 'Quirino'
          }, {
            code: 'RIZAL',
            name: 'Rizal'
          }, {
            code: 'ROMBLON',
            name: 'Romblon'
          }, {
            code: 'ROXAS',
            name: 'Roxas'
          }, {
            code: 'SAMAR',
            name: 'Samar'
          }, {
            code: 'SAN CARLOS (IN NEGROS OCCIDENTAL)',
            name: 'San Carlos (in Negros Occidental)'
          }, {
            code: 'SAN CARLOS (IN PANGASINAN)',
            name: 'San Carlos (in Pangasinan)'
          }, {
            code: 'SAN JOSE',
            name: 'San Jose'
          }, {
            code: 'SAN PABLO',
            name: 'San Pablo'
          }, {
            code: 'SILAY',
            name: 'Silay'
          }, {
            code: 'SIQUIJOR',
            name: 'Siquijor'
          }, {
            code: 'SORSOGON',
            name: 'Sorsogon'
          }, {
            code: 'SOUTH COTABATO',
            name: 'South Cotabato'
          }, {
            code: 'SOUTHERN LEYTE',
            name: 'Southern Leyte'
          }, {
            code: 'SULTAN KUDARAT',
            name: 'Sultan Kudarat'
          }, {
            code: 'SULU',
            name: 'Sulu'
          }, {
            code: 'SURIGAO',
            name: 'Surigao'
          }, {
            code: 'SURIGAO DEL NORTE',
            name: 'Surigao del Norte'
          }, {
            code: 'SURIGAO DEL SUR',
            name: 'Surigao del Sur'
          }, {
            code: 'TACLOBAN',
            name: 'Tacloban'
          }, {
            code: 'TAGAYTAY',
            name: 'Tagaytay'
          }, {
            code: 'TAGBILARAN',
            name: 'Tagbilaran'
          }, {
            code: 'TANGUB',
            name: 'Tangub'
          }, {
            code: 'TARLAC',
            name: 'Tarlac'
          }, {
            code: 'TAWITAWI',
            name: 'Tawitawi'
          }, {
            code: 'TOLEDO',
            name: 'Toledo'
          }, {
            code: 'TRECE MARTIRES',
            name: 'Trece Martires'
          }, {
            code: 'ZAMBALES',
            name: 'Zambales'
          }, {
            code: 'ZAMBOANGA',
            name: 'Zamboanga'
          }, {
            code: 'ZAMBOANGA DEL NORTE',
            name: 'Zamboanga del Norte'
          }, {
            code: 'ZAMBOANGA DEL SUR',
            name: 'Zamboanga del Sur'
          }];
        case 'PL':
          return [{
            code: 'DOLNOSLASKIE',
            name: 'Dolnoslaskie'
          }, {
            code: 'KUJAWSKO-POMORSKIE',
            name: 'Kujawsko-Pomorskie'
          }, {
            code: 'LODZKIE',
            name: 'Lodzkie'
          }, {
            code: 'LUBELSKIE',
            name: 'Lubelskie'
          }, {
            code: 'LUBUSKIE',
            name: 'Lubuskie'
          }, {
            code: 'MALOPOLSKIE',
            name: 'Malopolskie'
          }, {
            code: 'MAZOWIECKIE',
            name: 'Mazowieckie'
          }, {
            code: 'OPOLSKIE',
            name: 'Opolskie'
          }, {
            code: 'PODKARPACKIE',
            name: 'Podkarpackie'
          }, {
            code: 'PODLASKIE',
            name: 'Podlaskie'
          }, {
            code: 'POMORSKIE',
            name: 'Pomorskie'
          }, {
            code: 'SLASKIE',
            name: 'Slaskie'
          }, {
            code: 'SWIETOKRZYSKIE',
            name: 'Swietokrzyskie'
          }, {
            code: 'WARMINSKO-MAZURSKIE',
            name: 'Warminsko-Mazurskie'
          }, {
            code: 'WIELKOPOLSKIE',
            name: 'Wielkopolskie'
          }, {
            code: 'ZACHODNIOPOMORSKIE',
            name: 'Zachodniopomorskie'
          }];
        case 'PT':
          return [{
            code: 'ACORES (AZORES)',
            name: 'Acores (Azores)'
          }, {
            code: 'AVEIRO',
            name: 'Aveiro'
          }, {
            code: 'BEJA',
            name: 'Beja'
          }, {
            code: 'BRAGA',
            name: 'Braga'
          }, {
            code: 'BRAGANCA',
            name: 'Braganca'
          }, {
            code: 'CASTELO BRANCO',
            name: 'Castelo Branco'
          }, {
            code: 'COIMBRA',
            name: 'Coimbra'
          }, {
            code: 'EVORA',
            name: 'Evora'
          }, {
            code: 'FARO',
            name: 'Faro'
          }, {
            code: 'GUARDA',
            name: 'Guarda'
          }, {
            code: 'LEIRIA',
            name: 'Leiria'
          }, {
            code: 'LISBOA',
            name: 'Lisboa'
          }, {
            code: 'MADEIRA',
            name: 'Madeira'
          }, {
            code: 'PORTALEGRE',
            name: 'Portalegre'
          }, {
            code: 'PORTO',
            name: 'Porto'
          }, {
            code: 'SANTAREM',
            name: 'Santarem'
          }, {
            code: 'SETUBAL',
            name: 'Setubal'
          }, {
            code: 'VIANA DO CASTELO',
            name: 'Viana do Castelo'
          }, {
            code: 'VILA REAL',
            name: 'Vila Real'
          }, {
            code: 'VISEU',
            name: 'Viseu'
          }];
        case 'PR':
          return [{
            code: 'ADJUNTAS',
            name: 'Adjuntas'
          }, {
            code: 'AGUADA',
            name: 'Aguada'
          }, {
            code: 'AGUADILLA',
            name: 'Aguadilla'
          }, {
            code: 'AGUAS BUENAS',
            name: 'Aguas Buenas'
          }, {
            code: 'AIBONITO',
            name: 'Aibonito'
          }, {
            code: 'ANASCO',
            name: 'Anasco'
          }, {
            code: 'ARECIBO',
            name: 'Arecibo'
          }, {
            code: 'ARROYO',
            name: 'Arroyo'
          }, {
            code: 'BARCELONETA',
            name: 'Barceloneta'
          }, {
            code: 'BARRANQUITAS',
            name: 'Barranquitas'
          }, {
            code: 'BAYAMON',
            name: 'Bayamon'
          }, {
            code: 'CABO ROJO',
            name: 'Cabo Rojo'
          }, {
            code: 'CAGUAS',
            name: 'Caguas'
          }, {
            code: 'CAMUY',
            name: 'Camuy'
          }, {
            code: 'CANOVANAS',
            name: 'Canovanas'
          }, {
            code: 'CAROLINA',
            name: 'Carolina'
          }, {
            code: 'CATANO',
            name: 'Catano'
          }, {
            code: 'CAYEY',
            name: 'Cayey'
          }, {
            code: 'CEIBA',
            name: 'Ceiba'
          }, {
            code: 'CIALES',
            name: 'Ciales'
          }, {
            code: 'CIDRA',
            name: 'Cidra'
          }, {
            code: 'COAMO',
            name: 'Coamo'
          }, {
            code: 'COMERIO',
            name: 'Comerio'
          }, {
            code: 'COROZAL',
            name: 'Corozal'
          }, {
            code: 'CULEBRA',
            name: 'Culebra'
          }, {
            code: 'DORADO',
            name: 'Dorado'
          }, {
            code: 'FAJARDO',
            name: 'Fajardo'
          }, {
            code: 'FLORIDA',
            name: 'Florida'
          }, {
            code: 'GUANICA',
            name: 'Guanica'
          }, {
            code: 'GUAYAMA',
            name: 'Guayama'
          }, {
            code: 'GUAYANILLA',
            name: 'Guayanilla'
          }, {
            code: 'GUAYNABO',
            name: 'Guaynabo'
          }, {
            code: 'GURABO',
            name: 'Gurabo'
          }, {
            code: 'HATILLO',
            name: 'Hatillo'
          }, {
            code: 'HORMIGUEROS',
            name: 'Hormigueros'
          }, {
            code: 'HUMACAO',
            name: 'Humacao'
          }, {
            code: 'ISABELA',
            name: 'Isabela'
          }, {
            code: 'JAYUYA',
            name: 'Jayuya'
          }, {
            code: 'JUANA DIAZ',
            name: 'Juana Diaz'
          }, {
            code: 'JUNCOS',
            name: 'Juncos'
          }, {
            code: 'LAJAS',
            name: 'Lajas'
          }, {
            code: 'LARES',
            name: 'Lares'
          }, {
            code: 'LAS MARIAS',
            name: 'Las Marias'
          }, {
            code: 'LAS PIEDRAS',
            name: 'Las Piedras'
          }, {
            code: 'LOIZA',
            name: 'Loiza'
          }, {
            code: 'LUQUILLO',
            name: 'Luquillo'
          }, {
            code: 'MANATI',
            name: 'Manati'
          }, {
            code: 'MARICAO',
            name: 'Maricao'
          }, {
            code: 'MAUNABO',
            name: 'Maunabo'
          }, {
            code: 'MAYAGUEZ',
            name: 'Mayaguez'
          }, {
            code: 'MOCA',
            name: 'Moca'
          }, {
            code: 'MOROVIS',
            name: 'Morovis'
          }, {
            code: 'NAGUABO',
            name: 'Naguabo'
          }, {
            code: 'NARANJITO',
            name: 'Naranjito'
          }, {
            code: 'OROCOVIS',
            name: 'Orocovis'
          }, {
            code: 'PATILLAS',
            name: 'Patillas'
          }, {
            code: 'PENUELAS',
            name: 'Penuelas'
          }, {
            code: 'PONCE',
            name: 'Ponce'
          }, {
            code: 'QUEBRADILLAS',
            name: 'Quebradillas'
          }, {
            code: 'RINCON',
            name: 'Rincon'
          }, {
            code: 'RIO GRANDE',
            name: 'Rio Grande'
          }, {
            code: 'SABANA GRANDE',
            name: 'Sabana Grande'
          }, {
            code: 'SALINAS',
            name: 'Salinas'
          }, {
            code: 'SAN GERMAN',
            name: 'San German'
          }, {
            code: 'SAN JUAN',
            name: 'San Juan'
          }, {
            code: 'SAN LORENZO',
            name: 'San Lorenzo'
          }, {
            code: 'SAN SEBASTIAN',
            name: 'San Sebastian'
          }, {
            code: 'SANTA ISABEL',
            name: 'Santa Isabel'
          }, {
            code: 'TOA ALTA',
            name: 'Toa Alta'
          }, {
            code: 'TOA BAJA',
            name: 'Toa Baja'
          }, {
            code: 'TRUJILLO ALTO',
            name: 'Trujillo Alto'
          }, {
            code: 'UTUADO',
            name: 'Utuado'
          }, {
            code: 'VEGA ALTA',
            name: 'Vega Alta'
          }, {
            code: 'VEGA BAJA',
            name: 'Vega Baja'
          }, {
            code: 'VIEQUES',
            name: 'Vieques'
          }, {
            code: 'VILLALBA',
            name: 'Villalba'
          }, {
            code: 'YABUCOA',
            name: 'Yabucoa'
          }, {
            code: 'YAUCO',
            name: 'Yauco'
          }];
        case 'QA':
          return [{
            code: 'AD DAWHAH',
            name: 'Ad Dawhah'
          }, {
            code: 'AL GHUWAYRIYAH',
            name: 'Al Ghuwayriyah'
          }, {
            code: 'AL JUMAYLIYAH',
            name: 'Al Jumayliyah'
          }, {
            code: 'AL KHAWR',
            name: 'Al Khawr'
          }, {
            code: 'AL WAKRAH',
            name: 'Al Wakrah'
          }, {
            code: 'AR RAYYAN',
            name: 'Ar Rayyan'
          }, {
            code: 'JARAYAN AL BATINAH',
            name: 'Jarayan al Batinah'
          }, {
            code: 'MADINAT ASH SHAMAL',
            name: 'Madinat ash Shamal'
          }, {
            code: 'UMM SALAL',
            name: 'Umm Salal'
          }];
        case 'RE':
          return [{
            code: 'REUNION',
            name: 'Reunion'
          }];
        case 'RO':
          return [{
            code: 'ALBA',
            name: 'Alba'
          }, {
            code: 'ARAD',
            name: 'Arad'
          }, {
            code: 'ARGES',
            name: 'Arges'
          }, {
            code: 'BACAU',
            name: 'Bacau'
          }, {
            code: 'BIHOR',
            name: 'Bihor'
          }, {
            code: 'BISTRITA-NASAUD',
            name: 'Bistrita-Nasaud'
          }, {
            code: 'BOTOSANI',
            name: 'Botosani'
          }, {
            code: 'BRAILA',
            name: 'Braila'
          }, {
            code: 'BRASOV',
            name: 'Brasov'
          }, {
            code: 'BUCURESTI',
            name: 'Bucuresti'
          }, {
            code: 'BUZAU',
            name: 'Buzau'
          }, {
            code: 'CALARASI',
            name: 'Calarasi'
          }, {
            code: 'CARAS-SEVERIN',
            name: 'Caras-Severin'
          }, {
            code: 'CLUJ',
            name: 'Cluj'
          }, {
            code: 'CONSTANTA',
            name: 'Constanta'
          }, {
            code: 'COVASNA',
            name: 'Covasna'
          }, {
            code: 'DIMBOVITA',
            name: 'Dimbovita'
          }, {
            code: 'DOLJ',
            name: 'Dolj'
          }, {
            code: 'GALATI',
            name: 'Galati'
          }, {
            code: 'GIURGIU',
            name: 'Giurgiu'
          }, {
            code: 'GORJ',
            name: 'Gorj'
          }, {
            code: 'HARGHITA',
            name: 'Harghita'
          }, {
            code: 'HUNEDOARA',
            name: 'Hunedoara'
          }, {
            code: 'IALOMITA',
            name: 'Ialomita'
          }, {
            code: 'IASI',
            name: 'Iasi'
          }, {
            code: 'MARAMURES',
            name: 'Maramures'
          }, {
            code: 'MEHEDINTI',
            name: 'Mehedinti'
          }, {
            code: 'MURES',
            name: 'Mures'
          }, {
            code: 'NEAMT',
            name: 'Neamt'
          }, {
            code: 'OLT',
            name: 'Olt'
          }, {
            code: 'PRAHOVA',
            name: 'Prahova'
          }, {
            code: 'SALAJ',
            name: 'Salaj'
          }, {
            code: 'SATU MARE',
            name: 'Satu Mare'
          }, {
            code: 'SIBIU',
            name: 'Sibiu'
          }, {
            code: 'SUCEAVA',
            name: 'Suceava'
          }, {
            code: 'TELEORMAN',
            name: 'Teleorman'
          }, {
            code: 'TIMIS',
            name: 'Timis'
          }, {
            code: 'TULCEA',
            name: 'Tulcea'
          }, {
            code: 'VASLUI',
            name: 'Vaslui'
          }, {
            code: 'VILCEA',
            name: 'Vilcea'
          }, {
            code: 'VRANCEA',
            name: 'Vrancea'
          }];
        case 'RU':
          return [{
            code: 'ADYGEYA (MAYKOP)',
            name: 'Adygeya (Maykop)'
          }, {
            code: 'AGINSKIY BURYATSKIY (AGINSKOYE)',
            name: 'Aginskiy Buryatskiy (Aginskoye)'
          }, {
            code: 'ALTAY (GORNO-ALTAYSK)',
            name: 'Altay (Gorno-Altaysk)'
          }, {
            code: 'ALTAYSKIY (BARNAUL)',
            name: 'Altayskiy (Barnaul)'
          }, {
            code: 'AMURSKAYA (BLAGOVESHCHENSK)',
            name: 'Amurskaya (Blagoveshchensk)'
          }, {
            code: 'ARKHANGELSKAYA',
            name: 'ArkhangelIngushetiyaskaya'
          }, {
            code: 'ASTRAKHANSKAYA',
            name: 'Astrakhanskaya'
          }, {
            code: 'BASHKORTOSTAN (UFA)',
            name: 'Bashkortostan (Ufa)'
          }, {
            code: 'BELGORODSKAYA',
            name: 'Belgorodskaya'
          }, {
            code: 'BRYANSKAYA',
            name: 'Bryanskaya'
          }, {
            code: 'BURYATIYA (ULAN-UDE)',
            name: 'Buryatiya (Ulan-Ude)'
          }, {
            code: 'CHECHNYA (GROZNYY)',
            name: 'Chechnya (Groznyy)'
          }, {
            code: 'CHELYABINSKAYA',
            name: 'Chelyabinskaya'
          }, {
            code: 'CHITINSKAYA',
            name: 'Chitinskaya'
          }, {
            code: 'CHUKOTSKIY (ANADYR)',
            name: 'Chukotskiy (Anadyr)'
          }, {
            code: 'CHUVASHIYA (CHEBOKSARY)',
            name: 'Chuvashiya (Cheboksary)'
          }, {
            code: 'DAGESTAN (MAKHACHKALA)',
            name: 'Dagestan (Makhachkala)'
          }, {
            code: 'EVENKIYSKIY (TURA)',
            name: 'Evenkiyskiy (Tura)'
          }, {
            code: 'INGUSHETIYA (NAZRAN)',
            name: 'Ingushetiya (Nazran)'
          }, {
            code: 'IRKUTSKAYA',
            name: 'Irkutskaya'
          }, {
            code: 'IVANOVSKAYA',
            name: 'Ivanovskaya'
          }, {
            code: 'KABARDINO-BALKARIYA (NALCHIK)',
            name: 'Kabardino-Balkariya (Nalchik)'
          }, {
            code: 'KALININGRADSKAYA',
            name: 'Kaliningradskaya'
          }, {
            code: 'KALMYKIYA (ELISTA)',
            name: 'Kalmykiya (Elista)'
          }, {
            code: 'KALUZHSKAYA',
            name: 'Kaluzhskaya'
          }, {
            code: 'KAMCHATSKAYA (PETROPAVLOVSK-KAMCHATSKIY)',
            name: 'Kamchatskaya (Petropavlovsk-Kamchatskiy)'
          }, {
            code: 'KARACHAYEVO-CHERKESIYA (CHERKESSK)',
            name: 'Karachayevo-Cherkesiya (Cherkessk)'
          }, {
            code: 'KARELIYA (PETROZAVODSK)',
            name: 'Kareliya (Petrozavodsk)'
          }, {
            code: 'KEMEROVSKAYA',
            name: 'Kemerovskaya'
          }, {
            code: 'KHABAROVSKIY',
            name: 'Khabarovskiy'
          }, {
            code: 'KHAKASIYA (ABAKAN)',
            name: 'Khakasiya (Abakan)'
          }, {
            code: 'KHANTY-MANSIYSKIY (KHANTY-MANSIYSK)',
            name: 'Khanty-Mansiyskiy (Khanty-Mansiysk)'
          }, {
            code: 'KIROVSKAYA',
            name: 'Kirovskaya'
          }, {
            code: 'KOMI (SYKTYVKAR)',
            name: 'Komi (Syktyvkar)'
          }, {
            code: 'KOMI-PERMYATSKIY (KUDYMKAR)',
            name: 'Komi-Permyatskiy (Kudymkar)'
          }, {
            code: 'KORYAKSKIY (PALANA)',
            name: 'Koryakskiy (Palana)'
          }, {
            code: 'KOSTROMSKAYA',
            name: 'Kostromskaya'
          }, {
            code: 'KRASNODARSKIY',
            name: 'Krasnodarskiy'
          }, {
            code: 'KRASNOYARSKIY',
            name: 'Krasnoyarskiy'
          }, {
            code: 'KURGANSKAYA',
            name: 'Kurganskaya'
          }, {
            code: 'KURSKAYA',
            name: 'Kurskaya'
          }, {
            code: 'LENINGRADSKAYA',
            name: 'Leningradskaya'
          }, {
            code: 'LIPETSKAYA',
            name: 'Lipetskaya'
          }, {
            code: 'MAGADANSKAYA',
            name: 'Magadanskaya'
          }, {
            code: 'MARIY-EL (YOSHKAR-OLA)',
            name: 'Mariy-El (Yoshkar-Ola)'
          }, {
            code: 'MORDOVIYA (SARANSK)',
            name: 'Mordoviya (Saransk)'
          }, {
            code: 'MOSKOVSKAYA',
            name: 'Moskovskaya'
          }, {
            code: 'MOSKVA (MOSCOW)',
            name: 'Moskva (Moscow)'
          }, {
            code: 'MURMANSKAYA',
            name: 'Murmanskaya'
          }, {
            code: 'NENETSKIY (NARYAN-MAR)',
            name: 'Nenetskiy (Naryan-fMar)'
          }, {
            code: 'NIZHEGORODSKAYA',
            name: 'Nizhegorodskaya'
          }, {
            code: 'NOVGORODSKAYA',
            name: 'Novgorodskaya'
          }, {
            code: 'NOVOSIBIRSKAYA',
            name: 'Novosibirskaya'
          }, {
            code: 'OMSKAYA',
            name: 'Omskaya'
          }, {
            code: 'ORENBURGSKAYA',
            name: 'Orenburgskaya'
          }, {
            code: 'ORLOVSKAYA (OREL)',
            name: 'Orlovskaya (Orel)'
          }, {
            code: 'PENZENSKAYA',
            name: 'Penzenskaya'
          }, {
            code: 'PERMSKAYA',
            name: 'Permskaya'
          }, {
            code: 'PRIMORSKIY (VLADIVOSTOK)',
            name: 'Primorskiy (Vladivostok)'
          }, {
            code: 'PSKOVSKAYA',
            name: 'Pskovskaya'
          }, {
            code: 'ROSTOVSKAYA',
            name: 'Rostovskaya'
          }, {
            code: 'RYAZANSKAYA',
            name: 'Ryazanskaya'
          }, {
            code: 'SAKHA (YAKUTSK)',
            name: 'Sakha (Yakutsk)'
          }, {
            code: 'SAKHALINSKAYA (YUZHNO-SAKHALINSK)',
            name: 'Sakhalinskaya (Yuzhno-Sakhalinsk)'
          }, {
            code: 'SAMARSKAYA',
            name: 'Samarskaya'
          }, {
            code: 'SANKT-PETERBURG (SAINT PETERSBURG)',
            name: 'Sankt-Peterburg (Saint Petersburg)'
          }, {
            code: 'SARATOVSKAYA',
            name: 'Saratovskaya'
          }, {
            code: 'SEVERNAYA OSETIYA-ALANIYA [NORTH OSSETIA] (VLADIKAVKAZ)',
            name: 'Severnaya Osetiya-Alaniya [North Ossetia] (Vladikavkaz)'
          }, {
            code: 'SMOLENSKAYA',
            name: 'Smolenskaya'
          }, {
            code: 'STAVROPOLSKIY',
            name: 'Stavropolskiy'
          }, {
            code: 'SVERDLOVSKAYA (YEKATERINBURG)',
            name: 'Sverdlovskaya (Yekaterinburg)'
          }, {
            code: 'TAMBOVSKAYA',
            name: 'Tambovskaya'
          }, {
            code: 'TATARSTAN (KAZAN)',
            name: 'Tatarstan (Kazan)'
          }, {
            code: 'TAYMYRSKIY (DUDINKA)',
            name: 'Taymyrskiy (Dudinka)'
          }, {
            code: 'TOMSKAYA',
            name: 'Tomskaya'
          }, {
            code: 'TULSKAYA',
            name: 'Tulskaya'
          }, {
            code: 'TVERSKAYA',
            name: 'Tverskaya'
          }, {
            code: 'TYUMENSKAYA',
            name: 'Tyumenskaya'
          }, {
            code: 'TYVA (KYZYL)',
            name: 'Tyva (Kyzyl)'
          }, {
            code: 'UDMURTIYA (IZHEVSK)',
            name: 'Udmurtiya (Izhevsk)'
          }, {
            code: 'ULYANOVSKAYA',
            name: 'Ulyanovskaya'
          }, {
            code: 'UST-ORDYNSKIY BURYATSKIY (UST-ORDYNSKIY)',
            name: 'Ust-Ordynskiy Buryatskiy (Ust-Ordynskiy)'
          }, {
            code: 'VLADIMIRSKAYA',
            name: 'Vladimirskaya'
          }, {
            code: 'VOLGOGRADSKAYA',
            name: 'Volgogradskaya'
          }, {
            code: 'VOLOGODSKAYA',
            name: 'Vologodskaya'
          }, {
            code: 'VORONEZHSKAYA',
            name: 'Voronezhskaya'
          }, {
            code: 'YAMALO-NENETSKIY (SALEKHARD)',
            name: 'Yamalo-Nenetskiy (Salekhard)'
          }, {
            code: 'YAROSLAVSKAYA',
            name: 'Yaroslavskaya'
          }, {
            code: 'YEVREYSKAYA',
            name: 'Yevreyskaya'
          }];
        case 'RW':
          return [{
            code: 'BUTARE',
            name: 'Butare'
          }, {
            code: 'BYUMBA',
            name: 'Byumba'
          }, {
            code: 'CYANGUGU',
            name: 'Cyangugu'
          }, {
            code: 'GIKONGORO',
            name: 'Gikongoro'
          }, {
            code: 'GISENYI',
            name: 'Gisenyi'
          }, {
            code: 'GITARAMA',
            name: 'Gitarama'
          }, {
            code: 'KIBUNGO',
            name: 'Kibungo'
          }, {
            code: 'KIBUYE',
            name: 'Kibuye'
          }, {
            code: 'KIGALI RURALE',
            name: 'Kigali Rurale'
          }, {
            code: 'KIGALI-VILLE',
            name: 'Kigali-ville'
          }, {
            code: 'RUHENGERI',
            name: 'Ruhengeri'
          }, {
            code: 'UMUTARA',
            name: 'Umutara'
          }];
        case 'SH':
          return [{
            code: 'ASCENSION',
            name: 'Ascension'
          }, {
            code: 'SAINT HELENA',
            name: 'Saint Helena'
          }, {
            code: 'TRISTAN DA CUNHA',
            name: 'Tristan da Cunha'
          }];
        case 'KN':
          return [{
            code: 'CHRIST CHURCH NICHOLA TOWN',
            name: 'Christ Church Nichola Town'
          }, {
            code: 'SAINT ANNE SANDY POINT',
            name: 'Saint Anne Sandy Point'
          }, {
            code: 'SAINT GEORGE BASSETERRE',
            name: 'Saint George Basseterre'
          }, {
            code: 'SAINT GEORGE GINGERLAND',
            name: 'Saint George Gingerland'
          }, {
            code: 'SAINT JAMES WINDWARD',
            name: 'Saint James Windward'
          }, {
            code: 'SAINT JOHN CAPISTERRE',
            name: 'Saint John Capisterre'
          }, {
            code: 'SAINT JOHN FIGTREE',
            name: 'Saint John Figtree'
          }, {
            code: 'SAINT MARY CAYON',
            name: 'Saint Mary Cayon'
          }, {
            code: 'SAINT PAUL CAPISTERRE',
            name: 'Saint Paul Capisterre'
          }, {
            code: 'SAINT PAUL CHARLESTOWN',
            name: 'Saint Paul Charlestown'
          }, {
            code: 'SAINT PETER BASSETERRE',
            name: 'Saint Peter Basseterre'
          }, {
            code: 'SAINT THOMAS LOWLAND',
            name: 'Saint Thomas Lowland'
          }, {
            code: 'SAINT THOMAS MIDDLE ISLAND',
            name: 'Saint Thomas Middle Island'
          }, {
            code: 'TRINITY PALMETTO POINT',
            name: 'Trinity Palmetto Point'
          }];
        case 'PM':
          return [{
            code: 'MIQUELON',
            NAME: 'MIQUELON'
          }, {
            code: 'SAINT PIERRE',
            name: 'Saint Pierre'
          }];
        case 'VC':
          return [{
            code: 'CHARLOTTE',
            name: 'Charlotte'
          }, {
            code: 'GRENADINES',
            name: 'Grenadines'
          }, {
            code: 'SAINT ANDREW',
            name: 'Saint Andrew'
          }, {
            code: 'SAINT DAVID',
            name: 'Saint David'
          }, {
            code: 'SAINT GEORGE',
            name: 'Saint George'
          }, {
            code: 'SAINT PATRICK',
            name: 'Saint Patrick'
          }];
        case 'WS':
          return [{
            code: 'AANA',
            name: 'Aana'
          }, {
            code: 'AIGA-I-LE-TAI',
            name: 'Aiga-i-le-Tai'
          }, {
            code: 'ATUA',
            name: 'Atua'
          }, {
            code: 'FAASALELEAGA',
            name: 'Faasaleleaga'
          }, {
            code: 'GAGAEMAUGA',
            name: 'Gagaemauga'
          }, {
            code: 'GAGAIFOMAUGA',
            name: 'Gagaifomauga'
          }, {
            code: 'PALAULI',
            name: 'Palauli'
          }, {
            code: 'SATUPAITEA',
            name: 'Satupaitea'
          }, {
            code: 'TUAMASAGA',
            name: 'Tuamasaga'
          }, {
            code: 'VAA-O-FONOTI',
            name: 'Vaa-o-Fonoti'
          }, {
            code: 'VAISIGANO',
            name: 'Vaisigano'
          }];
        case 'SM':
          return [{
            code: 'ACQUAVIVA',
            name: 'Acquaviva'
          }, {
            code: 'BORGO MAGGIORE',
            name: 'Borgo Maggiore'
          }, {
            code: 'CHIESANUOVA',
            name: 'Chiesanuova'
          }, {
            code: 'DOMAGNANO',
            name: 'Domagnano'
          }, {
            code: 'FAETANO',
            name: 'Faetano'
          }, {
            code: 'FIORENTINO',
            name: 'Fiorentino'
          }, {
            code: 'MONTE GIARDINO',
            name: 'Monte Giardino'
          }, {
            code: 'SAN MARINO',
            name: 'San Marino'
          }, {
            code: 'SERRAVALLE',
            name: 'Serravalle'
          }];
        case 'ST':
          return [{
            code: 'PRINCIPE',
            NAME: 'PRINCIPE'
          }, {
            code: 'SAO TOME',
            name: 'Sao Tome'
          }];
        case 'SA':
          return [{
            code: 'ASIR',
            name: 'Asir'
          }, {
            code: 'AL BAHAH',
            name: 'Al Bahah'
          }, {
            code: 'AL HUDUD ASH SHAMALIYAH',
            name: 'Al Hudud ash Shamaliyah'
          }, {
            code: 'AL JAWF',
            name: 'Al Jawf'
          }, {
            code: 'AL MADINAH',
            name: 'Al Madinah'
          }, {
            code: 'AL QASIM',
            name: 'Al Qasim'
          }, {
            code: 'AR RIYAD',
            name: 'Ar Riyad'
          }, {
            code: 'ASH SHARQIYAH (EASTERN PROVINCE)',
            name: 'Ash Sharqiyah (Eastern Province)'
          }, {
            code: 'HAIL',
            name: 'Hail'
          }, {
            code: 'JIZAN',
            name: 'Jizan'
          }, {
            code: 'MAKKAH',
            name: 'Makkah'
          }, {
            code: 'NAJRAN',
            name: 'Najran'
          }, {
            code: 'TABUK',
            name: 'Tabuk'
          }];
        case 'SN':
          return [{
            code: 'DAKAR',
            name: 'Dakar'
          }, {
            code: 'DIOURBEL',
            name: 'Diourbel'
          }, {
            code: 'FATICK',
            name: 'Fatick'
          }, {
            code: 'KAOLACK',
            name: 'Kaolack'
          }, {
            code: 'KOLDA',
            name: 'Kolda'
          }, {
            code: 'LOUGA',
            name: 'Louga'
          }, {
            code: 'SAINT-LOUIS',
            name: 'Saint-Louis'
          }, {
            code: 'TAMBACOUNDA',
            name: 'Tambacounda'
          }, {
            code: 'THIES',
            name: 'Thies'
          }, {
            code: 'ZIGUINCHOR',
            name: 'Ziguinchor'
          }];
        case 'SC':
          return [{
            code: 'ANSE AUX PINS',
            name: 'Anse aux Pins'
          }, {
            code: 'ANSE BOILEAU',
            name: 'Anse Boileau'
          }, {
            code: 'ANSE ETOILE',
            name: 'Anse Etoile'
          }, {
            code: 'ANSE LOUIS',
            name: 'Anse Louis'
          }, {
            code: 'ANSE ROYALE',
            name: 'Anse Royale'
          }, {
            code: 'BAIE LAZARE',
            name: 'Baie Lazare'
          }, {
            code: 'BAIE SAINTE ANNE',
            name: 'Baie Sainte Anne'
          }, {
            code: 'BEAU VALLON',
            name: 'Beau Vallon'
          }, {
            code: 'BEL AIR',
            name: 'Bel Air'
          }, {
            code: 'BEL OMBRE',
            name: 'Bel Ombre'
          }, {
            code: 'CASCADE',
            name: 'Cascade'
          }, {
            code: 'GLACIS',
            name: 'Glacis'
          }, {
            code: 'GRAND ANSE (ON MAHE)',
            name: 'Grand Anse (on Mahe)'
          }, {
            code: 'GRAND ANSE (ON PRASLIN)',
            name: 'Grand Anse (on Praslin)'
          }, {
            code: 'LA DIGUE',
            name: 'La Digue'
          }, {
            code: 'LA RIVIERE ANGLAISE',
            name: 'La Riviere Anglaise'
          }, {
            code: 'MONT BUXTON',
            name: 'Mont Buxton'
          }, {
            code: 'MONT FLEURI',
            name: 'Mont Fleuri'
          }, {
            code: 'PLAISANCE',
            name: 'Plaisance'
          }, {
            code: 'POINTE LA RUE',
            name: 'Pointe La Rue'
          }, {
            code: 'PORT GLAUD',
            name: 'Port Glaud'
          }, {
            code: 'SAINT LOUIS',
            name: 'Saint Louis'
          }, {
            code: 'TAKAMAKA',
            name: 'Takamaka'
          }];
        case 'SL':
          return [{
            code: 'EASTERN',
            name: 'Eastern'
          }, {
            code: 'NORTHERN',
            name: 'Northern'
          }, {
            code: 'SOUTHERN',
            name: 'Southern'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'SG':
          return [{
            code: 'SINGAPORE',
            name: 'Singapore'
          }];
        case 'SK':
          return [{
            code: 'BANSKOBYSTRICKY',
            name: 'Banskobystricky'
          }, {
            code: 'BRATISLAVSKY',
            name: 'Bratislavsky'
          }, {
            code: 'KOSICKY',
            name: 'Kosicky'
          }, {
            code: 'NITRIANSKY',
            name: 'Nitriansky'
          }, {
            code: 'PRESOVSKY',
            name: 'Presovsky'
          }, {
            code: 'TRENCIANSKY',
            name: 'Trenciansky'
          }, {
            code: 'TRNAVSKY',
            name: 'Trnavsky'
          }, {
            code: 'ZILINSKY',
            name: 'Zilinsky'
          }];
        case 'SI':
          return [{
            code: 'AJDOVSCINA',
            name: 'Ajdovscina'
          }, {
            code: 'BELTINCI',
            name: 'Beltinci'
          }, {
            code: 'BLED',
            name: 'Bled'
          }, {
            code: 'BOHINJ',
            name: 'Bohinj'
          }, {
            code: 'BOROVNICA',
            name: 'Borovnica'
          }, {
            code: 'BOVEC',
            name: 'Bovec'
          }, {
            code: 'BRDA',
            name: 'Brda'
          }, {
            code: 'BREZICE',
            name: 'Brezice'
          }, {
            code: 'BREZOVICA',
            name: 'Brezovica'
          }, {
            code: 'CANKOVA-TISINA',
            name: 'Cankova-Tisina'
          }, {
            code: 'CELJE',
            name: 'Celje'
          }, {
            code: 'CERKLJE NA GORENJSKEM',
            name: 'Cerklje na Gorenjskem'
          }, {
            code: 'CERKNICA',
            name: 'Cerknica'
          }, {
            code: 'CERKNO',
            name: 'Cerkno'
          }, {
            code: 'CRENSOVCI',
            name: 'Crensovci'
          }, {
            code: 'CRNA NA KOROSKEM',
            name: 'Crna na Koroskem'
          }, {
            code: 'CRNOMELJ',
            name: 'Crnomelj'
          }, {
            code: 'DESTRNIK-TRNOVSKA VAS',
            name: 'Destrnik-Trnovska Vas'
          }, {
            code: 'DIVACA',
            name: 'Divaca'
          }, {
            code: 'DOBREPOLJE',
            name: 'Dobrepolje'
          }, {
            code: 'DOBROVA-HORJUL-POLHOV GRADEC',
            name: 'Dobrova-Horjul-Polhov Gradec'
          }, {
            code: 'DOL PRI LJUBLJANI',
            name: 'Dol pri Ljubljani'
          }, {
            code: 'DOMZALE',
            name: 'Domzale'
          }, {
            code: 'DORNAVA',
            name: 'Dornava'
          }, {
            code: 'DRAVOGRAD',
            name: 'Dravograd'
          }, {
            code: 'DUPLEK',
            name: 'Duplek'
          }, {
            code: 'GORENJA VAS-POLJANE',
            name: 'Gorenja Vas-Poljane'
          }, {
            code: 'GORISNICA',
            name: 'Gorisnica'
          }, {
            code: 'GORNJA RADGONA',
            name: 'Gornja Radgona'
          }, {
            code: 'GORNJI GRAD',
            name: 'Gornji Grad'
          }, {
            code: 'GORNJI PETROVCI',
            name: 'Gornji Petrovci'
          }, {
            code: 'GROSUPLJE',
            name: 'Grosuplje'
          }, {
            code: 'HODOS SALOVCI',
            name: 'Hodos Salovci'
          }, {
            code: 'HRASTNIK',
            name: 'Hrastnik'
          }, {
            code: 'HRPELJE-KOZINA',
            name: 'Hrpelje-Kozina'
          }, {
            code: 'IDRIJA',
            name: 'Idrija'
          }, {
            code: 'IG',
            name: 'Ig'
          }, {
            code: 'ILIRSKA BISTRICA',
            name: 'Ilirska Bistrica'
          }, {
            code: 'IVANCNA GORICA',
            name: 'Ivancna Gorica'
          }, {
            code: 'IZOLA',
            name: 'Izola'
          }, {
            code: 'JESENICE',
            name: 'Jesenice'
          }, {
            code: 'JURSINCI',
            name: 'Jursinci'
          }, {
            code: 'KAMNIK',
            name: 'Kamnik'
          }, {
            code: 'KANAL',
            name: 'Kanal'
          }, {
            code: 'KIDRICEVO',
            name: 'Kidricevo'
          }, {
            code: 'KOBARID',
            name: 'Kobarid'
          }, {
            code: 'KOBILJE',
            name: 'Kobilje'
          }, {
            code: 'KOCEVJE',
            name: 'Kocevje'
          }, {
            code: 'KOMEN',
            name: 'Komen'
          }, {
            code: 'KOPER',
            name: 'Koper'
          }, {
            code: 'KOZJE',
            name: 'Kozje'
          }, {
            code: 'KRANJ',
            name: 'Kranj'
          }, {
            code: 'KRANJSKA GORA',
            name: 'Kranjska Gora'
          }, {
            code: 'KRSKO',
            name: 'Krsko'
          }, {
            code: 'KUNGOTA',
            name: 'Kungota'
          }, {
            code: 'KUZMA',
            name: 'Kuzma'
          }, {
            code: 'LASKO',
            name: 'Lasko'
          }, {
            code: 'LENART',
            name: 'Lenart'
          }, {
            code: 'LENDAVA',
            name: 'Lendava'
          }, {
            code: 'LITIJA',
            name: 'Litija'
          }, {
            code: 'LJUBLJANA',
            name: 'Ljubljana'
          }, {
            code: 'LJUBNO',
            name: 'Ljubno'
          }, {
            code: 'LJUTOMER',
            name: 'Ljutomer'
          }, {
            code: 'LOGATEC',
            name: 'Logatec'
          }, {
            code: 'LOSKA DOLINA',
            name: 'Loska Dolina'
          }, {
            code: 'LOSKI POTOK',
            name: 'Loski Potok'
          }, {
            code: 'LUCE',
            name: 'Luce'
          }, {
            code: 'LUKOVICA',
            name: 'Lukovica'
          }, {
            code: 'MAJSPERK',
            name: 'Majsperk'
          }, {
            code: 'MARIBOR',
            name: 'Maribor'
          }, {
            code: 'MEDVODE',
            name: 'Medvode'
          }, {
            code: 'MENGES',
            name: 'Menges'
          }, {
            code: 'METLIKA',
            name: 'Metlika'
          }, {
            code: 'MEZICA',
            name: 'Mezica'
          }, {
            code: 'MIREN-KOSTANJEVICA',
            name: 'Miren-Kostanjevica'
          }, {
            code: 'MISLINJA',
            name: 'Mislinja'
          }, {
            code: 'MORAVCE',
            name: 'Moravce'
          }, {
            code: 'MORAVSKE TOPLICE',
            name: 'Moravske Toplice'
          }, {
            code: 'MOZIRJE',
            name: 'Mozirje'
          }, {
            code: 'MURSKA SOBOTA',
            name: 'Murska Sobota'
          }, {
            code: 'MUTA',
            name: 'Muta'
          }, {
            code: 'NAKLO',
            name: 'Naklo'
          }, {
            code: 'NAZARJE',
            name: 'Nazarje'
          }, {
            code: 'NOVA GORICA',
            name: 'Nova Gorica'
          }, {
            code: 'NOVO MESTO',
            name: 'Novo Mesto'
          }, {
            code: 'ODRANCI',
            name: 'Odranci'
          }, {
            code: 'ORMOZ',
            name: 'Ormoz'
          }, {
            code: 'OSILNICA',
            name: 'Osilnica'
          }, {
            code: 'PESNICA',
            name: 'Pesnica'
          }, {
            code: 'PIRAN',
            name: 'Piran'
          }, {
            code: 'PIVKA',
            name: 'Pivka'
          }, {
            code: 'PODCETRTEK',
            name: 'Podcetrtek'
          }, {
            code: 'PODVELKA-RIBNICA',
            name: 'Podvelka-Ribnica'
          }, {
            code: 'POSTOJNA',
            name: 'Postojna'
          }, {
            code: 'PREDDVOR',
            name: 'Preddvor'
          }, {
            code: 'PTUJ',
            name: 'Ptuj'
          }, {
            code: 'PUCONCI',
            name: 'Puconci'
          }, {
            code: 'RACE-FRAM',
            name: 'Race-Fram'
          }, {
            code: 'RADECE',
            name: 'Radece'
          }, {
            code: 'RADENCI',
            name: 'Radenci'
          }, {
            code: 'RADLJE OB DRAVI',
            name: 'Radlje ob Dravi'
          }, {
            code: 'RADOVLJICA',
            name: 'Radovljica'
          }, {
            code: 'RAVNE-PREVALJE',
            name: 'Ravne-Prevalje'
          }, {
            code: 'RIBNICA',
            name: 'Ribnica'
          }, {
            code: 'ROGASEVCI',
            name: 'Rogasevci'
          }, {
            code: 'ROGASKA SLATINA',
            name: 'Rogaska Slatina'
          }, {
            code: 'ROGATEC',
            name: 'Rogatec'
          }, {
            code: 'RUSE',
            name: 'Ruse'
          }, {
            code: 'SEMIC',
            name: 'Semic'
          }, {
            code: 'SENCUR',
            name: 'Sencur'
          }, {
            code: 'SENTILJ',
            name: 'Sentilj'
          }, {
            code: 'SENTJERNEJ',
            name: 'Sentjernej'
          }, {
            code: 'SENTJUR PRI CELJU',
            name: 'Sentjur pri Celju'
          }, {
            code: 'SEVNICA',
            name: 'Sevnica'
          }, {
            code: 'SEZANA',
            name: 'Sezana'
          }, {
            code: 'SKOCJAN',
            name: 'Skocjan'
          }, {
            code: 'SKOFJA LOKA',
            name: 'Skofja Loka'
          }, {
            code: 'SKOFLJICA',
            name: 'Skofljica'
          }, {
            code: 'SLOVENJ GRADEC',
            name: 'Slovenj Gradec'
          }, {
            code: 'SLOVENSKA BISTRICA',
            name: 'Slovenska Bistrica'
          }, {
            code: 'SLOVENSKE KONJICE',
            name: 'Slovenske Konjice'
          }, {
            code: 'SMARJE PRI JELSAH',
            name: 'Smarje pri Jelsah'
          }, {
            code: 'SMARTNO OB PAKI',
            name: 'Smartno ob Paki'
          }, {
            code: 'SOSTANJ',
            name: 'Sostanj'
          }, {
            code: 'STARSE',
            name: 'Starse'
          }, {
            code: 'STORE',
            name: 'Store'
          }, {
            code: 'SVETI JURIJ',
            name: 'Sveti Jurij'
          }, {
            code: 'TOLMIN',
            name: 'Tolmin'
          }, {
            code: 'TRBOVLJE',
            name: 'Trbovlje'
          }, {
            code: 'TREBNJE',
            name: 'Trebnje'
          }, {
            code: 'TRZIC',
            name: 'Trzic'
          }, {
            code: 'TURNISCE',
            name: 'Turnisce'
          }, {
            code: 'VELENJE',
            name: 'Velenje'
          }, {
            code: 'VELIKE LASCE',
            name: 'Velike Lasce'
          }, {
            code: 'VIDEM',
            name: 'Videm'
          }, {
            code: 'VIPAVA',
            name: 'Vipava'
          }, {
            code: 'VITANJE',
            name: 'Vitanje'
          }, {
            code: 'VODICE',
            name: 'Vodice'
          }, {
            code: 'VOJNIK',
            name: 'Vojnik'
          }, {
            code: 'VRHNIKA',
            name: 'Vrhnika'
          }, {
            code: 'VUZENICA',
            name: 'Vuzenica'
          }, {
            code: 'ZAGORJE OB SAVI',
            name: 'Zagorje ob Savi'
          }, {
            code: 'ZALEC',
            name: 'Zalec'
          }, {
            code: 'ZAVRC',
            name: 'Zavrc'
          }, {
            code: 'ZELEZNIKI',
            name: 'Zelezniki'
          }, {
            code: 'ZIRI',
            name: 'Ziri'
          }, {
            code: 'ZRECE',
            name: 'Zrece'
          }];
        case 'SB':
          return [{
            code: 'BELLONA',
            name: 'Bellona'
          }, {
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'CHOISEUL (LAURU)',
            name: 'Choiseul (Lauru)'
          }, {
            code: 'GUADALCANAL',
            name: 'Guadalcanal'
          }, {
            code: 'HONIARA',
            name: 'Honiara'
          }, {
            code: 'ISABEL',
            name: 'Isabel'
          }, {
            code: 'MAKIRA',
            name: 'Makira'
          }, {
            code: 'MALAITA',
            name: 'Malaita'
          }, {
            code: 'RENNELL',
            name: 'Rennell'
          }, {
            code: 'TEMOTU',
            name: 'Temotu'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'SO':
          return [{
            code: 'AWDAL',
            name: 'Awdal'
          }, {
            code: 'BAKOOL',
            name: 'Bakool'
          }, {
            code: 'BANAADIR',
            name: 'Banaadir'
          }, {
            code: 'BARI',
            name: 'Bari'
          }, {
            code: 'BAY',
            name: 'Bay'
          }, {
            code: 'GALGUDUUD',
            name: 'Galguduud'
          }, {
            code: 'GEDO',
            name: 'Gedo'
          }, {
            code: 'HIIRAAN',
            name: 'Hiiraan'
          }, {
            code: 'JUBBADA DHEXE',
            name: 'Jubbada Dhexe'
          }, {
            code: 'JUBBADA HOOSE',
            name: 'Jubbada Hoose'
          }, {
            code: 'MUDUG',
            name: 'Mudug'
          }, {
            code: 'NUGAAL',
            name: 'Nugaal'
          }, {
            code: 'SANAAG',
            name: 'Sanaag'
          }, {
            code: 'SHABEELLAHA DHEXE',
            name: 'Shabeellaha Dhexe'
          }, {
            code: 'SHABEELLAHA HOOSE',
            name: 'Shabeellaha Hoose'
          }, {
            code: 'SOOL',
            name: 'Sool'
          }, {
            code: 'TOGDHEER',
            name: 'Togdheer'
          }, {
            code: 'WOQOOYI GALBEED',
            name: 'Woqooyi Galbeed'
          }];
        case 'ZA':
          return [{
            code: 'EASTERN CAPE',
            name: 'Eastern Cape'
          }, {
            code: 'FREE STATE',
            name: 'Free State'
          }, {
            code: 'GAUTENG',
            name: 'Gauteng'
          }, {
            code: 'KWAZULU-NATAL',
            name: 'KwaZulu-Natal'
          }, {
            code: 'MPUMALANGA',
            name: 'Mpumalanga'
          }, {
            code: 'NORTH-WEST',
            name: 'North-West'
          }, {
            code: 'NORTHERN CAPE',
            name: 'Northern Cape'
          }, {
            code: 'NORTHERN PROVINCE',
            name: 'Northern Province'
          }, {
            code: 'WESTERN CAPE',
            name: 'Western Cape'
          }];
        case 'ES':
          return [{
            code: 'ANDALUCIA',
            name: 'Andalucia'
          }, {
            code: 'ARAGON',
            name: 'Aragon'
          }, {
            code: 'ASTURIAS',
            name: 'Asturias'
          }, {
            code: 'BALEARES (BALEARIC ISLANDS)',
            name: 'Baleares (Balearic Islands)'
          }, {
            code: 'CANARIAS (CANARY ISLANDS)',
            name: 'Canarias (Canary Islands)'
          }, {
            code: 'CANTABRIA',
            name: 'Cantabria'
          }, {
            code: 'CASTILLA Y LEON',
            name: 'Castilla y Leon'
          }, {
            code: 'CASTILLA-LA MANCHA',
            name: 'Castilla-La Mancha'
          }, {
            code: 'CATALUNA',
            name: 'Cataluna'
          }, {
            code: 'CEUTA',
            name: 'Ceuta'
          }, {
            code: 'COMMUNIDAD VALENCIAN',
            name: 'Communidad Valencian'
          }, {
            code: 'EXTREMADURA',
            name: 'Extremadura'
          }, {
            code: 'GALICIA',
            name: 'Galicia'
          }, {
            code: 'ISLAS CHAFARINAS',
            name: 'Islas Chafarinas'
          }, {
            code: 'LA RIOJA',
            name: 'La Rioja'
          }, {
            code: 'MADRID',
            name: 'Madrid'
          }, {
            code: 'MELILLA',
            name: 'Melilla'
          }, {
            code: 'MURCIA',
            name: 'Murcia'
          }, {
            code: 'NAVARRA',
            name: 'Navarra'
          }, {
            code: 'PAIS VASCO (BASQUE COUNTRY)',
            name: 'Pais Vasco (Basque Country)'
          }, {
            code: 'PENON DE ALHUCEMAS',
            name: 'Penon de Alhucemas'
          }, {
            code: 'PENON DE VELEZ DE LA GOMERA',
            name: 'Penon de Velez de la Gomera'
          }];
        case 'LK':
          return [{
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'EASTERN',
            name: 'Eastern'
          }, {
            code: 'NORTH CENTRAL',
            name: 'North Central'
          }, {
            code: 'NORTH EASTERN',
            name: 'North Eastern'
          }, {
            code: 'NORTH WESTERN',
            name: 'North Western'
          }, {
            code: 'NORTHERN',
            name: 'Northern'
          }, {
            code: 'SABARAGAMUWA',
            name: 'Sabaragamuwa'
          }, {
            code: 'SOUTHERN',
            name: 'Southern'
          }, {
            code: 'UVA',
            name: 'Uva'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'SD':
          return [{
            code: 'AALI AN NIL',
            name: 'Aali an Nil'
          }, {
            code: 'AL BAHR AL AHMAR',
            name: 'Al Bahr al Ahmar'
          }, {
            code: 'AL BUHAYRAT',
            name: 'Al Buhayrat'
          }, {
            code: 'AL JAZIRAH',
            name: 'Al Jazirah'
          }, {
            code: 'AL KHARTUM',
            name: 'Al Khartum'
          }, {
            code: 'AL QADARIF',
            name: 'Al Qadarif'
          }, {
            code: 'AL WAHDAH',
            name: 'Al Wahdah'
          }, {
            code: 'AN NIL AL ABYAD',
            name: 'An Nil al Abyad'
          }, {
            code: 'AN NIL AL AZRAQ',
            name: 'An Nil al Azraq'
          }, {
            code: 'ASH SHAMALIYAH',
            name: 'Ash Shamaliyah'
          }, {
            code: 'BAHR AL JABAL',
            name: 'Bahr al Jabal'
          }, {
            code: 'GHARB AL ISTIWAIYAH',
            name: 'Gharb al Istiwaiyah'
          }, {
            code: 'GHARB BAHR AL GHAZAL',
            name: 'Gharb Bahr al Ghazal'
          }, {
            code: 'GHARB DARFUR',
            name: 'Gharb Darfur'
          }, {
            code: 'GHARB KURDUFAN',
            name: 'Gharb Kurdufan'
          }, {
            code: 'JANUB DARFUR',
            name: 'Janub Darfur'
          }, {
            code: 'JANUB KURDUFAN',
            name: 'Janub Kurdufan'
          }, {
            code: 'JUNQALI',
            name: 'Junqali'
          }, {
            code: 'KASSALA',
            name: 'Kassala'
          }, {
            code: 'NAHR AN NIL',
            name: 'Nahr an Nil'
          }, {
            code: 'SHAMAL BAHR AL GHAZAL',
            name: 'Shamal Bahr al Ghazal'
          }, {
            code: 'SHAMAL DARFUR',
            name: 'Shamal Darfur'
          }, {
            code: 'SHAMAL KURDUFAN',
            name: 'Shamal Kurdufan'
          }, {
            code: 'SHARQ AL ISTIWAIYAH',
            name: 'Sharq al Istiwaiyah'
          }, {
            code: 'SINNAR',
            name: 'Sinnar'
          }, {
            code: 'WARAB',
            name: 'Warab'
          }];
        case 'SR':
          return [{
            code: 'BROKOPONDO',
            name: 'Brokopondo'
          }, {
            code: 'COMMEWIJNE',
            name: 'Commewijne'
          }, {
            code: 'CORONIE',
            name: 'Coronie'
          }, {
            code: 'MAROWIJNE',
            name: 'Marowijne'
          }, {
            code: 'NICKERIE',
            name: 'Nickerie'
          }, {
            code: 'PARA',
            name: 'Para'
          }, {
            code: 'PARAMARIBO',
            name: 'Paramaribo'
          }, {
            code: 'SARAMACCA',
            name: 'Saramacca'
          }, {
            code: 'SIPALIWINI',
            name: 'Sipaliwini'
          }, {
            code: 'WANICA',
            name: 'Wanica'
          }];
        case 'SZ':
          return [{
            code: 'HHOHHO',
            name: 'Hhohho'
          }, {
            code: 'LUBOMBO',
            name: 'Lubombo'
          }, {
            code: 'MANZINI',
            name: 'Manzini'
          }, {
            code: 'SHISELWENI',
            name: 'Shiselweni'
          }];
        case 'SE':
          return [{
            code: 'BLEKINGE',
            name: 'Blekinge'
          }, {
            code: 'DALARNAS',
            name: 'Dalarnas'
          }, {
            code: 'GAVLEBORGS',
            name: 'Gavleborgs'
          }, {
            code: 'GOTLANDS',
            name: 'Gotlands'
          }, {
            code: 'HALLANDS',
            name: 'Hallands'
          }, {
            code: 'JAMTLANDS',
            name: 'Jamtlands'
          }, {
            code: 'JONKOPINGS',
            name: 'Jonkopings'
          }, {
            code: 'KALMAR',
            name: 'Kalmar'
          }, {
            code: 'KRONOBERGS',
            name: 'Kronobergs'
          }, {
            code: 'NORRBOTTENS',
            name: 'Norrbottens'
          }, {
            code: 'OREBRO',
            name: 'Orebro'
          }, {
            code: 'OSTERGOTLANDS',
            name: 'Ostergotlands'
          }, {
            code: 'SKANE',
            name: 'Skane'
          }, {
            code: 'SODERMANLANDS',
            name: 'Sodermanlands'
          }, {
            code: 'STOCKHOLMS',
            name: 'Stockholms'
          }, {
            code: 'UPPSALA',
            name: 'Uppsala'
          }, {
            code: 'VARMLANDS',
            name: 'Varmlands'
          }, {
            code: 'VASTERBOTTENS',
            name: 'Vasterbottens'
          }, {
            code: 'VASTERNORRLANDS',
            name: 'Vasternorrlands'
          }, {
            code: 'VASTMANLANDS',
            name: 'Vastmanlands'
          }, {
            code: 'VASTRA GOTALANDS',
            name: 'Vastra Gotalands'
          }];
        case 'CH':
          return [{
            code: 'AARGAU',
            name: 'Aargau'
          }, {
            code: 'AUSSER-RHODEN',
            name: 'Ausser-Rhoden'
          }, {
            code: 'BASEL-LANDSCHAFT',
            name: 'Basel-Landschaft'
          }, {
            code: 'BASEL-STADT',
            name: 'Basel-Stadt'
          }, {
            code: 'BERN',
            name: 'Bern'
          }, {
            code: 'FRIBOURG',
            name: 'Fribourg'
          }, {
            code: 'GENEVE',
            name: 'Geneve'
          }, {
            code: 'GLARUS',
            name: 'Glarus'
          }, {
            code: 'GRAUBUNDEN',
            name: 'Graubunden'
          }, {
            code: 'INNER-RHODEN',
            name: 'Inner-Rhoden'
          }, {
            code: 'JURA',
            name: 'Jura'
          }, {
            code: 'LUZERN',
            name: 'Luzern'
          }, {
            code: 'NEUCHATEL',
            name: 'Neuchatel'
          }, {
            code: 'NIDWALDEN',
            name: 'Nidwalden'
          }, {
            code: 'OBWALDEN',
            name: 'Obwalden'
          }, {
            code: 'SANKT GALLEN',
            name: 'Sankt Gallen'
          }, {
            code: 'SCHAFFHAUSEN',
            name: 'Schaffhausen'
          }, {
            code: 'SCHWYZ',
            name: 'Schwyz'
          }, {
            code: 'SOLOTHURN',
            name: 'Solothurn'
          }, {
            code: 'THURGAU',
            name: 'Thurgau'
          }, {
            code: 'TICINO',
            name: 'Ticino'
          }, {
            code: 'URI',
            name: 'Uri'
          }, {
            code: 'VALAIS',
            name: 'Valais'
          }, {
            code: 'VAUD',
            name: 'Vaud'
          }, {
            code: 'ZUG',
            name: 'Zug'
          }, {
            code: 'ZURICH',
            name: 'Zurich'
          }];
        case 'SY':
          return [{
            code: 'AL HASAKAH',
            name: 'Al Hasakah'
          }, {
            code: 'AL LADHIQIYAH',
            name: 'Al Ladhiqiyah'
          }, {
            code: 'AL QUNAYTIRAH',
            name: 'Al Qunaytirah'
          }, {
            code: 'AR RAQQAH',
            name: 'Ar Raqqah'
          }, {
            code: 'AS SUWAYDA',
            name: 'As Suwayda'
          }, {
            code: 'DARA',
            name: 'Dara'
          }, {
            code: 'DAYR AZ ZAWR',
            name: 'Dayr az Zawr'
          }, {
            code: 'DIMASHQ',
            name: 'Dimashq'
          }, {
            code: 'HALAB',
            name: 'Halab'
          }, {
            code: 'HAMAH',
            name: 'Hamah'
          }, {
            code: 'HIMS',
            name: 'Hims'
          }, {
            code: 'IDLIB',
            name: 'Idlib'
          }, {
            code: 'RIF DIMASHQ',
            name: 'Rif Dimashq'
          }, {
            code: 'TARTUS',
            name: 'Tartus'
          }];
        case 'TW':
          return [{
            code: 'CHANG-HUA',
            name: 'Chang-hua'
          }, {
            code: 'CHI-LUNG',
            name: 'Chi-lung'
          }, {
            code: 'CHIA-I',
            name: 'Chia-i'
          }, {
            code: 'CHIA-I',
            name: 'Chia-i'
          }, {
            code: 'CHUNG-HSING-HSIN-TSUN',
            name: 'Chung-hsing-hsin-tsun'
          }, {
            code: 'HSIN-CHU',
            name: 'Hsin-chu'
          }, {
            code: 'HSIN-CHU',
            name: 'Hsin-chu'
          }, {
            code: 'HUA-LIEN',
            name: 'Hua-lien'
          }, {
            code: 'I-LAN',
            name: 'I-lan'
          }, {
            code: 'KAO-HSIUNG',
            name: 'Kao-hsiung'
          }, {
            code: 'KAO-HSIUNG',
            name: 'Kao-hsiung'
          }, {
            code: 'MIAO-LI',
            name: 'Miao-li'
          }, {
            code: 'NAN-TOU',
            name: 'Nan-tou'
          }, {
            code: 'PENG-HU',
            name: 'Peng-hu'
          }, {
            code: 'PING-TUNG',
            name: 'Ping-tung'
          }, {
            code: 'TAI-CHUNG',
            name: 'Tai-chung'
          }, {
            code: 'TAI-CHUNG',
            name: 'Tai-chung'
          }, {
            code: 'TAI-NAN',
            name: 'Tai-nan'
          }, {
            code: 'TAI-NAN',
            name: 'Tai-nan'
          }, {
            code: 'TAI-PEI',
            name: 'Tai-pei'
          }, {
            code: 'TAI-PEI',
            name: 'Tai-pei'
          }, {
            code: 'TAI-TUNG',
            name: 'Tai-tung'
          }, {
            code: 'TAO-YUAN',
            name: 'Tao-yuan'
          }, {
            code: 'YUN-LIN',
            name: 'Yun-lin'
          }];
        case 'TJ':
          return [{
            code: 'VILOYATI KHATLON',
            name: 'Viloyati Khatlon'
          }, {
            code: 'VILOYATI LENINOBOD',
            name: 'Viloyati Leninobod'
          }, {
            code: 'VILOYATI MUKHTORI KUHISTONI BADAKHSHON',
            name: 'Viloyati Mukhtori Kuhistoni Badakhshon'
          }];
        case 'TZ':
          return [{
            code: 'ARUSHA',
            name: 'Arusha'
          }, {
            code: 'DAR ES SALAAM',
            name: 'Dar es Salaam'
          }, {
            code: 'DODOMA',
            name: 'Dodoma'
          }, {
            code: 'IRINGA',
            name: 'Iringa'
          }, {
            code: 'KAGERA',
            name: 'Kagera'
          }, {
            code: 'KIGOMA',
            name: 'Kigoma'
          }, {
            code: 'KILIMANJARO',
            name: 'Kilimanjaro'
          }, {
            code: 'LINDI',
            name: 'Lindi'
          }, {
            code: 'MARA',
            name: 'Mara'
          }, {
            code: 'MBEYA',
            name: 'Mbeya'
          }, {
            code: 'MOROGORO',
            name: 'Morogoro'
          }, {
            code: 'MTWARA',
            name: 'Mtwara'
          }, {
            code: 'MWANZA',
            name: 'Mwanza'
          }, {
            code: 'PEMBA NORTH',
            name: 'Pemba North'
          }, {
            code: 'PEMBA SOUTH',
            name: 'Pemba South'
          }, {
            code: 'PWANI',
            name: 'Pwani'
          }, {
            code: 'RUKWA',
            name: 'Rukwa'
          }, {
            code: 'RUVUMA',
            name: 'Ruvuma'
          }, {
            code: 'SHINYANGA',
            name: 'Shinyanga'
          }, {
            code: 'SINGIDA',
            name: 'Singida'
          }, {
            code: 'TABORA',
            name: 'Tabora'
          }, {
            code: 'TANGA',
            name: 'Tanga'
          }, {
            code: 'ZANZIBAR CENTRAL/SOUTH',
            name: 'Zanzibar Central/South'
          }, {
            code: 'ZANZIBAR NORTH',
            name: 'Zanzibar North'
          }, {
            code: 'ZANZIBAR URBAN/WEST',
            name: 'Zanzibar Urban/West'
          }];
        case 'TH':
          return [{
            code: 'AMNAT CHAROEN',
            name: 'Amnat Charoen'
          }, {
            code: 'ANG THONG',
            name: 'Ang Thong'
          }, {
            code: 'BURIRAM',
            name: 'Buriram'
          }, {
            code: 'CHACHOENGSAO',
            name: 'Chachoengsao'
          }, {
            code: 'CHAI NAT',
            name: 'Chai Nat'
          }, {
            code: 'CHAIYAPHUM',
            name: 'Chaiyaphum'
          }, {
            code: 'CHANTHABURI',
            name: 'Chanthaburi'
          }, {
            code: 'CHIANG MAI',
            name: 'Chiang Mai'
          }, {
            code: 'CHIANG RAI',
            name: 'Chiang Rai'
          }, {
            code: 'CHON BURI',
            name: 'Chon Buri'
          }, {
            code: 'CHUMPHON',
            name: 'Chumphon'
          }, {
            code: 'KALASIN',
            name: 'Kalasin'
          }, {
            code: 'KAMPHAENG PHET',
            name: 'Kamphaeng Phet'
          }, {
            code: 'KANCHANABURI',
            name: 'Kanchanaburi'
          }, {
            code: 'KHON KAEN',
            name: 'Khon Kaen'
          }, {
            code: 'KRABI',
            name: 'Krabi'
          }, {
            code: 'KRUNG THEP MAHANAKHON (BANGKOK)',
            name: 'Krung Thep Mahanakhon (Bangkok)'
          }, {
            code: 'LAMPANG',
            name: 'Lampang'
          }, {
            code: 'LAMPHUN',
            name: 'Lamphun'
          }, {
            code: 'LOEI',
            name: 'Loei'
          }, {
            code: 'LOP BURI',
            name: 'Lop Buri'
          }, {
            code: 'MAE HONG SON',
            name: 'Mae Hong Son'
          }, {
            code: 'MAHA SARAKHAM',
            name: 'Maha Sarakham'
          }, {
            code: 'MUKDAHAN',
            name: 'Mukdahan'
          }, {
            code: 'NAKHON NAYOK',
            name: 'Nakhon Nayok'
          }, {
            code: 'NAKHON PATHOM',
            name: 'Nakhon Pathom'
          }, {
            code: 'NAKHON PHANOM',
            name: 'Nakhon Phanom'
          }, {
            code: 'NAKHON RATCHASIMA',
            name: 'Nakhon Ratchasima'
          }, {
            code: 'NAKHON SAWAN',
            name: 'Nakhon Sawan'
          }, {
            code: 'NAKHON SI THAMMARAT',
            name: 'Nakhon Si Thammarat'
          }, {
            code: 'NAN',
            name: 'Nan'
          }, {
            code: 'NARATHIWAT',
            name: 'Narathiwat'
          }, {
            code: 'NONG BUA LAMPHU',
            name: 'Nong Bua Lamphu'
          }, {
            code: 'NONG KHAI',
            name: 'Nong Khai'
          }, {
            code: 'NONTHABURI',
            name: 'Nonthaburi'
          }, {
            code: 'PATHUM THANI',
            name: 'Pathum Thani'
          }, {
            code: 'PATTANI',
            name: 'Pattani'
          }, {
            code: 'PHANGNGA',
            name: 'Phangnga'
          }, {
            code: 'PHATTHALUNG',
            name: 'Phatthalung'
          }, {
            code: 'PHAYAO',
            name: 'Phayao'
          }, {
            code: 'PHETCHABUN',
            name: 'Phetchabun'
          }, {
            code: 'PHETCHABURI',
            name: 'Phetchaburi'
          }, {
            code: 'PHICHIT',
            name: 'Phichit'
          }, {
            code: 'PHITSANULOK',
            name: 'Phitsanulok'
          }, {
            code: 'PHRA NAKHON SI AYUTTHAYA',
            name: 'Phra Nakhon Si Ayutthaya'
          }, {
            code: 'PHRAE',
            name: 'Phrae'
          }, {
            code: 'PHUKET',
            name: 'Phuket'
          }, {
            code: 'PRACHIN BURI',
            name: 'Prachin Buri'
          }, {
            code: 'PRACHUAP KHIRI KHAN',
            name: 'Prachuap Khiri Khan'
          }, {
            code: 'RANONG',
            name: 'Ranong'
          }, {
            code: 'RATCHABURI',
            name: 'Ratchaburi'
          }, {
            code: 'RAYONG',
            name: 'Rayong'
          }, {
            code: 'ROI ET',
            name: 'Roi Et'
          }, {
            code: 'SA KAEO',
            name: 'Sa Kaeo'
          }, {
            code: 'SAKON NAKHON',
            name: 'Sakon Nakhon'
          }, {
            code: 'SAMUT PRAKAN',
            name: 'Samut Prakan'
          }, {
            code: 'SAMUT SAKHON',
            name: 'Samut Sakhon'
          }, {
            code: 'SAMUT SONGKHRAM',
            name: 'Samut Songkhram'
          }, {
            code: 'SARA BURI',
            name: 'Sara Buri'
          }, {
            code: 'SATUN',
            name: 'Satun'
          }, {
            code: 'SING BURI',
            name: 'Sing Buri'
          }, {
            code: 'SISAKET',
            name: 'Sisaket'
          }, {
            code: 'SONGKHLA',
            name: 'Songkhla'
          }, {
            code: 'SUKHOTHAI',
            name: 'Sukhothai'
          }, {
            code: 'SUPHAN BURI',
            name: 'Suphan Buri'
          }, {
            code: 'SURAT THANI',
            name: 'Surat Thani'
          }, {
            code: 'SURIN',
            name: 'Surin'
          }, {
            code: 'TAK',
            name: 'Tak'
          }, {
            code: 'TRANG',
            name: 'Trang'
          }, {
            code: 'TRAT',
            name: 'Trat'
          }, {
            code: 'UBON RATCHATHANI',
            name: 'Ubon Ratchathani'
          }, {
            code: 'UDON THANI',
            name: 'Udon Thani'
          }, {
            code: 'UTHAI THANI',
            name: 'Uthai Thani'
          }, {
            code: 'UTTARADIT',
            name: 'Uttaradit'
          }, {
            code: 'YALA',
            name: 'Yala'
          }, {
            code: 'YASOTHON',
            name: 'Yasothon'
          }];
        case 'TG':
          return [{
            code: 'DE LA KARA',
            name: 'De La Kara'
          }, {
            code: 'DES PLATEAUX',
            name: 'Des Plateaux'
          }, {
            code: 'DES SAVANES',
            name: 'Des Savanes'
          }, {
            code: 'DU CENTRE',
            name: 'Du Centre'
          }, {
            code: 'MARITIME',
            name: 'Maritime'
          }];
        case 'TK':
          return [{
            code: 'ATAFU',
            name: 'Atafu'
          }, {
            code: 'FAKAOFO',
            name: 'Fakaofo'
          }, {
            code: 'NUKUNONU',
            name: 'Nukunonu'
          }];
        case 'TO':
          return [{
            code: 'HAAPAI',
            name: 'Haapai'
          }, {
            code: 'TONGATAPU',
            name: 'Tongatapu'
          }, {
            code: 'VAVAU',
            name: 'Vavau'
          }];
        case 'TT':
          return [{
            code: 'ARIMA',
            name: 'Arima'
          }, {
            code: 'CARONI',
            name: 'Caroni'
          }, {
            code: 'MAYARO',
            name: 'Mayaro'
          }, {
            code: 'NARIVA',
            name: 'Nariva'
          }, {
            code: 'PORT-OF-SPAIN',
            name: 'Port-of-Spain'
          }, {
            code: 'SAINT ANDREW',
            name: 'Saint Andrew'
          }, {
            code: 'SAINT DAVID',
            name: 'Saint David'
          }, {
            code: 'SAINT GEORGE',
            name: 'Saint George'
          }, {
            code: 'SAINT PATRICK',
            name: 'Saint Patrick'
          }, {
            code: 'SAN FERNANDO',
            name: 'San Fernando'
          }, {
            code: 'VICTORIA',
            name: 'Victoria'
          }];
        case 'TN':
          return [{
            code: 'ARIANA',
            name: 'Ariana'
          }, {
            code: 'BEJA',
            name: 'Beja'
          }, {
            code: 'BEN AROUS',
            name: 'Ben Arous'
          }, {
            code: 'BIZERTE',
            name: 'Bizerte'
          }, {
            code: 'EL KEF',
            name: 'El Kef'
          }, {
            code: 'GABES',
            name: 'Gabes'
          }, {
            code: 'GAFSA',
            name: 'Gafsa'
          }, {
            code: 'JENDOUBA',
            name: 'Jendouba'
          }, {
            code: 'KAIROUAN',
            name: 'Kairouan'
          }, {
            code: 'KASSERINE',
            name: 'Kasserine'
          }, {
            code: 'KEBILI',
            name: 'Kebili'
          }, {
            code: 'MAHDIA',
            name: 'Mahdia'
          }, {
            code: 'MEDENINE',
            name: 'Medenine'
          }, {
            code: 'MONASTIR',
            name: 'Monastir'
          }, {
            code: 'NABEUL',
            name: 'Nabeul'
          }, {
            code: 'SFAX',
            name: 'Sfax'
          }, {
            code: 'SIDI BOU ZID',
            name: 'Sidi Bou Zid'
          }, {
            code: 'SILIANA',
            name: 'Siliana'
          }, {
            code: 'SOUSSE',
            name: 'Sousse'
          }, {
            code: 'TATAOUINE',
            name: 'Tataouine'
          }, {
            code: 'TOZEUR',
            name: 'Tozeur'
          }, {
            code: 'TUNIS',
            name: 'Tunis'
          }, {
            code: 'ZAGHOUAN',
            name: 'Zaghouan'
          }];
        case 'TR':
          return [{
            code: 'ADANA',
            name: 'Adana'
          }, {
            code: 'ADIYAMAN',
            name: 'Adiyaman'
          }, {
            code: 'AFYON',
            name: 'Afyon'
          }, {
            code: 'AGRI',
            name: 'Agri'
          }, {
            code: 'AKSARAY',
            name: 'Aksaray'
          }, {
            code: 'AMASYA',
            name: 'Amasya'
          }, {
            code: 'ANKARA',
            name: 'Ankara'
          }, {
            code: 'ANTALYA',
            name: 'Antalya'
          }, {
            code: 'ARDAHAN',
            name: 'Ardahan'
          }, {
            code: 'ARTVIN',
            name: 'Artvin'
          }, {
            code: 'AYDIN',
            name: 'Aydin'
          }, {
            code: 'BALIKESIR',
            name: 'Balikesir'
          }, {
            code: 'BARTIN',
            name: 'Bartin'
          }, {
            code: 'BATMAN',
            name: 'Batman'
          }, {
            code: 'BAYBURT',
            name: 'Bayburt'
          }, {
            code: 'BILECIK',
            name: 'Bilecik'
          }, {
            code: 'BINGOL',
            name: 'Bingol'
          }, {
            code: 'BITLIS',
            name: 'Bitlis'
          }, {
            code: 'BOLU',
            name: 'Bolu'
          }, {
            code: 'BURDUR',
            name: 'Burdur'
          }, {
            code: 'BURSA',
            name: 'Bursa'
          }, {
            code: 'CANAKKALE',
            name: 'Canakkale'
          }, {
            code: 'CANKIRI',
            name: 'Cankiri'
          }, {
            code: 'CORUM',
            name: 'Corum'
          }, {
            code: 'DENIZLI',
            name: 'Denizli'
          }, {
            code: 'DIYARBAKIR',
            name: 'Diyarbakir'
          }, {
            code: 'DUZCE',
            name: 'Duzce'
          }, {
            code: 'EDIRNE',
            name: 'Edirne'
          }, {
            code: 'ELAZIG',
            name: 'Elazig'
          }, {
            code: 'ERZINCAN',
            name: 'Erzincan'
          }, {
            code: 'ERZURUM',
            name: 'Erzurum'
          }, {
            code: 'ESKISEHIR',
            name: 'Eskisehir'
          }, {
            code: 'GAZIANTEP',
            name: 'Gaziantep'
          }, {
            code: 'GIRESUN',
            name: 'Giresun'
          }, {
            code: 'GUMUSHANE',
            name: 'Gumushane'
          }, {
            code: 'HAKKARI',
            name: 'Hakkari'
          }, {
            code: 'HATAY',
            name: 'Hatay'
          }, {
            code: 'ICEL',
            name: 'Icel'
          }, {
            code: 'IGDIR',
            name: 'Igdir'
          }, {
            code: 'ISPARTA',
            name: 'Isparta'
          }, {
            code: 'ISTANBUL',
            name: 'Istanbul'
          }, {
            code: 'IZMIR',
            name: 'Izmir'
          }, {
            code: 'KAHRAMANMARAS',
            name: 'Kahramanmaras'
          }, {
            code: 'KARABUK',
            name: 'Karabuk'
          }, {
            code: 'KARAMAN',
            name: 'Karaman'
          }, {
            code: 'KARS',
            name: 'Kars'
          }, {
            code: 'KASTAMONU',
            name: 'Kastamonu'
          }, {
            code: 'KAYSERI',
            name: 'Kayseri'
          }, {
            code: 'KILIS',
            name: 'Kilis'
          }, {
            code: 'KIRIKKALE',
            name: 'Kirikkale'
          }, {
            code: 'KIRKLARELI',
            name: 'Kirklareli'
          }, {
            code: 'KIRSEHIR',
            name: 'Kirsehir'
          }, {
            code: 'KOCAELI',
            name: 'Kocaeli'
          }, {
            code: 'KONYA',
            name: 'Konya'
          }, {
            code: 'KUTAHYA',
            name: 'Kutahya'
          }, {
            code: 'MALATYA',
            name: 'Malatya'
          }, {
            code: 'MANISA',
            name: 'Manisa'
          }, {
            code: 'MARDIN',
            name: 'Mardin'
          }, {
            code: 'MUGLA',
            name: 'Mugla'
          }, {
            code: 'MUS',
            name: 'Mus'
          }, {
            code: 'NEVSEHIR',
            name: 'Nevsehir'
          }, {
            code: 'NIGDE',
            name: 'Nigde'
          }, {
            code: 'ORDU',
            name: 'Ordu'
          }, {
            code: 'OSMANIYE',
            name: 'Osmaniye'
          }, {
            code: 'RIZE',
            name: 'Rize'
          }, {
            code: 'SAKARYA',
            name: 'Sakarya'
          }, {
            code: 'SAMSUN',
            name: 'Samsun'
          }, {
            code: 'SANLIURFA',
            name: 'Sanliurfa'
          }, {
            code: 'SIIRT',
            name: 'Siirt'
          }, {
            code: 'SINOP',
            name: 'Sinop'
          }, {
            code: 'SIRNAK',
            name: 'Sirnak'
          }, {
            code: 'SIVAS',
            name: 'Sivas'
          }, {
            code: 'TEKIRDAG',
            name: 'Tekirdag'
          }, {
            code: 'TOKAT',
            name: 'Tokat'
          }, {
            code: 'TRABZON',
            name: 'Trabzon'
          }, {
            code: 'TUNCELI',
            name: 'Tunceli'
          }, {
            code: 'USAK',
            name: 'Usak'
          }, {
            code: 'VAN',
            name: 'Van'
          }, {
            code: 'YALOVA',
            name: 'Yalova'
          }, {
            code: 'YOZGAT',
            name: 'Yozgat'
          }, {
            code: 'ZONGULDAK',
            name: 'Zonguldak'
          }];
        case 'TM':
          return [{
            code: 'AHAL WELAYATY',
            name: 'Ahal Welayaty'
          }, {
            code: 'BALKAN WELAYATY',
            name: 'Balkan Welayaty'
          }, {
            code: 'DASHHOWUZ WELAYATY',
            name: 'Dashhowuz Welayaty'
          }, {
            code: 'LEBAP WELAYATY',
            name: 'Lebap Welayaty'
          }, {
            code: 'MARY WELAYATY',
            name: 'Mary Welayaty'
          }];
        case 'TV':
          return [{
            code: 'TUVALU',
            name: 'Tuvalu'
          }];
        case 'UG':
          return [{
            code: 'ADJUMANI',
            name: 'Adjumani'
          }, {
            code: 'APAC',
            name: 'Apac'
          }, {
            code: 'ARUA',
            name: 'Arua'
          }, {
            code: 'BUGIRI',
            name: 'Bugiri'
          }, {
            code: 'BUNDIBUGYO',
            name: 'Bundibugyo'
          }, {
            code: 'BUSHENYI',
            name: 'Bushenyi'
          }, {
            code: 'BUSIA',
            name: 'Busia'
          }, {
            code: 'GULU',
            name: 'Gulu'
          }, {
            code: 'HOIMA',
            name: 'Hoima'
          }, {
            code: 'IGANGA',
            name: 'Iganga'
          }, {
            code: 'JINJA',
            name: 'Jinja'
          }, {
            code: 'KABALE',
            name: 'Kabale'
          }, {
            code: 'KABAROLE',
            name: 'Kabarole'
          }, {
            code: 'KALANGALA',
            name: 'Kalangala'
          }, {
            code: 'KAMPALA',
            name: 'Kampala'
          }, {
            code: 'KAMULI',
            name: 'Kamuli'
          }, {
            code: 'KAPCHORWA',
            name: 'Kapchorwa'
          }, {
            code: 'KASESE',
            name: 'Kasese'
          }, {
            code: 'KATAKWI',
            name: 'Katakwi'
          }, {
            code: 'KIBALE',
            name: 'Kibale'
          }, {
            code: 'KIBOGA',
            name: 'Kiboga'
          }, {
            code: 'KISORO',
            name: 'Kisoro'
          }, {
            code: 'KITGUM',
            name: 'Kitgum'
          }, {
            code: 'KOTIDO',
            name: 'Kotido'
          }, {
            code: 'KUMI',
            name: 'Kumi'
          }, {
            code: 'LIRA',
            name: 'Lira'
          }, {
            code: 'LUWERO',
            name: 'Luwero'
          }, {
            code: 'MASAKA',
            name: 'Masaka'
          }, {
            code: 'MASINDI',
            name: 'Masindi'
          }, {
            code: 'MBALE',
            name: 'Mbale'
          }, {
            code: 'MBARARA',
            name: 'Mbarara'
          }, {
            code: 'MOROTO',
            name: 'Moroto'
          }, {
            code: 'MOYO',
            name: 'Moyo'
          }, {
            code: 'MPIGI',
            name: 'Mpigi'
          }, {
            code: 'MUBENDE',
            name: 'Mubende'
          }, {
            code: 'MUKONO',
            name: 'Mukono'
          }, {
            code: 'NAKASONGOLA',
            name: 'Nakasongola'
          }, {
            code: 'NEBBI',
            name: 'Nebbi'
          }, {
            code: 'NTUNGAMO',
            name: 'Ntungamo'
          }, {
            code: 'PALLISA',
            name: 'Pallisa'
          }, {
            code: 'RAKAI',
            name: 'Rakai'
          }, {
            code: 'RUKUNGIRI',
            name: 'Rukungiri'
          }, {
            code: 'SEMBABULE',
            name: 'Sembabule'
          }, {
            code: 'SOROTI',
            name: 'Soroti'
          }, {
            code: 'TORORO',
            name: 'Tororo'
          }];
        case 'UA':
          return [{
            code: 'AVTONOMNA RESPUBLIKA KRYM (SIMFEROPOL)',
            name: 'Avtonomna Respublika Krym (Simferopol)'
          }, {
            code: 'CHERKASKA (CHERKASY)',
            name: 'Cherkaska (Cherkasy)'
          }, {
            code: 'CHERNIHIVSKA (CHERNIHIV)',
            name: 'Chernihivska (Chernihiv)'
          }, {
            code: 'CHERNIVETSKA (CHERNIVTSI)',
            name: 'Chernivetska (Chernivtsi)'
          }, {
            code: 'DNIPROPETROVSKA (DNIPROPETROVSK)',
            name: 'Dnipropetrovska (Dnipropetrovsk)'
          }, {
            code: 'DONETSKA (DONETSK)',
            name: 'Donetska (Donetsk)'
          }, {
            code: 'IVANO-FRANKIVSKA (IVANO-FRANKIVSK)',
            name: 'Ivano-Frankivska (Ivano-Frankivsk)'
          }, {
            code: 'KHARKIVSKA (KHARKIV)',
            name: 'Kharkivska (Kharkiv)'
          }, {
            code: 'KHERSONSKA (KHERSON)',
            name: 'Khersonska (Kherson)'
          }, {
            code: 'KHMELNYTSKA (KHMELNYTSKYY)',
            name: 'Khmelnytska (Khmelnytskyy)'
          }, {
            code: 'KIROVOHRADSKA (KIROVOHRAD)',
            name: 'Kirovohradska (Kirovohrad)'
          }, {
            code: 'KYYIV',
            name: 'Kyyiv'
          }, {
            code: 'KYYIVSKA (KIEV)',
            name: 'Kyyivska (Kiev)'
          }, {
            code: 'LVIVSKA (LVIV)',
            name: 'Lvivska (Lviv)'
          }, {
            code: 'LUHANSKA (LUHANSK)',
            name: 'Luhanska (Luhansk)'
          }, {
            code: 'MYKOLAYIVSKA (MYKOLAYIV)',
            name: 'Mykolayivska (Mykolayiv)'
          }, {
            code: 'ODESKA (ODESA)',
            name: 'Odeska (Odesa)'
          }, {
            code: 'POLTAVSKA (POLTAVA)',
            name: 'Poltavska (Poltava)'
          }, {
            code: 'RIVNENSKA (RIVNE)',
            name: 'Rivnenska (Rivne)'
          }, {
            code: 'SEVASTOPOL',
            name: 'Sevastopol'
          }, {
            code: 'SUMSKA (SUMY)',
            name: 'Sumska (Sumy)'
          }, {
            code: 'TERNOPILSKA (TERNOPIL)',
            name: 'Ternopilska (Ternopil)'
          }, {
            code: 'VINNYTSKA (VINNYTSYA)',
            name: 'Vinnytska (Vinnytsya)'
          }, {
            code: 'VOLYNSKA (LUTSK)',
            name: 'Volynska (Lutsk)'
          }, {
            code: 'ZAKARPATSKA (UZHHOROD)',
            name: 'Zakarpatska (Uzhhorod)'
          }, {
            code: 'ZAPORIZKA (ZAPORIZHZHYA)',
            name: 'Zaporizka (Zaporizhzhya)'
          }, {
            code: 'ZHYTOMYRSKA (ZHYTOMYR)',
            name: 'Zhytomyrska (Zhytomyr)'
          }];
        case 'AE':
          return [{
            code: 'AJMAN',
            name: 'Ajman'
          }, {
            code: 'ABU ZABY (ABU DHABI)',
            name: 'Abu Zaby (Abu Dhabi)'
          }, {
            code: 'AL FUJAYRAH',
            name: 'Al Fujayrah'
          }, {
            code: 'ASH SHARIQAH (SHARJAH)',
            name: 'Ash Shariqah (Sharjah)'
          }, {
            code: 'DUBAYY (DUBAI)',
            name: 'Dubayy (Dubai)'
          }, {
            code: 'RAS AL KHAYMAH',
            name: 'Ras al Khaymah'
          }, {
            code: 'UMM AL QAYWAYN',
            name: 'Umm al Qaywayn'
          }];
        case 'GB':
          return [{
            code: 'ABERDEENSHIRE',
            name: 'Aberdeenshire'
          }, {
            code: 'ANGLESEY',
            name: 'Anglesey'
          }, {
            code: 'ANGUS',
            name: 'Angus'
          }, {
            code: 'ANTRIM',
            name: 'Antrim'
          }, {
            code: 'ARGYLL AND BUTE',
            name: 'Argyll And Bute'
          }, {
            code: 'ARMAGH',
            name: 'Armagh'
          }, {
            code: 'BARKING AND DAGENHAM',
            name: 'Barking And Dagenham'
          }, {
            code: 'BARNET',
            name: 'Barnet'
          }, {
            code: 'BARNSLEY',
            name: 'Barnsley'
          }, {
            code: 'BATH AND NORTH EAST SOMERSET',
            name: 'Bath And North East Somerset'
          }, {
            code: 'BEDFORDSHIRE',
            name: 'Bedfordshire'
          }, {
            code: 'BEXLEY',
            name: 'Bexley'
          }, {
            code: 'BIRMINGHAM',
            name: 'Birmingham'
          }, {
            code: 'BLACKBURN WITH DARWEN',
            name: 'Blackburn With Darwen'
          }, {
            code: 'BLACKPOOL',
            name: 'Blackpool'
          }, {
            code: 'BOLTON',
            name: 'Bolton'
          }, {
            code: 'BOURNEMOUTH',
            name: 'Bournemouth'
          }, {
            code: 'BRACKNELL FOREST',
            name: 'Bracknell Forest'
          }, {
            code: 'BRADFORD',
            name: 'Bradford'
          }, {
            code: 'BRECKNOCKSHIRE',
            name: 'Brecknockshire'
          }, {
            code: 'BRENT',
            name: 'Brent'
          }, {
            code: 'BRIGHTON AND HOVE',
            name: 'Brighton And Hove'
          }, {
            code: 'BROMLEY',
            name: 'Bromley'
          }, {
            code: 'BUCKINGHAMSHIRE',
            name: 'Buckinghamshire'
          }, {
            code: 'BURY',
            name: 'Bury'
          }, {
            code: 'CAERNARFONSHIRE',
            name: 'Caernarfonshire'
          }, {
            code: 'CALDERDALE',
            name: 'Calderdale'
          }, {
            code: 'CAMBRIDGESHIRE',
            name: 'Cambridgeshire'
          }, {
            code: 'CAMDEN',
            name: 'Camden'
          }, {
            code: 'CARDIGANSHIRE',
            name: 'Cardiganshire'
          }, {
            code: 'CARMARTHENSHIRE',
            name: 'Carmarthenshire'
          }, {
            code: 'CHESHIRE',
            name: 'Cheshire'
          }, {
            code: 'CITY OF ABERDEEN',
            name: 'City Of Aberdeen'
          }, {
            code: 'CITY OF BRISTOL',
            name: 'City Of Bristol'
          }, {
            code: 'CITY OF DUNDEE',
            name: 'City Of Dundee'
          }, {
            code: 'CITY OF EDINBURGH',
            name: 'City Of Edinburgh'
          }, {
            code: 'CITY OF GLASGOW',
            name: 'City Of Glasgow'
          }, {
            code: 'CITY OF KINGSTON UPON HULL',
            name: 'City Of Kingston Upon Hull'
          }, {
            code: 'CITY OF LONDON',
            name: 'City Of London'
          }, {
            code: 'CLACKMANNANSHIRE',
            name: 'Clackmannanshire'
          }, {
            code: 'CORNWALL',
            name: 'Cornwall'
          }, {
            code: 'COVENTRY',
            name: 'Coventry'
          }, {
            code: 'CROYDON',
            name: 'Croydon'
          }, {
            code: 'CUMBRIA',
            name: 'Cumbria'
          }, {
            code: 'DARLINGTON',
            name: 'Darlington'
          }, {
            code: 'DENBIGHSHIRE',
            name: 'Denbighshire'
          }, {
            code: 'DERBY',
            name: 'Derby'
          }, {
            code: 'DERBYSHIRE',
            name: 'Derbyshire'
          }, {
            code: 'DEVON',
            name: 'Devon'
          }, {
            code: 'DONCASTER',
            name: 'Doncaster'
          }, {
            code: 'DORSET',
            name: 'Dorset'
          }, {
            code: 'DOWN',
            name: 'Down'
          }, {
            code: 'DUDLEY',
            name: 'Dudley'
          }, {
            code: 'DUMFRIES AND GALLOWAYH',
            name: 'Dumfries And Galloway'
          }, {
            code: 'DURHAM',
            name: 'Durham'
          }, {
            code: 'EALING',
            name: 'Ealing'
          }, {
            code: 'EAST AYRSHIRE',
            name: 'East Ayrshire'
          }, {
            code: 'EAST DUNBARTONSHIRE',
            name: 'East Dunbartonshire'
          }, {
            code: 'EAST LOTHIAN',
            name: 'East Lothian'
          }, {
            code: 'EAST RENFREWSHIRE',
            name: 'East Renfrewshire'
          }, {
            code: 'EAST RIDING OF YORKSHIRE',
            name: 'East Riding Of Yorkshire'
          }, {
            code: 'EAST SUSSEX',
            name: 'East Sussex'
          }, {
            code: 'ENFIELD',
            name: 'Enfield'
          }, {
            code: 'ESSEX',
            name: 'Essex'
          }, {
            code: 'FALKIRK',
            name: 'Falkirk'
          }, {
            code: 'FERMANAGH',
            name: 'Fermanagh'
          }, {
            code: 'FIFE',
            name: 'Fife'
          }, {
            code: 'FLINTSHIRE',
            name: 'Flintshire'
          }, {
            code: 'GATESHEAD',
            name: 'Gateshead'
          }, {
            code: 'GLAMORGANSHIRE',
            name: 'Glamorganshire'
          }, {
            code: 'GLOUCESTERSHIRE',
            name: 'Gloucestershire'
          }, {
            code: 'GREENWICH',
            name: 'Greenwich'
          }, {
            code: 'HACKNEY',
            name: 'Hackney'
          }, {
            code: 'HALTON',
            name: 'Halton'
          }, {
            code: 'HAMMERSMITH AND FULHAM',
            name: 'Hammersmith And Fulham'
          }, {
            code: 'HAMPSHIRE',
            name: 'Hampshire'
          }, {
            code: 'HARINGEY',
            name: 'Haringey'
          }, {
            code: 'HARROW',
            name: 'Harrow'
          }, {
            code: 'HARTLEPOOL',
            name: 'Hartlepool'
          }, {
            code: 'HAVERING',
            name: 'Havering'
          }, {
            code: 'HEREFORDSHIRE',
            name: 'Herefordshire'
          }, {
            code: 'HERTFORDSHIRE',
            name: 'Hertfordshire'
          }, {
            code: 'HIGHLAND',
            name: 'Highland'
          }, {
            code: 'HILLINGDON',
            name: 'Hillingdon'
          }, {
            code: 'HOUNSLOW',
            name: 'Hounslow'
          }, {
            code: 'INVERCLYDE',
            name: 'Inverclyde'
          }, {
            code: 'ISLE OF WIGHT',
            name: 'Isle Of Wight'
          }, {
            code: 'ISLINGTON',
            name: 'Islington'
          }, {
            code: 'KENSINGTON AND CHELSEA',
            name: 'Kensington And Chelsea'
          }, {
            code: 'KENT',
            name: 'Kent'
          }, {
            code: 'KINGSTON UPON THAMES',
            name: 'Kingston Upon Thames'
          }, {
            code: 'KIRKLEES',
            name: 'Kirklees'
          }, {
            code: 'KNOWSLEY',
            name: 'Knowsley'
          }, {
            code: 'LAMBETH',
            name: 'Lambeth'
          }, {
            code: 'LANCASHIRE',
            name: 'Lancashire'
          }, {
            code: 'LEEDS',
            name: 'Leeds'
          }, {
            code: 'LEICESTER',
            name: 'Leicester'
          }, {
            code: 'LEICESTERSHIRE',
            name: 'Leicestershire'
          }, {
            code: 'LEWISHAM',
            name: 'Lewisham'
          }, {
            code: 'LINCOLNSHIRE',
            name: 'Lincolnshire'
          }, {
            code: 'LIVERPOOL',
            name: 'Liverpool'
          }, {
            code: 'LONDONDERRY',
            name: 'Londonderry'
          }, {
            code: 'LUTON',
            name: 'Luton'
          }, {
            code: 'MANCHESTER',
            name: 'Manchester'
          }, {
            code: 'MEDWAY',
            name: 'Medway'
          }, {
            code: 'MERIONETHSHIRE',
            name: 'Merionethshire'
          }, {
            code: 'MERTON',
            name: 'Merton'
          }, {
            code: 'MIDDLESBROUGH',
            name: 'Middlesbrough'
          }, {
            code: 'MIDLOTHIAN',
            name: 'Midlothian'
          }, {
            code: 'MILTON KEYNES',
            name: 'Milton Keynes'
          }, {
            code: 'MONMOUTHSHIRE',
            name: 'Monmouthshire'
          }, {
            code: 'MONTGOMERYSHIRE',
            name: 'Montgomeryshire'
          }, {
            code: 'MORAY',
            name: 'Moray'
          }, {
            code: 'NA H-EILEANAN SIAR WESTERN ISLES',
            name: 'Na H Eileanan Siar Western Isles'
          }, {
            code: 'NEWCASTLE UPON TYNE',
            name: 'Newcastle Upon Tyne'
          }, {
            code: 'NEWHAM',
            name: 'Newham'
          }, {
            code: 'NORFOLK',
            name: 'Norfolk'
          }, {
            code: 'NORTH AYRSHIRE',
            name: 'North Ayrshire'
          }, {
            code: 'NORTH EAST LINCOLNSHIRE',
            name: 'North East Lincolnshire'
          }, {
            code: 'NORTH LANARKSHIRE',
            name: 'North Lanarkshire'
          }, {
            code: 'NORTH LINCOLNSHIRE',
            name: 'North Lincolnshire'
          }, {
            code: 'NORTH SOMERSET',
            name: 'North Somerset'
          }, {
            code: 'NORTH TYNESIDE',
            name: 'North Tyneside'
          }, {
            code: 'NORTH YORKSHIRE',
            name: 'North Yorkshire'
          }, {
            code: 'NORTHAMPTONSHIRE',
            name: 'Northamptonshire'
          }, {
            code: 'NORTHUMBERLAND',
            name: 'Northumberland'
          }, {
            code: 'NOTTINGHAM',
            name: 'Nottingham'
          }, {
            code: 'NOTTINGHAMSHIRE',
            name: 'Nottinghamshire'
          }, {
            code: 'OLDHAM',
            name: 'Oldham'
          }, {
            code: 'ORKNEY ISLANDS',
            name: 'Orkney Islands'
          }, {
            code: 'OXFORDSHIRE',
            name: 'Oxfordshire'
          }, {
            code: 'PEMBROKESHIRE',
            name: 'Pembrokeshire'
          }, {
            code: 'PERTH AND KINROSS',
            name: 'Perth And Kinross'
          }, {
            code: 'PETERBOROUGH',
            name: 'Peterborough'
          }, {
            code: 'PLYMOUTH',
            name: 'Plymouth'
          }, {
            code: 'POOLE',
            name: 'Poole'
          }, {
            code: 'PORTSMOUTH',
            name: 'Portsmouth'
          }, {
            code: 'RADNORSHIRE',
            name: 'Radnorshire'
          }, {
            code: 'READING',
            name: 'Reading'
          }, {
            code: 'REDBRIDGE',
            name: 'Redbridge'
          }, {
            code: 'REDCAR AND CLEVELAND',
            name: 'Redcar And Cleveland'
          }, {
            code: 'RENFREWSHIRE',
            name: 'Renfrewshire'
          }, {
            code: 'RICHMOND UPON THAMES',
            name: 'Richmond Upon Thames'
          }, {
            code: 'ROCHDALE',
            name: 'Rochdale'
          }, {
            code: 'ROTHERHAM',
            name: 'Rotherham'
          }, {
            code: 'RUTLAND',
            name: 'Rutland'
          }, {
            code: 'SALFORD',
            name: 'Salford'
          }, {
            code: 'SANDWELL',
            name: 'Sandwell'
          }, {
            code: 'SCOTTISH BORDERS',
            name: 'Scottish Borders'
          }, {
            code: 'SEFTON',
            name: 'Sefton'
          }, {
            code: 'SHEFFIELD',
            name: 'Sheffield'
          }, {
            code: 'SHETLAND ISLANDS',
            name: 'Shetland Islands'
          }, {
            code: 'SHROPSHIRE',
            name: 'Shropshire'
          }, {
            code: 'SLOUGH',
            name: 'Slough'
          }, {
            code: 'SOLIHULL',
            name: 'Solihull'
          }, {
            code: 'SOMERSET',
            name: 'Somerset'
          }, {
            code: 'SOUTH AYRSHIRE',
            name: 'South Ayrshire'
          }, {
            code: 'SOUTH GLOUCESTERSHIRE',
            name: 'South Gloucestershire'
          }, {
            code: 'SOUTH LANARKSHIRE',
            name: 'South Lanarkshire'
          }, {
            code: 'SOUTH TYNESIDE',
            name: 'South Tyneside'
          }, {
            code: 'SOUTHAMPTON',
            name: 'Southampton'
          }, {
            code: 'SOUTHEND-ON-SEA',
            name: 'Southend On Sea'
          }, {
            code: 'SOUTHWARK',
            name: 'Southwark'
          }, {
            code: 'ST. HELENS',
            name: 'St Helens'
          }, {
            code: 'STAFFORDSHIRE',
            name: 'Staffordshire'
          }, {
            code: 'STIRLING',
            name: 'Stirling'
          }, {
            code: 'STOCKPORT',
            name: 'Stockport'
          }, {
            code: 'STOCKTON-ON-TEES',
            name: 'Stockton On Tees'
          }, {
            code: 'STOKE-ON-TRENT',
            name: 'Stoke On Trent'
          }, {
            code: 'SUFFOLK',
            name: 'Suffolk'
          }, {
            code: 'SUNDERLAND',
            name: 'Sunderland'
          }, {
            code: 'SURREY',
            name: 'Surrey'
          }, {
            code: 'SUTTON',
            name: 'Sutton'
          }, {
            code: 'SWINDON',
            name: 'Swindon'
          }, {
            code: 'TAMESIDE',
            name: 'Tameside'
          }, {
            code: 'TELFORD AND WREKIN',
            name: 'Telford And Wrekin'
          }, {
            code: 'THURROCK',
            name: 'Thurrock'
          }, {
            code: 'TORBAY',
            name: 'Torbay'
          }, {
            code: 'TOWER HAMLETS',
            name: 'Tower Hamlets'
          }, {
            code: 'TRAFFORD',
            name: 'Trafford'
          }, {
            code: 'TYRONE',
            name: 'Tyrone'
          }, {
            code: 'WAKEFIELD',
            name: 'Wakefield'
          }, {
            code: 'WALSALL',
            name: 'Walsall'
          }, {
            code: 'WALTHAM FOREST',
            name: 'Waltham Forest'
          }, {
            code: 'WANDSWORTH',
            name: 'Wandsworth'
          }, {
            code: 'WARRINGTON',
            name: 'Warrington'
          }, {
            code: 'WARWICKSHIRE',
            name: 'Warwickshire'
          }, {
            code: 'WEST BERKSHIRE',
            name: 'West Berkshire'
          }, {
            code: 'WEST DUNBARTONSHIRE',
            name: 'West Dunbartonshire'
          }, {
            code: 'WEST LOTHIAN',
            name: 'West Lothian'
          }, {
            code: 'WEST SUSSEX',
            name: 'West Sussex'
          }, {
            code: 'WESTMINSTER',
            name: 'Westminster'
          }, {
            code: 'WIGAN',
            name: 'Wigan'
          }, {
            code: 'WILTSHIRE',
            name: 'Wiltshire'
          }, {
            code: 'WINDSOR AND MAIDENHEAD',
            name: 'Windsor And Maidenhead'
          }, {
            code: 'WIRRAL',
            name: 'Wirral'
          }, {
            code: 'WOKINGHAM',
            name: 'Wokingham'
          }, {
            code: 'WOLVERHAMPTON',
            name: 'Wolverhampton'
          }, {
            code: 'WORCESTERSHIRE',
            name: 'Worcestershire'
          }, {
            code: 'YORK',
            name: 'York'
          }];
        case 'UY':
          return [{
            code: 'ARTIGAS',
            name: 'Artigas'
          }, {
            code: 'CANELONES',
            name: 'Canelones'
          }, {
            code: 'CERRO LARGO',
            name: 'Cerro Largo'
          }, {
            code: 'COLONIA',
            name: 'Colonia'
          }, {
            code: 'DURAZNO',
            name: 'Durazno'
          }, {
            code: 'FLORES',
            name: 'Flores'
          }, {
            code: 'FLORIDA',
            name: 'Florida'
          }, {
            code: 'LAVALLEJA',
            name: 'Lavalleja'
          }, {
            code: 'MALDONADO',
            name: 'Maldonado'
          }, {
            code: 'MONTEVIDEO',
            name: 'Montevideo'
          }, {
            code: 'PAYSANDU',
            name: 'Paysandu'
          }, {
            code: 'RIO NEGRO',
            name: 'Rio Negro'
          }, {
            code: 'RIVERA',
            name: 'Rivera'
          }, {
            code: 'ROCHA',
            name: 'Rocha'
          }, {
            code: 'SALTO',
            name: 'Salto'
          }, {
            code: 'SAN JOSE',
            name: 'San Jose'
          }, {
            code: 'SORIANO',
            name: 'Soriano'
          }, {
            code: 'TACUAREMBO',
            name: 'Tacuarembo'
          }, {
            code: 'TREINTA Y TRES',
            name: 'Treinta y Tres'
          }];
        case 'UZ':
          return [{
            code: 'ANDIJON WILOYATI',
            name: 'Andijon Wiloyati'
          }, {
            code: 'BUKHORO WILOYATI',
            name: 'Bukhoro Wiloyati'
          }, {
            code: 'FARGHONA WILOYATI',
            name: 'Farghona Wiloyati'
          }, {
            code: 'JIZZAKH WILOYATI',
            name: 'Jizzakh Wiloyati'
          }, {
            code: 'KHORAZM WILOYATI (URGANCH)',
            name: 'Khorazm Wiloyati (Urganch)'
          }, {
            code: 'NAMANGAN WILOYATI',
            name: 'Namangan Wiloyati'
          }, {
            code: 'NAWOIY WILOYATI',
            name: 'Nawoiy Wiloyati'
          }, {
            code: 'QASHQADARYO WILOYATI (QARSHI)',
            name: 'Qashqadaryo Wiloyati (Qarshi)'
          }, {
            code: 'QORAQALPOGHISTON (NUKUS)',
            name: 'Qoraqalpoghiston (Nukus)'
          }, {
            code: 'SAMARQAND WILOYATI',
            name: 'Samarqand Wiloyati'
          }, {
            code: 'SIRDARYO WILOYATI (GULISTON)',
            name: 'Sirdaryo Wiloyati (Guliston)'
          }, {
            code: 'SURKHONDARYO WILOYATI (TERMIZ)',
            name: 'Surkhondaryo Wiloyati (Termiz)'
          }, {
            code: 'TOSHKENT SHAHRI',
            name: 'Toshkent Shahri'
          }, {
            code: 'TOSHKENT WILOYATI',
            name: 'Toshkent Wiloyati'
          }];
        case 'VU':
          return [{
            code: 'MALAMPA',
            name: 'Malampa'
          }, {
            code: 'PENAMA',
            name: 'Penama'
          }, {
            code: 'SANMA',
            name: 'Sanma'
          }, {
            code: 'SHEFA',
            name: 'Shefa'
          }, {
            code: 'TAFEA',
            name: 'Tafea'
          }, {
            code: 'TORBA',
            name: 'Torba'
          }];
        case 'VE':
          return [{
            code: 'AMAZONAS',
            name: 'Amazonas'
          }, {
            code: 'ANZOATEGUI',
            name: 'Anzoategui'
          }, {
            code: 'APURE',
            name: 'Apure'
          }, {
            code: 'ARAGUA',
            name: 'Aragua'
          }, {
            code: 'BARINAS',
            name: 'Barinas'
          }, {
            code: 'BOLIVAR',
            name: 'Bolivar'
          }, {
            code: 'CARABOBO',
            name: 'Carabobo'
          }, {
            code: 'COJEDES',
            name: 'Cojedes'
          }, {
            code: 'DELTA AMACURO',
            name: 'Delta Amacuro'
          }, {
            code: 'DEPENDENCIAS FEDERALES',
            name: 'Dependencias Federales'
          }, {
            code: 'DISTRITO FEDERAL',
            name: 'Distrito Federal'
          }, {
            code: 'FALCON',
            name: 'Falcon'
          }, {
            code: 'GUARICO',
            name: 'Guarico'
          }, {
            code: 'LARA',
            name: 'Lara'
          }, {
            code: 'MERIDA',
            name: 'Merida'
          }, {
            code: 'MIRANDA',
            name: 'Miranda'
          }, {
            code: 'MONAGAS',
            name: 'Monagas'
          }, {
            code: 'NUEVA ESPARTA',
            name: 'Nueva Esparta'
          }, {
            code: 'PORTUGUESA',
            name: 'Portuguesa'
          }, {
            code: 'SUCRE',
            name: 'Sucre'
          }, {
            code: 'TACHIRA',
            name: 'Tachira'
          }, {
            code: 'TRUJILLO',
            name: 'Trujillo'
          }, {
            code: 'VARGAS',
            name: 'Vargas'
          }, {
            code: 'YARACUY',
            name: 'Yaracuy'
          }, {
            code: 'ZULIA',
            name: 'Zulia'
          }];
        case 'VN':
          return [{
            code: 'AN GIANG',
            name: 'An Giang'
          }, {
            code: 'BA RIA-VUNG TAU',
            name: 'Ba Ria-Vung Tau'
          }, {
            code: 'BAC GIANG',
            name: 'Bac Giang'
          }, {
            code: 'BAC KAN',
            name: 'Bac Kan'
          }, {
            code: 'BAC LIEU',
            name: 'Bac Lieu'
          }, {
            code: 'BAC NINH',
            name: 'Bac Ninh'
          }, {
            code: 'BEN TRE',
            name: 'Ben Tre'
          }, {
            code: 'BINH DINH',
            name: 'Binh Dinh'
          }, {
            code: 'BINH DUONG',
            name: 'Binh Duong'
          }, {
            code: 'BINH PHUOC',
            name: 'Binh Phuoc'
          }, {
            code: 'BINH THUAN',
            name: 'Binh Thuan'
          }, {
            code: 'CA MAU',
            name: 'Ca Mau'
          }, {
            code: 'CAN THO',
            name: 'Can Tho'
          }, {
            code: 'CAO BANG',
            name: 'Cao Bang'
          }, {
            code: 'DA NANG',
            name: 'Da Nang'
          }, {
            code: 'DAC LAK',
            name: 'Dac Lak'
          }, {
            code: 'DONG NAI',
            name: 'Dong Nai'
          }, {
            code: 'DONG THAP',
            name: 'Dong Thap'
          }, {
            code: 'GIA LAI',
            name: 'Gia Lai'
          }, {
            code: 'HA GIANG',
            name: 'Ha Giang'
          }, {
            code: 'HA NAM',
            name: 'Ha Nam'
          }, {
            code: 'HA NOI',
            name: 'Ha Noi'
          }, {
            code: 'HA TAY',
            name: 'Ha Tay'
          }, {
            code: 'HA TINH',
            name: 'Ha Tinh'
          }, {
            code: 'HAI DUONG',
            name: 'Hai Duong'
          }, {
            code: 'HAI PHONG',
            name: 'Hai Phong'
          }, {
            code: 'HO CHI MINH',
            name: 'Ho Chi Minh'
          }, {
            code: 'HOA BINH',
            name: 'Hoa Binh'
          }, {
            code: 'HUNG YEN',
            name: 'Hung Yen'
          }, {
            code: 'KHANH HOA',
            name: 'Khanh Hoa'
          }, {
            code: 'KIEN GIANG',
            name: 'Kien Giang'
          }, {
            code: 'KON TUM',
            name: 'Kon Tum'
          }, {
            code: 'LAI CHAU',
            name: 'Lai Chau'
          }, {
            code: 'LAM DONG',
            name: 'Lam Dong'
          }, {
            code: 'LANG SON',
            name: 'Lang Son'
          }, {
            code: 'LAO CAI',
            name: 'Lao Cai'
          }, {
            code: 'LONG AN',
            name: 'Long An'
          }, {
            code: 'NAM DINH',
            name: 'Nam Dinh'
          }, {
            code: 'NGHE AN',
            name: 'Nghe An'
          }, {
            code: 'NINH BINH',
            name: 'Ninh Binh'
          }, {
            code: 'NINH THUAN',
            name: 'Ninh Thuan'
          }, {
            code: 'PHU THO',
            name: 'Phu Tho'
          }, {
            code: 'PHU YEN',
            name: 'Phu Yen'
          }, {
            code: 'QUANG BINH',
            name: 'Quang Binh'
          }, {
            code: 'QUANG NAM',
            name: 'Quang Nam'
          }, {
            code: 'QUANG NGAI',
            name: 'Quang Ngai'
          }, {
            code: 'QUANG NINH',
            name: 'Quang Ninh'
          }, {
            code: 'QUANG TRI',
            name: 'Quang Tri'
          }, {
            code: 'SOC TRANG',
            name: 'Soc Trang'
          }, {
            code: 'SON LA',
            name: 'Son La'
          }, {
            code: 'TAY NINH',
            name: 'Tay Ninh'
          }, {
            code: 'THAI BINH',
            name: 'Thai Binh'
          }, {
            code: 'THAI NGUYEN',
            name: 'Thai Nguyen'
          }, {
            code: 'THANH HOA',
            name: 'Thanh Hoa'
          }, {
            code: 'THUA THIEN-HUE',
            name: 'Thua Thien-Hue'
          }, {
            code: 'TIEN GIANG',
            name: 'Tien Giang'
          }, {
            code: 'TRA VINH',
            name: 'Tra Vinh'
          }, {
            code: 'TUYEN QUANG',
            name: 'Tuyen Quang'
          }, {
            code: 'VINH LONG',
            name: 'Vinh Long'
          }, {
            code: 'VINH PHUC',
            name: 'Vinh Phuc'
          }, {
            code: 'YEN BAI',
            name: 'Yen Bai'
          }];
        case 'YE':
          return [{
            code: 'ADAN',
            name: 'Adan'
          }, {
            code: 'ATAQ',
            name: 'Ataq'
          }, {
            code: 'ABYAN',
            name: 'Abyan'
          }, {
            code: 'AL BAYDA',
            name: 'Al Bayda'
          }, {
            code: 'AL HUDAYDAH',
            name: 'Al Hudaydah'
          }, {
            code: 'AL JAWF',
            name: 'Al Jawf'
          }, {
            code: 'AL MAHRAH',
            name: 'Al Mahrah'
          }, {
            code: 'AL MAHWIT',
            name: 'Al Mahwit'
          }, {
            code: 'DHAMAR',
            name: 'Dhamar'
          }, {
            code: 'HADHRAMAWT',
            name: 'Hadhramawt'
          }, {
            code: 'HAJJAH',
            name: 'Hajjah'
          }, {
            code: 'IBB',
            name: 'Ibb'
          }, {
            code: 'LAHIJ',
            name: 'Lahij'
          }, {
            code: 'MARIB',
            name: 'Marib'
          }, {
            code: 'SADAH',
            name: 'Sadah'
          }, {
            code: 'SANA',
            name: 'Sana'
          }, {
            code: 'TAIZZ',
            name: 'Taizz'
          }];
        case 'ZM':
          return [{
            code: 'CENTRAL',
            name: 'Central'
          }, {
            code: 'COPPERBELT',
            name: 'Copperbelt'
          }, {
            code: 'EASTERN',
            name: 'Eastern'
          }, {
            code: 'LUAPULA',
            name: 'Luapula'
          }, {
            code: 'LUSAKA',
            name: 'Lusaka'
          }, {
            code: 'NORTH-WESTERN',
            name: 'North-Western'
          }, {
            code: 'NORTHERN',
            name: 'Northern'
          }, {
            code: 'SOUTHERN',
            name: 'Southern'
          }, {
            code: 'WESTERN',
            name: 'Western'
          }];
        case 'ZW':
          return [{
            code: 'BULAWAYO',
            name: 'Bulawayo'
          }, {
            code: 'HARARE',
            name: 'Harare'
          }, {
            code: 'MASHONALAND CENTRAL',
            name: 'Mashonaland Central'
          }, {
            code: 'MASHONALAND EAST',
            name: 'Mashonaland East'
          }, {
            code: 'MASHONALAND WEST',
            name: 'Mashonaland West'
          }, {
            code: 'MASVINGO',
            name: 'Masvingo'
          }, {
            code: 'MATABELELAND NORTH',
            name: 'Matabeleland North'
          }, {
            code: 'MATABELELAND SOUTH',
            name: 'Matabeleland South'
          }, {
            code: 'MIDLANDS',
            name: 'Midlands'
          }];
        case 'AD':
          return [{
            code: 'ANDORRA',
            name: 'ANDORRA'
          }];
        case 'AI':
          return [{
            code: 'ANGUILLA',
            name: 'ANGUILLA'
          }];
        case 'AG':
          return [{
            code: 'ANTIGUA',
            name: 'ANTIGUA'
          }];
        case 'BQ':
          return [{
            code: 'BONAIRE, SINT EUSTATIUS AND SABA',
            name: 'BONAIRE, SINT EUSTATIUS AND SABA'
          }];
        case 'IO':
          return [{
            code: 'BRITISH INDIAN OCEAN TERRITORY',
            name: 'BRITISH INDIAN OCEAN TERRITORY'
          }];
        case 'KY':
          return [{
            code: 'CAYMAN ISLANDS',
            name: 'CAYMAN ISLANDS'
          }];
        case 'CW':
          return [{
            code: 'CURAÇAO',
            name: 'CURAÇAO'
          }];
        case 'FK':
          return [{
            code: 'FALKLAND ISLANDS',
            name: 'FALKLAND ISLANDS'
          }];
        case 'FM':
          return [{
            code: 'FEDERATED STATES OF MICRONESIA',
            name: 'FEDERATED STATES OF MICRONESIA'
          }];
        case 'GA':
          return [{
            code: 'GABON',
            name: 'GABON'
          }];
        case 'XK':
          return [{
            code: 'KOSOVO',
            name: 'KOSOVO'
          }];
        case 'ME':
          return [{
            code: 'MONTENEGRO',
            name: 'MONTENEGRO'
          }];
        case 'PS':
          return [{
            code: 'PALESTINE',
            name: 'PALESTINE'
          }];
        case 'BL':
          return [{
            code: 'SAINT BARTHÉLEMY',
            name: 'SAINT BARTHÉLEMY'
          }];
        case 'MF':
          return [{
            code: 'SAINT MARTIN',
            name: 'SAINT MARTIN'
          }];
        case 'RS':
          return [{
            code: 'SERBIA',
            name: 'SERBIA'
          }];
        case 'SS':
          return [{
            code: 'SOUTH SUDAN',
            name: 'SOUTH SUDAN'
          }];
        case 'LC':
          return [{
            code: 'ST. LUCIA',
            name: 'ST. LUCIA'
          }];
        case 'SX':
          return [{
            code: 'SINT MAARTEN (DUTCH PART)',
            name: 'SINT MAARTEN (DUTCH PART)'
          }];
        case 'GM':
          return [{
            code: 'THE GAMBIA',
            name: 'THE GAMBIA'
          }];
        case 'TL':
          return [{
            code: 'TIMOR-LESTE',
            name: 'TIMOR-LESTE'
          }];
        case 'TC':
          return [{
            code: 'TURKS AND CAICOS ISLANDS',
            name: 'TURKS AND CAICOS ISLANDS'
          }];
        case 'VI':
          return [{
            code: 'US VIRGIN ISLANDS',
            name: 'US VIRGIN ISLANDS'
          }];
        case 'VA':
          return [{
            code: 'VATICAN CITY',
            name: 'VATICAN CITY'
          }];
        case 'WF':
          return [{
            code: 'WALLIS AND FUTUNA',
            name: 'WALLIS AND FUTUNA'
          }];
        default:
          return [];
      }
    }
  }]);
  return Options;
}();
// EXTERNAL MODULE: ./node_modules/loglevel/lib/loglevel.js
var loglevel = __webpack_require__(43);
var loglevel_default = /*#__PURE__*/__webpack_require__.n(loglevel);
;// CONCATENATED MODULE: ./src/lib/util.js
function util_typeof(obj) { "@babel/helpers - typeof"; return util_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, util_typeof(obj); }
function util_defineProperty(obj, key, value) { key = util_toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function util_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function util_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, util_toPropertyKey(descriptor.key), descriptor); } }
function util_createClass(Constructor, protoProps, staticProps) { if (protoProps) util_defineProperties(Constructor.prototype, protoProps); if (staticProps) util_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function util_toPropertyKey(arg) { var key = util_toPrimitive(arg, "string"); return util_typeof(key) === "symbol" ? key : String(key); }
function util_toPrimitive(input, hint) { if (util_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (util_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable no-undef */






var Util = /*#__PURE__*/function () {
  function Util() {
    util_classCallCheck(this, Util);
  }
  util_createClass(Util, null, [{
    key: "log2le",
    value:
    /**
     * Helper method to send data to LogEntries
     * @param level The LogEntries log level (log/info/warn/error)
     * @param msg The message we send to LogEntries
     * @param data Arbitrary data object to send with the log entry
     */
    function log2le(level, msg, data) {
      if (typeof window.LE === 'undefined') {
        return;
      }
      if (typeof data === 'undefined') {
        data = {};
      }
      LE[level]({
        msg: msg,
        data: data
      });
    }
  }, {
    key: "logDebug",
    value: function logDebug(msg, obj) {
      Util.log2le('log', msg, obj);
      loglevel_default().debug('logDebug:', msg, obj);
    }
  }, {
    key: "logError",
    value: function logError(msg, obj) {
      Util.log2le('error', msg, obj);
      loglevel_default().error('logError:', msg, obj);
    }
  }, {
    key: "logInfo",
    value: function logInfo(msg, obj) {
      Util.log2le('info', msg, obj);
      loglevel_default().info('logInfo:', msg, obj);
    }

    /**
     * Create and handle loading overlay
     */
  }, {
    key: "createLoadingOverlay",
    value: function createLoadingOverlay() {
      if ($('#fcLoadingOverlay').length) {
        Util.logDebug('CampaignJS.createErrorOverlay already exists');
        return true;
      }
      Util.logDebug('CampaignJS.createLoadingOverlay');
      var overlay = $('<div>', {
        id: 'fcLoadingOverlay',
        "class": 'fc-loading-overlay fc-overlay'
      });
      var indicator = $('<div>', {
        "class": 'fc-loading-indicator'
      });
      var msg = $('<h3>', {
        "class": 'fc-loading-indicator-msg'
      });
      msg.text('Loading...');
      overlay.append(indicator);
      overlay.append(msg);
      $('body').prepend(overlay);
      return null;
    }
  }, {
    key: "startLoading",
    value: function startLoading() {
      Util.disableInputs();
      Util.logDebug('CampaignJS.startLoading');
      $('.fc-loading-overlay').fadeIn(250);
    }
  }, {
    key: "stopLoading",
    value: function stopLoading() {
      Util.enableInputs();
      Util.logDebug('CampaignJS.stopLoading');
      $('.fc-loading-overlay').fadeOut(500);
    }

    /**
     * Create and handle error overlay
     */
  }, {
    key: "createErrorOverlay",
    value: function createErrorOverlay() {
      if ($('#fcErrorOverlay').length) {
        Util.logDebug('CampaignJS.createErrorOverlay already exists');
        return true;
      }
      Util.logDebug('CampaignJS.createErrorOverlay');
      var overlay = $('<div>', {
        id: 'fcErrorOverlay',
        "class": 'fc-error-overlay fc-overlay'
      });
      var message = $('<div>', {
        "class": 'fc-error-message'
      });
      overlay.append(message);
      overlay.on('click', function () {
        return Util.hideError();
      });
      $('body').prepend(overlay);
      return null;
    }
  }, {
    key: "showError",
    value: function showError(msg) {
      Util.logDebug('CampaignJS.showError');
      $('.fc-loading-overlay').hide();
      $('.fc-error-overlay').fadeIn(250);
      $('.fc-error-overlay .fc-error-message').html(msg);
    }
  }, {
    key: "hideError",
    value: function hideError() {
      Util.enableInputs();
      Util.logDebug('CampaignJS.hideError');
      $('.fc-error-overlay').fadeOut(500);
      $(cjs.config.submitButton).removeClass('disabled');
      if (cjs.config.paypalSubmitButton) {
        $(cjs.config.paypalSubmitButton).removeClass('disabled');
      }
    }

    /**
     * Enable and disable all inputs
     */
  }, {
    key: "disableInputs",
    value: function disableInputs() {
      Util.logDebug('CampaignJS.disableInputs');
      $('[id^=fc-]').attr('disabled', true);
    }
  }, {
    key: "enableInputs",
    value: function enableInputs() {
      Util.logDebug('CampaignJS.enableInputs');
      $('[id^=fc-]').attr('disabled', false);

      // Disable the email field if it is being inferred from the url.
      if (Dom.getUrlParam('checksum') || Dom.getUrlParam('email')) {
        $('#fc-emailVerify').val($('#fc-email').val());
        $('[id^=fc-email]').attr('disabled', true);
      }
    }

    /**
     * Return the context object that gets sent to the API
     */
  }, {
    key: "getContext",
    value: function getContext() {
      return {
        app: Bootstrap.version(),
        campaign: Dom.getUtmParams()
      };
    }

    /**
     * Return formatted person info
     */
  }, {
    key: "formatPersonAddress",
    value: function formatPersonAddress(personInfo) {
      if (personInfo.state) {
        personInfo.addressInfo = [{
          addressType: 'billing',
          street: _.get(personInfo, 'street', null),
          city: _.get(personInfo, 'city', null),
          state: _.get(personInfo, 'state', null),
          zip: _.get(personInfo, 'zip', null),
          country: _.get(personInfo, 'country', null),
          isPrimary: true
        }];
      }
      if (personInfo.stateBilling && personInfo.stateShipping) {
        personInfo.addressInfo = [{
          addressType: 'billing',
          street: _.get(personInfo, 'streetBilling', null),
          city: _.get(personInfo, 'cityBilling', null),
          state: _.get(personInfo, 'stateBilling', null),
          zip: _.get(personInfo, 'zipBilling', null),
          country: _.get(personInfo, 'countryBilling', null),
          isPrimary: true
        }, {
          addressType: 'shipping',
          street: _.get(personInfo, 'streetShipping', null),
          city: _.get(personInfo, 'cityShipping', null),
          state: _.get(personInfo, 'stateShipping', null),
          zip: _.get(personInfo, 'zipShipping', null),
          country: _.get(personInfo, 'countryShipping', null)
        }];
      }
      return personInfo;
    }

    /**
     * Parse the errors returned from the validator and format them
     * @param errors
     * @returns {string}
     */
  }, {
    key: "parseValidationErrors",
    value: function parseValidationErrors(errors) {
      var msg = '<p class="fc-validation-errors"><ul>';
      Object.keys(errors).forEach(function (key) {
        msg += "<li>".concat(errors[key], "</li>");
      });
      msg += '</ul></p>';
      return msg;
    }

    /**
     * Parse the errors returned from the validator and format them
     * @returns {string}
     */
  }, {
    key: "prepareSupportMessage",
    value: function prepareSupportMessage() {
      var programSettings = cjs.landingPage.program.settings;
      var contactSupportMessage = '<p>If you have any questions or concerns, feel free to contact us using the contact information on this page.</p>';
      if (programSettings.campaignJs && programSettings.campaignJs.extendedError) {
        var contactDetails = cjs.landingPage.program.contactDetails;
        contactSupportMessage = '<p>If you have any questions or concerns, feel free to contact us ';
        if (contactDetails[0].phone.length && contactDetails[0].email.length) {
          contactSupportMessage += "at ".concat(contactDetails[0].phone, " or email us at ").concat(contactDetails[0].email);
        } else if (contactDetails[0].phone.length && !contactDetails[0].email.length) {
          contactSupportMessage += "at ".concat(contactDetails[0].phone);
        } else if (!contactDetails[0].phone.length && contactDetails[0].email.length) {
          contactSupportMessage += "by email at ".concat(contactDetails[0].email);
        }
        contactSupportMessage += '.</p>';
      }
      return contactSupportMessage;
    }

    /**
     * Swtich laningpage info
     */
  }, {
    key: "switchLandingPage",
    value: function switchLandingPage(landingPageId) {
      // Update the cjs config and landingPage info
      var landingPageInfo = cjs._pageConfigs[landingPageId];

      // Show an error when the page config is not found
      if (!landingPageInfo) {
        Util.logError('CampaignJS.switchLandingPage : Error switching to landingPageId:', landingPageId);
      }
      cjs.config.landingPageId = landingPageInfo.landingPageId;
      cjs.config.nextPage = landingPageInfo.nextPage;
      cjs.landingPage = landingPageInfo;

      // Reset the products data
      if (typeof cjs.fields.productSKU !== 'undefined') {
        Dom.addOptionsToSelect(cjs.landingPage.products, $(cjs.fields.productSKU));
      }
      Util.logDebug('CampaignJS.switchLandingPage : Switched to landingPageId:', landingPageInfo.landingPageId);

      // Setup tax info and listeners
      Dom.setTaxInfoAndAddressListener();
    }

    /**
     * List of supported countries
     */
  }, {
    key: "getCountries",
    value: function getCountries() {
      // Only allow the countries configured in program settings
      var programCountriesEnabled = _.get(cjs, 'landingPage.program.settings.campaignJs.enabledCountries', ['US', 'CA', 'AU']);
      if (programCountriesEnabled == null || programCountriesEnabled.length == 0) {
        programCountriesEnabled = ['US', 'CA', 'AU'];
      }
      return _.filter(Options.getCountriesOptions(), function (country) {
        return _.includes(programCountriesEnabled, country.code);
      });
    }

    /**
     * List of supported currencies
     */
  }, {
    key: "getCurrencies",
    value: function getCurrencies() {
      // Only allow the currencies configured in program settings
      var programCurrenciesEnabled = _.get(cjs, 'landingPage.program.settings.billing.enabledCurrencies', ['USD']);
      if (programCurrenciesEnabled == null || programCurrenciesEnabled.length == 0) {
        programCurrenciesEnabled = ['USD'];
      }
      return _.filter(Options.getCurrenciesOptions(), function (currency) {
        return _.includes(programCurrenciesEnabled, currency.code);
      });
    }

    /**
     * Define Custom validators
     */
  }, {
    key: "customValidators",
    value: function customValidators(window) {
      if (window.validate) {
        window.validate.validators.validateZip = function validateZip(value, options, key, attributes) {
          if (!value) {
            return 'Postal / zip code is required';
          }
          var country = attributes.person.country;
          if (key == 'person.zipBilling') {
            country = attributes.person.countryBilling;
          } else if (key == 'person.zipShipping') {
            country = attributes.person.countryShipping;
          }
          var postalCode = value.toString().replace(/ /g, '').trim();
          var format = null;
          switch (country) {
            case 'US':
              format = new RegExp(/(^\d{5}$)|(^\d{5}-\d{4}$)/);
              break;
            case 'CA':
              format = new RegExp(/^[ABCEGHJKLMNPRSTVXYabceghjklmnprstvxy]{1}\d{1}[A-Za-z]{1} *\d{1}[A-Za-z]{1}\d{1}$/);
              break;
            case 'AU':
              format = new RegExp(/^\d{4}$/); // Australian postal codes are 4 digits
              break;
            default:
              return null;
          }
          if (!format.test(postalCode.toString())) {
            return 'Postal / zip code appears to be incorrectly formatted';
          }
          return null;
        };
      }
    }

    /**
     * Expected states by country
     * @returns {Object}
     */
  }, {
    key: "getStates",
    value: function getStates(country) {
      return Options.getStatesOptions(country);
    }
    /**
     * Validate and return the fields which are expected to be on the page.
     * @returns {Object}
     */
  }, {
    key: "getPageFields",
    value: function getPageFields(config) {
      var fields = {};
      if (!config.page) {
        Util.logError('Required page parameter missing to fetch fields');
        return fields;
      }

      // loop through all supported fields types and add to the list
      var supportedFields = Util.getFields();
      Object.keys(supportedFields).forEach(function (key) {
        Object.keys(supportedFields[key]).forEach(function (field) {
          if (Dom.getElementLength(supportedFields[key][field])) {
            fields[field] = supportedFields[key][field];
          }
        });
      });

      // Check if this page supports the plan selection and add field to the list
      if (Dom.getElementLength('input[type=radio][name=fc-landingPageId]')) {
        fields.landingPageId = 'input[type=radio][name=fc-landingPageId]';
      }
      var configPages = ['landing', 'one-step', 'update', 'gift-purchase', 'gift-redeem'];
      if (fields && _.includes(configPages, config.page)) {
        // Validate the required fields and filter as requested
        var requiredFields = ['email', 'firstName', 'lastName'];

        // log error if the basic required fields are missing in config
        requiredFields.forEach(function (field) {
          if (!fields[field]) {
            Util.showError("Required field ".concat(field, " is missing in CampaignJS fields config"));
          }
        });
      }
      return fields;
    }

    /**
     * Expected field defination
     * @returns {Object}
     */
  }, {
    key: "getFields",
    value: function getFields(fieldType) {
      var supportedFields = {
        person: {
          city: '#fc-city',
          country: '#fc-country',
          email: '#fc-email',
          emailVerify: '#fc-emailVerify',
          firstName: '#fc-firstName',
          lastName: '#fc-lastName',
          state: '#fc-state',
          street: '#fc-street',
          zip: '#fc-zip',
          phone: '#fc-phone',
          cityBilling: '#fc-city-billing',
          countryBilling: '#fc-country-billing',
          stateBilling: '#fc-state-billing',
          streetBilling: '#fc-street-billing',
          zipBilling: '#fc-zip-billing',
          cityShipping: '#fc-city-shipping',
          countryShipping: '#fc-country-shipping',
          stateShipping: '#fc-state-shipping',
          streetShipping: '#fc-street-shipping',
          zipShipping: '#fc-zip-shipping'
        },
        payment: {
          ccMonth: '#fc-ccMonth',
          ccNumber: '#fc-ccNumber',
          ccYear: '#fc-ccYear'
        },
        options: {
          currency: '#fc-currency',
          productSKU: '#fc-productSKU',
          giftCode: '#fc-giftCode',
          landingPageId: 'input[type=radio][name=fc-landingPageId]',
          zinio: '#fc-zinio',
          recurlySubscription: '#fc-recurlySubscription',
          password: '#fc-password',
          confirmPassword: '#fc-confirmPassword'
        }
      };
      if (fieldType) {
        return _.get(supportedFields, fieldType, {});
      }
      return supportedFields;
    }

    /**
     * Process page request
     */
  }, {
    key: "processPageRequest",
    value: function processPageRequest(page, apiMethod) {
      var verifyChecksum = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      return new Promise(function (resolve, reject) {
        if (verifyChecksum && !cjs.checksumVerified) {
          Util.logDebug("".concat(page, ".process: checksum verification failed"));
          Util.showError('<b>Sorry, we are unable to verify your account. Please contact Customer Service for assistance.</b>');
          resolve();
        }

        // First we disable the inputs
        Util.disableInputs();
        var productSKU;
        var password;
        var confirmPassword = null;
        var requestToken = null;
        var recurlySubscription = null;
        var currency = Dom.getUrlParam('currency');
        if (!currency || currency == null) {
          currency = 'USD';
        }
        if (typeof cjs.fields.productSKU !== 'undefined') {
          // Get the product info
          productSKU = Dom.getElementValue(cjs.fields.productSKU);
        }
        if (typeof cjs.fields.password !== 'undefined') {
          // Get the password
          password = Dom.getElementValue(cjs.fields.password);
        }
        if (typeof cjs.fields.confirmPassword !== 'undefined') {
          // Get the password
          confirmPassword = Dom.getElementValue(cjs.fields.confirmPassword);
        }
        if (typeof cjs.fields.currency !== 'undefined') {
          // Get the currency selected
          currency = Dom.getElementValue(cjs.fields.currency);
        }
        if (typeof cjs.fields.recurlySubscription !== 'undefined') {
          // Get the subscription uuid to be cancelled / terminated
          recurlySubscription = Dom.getElementValue(cjs.fields.recurlySubscription);
        }
        var payload = {
          person: Dom.getMemberDetails(cjs.fields),
          options: {
            productSKU: productSKU,
            password: password,
            confirmPassword: confirmPassword,
            currency: currency,
            trustedFormCertUrl: null,
            zinioSubscription: cjs.fields.zinio ? cjs.fields.zinio.is(':checked') : null,
            addressFieldVisibility: Dom.addressFieldVisibility(),
            recurlySubscription: recurlySubscription
          },
          context: Util.getContext()
        };

        // Format Person Info
        payload.person = Util.formatPersonAddress(payload.person);

        // Add giftCode to the payload data if available.
        if (typeof cjs.fields.giftCode !== 'undefined') {
          payload.giftCode = Dom.getElementValue(cjs.fields.giftCode);
        }

        // Set the checksum in payload optionsm if available.
        if (Dom.getUrlParam('checksum')) {
          payload.options.checksum = Dom.getUrlParam('checksum');
        }

        // Parse form fields if the CC fields exists
        if (typeof cjs.fields.ccNumber !== 'undefined') {
          var card = Dom.getMemberCard(cjs.fields);

          // Do cc validation only if the current billingInfo is not valid
          // and there is any cc data to validate
          if (!cjs.billingInfoValid || card.number !== '' || card.month !== '' || card.year !== '') {
            payload.billingOptions = {
              ccType: card.type,
              ccYear: card.year,
              ccMonth: card.month,
              ccFirstSix: card.firstSix,
              ccLastFour: card.lastFour,
              billingToken: null
            };

            // Create the recurly requestToken
            requestToken = {
              number: card.number,
              month: card.month,
              year: card.year,
              first_name: _.get(payload, 'person.firstName', null),
              last_name: _.get(payload, 'person.lastName', null),
              address1: _.get(payload, 'person.street', null),
              city: _.get(payload, 'person.city', null),
              state: _.get(payload, 'person.state', null),
              postal_code: _.get(payload, 'person.zip', null),
              country: _.get(payload, 'person.country', null),
              currency: currency
            };
          }
        }

        // Format Person Info
        payload.person = Util.formatPersonAddress(payload.person);
        validate.runValidation(payload).then(function () {
          if (!window.Autopilot) {
            Util.logDebug("".concat(page, ".process: Autopilot not found, skipping"));
            return null;
          }
          window.Autopilot.run('associate', payload.person.email, function () {
            Util.logDebug("".concat(page, ".process: Running Autopilot associate for ").concat(payload.person.email));
            return null;
          });
          return null;
        }).then(function () {
          if (requestToken) {
            Util.startLoading();
            return Dom.getRecurlyToken(requestToken);
          }
          return null;
        }).then(function (token) {
          if (token && payload.billingOptions) {
            payload.billingOptions.billingToken = token.id;
          }
          return api[apiMethod](payload);
        }).then(function (res) {
          Util.logDebug("".concat(page, ".process: success:"), res);
          var utmCodePairs = Dom.getUtmCodePairs();
          var redirectUrl = Dom.appendQueryString(cjs.config.nextPage, utmCodePairs);
          Util.stopLoading();
          Dom.navigateTo(redirectUrl);
          resolve(res);
        })["catch"](function (err) {
          var contactSupportMessage = Util.prepareSupportMessage();
          var utmCodePairs = Dom.getUtmCodePairs();

          // Append the payload data to utm code pairs so can be carry forwaded when redirected
          var payloadData = _.merge(payload.person, payload.options);
          Object.keys(payloadData).forEach(function (key) {
            if (payloadData[key] && payloadData[key].length > 1) {
              utmCodePairs.push("".concat(key, "=").concat(payloadData[key]));
            }
          });
          Util.stopLoading();
          if (typeof err.validationErrors !== 'undefined') {
            Util.logDebug("".concat(page, ".process: a validation error occurred: ").concat(err.message), err);
            var errorMsg = '<b>Sorry, there was a problem with the information:</b>';
            errorMsg += Util.parseValidationErrors(err.validationErrors);
            Util.showError(errorMsg);
            resolve();
          } else if (err.code === 'ALREADY_ACTIVE') {
            Util.logDebug("landing.process: a PersonActiveError error occurred: ".concat(err.message), err);
            var _errorMsg = "<b>We're sorry! It appears you have already signed up. ".concat(contactSupportMessage, " </b>");
            Util.showError(_errorMsg);
            resolve();
          } else if (err.code === 'validation') {
            Util.logDebug("".concat(page, ".process: validation error code: ").concat(err.message), err);
            var _errorMsg2 = '<b>Sorry, there was a problem validating your credit card.</b>';
            _errorMsg2 += '<p>Please verify the number and expiration date on your credit card</p>';
            Util.showError(_errorMsg2);
            resolve();
          } else if (err.code === 'PAYMENT_ERROR' && err.message) {
            Util.logDebug("".concat(page, ".process: PaymentError occurred: ").concat(err.message), err);
            var _errorMsg3 = '<b>Oops! There seems to be a problem processing  your payment.</b>';
            _errorMsg3 += "<p>".concat(err.message, "</p>");
            // If the error is due to the Fraud system checks, show custpm error message
            if (err.message.includes('Fraudulent Transaction')) {
              _errorMsg3 = 'Oops! There seems to be a problem processing your payment. Please try another payment method.';
            }
            Util.showError(_errorMsg3);
            resolve();
          } else if (err.code === 'PAYMENT_ERROR' && err.customer_message) {
            Util.logDebug("".concat(page, ".process: PaymentError occurred: ").concat(err.message), err);
            var _errorMsg4 = '<b>Oops! There seems to be a problem with your credit card.</b>';
            _errorMsg4 += "<p>".concat(err.customer_message, "</p>");
            Util.showError(_errorMsg4);
            resolve();
          } else if (err.code === 'INVALID_ADDRESS' && err.message) {
            Util.logDebug("".concat(page, ".process: Address validation error occurred: ").concat(err.message), err);
            var _errorMsg5 = "<b>No address match was found for the information you entered. Please reenter\n            your mailing address.</b>";
            Util.showError(_errorMsg5);
            resolve();
          } else if (err.code === 'ADDRESS_CORRECTION' && err.details && err.details.correctedAddress) {
            // Check if the address fields exists on page and populate with corrected adrress
            Dom.setDefaults({
              street: _.get(err.details.correctedAddress, 'street'),
              city: _.get(err.details.correctedAddress, 'city'),
              state: _.get(err.details.correctedAddress, 'state'),
              zip: _.get(err.details.correctedAddress, 'zip'),
              country: _.get(err.details.correctedAddress, 'country')
            });
            if (_.get(err.details.correctedAddress, 'addressType')) {
              var _Dom$setDefaults;
              var addressType = _.capitalize(_.get(err.details.correctedAddress, 'addressType'));
              Dom.setDefaults((_Dom$setDefaults = {}, util_defineProperty(_Dom$setDefaults, "street".concat(addressType), _.get(err.details.correctedAddress, 'street')), util_defineProperty(_Dom$setDefaults, "city".concat(addressType), _.get(err.details.correctedAddress, 'city')), util_defineProperty(_Dom$setDefaults, "state".concat(addressType), _.get(err.details.correctedAddress, 'state')), util_defineProperty(_Dom$setDefaults, "zip".concat(addressType), _.get(err.details.correctedAddress, 'zip')), util_defineProperty(_Dom$setDefaults, "country".concat(addressType), _.get(err.details.correctedAddress, 'country')), _Dom$setDefaults));
            }
            Util.logDebug("landing.process: Updated the address with corrected information: ".concat(err.message), err);
            var _errorMsg6 = "<b>Upon validation, one or more parts of your mailing address have been corrected.\n             Please review the changes and resubmit.</b>";
            Util.showError(_errorMsg6);
            resolve();
          } else if (err.code === 'GIFTCODE_ERROR' || err.code === 'GIFTCODE_REDEEMED' && err.message) {
            Util.logDebug("".concat(page, ".process: PaymentError occurred: ").concat(err.message), err);
            var _errorMsg7 = '<b>Sorry, there was a problem with the information.</b>';
            _errorMsg7 += "<p>".concat(err.message, "</p>");
            Util.showError(_errorMsg7);
            resolve();
          } else if (err.code === 'PERSON_NOT_FOUND') {
            // If anonymousNextPage is provided, redirect the person to provided url
            if (cjs.config.anonymousNextPage) {
              Util.logDebug("".concat(page, ".process: redirecting to anonymousNextPage:"), cjs.config.anonymousNextPage);
              var redirectUrl = Dom.appendQueryString(cjs.config.anonymousNextPage, utmCodePairs);
              Dom.navigateTo(redirectUrl);
              resolve();
            } else {
              Util.logDebug("".concat(page, ".process: Person not found: ").concat(err.message), err);
              var _errorMsg8 = '<b>Sorry, we could not find an existing member with provided email address.</b>';
              Util.showError(_errorMsg8);
              resolve();
            }
          } else if (err.code === 'UPDATE_REQUEST_NEDEED') {
            // If personNextPage is provided, redirect the person to provided url
            if (cjs.config.personNextPage) {
              Util.logDebug("".concat(page, ".process: redirecting to personNextPage:"), cjs.config.personNextPage);
              var _redirectUrl = Dom.appendQueryString(cjs.config.personNextPage, utmCodePairs);
              Dom.navigateTo(_redirectUrl);
              resolve();
            } else {
              Util.logDebug("".concat(page, ".process: Person already exists: ").concat(err.message), err);
              var _errorMsg9 = '<b>Sorry, you need to raise a request in order to process this form.</b>';
              Util.showError(_errorMsg9);
              resolve();
            }
          } else {
            Util.logDebug("".concat(page, ".process: an unknown error occurred: ").concat(err.message), err);
            Util.showError("<b>Unknown error. ".concat(contactSupportMessage, "</b>"));
            reject(err);
          }
        });
      });
    }
  }]);
  return Util;
}();
;// CONCATENATED MODULE: ./src/lib/campaign.js


function campaign_typeof(obj) { "@babel/helpers - typeof"; return campaign_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, campaign_typeof(obj); }
function campaign_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, campaign_toPropertyKey(descriptor.key), descriptor); } }
function campaign_createClass(Constructor, protoProps, staticProps) { if (protoProps) campaign_defineProperties(Constructor.prototype, protoProps); if (staticProps) campaign_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function campaign_toPropertyKey(arg) { var key = campaign_toPrimitive(arg, "string"); return campaign_typeof(key) === "symbol" ? key : String(key); }
function campaign_toPrimitive(input, hint) { if (campaign_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (campaign_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function campaign_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }


var CampaignJS = /*#__PURE__*/campaign_createClass(
/**
 * CampaignJS main initialization
 * @param config
 * @returns {Promise}
 */
function CampaignJS(config) {
  campaign_classCallCheck(this, CampaignJS);
  if (typeof config.trace !== 'undefined' && config.trace) {
    loglevel_default().setLevel('trace');
  } else if (typeof config.debug !== 'undefined' && config.debug) {
    loglevel_default().setLevel('debug');
  } else {
    loglevel_default().setLevel('info');
  }
  Util.logDebug('CampaignJS init', config);
  Util.createLoadingOverlay();
  Util.createErrorOverlay();
  Util.startLoading();
});
;// CONCATENATED MODULE: ./src/lib/config.js
/* eslint-disable no-undef */



function config_typeof(obj) { "@babel/helpers - typeof"; return config_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, config_typeof(obj); }
function config_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function config_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, config_toPropertyKey(descriptor.key), descriptor); } }
function config_createClass(Constructor, protoProps, staticProps) { if (protoProps) config_defineProperties(Constructor.prototype, protoProps); if (staticProps) config_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function config_toPropertyKey(arg) { var key = config_toPrimitive(arg, "string"); return config_typeof(key) === "symbol" ? key : String(key); }
function config_toPrimitive(input, hint) { if (config_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (config_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }












var Config = /*#__PURE__*/function () {
  function Config() {
    config_classCallCheck(this, Config);
  }
  config_createClass(Config, [{
    key: "init",
    value: function init(config) {
      return new Promise(function (resolve, reject) {
        if (typeof config === 'undefined') {
          return reject('No configuration found!');
        }

        // Set up LogEntries if we have a token
        if (typeof config.logToken !== 'undefined' && typeof window.LE !== 'undefined') {
          Util.logDebug('LogEntries configured.');
          window.LE.init({
            token: config.logToken,
            trace: true,
            page_info: 'per-entry'
          });
        } else {
          Util.logDebug('LogEntries NOT configured.');
        }
        Util.logDebug("CJS version ".concat("20230818091103", " CJS href ").concat(window.location.href));

        // Check if the required fields are there
        var requiredKeys = ['apiUrl', 'page'];

        // If we are on a checkout or a landing page we need a landingPageId
        if (typeof config.page !== 'undefined' && (config.page === 'landing' || config.page === 'checkout')) {
          requiredKeys.push('submitButton');

          // Deprecated config.page values
          if ($(config.submitButton).length !== 1) {
            Util.logInfo("fcCampaign configuration error: submitButton ".concat(config.submitButton, " not found"));
          }
        }
        if (config.campaignId) {
          Util.logInfo('fcCampaign config error: campaignId has been depreciated, please use landingPageId instead.');
          config.landingPageId = config.campaignId;
        }
        if (config.landingPageId) {
          window.apm.addLabels({
            landingPageId: config.landingPageId
          });
        }

        // On the checkout page we get the landingPageId from the URL, else we require it from the config
        if (typeof config.page !== 'undefined' && config.page === 'checkout') {
          config.landingPageId = Dom.getUrlParam('landingPageId');

          // Deprecated config.campaignId values
          var campaignId = Dom.getUrlParam('campaignId');
          if (campaignId) {
            Util.logInfo('fcCampaign config error: campaignId has been depreciated, please use landingPageId instead.');
            config.landingPageId = config.landingPageId || campaignId;
          }
        } else {
          requiredKeys.push('landingPageId');
        }

        // Check each required key
        requiredKeys.forEach(function (requiredKey) {
          if (typeof config[requiredKey] === 'undefined') {
            return reject("Configuration error: Unable to find key ".concat(requiredKey));
          }
          return null;
        });

        // Require current page
        var page = null;
        try {
          switch (config.page) {
            case 'add-recurly-account':
              page = new AddRecurlyAccountPage();
              break;
            case 'checkout':
              page = new CheckoutPage();
              break;
            case 'gift-purchase':
              page = new GiftPurchasePage();
              break;
            case 'gift-redeem':
              page = new GiftRedeemPage();
              break;
            case 'landing':
              page = new LandingPage();
              break;
            case 'one-step':
              page = new OneStepPage();
              break;
            case 'update-recurly-account':
              page = new UpdateRecurlyAccountPage();
              break;
            case 'update-request':
              page = new UpdateRequestPage();
              break;
            case 'update':
              page = new UpdatePage();
              break;
          }
        } catch (err) {
          return reject(err);
        }

        // Add predefined fields
        cjs.fields = Util.getPageFields(config);

        // Attach the creditcard submit button
        $(config.submitButton).on('click', function (event) {
          event.preventDefault();
          return page.handleSubmit('creditcard');
        });

        // Attach the paypal submit button listener
        if (config.paypalSubmitButton) {
          $(config.paypalSubmitButton).on('click', function (event) {
            event.preventDefault();
            return page.handleSubmit('paypal');
          });
        }
        cjs.config = config;

        // Create a variations array if it's not there
        if (!config.variations) {
          config.variations = [];
        }

        // Add the default variation to the array
        config.variations.push({
          landingPageId: config.landingPageId,
          nextPage: config.nextPage
        });
        var promises = [];
        cjs._pageConfigs = {};

        // Fetch and store info for each landingPageId in cjs._pageConfigs.
        config.variations.forEach(function (variation) {
          if (typeof variation.landingPageId !== 'undefined') {
            // If the variation does not have a nextPage we will use the default one
            var nextPage = variation.nextPage ? variation.nextPage : config.nextPage;
            cjs._pageConfigs[variation.landingPageId] = {
              landingPageId: variation.landingPageId,
              nextPage: nextPage
            };
            promises.push(api.getLandingPage(variation.landingPageId));
          }
        });
        return Promise.all(promises).then(function (variationsInfo) {
          variationsInfo.forEach(function (variation) {
            // Make sure each variation has info about landingPageId, nextPage and workflow
            cjs._pageConfigs[variation.id] = _.merge(cjs._pageConfigs[variation.id], variation);
          });

          // Make sure cjs sets landingPage info for default landingPageId
          Util.switchLandingPage(config.landingPageId);
          return resolve(page);
        })["catch"](function (err) {
          Util.logError('config.js config error', err);
          Util.showError('There was an error loading campaignjs');
          return reject(err);
        });
      });
    }

    /**
     * The amazon pay submit function
     */
  }, {
    key: "submitAmazonPay",
    value: function submitAmazonPay(status) {
      if (status && status.consent && status.id) {
        var page = new CheckoutPage();
        Util.logInfo('fcCampaign submit amazon pay: submitting amazon pay after receicing the agreement id.');
        return page.handleSubmit('amazon', status.id);
      }
    }
  }]);
  return Config;
}();
var config = new Config();

;// CONCATENATED MODULE: ./src/lib/bootstrap.js
function bootstrap_typeof(obj) { "@babel/helpers - typeof"; return bootstrap_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, bootstrap_typeof(obj); }
function bootstrap_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function bootstrap_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, bootstrap_toPropertyKey(descriptor.key), descriptor); } }
function bootstrap_createClass(Constructor, protoProps, staticProps) { if (protoProps) bootstrap_defineProperties(Constructor.prototype, protoProps); if (staticProps) bootstrap_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function bootstrap_toPropertyKey(arg) { var key = bootstrap_toPrimitive(arg, "string"); return bootstrap_typeof(key) === "symbol" ? key : String(key); }
function bootstrap_toPrimitive(input, hint) { if (bootstrap_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (bootstrap_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable no-undef */




var Bootstrap = /*#__PURE__*/function () {
  function Bootstrap() {
    bootstrap_classCallCheck(this, Bootstrap);
  }
  bootstrap_createClass(Bootstrap, [{
    key: "init",
    value:
    /**
     * The main init function
     */
    function init(params, cb) {
      cb = cb || (lodash_default()).noop;
      window.cjs = new CampaignJS(params);
      Bootstrap.loadDependencies(function (err) {
        if (err) {
          Util.logError('campaign.js dependency error:', err);
          Util.showError('There was an error loading campaignjs');
          return cb(err);
        }
        return config.init(params).then(function (page) {
          return page.init();
        }).then(function () {
          Util.logInfo('campaign.js loaded');
          Util.stopLoading();
          return cb();
        })["catch"](function (err) {
          Util.logError('campaign.js init error', err);
          Util.showError('There was an error loading campaignjs');
          return cb(err);
        });
      });
    }

    /**
     * The amazon pay submit function
     */
  }, {
    key: "submitAmazonPay",
    value: function submitAmazonPay(status) {
      return config.submitAmazonPay(status);
    }
  }], [{
    key: "loadDependencies",
    value:
    /**
     * Load the external dependencies
     */
    function loadDependencies(cb) {
      $.when($.getScript('//cdnjs.cloudflare.com/ajax/libs/fetch/0.10.1/fetch.min.js'), $.getScript('//cdnjs.cloudflare.com/ajax/libs/es6-promise/3.0.2/es6-promise.min.js'), $.getScript('//cdnjs.cloudflare.com/ajax/libs/validate.js/0.8.0/validate.min.js'), $.getScript('//js.recurly.com/v3/recurly.js')).done(function () {
        // Ensure that validate.js knows about our Promise implementation, which may have become
        // available only after validate.js initialized.
        window.validate.Promise = Promise;
        Util.customValidators(window);
        cb();
      }).fail(cb);
    }

    /**
     * CampaignJS version info
     */
  }, {
    key: "version",
    value: function version() {
      return {
        name: "@fullcube/campaign.js",
        version: "1.160.0",
        build: "20230818091103"
      };
    }
  }]);
  return Bootstrap;
}();
;// CONCATENATED MODULE: ./src/index.js
/* eslint-disable no-undef */



__webpack_require__(962);
__webpack_require__(270);
window.apm = __webpack_require__(368)/* .init */ .S1({
  environment: 'production',
  serverUrl: 'https://apm-server.fullcube.io',
  serviceName: 'campaign-js'
});

window.fcCampaign = new Bootstrap();
window.fcCampaign.version = Bootstrap.version();
})();

/******/ })()
;